#ifdef GL_ES
precision mediump float;
#endif

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

float PI = 3.1415926535897932;
float speed = 0.01;
float speed_x = 0.3;
float speed_y = 0.1;

float angle = 7.0;
float emboss = 0.50;
float intensity = 2.4;
float frequency = 6.0;

float delta = 60.0;
float intence = 700.0;

float reflectionCutOff = 0.012;
float reflectionIntence = 200000.0;


float iGlobalTime = float(CC_Time[1]);
float time = iGlobalTime*1.3;

float col(vec2 coord)
{
	float delta_theta = 2.0 * PI / angle;
	float tcol = 0.0;
	float theta = 0.0;
	for (int i = 0; i < 8; i++)
	{
		vec2 adjc = coord;
		theta = delta_theta*float(i);
		adjc.x += cos(theta)*time*speed + time * speed_x;
		adjc.y -= sin(theta)*time*speed - time * speed_y;
		tcol = tcol + cos( (adjc.x*cos(theta) - adjc.y*sin(theta))*frequency)*intensity;
	}
	return cos(tcol);
}

void main(void)
{
	vec2 p = v_texCoord, c1 = p, c2 = p;
	float cc1 = col(c1);
	c2.x = c2.x + float(512.0/delta);
	float dx = emboss*(cc1-col(c2))/delta;

	c2.x = p.x;
	c2.y += float(512.0/delta);
	float dy = emboss*(cc1-col(c2))/delta;
	c1.x += dx*2.0;
	c1.y = -(c1.y+dy*2.0);

	float alpha = 1.0+dot(dx,dy)*intence;
	
		
	float ddx = dx - reflectionCutOff;
	float ddy = dy - reflectionCutOff;
	if (ddx > 0.0 && ddy > 0.0)
		alpha = pow(alpha, float(ddx*ddy*reflectionIntence));
	
	
	//vec2 uv = v_texCoord;	
	//uv.y += (cos((uv.y + (iGlobalTime * 0.04)) * 45.0) * 0.0019) +
	//	(cos((uv.y + (iGlobalTime * 0.1)) * 10.0) * 0.002);

	//uv.x += (sin((uv.y + (iGlobalTime * 0.07)) * 15.0) * 0.0029) +
	//	(sin((uv.y + (iGlobalTime * 0.1)) * 15.0) * 0.002);		
		
	vec4 col = texture2D(CC_Texture0,v_texCoord)*(alpha);
	gl_FragColor = col;
}
