--建筑
local armySprite = class("armySprite")
armySprite._battle = nil
armySprite._type = 0
armySprite._key  = 0
armySprite._sid  = 0
armySprite._my   = nil
armySprite.isPlayAttackEffects = {false, false, false,false, false, false,false, false, false}

armySprite._red_index  = 1
armySprite._blue_index = 2
--1walk,2attack,3dead,4nut
armySprite._animation = {{'walkUP','attackUP','deadUP','nutUP'},{'walkDOWN','attackDOWN','deadDOWN','nutDOWN'}}

armySprite._index_sid    = 1
armySprite._index_attack = 2
armySprite._index_count  = 3
armySprite._index_target = 4
armySprite._index_hp     = 5
armySprite._index_live   = 6
armySprite._index_state  = 7
armySprite._index_sprite = 8
armySprite._index_update = 9
armySprite._index_effect = 10
armySprite._allCount = 0
--test
--armySprite._animation = nil

function armySprite.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, armySprite)
    return target
end

function armySprite:getNextTick()
    return 400
end
function armySprite:dealWaiting()
    local delay = math.random()*100/1000
    self:getChildByTag(1):addAnimation(0,self._animation[self._type][4],true,delay)
    if self:getChildByTag(2) ~= nil then
        local delay = math.random()*100/1000
        self:getChildByTag(2):addAnimation(0,self._animation[self._type][4],true,delay)
    end
    if self:getChildByTag(3) ~= nil then
        local delay = math.random()*100/1000
        self:getChildByTag(3):addAnimation(0,self._animation[self._type][4],true,delay)
    end
    if self:getChildByTag(4) ~= nil then
        local delay = math.random()*100/1000
        self:getChildByTag(4):addAnimation(0,self._animation[self._type][4],true,delay)
    end
    if self:getChildByTag(5) ~= nil then
        local delay = math.random()*100/1000
        self:getChildByTag(5):addAnimation(0,self._animation[self._type][4],true,delay)
    end
    if self:getChildByTag(6) ~= nil then
        local delay = math.random()*100/1000
        self:getChildByTag(6):addAnimation(0,self._animation[self._type][4],true,delay)
    end
    if self:getChildByTag(7) ~= nil then
        local delay = math.random()*100/1000
        self:getChildByTag(7):addAnimation(0,self._animation[self._type][4],true,delay)
    end
    if self:getChildByTag(8) ~= nil then
        local delay = math.random()*100/1000
        self:getChildByTag(8):addAnimation(0,self._animation[self._type][4],true,delay)
    end
end

function armySprite:soiderAttackEffects(childTag)
    if dd.currentLayer.stop then
        return
    end

    if self._sid == 201 or  self._sid == 202 or self._sid == 203 or self._sid == 25 or self._sid == 26 then      
        self.isPlayAttackEffects[childTag] = true        
        local arm = ccs.Armature:create("pvpEffect")
        arm:getAnimation():play("baoza")
        arm:setPosition(getRandomAndEnablePos(self._type))
        dd.currentLayer:addChild(arm, 1)
        arm:runAction(cc.Sequence:create(cc.DelayTime:create(1), cc.CallFunc:create(function () arm:removeFromParent(); self.isPlayAttackEffects[childTag] = false end)))
    elseif self._sid == 16 then     
        --火箭兵-----------------------------------------------------------------------------------------------  

        if self.isPlayAttackEffects[childTag] then
            return
        end       
        function roketLaunh(destPos, rotation, lenth)
            --此处播放音效会有卡顿、、、
            AudioEngine.playEffect(ff.sounds[403])
            self.isPlayAttackEffects[childTag] = true   
            self:getChildByTag(1):addAnimation(0, self._animation[self._type][4], true, math.random()*100/1000) --播放待机动画
            if self:getChildByTag(2) ~= nil then
                self:getChildByTag(2):addAnimation(0, self._animation[self._type][4], true, math.random()*100/1000)
            elseif self:getChildByTag(3) ~= nil then
                self:getChildByTag(3):addAnimation(0, self._animation[self._type][4], true, math.random()*100/1000)
            elseif self:getChildByTag(4) ~= nil then
                self:getChildByTag(4):addAnimation(0, self._animation[self._type][4], true, math.random()*100/1000)
            elseif self:getChildByTag(5) ~= nil then
                self:getChildByTag(5):addAnimation(0, self._animation[self._type][4], true, math.random()*100/1000)
            elseif self:getChildByTag(6) ~= nil then
                self:getChildByTag(6):addAnimation(0, self._animation[self._type][4], true, math.random()*100/1000)
            elseif self:getChildByTag(7) ~= nil then
                self:getChildByTag(7):addAnimation(0, self._animation[self._type][4], true, math.random()*100/1000)
            elseif self:getChildByTag(8) ~= nil then
                self:getChildByTag(8):addAnimation(0, self._animation[self._type][4], true, math.random()*100/1000)
            end
            --弹头
            local sp = cc.Sprite:create("images/battle/dd1.png") 
            sp:setPosition(self:getPosition())
            sp:setRotation(-90 - rotation)
            sp:setScale(0.2)
            dd.currentLayer:addChild(sp, 1)

            sp:runAction(cc.ScaleTo:create(lenth / 300, 1.2))
            sp:runAction(cc.Sequence:create(
                cc.MoveTo:create(lenth / 300, destPos),
                cc.CallFunc:create(
                    function ()
                        sp:removeFromParent()
                     
                        local arm1 = ccs.Armature:create("pvpEffect")
                        arm1:getAnimation():play("huojian")
                        arm1:setPosition(destPos)
                        arm1:setAnchorPoint(0.5, 0.25)
                        dd.currentLayer:addChild(arm1, 1)

                        arm1:runAction(cc.Sequence:create(
                            cc.DelayTime:create(1.2), 
                            cc.CallFunc:create(
                                function () 
                                    arm1:removeFromParent()
                                    if self:getChildByTag(1) ~= nil then
                                        self:getChildByTag(1):addAnimation(0, self._animation[self._type][2], true, 0.5)
                                    elseif self:getChildByTag(2) ~= nil then
                                        self:getChildByTag(2):addAnimation(0, self._animation[self._type][2], true, 0.5)
                                    elseif self:getChildByTag(3) ~= nil then
                                        self:getChildByTag(3):addAnimation(0, self._animation[self._type][2], true, 0.5)
                                    elseif self:getChildByTag(4) ~= nil then
                                        self:getChildByTag(4):addAnimation(0, self._animation[self._type][2], true, 0.5)
                                    elseif self:getChildByTag(5) ~= nil then
                                        self:getChildByTag(5):addAnimation(0, self._animation[self._type][2], true, 0.5)
                                    elseif self:getChildByTag(6) ~= nil then
                                        self:getChildByTag(6):addAnimation(0, self._animation[self._type][2], true, 0.5)
                                    elseif self:getChildByTag(7) ~= nil then
                                        self:getChildByTag(7):addAnimation(0, self._animation[self._type][2], true, 0.5)
                                    elseif self:getChildByTag(8) ~= nil then
                                        self:getChildByTag(8):addAnimation(0, self._animation[self._type][2], true, 0.5)
                                    end
                                    self.isPlayAttackEffects[childTag] = false
                                    end)))    
                    end
                )
            ))
            --烟
            local counts = 0
            sp:runAction(cc.Repeat:create(cc.Sequence:create(
                cc.CallFunc:create(
                    function ()
                            local dd2 = cc.Sprite:create("images/battle/dd2.png")
                            dd2:setPosition(sp:getPosition())
                            dd2:setRotation(-90 - rotation)
                            dd2:setScale(0.2 + counts * (15 / lenth) * 0.5)
                            dd2:setAnchorPoint(0.5, 0)
                            dd.currentLayer:addChild(dd2, 1)
                            dd2:runAction(cc.Sequence:create( cc.FadeOut:create(1.5), cc.CallFunc:create(function () dd2:removeFromParent() end)))
                            counts = counts + 1
                    end
                    ),
                cc.DelayTime:create(0.05)
            ), lenth / 15))
        end    

        local pos = getRandomAndEnablePos(self._type)         
        local lenth = math.sqrt((pos.y - self:getPositionY()) * (pos.y - self:getPositionY()) + (pos.x - self:getPositionX()) * (pos.x - self:getPositionX()))
        local angle = math.asin((pos.y - self:getPositionY()) / lenth )
        local jiaodu = angle * 180 / 3.1415926
        if pos.x - self:getPositionX() < 0 then
            if jiaodu >= 0 then
                jiaodu = 180 - jiaodu
            else
                jiaodu = -180 - jiaodu
            end
        end
        roketLaunh(pos, jiaodu, lenth)
    elseif 1 then
           
    end
end

--SP_ANIMATION_START    = 0
--SP_ANIMATION_END      = 1
--SP_ANIMATION_COMPLETE = 2
--SP_ANIMATION_EVENT    = 3
function getRandomAndEnablePos(type_)
    if type_ == 1 then
        pos = {cc.p(181,751),cc.p(331,751),cc.p(481,751),cc.p(191,906),cc.p(341,906),cc.p(491,906),cc.p(214,1031),cc.p(364,1031),cc.p(814,1031),cc.p(217,772),cc.p(371,751),cc.p(518,729)}
    elseif type_ == 2 then
        pos = {cc.p(166,556),cc.p(316,556),cc.p(466,556),cc.p(160,446),cc.p(310,446),cc.p(460,446),cc.p(187,330),cc.p(337,330),cc.p(487,330),cc.p(191,658),cc.p(345,637),cc.p(493,616)}
    end
    while true do
        local randnum = math.random(1, 12)
        for k, v in ipairs(dd.currentLayer:getChildByTag(1):getChildren()) do
            local x,y = v:getPosition()
            if x == pos[randnum].x  and y == pos[randnum].y then
                return pos[randnum]
            end
        end
    end   
end
function armySprite:dealAttack()
    function nextCall1(event)
        self:soiderAttackEffects(1)
    end
    function nextCall2(event)   
        self:soiderAttackEffects(2)
    end
    function nextCall3(event)   
        self:soiderAttackEffects(3)
    end
    function nextCall4(event)   
        self:soiderAttackEffects(4)
    end
    function nextCall5(event)   
        self:soiderAttackEffects(5)
    end
    function nextCall6(event)   
        self:soiderAttackEffects(6)
    end
    function nextCall7(event)   
        self:soiderAttackEffects(7)
    end
    function nextCall8(event)   
        self:soiderAttackEffects(8)
    end
    
    --音效播放
    if self._sid == 15 or self.sid == 22 or self.sid == 23 or self.sid == 24 or self._sid == 101 then
        self:getChildByTag(1):runAction(cc.RepeatForever:create(cc.Sequence:create(
                cc.CallFunc:create(
                    function ()
                       AudioEngine.playEffect(ff.sounds[401])
                    end
                    ),
                cc.DelayTime:create(0.8)
            )))
    elseif self._sid == 201 or  self._sid == 202 or self._sid == 203 or self._sid == 25 or self._sid == 26 then      
    --坦克、炮----------------------------------------------------------------------------------------------- 
        AudioEngine.playEffect(ff.sounds[404])
    end



    if self._sid == 121 then
        AudioEngine.playEffect(ff.sounds[402])
        self:setVisible(true)
        self:getChildByTag(1):setAnimation(0,"attackUP",true)
    else
        local delay = math.random()*100/1000
        if self:getChildByTag(1) ~= nil  and not self.isPlayAttackEffects[2] then
            local delay = math.random()*100/1000
            self:getChildByTag(1):addAnimation(0,self._animation[self._type][2],true,delay)
            self:getChildByTag(1):registerSpineEventHandler(nextCall1,SP_ANIMATION_COMPLETE)
        end
        if self:getChildByTag(2) ~= nil  and not self.isPlayAttackEffects[2] then
            local delay = math.random()*100/1000
            self:getChildByTag(2):addAnimation(0,self._animation[self._type][2],true,delay)
            self:getChildByTag(2):registerSpineEventHandler(nextCall2,SP_ANIMATION_COMPLETE)
        end
        if self:getChildByTag(3) ~= nil  and not self.isPlayAttackEffects[3] then
            local delay = math.random()*100/1000
            self:getChildByTag(3):addAnimation(0,self._animation[self._type][2],true,delay)
            self:getChildByTag(3):registerSpineEventHandler(nextCall3,SP_ANIMATION_COMPLETE)
        end 
        if self:getChildByTag(4) ~= nil  and not self.isPlayAttackEffects[4] then
            local delay = math.random()*100/1000
            self:getChildByTag(4):addAnimation(0,self._animation[self._type][2],true,delay)
            self:getChildByTag(4):registerSpineEventHandler(nextCall4,SP_ANIMATION_COMPLETE)
        end 
        if self:getChildByTag(5) ~= nil  and not self.isPlayAttackEffects[5] then
            local delay = math.random()*100/1000
            self:getChildByTag(5):addAnimation(0,self._animation[self._type][2],true,delay)
            self:getChildByTag(5):registerSpineEventHandler(nextCall5,SP_ANIMATION_COMPLETE)
        end 
        if self:getChildByTag(6) ~= nil  and not self.isPlayAttackEffects[6] then
            local delay = math.random()*100/1000
            self:getChildByTag(6):addAnimation(0,self._animation[self._type][2],true,delay)
            self:getChildByTag(6):registerSpineEventHandler(nextCall6,SP_ANIMATION_COMPLETE)
        end 
        if self:getChildByTag(7) ~= nil  and not self.isPlayAttackEffects[7] then
            local delay = math.random()*100/1000
            self:getChildByTag(7):addAnimation(0,self._animation[self._type][2],true,delay)
            self:getChildByTag(7):registerSpineEventHandler(nextCall7,SP_ANIMATION_COMPLETE)
        end 
        if self:getChildByTag(8) ~= nil  and not self.isPlayAttackEffects[8] then
            local delay = math.random()*100/1000
            self:getChildByTag(8):addAnimation(0,self._animation[self._type][2],true,delay)
            self:getChildByTag(8):registerSpineEventHandler(nextCall8,SP_ANIMATION_COMPLETE)
        end 
     
        
    end
end
function armySprite:dead(tag)
    local sprite = self:getChildByTag(tag)
    if sprite ~= nil then
        local function remove()
            sprite:removeFromParent(true)
        end
        sprite:stopAllActions()
        sprite:addAnimation(0,self._animation[self._type][3],false,0)
        sprite:runAction(cc.Sequence:create(cc.FadeOut:create(0.5),cc.CallFunc:create(remove)))
    end
end
function armySprite:stop()
    for i=1,3 do
        local sprite = self:getChildByTag(i)
        if sprite ~= nil then
            sprite:stopAllActions()
            sprite:setAnimation(0,self._animation[self._type][4],true)
        end
    end
end
function armySprite:gogogo() 
    --选择是否移动
    self._my[self._index_state] = 3 
    local type = dd.cfgSoldier[self._sid]['type']

    if self._sid ~= 100 then
        self:dealAttack()
    end
    
end
--移动
function armySprite:dealSort(army)
    cclog("dealSort")
    if army == nil then
        cclog("self._index:"..self._my[self._index_target])
    end
    if army == nil then
        if self._my[self._index_target] >= 4 then
            self:dealMove(self._my[self._index_target] - 3,1)
        end
    end
    
end
function armySprite:dealDead()
    -- 死亡方式1: 前排先死,依次第二排,第三排  对前三排设置每次减少数量的比值（相对自身的减少）. eg：100 ：10 ：1
    local hp    = self._my[self._index_hp]
    local count = self._my[self._index_hp]
    local deads = self._my[self._index_count] - self._my[self._index_live]
    local item = self._allCount/8
    if self._sid == 100 or self._sid == 101 then
    end
    local reduceCount = 0
    if self._sid > 200 then 
         reduceCount  = math.ceil(deads * (math.ceil(math.random() * 3)/100))
    else 
        if self._my[self._index_target] < 4 then 
            reduceCount  = math.ceil(deads * (math.ceil(math.random() * 3)/100))
        elseif self._my[self._index_target] < 7 then 
            reduceCount  = math.ceil(deads * (math.ceil(math.random() * 3)/500))
        elseif self._my[self._index_target] < 10 then 
            reduceCount  = math.ceil(deads * (math.ceil(math.random() * 3)/1000))
        end
    end

    count = count - reduceCount
    if count < 0 then
        count = 0
    end
    if count <= self._my[self._index_live] then
        count = self._my[self._index_live]
        self._my[self._index_state] = 4
    end 
    cclog("count:"..count..",hp:"..hp)
    self._my[self._index_hp] = count

    if count <= item*7 and hp > item*7 then
        self:dead(8)
    end
    if count <= item*6 and hp > item*6 then
        self:dead(7)
    end
    if count <= item*5 and hp > item*5 then
        self:dead(6)
    end
    if count <= item*4 and hp > item*4 then
        self:dead(5)
    end
    if count <= item*3 and hp > item*3 then
        self:dead(4)
    end
    if count <= item*2 and hp > item*2 then
        self:dead(3)
    end
    if count <= item and hp > item then
        self:dead(2)
    end
    if count <= 0 and hp > 0 then
        -- 此处播放会卡顿
        --AudioEngine.playEffect(ff.sounds[406]) 
        self:dead(1)
    end 
    if self._my[self._index_state] == 4 then
        return true
    end
    return false
end

function armySprite:readyPosition(target,tick)
    local function nextaction()
        self._my[self._index_effect] = 0
        if self._my[self._index_state] == 1 then
            self._my[self._index_state] = 2
            self:dealWaiting()
        end
    end
    self:getChildByTag(1):setAnimation(0, self._animation[self._type][4], true)
    if self:getChildByTag(2) ~= nil then
        self:getChildByTag(2):setAnimation(0, self._animation[self._type][4], true)
    end
    if self:getChildByTag(3) ~= nil then
        self:getChildByTag(3):setAnimation(0, self._animation[self._type][4], true)
    end
    if self:getChildByTag(4) ~= nil then
        self:getChildByTag(4):setAnimation(0, self._animation[self._type][4], true)
    end
    if self:getChildByTag(5) ~= nil then
        self:getChildByTag(5):setAnimation(0, self._animation[self._type][4], true)
    end
    if self:getChildByTag(6) ~= nil then
        self:getChildByTag(6):setAnimation(0, self._animation[self._type][4], true)
    end
    if self:getChildByTag(7) ~= nil then
        self:getChildByTag(7):setAnimation(0, self._animation[self._type][4], true)
    end
    if self:getChildByTag(8) ~= nil then
        self:getChildByTag(8):setAnimation(0, self._animation[self._type][4], true)
    end

    --计算时间
    cclog("--sid:"..self._sid..",state:"..self._my[self._index_state]..","..target)
    self._my[self._index_target] = target
    self._my[self._index_effect] = 1
    self:setPosition(self._grids[target])
    nextaction()
end

function armySprite:dealMove(target,tick)
    local function nextaction()
        cclog("sid:"..self._sid..",state:"..self._my[self._index_state]..","..self._my[self._index_target])
        self._my[self._index_effect] = 0
        if self._my[self._index_state] == 1 then
            self._my[self._index_state] = 2
            self:dealWaiting()
        else
            --local type = dd.cfgSoldier[self._sid]['type']
            if self._my[self._index_state] == 0 then
                self._my[self._index_state] = 3
                self:dealAttack()                
            else
                if self._my[self._index_target] < 9 then
                    self:dealAttack()
                else
                    self:dealWaiting()
                end
            end
        end
    end
    self:getChildByTag(1):setAnimation(0, self._animation[self._type][1], true)
    if self:getChildByTag(2) ~= nil then
        self:getChildByTag(2):setAnimation(0, self._animation[self._type][1], true)
    end
    if self:getChildByTag(3) ~= nil then
        self:getChildByTag(3):setAnimation(0, self._animation[self._type][1], true)
    end
    if self:getChildByTag(4) ~= nil then
        self:getChildByTag(4):setAnimation(0, self._animation[self._type][1], true)
    end
    if self:getChildByTag(5) ~= nil then
        self:getChildByTag(5):setAnimation(0, self._animation[self._type][1], true)
    end
    if self:getChildByTag(6) ~= nil then
        self:getChildByTag(6):setAnimation(0, self._animation[self._type][1], true)
    end
    if self:getChildByTag(7) ~= nil then
        self:getChildByTag(7):setAnimation(0, self._animation[self._type][1], true)
    end
    if self:getChildByTag(8) ~= nil then
        self:getChildByTag(8):setAnimation(0, self._animation[self._type][1], true)
    end
    
    --计算时间
    cclog("--sid:"..self._sid..",state:"..self._my[self._index_state]..","..target)
    self._my[self._index_target] = target
    self._my[self._index_effect] = 1
    if tick == nil then
        self:runAction(cc.Sequence:create(cc.Sequence:create(cc.MoveTo:create(3, self._grids[target]),cc.CallFunc:create(nextaction))))
    else        
        self:runAction(cc.Sequence:create(cc.Sequence:create(cc.MoveTo:create(tick, self._grids[target]),cc.CallFunc:create(nextaction))))
    end
end
function armySprite:onInit(report,type,row,sid)
    self.isPlayAttackEffects = {false, false, false,false, false, false,false, false, false}

    self._battle = report
    self._type   = type
    self._key    = row
    self._sid    = sid


    local key = sid..type
    if self._type == self._blue_index then
        self._my = self._battle.blue.armys[row]
        self._grids = {cc.p(181,751),cc.p(331,751),cc.p(481,751),cc.p(191,906),cc.p(341,906),cc.p(491,906),cc.p(214,1031),cc.p(364,1031),cc.p(814,1031),cc.p(217,772),cc.p(371,751),cc.p(518,729)}
        --self._grids = {cc.p(256,866),cc.p(410,845),cc.p(558,824),cc.p(284,994),cc.p(438,973),cc.p(586,952),cc.p(315,1127),cc.p(469,1106),cc.p(616,1085),cc.p(217,772),cc.p(371,751),cc.p(518,729)}
        --self._grids = {cc.p(160,ff.height - 400),cc.p(360,ff.height - 400),cc.p(560,ff.height - 400),cc.p(160,ff.height - 400 + 120),cc.p(360,ff.height - 400 + 120),cc.p(560,ff.height - 400 + 120),cc.p(160,ff.height - 400 + 240),cc.p(360,ff.height - 400 + 240),cc.p(560,ff.height - 400 + 240),cc.p(160,ff.height - 550),cc.p(360,ff.height - 550),cc.p(560,ff.height - 550)}
    else
        self._my = self._battle.red.armys[row]
        self._grids = {cc.p(166,556),cc.p(316,556),cc.p(466,556),cc.p(160,446),cc.p(310,446),cc.p(460,446),cc.p(187,330),cc.p(337,330),cc.p(487,330),cc.p(191,658),cc.p(345,637),cc.p(493,616)}
        --self._grids = {cc.p(151,484),cc.p(304,463),cc.p(453,442),cc.p(122,358),cc.p(277,337),cc.p(425,316),cc.p(96,232),cc.p(248,211),cc.p(395,189),cc.p(191,658),cc.p(345,637),cc.p(493,616)}
    end
    self._allCount = self._my[self._index_hp]

    local sprite = sp.SkeletonAnimation:create("images/battle/armys/"..key..".json", "images/battle/armys/"..key..".atlas")
    sprite:setMix(self._animation[self._type][1],self._animation[self._type][2],0.2)
    sprite:setMix(self._animation[self._type][1],self._animation[self._type][4],0.2)
    sprite:setMix(self._animation[self._type][2],self._animation[self._type][3],0.2)
    sprite:setPosition(cc.p(27,0))
    self:addChild(sprite,1,1)

    if self._type == self._red_index then
        if self._my[self._index_target] == 1 or self._my[self._index_target] == 4 or self._my[self._index_target] == 7 then
            self:setPosition(cc.p(15,-121))
        elseif self._my[self._index_target] == 2 or self._my[self._index_target] == 5 or self._my[self._index_target] == 8 then
            self:setPosition(cc.p(168,-171))
        else
            self:setPosition(cc.p(315,-221))
        end     
    else
        if self._my[self._index_target] == 1 or self._my[self._index_target] == 4 or self._my[self._index_target] == 7 then
            self:setPosition(cc.p(370,1564))
        elseif self._my[self._index_target] == 2 or self._my[self._index_target] == 5 or self._my[self._index_target] == 8 then
            self:setPosition(cc.p(524,1543))
        else
            self:setPosition(cc.p(671,1521))
        end     
    end
    -- 测试 兵最多显示9个，战车界面能放得下几个。
    -- 兵为  2 4 6 8 
    local tempCount = self._battle.base.maxCount/8
    if self._sid < 21 then --兵最多拜访9个
 
        local sprite = sp.SkeletonAnimation:create("images/battle/armys/"..key..".json", "images/battle/armys/"..key..".atlas")
        sprite:setMix(self._animation[self._type][1],self._animation[self._type][2],0.2)
        sprite:setMix(self._animation[self._type][1],self._animation[self._type][4],0.2)
        sprite:setMix(self._animation[self._type][2],self._animation[self._type][3],0.2)
        sprite:setPosition(cc.p(54,0))
        self:addChild(sprite,2,2)       

        local sprite = sp.SkeletonAnimation:create("images/battle/armys/"..key..".json", "images/battle/armys/"..key..".atlas")
        sprite:setMix(self._animation[self._type][1],self._animation[self._type][2],0.2)
        sprite:setMix(self._animation[self._type][1],self._animation[self._type][4],0.2)
        sprite:setMix(self._animation[self._type][2],self._animation[self._type][3],0.2)
        sprite:setPosition(cc.p(27,50))
        self:addChild(sprite,3,3)

        local sprite = sp.SkeletonAnimation:create("images/battle/armys/"..key..".json", "images/battle/armys/"..key..".atlas")
        sprite:setMix(self._animation[self._type][1],self._animation[self._type][2],0.2)
        sprite:setMix(self._animation[self._type][1],self._animation[self._type][4],0.2)
        sprite:setMix(self._animation[self._type][2],self._animation[self._type][3],0.2)
        sprite:setPosition(cc.p(54,50))
        self:addChild(sprite,4,4)       

        if self._my[self._index_count] > tempCount*4 then
            local sprite = sp.SkeletonAnimation:create("images/battle/armys/"..key..".json", "images/battle/armys/"..key..".atlas")
            sprite:setMix(self._animation[self._type][1],self._animation[self._type][2],0.2)
            sprite:setMix(self._animation[self._type][1],self._animation[self._type][4],0.2)
            sprite:setMix(self._animation[self._type][2],self._animation[self._type][3],0.2)
            sprite:setPosition(cc.p(0,0))
            self:addChild(sprite,5,5)

            local sprite = sp.SkeletonAnimation:create("images/battle/armys/"..key..".json", "images/battle/armys/"..key..".atlas")
            sprite:setMix(self._animation[self._type][1],self._animation[self._type][2],0.2)
            sprite:setMix(self._animation[self._type][1],self._animation[self._type][4],0.2)
            sprite:setMix(self._animation[self._type][2],self._animation[self._type][3],0.2)
            sprite:setPosition(cc.p(0,50))
            self:addChild(sprite,6,6)   
        end 

                

        if self._my[self._index_count] > tempCount*6 then
            local sprite = sp.SkeletonAnimation:create("images/battle/armys/"..key..".json", "images/battle/armys/"..key..".atlas")
            sprite:setMix(self._animation[self._type][1],self._animation[self._type][2],0.2)
            sprite:setMix(self._animation[self._type][1],self._animation[self._type][4],0.2)
            sprite:setMix(self._animation[self._type][2],self._animation[self._type][3],0.2)
            sprite:setPosition(cc.p(81,0))
            self:addChild(sprite,7,7)
        
            local sprite = sp.SkeletonAnimation:create("images/battle/armys/"..key..".json", "images/battle/armys/"..key..".atlas")
            sprite:setMix(self._animation[self._type][1],self._animation[self._type][2],0.2)
            sprite:setMix(self._animation[self._type][1],self._animation[self._type][4],0.2)
            sprite:setMix(self._animation[self._type][2],self._animation[self._type][3],0.2)
            sprite:setPosition(cc.p(81,50))
            self:addChild(sprite,8,8)
        end
    elseif self._sid == 21 then
        local sprite = sp.SkeletonAnimation:create("images/battle/armys/"..key..".json", "images/battle/armys/"..key..".atlas")
        sprite:setMix(self._animation[self._type][1],self._animation[self._type][2],0.2)
        sprite:setMix(self._animation[self._type][1],self._animation[self._type][4],0.2)
        sprite:setMix(self._animation[self._type][2],self._animation[self._type][3],0.2)
        sprite:setPosition(cc.p(30,0))
        self:addChild(sprite,2,2) 
        if self._my[self._index_count] > tempCount*4 then
            local sprite = sp.SkeletonAnimation:create("images/battle/armys/"..key..".json", "images/battle/armys/"..key..".atlas")
            sprite:setMix(self._animation[self._type][1],self._animation[self._type][2],0.2)
            sprite:setMix(self._animation[self._type][1],self._animation[self._type][4],0.2)
            sprite:setMix(self._animation[self._type][2],self._animation[self._type][3],0.2)
            sprite:setPosition(cc.p(60,0))
            self:addChild(sprite,3,3) 
        end 

    elseif self._sid >= 22 then --战车类 
        -- if self._my[self._index_count] > tempCount*2 then
        --     local sprite = sp.SkeletonAnimation:create("images/battle/armys/"..key..".json", "images/battle/armys/"..key..".atlas")
        --     sprite:setMix(self._animation[self._type][1],self._animation[self._type][2],0.2)
        --     sprite:setMix(self._animation[self._type][1],self._animation[self._type][4],0.2)
        --     sprite:setMix(self._animation[self._type][2],self._animation[self._type][3],0.2)
        --     sprite:setPosition(cc.p(80,0))
        --     self:addChild(sprite,2,2)       
        -- end 
    end
    
    self._my[self._index_state] = 1

    ccs.ArmatureDataManager:getInstance():addArmatureFileInfo("images/battle/pvpEffect0.png", "images/battle/pvpEffect0.plist" , "images/battle/pvpEffect.ExportJson")
end
function armySprite:onInitQixie(report,type,sid)
    self._battle = report
    self._type   = type
    self._sid    = sid

    local key = sid..type
    if self._type == self._blue_index then
        self._my = self._battle.blue.qixie[sid]
    else
        self._my = self._battle.red.qixie[sid]
    end

    for i=1,2 do
        local sprite = sp.SkeletonAnimation:create("images/battle/armys/"..key..".json", "images/battle/armys/"..key..".atlas")
        self:addChild(sprite,i,i)
        sprite:setAnimation(0,self._animation[self._type][1],false)
        if self._type == self._red_index then
            if self._sid == 201 then
                sprite:setPosition(cc.p(145 + 40*(i-1) ,170))
            elseif self._sid == 202 then
                sprite:setPosition(cc.p(295 + 40*(i-1),170))
            else
                sprite:setPosition(cc.p(445 + 40*(i-1),170))
            end 
        else
            if self._sid == 201 then
                sprite:setPosition(cc.p(234 + 40*(i-1) ,1156))
            elseif self._sid == 202 then
                sprite:setPosition(cc.p(384 + 40*(i-1),1156))
            else
                sprite:setPosition(cc.p(534 + 40*(i-1),1156))
            end
        end
    end
    self:setPosition(cc.p(0,0))
    self._my[self._index_state] = 1
end
function armySprite:onInitWalls(report,type,sid)
    self._battle = report
    self._type   = type
    self._sid    = sid

    local key = sid..type
    self._my = self._battle.blue.walls[sid]

    if sid == 100 then
        for i=1,2 do
            local sprite = cc.Sprite:create("images/battle/armys/"..sid.."1.png")
            sprite:setPosition(cc.p(189 + 129 * (i-1),709 - (2 * (i -1))))
            self:addChild(sprite,i,i)
        end
        for i=3,4 do
            local sprite = cc.Sprite:create("images/battle/armys/"..sid.."1.png")
            sprite:setPosition(cc.p(471 + 129 * (i-3),709))
            self:addChild(sprite,i,i)
        end
        self:setPosition(cc.p(0,0))
    elseif sid == 111 then
        for i=1,9 do
            local sprite = cc.Sprite:create("images/battle/armys/"..sid.."1.png")
            sprite:setPosition(cc.p(160 + 60 * (i-1),692))
            self:addChild(sprite,i,i)
        end
        self:setPosition(cc.p(0,0))
    elseif sid == 101 then
        for i=1,2 do
            local sprite = sp.SkeletonAnimation:create("images/battle/armys/"..key..".json", "images/battle/armys/"..key..".atlas")
            sprite:setPosition(cc.p(95 + 545 * (i-1),797))
            self:addChild(sprite,i,i)
            sprite:setAnimation(0,self._animation[self._type][4],false)
        end
        self:setPosition(cc.p(0,0))
    else
        local sprite = sp.SkeletonAnimation:create("images/battle/armys/"..key..".json", "images/battle/armys/"..key..".atlas")
        sprite:setPosition(cc.p(0,0))
        self:addChild(sprite,1,1)
        sprite:setAnimation(0,self._animation[self._type][4],false)
        self:setPosition(cc.p(151,484))
        self:setVisible(false) 
    end
    self._my[self._index_state] = 1 
end
--type--1红方
--type--2蓝方
function initArmy(report,type,row,sid)
    local army = armySprite.extend(cc.Layer:create())
    army:setAnchorPoint(cc.p(0.5,0.5))
    army:onInit(report,type,row,sid)
    return army
end
function showQiXie(report,armys,type)
    if armys[201] ~= nil then
        local army = armySprite.extend(cc.Layer:create())
        army:setAnchorPoint(cc.p(0.5,0.5))
        army:onInitQixie(report,type,201)
        armys[201][army._index_sprite] = army       
        armys[201][army._index_state] = 0   
    end
    if armys[202] ~= nil then
        local army = armySprite.extend(cc.Layer:create())
        army:setAnchorPoint(cc.p(0.5,0.5))
        army:onInitQixie(report,type,202)
        armys[202][army._index_sprite] = army       
        armys[202][army._index_state] = 0   
    end
    if armys[203] ~= nil then
        local army = armySprite.extend(cc.Layer:create())
        army:setAnchorPoint(cc.p(0.5,0.5))
        army:onInitQixie(report,type,203)
        armys[203][army._index_sprite] = army       
        armys[203][army._index_state] = 0   
    end

end
function showWalls(report,armys,type)
    if armys[100] ~= nil then
        local army = armySprite.extend(cc.Layer:create())
        army:setAnchorPoint(cc.p(0.5,0.5))
        army:onInitWalls(report,type,100)
        armys[100][army._index_sprite] = army       
        armys[100][army._index_state] = 0   
    end
    if armys[111] ~= nil then
        local army = armySprite.extend(cc.Layer:create())
        army:setAnchorPoint(cc.p(0.5,0.5))
        army:onInitWalls(report,type,111)
        armys[111][army._index_sprite] = army       
        armys[111][army._index_state] = 0   
    end

    if armys[101] ~= nil then
        local army = armySprite.extend(cc.Layer:create())
        army:setAnchorPoint(cc.p(0.5,0.5))
        army:onInitWalls(report,type,101)
        armys[101][army._index_sprite] = army       
        armys[101][army._index_state] = 0   
    end 
    if armys[121] ~= nil then
        local army = armySprite.extend(cc.Layer:create())
        army:setAnchorPoint(cc.p(0.5,0.5))
        army:onInitWalls(report,type,121)
        armys[121][army._index_sprite] = army       
        armys[121][army._index_state] = 0   
    end 
end