local battleLayer    = class("battleLayer")
battleLayer._name    = "battle"
battleLayer._widget  = nil
battleLayer._battle  = {}
battleLayer.stop = false

battleLayer._red_index  = 1
battleLayer._blue_index = 2
battleLayer._index_data = 0

battleLayer._uid = 0
battleLayer.singleEnmy = {}

require "battle/army"

function battleLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, battleLayer)
    return target
end
function battleLayer:initUI()
	sprite = cc.Sprite:create("images/battle/battle.jpg")
	sprite:setPosition( cc.p(360,ff.height/2) )
	self:addChild(sprite,0)

	self._widget = addCityUI(self)	
	--self:addChild(self._widget,9,20)

	self._widget:onShow(false)	
	self._widget:getChildByName("pop2"):setVisible(false)
	self._widget:getChildByName("pop3"):setVisible(false)
	self._widget:getChildByName("pop4"):setVisible(false)
	self._widget:closePublic(true)	
	--self._widget:getChildByName("builds"):setVisible(false)
	self:initBattleInfo()
end

--战场UI
function battleLayer:initBattleInfo()
	local battle = self._widget:getChildByName("battle")
	local blue_name = self._battle.blue.short
	local red_name = self._battle.red.short
	if blue_name ~= ""	then
		blue_name = "["..blue_name.."]"
	end
	if red_name ~= ""	then
		red_name = "["..red_name.."]"
	end
	battle:getChildByName("info"):getChildByName("blue"):setString(blue_name..self._battle.blue.name)
	battle:getChildByName("info"):getChildByName("red"):setString(red_name..self._battle.red.name)

	battle:getChildByName("info"):getChildByName("blue_level"):getChildByName("level"):setString(self._battle.blue.level)
	battle:getChildByName("info"):getChildByName("red_level"):getChildByName("level"):setString(self._battle.red.level)

	battle:getChildByName("progress"):getChildByName("blue"):getChildByName("hp"):setString(self._battle.blue.cur.."/"..self._battle.blue.hp)
	battle:getChildByName("progress"):getChildByName("red"):getChildByName("hp"):setString(self._battle.red.cur.."/"..self._battle.red.hp)

	battle:getChildByName("progress"):getChildByName("blue"):getChildByName("progress"):setPercent(100)
	battle:getChildByName("progress"):getChildByName("red"):getChildByName("progress"):setPercent(100)
end
--主要函数，解析战报
function battleLayer:initReport(report,clear,uid)
	if uid == nil then
		self._uid = dd.uid
	else
		self._uid = uid	
	end

	local rep = {}
	--防御
	rep.blue = {}
	rep.red  = {}
	--基础信息
	rep.base = {}

    --1进攻方获胜
    --2防御方获胜
	rep.base.result = report.result
	rep.base.type   = report.type
	rep.base.time   = report.time
	rep.base.tick   = ff.gameCore:getTick()
	rep.base.id     = report.id
	rep.base.cid    = report.pos
	rep.base.reds   = report.Ainfo
	rep.base.blues  = report.Binfo
	rep.base.maxCount = 0

	rep.base.speed  = 1
	rep.base.keep   = 1000
	rep.base.step   = 0

	rep.blue.name   = ff.langString("防御方")
	rep.blue.master = report.B_hero_Master_ID

	rep.base.myindex = 0
	rep.base.res = {0,0,0,0,0}
	rep.base.deads = {0,0,0}
	rep.base.uidA = 0
	rep.base.uidB = 0

	local hp   = 0
	local last = 0
	local armys = {}
	for i=1,report.Binfo:rowCount() do
		rep.blue.name = report.Binfo:getString(i,"name")
		if report.Binfo:getLong(i,"id") == report.B_union_ID then
		end
		if report.Binfo:getLong(i,"id") == self._uid then
			rep.base.myindex = self._blue_index
		end

		local type = report.Binfo:getLong(i,"type")
		local uid  = report.Binfo:getLong(i,"id")
		rep.base.uidB = uid

		for j=1,report.amyInfo:rowCount() do
			if report.amyInfo:getLong(j,"playerid") == uid then
				local sid = report.amyInfo:getLong(j,"id")
				local begin  = report.amyInfo:getLong(j,"power")
				local theend = begin - report.amyInfo:getLong(j,"powerlose")

				hp   = hp + begin
				last = last + theend
				--sid|攻击方式|初始数量|目标格子|剩余数量|存活数量|状态（0,没上场,1上场，2准备开始，3攻击中，4战死）|sprite|lastupdate
				if armys[sid] == nil then
					armys[sid] = {sid,1,begin,0,begin,theend,0,nil,0,0}
				else
					armys[sid][self._index_count] = armys[sid][self._index_count] + begin
					armys[sid][self._index_hp] = armys[sid][self._index_hp] + begin
					armys[sid][self._index_live] = armys[sid][self._index_live] + theend
				end
			end
		end
	end
	
	--sid|攻击方式|初始数量|目标格子|剩余数量|存活数量|状态（0,没上场,1上场，2准备开始，3攻击中，4战死）|sprite|lastupdate
	--armys[16] = {16,0,20000,0,20000,50,0,nil,0,0}

	--armys[101] = {101,6,100,0,50,0,0,nil,0,0}
	--armys[111] = {111,10,100,0,50,0,0,nil,0,0}
	--armys[121] = {121,9,100,0,50,0,0,nil,0,0}

	--armys[201] = {201,9,100,0,50,0,0,nil,0,0}
	--armys[202] = {202,9,100,0,50,0,0,nil,0,0}
	--armys[203] = {203,9,100,0,50,0,0,nil,0,0}

--	--armys[1] = {1,1,1000,0,100,0,0,nil,0,0}

--	hp = hp + 20000
--	last = last	+ 50


	rep.blue.hp   = hp
	rep.blue.last = last
	rep.blue.cur  = hp
	rep.blue.short= report.B_union_Name2
	rep.blue.level= report.Binfo:getLong(1, "level"); 
	self._index_data = self._blue_index
	rep.blue.armys  = self:initArmys(armys)
	rep.blue.walls  = self:initWalls(armys)
	rep.blue.qixie  = self:initQiXie(armys)
	rep.blue.grids = {0,0,0,0,0,0,0,0,0}

	rep.red.name   = ff.langString("攻击方")
	rep.red.master = report.A_hero_Master_ID
	hp   = 0
	last = 0
	local armys = {}
	for i=1,report.Ainfo:rowCount() do
		rep.red.name = report.Ainfo:getString(i,"name")
		if report.Ainfo:getLong(i,"id") == report.A_union_ID then
		end
		if report.Ainfo:getLong(i,"id") == self._uid then
			rep.base.myindex = self._red_index
		end

		local type = report.Ainfo:getLong(i,"type")
		local uid  = report.Ainfo:getLong(i,"id")
		rep.base.uidA = uid

		for j=1,report.amyInfo:rowCount() do
			if report.amyInfo:getLong(j,"playerid") == uid then
				local sid = report.amyInfo:getLong(j,"id")
				local begin  = report.amyInfo:getLong(j,"power")
				local theend = begin - report.amyInfo:getLong(j,"powerlose")
				hp   = hp + begin
				last = last + theend
				--sid|攻击方式|初始数量|目标格子|剩余数量|存活数量|状态（0,没上场,1上场，2准备开始，3攻击中，4战死）|sprite|lastupdate
				if armys[sid] == nil then
					armys[sid] = {sid,1,begin,0,begin,theend,0,nil,0,0}
				else
					armys[sid][self._index_count] = armys[sid][self._index_count] + begin
					armys[sid][self._index_hp] = armys[sid][self._index_hp] + begin
					armys[sid][self._index_live] = armys[sid][self._index_live] + theend
				end

			end
		end
	end

	if report.resInfo ~= nil then
		for i=1,report.resInfo:rowCount()  do 
			if report.resInfo:getLong(i,"playerid") == rep.base.uidA or report.resInfo:getLong(i,"playerid") == rep.base.uidB then 
				local type =  report.resInfo:getLong(i,"itemType")
                if tonumber(type) == 1 then
                	rep.base.res[6][report.resInfo:getLong(i,"itemId")] =  report.resInfo:getLong(i,"itemCnt")
                elseif tonumber(type) == 2 then
                   	rep.base.res[1] = report.resInfo:getLong(i,"itemCnt")
                elseif tonumber(type) == 3 then
                    rep.base.res[2] = report.resInfo:getLong(i,"itemCnt")
                elseif tonumber(type) == 4 then
                    rep.base.res[3] = report.resInfo:getLong(i,"itemCnt")
                elseif tonumber(type) == 5 then
                    rep.base.res[4] = report.resInfo:getLong(i,"itemCnt")
                elseif tonumber(type) == 6 then
                    rep.base.res[5] = report.resInfo:getLong(i,"itemCnt")
                end
			end 
		end
	end

	if rep.base.myindex == self._blue_index then 
		rep.base.res[1] = -rep.base.res[1]
		rep.base.res[2] = -rep.base.res[2]
		rep.base.res[3] = -rep.base.res[3]
		rep.base.res[4] = -rep.base.res[4]
		rep.base.res[5] = -rep.base.res[5]
	end


	
	rep.red.hp   = hp
	rep.red.last = last
	rep.red.cur  = hp
	rep.red.short= report.A_union_Name2
	rep.red.level= report.Ainfo:getLong(1, "level");
	self._index_data = self._red_index 
	rep.red.armys  = self:initArmys(armys)
	rep.red.walls  = {}
	rep.red.qixie  = self:initQiXie(armys)

	rep.red.grids = {0,0,0,0,0,0,0,0,0}

	cclog("hp:"..hp..",last:"..last)

	rep.blue_hp = rep.blue.cur
	rep.red_hp = rep.red.cur

	--击杀士兵，城防。士兵损失
	if rep.base.myindex == self._red_index then
		for i=1,table.getn(rep.blue.armys) do
			rep.base.deads[1] = rep.base.deads[1] + rep.blue.armys[i][self._index_hp] - rep.blue.armys[i][self._index_live]
		end
		if rep.blue.qixie[201] ~= nil then
			rep.base.deads[1] = rep.base.deads[1] + rep.blue.qixie[201][self._index_hp] - rep.blue.qixie[201][self._index_live]
		end			
		if rep.blue.qixie[202] ~= nil then
			rep.base.deads[1] = rep.base.deads[1] + rep.blue.qixie[202][self._index_hp] - rep.blue.qixie[202][self._index_live]
		end			
		if rep.blue.qixie[203] ~= nil then
			rep.base.deads[1] = rep.base.deads[1] + rep.blue.qixie[203][self._index_hp] - rep.blue.qixie[203][self._index_live]
		end			
		--城防
		if rep.blue.walls[100] ~= nil then
			rep.base.deads[2] = rep.base.deads[2] + rep.blue.walls[100][self._index_hp] - rep.blue.walls[100][self._index_live]
		end			
		if rep.blue.walls[101] ~= nil then
			rep.base.deads[2] = rep.base.deads[2] + rep.blue.walls[101][self._index_hp] - rep.blue.walls[101][self._index_live]
		end			
		if rep.blue.walls[111] ~= nil then
			rep.base.deads[2] = rep.base.deads[2] + rep.blue.walls[111][self._index_hp] - rep.blue.walls[111][self._index_live]
		end			
		if rep.blue.walls[121] ~= nil then
			rep.base.deads[2] = rep.base.deads[2] + rep.blue.walls[121][self._index_hp] - rep.blue.walls[121][self._index_live]
		end			
		--死兵
		for j=1,report.amyInfo:rowCount() do
			if report.amyInfo:getLong(j,"playerid") == self._uid then
				local sid = report.amyInfo:getLong(j,"id")
				local begin  = report.amyInfo:getLong(j,"power")
				local theend = begin - report.amyInfo:getLong(j,"powerlose")
				rep.base.deads[3] = rep.base.deads[3] + begin - theend  
			end
		end
	else
		for i=1,table.getn(rep.red.armys) do
			rep.base.deads[1] = rep.base.deads[1] + rep.red.armys[i][self._index_hp] - rep.red.armys[i][self._index_live]
		end
		if rep.red.qixie[201] ~= nil then
			rep.base.deads[1] = rep.base.deads[1] + rep.red.qixie[201][self._index_hp] - rep.red.qixie[201][self._index_live]
		end			
		if rep.red.qixie[202] ~= nil then
			rep.base.deads[1] = rep.base.deads[1] + rep.red.qixie[202][self._index_hp] - rep.red.qixie[202][self._index_live]
		end			
		if rep.red.qixie[203] ~= nil then
			rep.base.deads[1] = rep.base.deads[1] + rep.red.qixie[203][self._index_hp] - rep.red.qixie[203][self._index_live]
		end			
		--死兵
		for j=1,report.amyInfo:rowCount() do
			if report.amyInfo:getLong(j,"playerid") == self._uid then
				local sid = report.amyInfo:getLong(j,"id")
				local begin  = report.amyInfo:getLong(j,"power")
				local theend = begin - report.amyInfo:getLong(j,"powerlose")
				rep.base.deads[3] = rep.base.deads[3] + begin - theend  
			end
		end
	end
	-- 取得AB双方最大的兵的数量，用于作为max计算其他兵种对应的模型数量
	for i=1,table.getn(rep.red.armys) do
		local begin  =rep.red.armys[i][self._index_count]
		if rep.base.maxCount < begin then 
			rep.base.maxCount = begin
		end
	end
	for i=1,table.getn(rep.blue.armys) do
		local begin  =rep.blue.armys[i][self._index_count]
		if rep.base.maxCount < begin then 
			rep.base.maxCount = begin
		end
	end

	if clear == true then
		if report.Binfo ~= nil then
			report.Binfo:clear()
		end
		if report.Ainfo ~= nil then
			report.Ainfo:clear()
		end
		if report.amyInfo ~= nil then
			report.amyInfo:clear()
		end
		if report.npcInfo ~= nil then
			report.npcInfo:clear()
		end
		report.Binfo = nil
		report.Ainfo = nil
		report.amyInfo = nil
		report.npcInfo = nil
	end
	return rep
end


battleLayer._index_sid    = 1
battleLayer._index_attack = 2
battleLayer._index_count  = 3
battleLayer._index_target = 4
battleLayer._index_hp     = 5
battleLayer._index_live   = 6
battleLayer._index_state  = 7
battleLayer._index_sprite = 8
battleLayer._index_update = 9
battleLayer._index_effect = 10

--初始化站位
function battleLayer:initArmys(troops)
	--测试数据
	-- troops = {}
	--   if self._index_data == self._blue_index then
	--     troops[12] = {12,1,5000,0,5000,0,0,nil,0,0} 
	--     troops[13] = {13,1,6000,0,6000,0,0,nil,0,0} 
	--     troops[14] = {14,1,300,0,300,0,0,nil,0,0}  
	--    	troops[15] = {15,1,6000,0,6000,0,0,nil,0,0}
	--     troops[21] = {21,4,200,0,200,0,0,nil,0,0}
	--     troops[22] = {22,5,6000,0,6000,500,0,nil,0,0}
	--     troops[23] = {23,6,50,0,50,0,0,nil,0,0}
	--     troops[24] = {24,7,200,0,200,0,0,nil,0,0}
	--     troops[25] = {25,7,60,0,60,0,0,nil,0,0}
	--   else
	--     troops[12] = {12,1,5000,0,5000,0,0,nil,0,0} 
	--     troops[13] = {13,1,6000,0,6000,0,0,nil,0,0} 
	--     troops[14] = {14,1,300,0,300,0,0,nil,0,0}  
	--    	troops[15] = {15,1,6000,0,6000,0,0,nil,0,0}
	--     troops[21] = {21,4,200,0,200,0,0,nil,0,0}
	--     troops[22] = {22,5,6000,0,6000,500,0,nil,0,0}
	--     troops[23] = {23,6,50,0,50,0,0,nil,0,0}
	--     troops[24] = {24,7,200,0,200,0,0,nil,0,0}
	--     troops[25] = {25,7,60,0,60,0,0,nil,0,0}
	--   end
	
	
    

	--按伤亡情况，数量排序
	local chuzhanTemp = {1,2,3,4,5,6,11,12,13,14,15,16,21,22,23,24,25,26}
	local chuzhan = {}
	local chuzhanZero = {}
	local chuzhanNo = {}
	local armys = {}
	local armysCar = {}
	local armysTemps1 = {}
	local armysTemps2 = {}
	local index = 1
	local waiting = 1
	--对live数量>0的兵种至前
	for i=1,table.getn(chuzhanTemp) do
		if troops[chuzhanTemp[i]] ~= nil then
			if troops[chuzhanTemp[i]][self._index_live] > 0 then
				chuzhan[table.getn(chuzhan) + 1] = chuzhanTemp[i]
			else
				chuzhanZero[table.getn(chuzhanZero) + 1] = chuzhanTemp[i]
			end
		else
			chuzhanNo[table.getn(chuzhanNo) + 1] = chuzhanTemp[i]
		end
	end
	for i=1,table.getn(chuzhanZero) do
		chuzhan[table.getn(chuzhan) + 1] = chuzhanZero[i]
	end

	-- for i=1,table.getn(chuzhan) do
	-- 	print("出战。。。。。。。。。。。。。。。。。。== "..chuzhan[i])
	-- end

	--提取至多9个方正
	for i=1,9 do
		local have = false
		for j=index,table.getn(chuzhan) do
			if troops[chuzhan[index]] ~= nil then
				if troops[chuzhan[index]][self._index_sid] < 21 then 
					armys[table.getn(armys) + 1] = troops[chuzhan[index]]
				else
					armysCar[table.getn(armysCar) + 1] = troops[chuzhan[index]]
				end
				have = true
			end
			index = index + 1
			if have == true then
				break
			end
		end
	end
	table.sort( armys, function(a,b) return a[self._index_count] < b[self._index_count]  end )
	for i=1,table.getn(armysCar) do
		armys[table.getn(armys) + 1] = armysCar[i]
	end
	-- 按照是否死亡再次筛选一边
	for i=1,table.getn(armys) do
		if armys[i][self._index_live] == 0 then
			armysTemps1[table.getn(armysTemps1) + 1] = armys[i]	
		else
			armysTemps2[table.getn(armysTemps2) + 1] = armys[i]	
		end
	end
	armys = {}
	for i=1,table.getn(armysTemps1) do
		armys[table.getn(armys) + 1] = armysTemps1[i]
	end
	for i=1,table.getn(armysTemps2) do
		armys[table.getn(armys) + 1] = armysTemps2[i]
	end

	
	for i=1,table.getn(armys) do
		armys[i][self._index_target] = i
	end
	return armys
end
--城防
function battleLayer:initWalls(troops)
	--测试数据
	-- troops = {}
	-- troops[100] = {100,3,1000,0,1000,0,0,nil,0,0}
	-- troops[101] = {101,3,1000,0,1000,0,0,nil,0,0}
	-- troops[111] = {111,3,1000,0,1000,0,0,nil,0,0}
	-- troops[121] = {121,3,1000,0,1000,0,0,nil,0,0}
	local armys = {}
	if troops[100] ~= nil then
		armys[100] = troops[100]
		armys[100][self._index_attack] = 10
	end
	if troops[101] ~= nil then
		armys[101] = troops[101]
		armys[101][self._index_attack] = 6
	end
	if troops[111] ~= nil then
		armys[111] = troops[111]
		armys[111][self._index_attack] = 10
	end
	if troops[121] ~= nil then
		armys[121] = troops[121]
		armys[121][self._index_attack] = 9
	end
	return armys
end
--城防
function battleLayer:initQiXie(troops)
	--测试数据
	-- troops = {}
	-- troops[201] = {201,3,1000,0,1000,0,0,nil,0,0}
	-- troops[202] = {201,3,1000,0,1000,0,0,nil,0,0}
	-- troops[203] = {201,3,1000,0,1000,0,0,nil,0,0}
    local armys = {}
	if troops[201] ~= nil then
		armys[201] = troops[201]
		armys[201][self._index_attack] = 3
	end
	if troops[202] ~= nil then
		armys[202] = troops[202]
		armys[202][self._index_attack] = 3
	end
	if troops[203] ~= nil then
		armys[203] = troops[203]
		armys[203][self._index_attack] = 3
	end
	return armys
end



function battleLayer:initBattle(report,clear,uid)
	--初始化UI
	self._battle = self:initReport(report,clear,uid)
	self:initUI()
    self.stop = false
end

function battleLayer:update(dt)
	local base = self._battle.base
	if base.keep == 0 then
		return
	end
	if base.tick + base.keep/base.speed <= ff.gameCore:getTick() then
		base.tick = ff.gameCore:getTick()
		if base.step == 0 then
			self:ready()
			base.step = 1
			base.keep = 3200
			if self:isBattleEnd() == true then
				base.keep = 500
				base.step = 3
			end			
		elseif base.step == 1 then
			if self:startBattle() == true then
				--1秒后开始攻击，这里可以播放开战特效
				base.step = 2
				base.keep = 1000
			else
				base.keep = 100
			end
		elseif base.step == 2 then			
			base.keep = 100
			self:dead()
			self:sortArmys()
			if self:isBattleEnd() == true then
				base.keep = 500
				base.step = 3
			end
		elseif base.step == 3 then
			--结束
			self:stopAll()
			base.keep = 1000000			
		end
	end
	self:updateBlood()
end
--更新血条
function battleLayer:updateBlood()
	local battle = self._widget:getChildByName("battle")

	local blue = 0
	local red  = 0
	for i=1,table.getn(self._battle.blue.armys) do
		blue = blue + self._battle.blue.armys[i][self._index_hp]
	end
	if self._battle.blue.qixie[201] ~= nil then
		blue = blue + self._battle.blue.qixie[201][self._index_hp]
	end
	if self._battle.blue.qixie[202] ~= nil then
		blue = blue + self._battle.blue.qixie[202][self._index_hp]
	end
	if self._battle.blue.qixie[203] ~= nil then
		blue = blue + self._battle.blue.qixie[203][self._index_hp]
	end
	if self._battle.blue.walls[100] ~= nil then
		blue = blue + self._battle.blue.walls[100][self._index_hp]
	end
	if self._battle.blue.walls[101] ~= nil then
		blue = blue + self._battle.blue.walls[101][self._index_hp]
	end
	if self._battle.blue.walls[111] ~= nil then
		blue = blue + self._battle.blue.walls[111][self._index_hp]
	end
	if self._battle.blue.walls[121] ~= nil then
		blue = blue + self._battle.blue.walls[121][self._index_hp]
	end

	--当前实际血量
	self._battle.blue.cur = blue

	local step = math.ceil((self._battle.blue_hp - blue)/20)
	--血线
	self._battle.blue_hp =  self._battle.blue_hp - step
	if self._battle.blue_hp < blue then
		self._battle.blue_hp = blue
	end
	battle:getChildByName("progress"):getChildByName("blue"):getChildByName("hp"):setString(self._battle.blue_hp.."/"..self._battle.blue.hp)
	battle:getChildByName("progress"):getChildByName("blue"):getChildByName("progress"):setPercent(self._battle.blue_hp*100/self._battle.blue.hp)


	for i=1,table.getn(self._battle.red.armys) do
		red = red + self._battle.red.armys[i][self._index_hp]
	end

	if self._battle.red.qixie[201] ~= nil then
		red = red + self._battle.red.qixie[201][self._index_hp]
	end
	if self._battle.red.qixie[202] ~= nil then
		red = red + self._battle.red.qixie[202][self._index_hp]
	end
	if self._battle.red.qixie[203] ~= nil then
		red = red + self._battle.red.qixie[203][self._index_hp]
	end	
	--当前实际血量
	self._battle.red.cur = red

	local step = math.ceil((self._battle.red_hp - red)/20)
	--血线
	self._battle.red_hp =  self._battle.red_hp - step
	if self._battle.red_hp < red then
		self._battle.red_hp = red
	end
	battle:getChildByName("progress"):getChildByName("red"):getChildByName("hp"):setString(self._battle.red_hp.."/"..self._battle.red.hp)
	battle:getChildByName("progress"):getChildByName("red"):getChildByName("progress"):setPercent(self._battle.red_hp*100/self._battle.red.hp)
end
--进场
function battleLayer:ready()
	--初始化城防
	local blue_walls = self._battle.blue.walls
	showWalls(self._battle,blue_walls,self._blue_index)

	if blue_walls[100] ~= nil and blue_walls[100][self._index_sprite] ~= nil then
		self:getChildByTag(1):addChild(blue_walls[100][self._index_sprite])
	end
	if blue_walls[111] ~= nil and blue_walls[111][self._index_sprite] ~= nil then
		self:getChildByTag(1):addChild(blue_walls[111][self._index_sprite])
	end

	if blue_walls[101] ~= nil and blue_walls[101][self._index_sprite] ~= nil then
		self:getChildByTag(1):addChild(blue_walls[101][self._index_sprite])
	end
	if blue_walls[121] ~= nil and blue_walls[121][self._index_sprite] ~= nil then
		self:getChildByTag(1):addChild(blue_walls[121][self._index_sprite])
	end

	--初始化攻城武器
	local blue_qixie = self._battle.blue.qixie
	local red_qixie = self._battle.red.qixie
	showQiXie(self._battle,blue_qixie,self._blue_index)
	showQiXie(self._battle,red_qixie,self._red_index)

	if blue_qixie[201] ~= nil and blue_qixie[201][self._index_sprite] ~= nil then
		self:getChildByTag(1):addChild(blue_qixie[201][self._index_sprite])
	end
	if blue_qixie[202] ~= nil and blue_qixie[202][self._index_sprite] ~= nil then
		self:getChildByTag(1):addChild(blue_qixie[202][self._index_sprite])
	end
	if blue_qixie[203] ~= nil and blue_qixie[203][self._index_sprite] ~= nil then
		self:getChildByTag(1):addChild(blue_qixie[203][self._index_sprite])
	end

	if red_qixie[201] ~= nil and red_qixie[201][self._index_sprite] ~= nil then
		self:getChildByTag(1):addChild(red_qixie[201][self._index_sprite])
	end
	if red_qixie[202] ~= nil and red_qixie[202][self._index_sprite] ~= nil then
		self:getChildByTag(1):addChild(red_qixie[202][self._index_sprite])
	end
	if red_qixie[203] ~= nil and red_qixie[203][self._index_sprite] ~= nil then
		self:getChildByTag(1):addChild(red_qixie[203][self._index_sprite])
	end

	local blue = self._battle.blue.armys
	local red  = self._battle.red.armys
    local index = 1
	for i=1,table.getn(blue) do
		self._battle.blue.grids[index] = blue[i][self._index_sid]
	    self:doMove(self._blue_index,i,index)
	    index = index + 1
	    if index == 10 then
	    	break
	    end
	end
	index = 1
	for i=1,table.getn(red) do
		self._battle.red.grids[index] = red[i][self._index_sid]
	    self:doMove(self._red_index,i,index)
	    index = index + 1
	    if index == 10 then
	    	break
	    end
	end
end
--开战
function battleLayer:startBattle()
	for i=1,table.getn(self._battle.blue.armys) do
		if self._battle.blue.armys[i][self._index_state] == 1 then	
			return false		
		end
	end
	for i=1,table.getn(self._battle.red.armys) do
		if self._battle.red.armys[i][self._index_state] == 1 then	
			return false				
		end
	end	

	if self._battle.blue.qixie[201] ~= nil then
		local army = self._battle.blue.qixie[201][self._index_sprite]
		army:gogogo()	
	end				
	if self._battle.blue.qixie[202] ~= nil then
		local army = self._battle.blue.qixie[202][self._index_sprite]
		army:gogogo()	
	end				
	if self._battle.blue.qixie[203] ~= nil then
		local army = self._battle.blue.qixie[203][self._index_sprite]
		army:gogogo()	
	end				

	if self._battle.blue.walls[101] ~= nil then
		local army = self._battle.blue.walls[101][self._index_sprite]
		army:gogogo()	
	end			

	if self._battle.red.qixie[201] ~= nil then
		local army = self._battle.red.qixie[201][self._index_sprite]
		army:gogogo()	
	end				
	if self._battle.red.qixie[202] ~= nil then
		local army = self._battle.red.qixie[202][self._index_sprite]
		army:gogogo()	
	end				
	if self._battle.red.qixie[203] ~= nil then
		local army = self._battle.red.qixie[203][self._index_sprite]
		army:gogogo()	
	end		

	for i=1,table.getn(self._battle.blue.armys) do
		cclog(self._battle.blue.armys[i][self._index_state])
		if self._battle.blue.armys[i][self._index_state] == 2 then			
			local army = self._battle.blue.armys[i][self._index_sprite]
			army:gogogo()
		end
	end
	for i=1,table.getn(self._battle.red.armys) do
		if self._battle.red.armys[i][self._index_state] == 2 then			
			local army = self._battle.red.armys[i][self._index_sprite]			
			army:gogogo()
		end
	end	
	return true
end
--战斗
function battleLayer:dead()
	for i=1,table.getn(self._battle.blue.armys) do
		if self._battle.blue.armys[i][self._index_state] == 3 then			
			local army = self._battle.blue.armys[i][self._index_sprite]
			if army ~= nil then
				army:dealDead()
			end
		end
	end
	if self._battle.blue.qixie[201] ~= nil then
		local army = self._battle.blue.qixie[201][self._index_sprite]
		if army ~= nil then
			army:dealDead()
		end
	end		
	if self._battle.blue.qixie[202] ~= nil then
		local army = self._battle.blue.qixie[202][self._index_sprite]
		if army ~= nil then
			army:dealDead()
		end
	end		
	if self._battle.blue.qixie[203] ~= nil then
		local army = self._battle.blue.qixie[203][self._index_sprite]
		if army ~= nil then
			army:dealDead()
		end
	end		

	for i=1,table.getn(self._battle.red.armys) do
		if self._battle.red.armys[i][self._index_state] == 3 then			
			local army = self._battle.red.armys[i][self._index_sprite]
			if army ~= nil then
				army:dealDead()
			end
		end
	end	
	if self._battle.red.qixie[201] ~= nil then
		local army = self._battle.red.qixie[201][self._index_sprite]
		if army ~= nil then
			army:dealDead()
		end
	end		
	if self._battle.red.qixie[202] ~= nil then
		local army = self._battle.red.qixie[202][self._index_sprite]
		if army ~= nil then
			army:dealDead()
		end
	end		
	if self._battle.red.qixie[203] ~= nil then
		local army = self._battle.red.qixie[203][self._index_sprite]
		if army ~= nil then
			army:dealDead()
		end
	end
end
--更新部队
function battleLayer:sortArmys()
	for i=1,9 do
 		local army = self:getArmyByPos(self._blue_index,i)
		if army ~= nil then
			if army._my[self._index_effect] == 0 then
				army:dealSort(self:getArmyByPos(self._blue_index,i-3))
			end
		else
			if i >= 7 then
				for j=1,table.getn(self._battle.blue.armys) do
					if self._battle.blue.armys[j][self._index_target] == 0 and self._battle.blue.armys[j][self._index_sprite] == nil then
						sprite = initArmy(self._battle,self._blue_index,j,self._battle.blue.armys[j][self._index_sid])
						self._battle.blue.armys[j][self._index_sprite] = sprite
						self:getChildByTag(1):addChild(sprite);
						if i == 7 then						
							sprite:setPosition(cc.p(370,1564))
						elseif i == 8 then 
							sprite:setPosition(cc.p(524,1543))
						else
							sprite:setPosition(cc.p(671,1521))
						end						
						sprite:dealMove(i)
						break
					end
				end
			end
		end		
	end
	for i=1,9 do
		local army = self:getArmyByPos(self._red_index,i)
		if army ~= nil then
			if army._my[self._index_effect] == 0 then
				army:dealSort(self:getArmyByPos(self._red_index,i-3))
			end
		else
			if i >= 7 then 
				for j=1,table.getn(self._battle.red.armys) do
					if self._battle.red.armys[j][self._index_target] == 0 and self._battle.red.armys[j][self._index_sprite] == nil then
						sprite = initArmy(self._battle,self._red_index,j,self._battle.red.armys[j][self._index_sid])
						self._battle.red.armys[j][self._index_sprite] = sprite
						self:getChildByTag(1):addChild(sprite)
						sprite._my[self._index_state] = 0
						if i == 7 then						
							sprite:setPosition(cc.p(15,-121))
						elseif i == 8 then 
							sprite:setPosition(cc.p(168,-142))
						else
							sprite:setPosition(cc.p(315,-164))
						end
						sprite:dealMove(i)
						break
					end
				end
			end
		end		
	end	
end

function battleLayer:isBattleEnd()
	local ended = true
	for i=1,table.getn(self._battle.blue.armys) do
		if self._battle.blue.armys[i][self._index_state] ~= 4 then	
			ended = false
			break
		end
	end
	if self._battle.blue.qixie[201] ~= nil and self._battle.blue.qixie[201][self._index_state] ~= 4 then
		ended = false
	end
	if self._battle.blue.qixie[202] ~= nil and self._battle.blue.qixie[202][self._index_state] ~= 4 then
		ended = false
	end
	if self._battle.blue.qixie[203] ~= nil and self._battle.blue.qixie[203][self._index_state] ~= 4 then
		ended = false
	end

	if self._battle.blue.qixie[100] ~= nil and self._battle.blue.qixie[100][self._index_state] ~= 4 then
		ended = false
	end
	if self._battle.blue.qixie[101] ~= nil and self._battle.blue.qixie[101][self._index_state] ~= 4 then
		ended = false
	end
	if self._battle.blue.qixie[111] ~= nil and self._battle.blue.qixie[111][self._index_state] ~= 4 then
		ended = false
	end
	if self._battle.blue.qixie[121] ~= nil and self._battle.blue.qixie[121][self._index_state] ~= 4 then
		ended = false
	end
	for i=1,table.getn(self._battle.red.armys) do
		if self._battle.red.armys[i][self._index_state] ~= 4 then	
			ended = false
			break
		end
	end
	if self._battle.red.qixie[201] ~= nil and self._battle.red.qixie[201][self._index_state] ~= 4 then
		ended = false
	end
	if self._battle.red.qixie[202] ~= nil and self._battle.red.qixie[202][self._index_state] ~= 4 then
		ended = false
	end
	if self._battle.red.qixie[203] ~= nil and self._battle.red.qixie[203][self._index_state] ~= 4 then
		ended = false
	end
	return ended
end
function battleLayer:stopAll()
    self.stop = true;
	for i=1,table.getn(self._battle.blue.armys) do
		local army = self._battle.blue.armys[i][self._index_sprite]
		if army ~= nil then
			army:stop()
		end
	end
	for i=1,table.getn(self._battle.red.armys) do
		local army = self._battle.red.armys[i][self._index_sprite]
		if army ~= nil then
			army:stop()
		end
	end
	
    if ff.effects[401] ~= nil then
        AudioEngine.stopEffect(ff.effects[401])
    end
    if ff.effects[402] ~= nil then
        AudioEngine.stopEffect(ff.effects[402])
    end
    if ff.effects[403] ~= nil then
        AudioEngine.stopEffect(ff.effects[403])
    end
    if ff.effects[404] ~= nil then
        AudioEngine.stopEffect(ff.effects[404])
    end
    if ff.effects[406] ~= nil then
        AudioEngine.stopEffect(ff.effects[406])
    end

    pop.popDialog("result",self)
    local widget = pop.getDialog("result")
    widget:stopAllActions()
    widget:showReport(self._battle)
    pop.showPopEffect(14,widget,true) 
end

function battleLayer:getArmyByPos(type,pos)
 	if type == self._blue_index then
		for i=1,table.getn(self._battle.blue.armys) do
 			if self._battle.blue.armys[i][self._index_target] == pos then
 				if self._battle.blue.armys[i][self._index_live] > 0 then 
 					return self._battle.blue.armys[i][self._index_sprite]
 				end
				if self._battle.blue.armys[i][self._index_state] == 3 or self._battle.blue.armys[i][self._index_state] == 0 then			
					return self._battle.blue.armys[i][self._index_sprite]
				end
			end
		end	
	else
		for i=1,table.getn(self._battle.red.armys) do
			if self._battle.red.armys[i][self._index_target] == pos then
				if self._battle.blue.armys[i][self._index_live] > 0 then 
 					return self._battle.blue.armys[i][self._index_sprite]
 				end
				if self._battle.red.armys[i][self._index_state] == 3 or self._battle.red.armys[i][self._index_state] == 0 then								
					return self._battle.red.armys[i][self._index_sprite]
				end
			end
		end	
	end			
	return nil
end

function battleLayer:doMove(type,row,target)	
	local sprite = nil
	local sid = 0
    self.singleEnmy[type] = self.singleEnmy[type] or {}

	if type == self._blue_index then
		sprite = self._battle.blue.armys[row][self._index_sprite]
		sid = self._battle.blue.armys[row][self._index_sid]
	else
		sprite = self._battle.red.armys[row][self._index_sprite]
		sid = self._battle.red.armys[row][self._index_sid]
	end
	if sprite == nil then
		sprite = initArmy(self._battle,type,row,sid)
		if type == self._blue_index then
			self._battle.blue.armys[row][self._index_sprite] = sprite
		else	
			self._battle.red.armys[row][self._index_sprite] = sprite
		end
		self:getChildByTag(1):addChild(sprite,10 - type)
	end
	sprite:readyPosition(target)
end

function battleLayer:onStart()
	dd.yunOpen()	
	self:scheduleUpdateWithPriorityLua(function (dt)self:update(dt) end, 0)
end
function battleLayer:onEnd()
	self:unscheduleUpdate()
end
--入口
function runBattleScene(report,clear,masterid)
	cclog("runBattleScene")
    dd.clearBackEvent()
    local scene = cc.Director:getInstance():getRunningScene()
    local widget = scene:getChildByTag(1)
    if widget ~= nil then
        if widget == dd._cityLayer then
            dd._cityLayer:retain()
        end    	
        widget:stopAllActions()
        widget:removeFromParent(true)
    end

    local layer = battleLayer.extend(cc.Layer:create())
	dd.clearScene()
	dd.battleLayer = layer
	dd.currentLayer= layer
	dd.currentLayer._widget = dd.mainUI

    local armys = cc.Layer:create()
    layer:initBattle(report,clear,masterid)
    layer:addChild(armys,2,1)

  	--显示阶段    
    local function onEnterOrExit(tag)
	    if tag == "enter" then
	    	dd.playBackMusic(914,true)
	    elseif tag == "enterTransitionFinish" then
	    	layer:onStart()
	    elseif tag == "exitTransitionStart" then	
	    elseif tag == "exit" then   
	    	layer:onEnd()
        elseif tag == "cleanup" then
            if ff.set_power <= 1 then
                cc.Director:getInstance():getTextureCache():removeUnusedTextures()     
            end
	    end        	
    end
	layer:registerScriptHandler(onEnterOrExit)    
	scene:addChild(layer,1,1)
end
