local resultLayer   = class("resultLayer")
resultLayer._name = "resultLayer"
resultLayer._init = false


function resultLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, resultLayer)
    return target
end

function resultLayer.getColor(color)
    local colorcode = cc.c3b(196,213,214)
    if color == 1 then
        colorcode = cc.c3b(196,213,214)
    elseif color == 2 then
        colorcode = cc.c3b(75,137,81)
    elseif color == 3 then
        colorcode = cc.c3b(63,116,160)
    elseif color == 4 then
        colorcode = cc.c3b(164,80,151)
    elseif color == 5 then
        colorcode = cc.c3b(255,250,106)
    else
        colorcode = cc.c3b(196,213,214)
    end
    return colorcode
end

function resultLayer:skipDialog(index, item, base, report)
    self:getChildByName("infor"):setLocalZOrder(101)
    local currentType = base
    local xx,yy = currentType:getPosition()
    local dialog = self:getChildByName("infor"):clone()
    currentType:getParent():removeChildByTag(dialog:getTag())
    currentType:getParent():addChild(dialog)
    currentType:getParent():setLocalZOrder(100)
    dialog:setAnchorPoint(cc.p(0, 0))  
    dialog:setTouchEnabled(false)
    dialog:setPosition(xx, yy+67)
    dialog:setScale(0.1)
    dialog:setOpacity(255)
    dialog:stopAllActions()
    dialog:runAction(cc.ScaleTo:create(0.2,1))
    --set dialog stringValue

    local richText1 = ccui.RichText:create()
    richText1:ignoreContentAdaptWithSize(false)
    richText1:setContentSize(cc.size(330,600)) 
    richText1:setAutoHeight() 
    richText1:runAction(cc.ScaleTo:create(0.1,1))
    local name = {ff.langString("石油"),ff.langString("木材"),ff.langString("钢铁"),ff.langString("粮食"),ff.langString("银币")}
    local count1 = 0
    local resultName = ccui.RichElementText:create(1, self.getColor(1), 255, name[index], "Helvetica", 24)
    local resultCount = ccui.RichElementText:create(2, self.getColor(1), 255, "\n"..ff.langString("总量+"..dd.showKM(report.base.res[index],3)), "Helvetica", 24)
    richText1:insertElement(resultName,count1)
    count1 = count1 + 1
    richText1:insertElement(resultCount,count1)
    count1 = count1 + 1
    richText1:formatText()
    if item == 1 then
        dialog:setPositionX(xx+110)
        dialog:getChildByName("Image_46"):setPositionX(-90)
    elseif item == 2 then
        dialog:getChildByName("Image_46"):setPositionX(0)
    elseif item == 3 then
        dialog:getChildByName("Image_46"):setPositionX(0)
    elseif item == 4 then
        dialog:getChildByName("Image_46"):setPositionX(0)
    elseif item == 5 then
        dialog:setPositionX(xx-110)
        dialog:getChildByName("Image_46"):setPositionX(90)
    end
    local size2 = dialog:getChildByName("kuang"):getContentSize()
        
    local height = 0
    local size1 = richText1:getContentSize()
    height = size1.height
    dialog:getChildByName("kuang"):setContentSize(cc.size(size2.width, height+40))
    richText1:setPosition(cc.p(size2.width/2,height - size1.height/2 + 20))
    dialog:getChildByName("kuang"):addChild(richText1)
    dialog:getChildByName("kuang"):setPosition(dialog:getChildByName("kuang"):getPositionX(),60)
    richText1:setTag(1)
    dialog:setVisible(true)
    dialog:runAction(cc.Sequence:create(cc.DelayTime:create(6), cc.CallFunc:create(function () richText1:removeFromParent() end)))
    dialog:runAction(cc.Sequence:create(cc.DelayTime:create(5), cc.CallFunc:create(function () dialog:runAction(cc.FadeOut:create(2)) end)))
end


function resultLayer:showReport(report)
    self:onEndBattle()
    local function click(sender, eventType)
        local doaction = false
        if eventType == ccui.TouchEventType.canceled then
            local startp = sender:getTouchBeganPosition()
            local endp   = sender:getTouchEndPosition()
            if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                doaction = true
            end
        end
    
        if eventType==ccui.TouchEventType.ended then    
            doaction = true
        end
        if doaction == true then
            local tag = math.floor(sender:getTag()/10)
            local item = sender:getTag()%10
            self:skipDialog(tag,item, sender, report)
        end
    end


    local function seeFightRep(sender,eventType)
        --看战报跳转
        if eventType == ccui.TouchEventType.ended then
            dd.mainUI.outBattle(sender,eventType)
            if pop.isShowing("mail") then
                local widget = pop.getDialog("mail")
                if widget ~= nil then
                    if widget._type ~= 1 then
                        widget.selectType(widget:getChildByName("topNavi"):getChildByName("btreport"),ccui.TouchEventType.ended)
                        widget:getChildByName("topNavi"):getChildByName("btreport"):setSelectedState(true)
                    end
                end
            else
                pop.onShowPopDialog("mail",1)
            end  
            
        end
    end

    if (report.base.result == 1 and report.base.myindex == 1) or (report.base.result == 2 and report.base.myindex == 2) then
        AudioEngine.playEffect(ff.sounds[305]) 
        self:getChildByName("back"):loadTexture("images/battle/result/img03_fight.png",0)
        self:getChildByName("chu_label1"):setColor(cc.c3b(255,222,0))
        self:getChildByName("chu_label1"):setString(ff.langString("战斗胜利"))
        self:getChildByName("chu_label1"):setPosition(self:getChildByName("chu_label1"):getPositionX(),self:getChildByName("label2"):getPositionY()+40)
        self:getChildByName("label2"):setString("")
        local data  = {}
        for i=1,5 do
            if dd.myinfo:getLong(1,"level") <= 10 then
                if report.base.res[i] > 0 and i~=1 and i~=3 then
                    data[table.getn(data) + 1] = i
                end
            elseif dd.myinfo:getLong(1,"level") <= 14 then
                if report.base.res[i] > 0 and i~=3 then
                    data[table.getn(data) + 1] = i
                end
            else
                if report.base.res[i] > 0 then
                    data[table.getn(data) + 1] = i
                end
            end
        end
        local spriteBack = sp.SkeletonAnimation:create("images/pve/PVEshengli.json", "images/pve/PVEshengli.atlas")
        spriteBack:setPosition(cc.p(360, -70))
        spriteBack:setAnimation(0, "PVEshengli_animation", true)
        local item1 =  self:getChildByName("item1")
        local sprite =  sp.SkeletonAnimation:create("images/pve/PveAnimation/zhuchengshengji.json", "images/pve/PveAnimation/zhuchengshengji.atlas")
        sprite:setPosition(cc.p(item1:getContentSize().width / 2, item1:getContentSize().height / 2))
        sprite:setAnimation(0, "Guangquan_animation", true)
        sprite:setLocalZOrder(0)
        self:getChildByName("item1"):addChild(sprite,0,120)
        local sprite2 = sp.SkeletonAnimation:create("images/pve/PveAnimation/zhuchengshengji.json", "images/pve/PveAnimation/zhuchengshengji.atlas")
        sprite2:setPosition(cc.p(item1:getContentSize().width / 2, item1:getContentSize().height / 2))
        sprite2:setAnimation(0, "Guangquan_animation", true)
        sprite2:setLocalZOrder(0)
        self:getChildByName("item2"):addChild(sprite2,0,120)
        local sprite3 = sp.SkeletonAnimation:create("images/pve/PveAnimation/zhuchengshengji.json", "images/pve/PveAnimation/zhuchengshengji.atlas")
        sprite3:setPosition(cc.p(item1:getContentSize().width / 2, item1:getContentSize().height / 2))
        sprite3:setAnimation(0, "Guangquan_animation", true)
        sprite3:setLocalZOrder(0)
        self:getChildByName("item3"):addChild(sprite3,0,120)
        local sprite4 = sp.SkeletonAnimation:create("images/pve/PveAnimation/zhuchengshengji.json", "images/pve/PveAnimation/zhuchengshengji.atlas")
        sprite4:setPosition(cc.p(item1:getContentSize().width / 2, item1:getContentSize().height / 2))
        sprite4:setAnimation(0, "Guangquan_animation", true)
        sprite4:setLocalZOrder(0)
        self:getChildByName("item4"):addChild(sprite4,0,120)
        local sprite5 = sp.SkeletonAnimation:create("images/pve/PveAnimation/zhuchengshengji.json", "images/pve/PveAnimation/zhuchengshengji.atlas")
        sprite5:setPosition(cc.p(item1:getContentSize().width / 2, item1:getContentSize().height / 2))
        sprite5:setAnimation(0, "Guangquan_animation", true)
        sprite5:setLocalZOrder(0)
        self:getChildByName("item5"):addChild(sprite5,0,120)
        self:getChildByName("item1"):setVisible(false)
        self:getChildByName("item2"):setVisible(false)
        self:getChildByName("item3"):setVisible(false)
        self:getChildByName("item4"):setVisible(false)
        self:getChildByName("item5"):setVisible(false)
        for i=1,table.getn(data) do
            local j = data[i]
            self:getChildByName("item"..i):setVisible(true)
            self:getChildByName("item"..i):getChildByName("icon"):loadTexture(dd.getPathFromUI("ic0"..j.."_big.png",1))
            self:getChildByName("item"..i):getChildByName("num_bg"):getChildByName("count"):setString(dd.showKM(report.base.res[j],3))
            self:getChildByName("item"..i):addTouchEventListener(click)
            self:getChildByName("item"..i):setTag(j*10+i)
        end
    else
        AudioEngine.playEffect(ff.sounds[306]) 
        self:getChildByName("back"):loadTexture("images/battle/result/img04_fight.png",0)
        self:getChildByName("chu_label1"):setString(ff.langString("战斗失败"))
        self:getChildByName("chu_label1"):setPosition(self:getChildByName("chu_label1"):getPositionX(),self:getChildByName("label2"):getPositionY()+40)
        self:getChildByName("label2"):setString("")
    end
    self:getChildByName("result_label"):getChildByName("lable1"):setString(ff.getFormatMoney(report.base.deads[1]))
    self:getChildByName("result_label"):getChildByName("label2"):setString(ff.getFormatMoney(report.base.deads[2]))
    self:getChildByName("result_label"):getChildByName("label3"):setString(ff.getFormatMoney(report.base.deads[3]))
    self:getChildByName("report"):addTouchEventListener(seeFightRep)
 end

function resultLayer:onEndBattle()
    for i=1,5 do
        local node =  self:getChildByName("item"..i):getChildByTag(120)
        if node ~= nil then 
            node:removeFromParent(true)
        end
    end
    self:getChildByName("infor"):setVisible(false)
    self:getChildByName("item1"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
    self:getChildByName("item2"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
    self:getChildByName("item3"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
    self:getChildByName("item4"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
    self:getChildByName("item5"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
    self:getChildByName("back"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
    local node = self:getChildByName("back"):getChildByTag(50)
    if node ~=nil then 
        node:removeFromParent(true)
    end 
end

function resultLayer.onEnd(sender)

end
function resultLayer.onStart(sender)
    sender:requestDoLayout()
end
function resultLayer.onBefore(sender)
    return false
end

function resultLayer:onInit()
    if self._init == false then
        self:setPositionY(-105)
        self:setContentSize(cc.size(720,ff.height)) 
        self:getChildByName("close"):addTouchEventListener(dd.mainUI.outBattle)
        self._init = true
    end
end


function onShowPvpResult(widget)
    local layer = resultLayer.extend(widget)
    layer:onInit()
    return layer
end