--建筑
local BuildingSprite = class("BuildingSprite")

BuildingSprite._bid  = 0
BuildingSprite._pos  = 0
BuildingSprite._order= 0
BuildingSprite._level= 0
BuildingSprite._state= 0
BuildingSprite._name = "BuildingSprite"
--1 spine 2-sprite
BuildingSprite._type = 1
BuildingSprite._init = false
BuildingSprite._sprite    = nil
BuildingSprite._animation = nil
BuildingSprite._empty = false
BuildingSprite._statesprite = nil
BuildingSprite._clicksp = nil
BuildingSprite._clock   = nil
BuildingSprite._flash   = false
BuildingSprite._hand    = nil
BuildingSprite._newbie  = 0
BuildingSprite._free = nil

function BuildingSprite.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, BuildingSprite)
    return target
end


function BuildingSprite:closeFlash()
    if self._flash == true then
        self:removeClick()
        self._flash = false
        self:showHand(false)
    end
end
function BuildingSprite:flash(show)
    if self._flash == show then
        return
    end
    if show == false then
        self:removeClick()
    else
        self:addClick(true)        
    end
    self._flash = show
    self:showHand(show)
end
function BuildingSprite:showHand(show)
    if self._free ~= nil then
        return
    end
    if dd.cityLayer ~= nil and dd.cityLayer._level ~= nil then
        local restag = dd.cityLayer._level:getChildByTag(self._pos * 1000 + 4)
        if restag ~= nil then
            return
        end
    end
    --新手引导期间，不显示
    if dd.canShowHandArrow() == false then
        return
    end
    if self._hand == nil then
        self._hand = cc.Sprite:create("images/city/effect/hand.png")                      
        self:addChild(self._hand,9,9)
    end
    self._hand:stopAllActions()
    if self._bid == 5 then
        self._hand:setPosition(20,-150)
    else
        self._hand:setPosition(20,60)
    end
    if show == true then
        local action = cc.MoveBy:create(0.5,cc.p(-20,-40))
        local back = action:reverse()
        self._hand:runAction(cc.RepeatForever:create(cc.Sequence:create(action,back)))
        self._hand:setVisible(true)
    else
        self._hand:setVisible(false)
    end
end

function BuildingSprite:showResBuff(  )
    -- body
    if self._bid >= 23 and self._bid <= 27 then
        local buffID = 1
        if self._bid == 23 then
            buffID = 10 
        elseif self._bid == 24 then
            buffID = 8 
        elseif self._bid == 25 then
            buffID = 11 
        elseif self._bid == 26 then
            buffID = 9
        elseif self._bid == 27 then
            buffID = 12
        end
        local show = false
        for i=1,dd.myplus:rowCount() do
            if dd.myplus:getLong(i,"id") == tonumber(dd.cfgBuffShow[buffID]['effect']) then
                show = true
                break
            end
        end
        if show == true then
            if dd.cityLayer ~= nil then
                if self._animation ~= nil then
                    dd.cityLayer:showResBuff(true,self._pos,self._animation:getContentSize().width/2,self._animation:getContentSize().height/2)
                else           
                    dd.cityLayer:showResBuff(true,self._pos,self._sprite:getContentSize().width/2,self._sprite:getContentSize().height/2)
                end
            end   
        else

            if dd.cityLayer ~= nil then
                dd.cityLayer:showResBuff(false,self._pos)
            end
        end 
    end
end

function BuildingSprite:setBuildingFrame(bid,state,level,pos,ref)
    self._bid   = bid
    self._state = state
    self._level = level
    local image = 0
    if level == 0 then
        image = dd.cfgBuildingUp[self._bid][1]['image']
    else
        if dd.cfgBuildingUp[self._bid][level] ~= nil then
            image = dd.cfgBuildingUp[self._bid][level]['image']
        else
            image = dd.cfgBuildingUp[self._bid][1]['image']
        end
    end 
    if image > 10 then
        local str = self._bid.."_"..(image - 10)
        if self._animation == nil then
            self._animation = sp.SkeletonAnimation:create("images/builds/"..self._bid.."/"..str..".json", "images/builds/"..self._bid.."/"..str..".atlas")
            self._animation:setAnimation(0,str.."_animation",true)
            self._animation:setTag(image - 10)
            self:addChild(self._animation)
            self:setPosition(cc.p(pos[1]+self._animation:getContentSize().width/2,pos[2]+self._animation:getContentSize().height/2))
            self._sprite:setVisible(false)
            self._type = 2
        else
            local tag = self._animation:getTag()
            if tag ~= image - 10 then
                self._animation:removeFromParent(true)
                self._animation = sp.SkeletonAnimation:create("images/builds/"..self._bid.."/"..str..".json", "images/builds/"..self._bid.."/"..str..".atlas")
                self._animation:setAnimation(0,str.."_animation",true)
                self._animation:setTag(image - 10)
                self:addChild(self._animation)
                self:setPosition(cc.p(pos[1]+self._animation:getContentSize().width/2,pos[2]+self._animation:getContentSize().height/2))
            end
        end    
    else
        self._type = 1
        if self._animation ~= nil then
            self._animation:removeFromParent(true)
            self._animation = nil
        end   

        if self._bid ~= 5 then
            self._sprite:setTexture(dd.getBuildImage(self._bid,level))
            ff.SantanaImageData:addImage(dd.getBuildImage(self._bid,level),dd.getBuildMask(self._bid,level))
            self._sprite:setScale(1)
            self._sprite:setPosition(cc.p(0,0))
            self:setPosition(cc.p(pos[1]+self._sprite:getContentSize().width/2,pos[2]+self._sprite:getContentSize().height/2))
        end    
    end     
    self:setLevelSprite()
    self:showCanUp()
    if ref == true then
        if self._animation ~= nil and image > 10 then
            local str = self._bid.."_"..(image - 10)
            self._animation:setAnimation(0,str.."_animation",true)
        end
        if self._statesprite ~= nil then
            self._statesprite:setAnimation(0,"animation",true)
        end
    end

    local slevel = dd.cfgPos[self._pos]['lv']
    if slevel > 0 and slevel < 99 then
        if dd.myinfo:getLong(1,"level") < slevel then
            if self._clock == nil then
                self._clock = dd.safeCreateWithSpriteFrameName("fclock.png","images/builds.plist")    
                if self._bid == 3 then               
                    self._clock:setPosition(0,-80)
                elseif self._bid == 14 then
                    self._clock:setPosition(0,-40)
                else
                    self._clock:setPosition(0,0)
                end
                self:addChild(self._clock,99,99)
            end
        else
            if self._clock ~= nil then
                self._clock:removeFromParent(true)
                self._clock = nil
            end
        end
    end
end
function BuildingSprite:setPlace(pos,mod,lv)
    if lv == 99 and self._clock == nil then
        self._clock = dd.safeCreateWithSpriteFrameName("fclock.png","images/builds.plist")    
        self._clock:setPosition(0,0)
        self:addChild(self._clock,99,99)
    else
        if lv <= 0 then
            return
        end
        if dd.myinfo:getLong(1,"level") >= lv then
            local have = false
            for j=1,dd.myLocks:rowCount() do
                if dd.myLocks:getLong(j,"pos") == self._pos then
                    have = true
                    break
                end
            end
            if have == false then
                self._empty = true
                if mod == 2 then
                    self._sprite:setSpriteFrame("e2.png")
                    self._sprite:setScale(1)
                    self._sprite:setPosition(cc.p(0,0))
                    self:setPosition(cc.p(pos[1]+self._sprite:getContentSize().width/2,pos[2]+self._sprite:getContentSize().height/2))
                end            
                if self._clock == nil then
                    self._clock = sp.SkeletonAnimation:create("images/city/effect/jiesuo.json", "images/city/effect/jiesuo.atlas")
                    self:addChild(self._clock,8,8)
                    self._clock:setPosition(cc.p(0,0))
                end
                self._clock:setAnimation(0,"JIESUO2_animation",true)
            end
        else
            self._empty = true
            if mod == 2 then
                self._sprite:setSpriteFrame("e2.png")
                self._sprite:setScale(1)
                self._sprite:setPosition(cc.p(0,0))
                self:setPosition(cc.p(pos[1]+self._sprite:getContentSize().width/2,pos[2]+self._sprite:getContentSize().height/2))
            end            
        end
    end        
end
function BuildingSprite:addLock(frist)
    if frist ~= nil and frist == true then
        local label = self:getChildByTag(999)
        if label ~= nil then
            label:stopAllActions()
            label:runAction(cc.RemoveSelf:create())
        end
    end    
    if self._bid > 0 then
        return
    end

    if self._clock == nil then        
        if dd.myinfo:getLong(1,"level") >= dd.cfgPos[self._pos]['lv'] and dd.cfgPos[self._pos]['lv'] > 0 then
            local have = false
            for j=1,dd.myLocks:rowCount() do
                if dd.myLocks:getLong(j,"pos") == self._pos then
                    have = true
                    break
                end
            end
            if have == false then
                self._clock = sp.SkeletonAnimation:create("images/city/effect/jiesuo.json", "images/city/effect/jiesuo.atlas")
                self:addChild(self._clock,8,8)
                self._clock:setPosition(cc.p(0,0))          
                self._clock:setAnimation(0,"JIESUO2_animation",true)
            end
        end
    end
end
function BuildingSprite:unLock()
    if self._clock ~= nil then
        self._clock:setAnimation(0,"JIESUO_animation",false)
    end
    local function remove()
        if dd.cityLayer ~= nil then
            self:updateRemove(dd.cityLayer._pos[self._pos])
            GuideControl:GuideCheck()
        end
    end
    local function onSound()
        if dd.cityLayer ~= nil then
            AudioEngine.playEffect(ff.sounds[221])
        end
        GuideControl:GuideCheck()
    end
    performWithDelay(self, onSound, 0.8)
    self:runAction(cc.Sequence:create(cc.FadeOut:create(1.5),cc.CallFunc:create(remove)))
end

function BuildingSprite:showGetRes(num)
    local lab = cc.Label:createWithSystemFont("+"..num, "", 30)
    lab:enableBold(true)
    lab:enableOutline(cc.c4b(0,0,0,255),3)
    lab:setColor(cc.c3b(0,255,0))
    lab:setPosition(cc.p(0,0))
    self:addChild(lab,999,999)

    local action = cc.Spawn:create(
                cc.EaseExponentialOut:create(cc.MoveBy:create(1, cc.p(0,80))),
                cc.FadeOut:create(1)
                )
    lab:runAction(cc.Sequence:create(cc.ScaleTo:create(0.05,1.25),cc.ScaleTo:create(0.125, 1),cc.DelayTime:create(1),action,cc.RemoveSelf:create()))        
end

function BuildingSprite:showGetArmys(type,sid,num)
    local str = ff.langString(dd.cfgSoldier[sid]['soldierName']).." +"..num
    local lab = cc.Label:createWithSystemFont(str, "", 24)
    lab:setColor(cc.c3b(0,255,0))
    if self._bid == 5 then
        lab:setPosition(cc.p(250,-200))
    else
        lab:setPosition(cc.p(0,0))
    end
    self:addChild(lab,999,999)
    local action = cc.Spawn:create(
                cc.EaseExponentialOut:create(cc.MoveBy:create(1, cc.p(0,80))),
                cc.FadeOut:create(1)
                )
    lab:runAction(cc.Sequence:create(cc.ScaleTo:create(0.05,1.25),cc.ScaleTo:create(0.125, 1),action,cc.RemoveSelf:create()))        
end



function BuildingSprite:updateRemove(pos)
    if self._empty == true then
        self._empty = false
    end
    --清理当前地块资源
    --if dd.myResInfo[pos] ~= nil then
    --    dd.myResInfo[pos] = nil
    --end

    if self._type == 2 then
        if self._animation ~= nil then
            self._animation:removeFromParent(true)
            self._animation = nil
        end   
        self._type = 1
        self._bid  = 0
    else    
        self._bid  = 0
        local src = (self._mod + 1000)..".png"
        if self._mod == 5 then
            src = "wall5.png"
        end    
        if self._sprite ~= nil then
            self._sprite:setSpriteFrame(src)
        end     
    end    
    if self._sprite ~= nil then
        local ww = self._sprite:getContentSize().width * 10
        local hh = self._sprite:getContentSize().height* 10

        local xx = pos[1] + ww/2
        local yy = pos[2] + hh/2
        self._sprite:setScale(10)
        self._sprite:setPosition(cc.p(0,0))

        self:setPosition(cc.p(xx,yy))
        self._sprite:setVisible(true)
    end        
    if self._clock ~= nil then
        self._clock:removeFromParent(true)
        self._clock = nil
    end
    if self._hand ~= nil then
        self._hand:removeFromParent(true)
        self._hand = nil
    end

    if dd.cityLayer ~= nil then
        dd.cityLayer:showUpLevel(false,self._pos)
        dd.cityLayer:showResBuff(false,self._pos)
        dd.cityLayer:removeLevel(self._pos)
        dd.cityLayer:removeLevelName(self._pos)
        dd.cityLayer:removeResTag(self._pos)
    end
    if self._statesprite ~= nil then    
        self._statesprite:removeFromParent(true)
        self._statesprite = nil
    end
    if self._free ~= nil then
        self._free:removeFromParent(true)
        self._free = nil
    end        
end

function BuildingSprite:checkFree()
    local free = false
    for i=1,dd.mylists:rowCount() do
        local type = dd.mylists:getLong(i,"type")
        if type == 1 or type == 13 then
            if dd.mylists:getLong(i,"param1") == self._pos then
                if dd.mylists:getLong(i,"param2") == 1 then
                    local starttime = dd.mylists:getLong(i,"start")
                    local endtime   = dd.mylists:getLong(i,"end")
                    local curtime   = dd.getServerTime()
                    local total     = endtime - starttime
                    local now       = curtime - starttime
                    if total - now <= dd.getRealFreeTick() then
                        free = true
                    else
                        free = false
                    end                
                end
            end
        end
    end
    if free == true and self._free == nil then
        self._free = sp.SkeletonAnimation:create("images/city/effect/free.json", "images/city/effect/free.atlas")
        self._free:setAnimation(0,"Free_animation",true)
        self:addChild(self._free,4,4)
        self._free:setTag(self._pos)
        if self._bid == 5 then
            self._free:setPosition(cc.p(260,-100))
        else
            if dd.cfgPos[self._pos]["mod"] == 2 then
                self._free:setPosition(cc.p(0,60))
            elseif dd.cfgPos[self._pos]["mod"] == 1 then
                self._free:setPosition(cc.p(-30,120))
            else
                self._free:setPosition(cc.p(0,120))
            end
        end
    end
    if free == false and self._free ~= nil then
        self._free:removeFromParent(true)
        self._free = nil
    end
    if self._free ~= nil then
        self._free:setVisible(true)
    end
    return free
end
function BuildingSprite:showCanUp()
    if dd.myinfo == nil then
        return
    end
    self:checkFree()
    self:checkResTag()
    self:checkShowName()
    if self._bid == 5 or self._bid == 37 then
        return
    end
    if dd.cfgBuilding[self._bid] == nil then
        return
    end
    if dd.cfgPos[self._pos]["lv"] == 99 then
        return
    end
    local slevel = dd.cfgPos[self._pos]['lv']
    if slevel > dd.myinfo:getLong(1,"level") then
        return
    end

    if dd.cityLayer ~= nil then
        if dd.cityLayer._buildingEffect ~= nil and dd.cityLayer._buildingEffect:getTag() == self._pos then
            dd.cityLayer:showUpLevel(false,self._pos)
            return
        end
        if dd.cityLayer._buildingEffectEx ~= nil and dd.cityLayer._buildingEffectEx:getTag() == self._pos then
            dd.cityLayer:showUpLevel(false,self._pos)
            return
        end
    end

    if self._level > 0 then
        local show = true
        local level = self._level + 1
        if level > dd.cfgBuilding[self._bid]['maxlevel'] then
            show = false
        elseif dd.cfgBuildingUp[self._bid][level]['iron'] > dd.iron() then      
            show = false
        elseif dd.cfgBuildingUp[self._bid][level]['stone'] > dd.stone() then
            show = false
        elseif dd.cfgBuildingUp[self._bid][level]['food'] > dd.food() then
            show = false
        elseif dd.cfgBuildingUp[self._bid][level]['wood'] > dd.wood() then
            show = false
        elseif dd.cfgBuildingUp[self._bid][level]['tid'] > 0  and dd.cfgBuildingUp[self._bid][level]['tcount'] > dd.getToolsCount(dd.cfgBuildingUp[self._bid][level]['tid']) then
            show = false
        end 

        if show == false then
            if dd.cityLayer ~= nil then
                dd.cityLayer:showUpLevel(false,self._pos)
            end
            return            
        end

        local bid   = dd.cfgBuildingUp[self._bid][level]["bid1"]
        local level1 = dd.cfgBuildingUp[self._bid][level]["level1"]
        if bid > 0 and level1 ~=nil then
            local have = false
            for i=1,dd.mybuilds:rowCount() do
                if bid == dd.mybuilds:getLong(i,"bid") then
                    if dd.mybuilds:getLong(i,"level") >= level1 then
                        have = true
                        break
                    end 
                end
            end
            if have == false then
                show = false
            end
        end
        bid   = dd.cfgBuildingUp[self._bid][level]["bid2"]
        level1 = dd.cfgBuildingUp[self._bid][level]["level2"]
        if bid > 0 then
            local have = false
            for i=1,dd.mybuilds:rowCount() do
                if bid == dd.mybuilds:getLong(i,"bid") then
                    if dd.mybuilds:getLong(i,"level") >= level1 then
                        have = true
                        break
                    end 
                end
            end
            if have == false then
                show = false
            end
        end
        --BUG fix
        if self._animation == nil and self._sprite == nil then
            show = false
        end

        if show == true then
            if dd.cityLayer ~= nil then
                if self._animation ~= nil then
                    dd.cityLayer:showUpLevel(true,self._pos,self._animation:getContentSize().width/2,70)
                else           
                    dd.cityLayer:showUpLevel(true,self._pos,self._sprite:getContentSize().width/2,70)
                end
            end   
        else
            if dd.cityLayer ~= nil then
                dd.cityLayer:showUpLevel(false,self._pos)
            end            
        end
    end
end
function BuildingSprite:checkResTag()
    if self._free ~= nil then
        dd.cityLayer:removeResTag(self._pos)
        return
    end
    if self._bid >= 23 and self._bid <= 27 then
        if dd.myResInfo[self._pos] ~= nil then
            local canget = dd.myResInfo[self._pos]['nowNum'] + math.max(dd.myResInfo[self._pos]['pro'] * (dd.getServerTime() - dd.myResInfo[self._pos]['lastUpdate'])/3600,0)
            if canget >= dd.myResInfo[self._pos]['limit']/10 then
                if self._animation ~= nil then
                    dd.cityLayer:addResTag(self._pos,self._bid,self._animation:getContentSize().width/2,self._animation:getContentSize().height - 37)
                else
                    dd.cityLayer:addResTag(self._pos,self._bid,self._sprite:getContentSize().width/2,self._sprite:getContentSize().height - 37)
                end                
            else
                dd.cityLayer:removeResTag(self._pos)
            end
        else
            if dd.cityLayer ~= nil then
                dd.cityLayer:removeResTag(self._pos)
            end            
        end
        self:showResBuff()
    end
    if self._bid == 21 or self._bid == 5 or self._bid == 32 then
        local type = 0
        if self._bid == 21 then
            type = 3
        elseif self._bid == 5 then
            type = 4
        else
            type = 11
        end

        local have = false
        for i=1,dd.mylists:rowCount() do
            if dd.mylists:getLong(i,"type") == type and dd.mylists:getLong(i,"param3") == 1 then
                have = true
                if self._animation ~= nil then
                    dd.cityLayer:addResTag(self._pos,self._bid,self._animation:getContentSize().width/2,self._animation:getContentSize().height - 37)
                else
                    dd.cityLayer:addResTag(self._pos,self._bid,self._sprite:getContentSize().width/2,self._sprite:getContentSize().height - 37)
                end                
                break
            end
        end
        if have == false then
            if dd.cityLayer ~= nil then
                dd.cityLayer:removeResTag(self._pos)
            end            
        end          
    end    
end

function BuildingSprite:setLevelSprite()
    if dd.cityLayer ~= nil then
        if self._animation ~= nil then
            dd.cityLayer:addLevel(self._pos,self._level,self._animation:getContentSize().width/2,30)
        else
            if self._bid == 5 then
                dd.cityLayer:addLevel(self._pos,self._level,self._sprite:getContentSize().width/2,30)
            else
                dd.cityLayer:addLevel(self._pos,self._level,self._sprite:getContentSize().width/2,30)
            end
        end
    end
    if self._bid == 1 then
        if dd.mainUI ~= nil then
            dd.mainUI:checkResIcon()
        end
    end
end
function BuildingSprite:checkShowName()
    if dd.cityLayer ~= nil then
        if dd.cityLayer:isLevelShow(self._pos) == false then
            return
        end
    end
    if dd.cityLayer ~= nil and dd.cityLayer._map ~= nil then
        local xyScale = dd.currentLayer._map:getScale()
        if xyScale > 0.8 + 0.001 then
            if self._showname == false then
                if self._animation ~= nil then
                    dd.cityLayer:addLevelName(self._pos,self._bid,self._animation:getContentSize().width/2)
                else
                    dd.cityLayer:addLevelName(self._pos,self._bid,self._sprite:getContentSize().width/2)
                end
                self._showname = true
            end
        else
            self._showname = false
            dd.cityLayer:removeLevelName(self._pos)
        end
    end
end

function BuildingSprite.openBuilding(sender,eventType)
    if eventType==ccui.TouchEventType.ended then
        local pos = sender:getTag()
        onShowBuildsList(dd.currentLayer._widget,pos)
    end
end

function BuildingSprite:setState()
    if self._bid ~= 21 and self._bid ~= 22 and self._bid ~= 4 and self._bid ~= 11 then
        return
    end
    local show = true
    for i=1,dd.mylists:rowCount() do
        if dd.mylists:getLong(i,"type") == 2 and self._bid == 11 then
            show = false
            break
        end
        if dd.mylists:getLong(i,"type") == 3 and self._bid == 21 then
            show = false
            break
        end
        if dd.mylists:getLong(i,"type") == 5 and self._bid == 16 then
            show = false
            break
        end
        if dd.mylists:getLong(i,"type") == 8 and self._bid == 4 then
            show = false
            break
        end
        if dd.mylists:getLong(i,"type") == 9 and self._bid == 22 then
            show = false
            break
        end
    end
    if show == true and self._bid == 22 then
        show = false
        for i=1,dd.soliders:rowCount() do
            if dd.soliders:getLong(i,"hurtcount") > 0 then
                show = true
                break
            end
        end
    end
    --if self._bid == 22 then
    --    show = true
    --end
    --ZZ
    if show == true then
        if self._statesprite == nil then
            --self._statesprite = dd.currentLayer._widget:getChildByName("state"):clone()
            if self._bid == 22 then
                self._statesprite = sp.SkeletonAnimation:create("images/city/healths.json", "images/city/healths.atlas")
                self._statesprite:setAnimation(0,"Yiliao_animation",true)
            else
                self._statesprite = sp.SkeletonAnimation:create("images/city/zz.json", "images/city/zz.atlas")
                self._statesprite:setAnimation(0,"animation",true)
            end
            self:addChild(self._statesprite,4,self._pos)
            self._statesprite:setTag(self._pos)

            if self._bid == 11 or self._bid == 21 then
                --self._statesprite:setPosition(cc.p(130 - self._animation:getContentSize().width/2,226 - self._animation:getContentSize().height/2))
                self._statesprite:setPosition(cc.p(0,0))
            elseif self._bid == 22 then    
                self._statesprite:setPosition(cc.p(0,60))
            else
                --self._statesprite:setPosition(cc.p(130 - self._sprite:getContentSize().width/2,226 - self._sprite:getContentSize().height/2))
                self._statesprite:setPosition(cc.p(0,0))
            end
        end
        self._statesprite:setVisible(true)        
    else
        if self._statesprite ~= nil then
            self._statesprite:setVisible(false)
        end
    end
end

function BuildingSprite:addClick(flash)
    if self._bid <= 0 or self._bid == 5 then
        if self._empty == true then
            self._sprite:setOpacity(220)
        else
            if self._clicksp ~= nil then
                self._clicksp:stopAllActions()
            else
                if self._bid == 5 then
                    self._clicksp = dd.safeCreateWithSpriteFrameName("wall5.png","images/builds.plist")                      
                    self._clicksp:setScale(10)  
                    self._clicksp:setOpacity(50)
                else
                    self._clicksp = dd.safeCreateWithSpriteFrameName("bclick.png","images/builds.plist")                      
                    self._clicksp:setScale(self._sprite:getContentSize().width * 10 /252)  
                    self._clicksp:setOpacity(100)
                end                
                self:addChild(self._clicksp,6,6)
            end
            self._clicksp:setVisible(true)
            self._clicksp:setPosition(cc.p(0,0))
            if flash == true then
                local action = cc.Blink:create(2, 3)
                self._clicksp:runAction(cc.RepeatForever:create(cc.Sequence:create(action,action:reverse())))
            end
        end
    else
        if self._type == 1 and self._sprite ~= nil then
            local effect = ff.Effect:effectHighLight()    
            self._sprite:setGLProgramState(effect:getGLProgramState())
            if flash == true then
                local function blink(type)
                    if type == true then
                        self._sprite:setGLProgramState(ff.Effect:effectHighLight():getGLProgramState())
                    else
                        self._sprite:setGLProgramState(ff.gameCore:getNormalGLState())
                    end
                end
                self._sprite:runAction(cc.RepeatForever:create(cc.Sequence:create(cc.DelayTime:create(0.5),cc.CallFunc:create(function() blink(false) end),cc.DelayTime:create(0.5),cc.CallFunc:create(function() blink(true) end))))
            end
        elseif self._animation ~= nil then
            local effect = ff.Effect:effectSpineHighLight()    
            self._animation:setGLProgramState(effect:getGLProgramState())
            if flash == true then
                local function blink2(type)
                    if type == true then
                        self._animation:setGLProgramState(ff.Effect:effectSpineHighLight():getGLProgramState())
                    else
                        self._animation:setGLProgramState(ff.gameCore:getNormalGLState(false))
                    end
                end
                self._animation:runAction(cc.RepeatForever:create(cc.Sequence:create(cc.DelayTime:create(0.5),cc.CallFunc:create(function() blink2(false) end),cc.DelayTime:create(0.5),cc.CallFunc:create(function() blink2(true) end))))
            end
        end
    end
end
function BuildingSprite:removeClick()
    if self._sprite ~= nil then
        self._sprite:stopAllActions()
        self._sprite:setGLProgramState(ff.gameCore:getNormalGLState())
    end
    if self._animation ~= nil then
        self._animation:stopAllActions()
        self._animation:setGLProgramState(ff.gameCore:getNormalGLState(false))
    end
    if self._clicksp ~= nil then
        self._clicksp:stopAllActions()
        local scale = self._clicksp:getScale()
        self._clicksp:runAction(cc.Sequence:create(cc.ScaleTo:create(0.05,scale - 0.05),cc.ScaleTo:create(0.125,scale),cc.RemoveSelf:create()))        
        self._clicksp = nil
    end
end

function BuildingSprite:onInit(nt,row)
    if self._init == false then
        self._pos    = tonumber(nt:getString(row,"pos"))     
        self._mod    = tonumber(nt:getString(row,"mod"))
        self._order  = tonumber(nt:getString(row,"order"))
        local src    = (self._mod+1000)..".png"
        if self._mod == 5 then
            src = "wall5.png"
        end    
        local item   =  dd.safeCreateWithSpriteFrameName(src,"images/builds.plist")   
        if self._mod == 5 then
            item:setOpacity(10)
        end
        item:setTag(self._pos)
        self._sprite = item
        self._showname = false

        local function isHaveResTag()
            if dd.cityLayer ~= nil and dd.cityLayer._level ~= nil then
                local tag = dd.cityLayer._level:getChildByTag(self._pos * 1000 + 4)
                if tag ~= nil and tag:isVisible() == true then
                    return true
                end
            end
            return false    
        end
        local function ifFree()
            if self._free ~= nil then
                for i=1,dd.mylists:rowCount() do
                    if dd.mylists:getLong(i,"type") == 1 or dd.mylists:getLong(i,"type") == 13 then
                        if dd.mylists:getLong(i,"param1") == self._pos then
                            local message = ff.net:createMessage()
                            message:addCmd(0x104)
                            message:addLong(dd.uid)
                            message:addLong(0)
                            message:addLong(0)
                            message:addLong(dd.mylists:getLong(i,"type"))
                            ff.net:rpc(message,false)
                            return true
                        end
                    end
                end
            end
            return false
        end

        local _drag = false
        local startp = nil
        local endp   = nil
        local hit    = false
        local function onTouchBegan(touch, event)
            if hit == true then
                self._newbie = 0
                return false
            end
            local target = nil
            startp = touch:getLocation()
            if self._type == 1 then
                if self._sprite ~= nil and self._sprite:isVisible() == true then
                    target = self._sprite
                end 
            elseif self._type == 2 then    
                if self._animation ~= nil and self._animation:isVisible() == true then
                    target = self._animation
                end 
            end     

            if target == nil then
                self._newbie = 0
                return false
            end


            local location = target:convertToNodeSpace(touch:getLocation())
            local size = target:getContentSize()
            local rect = nil
            if self._type == 1 then
                rect = cc.rect(0, 0, size.width, size.height)
            else
                rect = cc.rect(-size.width/2,-size.height/2,size.width,size.height)
            end        
            if cc.rectContainsPoint(rect, location) then
                if self._type == 1 then
                    local frame = (self._mod+1000)..".png"
                    local alpha = false
                    if self._bid ~= 0 and self._bid ~= 5 then
                        alpha = ff.SantanaImageData:check(dd.getBuildMask(self._bid,self._level), cc.p(location.x/size.width, location.y/size.height))
                    else
                        if self._bid == 5 or self._mod == 5 then                            
                            alpha = ff.SantanaImageData:check(1,"wall5.png", location.x/size.width, location.y/size.height)
                        else    
                            alpha = ff.SantanaImageData:check(1,frame, location.x/size.width, location.y/size.height)
                        end    
                    end    
                    if alpha == true then
                        self._newbie = 0
                        return false
                    else
                        _drag = false
                        self:addClick()
                        hit = true                        
                        return true
                    end      
                else
                    if self._animation:isContainsPoint(location.x,location.y) == true then
                        _drag = false
                        self:addClick()
                        hit = true
                        return true
                    else
                        self._newbie = 0
                        return false
                    end        
                end
            end
            self._newbie = 0
            return false    
        end
        local function onTouchMoved(touch, event)
            _drag = true
        end
        local function onTouchCancel(touch,event)
            self:removeClick()
            self._newbie = 0
            hit = false
        end
        local function onTouchEnded(touch, event)
            if _drag == false then
                if dd.currentLayer._widget ~= nil then
                    if ifFree() == false then
                        if isHaveResTag() == false then
                            if self._newbie > 0 then
                                onShowBuildsListNewbie(dd.currentLayer._widget,self._pos,self._newbie) 
                            else
                                onShowBuildsList(dd.currentLayer._widget,self._pos) 
                            end
                        else
                            if dd.cityLayer ~= nil then
                                dd.cityLayer:makeEffects(self._pos,touch:getLocation())
                            end
                        end
                    end
                end               
            else
                endp = touch:getLocation()
                if math.abs(endp.x - startp.x) <= 10 and math.abs(endp.y - startp.y) <= 10 then
                    if dd.currentLayer._widget ~= nil then
                        if ifFree() == false then
                            if isHaveResTag() == false then
                                if self._newbie > 0 then
                                    onShowBuildsListNewbie(dd.currentLayer._widget,self._pos,self._newbie) 
                                else
                                    onShowBuildsList(dd.currentLayer._widget,self._pos) 
                                end
                            else
                                if dd.cityLayer ~= nil then
                                    dd.cityLayer:makeEffects(self._pos,endp)
                                end
                            end
                        end
                    end    
                end
            end                
            --add by zq 新手引导
            --GuideControl:clickCallback()
            hit = false
            self._newbie = 0
            self:removeClick()
        end

        local listener = cc.EventListenerTouchOneByOne:create()
        listener:registerScriptHandler(onTouchBegan,cc.Handler.EVENT_TOUCH_BEGAN)
        listener:registerScriptHandler(onTouchMoved,cc.Handler.EVENT_TOUCH_MOVED)
        listener:registerScriptHandler(onTouchEnded,cc.Handler.EVENT_TOUCH_ENDED)
        listener:registerScriptHandler(onTouchCancel,cc.Handler.EVENT_TOUCH_CANCELLED )
        --listener:setSwallowTouches(true)
        self:getEventDispatcher():addEventListenerWithSceneGraphPriority(listener,self)

        
        local ww = item:getContentSize().width * 10
        local hh = item:getContentSize().height* 10

        local xx = tonumber(nt:getString(row,"x")) + ww/2
        local yy = (2208 - tonumber(nt:getString(row,"y"))) + hh/2

        item:setPosition(cc.p(0,0))
        self:addChild(item,1)
        item:setScale(10)
        self:setPosition(cc.p(xx,yy))
        self._init = true
    end
end

--城内坐标，建筑id
function initBuilding(nt,row)
    local build = BuildingSprite.extend(cc.Layer:create())
    build:onInit(nt,row)
    return build
end

