AttendanceLayer = class("AttendanceLayer")
AttendanceLayer._name = "Attendance"
AttendanceLayer._init = false
AttendanceLayer._Cfg_day = {}

function AttendanceLayer.extend( target )
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target,t)
    end
    setmetatable(t,AttendanceLayer)
    return target
    -- body
end

function AttendanceLayer:onAutoSize()
    local hh = ff.height
    self:setContentSize(cc.size(720,hh))
    self:getChildByName("back"):setContentSize(cc.size(720,hh))
    self:getChildByName("top"):setPositionY(hh - 105)
    self:getChildByName("oper"):setPositionY(0)
    self:getChildByName("info"):setPositionY(hh - 105 - 41 )
    self:getChildByName("top"):getChildByName("return"):addTouchEventListener(self.onReturn)
    self:getChildByName("top"):getChildByName("addgold"):addTouchEventListener(dd.onPay)

    self:getChildByName("ScrollView"):setContentSize(cc.size(720,hh - 105 - 41 - 195))
    self:getChildByName("ScrollView"):setPositionY(180)
    self:getChildByName("oper"):getChildByName("qiandao"):addTouchEventListener(self.onAttendance)
    self:getChildByName("info"):getChildByName("help"):addTouchEventListener(self.onPop)
    self:getChildByName("pop"):getChildByName("close"):addTouchEventListener(self.closePop)
    self:getChildByName("pop"):setPositionY(0)
end

function onShowAttendance( widget )
    -- body
    local layer = AttendanceLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)

    layer:onInit()
    return layer
end

function AttendanceLayer:onInit( )
    -- body
    if self._init == false then
        self:onAutoSize()
        self._init = true
    end
    self:initDate()

    self.updateGold()
 
end

function AttendanceLayer.update( sender )
    -- body
    local nowDay = dd.mygifts:getLong(1,"checkDay")
        local getDay = dd.mygifts:getLong(1,"checkDayInfo")
        local a = string.format("%#x",getDay)--转16
        local b = string.format("%#x",math.pow(2,(nowDay-1)))
        local c = ff._and(a,b)
        if c == 0 then
            sender:getChildByName("oper"):getChildByName("time"):setString("")
        else
            local time = dd.serverTime.zero + 86400 - dd.getServerTime()
            sender:getChildByName("oper"):getChildByName("time"):setString(ff.getLeftTime(time,":"))
        end   
end

function AttendanceLayer:haveAttendance( message )
    if message[1] == 0 then
        local info = {}
        local giftInfo = Split(self._Cfg_day[dd.mygifts:getLong(1,"checkDay")]['content'],'|')
        for k,v in pairs(giftInfo) do
            local gift = Split(v,'%^')
            info[k]={}
            info[k]["type"] = tonumber(gift[1])
            info[k]["id"] = tonumber(gift[2])
            info[k]["count"] = tonumber(gift[3])
        end
        pop.onShowPopDialog("reward",info,ff.langString("签到"),true)
        self.update(self)
        self:showList()
    else
        if dd.currentLayer._widget ~= nil then
            dd.currentLayer._widget:onShowTips("\t"..dd.errorCode(message[1]))  
        end
    end
    -- body
end

function AttendanceLayer.onAttendance(sender,touchEventType)
    if touchEventType==ccui.TouchEventType.ended then  
        local widget = pop.getDialog("Attendance") 
        local nowDay = dd.mygifts:getLong(1,"checkDay")
        local getDay = dd.mygifts:getLong(1,"checkDayInfo")
        local a = string.format("%#x",getDay)--转16
        local b = string.format("%#x",math.pow(2,(nowDay-1)))
        local c = ff._and(a,b)
        if c == 0 then
            local message = ff.net:createMessage()
            message:addCmd(0x00000172)
            message:addLong(dd.uid)
            ff.net:rpc(message,false)      
        else
            pop.onClosePopDialog("Attendance")
        end   

        --widget:getChildByName("pop"):setVisible(true)
    end
end

function AttendanceLayer:initDate(  )
    local propData1 = ff.dbmanager:sql_fetch_rows("SELECT * FROM `cfg_sign`")
    for i=1, propData1:rowCount() do
        local type = tonumber(propData1:getString(i, "day"))
        self._Cfg_day[type] = {}
        self._Cfg_day[type]['content']   = propData1:getString(i, "content")
    end
    propData1:clear()
end


function AttendanceLayer.closePop(sender,touchEventType)


    if touchEventType==ccui.TouchEventType.ended then   
        local widget = pop.getDialog("Attendance") 
        widget:getChildByName("pop"):setVisible(false)
                     
    end
end

function AttendanceLayer.onPop(sender,touchEventType)


    if touchEventType==ccui.TouchEventType.ended then   
        local widget = pop.getDialog("Attendance") 
        widget:getChildByName("pop"):setVisible(true)
                     
    end
end

function AttendanceLayer.onReturn( sender,eventType )
    -- body
    local close = false
    if sender == nil then
        close = true
    end
    if eventType == ccui.TouchEventType.ended then
        close = true
    end
    if close == true then
        local widget = pop.getDialog("Attendance")
            if widget == nil then
                return
            end
            if widget:getChildByName("pop"):isVisible() == true then
                widget.closePop(sender,ccui.TouchEventType.ended)
                return
            end
        pop.onClosePopDialog("Attendance")
    end
end

function AttendanceLayer:showList(  )
    -- body
    local nowDay = dd.mygifts:getLong(1,"checkDay")
    local getDay = dd.mygifts:getLong(1,"checkDayInfo")
    
    for i=1,30 do
        local item = self:getChildByName("ScrollView"):getChildByName("day"..tostring(i))
        if item ~= nil then
            if nowDay > i then
                item:getChildByName("have"):setVisible(true)
            else
                item:getChildByName("have"):setVisible(false)
            end

            local giftInfo = Split(self._Cfg_day[i]['content'],'|')
            for k,v in pairs(giftInfo) do
                local gift = Split(v,'%^')
                if i == 1 or i == 2 or i == 4 or i == 6 or i == 10 or i == 11 or i == 12 or i == 13 or i == 16 or i == 17 or i == 18 or i == 19 or i == 21 or i == 22 or i == 23 or i == 24 or i == 26 or i == 27 or i == 28 or i == 29 then
                    item:getChildByName("ico"):getChildByName("ico"):loadTexture(dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[1],dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[2])
                    item:getChildByName("ico"):getChildByName("count"):setString("X "..gift[3])
                    item:getChildByName("ico"):addTouchEventListener(self.onShowTips)
                    item:getChildByName("ico").type = tonumber(gift[1])
                    item:getChildByName("ico").id = tonumber(gift[2])
                    item:getChildByName("ico").count = tonumber(gift[3])
                elseif  i == 3 or i == 5 or i == 7 or i == 8 or i == 14 or i == 15 then
                    if k == 1 then
                        item:getChildByName("ico1"):getChildByName("ico"):loadTexture(dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[1],dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[2])
                        item:getChildByName("ico1"):getChildByName("count"):setString("X "..gift[3])
                        item:getChildByName("ico1"):addTouchEventListener(self.onShowTips)
                        item:getChildByName("ico1").type = tonumber(gift[1])
                        item:getChildByName("ico1").id = tonumber(gift[2])
                        item:getChildByName("ico1").count = tonumber(gift[3])
                    elseif k ==2 then
                        item:getChildByName("ico2"):getChildByName("ico"):loadTexture(dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[1],dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[2])
                        item:getChildByName("ico2"):getChildByName("count"):setString("X "..gift[3])
                        item:getChildByName("ico2"):addTouchEventListener(self.onShowTips)
                        item:getChildByName("ico2").type = tonumber(gift[1])
                        item:getChildByName("ico2").id = tonumber(gift[2])
                        item:getChildByName("ico2").count = tonumber(gift[3])
                    end
                elseif  i == 9 or i == 20 or i == 25 or i == 30 then
                    if k == 1 then
                        item:getChildByName("ico1"):getChildByName("ico"):loadTexture(dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[1],dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[2])
                        item:getChildByName("ico1"):getChildByName("count"):setString("X "..gift[3])
                        item:getChildByName("ico1"):addTouchEventListener(self.onShowTips)
                        item:getChildByName("ico1").type = tonumber(gift[1])
                        item:getChildByName("ico1").id = tonumber(gift[2])
                        item:getChildByName("ico1").count = tonumber(gift[3])
                    elseif k ==2 then
                        item:getChildByName("ico2"):getChildByName("ico"):loadTexture(dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[1],dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[2])
                        item:getChildByName("ico2"):getChildByName("count"):setString("X "..gift[3])
                        item:getChildByName("ico2"):addTouchEventListener(self.onShowTips)
                        item:getChildByName("ico2").type = tonumber(gift[1])
                        item:getChildByName("ico2").id = tonumber(gift[2])
                        item:getChildByName("ico2").count = tonumber(gift[3])
                    elseif k ==3 then
                        item:getChildByName("ico3"):getChildByName("ico"):loadTexture(dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[1],dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[2])
                        item:getChildByName("ico3"):getChildByName("count"):setString("X "..gift[3])
                        item:getChildByName("ico3"):addTouchEventListener(self.onShowTips)
                        item:getChildByName("ico3").type = tonumber(gift[1])
                        item:getChildByName("ico3").id = tonumber(gift[2])
                        item:getChildByName("ico3").count = tonumber(gift[3])
                    elseif k ==4 then
                        item:getChildByName("ico4"):getChildByName("ico"):loadTexture(dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[1],dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[2])
                        item:getChildByName("ico4"):getChildByName("count"):setString("X "..gift[3])
                        item:getChildByName("ico4"):addTouchEventListener(self.onShowTips)
                        item:getChildByName("ico4").type = tonumber(gift[1])
                        item:getChildByName("ico4").id = tonumber(gift[2])
                        item:getChildByName("ico4").count = tonumber(gift[3])
                    end
                end
                
            end
            
            local a = string.format("%#x",getDay)--转16
            local b = string.format("%#x",math.pow(2,(i-1)))
            local c = ff._and(a,b)
            if nowDay == i then
                if c == 0 then
                    self:getChildByName("oper"):getChildByName("qiandao"):getChildByName("Label_1037"):setString(ff.langString("签到"))
                    self:getChildByName("oper"):getChildByName("qiandao"):setTouchEnabled(true)
                    self:getChildByName("oper"):getChildByName("qiandao"):getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
                else
                    item:getChildByName("have"):setVisible(true)
                    local effect = ff.Effect:effectGrey()    
                    self:getChildByName("oper"):getChildByName("qiandao"):getVirtualRenderer():setGLProgramState(effect:getGLProgramState())
                    self:getChildByName("oper"):getChildByName("qiandao"):setTouchEnabled(false)
                    self:getChildByName("oper"):getChildByName("qiandao"):getChildByName("Label_1037"):setString(ff.langString("完成签到"))
                end
            end
            if i == 1 or i == 2 or i == 4 or i == 6 or i == 10 or i == 11 or i == 12 or i == 13 or i == 16 or i == 17 or i == 18 or i == 19 or i == 21 or i == 22 or i == 23 or i == 24 or i == 26 or i == 27 or i == 28 or i == 29 then
                if c == 0 then
                    item:getChildByName("gou"):setVisible(false)
                else
                    item:getChildByName("gou"):setVisible(true)
                end

                if nowDay == i and c == 0 then
                    item:getChildByName("guang"):setVisible(true)
                else
                    item:getChildByName("guang"):setVisible(false)
                end
            elseif  i == 3 or i == 5 or i == 7 or i == 8 or i == 14 or i == 15 then
                if c == 0 then
                    item:getChildByName("gou1"):setVisible(false)
                    item:getChildByName("gou2"):setVisible(false)
                else
                    item:getChildByName("gou1"):setVisible(true)
                    item:getChildByName("gou2"):setVisible(true)
                end

                if nowDay == i and c == 0 then
                    item:getChildByName("guang1"):setVisible(true)
                    item:getChildByName("guang2"):setVisible(true)
                else
                    item:getChildByName("guang1"):setVisible(false)
                    item:getChildByName("guang2"):setVisible(false)
                end
            elseif  i == 9 or i == 20 or i == 25 or i == 30 then
                if c == 0 then
                    item:getChildByName("gou1"):setVisible(false)
                    item:getChildByName("gou2"):setVisible(false)
                    item:getChildByName("gou3"):setVisible(false)
                    item:getChildByName("gou4"):setVisible(false)
                else
                    item:getChildByName("gou1"):setVisible(true)
                    item:getChildByName("gou2"):setVisible(true)
                    item:getChildByName("gou3"):setVisible(true)
                    item:getChildByName("gou4"):setVisible(true)
                end

                if nowDay == i and c == 0 then
                    item:getChildByName("guang1"):setVisible(true)
                    item:getChildByName("guang2"):setVisible(true)
                    item:getChildByName("guang3"):setVisible(true)
                    item:getChildByName("guang4"):setVisible(true)
                else
                    item:getChildByName("guang1"):setVisible(false)
                    item:getChildByName("guang2"):setVisible(false)
                    item:getChildByName("guang3"):setVisible(false)
                    item:getChildByName("guang4"):setVisible(false)
                end
            end
        end

    end
    
end

function AttendanceLayer.onEnd( sender )
    -- body
    ff.net:removeEvent(2,dd.Tjf_Attendance)
    ff.net:unbindProperty("gold",2319)
    sender:stopAllActions()
end

function AttendanceLayer.onBefore( sender)
  -- body
    ff.net:registerEvent(2,dd.Tjf_Attendance, function (message)sender:haveAttendance(message)end)
    --sender:getChildByName("ScrollView"):jumpToTop()
    if dd.mygifts:getLong(1,"checkDay") > 9 then
        local ps = dd.mygifts:getLong(1,"checkDay") * 100.0/30
        sender:getChildByName("ScrollView"):scrollToPercentVertical(ps,0.1,false)
    end
    schedule(sender, sender.update,1)
    sender:showList()
end

function AttendanceLayer.onStart( sender )
  -- body
    ff.net:bindProperty(2319,"gold",sender.updateGold)
    dd.initGoldSpine(sender:getChildByName("top"):getChildByName("gold"),sender:getChildByName("top"):getChildByName("addgold"))
    
    
end

function AttendanceLayer.updateGold(name,row,old,value)
    local widget = pop.getDialog("Attendance")
    if widget ~= nil then
        widget:getChildByName("top"):getChildByName("count"):setString(dd.myinfo:getLong(1,"gold"))
        local w = widget:getChildByName("top"):getChildByName("count"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        widget:getChildByName("top"):getChildByName("title"):setContentSize(cc.size(w,100))
        widget:getChildByName("top"):getChildByName("title"):requestDoLayout()
        widget:getChildByName("top"):requestDoLayout()
    end
end



function AttendanceLayer.onShowTips(sender, eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end

    if eventType==ccui.TouchEventType.ended then    
        doaction = true
    end
    if doaction == true then        
        local widget = pop.getDialog("Attendance")
        local pos2word = widget:getWorldPos(sender)
        local pos = widget:convertToNodeSpace(pos2word) 
        pos = cc.p(pos.x, pos.y+30)
        widget:showTips(sender.type, sender.id, sender.count, pos)
    end
end

function AttendanceLayer:showTips(type, id, count, pos)
    local ret  = dd.getGiftsTips(type, id, count)
    local name = ret[1]
    local str  = ret[2]
    
    local tips = self:getChildByName("tips")
    local wid  = 360
    tips:stopAllActions()
    tips:setVisible(true)
    tips:getChildByName("tips"):removeAllChildren(true)

    local richText = ccui.RichText:create()
    richText:ignoreContentAdaptWithSize(false)
    richText:setContentSize(cc.size(wid-30,600))    
    richText:setAutoHeight()

    local chat = ccui.RichElementText:create(1, cc.c3b(161,175,175), 255, str, "Helvetica", 20)
    richText:insertElement(chat,0)
    richText:formatText()

    local size = richText:getContentSize()
    richText:setPosition(cc.p(172,size.height/2 + 15))
    tips:setContentSize(cc.size(wid, size.height + 60))
    tips:getChildByName("tips"):setContentSize(cc.size(wid, size.height + 60))
    tips:getChildByName("tips"):addChild(richText)

    tips:getChildByName("name"):setString(name) 
    tips:getChildByName("name"):setPositionY(size.height + 40)

    tips:setPosition(pos)
    if pos.x < 300 then
        tips:setAnchorPoint(cc.p(0.2,0))
        tips:getChildByName("flag"):setPositionX(wid*0.2)
    elseif pos.x > 550 then
        tips:setAnchorPoint(cc.p(0.8,0))
        tips:getChildByName("flag"):setPositionX(wid*0.8)
    else
        tips:setAnchorPoint(cc.p(0.5,0))
        tips:getChildByName("flag"):setPositionX(wid*0.5)
    end       
    local function sched()
        tips:setVisible(false)
    end 

    performWithDelay(tips,sched,1.5) 
end

function AttendanceLayer:getWorldPos(node)
    local anr   = node:getAnchorPoint()
    local size  = node:getContentSize()
    local p = node:convertToWorldSpace(cc.p(anr.x * size.width,anr.y * size.height)) --世界坐标
    return p
end
