buffsLayer = class("buffsLayer")
buffsLayer._name = "buffs"
buffsLayer._init = false

function buffsLayer.extend( target )
	local t = tolua.getpeer(target)
	if not t then
		t = {}
		tolua.setpeer(target,t)
	end
	setmetatable(t,buffsLayer)
	return target
	-- body
end

function buffsLayer:onAutoSize()
    local hh = ff.height
    self:setContentSize(cc.size(720,hh-214))
    self:getChildByName("back"):setContentSize(cc.size(720,hh-214))
    self:getChildByName("top"):setPositionY(self:getContentSize().height - 105)
    --self:getChildByName("top"):getChildByName("count"):setString(dd.myinfo:getLong(1,"gold"))
    --self:getChildByName("top"):getChildByName("chu_title"):setString("BUFFS")
    self:getChildByName("top"):getChildByName("return"):addTouchEventListener(self.onReturn)
    self:getChildByName("top"):getChildByName("addgold"):addTouchEventListener(dd.onPay)

    self:getChildByName("main"):setContentSize(cc.size(720,hh-214-120))
    self:getChildByName("main"):setPositionY(0)
    self.updateGold()
end

function onShowBUFFS( widget )
	-- body
	local layer = buffsLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)

    layer:onInit()
    return layer
end

function buffsLayer:onInit( )
	-- body
	if self._init == false then
        self:onAutoSize()
        self._init = true
    end
    
end

function buffsLayer.onReturn( sender,eventType )
	-- body
	local close = false
    if sender == nil then
        close = true
    end
    if eventType == ccui.TouchEventType.ended then
        close = true
    end
    if close == true then
        local widget = pop.getDialog("buffs")
    		if widget == nil then
    			return
    		end
        --cclog("====")
        pop.onClosePopDialog("buffs")
    end
end

function buffsLayer.onEnd( sender )
    -- body
    dd.delBackEvent()
    sender:stopAllActions()
    if ff.platform ~= 1 then
      for i,v in ipairs(dd.cfgBuffShow) do  
        local item = sender:getChildByName("main"):getChildByTag(i)
        if item ~= nil then
            item:getChildByName("ico"):getChildByName("ico"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        end
      end
    end
    ff.net:unbindProperty("gold",2302)
    
end

function buffsLayer.onStart( sender )
  -- body
  sender:showItems()

    schedule(sender, sender.updateList,1)
  ff.net:bindProperty(2302,"gold",sender.updateGold)
  dd.initGoldSpine(sender:getChildByName("top"):getChildByName("gold"),sender:getChildByName("top"):getChildByName("addgold"))
end

function buffsLayer.updateGold(name,row,old,value)
    local widget = pop.getDialog("buffs")
    if widget ~= nil then
        widget:getChildByName("top"):getChildByName("count"):setString(dd.myinfo:getLong(1,"gold"))
        local w = widget:getChildByName("top"):getChildByName("count"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        widget:getChildByName("top"):getChildByName("title"):setContentSize(cc.size(w,100))
        widget:getChildByName("top"):getChildByName("title"):requestDoLayout()
        widget:getChildByName("top"):requestDoLayout()
    end
end

function buffsLayer.onOpenMulTools( sender,eventType )
    if eventType == ccui.TouchEventType.ended then   
        local tag = sender:getTag()
        dd.currentLayer._widget:onShowMulTools(tag,0,nil,true)
    end
end

function buffsLayer:showItems(  )
	-- body
	self:getChildByName("main"):removeAllChildren(true)

	for i,v in ipairs(dd.cfgBuffShow) do	
    repeat
      local level = dd.myinfo:getLong(1,"level")
      if i == 3 and level < 10 then
        break
      elseif i == 4 and level < 15 then
        break
      end
		  local item = self:getChildByName("item"):clone()
			item:setVisible(true)
			item:getChildByName("ico"):getChildByName("ico"):loadTexture(dd.getEffectIcon(i),0)
			item:getChildByName("name"):setString(ff.langString(dd.cfgBuffShow[i]['name']))
			item:getChildByName("go"):setTag(tonumber(dd.cfgBuffShow[i]['showtype']))
			item:getChildByName("go"):addTouchEventListener(self.onOpenMulTools)
      item:getChildByName("goex"):setTag(tonumber(dd.cfgBuffShow[i]['showtype']))
      item:getChildByName("goex"):addTouchEventListener(self.onOpenMulTools)
			item:getChildByName("info"):setString(ff.langString(dd.cfgBuffShow[i]['disc']))
			item:getChildByName("progress"):setVisible(false)
			item:setTag(i)
		  for j=1,dd.myplus:rowCount() do
            if dd.myplus:getLong(j,"id") == tonumber(dd.cfgBuffShow[i]['effect']) then

          local time = 0
          local per = 0
          local start = dd.myplus:getLong(j,"start")
          local endtime   = dd.myplus:getLong(j,"end")
          if (endtime - start )>0 then
              per = (endtime - start - (endtime - dd.getServerTime()))/(endtime - start)*100
          end
          time = dd.myplus:getLong(j,"end") - dd.getServerTime()
  				
         	item:getChildByName("progress"):getChildByName("progress"):getChildByName("progress"):setPercent(per)
  				item:getChildByName("progress"):setVisible(true)
  				item:getChildByName("progress"):getChildByName("time"):setString(ff.getLeftTime(time,":"))
                break
            end
          
        end
        self:getChildByName("main"):pushBackCustomItem(item)
    until true
	end
	  self:getChildByName("main"):jumpToTop()
end

function buffsLayer.updateList( sender )
    -- body
    local level = dd.myinfo:getLong(1,"level")
    for i,v in ipairs(dd.cfgBuffShow) do	
		  local item = sender:getChildByName("main"):getChildByTag(i)
      if item ~= nil then
  			item:getChildByName("info"):setString(ff.langString(dd.cfgBuffShow[i]['disc']))
  			item:getChildByName("progress"):setVisible(false)
    		for j=1,dd.myplus:rowCount() do
              if dd.myplus:getLong(j,"id") == tonumber(dd.cfgBuffShow[i]['effect']) then
        				local time = 0
                local per = 0
                local start = dd.myplus:getLong(j,"start")
                local endtime   = dd.myplus:getLong(j,"end")
                if (endtime - start )>0 then
                    per = (endtime - start - (endtime - dd.getServerTime()))/(endtime - start)*100
                end
                time = dd.myplus:getLong(j,"end") - dd.getServerTime()

                item:getChildByName("progress"):getChildByName("progress"):getChildByName("progress"):setPercent(per)
                item:getChildByName("progress"):setVisible(true)
                item:getChildByName("progress"):getChildByName("time"):setString(ff.getLeftTime(time,":"))
                break
              end
              
          end
      elseif item == nil and i == 3 and level>= 10 then
        local item = sender:getChildByName("item"):clone()
        item:setVisible(true)
        item:getChildByName("ico"):getChildByName("ico"):loadTexture(dd.getEffectIcon(i),0)
        item:getChildByName("name"):setString(ff.langString(dd.cfgBuffShow[i]['name']))
        item:getChildByName("go"):setTag(tonumber(dd.cfgBuffShow[i]['showtype']))
        item:getChildByName("go"):addTouchEventListener(sender.onOpenMulTools)
        item:getChildByName("goex"):setTag(tonumber(dd.cfgBuffShow[i]['showtype']))
        item:getChildByName("goex"):addTouchEventListener(sender.onOpenMulTools)
        item:getChildByName("info"):setString(ff.langString(dd.cfgBuffShow[i]['disc']))
        item:getChildByName("progress"):setVisible(false)
        item:setTag(i)
        for j=1,dd.myplus:rowCount() do
              if dd.myplus:getLong(j,"id") == tonumber(dd.cfgBuffShow[i]['effect']) then

                local time = 0
                local per = 0
                local start = dd.myplus:getLong(j,"start")
                local endtime   = dd.myplus:getLong(j,"end")
                if (endtime - start )>0 then
                    per = (endtime - start - (endtime - dd.getServerTime()))/(endtime - start)*100
                end
                time = dd.myplus:getLong(j,"end") - dd.getServerTime()
                
                item:getChildByName("progress"):getChildByName("progress"):getChildByName("progress"):setPercent(per)
                item:getChildByName("progress"):setVisible(true)
                item:getChildByName("progress"):getChildByName("time"):setString(ff.getLeftTime(time,":"))
                break
              end
            
          end
          sender:getChildByName("main"):insertCustomItem(item,3)
          sender:getChildByName("resources"):refreshView()
    elseif item == nil and i == 4 and level>= 15 then
        local item = sender:getChildByName("item"):clone()
        item:setVisible(true)
        item:getChildByName("ico"):getChildByName("ico"):loadTexture(dd.getEffectIcon(i),0)
        item:getChildByName("name"):setString(ff.langString(dd.cfgBuffShow[i]['name']))
        item:getChildByName("go"):setTag(tonumber(dd.cfgBuffShow[i]['showtype']))
        item:getChildByName("go"):addTouchEventListener(sender.onOpenMulTools)
        item:getChildByName("goex"):setTag(tonumber(dd.cfgBuffShow[i]['showtype']))
        item:getChildByName("goex"):addTouchEventListener(sender.onOpenMulTools)
        item:getChildByName("info"):setString(ff.langString(dd.cfgBuffShow[i]['disc']))
        item:getChildByName("progress"):setVisible(false)
        item:setTag(i)
        for j=1,dd.myplus:rowCount() do
              if dd.myplus:getLong(j,"id") == tonumber(dd.cfgBuffShow[i]['effect']) then

              local time = 0
              local per = 0
              local start = dd.myplus:getLong(j,"start")
              local endtime   = dd.myplus:getLong(j,"end")
              if (endtime - start )>0 then
                  per = (endtime - start - (endtime - dd.getServerTime()))/(endtime - start)*100
              end
              time = dd.myplus:getLong(j,"end") - dd.getServerTime()
              
              item:getChildByName("progress"):getChildByName("progress"):getChildByName("progress"):setPercent(per)
              item:getChildByName("progress"):setVisible(true)
              item:getChildByName("progress"):getChildByName("time"):setString(ff.getLeftTime(time,":"))
                    break
              end
            
        end
          sender:getChildByName("main"):insertCustomItem(item,4)
          sender:getChildByName("resources"):refreshView()
      end

	 end
end