function CityLayer:onInitEffects()
	if dd.myCityEffects == nil then
        dd.myCityEffects = ff.NetTable:create()
        dd.myCityEffects:addCol("targetpos",ff.NET_LONG)
        dd.myCityEffects:addCol("state",ff.NET_LONG)
        dd.myCityEffects:addCol("playing",ff.NET_LONG)
        dd.myCityEffects:addCol("time",ff.NET_LONG)
        dd.myCityEffects:addCol("begin",ff.NET_LONG)
        dd.myCityEffects:addCol("eid",ff.NET_LONG)
        dd.myCityEffects:addCol("x",ff.NET_LONG)
        dd.myCityEffects:addCol("y",ff.NET_LONG)
        dd.myCityEffects:addCol("tx",ff.NET_LONG)
        dd.myCityEffects:addCol("ty",ff.NET_LONG)        
        dd.myCityEffects:addCol("frames",ff.NET_LONG)
        dd.myCityEffects:addCol("type",ff.NET_LONG)
        dd.myCityEffects:addCol("id",ff.NET_LONG)
        dd.myCityEffects:addCol("minlevel",ff.NET_LONG)
        dd.myCityEffects:addCol("maxlevel",ff.NET_LONG)
        dd.myCityEffects:addCol("pos",ff.NET_LONG)
        dd.myCityEffects:addCol("face",ff.NET_LONG)

        local rows = ff.dbmanager:sql_fetch_rows("select * from cfg_city_effects_id")
        for i=1,rows:rowCount() do
            local row = dd.myCityEffects:addRow()
            dd.myCityEffects:setLong(row,"targetpos",0)
            dd.myCityEffects:setLong(row,"state",0)
            dd.myCityEffects:setLong(row,"playing",0)
            dd.myCityEffects:setLong(row,"time",0)
            dd.myCityEffects:setLong(row,"frames",tonumber(rows:getString(i,"frames")))
            dd.myCityEffects:setLong(row,"pos",tonumber(rows:getString(i,"pos")))
            dd.myCityEffects:setLong(row,"begin",tonumber(rows:getString(i,"pos")))
            dd.myCityEffects:setLong(row,"type",tonumber(rows:getString(i,"type")))
            dd.myCityEffects:setLong(row,"id",tonumber(rows:getString(i,"id")))
            dd.myCityEffects:setLong(row,"minlevel",tonumber(rows:getString(i,"minlevel")))
            dd.myCityEffects:setLong(row,"maxlevel",tonumber(rows:getString(i,"maxlevel")))
            dd.myCityEffects:setLong(row,"eid",tonumber(rows:getString(i,"eid")))    
        end
    else
        for i=1,dd.myCityEffects:rowCount() do
            dd.myCityEffects:setLong(i,"playing",0)
        end
    end 
end

function CityLayer:checkCityEffects()
    if dd.myCityEffects == nil or dd.myCityEffects:rowCount() <= 0 then
        return
    end
    if self._effect == nil then
        return
    end

    for i=1,dd.myCityEffects:rowCount() do
        local playing = dd.myCityEffects:getLong(i,"playing")
        local state   = dd.myCityEffects:getLong(i,"state")
        if playing == 0 then
            local type = dd.myCityEffects:getLong(i,"type")
            local min  = dd.myCityEffects:getLong(i,"minlevel")
            local max  = dd.myCityEffects:getLong(i,"maxlevel")
            local id   = dd.myCityEffects:getLong(i,"id")
            if type == 0 then
                self:dealCityEffect(dd.myCityEffects,i)
                deal = true
            elseif type == 1 then
                local level = dd.getBuildLevel(id)
                if level >= min and level <= max then
                    self:dealCityEffect(dd.myCityEffects,i)
                    deal = true
                end    
            elseif type == 2 then
                local level = dd.getTecLevel(id)
                if level >= min and level <= max then
                    self:dealCityEffect(dd.myCityEffects,i)
                    deal = true
                end    
            end
            if deal == true then
                return
            end
        end
    end
end

function CityLayer:dealCityEffect(rows,i)
    local cache  = cc.SpriteFrameCache:getInstance()
    local eid    = dd.myCityEffects:getLong(i,"eid")
    local pos    = dd.myCityEffects:getLong(i,"pos")
    local state  = dd.myCityEffects:getLong(i,"state")

    local data = ff.dbmanager:sql_fetch_rows("select * from cfg_city_effects_pos where `id`='"..pos.."'")
    if data == nil or data:rowCount() ~= 1 then
        if data ~= nil then
            data:clear()
        end    
        rows:setLong(i,"playing",1)
        return
    end    
    --选择路线
    local function selectTarget(row)
        if dd.myCityEffects:rowCount() >= row then
            local thePos = tonumber(dd.myCityEffects:getLong(row,"pos"))
            local poss = ff.dbmanager:sql_fetch_rows("select * from cfg_city_effects where `pos`='"..thePos.."'")
            if poss == nil then
                return {0,0,0}
            end    
            --for j=1,poss:rowCount() do
            --    local only = tonumber(poss:getString(j,"only"))
            --    if only > 0 and only ~= tonumber(dd.myCityEffects:getLong(row,"eid")) then
            --        poss:delRow(j)
            --    end
            --end
            local ret = {0,0,0}
            if poss:rowCount() > 0 then
                local rand = math.floor(math.random() * poss:rowCount()) + 1
                ret[1] = tonumber(poss:getString(rand,"endp"))
                ret[2] = tonumber(poss:getString(rand,"face"))
                ret[3] = tonumber(poss:getString(rand,"time")/30)
            end
            poss:clear()
            return ret
        end            
    end
    --播放动画
    local function playing(sender)
        --下一组
        local function nextaction(sender)
            sender:stopAllActions()
            local thePos = sender:getTag()
            dd.myCityEffects:setLong(thePos,"pos",dd.myCityEffects:getLong(thePos,"targetpos"))

            local face   = selectTarget(thePos)
            dd.myCityEffects:setLong(thePos,"face",face[2])
            dd.myCityEffects:setLong(thePos,"targetpos",face[1])
            dd.myCityEffects:setLong(thePos,"time",face[3])
            playing(sender)
        end

        local thePos = sender:getTag()
        if dd.myCityEffects:rowCount() >= thePos then
            local frames   = dd.myCityEffects:getLong(thePos,"frames")
            local targetpos= dd.myCityEffects:getLong(thePos,"targetpos")
            local eid      = dd.myCityEffects:getLong(thePos,"eid")
            local theFace  = dd.myCityEffects:getLong(thePos,"face")
            local time     = dd.myCityEffects:getLong(thePos,"time")
            local cache = cc.SpriteFrameCache:getInstance()

            local str    = eid
            if theFace == 1 then
                str = eid.."4"
            elseif theFace == 2 then
                str = eid.."3"
            else
                str = eid..theFace 
            end  
            if theFace == 1 or theFace == 2 then
                sender:setFlippedX(true)
            else    
                sender:setFlippedX(false)
            end  


            local animFrames = {}
            for j = 1, frames do
                local frame = cache:getSpriteFrame(str.."/"..(10000 + j -1)..".png")
                animFrames[j] = frame
            end
            local animation = cc.Animation:createWithSpriteFrames(animFrames, 1/24)
            sender:runAction(cc.RepeatForever:create(cc.Animate:create(animation)))

            if theFace ~= 0 then
                local point = ff.dbmanager:sql_fetch_rows("select * from cfg_city_effects_pos where `id`='"..targetpos.."'")
                if point ~= nil and point:rowCount() == 1 then
                    local xx = tonumber(point:getString(1,"x"))
                    local yy = tonumber(point:getString(1,"y"))
                    dd.myCityEffects:setLong(thePos,"tx",xx)
                    dd.myCityEffects:setLong(thePos,"ty",yy)

                    sender:runAction(cc.Sequence:create(cc.MoveTo:create(time*2, cc.p(xx,yy)),cc.CallFunc:create(nextaction)))
                end
                if point ~= nil then
                    point:clear()
                end    
            end
        end
    end

    local face   = selectTarget(i)
    local str    = eid
    if face[2] == 1 then
        str = eid.."4"
    elseif face[2] == 2 then
        str = eid.."3"
    else
        str = eid..face[2]    
    end        
    local effect = cc.Sprite:createWithSpriteFrameName(str.."/10000.png")
    if face[2] == 1 or face[2] == 2 then
        effect:setFlippedX(true)
    else    
        effect:setFlippedX(false)
    end    
    effect:setTag(i)
    rows:setLong(i,"state",1)
    rows:setLong(i,"face",face[2])
    rows:setLong(i,"targetpos",face[1])
    rows:setLong(i,"time",face[3])
    rows:setLong(i,"playing",1)

    self._effect:addChild(effect)
    effect:setPosition(cc.p(tonumber(data:getString(1,"x")),tonumber(data:getString(1,"y"))))
    effect:setOpacity(0)
    effect:runAction(cc.Sequence:create(cc.FadeIn:create(1),cc.CallFunc:create(playing)))
    data:clear()
end
