local upgradeLayer   = class("upgradeLayer")
upgradeLayer._name   = "upgradeLayer"
upgradeLayer._init   = false
upgradeLayer._pos    = 0
upgradeLayer._bid    = 0
upgradeLayer._type   = 0 --1建造
upgradeLayer._level  = 0
upgradeLayer._create = false
upgradeLayer._showBtns = false
upgradeLayer._refresh = false
upgradeLayer._res    = {}

function upgradeLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, upgradeLayer)
    return target
end

function upgradeLayer:addTitle(label)
	local title = self:getChildByName("mainArea"):getChildByName("th01"):clone()
	title:setVisible(true)
	title:getChildByName("label"):setString(ff.langString(label))
	self:getChildByName("mainArea"):getChildByName("needs"):addChild(title)
end
function upgradeLayer:addTitle2()
	local title = self:getChildByName("mainArea"):getChildByName("td01"):clone()
	title:setVisible(true)
	self:getChildByName("mainArea"):getChildByName("needs"):addChild(title)
end
function upgradeLayer:addItem(type,need,have,change,bid,rew)
	cclog("need:"..need..",have:"..have)
	local item = self:getChildByName("mainArea"):getChildByName("item"):clone()
	if rew ~= true then
		item:setTag(type)
	end
	item:setVisible(true)

	local count = 0
	for i,v in ipairs(self:getChildByName("mainArea"):getChildByName("needs"):getChildren()) do
		if v:getName() == "item" then
			count = count + 1
		end
	end
	if count % 2 == 0 then
		item:loadTexture(dd.getPathFromUI("public/v2/title3.png",1))
	else
		item:loadTexture(dd.getPathFromUI("public/v2/title4.png",1))
	end

	if type >= 1 and type <= 5 then
		if type == 3 then
			item:getChildByName("res"):setString(ff.langString("钢铁"))
		elseif type == 1 then	
			item:getChildByName("res"):setString(ff.langString("石油"))
		elseif type == 4 then	
			item:getChildByName("res"):setString(ff.langString("粮食"))
		elseif type == 2 then	
			item:getChildByName("res"):setString(ff.langString("木材"))
		elseif type == 5 then	
			item:getChildByName("res"):setString(ff.langString("银币"))
		end			
		item:getChildByName("icon"):loadTexture(dd.getPathFromUI("public/ic0"..type..".png",1))		
		item:getChildByName("needs"):setString(dd.showKM(need,6))
		if rew == true then
			item:getChildByName("have"):setVisible(false)
			item:getChildByName("change"):setVisible(false)
			--item:getChildByName("change"):setTouchEnabled(false)
		else
			if need > have then
				self._res[type] = need
				item:getChildByName("have"):setColor(cc.c3b(237,101,101))
				item:getChildByName("change"):setVisible(true)
				--item:getChildByName("change"):setTouchEnabled(true)
				item:getChildByName("change"):setTag(type)
				item:getChildByName("fuhe"):setVisible(false)
				item:getChildByName("change"):loadTextureNormal(dd.getPathFromUI("public/v2/res.png",1))
			else
				self._res[type] = need
				item:getChildByName("have"):setColor(cc.c3b(7,159,0))
				item:getChildByName("change"):setVisible(false)
				item:getChildByName("fuhe"):setVisible(true)
				--item:getChildByName("change"):setTouchEnabled(false)
				item:getChildByName("change"):setTag(type)
			end
			item:getChildByName("have"):setString(dd.showKM(have,6))
		end	
	end
	--建筑	
	if type == 6 then
		item:getChildByName("icon"):setVisible(false)
		item:getChildByName("res"):setString(ff.langString(dd.cfgBuilding[bid]['name']))
		item:getChildByName("needs"):setString("LV."..need)
		item:getChildByName("have"):setVisible(true)
		if have >= need then
			item:getChildByName("have"):setColor(cc.c3b(7,159,0))
			item:getChildByName("fuhe"):setVisible(true)
			item:getChildByName("change"):setVisible(false)
			item:getChildByName("have"):setString("LV."..have)
		else
			item:getChildByName("have"):setColor(cc.c3b(237,101,101))
			item:getChildByName("fuhe"):setVisible(false)

			if have <= 0 then
				item:getChildByName("change"):setVisible(false)
				item:getChildByName("change"):setTag(0)
				item:getChildByName("have"):setString(ff.langString("无"))
			else	
				item:getChildByName("change"):setVisible(true)
				item:getChildByName("change"):loadTextureNormal(dd.getPathFromUI("public/v2/look.png",1))
				item:getChildByName("change"):setTag(10000 + bid)
				item:getChildByName("have"):setString("LV."..have)
			end
		end
	end
	if type == 9 or type == 10 then
		item:getChildByName("icon"):setVisible(false)
		if type == 9 then
			item:getChildByName("res"):setString(ff.langString("经验"))
		else
			item:getChildByName("res"):setString(ff.langString("战力"))
			item:getChildByName("icon"):setVisible(true)
			item:getChildByName("icon"):loadTexture(dd.getPathFromUI("v2/rewpower.png",1))
		end	
		item:getChildByName("needs"):setString(need)

		item:getChildByName("change"):setVisible(false)
		item:getChildByName("fuhe"):setVisible(false)
		--item:getChildByName("change"):setTouchEnabled(false)
		item:getChildByName("have"):setVisible(false)
	end	

	--道具
	if type == 101 then
		if bid == 1001 or bid == 1002 then
			item:getChildByName("icon"):setVisible(true)
			item:getChildByName("icon"):loadTexture(dd.getPathFromUI("v2/rewtool"..bid..".png",1))
		elseif bid == 1028 then
			item:getChildByName("icon"):setVisible(true)
			item:getChildByName("icon"):loadTexture(dd.getPathFromUI("v2/rewtool"..bid..".png",1))
		else
			item:getChildByName("icon"):setVisible(false)
		end

		item:getChildByName("res"):setString(ff.langString(dd.cfgProp[bid]['name'],{dd.cfgProp[bid]['name1_lan']}))
		item:getChildByName("needs"):setString(need)
		item:getChildByName("have"):setColor(cc.c3b(237,101,101))
		item:getChildByName("change"):setVisible(false)
		--item:getChildByName("change"):setTouchEnabled(false)

		if rew == false then
			self._res[8][1] = bid
			self._res[8][2] = need
			if need > have then
				
				item:getChildByName("have"):setColor(cc.c3b(237,101,101))			
				item:getChildByName("fuhe"):setVisible(false)
			else
				item:getChildByName("have"):setColor(cc.c3b(7,159,0))
				item:getChildByName("fuhe"):setVisible(true)
			end	
			item:getChildByName("have"):setString(have)
		else
			item:getChildByName("have"):setVisible(false)
		end	
	end
	--科技
	if type == 102 then
		item:getChildByName("icon"):setVisible(false)
		if bid == -1 then
			item:getChildByName("res"):setString(ff.langString("全部科技"))
		else
			item:getChildByName("res"):setString(ff.langString(dd.cfgTec[bid]['tec_name']))
		end
		item:getChildByName("needs"):setString("LV."..need)
		item:getChildByName("have"):setColor(cc.c3b(237,101,101))
		item:getChildByName("change"):setVisible(true)
		item:getChildByName("fuhe"):setVisible(false)
		--item:getChildByName("change"):setTouchEnabled(true)
		item:getChildByName("change"):loadTextureNormal(dd.getPathFromUI("public/v2/look.png",1))
		item:getChildByName("change"):setTag(20000 + 11)
		if bid == -1 then
			item:getChildByName("needs"):setColor(cc.c3b(237,101,101))
			item:getChildByName("have"):setString("")
		else
			item:getChildByName("have"):setString("LV."..have)
		end
	end

	self:getChildByName("mainArea"):getChildByName("needs"):addChild(item)
end
function upgradeLayer:getBuildTips(level)
	local str = ""

	local id = dd.cfgBuildingUp[self._bid][level]['param1']
	local value = dd.cfgBuildingUp[self._bid][level]['value1']
	
	if id > 0 then
		value = value/dd.cfgEffect[id]['value']
		str = dd.cfgEffect[id]['tips1']
		str = ff.langString(str,{value})
	end
	id = dd.cfgBuildingUp[self._bid][level]['param2']
	value = dd.cfgBuildingUp[self._bid][level]['value2']
	if id > 0 then
		value = value/dd.cfgEffect[id]['value']
		local str2 = dd.cfgEffect[id]['tips1']
		str2 = ff.langString(str2,{value})
		str = str.."\n"..str2
	end
	id = dd.cfgBuildingUp[self._bid][level]['param3']
	value = dd.cfgBuildingUp[self._bid][level]['value3']
	if id > 0 then
		value = value/dd.cfgEffect[id]['value']
		local str2 = dd.cfgEffect[id]['tips1']
		str2 = ff.langString(str2,{value})
		str = str.."\n"..str2
	end
	return str
end
function upgradeLayer.onBuilding(param)
    local code   = param[1]
    local action = param[2]
    local pos    = param[3]
    if code ~= 0 then
		if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
			if code == 111 then
				local function callback()
					pop.onShowPopDialog("vip",1)
				end
				dd.currentLayer._widget:onShowSure(ff.langString("VIP时间不足"),dd.errorCode(code),callback,true,2)
			else
				dd.mainUI:onShowCodeTips(code)
			end
		end	
		return
    end
    cclog("action:"..action..",pos:"..pos)
    --if dd.cityLayer ~= nil then
    --    dd.cityLayer:updateBuilding()
    --end   
    
    --刷新该界面
	if dd.currentLayer ~= nil and dd.currentLayer._pop ~= nil then
		local upgrade = dd.currentLayer._pop._upgrade
	    if action == 12 or action == 11 then
			upgrade._type = 2
	    end
	    if action == 12 or action == 22 then
	    	   	
			upgrade:showUpLevelEffect() 
		end
		if action == 91 or action == 92 then
			dd.currentLayer._pop._type   = 1
			if action == 92 then
				dd.currentLayer._pop.onClose()
				return
			end
		end
		upgrade._refresh = false
	    upgrade:onUpdateView()
		if action == 11 or action == 13 or action == 21 or action == 23 then
	    	AudioEngine.playEffect(ff.sounds["b001"])
	    	--立即关闭界面7-8
	        local widget = dd.currentLayer._pop
	        if widget ~= nil then
                pop.onCloseEffect(99,widget._upgrade)
                widget._parent:closeBuilds()
                --打开排程
                dd.mainUI:queShow(1)
                dd.mainUI:getChildByName("action"):getChildByName("navi"):getChildByName("queue1"):setSelectedState(true)

                for row=1,dd.mylists:rowCount() do
                	if dd.mylists:getLong(row,"param1") == pos then
			            if dd.mylists:getLong(row,"end") - dd.getServerTime() <= dd.getRealFreeTick() and dd.mylists:getLong(row,"param5") == 0 then
			                dd.mylists:setLong(row,"param5",1)
			                break
			            end
			        end
                end
	        end   	    	
	    	--道具过期警告
	    	if pos == 101 then
	    		local level = dd.getBuildLevel(1) + 1
		        local function sure()
		        	for i=1,dd.mylists:rowCount() do
		        		if dd.mylists:getLong(i,"type") == 1 or dd.mylists:getLong(i,"type") == 13 then
		        			if dd.mylists:getLong(i,"param1") == 101 then
								if dd.currentLayer ~= nil and dd.currentLayer._pop ~= nil then
									local upgrade = dd.currentLayer._pop._upgrade		        				
						        	if dd.mainUI ~= nil then
						        		if level == 7 then
						        			dd.yunClose(2)
						        		else
											dd.mainUI:onShowBuyTime(upgrade:getQueType(),upgrade.speedUp)
										end
									end
								end
		        				break
		        			end
		        		end
		        	end
		        end
	    		if level >= 9 then
		    		local rows = ff.dbmanager:sql_fetch_rows("select `id` from cfg_props where `showtype`='32' and `Vanish`='"..level.."'")
		    		if rows ~= nil then
		    			for i=1,rows:rowCount() do
		    				local count = dd.getToolsCount(tonumber(rows:getString(i,"id")))
		    				if count > 0 then
					            dd.mainUI:onShowSure(ff.langString("道具即将过期"),ff.langString("您有可以使用的道具即将过期.\n是否现在就使用?"),sure,true,2,2,ff.langString("使用"))
					            break
		    				end
		    			end
		    			rows:clear()
		    		end
		    	end
		    	if level == 7 then
		            dd.mainUI:onShowSure(ff.langString("道具即将过期"),ff.langString("司令部达到7级时，你将失去新手保护\n状态，新手迁徙道具也将消失。"),sure,true,2,2,ff.langString("使用"))
		    	end
	    	end
	    end
	end  
end
function upgradeLayer:onUpdateView()
	self.onEnd(self)
	self:onInit()
	self.onBefore(self)
	self.onStart(self)
end

function upgradeLayer.speedUp()
	if dd.currentLayer ~= nil and dd.currentLayer._pop ~= nil then
		local upgrade = dd.currentLayer._pop._upgrade
        local message = ff.net:createMessage()
        message:addCmd(0x00000104)
        message:addLong(dd.uid)
        message:addLong(8)
        message:addLong(0)
        message:addLong(upgrade:getQueType())
        ff.net:rpc(message,false)
	end	
end
function upgradeLayer.buildRes()
	if dd.currentLayer ~= nil and dd.currentLayer._pop ~= nil then
		local upgrade = dd.currentLayer._pop._upgrade
        local message = ff.net:createMessage()
        message:addCmd(0x103)
        message:addLong(dd.uid)
        if upgrade._type == 1 then
            message:addLong(13)
        else
        	message:addLong(23)    
        end	
        message:addLong(upgrade._pos)
        message:addLong(upgrade._bid)
        ff.net:rpc(message,false)
	end		
end
--黄金加速
function upgradeLayer.onGoldSpeed(sender,eventType)
	if eventType==ccui.TouchEventType.ended then     
		if dd.currentLayer ~= nil and dd.currentLayer._pop ~= nil then
			local upgrade = dd.currentLayer._pop._upgrade
			dd.currentLayer._widget:onShowBuyTime(upgrade:getQueType(),upgrade.speedUp)
		end	
	end	
end
function upgradeLayer.onFree(sender,eventType)
	cclog("type:"..eventType)
	if eventType == ccui.TouchEventType.ended then
		if dd.currentLayer ~= nil and dd.currentLayer._pop ~= nil then
			local upgrade = dd.currentLayer._pop._upgrade
			if upgrade ~= nil then
		        local message = ff.net:createMessage()
		        message:addCmd(0x104)
		        message:addLong(dd.uid)
		        message:addLong(0)
		        message:addLong(0)
		        message:addLong(upgrade:getQueType())
		       
		        ff.net:rpc(message,false)
		    end
		end
	end	
end
function upgradeLayer.onUnionHelp(sender,eventType)
	if eventType==ccui.TouchEventType.ended then     
		if dd.currentLayer ~= nil and dd.currentLayer._pop ~= nil then
			local upgrade = dd.currentLayer._pop._upgrade
			if upgrade ~= nil then
		        local message = ff.net:createMessage()
		        message:addCmd(0x11c)
		        message:addLong(dd.uid)
		        message:addLong(upgrade:getQueType())
		        ff.net:rpc(message,false)
		        --dd.myHelper[upgrade:getQueType()] = 0
		    end
		end
	end	
end
function upgradeLayer.onStop(sender,eventType)
	if eventType==ccui.TouchEventType.ended then     
		if dd.currentLayer ~= nil and dd.currentLayer._pop ~= nil then
			local upgrade = dd.currentLayer._pop._upgrade
			if upgrade ~= nil then
				if upgrade._level == 0 then
					dd.currentLayer._widget:onShowTips("\t"..ff.langString("不能取消本次升级"))
				else
					local function callback()
				        local message = ff.net:createMessage()
				        message:addCmd(0x104)
				        message:addLong(dd.uid)
				        message:addLong(9)
				        message:addLong(0)
				        message:addLong(upgrade:getQueType())
				        ff.net:rpc(message,false)
					end
					dd.currentLayer._widget:onShowSure(ff.langString("建造取消确认"),ff.langString("您确认要取消本次操作吗？\n取消建造不会返还任何资源"),callback,true,2)
			    end
		    end
		end
	end	
end
function upgradeLayer.onChange(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end

	if doaction == true then   
		local tag = sender:getTag()
		cclog(tag)
		if tag > 10000 then
			local bid = tag - 10000
			if tag > 20000 then
				bid = tag - 20000
			end
			if dd.currentLayer ~= nil and dd.currentLayer._pop ~= nil and dd.currentLayer._pop._upgrade ~= nil then
		        dd.currentLayer._pop._bid = bid
		        local pos = 1
		        local level = 0
		        for i=1,dd.mybuilds:rowCount() do
		        	if dd.mybuilds:getLong(i,"bid") == bid then
		        		if dd.mybuilds:getLong(i,"level") > level then
		        			level = dd.mybuilds:getLong(i,"level")
		        			pos = dd.mybuilds:getLong(i,"pos")
		        		end
		        	end
		        end
		        if tag > 20000 then
		        	onShowBuildsList(dd.currentLayer._widget,pos)
		        else
			        dd.currentLayer._pop._pos = pos
					performWithDelay(dd.currentLayer._pop._upgrade,dd.currentLayer._pop._upgrade.showOtherBuilding,0.1)
				end
			end	
		else
			if dd.currentLayer ~= nil and dd.currentLayer._pop ~= nil then
				dd.currentLayer._widget:onShowMulTools(tag)
			end	
		end
	end
end
function upgradeLayer.showOtherBuilding()
    if dd.currentLayer ~= nil and dd.currentLayer._pop ~= nil then
        dd.currentLayer._pop:showUpgrade(dd.currentLayer._pop._bid)
        GuideControl:GuideCheck()
    end			
end

function upgradeLayer:onInit()
	
	local function test(sender,eventType)
		if eventType==ccui.TouchEventType.ended then
            if self._bid == 14 then
                pop.onShowPopDialog("embassy_help")
            elseif self._bid == 22 then
                pop.onShowPopDialog("hospitalHelp")
            elseif self._bid == 1 then
                pop.onShowPopDialog("mainBaseHelp")
            elseif self._bid == 15 then
                pop.onShowPopDialog("warHouseHelp")
            elseif self._bid == 21 then
                pop.onShowPopDialog("barrackHelp")
            else
                pop.onShowPopDialog("buildHelp",self._bid,self._level)
            end
		end
	end
	if self._init == false then
		self:getChildByName("detail"):getChildByName("info"):getChildByName("label"):getVirtualRenderer():enableBold(true)
		self:getChildByName("detail"):getChildByName("info"):getChildByName("next"):getVirtualRenderer():enableBold(true)
		
		self:getChildByName("detail"):getChildByName("info"):getChildByName("tips"):getVirtualRenderer():setDimensions(360,0)
		self:getChildByName("detail"):getChildByName("info"):getChildByName("nexttip"):getVirtualRenderer():setDimensions(360,0)

		self:getChildByName("mainArea"):getChildByName("btns"):getChildByName("goldsure"):addTouchEventListener(self.onGold)
		self:getChildByName("mainArea"):getChildByName("btns"):getChildByName("sure"):addTouchEventListener(self.onNormal)
		self:getChildByName("mainArea"):getChildByName("btns"):getChildByName("remove"):addTouchEventListener(self.onRemove)

		self:getChildByName("mainArea"):getChildByName("btns"):getChildByName("remove"):getChildByName("label"):getVirtualRenderer():enableBold(true)
		self:getChildByName("mainArea"):getChildByName("btns"):getChildByName("goldsure"):getChildByName("label"):getVirtualRenderer():enableBold(true)
		self:getChildByName("mainArea"):getChildByName("btns"):getChildByName("sure"):getChildByName("label"):getVirtualRenderer():enableBold(true)

		self:getChildByName("detail"):getChildByName("showinfo"):addTouchEventListener(test)

		self:getChildByName("mainArea"):getChildByName("actions"):getChildByName("speedup"):addTouchEventListener(self.onGoldSpeed)
		self:getChildByName("mainArea"):getChildByName("actions"):getChildByName("unionhelp"):addTouchEventListener(self.onUnionHelp)
		self:getChildByName("mainArea"):getChildByName("actions"):getChildByName("free"):addTouchEventListener(self.onFree)
		self:getChildByName("mainArea"):getChildByName("actions"):getChildByName("stop"):addTouchEventListener(self.onStop)
		
		self:getChildByName("mainArea"):getChildByName("item"):getChildByName("change"):addTouchEventListener(self.onChange)
		self._init = true
	end
	self:getChildByName("mainArea"):getChildByName("needs"):removeAllChildren(true)
    --建造事件
    ff.net:registerEvent(2,dd.Tjf_rpc_BuildingAction,self.onBuilding)
    ff.net:registerEvent(2,dd.Tjf_Queue_QueueAction,self.onQueueView)
    ff.net:registerEvent(2,dd.Tjf_notify_SNQueueInfo,self.onQueue)

    ff.net:bindProperty(2203,"wood",self.updateWood)    
    ff.net:bindProperty(2203,"food",self.updateFood)    
    ff.net:bindProperty(2203,"stone",self.updateStone)    
    ff.net:bindProperty(2203,"iron",self.updateIron)    
    ff.net:bindProperty(2203,"silver",self.updateSliver)    
    
    
	self:getChildByName("detail"):getChildByName("info"):getChildByName("next"):setVisible(true)
	self:getChildByName("detail"):getChildByName("info"):getChildByName("nexttip"):setVisible(true)

	if self._bid == 35 then
		self:getChildByName("detail"):getChildByName("showinfo"):setVisible(false)
	else
		self:getChildByName("detail"):getChildByName("showinfo"):setVisible(true)
	end

	self._res={0,0,0,0,0,{0,0,0},{0,0,0},{0,0},{0,0}}
	if self._type == 1 then
		self._parent:getChildByName("topArea"):getChildByName("title"):getChildByName("chu_title"):setString(ff.langString(dd.cfgBuilding[self._bid]['name']))
		self:getChildByName("detail"):getChildByName("info"):getChildByName("label"):setString("Lv 0/"..dd.cfgBuilding[self._bid]['maxlevel'])
		self:getChildByName("detail"):getChildByName("info"):getChildByName("tips"):setString(ff.langString(dd.cfgBuilding[self._bid]['tips']))
		self:getChildByName("detail"):getChildByName("info"):getChildByName("next"):setString("Lv 1/"..dd.cfgBuilding[self._bid]['maxlevel'])

		self._level = 0
		local str = self:getBuildTips(1)
		self:getChildByName("detail"):getChildByName("info"):getChildByName("nexttip"):setString(str)
	else
		for i=1,dd.mybuilds:rowCount() do
			if dd.mybuilds:getLong(i,"pos") == self._pos then
				self._level = dd.mybuilds:getLong(i,"level")
				break
			end	
		end		
		if self._parent == nil then
			cclog("parent empty")
			return
		end	
		self._parent:getChildByName("topArea"):getChildByName("title"):getChildByName("chu_title"):setString(ff.langString(dd.cfgBuilding[self._bid]['name']))
		self:getChildByName("detail"):getChildByName("info"):getChildByName("label"):setString("Lv "..self._level.."/"..dd.cfgBuilding[self._bid]['maxlevel'])
		if self._level == 0 then
			self:getChildByName("detail"):getChildByName("info"):getChildByName("tips"):setString(ff.langString(dd.cfgBuilding[self._bid]['tips']))
		else			
			if self._bid == 35 then
				self:getChildByName("detail"):getChildByName("info"):getChildByName("tips"):setString(ff.langString("升级银行可以获得超值回报").."\n"..ff.langString("银行等级越高，回报越丰富"))
			else
				self:getChildByName("detail"):getChildByName("info"):getChildByName("tips"):setString(self:getBuildTips(self._level))
			end
		end	

		if self._level == dd.cfgBuilding[self._bid]['maxlevel'] or self._bid == 35 then
			self:getChildByName("detail"):getChildByName("info"):getChildByName("next"):setString("")
			self:getChildByName("detail"):getChildByName("info"):getChildByName("next"):setVisible(false)
			self:getChildByName("detail"):getChildByName("info"):getChildByName("nexttip"):setString("")
			self:getChildByName("detail"):getChildByName("info"):getChildByName("nexttip"):setVisible(false)
		else
			self:getChildByName("detail"):getChildByName("info"):getChildByName("next"):setString("Next Lv")
			self:getChildByName("detail"):getChildByName("info"):getChildByName("nexttip"):setString(self:getBuildTips(self._level + 1))
		end
	end
	local level = self._level
	if dd.cfgBuilding[self._bid]['maxlevel'] > level then
		level = level + 1
	end	

	if self._refresh == false and level > 1 and dd.cfgBuildingUp[self._bid][level]['image'] == dd.cfgBuildingUp[self._bid][level-1]['image'] then

	else
		self:getChildByName("detail"):getChildByName("item"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
		self:getChildByName("detail"):requestDoLayout()

		local spine = self:getChildByName("detail"):getChildByName("item"):getChildByTag(10)
		if spine ~= nil then
			spine:removeFromParent(true)
		end
		--cclog("#########################################"..level)
		--if dd.cfgBuildingUp[self._bid][level]['image'] > 10 and self._bid ~= 3 then
		if dd.cfgBuildingUp[self._bid][level]['image'] > 10 then
			local image = dd.cfgBuildingUp[self._bid][level]['image']
			local str = self._bid.."_"..(image - 10)
			spine = sp.SkeletonAnimation:create("images/builds/"..self._bid.."/"..str..".json", "images/builds/"..self._bid.."/"..str..".atlas")
	        spine:setAnimation(0,str.."_animation",true)
	        spine:setTag(10)
		    local xScale = 220/spine:getContentSize().width
		    local yScale = 278/spine:getContentSize().height
		    if self._bid == 3 then
		        spine:setScale(yScale)
		        spine:setPosition(cc.p(0,40))
		    else
		        spine:setScale(xScale)
		        spine:setPosition(cc.p(0,0))
		    end
	        self:getChildByName("detail"):getChildByName("item"):addChild(spine)
	        
		else
			local image = cc.Sprite:create(dd.getBuildImage(self._bid,level))
			local xScale = 220/image:getContentSize().width
			image:setTag(10)
		    image:setScale(xScale)
		    image:setPosition(cc.p(0,30))

			self:getChildByName("detail"):getChildByName("item"):addChild(image)
		end
	end

	self:addTitle("需求")
	self:addTitle2()

	local bid   = dd.cfgBuildingUp[self._bid][level]["bid1"]
	local level1 = dd.cfgBuildingUp[self._bid][level]["level1"]
	if bid > 0 then
		local have = 0
		local add  = true
		for i=1,dd.mybuilds:rowCount() do
			if bid == dd.mybuilds:getLong(i,"bid") then
				if dd.mybuilds:getLong(i,"level") >= level1 then
					add = false
					have = dd.mybuilds:getLong(i,"level")
					break
				else
					if have < dd.mybuilds:getLong(i,"level") then
						have = dd.mybuilds:getLong(i,"level")
					end	
				end	
			end
		end
		if add == true then
			self:addItem(6,level1,have,0,bid,false)
			self._res[6] = {bid,level1,have}
		else
			self:addItem(6,level1,have,0,bid,false)
			self._res[6] = {0,0,0}	
		end
	end
	bid   = dd.cfgBuildingUp[self._bid][level]["bid2"]
	level1 = dd.cfgBuildingUp[self._bid][level]["level2"]
	if bid > 0 then
		local have = 0
		local add  = true
		for i=1,dd.mybuilds:rowCount() do
			if bid == dd.mybuilds:getLong(i,"bid") then
				if dd.mybuilds:getLong(i,"level") >= level1 then
					add = false
					have = dd.mybuilds:getLong(i,"level")
					break					
				else
					if have < dd.mybuilds:getLong(i,"level") then
						have = dd.mybuilds:getLong(i,"level")
					end	
				end	
			end
		end
		if add == true then
			self:addItem(6,level1,have,0,bid,false)
			self._res[7] = {bid,level1,have}
		else
			self:addItem(6,level1,have,0,bid,false)
			self._res[7] = {0,0,0}	
		end
	end
	local tecid = dd.cfgBuildingUp[self._bid][level]["tec"]
	if tecid ~= 0 then
		local havetec = true
		if tecid == -1 then			
			for tid,tecitem in pairs(dd.cfgTec) do
				if tecitem['lv_limit'] > 1 then
					for i=1,dd.myTec:rowCount() do
						if dd.myTec:getLong(i,"tec_id") == tid then
							if dd.myTec:getLong(i,"lv") < dd.cfgBuildingUp[self._bid][level]["teclevel"] then
								havetec = false
								break
							end
						end
					end
					if havetec == false then
						break
					end
				end
			end
		else
			for i=1,dd.myTec:rowCount() do
				if dd.myTec:getLong(i,"tec_id") == tecid then
					if dd.myTec:getLong(i,"lv") >= dd.cfgBuildingUp[self._bid][level]["teclevel"] then
						havetec = true
					end
					break
				end
			end
		end
		if havetec == false then
			self:addItem(102,dd.cfgBuildingUp[self._bid][level]["teclevel"],0,0,dd.cfgBuildingUp[self._bid][level]["tec"],false)
		else
			self._res[9] = {0,0}		
		end			
	else
		self._res[9] = {0,0}		
	end


	if dd.cfgBuildingUp[self._bid][level]['iron'] > 0 then		
		self:addItem(3,dd.cfgBuildingUp[self._bid][level]['iron'],dd.iron(),1,0,false)
	end	
	if dd.cfgBuildingUp[self._bid][level]['stone'] > 0 then
		self:addItem(1,dd.cfgBuildingUp[self._bid][level]['stone'],dd.stone(),2,0,false)
	end	
	if dd.cfgBuildingUp[self._bid][level]['food'] > 0 then
		self:addItem(4,dd.cfgBuildingUp[self._bid][level]['food'],dd.food(),3,0,false)
	end	
	if dd.cfgBuildingUp[self._bid][level]['wood'] > 0 then
		self:addItem(2,dd.cfgBuildingUp[self._bid][level]['wood'],dd.wood(),4,0,false)
	end	
	if dd.cfgBuildingUp[self._bid][level]['tid'] > 0 then
		self:addItem(101,dd.cfgBuildingUp[self._bid][level]['tcount'],dd.getToolsCount(dd.cfgBuildingUp[self._bid][level]['tid']),0,dd.cfgBuildingUp[self._bid][level]['tid'],false)
	end	

	--奖励
	local exp   = dd.cfgBuildingUp[self._bid][level]['exp']
	local power = dd.cfgBuildingUp[self._bid][level]['power']
	local rews  = Split(dd.cfgBuildingUp[self._bid][level]['exp'],"|")
	if exp > 0 or power > 0 or table.getn(rews) > 0 then
		self:addTitle("奖励")
		if exp > 0 then
			self:addItem(9,exp,0,9,0,true)
		end	
		if power > 0 then
			self:addItem(10,power,0,10,0,true)
		end	
		for i=1,table.getn(rews) do
			local rew = Split(rews[i],"%^")
			if table.getn(rew) == 3 then
				if rew[1] == 1 then
					self:addItem(101,rew[3],0,0,rew[2],true)
				elseif rew[1] == 2 then
					self:addItem(1,rew[3],0,0,0,true)
				elseif rew[1] == 3 then
					self:addItem(2,rew[3],0,0,0,true)
				elseif rew[1] == 4 then
					self:addItem(3,rew[3],0,0,0,true)
				elseif rew[1] == 5 then
					self:addItem(4,rew[3],0,0,0,true)
				elseif rew[1] == 6 then
					self:addItem(5,rew[3],0,0,0,true)
				end	
			end
		end
	end
	--计算立即建造和普通建造时间
	local puls = 0

	for i=1,dd.myeffect:rowCount() do
		if dd.myeffect:getLong(i,"id") == 41 then
			puls = dd.myeffect:getLong(i,"param")
			break
		end
	end
	
	--计算需要的黄金
	local gold = 0
    if dd.stone() < self._res[1] then
        gold = gold + (self._res[1] - dd.stone())/dd.stone_lv
    end    
    if dd.iron() < self._res[3] then
        gold = gold + (self._res[3] - dd.iron())/dd.iron_lv
    end    
    if dd.food() < self._res[4] then
        gold = gold + (self._res[4] - dd.food())/dd.food_lv
    end    
    if dd.wood() < self._res[2] then
        gold = gold + (self._res[2] - dd.wood())/dd.wood_lv
    end    
    if dd.silver() < self._res[5] then
        gold = gold + (self._res[5] - dd.silver())/dd.silver_lv
    end    
	local time = math.ceil(dd.cfgBuildingUp[self._bid][level]['time']/((1000 + puls)/1000))
	local golds = dd.getRealGoodp(time - dd.getRealFreeTick()) + math.ceil(gold)
	if self._res[8][1] > 0 then
		local tcount = dd.getToolsCount(self._res[8][1])
		if tcount < self._res[8][2] then
			golds = golds + (self._res[8][2] - tcount) * dd.cfgProp[self._res[8][1]]['value']
		end
	end
	if golds <= 0 then
		golds = 0
	end	
	self:getChildByName("mainArea"):getChildByName("btns"):getChildByName("goldsure"):getChildByName("count"):setString(golds)
	self:getChildByName("mainArea"):getChildByName("btns"):getChildByName("sure"):getChildByName("time"):setString(ff.getLeftTime(time,":"))
	if self._type == 1 then
		self:getChildByName("mainArea"):getChildByName("btns"):getChildByName("goldsure"):getChildByName("label"):setString(ff.langString("立即完成"))
		self:getChildByName("mainArea"):getChildByName("btns"):getChildByName("sure"):getChildByName("label"):setString(ff.langString("建造"))
	else
		self:getChildByName("mainArea"):getChildByName("btns"):getChildByName("goldsure"):getChildByName("label"):setString(ff.langString("立即完成"))
		self:getChildByName("mainArea"):getChildByName("btns"):getChildByName("sure"):getChildByName("label"):setString(ff.langString("升级"))
	end
end

function upgradeLayer.updateWood(name,row,old,value)
	if dd.currentLayer ~= nil and dd.currentLayer._pop ~= nil then
		local upgrade = dd.currentLayer._pop._upgrade
		if upgrade ~= nil and upgrade:isVisible() == true then
			upgrade:updateRes(2)
		end
	end
end
function upgradeLayer.updateFood(name,row,old,value)
	if dd.currentLayer ~= nil and dd.currentLayer._pop ~= nil then
		local upgrade = dd.currentLayer._pop._upgrade
		if upgrade ~= nil and upgrade:isVisible() == true then
			upgrade:updateRes(4)
		end
	end
end
function upgradeLayer.updateStone(name,row,old,value)
	if dd.currentLayer ~= nil and dd.currentLayer._pop ~= nil then
		local upgrade = dd.currentLayer._pop._upgrade
		if upgrade ~= nil and upgrade:isVisible() == true then
			upgrade:updateRes(1)
		end
	end
end
function upgradeLayer.updateIron(name,row,old,value)
	if dd.currentLayer ~= nil and dd.currentLayer._pop ~= nil then
		local upgrade = dd.currentLayer._pop._upgrade
		if upgrade ~= nil and upgrade:isVisible() == true then
			upgrade:updateRes(3)
		end
	end		
end
function upgradeLayer.updateSliver(name,row,old,value)
	if dd.currentLayer ~= nil and dd.currentLayer._pop ~= nil then
		local upgrade = dd.currentLayer._pop._upgrade
		if upgrade ~= nil and upgrade:isVisible() == true then
			upgrade:updateRes(5)
		end
	end
end
function upgradeLayer:updateRes(type)
	local item = self:getChildByName("mainArea"):getChildByName("needs"):getChildByTag(type)
	if item ~= nil then
		local have = 0
		local need = self._res[type]
		if type == 3 then
			have = dd.iron()
		elseif type == 1 then
			have = dd.stone()
		elseif type == 2 then
			have = dd.wood()
		elseif type == 4 then
			have = dd.food()
		elseif type == 5 then
			have = dd.silver()
		elseif type == 101 then
			cclog("==================="..self._res[8][1])
			have = dd.getToolsCount(self._res[8][1])
			need = self._res[8][2]
		else
			return
		end
		
		if need > have then
			item:getChildByName("have"):setColor(cc.c3b(237,101,101))
			item:getChildByName("change"):setVisible(true)
			--item:getChildByName("change"):setTouchEnabled(true)
			item:getChildByName("change"):setTag(type)
			item:getChildByName("fuhe"):setVisible(false)
		else
			item:getChildByName("have"):setColor(cc.c3b(7,159,0))
			item:getChildByName("change"):setVisible(false)
			item:getChildByName("fuhe"):setVisible(true)
			--item:getChildByName("change"):setTouchEnabled(false)
			item:getChildByName("change"):setTag(type)
		end
		item:getChildByName("have"):setString(dd.showKM(have,6))

		--计算立即建造和普通建造时间
		local puls = 0

		for i=1,dd.myeffect:rowCount() do
			if dd.myeffect:getLong(i,"id") == 41 then
				puls = dd.myeffect:getLong(i,"param")
				break
			end
		end
		local level = self._level
		if dd.cfgBuilding[self._bid]['maxlevel'] > level then
			level = level + 1
		end	
		
		local gold = 0
	    if dd.stone() < self._res[1] then
	        gold = gold + (self._res[1] - dd.stone())/dd.stone_lv
	    end    
	    if dd.iron() < self._res[3] then
	        gold = gold + (self._res[3] - dd.iron())/dd.iron_lv
	    end    
	    if dd.food() < self._res[4] then
	        gold = gold + (self._res[4] - dd.food())/dd.food_lv
	    end    
	    if dd.wood() < self._res[2] then
	        gold = gold + (self._res[2] - dd.wood())/dd.wood_lv
	    end    
	    if dd.silver() < self._res[5] then
	        gold = gold + (self._res[5] - dd.silver())/dd.silver_lv
	    end    
		local time = math.ceil(dd.cfgBuildingUp[self._bid][level]['time']/((1000 + puls)/1000))
		local golds = dd.getRealGoodp(time - dd.getRealFreeTick()) + math.ceil(gold)
		if self._res[8][1] > 0 then
			local tcount = dd.getToolsCount(self._res[8][1])
			if tcount < self._res[8][2] then
				golds = golds + (self._res[8][2] - tcount) * dd.cfgProp[self._res[8][1]]['value']
			end
		end
		if golds <= 0 then
			golds = 0
		end	
		self:getChildByName("mainArea"):getChildByName("btns"):getChildByName("goldsure"):getChildByName("count"):setString(golds)
	end
end

function upgradeLayer.onQueueView(params)
	if table.getn(params) > 1 then		
		if dd.currentLayer._pop ~= nil and dd.currentLayer._pop._upgrade ~= nil then
			local upgrade = dd.currentLayer._pop._upgrade
			local action  = params[1]
			local start   = params[2]
			local type    = params[3]
			local param1  = params[4]
			local param2  = params[5]
			if type == 1 or type == 13 then
				if param1 == upgrade._pos then
					if action == 9 then
					else
						if action == 0 or (start == 0 and param2 == 1) then
							upgrade:showUpLevelEffect()
						end
					end
				end
			end

			upgrade.showAction(upgrade)
		end
	end
end
function upgradeLayer.onQueue(params)
	if table.getn(params) > 1 then		
	    local reson  = params[1]
	    local type   = params[2]
	    local param1 = params[3]
	    local param2 = params[4]
	    local param3 = params[5]
	    local param4 = params[6]
	    local bid    = params[7]

	    if dd.currentLayer ~= nil and dd.currentLayer._pop ~= nil then
		    if reson == 1 then
	        	local upgrade = dd.currentLayer._pop._upgrade
		        if (type == 1 or type == 13) and param2 == 1 and param1 == upgrade._pos then
		        	if upgrade ~= nil then
		        		upgrade:showUpLevelEffect()
		        	end
				    --newbie
				    if GuideControl._curGuideLayer ~= nil then
						GuideControl._curGuideLayer:checkDelay()
					end
					GuideControl:GuideCheck()	
				end
			end
		end
	end
end

function upgradeLayer:showUpLevelEffect()
	if self:isVisible() == true then
		local spine = self:getChildByName("detail"):getChildByTag(11)
		if spine == nil then
	        spine = sp.SkeletonAnimation:create("images/city/bsj.json", "images/city/bsj.atlas")
	        self:getChildByName("detail"):addChild(spine,999,11)
		end
		spine:setAnimation(0,"sjSMALL",false)
	    if self._bid == 1 then
	        AudioEngine.playEffect(ff.sounds[205])
	    else
	        AudioEngine.playEffect(ff.sounds[203])
	    end
	    spine:setPosition(cc.p(570,120))
	end
end


function upgradeLayer:sizeAction()
	local builds = self._parent
	local upgradeh = ff.height - 214 - 105 - 85
    builds:getChildByName("upgrade"):setContentSize(cc.size(ff.width,upgradeh))
    builds:getChildByName("upgrade"):setPositionY(0)
    builds:getChildByName("upgrade"):getChildByName("mainArea"):setContentSize(cc.size(ff.width,upgradeh - 267))
    builds:getChildByName("upgrade"):getChildByName("mainArea"):getChildByName("needs"):setContentSize(cc.size(699,upgradeh - 267 - 90))

    builds:getChildByName("upgrade"):getChildByName("detail"):setPositionY(upgradeh - 267)
    builds:getChildByName("upgrade"):getChildByName("mainArea"):setPositionY(0)
    builds:getChildByName("upgrade"):getChildByName("mainArea"):getChildByName("btns"):setPositionY(upgradeh - 267 - 90)
    builds:getChildByName("upgrade"):getChildByName("mainArea"):getChildByName("actions"):setPositionY(upgradeh - 267 - 90)
    builds:getChildByName("upgrade"):getChildByName("mainArea"):getChildByName("needs"):setPositionY(0)
end

function upgradeLayer.showAction(sender)
	for i=1,dd.mylists:rowCount() do
		if dd.mylists:getLong(i,"type") == sender:getQueType() then
		    local starttime = dd.mylists:getLong(i,"start")
    		local endtime   = dd.mylists:getLong(i,"end")
		    local curtime   = dd.getServerTime()
    		local total     = endtime - starttime
		    if total == 0 then
		        return
		    end    
		    local now       = curtime - starttime
    		local progress  = math.floor(now * 100 / total)
    		if progress > 100 then
        		progress = 100
    		end
    		if progress < 0 then
        		progress = 0
    		end
		    sender:getChildByName("mainArea"):getChildByName("actions"):getChildByName("progress"):getChildByName("back"):getChildByName("progress"):setPercent(progress)    
		    if now > total then
		        now = total
		    end    

		    --sender:getChildByName("mainArea"):getChildByName("actions"):getChildByName("speedup"):setVisible(false)
		    --sender:getChildByName("mainArea"):getChildByName("actions"):getChildByName("unionhelp"):setVisible(false)
		    --sender:getChildByName("mainArea"):getChildByName("actions"):getChildByName("free"):setVisible(false)

		    if (total - now) > dd.getRealFreeTick() then
		    	if dd.myUnion:getLong(1,"unionid") > 0 and dd.myHelper[dd.mylists:getLong(i,"type")] == -1 and (GuideControl._curGuideLayer == nil or GuideControl._curGuideLayer:isVisible() == false) then
				    sender:getChildByName("mainArea"):getChildByName("actions"):getChildByName("unionhelp"):setVisible(true)
				    sender:getChildByName("mainArea"):getChildByName("actions"):getChildByName("speedup"):setVisible(false)
				    sender:getChildByName("mainArea"):getChildByName("actions"):getChildByName("free"):setVisible(false)
				else
				    sender:getChildByName("mainArea"):getChildByName("actions"):getChildByName("speedup"):setVisible(true)
				    sender:getChildByName("mainArea"):getChildByName("actions"):getChildByName("unionhelp"):setVisible(false)
				    sender:getChildByName("mainArea"):getChildByName("actions"):getChildByName("free"):setVisible(false)
				end
			else
			    sender:getChildByName("mainArea"):getChildByName("actions"):getChildByName("free"):setVisible(true)
			    sender:getChildByName("mainArea"):getChildByName("actions"):getChildByName("speedup"):setVisible(false)
			    sender:getChildByName("mainArea"):getChildByName("actions"):getChildByName("unionhelp"):setVisible(false)
			end
		    sender:getChildByName("mainArea"):getChildByName("actions"):getChildByName("progress"):getChildByName("time"):setString(ff.getLeftTime((total - now),":"))
		    sender:getChildByName("mainArea"):getChildByName("actions"):getChildByName("progress"):getChildByName("name"):setString(ff.langString(dd.cfgBuilding[sender._bid]['name']))

		    --sender:setVisible(true)
			return
		end
	end
	sender:stopAllActions()
	local old = sender._type
	sender._type = 1
	for i=1,dd.mybuilds:rowCount() do
		if dd.mybuilds:getLong(i,"pos") == sender._pos then
			sender._type = 2   
			break
		end	
	end
	if old == 2 and sender._type == 1 then
		dd.currentLayer._pop._type = 1
	end
	cclog("type:"..sender._type..",pos:"..sender._pos)
	sender:onUpdateView()
end

function upgradeLayer.onGold(sender,eventType)
	if eventType==ccui.TouchEventType.ended then 
		if dd.currentLayer ~= nil and dd.currentLayer._pop ~= nil then
			local upgrade = dd.currentLayer._pop._upgrade
			if upgrade._level >= dd.cfgBuilding[upgrade._bid]['maxlevel'] then
				dd.currentLayer._widget:onShowTips("\t"..ff.langString("已经是最高等级"))
			else			
				if upgrade._bid == 35 then
					if upgrade._res[8][1] > 0 and upgrade._res[8][2] > dd.getToolsCount(upgrade._res[8][1]) then
						local function sure()
			                pop.onShowPopDialog("charge")
			            end
			            dd.mainUI:onShowSure(ff.langString("金条不足"),ff.langString("金条不足，充值金币 \n 可获取金条。是否前往？"),sure,true,2,2,ff.langString("充值"))
						
						return	
					end
						
				end
		            local message = ff.net:createMessage()
		            message:addCmd(0x103)
		            message:addLong(dd.uid)
		            if upgrade._type == 1 then
			            message:addLong(12)
			        else
			        	message:addLong(22)    
			        end	
		            message:addLong(upgrade._pos)
		            message:addLong(upgrade._bid)
		            ff.net:rpc(message,false)	
	                       
	        end
		end	
	end
end
function upgradeLayer.onNormal(sender,eventType)
	if eventType==ccui.TouchEventType.ended then     
		if dd.currentLayer ~= nil and dd.currentLayer._pop ~= nil then
			local upgrade = dd.currentLayer._pop._upgrade
			if dd.currentLayer._widget:haveSameQue(1) == false then
				--前提建筑
				if upgrade._level >= dd.cfgBuilding[upgrade._bid]['maxlevel'] then
					dd.currentLayer._widget:onShowTips("\t"..ff.langString("已经是最高等级"))
				elseif upgrade._res[6][1] > 0 or upgrade._res[7][1] > 0 then
					dd.currentLayer._widget:onShowTips("\t"..ff.langString("前提建筑尚未修建完成"))
				elseif upgrade._res[9][1] ~= 0 and upgrade._res[9][2] == 0 then
					dd.currentLayer._widget:onShowTips("\t"..ff.langString("前提科技尚未研究完成"))
				else
					--判断资源是否足够
					if upgrade._res[3] > dd.iron() or upgrade._res[1] > dd.stone() or upgrade._res[4] > dd.food() or upgrade._res[2] > dd.wood() or upgrade._res[5] > dd.silver() then
						dd.currentLayer._widget:onShowBuyRes(1,upgrade._bid,upgrade._level + 1,upgrade.buildRes)
					elseif upgrade._res[8][1] > 0 and upgrade._res[8][2] > dd.getToolsCount(upgrade._res[8][1]) then
						if upgrade._bid == 35 then
							local function sure()
				                pop.onShowPopDialog("charge")
				            end
				            dd.mainUI:onShowSure(ff.langString("金条不足"),ff.langString("金条不足，充值金币 \n 可获取金条。是否前往？"),sure,true,2,2,ff.langString("充值"))
						
							return
						else
							dd.currentLayer._widget:onShowBuyRes(1,upgrade._bid,upgrade._level + 1,upgrade.buildRes)
						end	
						
					else
						if GuideControl.curId == 1230 then
							GuideControl.curId = 1355
						end
			            local message = ff.net:createMessage()
			            message:addCmd(0x103)
			            message:addLong(dd.uid)
			            if upgrade._type == 1 then
				            message:addLong(11)
				        else
				        	message:addLong(21)    
				        end	
			            message:addLong(upgrade._pos)
			            message:addLong(upgrade._bid)
			            ff.net:rpc(message,false)			            
			        end    
			    end    
	        else
	        	if dd.currentLayer._widget:haveSameQue(12) == true then
	        		if dd.currentLayer._widget:haveSameQue(13) == false then
	        			if upgrade._level >= dd.cfgBuilding[upgrade._bid]['maxlevel'] then
							dd.currentLayer._widget:onShowTips("\t"..ff.langString("已经是最高等级"))
						elseif upgrade._res[6][1] > 0 or upgrade._res[7][1] > 0 then
							dd.currentLayer._widget:onShowTips("\t"..ff.langString("前提建筑尚未修建完成"))
						elseif upgrade._res[9][1] ~= 0 and upgrade._res[9][2] == 0 then
							dd.currentLayer._widget:onShowTips("\t"..ff.langString("前提科技尚未研究完成"))
						else
							--判断资源是否足够
							if upgrade._res[3] > dd.iron() or upgrade._res[1] > dd.stone() or upgrade._res[4] > dd.food() or upgrade._res[2] > dd.wood() or upgrade._res[5] > dd.silver() then
								dd.currentLayer._widget:onShowBuyRes(13,upgrade._bid,upgrade._level + 1,upgrade.buildRes)
							elseif upgrade._res[8][1] > 0 and upgrade._res[8][2] > dd.getToolsCount(upgrade._res[8][1]) then	
								if upgrade._bid == 35 then
									local function sure()
						                pop.onShowPopDialog("charge")
						            end
						            dd.mainUI:onShowSure(ff.langString("金条不足"),ff.langString("金条不足，充值金币 \n 可获取金条。是否前往？"),sure,true,2,2,ff.langString("充值"))
								
									return
								else
									dd.currentLayer._widget:onShowBuyRes(13,upgrade._bid,upgrade._level + 1,upgrade.buildRes)
								end
							else
					            local message = ff.net:createMessage()
					            message:addCmd(0x103)
					            message:addLong(dd.uid)
					            if upgrade._type == 1 then
						            message:addLong(11)
						        else
						        	message:addLong(21)    
						        end	
					            message:addLong(upgrade._pos)
					            message:addLong(upgrade._bid)
					            ff.net:rpc(message,false)
					        end    
					    end    
	        		else
	        			dd.currentLayer._widget:onShowSameQue(13)   
	        		end
	        	else
	        		dd.currentLayer._widget:onShowSameQue(1)   
	        	end       
	        end    
		end	
	end
end
function upgradeLayer.onRemove(sender,eventType)
	if eventType==ccui.TouchEventType.ended then     
		if dd.currentLayer ~= nil and dd.currentLayer._pop ~= nil then
			if dd.currentLayer._widget:haveSameQue(1) == false then
				local upgrade = dd.currentLayer._pop._upgrade
				if dd.cfgBuilding[upgrade._bid]['removeable'] == 0 then
					dd.currentLayer._widget:onShowTips("\t"..ff.langString("您不能拆除该建筑"))
				else
					dd.currentLayer._widget:onShowRemove(upgrade._pos)
		        end
		    else
		    	if dd.currentLayer._widget:haveSameQue(12) == true then
		    		if dd.currentLayer._widget:haveSameQue(13) == false then
			    		local upgrade = dd.currentLayer._pop._upgrade
						if dd.cfgBuilding[upgrade._bid]['removeable'] == 0 then
							dd.currentLayer._widget:onShowTips("\t"..ff.langString("您不能拆除该建筑"))
						else
							dd.currentLayer._widget:onShowRemove(upgrade._pos)
				        end
		    		else
		    			dd.currentLayer._widget:onShowSameQue(13)   
		    		end
		    	else
		        	dd.currentLayer._widget:onShowSameQue(1)   
		        end      
		    end    
		end	
	end
end

function upgradeLayer:getQueType()
	for i=1,dd.mylists:rowCount() do
		if dd.mylists:getLong(i,"type") == 1 or dd.mylists:getLong(i,"type") == 13 then
			if dd.mylists:getLong(i,"param1") == self._pos then
				return dd.mylists:getLong(i,"type")
			end
		end
	end	
	return 0
end

function upgradeLayer.onStart(sender)
	sender:setPositionY(0)
end
function upgradeLayer.onBefore(sender)
	local tipsh = sender:getChildByName("detail"):getChildByName("info"):getChildByName("tips"):getContentSize().height
	local hh = 30 + tipsh
	hh = hh + 8 + 28 + sender:getChildByName("detail"):getChildByName("info"):getChildByName("nexttip"):getContentSize().height

	if hh > 220 then
		sender:getChildByName("detail"):getChildByName("info"):setInnerContainerSize(cc.size(400,hh))	
	else	
		hh = 220
		sender:getChildByName("detail"):getChildByName("info"):setInnerContainerSize(cc.size(400,220))	
	end
	sender:getChildByName("detail"):getChildByName("info"):requestDoLayout()

	--sender:getChildByName("detail"):getChildByName("info"):getChildByName("label"):setPositionY(hh-2)
	--sender:getChildByName("detail"):getChildByName("info"):getChildByName("tips"):setPositionY(hh-30)
	--sender:getChildByName("detail"):getChildByName("info"):getChildByName("next"):setPositionY(hh-(30 + tipsh + 8))
	--sender:getChildByName("detail"):getChildByName("info"):getChildByName("nexttip"):setPositionY(hh - (30 + tipsh + 8 + 28))

	if sender._type == 1 then
		local left = (720 - 237 - 237 - 30)/2
		sender:getChildByName("mainArea"):getChildByName("btns"):getChildByName("remove"):setVisible(false)
		--sender:getChildByName("mainArea"):getChildByName("btns"):getChildByName("remove"):setTouchEnabled(false)
		sender:getChildByName("mainArea"):getChildByName("btns"):getChildByName("goldsure"):setPositionX(left + 118)
		sender:getChildByName("mainArea"):getChildByName("btns"):getChildByName("sure"):setPositionX(left + 118 + 237 + 30)
	else
		sender:getChildByName("mainArea"):getChildByName("btns"):getChildByName("remove"):setVisible(true)
		--sender:getChildByName("mainArea"):getChildByName("btns"):getChildByName("remove"):setTouchEnabled(true)
		sender:getChildByName("mainArea"):getChildByName("btns"):getChildByName("remove"):setPositionX(123)
		sender:getChildByName("mainArea"):getChildByName("btns"):getChildByName("goldsure"):setPositionX(360)
		sender:getChildByName("mainArea"):getChildByName("btns"):getChildByName("sure"):setPositionX(596)
	end			

	--判断显示升级中还是升级按钮
	sender:getChildByName("mainArea"):getChildByName("btns"):setVisible(true)
	sender:getChildByName("mainArea"):getChildByName("actions"):setVisible(false)

	for i=1,dd.mylists:rowCount() do
		if (dd.mylists:getLong(i,"type") == 1 or dd.mylists:getLong(i,"type") == 13) and dd.mylists:getLong(i,"param1") == sender._pos then
			sender:getChildByName("mainArea"):getChildByName("btns"):setVisible(false)
			sender:getChildByName("mainArea"):getChildByName("actions"):setVisible(true)
			sender.showAction(sender)
			schedule(sender, sender.showAction,1)
			break
		end
	end

	--设置大小
    local builds = sender._parent
    local listh = ff.height - 214 - 105
	if sender._level == 0 then
		builds:getChildByName("btns"):setVisible(false)
		local upgradeh = listh
	    builds:getChildByName("upgrade"):setContentSize(cc.size(ff.width,upgradeh))
	    builds:getChildByName("upgrade"):getChildByName("mainArea"):setContentSize(cc.size(ff.width,upgradeh - 270))
	    builds:getChildByName("upgrade"):getChildByName("mainArea"):getChildByName("needs"):setContentSize(cc.size(699,upgradeh - 270 - 90))

	    builds:getChildByName("upgrade"):getChildByName("detail"):setPositionY(upgradeh - 270)
	    builds:getChildByName("upgrade"):getChildByName("mainArea"):setPositionY(0)
	    builds:getChildByName("upgrade"):getChildByName("mainArea"):getChildByName("btns"):setPositionY(upgradeh - 270 - 90)
	    builds:getChildByName("upgrade"):getChildByName("mainArea"):getChildByName("actions"):setPositionY(upgradeh - 270 - 90)
	    builds:getChildByName("upgrade"):getChildByName("mainArea"):getChildByName("needs"):setPositionY(0)
	else
		builds:getChildByName("btns"):setVisible(true)
		if sender._showBtns == false then
			sender._showBtns = true
			sender._parent:getChildByName("btns"):runAction(cc.EaseExponentialOut:create(cc.MoveTo:create(1, cc.p(0,sender._parent:getContentSize().height - 190))))
		else			
			sender._parent:getChildByName("btns"):setPositionY(sender._parent:getContentSize().height - 190)
		end			
		if sender._create == true then
			sender._create = false	
			sender:runAction(cc.Sequence:create(cc.EaseExponentialOut:create(cc.MoveTo:create(1, cc.p(0,-85))),cc.CallFunc:create(sender.sizeAction)))
		else
			local upgradeh = listh - 85
		    builds:getChildByName("upgrade"):setContentSize(cc.size(ff.width,upgradeh))
		    builds:getChildByName("upgrade"):getChildByName("mainArea"):setContentSize(cc.size(ff.width,upgradeh - 267))
		    builds:getChildByName("upgrade"):getChildByName("mainArea"):getChildByName("needs"):setContentSize(cc.size(699,upgradeh - 267 - 90))

		    builds:getChildByName("upgrade"):getChildByName("detail"):setPositionY(upgradeh - 267)
		    builds:getChildByName("upgrade"):getChildByName("mainArea"):setPositionY(0)
		    builds:getChildByName("upgrade"):getChildByName("mainArea"):getChildByName("btns"):setPositionY(upgradeh - 267 - 90)
		    builds:getChildByName("upgrade"):getChildByName("mainArea"):getChildByName("actions"):setPositionY(upgradeh - 267 - 90)
		    builds:getChildByName("upgrade"):getChildByName("mainArea"):getChildByName("needs"):setPositionY(0)
		end	
	end	

	sender:getChildByName("mainArea"):getChildByName("needs"):scrollToTop(0.2,true)
	return true
end
function upgradeLayer.onEnd(sender)
	cclog("upgradeLayer.onEnd")
	if sender._refresh == true then
		sender:getChildByName("detail"):getChildByName("item"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
	end

	sender:stopAllActions()
	sender:getChildByName("mainArea"):getChildByName("needs"):removeAllChildren(true)
    ff.net:removeEvent(2,dd.Tjf_rpc_BuildingAction)
    ff.net:removeEvent(2,dd.Tjf_Queue_QueueAction)
    ff.net:removeEvent(2,dd.Tjf_notify_SNQueueInfo)

    ff.net:unbindProperty("wood",2203)    
    ff.net:unbindProperty("food",2203)
    ff.net:unbindProperty("iron",2203)
    ff.net:unbindProperty("stone",2203)
    ff.net:unbindProperty("silver",2203)
    if sender._refresh == true then
		local spine = sender:getChildByName("detail"):getChildByName("item"):getChildByTag(10)
		if spine ~= nil then
			spine:removeFromParent(true)
		end
	end
end
--建造
function showUpgrade(widget,bid,pos)
	local pop   = upgradeLayer.extend(widget:getChildByName("upgrade"))
	pop._parent = widget
	pop._pos    = pos
	pop._bid    = bid

	pop._type   = 1
	pop._create   = true
	pop._showBtns = false
	pop._refresh = true
	for i=1,dd.mybuilds:rowCount() do
		if dd.mybuilds:getLong(i,"pos") == pop._pos then
			pop._type = 2
			pop._create = false
			break
		end	
	end
	pop:onInit()
    return pop
end
