require "Cocos2d"
require "StudioConstants"
require "Cocos2dConstants"
require "GuiConstants"
require "AudioEngine" 
require "extern"
require "input"
require "platform"
require "lang"


SP_ANIMATION_START    = 0
SP_ANIMATION_END      = 1
SP_ANIMATION_COMPLETE = 2
SP_ANIMATION_EVENT    = 3

ff = ff or {}
--网络地址

ff.addr = "192.168.10.124"
ff.port = 8112

ff.apk_version = 1220
ff.apk_version_name = "1.07"

ff.restart = false
ff.needUpdate = false
--帐号ID
ff.acount    = 0
--通行证编号
ff.account_id= 0  
ff.serverid = 1
ff.debug = false

--报活时间
ff.live = 60

ff.NET_LONG       = 19
ff.NET_DOUBLE     = 21
ff.NET_STRING     = 22
ff.NET_TABLE      = 25
ff.NET_SUPER_LONG = 26
--UI设计大小
ff.uiDesignWidth = 720
ff.uiDesignHeight= 1280
--面板设计尺寸(计算获得)
ff.uiWidth = 720
ff.uiHeight= 1280

--手机屏幕大小(windows里有用)
ff.frame_width  = 540 --*0.8
ff.frame_height = 960 --*0.8

--ff.frame_width  = 540
--ff.frame_height = 800

--实际使用大小(计算获得)
ff.width = 0--1280 720
ff.height= 0--768	 960

--session
ff.session = 0
--超时设定
ff.outtime = 60
--预读界面
ff.loadingLayer = nil

--ff.platform 0 --android模式 
--ff.platform 1 --ios模式
ff.platform  = 0
ff.pathParam = 0 -- 安卓模式下为1，ios模式下为0，用来做loadTexture等函数的第二个参数

--版本

ff.db_version = 0

--未更新前版本
ff.old_version= 0



ff.set_warn_help = 1
ff.set_warn_battle = 1
ff.set_music =true       
ff.set_sound = 1
ff.set_3d = 0
ff.set_battle = 1
ff.set_schedule = 1
ff.set_alliance = 0
ff.set_system = 0
ff.set_lan = 0
ff.set_trans_lan = 0
ff.set_bind_mail = ""
ff.set_power = 1
--机器码
ff.mkey     = ''


--android处理音效线程BUG
ff.sounds_open = false

--切出去时间
ff.lastTick = 0
--启动内存
ff.memory   = 0

ff.sounds = {}
ff.effects = {}
ff.chanels = {}

--世界地图大小
ff.world_areaSize = {}
ff.world_areaSize.width = 16         --分块格子数
ff.world_areaSize.height = 16

ff.world_maplayerSize = {}
ff.world_maplayerSize.width = 640   --地图格子数
ff.world_maplayerSize.height = 640
ff.languageUse = {0,1,2,3,4,5,-1,7,8,-1,-1,11,-1,-1,-1,15,16}
ff.data32={} 
for i=1,32 do  
    ff.data32[i]=2^(32-i)  
end  
--初始化网络
function ff.initNet()
	ff.net = createNet()
end
--str是否合法
function ff.strIsOK(str)
	return true
end
function ff.strIsEmail(str)
	return true
end

function ff.dealFaceBook(event)
	local name = event:getEventName()
	if name == "facebook_face" then
		local cmd = Split(event:getUserData(),",")
		cclog("dealFaceBook:"..cmd[1]..","..cmd[2])
		local uid = tonumber(cmd[1])
		ff.UserFaces[uid] = cmd[2]
		
	end	
end

--初始化参数
--当前语言0英文1中文14繁体
ff.lang     = 0
--语言路径       
ff.lang_dir = ''
ff.show_servers = false
ff.show_loadplayer = false

function ff.initGame()
	local glview = cc.Director:getInstance():getOpenGLView()
	if glview == nil then
		--windows下的情况
		glview = cc.GLView:create("SLG")
		glview:setFrameSize(ff.frame_width,ff.frame_height)
		cc.Director:getInstance():setOpenGLView(glview)
	end	
	local size   = glview:getFrameSize()
	cclog("framew:"..size.width..",frameh:"..size.height)
	platform_initGame(size)

	cc.Director:getInstance():getOpenGLView():setDesignResolutionSize(ff.width,ff.height,2)
	ff.lastTick = ff.gameCore:getTick()
	cclog("启动Tick:"..ff.lastTick)

	cc.Director:getInstance():setDisplayStats(false)

    --获取机器码
    ff.mkey = cc.UserDefault:getInstance():getStringForKey("uuid")
    print("机器识别码:"..ff.mkey)

    ff.lang = cc.UserDefault:getInstance():getIntegerForKey("lang")
    if ff.languageUse[ff.lang + 1] == -1 then
    	ff.lang = 0
    end
    --初始化版本信息
    --platform_initVersion()
    ff.show_servers = platform_showServers()
    if cc.UserDefault:getInstance():getBoolForKey("isInitVersion") == false then
    	--初始化
    	cc.UserDefault:getInstance():setIntegerForKey("httpif",1)
    	--默认登录方式-1：硬件编码登录
		cc.UserDefault:getInstance():setBoolForKey("isInitVersion",true) 

		local wp = cc.FileUtils:getInstance():getWritablePath()
		ff.gameCore:createDirectory(wp.."version")
	    ff.show_loadplayer = true
    end


    if cc.PLATFORM_OS_WINDOWS == cc.Application:getInstance():getTargetPlatform() then
	    if ff.platform == 1 then
	    	cc.FileUtils:getInstance():addSearchPath("resource/ios/")
	    	cc.FileUtils:getInstance():addSearchPath("resource/ios/images/")
	    	cc.FileUtils:getInstance():addSearchPath("resource/ios/images/ui")
	    else
	    	cc.FileUtils:getInstance():addSearchPath("resource/android")
	    end
	end

    --ff.lang_dir = cc.FileUtils:getInstance():getValueMapFromFile("lang/"..ff.lang..".xml")
    cc.Director:getInstance():sharedDirector():setProjection(cc.DIRECTOR_PROJECTION2_D)
	cc.Director:getInstance():sharedDirector():setAnimationInterval(1/60)
    --创建零时目录
    --初始化需要的路径
    ff.gameCore:createDirectory("face")
    ff.gameCore:createDirectory("face/facebook")
    ff.gameCore:createDirectory("reports")
    ff.gameCore:createDirectory("images")
    ff.gameCore:createDirectory("images/world")
    ff.gameCore:createDirectory("images/battle")
    ff.gameCore:createDirectory("images/pve")
    --ff.gameCore:createDirectory("images/city")
    --ff.gameCore:createDirectory("images/city/res")

    --dd.initGame()
end

--日期更新
function ff.updateGame()
    local time   = math.floor(dd.myinfo:getLong(1,"server")/86400) * 86400
    local config = cc.UserDefault:getInstance():getIntegerForKey("lastupdate")
    --清理过期数据
    if time > config then
    	cc.UserDefault:getInstance():setIntegerForKey("lastupdate",time)
    end
end	

--多语言版本,
function ff.langString(str,params)
	if ff.lang == -99999 then
		if params ~= nil then
			for i=1,table.getn(params) do
				str = (string.gsub(str, "{"..(i-1).."}", params[i])) 
			end
		end
--		local num = 0
        str = string.gsub(str,"\\n","\n")		
		return str
	else
		local lang = ""
		if type(str) == "number" then
			lang = ff.gameCore:getString(str)
			if lang == "" or lang == "0" then
				if ff.lang == 0 then
					if tonumber(str) == 990804 then					
						lang = "Updating Files"
					else
						lang = "UIID"
					end
				else
					lang = str
				end
			end
		else
			if lan[str] == nil then
				lang = str
			else
				if tonumber(lan[str]) == 990804 then					
					lang = "Updating Files"
				elseif tonumber(lan[str]) == 990058 then
					lang = "Connection Error.Please check your wifi or data network and re-login."	
				elseif tonumber(lan[str]) == 990836 then
					lang = "Network connection error"	
				elseif tonumber(lan[str]) == 990002 then
					lang = "Connecting to server…"		
				else
					lang = ff.gameCore:getString(tonumber(lan[str]))
					if lang == "" or lang == "0" then
						lang = str
					end
				end	
			end
		end
		if params ~= nil then
			for i=1,table.getn(params) do
				lang = string.gsub(lang, "{"..(i-1).."}", params[i]) 
			end
		end
		if lang ~= nil then
	        lang = string.gsub(lang,"\\n","\n")
	    else
	    	lang = ""
	    end
		return lang
	end
end	
--显示日期
function ff.showData(tick)
	return os.date("%x", tick)
end

function ff.showTimes(tick)
	return os.date("%X", tick)
end

--显示日期 格式 月/日 时:分  param: tick = server time
function ff.getFormatTime(tick)
	local dateStr = os.date("%x", tick)
	local timeStr = os.date("%X", tick)
	local formatTime = string.sub(dateStr, 1, -4).." "
	formatTime = formatTime..string.sub(timeStr, 1, -4)
	return formatTime
end

--显示时间 格式 时：分 
function ff.showTimesWithOutSeconds(tick)
	local timeStr = os.date("%X", tick)
	timeStr=string.sub(timeStr, 1, -4)
	return timeStr
end
function ff.getLeftTime(second,flg)
	if second < 0 then
		second = 0
	end
	local hour   = math.floor(second/3600)
	local minutes= math.floor((second - hour * 3600)/60)
	local ss     = (second - hour * 3600)%60
	local day    = math.floor(hour/24)
	hour = hour - 24 * day

	local str = ""
	if day > 0 then
		str = day.."d "
	end	
	if hour == 0 then
		str = str.."00"..flg
	else
		if hour < 10 then
			str = str.."0"..hour..flg
		else
            str = str..hour..flg
		end	
	end
	if minutes == 0 then
		str = str.."00"..flg
	else
		if minutes < 10 then
			str = str.."0"..minutes..flg
		else
			str = str..minutes..flg
		end	
	end				
	if ss == 0 then
		str = str.."00"
	else
		if ss < 10 then
			str = str.."0"..ss
		else
			str = str..ss
		end	
	end	
    return str
end

--second 秒  用于倒计时
function ff.getDateByTimes(second,style)
   local minutes=math.floor(second/60)
   local hour=0
   local day=0
   if(minutes>60) then
        hour=math.floor(minutes/60)
        minutes=math.floor(minutes%60)
        if(hour>24) then
--            day=math.floor(day/24)
--            hour=hour%24
        end
   end
    second=second%60

    if second < 10 then
        second = "0"..second
    end
    if minutes < 10 then
        minutes = "0"..minutes
    end

   local str=""
   if(day~=0) then
        --str=day.."dd"
        str=str..":"
   end
   
   --if(hour~=0) then
        str=str..hour..":"
        --str=str.."hh"..":"
   --end
   
   --if(minutes~=0) then
        str=str..minutes..":"
        --str=str.."mm"..":"
   --end
   
   str=str..second
   --str=str.."ss"
   return str
end
--时间描述，几分钟前，几小时前，几天前
function ff.getTimeTips(second)
	local day = math.floor(second/(24 * 3600))
	if day > 0 then
		return day..ff.langString("天前")
	end
	local h = math.floor(second/3600)
	if h > 0 then
		return h..ff.langString("小时前")
	end
	local m = math.ceil(second/60)
	if m <= 1 then
		return "1"..ff.langString("分钟内")
	else
		return m..ff.langString("分钟前")
	end
end

function ff.getFormatMoney(value)
	if value == nil then
        value = 0
    end    
   	local str = tostring(value)
    local len = string.len(str)
    local tmpStr = ""
    local result = ""
	for i=1, math.ceil(len/3) do
		local s = len - i*3 + 1
		local e = len - (i-1) *3
		if s < 0 then
			s = 0
		end
		tmpStr = string.sub(str, s, e)
		if i == 1 then
			result = tmpStr
		else
			result = tmpStr..","..result
		end
	end
	return result
end
--获得与当前系统时间的差值 tick-serverTime param：tick = 需要计算的时间
-- function ff.getTimeDiffFormat(tick)
-- 	local diffTime = dd.getServerTime() - tick

function ff.getSounds(id,mp3)
	cclog("getSounds id:"..id)
	if cc.PLATFORM_OS_WINDOWS ~= cc.Application:getInstance():getTargetPlatform() then
    	if cc.PLATFORM_OS_IPHONE == cc.Application:getInstance():getTargetPlatform() or cc.PLATFORM_OS_IPAD == cc.Application:getInstance():getTargetPlatform() then
    		return "sounds/ios/"..id..".mp3"
		else    		
			if mp3 == true then
				return "sounds/"..id..".mp3"
			else
				return "sounds/"..id..".ogg"
			end
		end
	else
		return cc.FileUtils:getInstance():fullPathForFilename("sounds/win32/"..id..".wav")
	end
end
--返回第bit位的值
function ff.to2str(num,bit)
	local str = ""
	while true do
		str = str..num%2
		num = math.floor(num/2)
		if num == 0 then
			if string.len(str) < tonumber(bit) then
				return 0
			else
				local value = tonumber(string.sub(str,tonumber(bit),tonumber(bit)))
				return value
			end
		end
	end
end



 
function ff.d2b(arg)  
    local   tr={}  

    for i=1,32 do  
        if tonumber(arg) >= ff.data32[i] then  
        tr[i]=1  
        arg=tonumber(arg)-ff.data32[i]  
        else  
        tr[i]=0  
        end  
    end  
    return   tr  
end   --bit:d2b  
 
function    ff.b2d(arg)  
    local   nr=0 
    for i=1,32 do  
        if arg[i] ==1 then  
        nr=nr+2^(32-i)  
        end  
    end  
    return  nr  
end   --bit.b2d  
 
function    ff._xor(a,b)  
    local   op1=ff.d2b(a)  
    local   op2=ff.d2b(b)  
    local   r={}  
 
    for i=1,32 do  
        if op1[i]==op2[i] then  
            r[i]=0  
        else  
            r[i]=1  
        end  
    end  
    return  ff.b2d(r)  
end --bit.xor  
 
function    ff._and(a,b)  
    local   op1=ff.d2b(a)  
    local   op2=ff.d2b(b)  
    local   r={}  
      
    for i=1,32 do  
        if op1[i]==1 and op2[i]==1  then  
            r[i]=1  
        else  
            r[i]=0  
        end  
    end  
    return  ff.b2d(r)  
      
end --bit._and  
 
function    ff._or(a,b)  
    local   op1=ff.d2b(a)  
    local   op2=ff.d2b(b)  
    local   r={}  
      
    for i=1,32 do  
        if  op1[i]==1 or   op2[i]==1   then  
            r[i]=1  
        else  
            r[i]=0  
        end  
    end  
    return  ff.b2d(r)  
end --bit._or  
 
function    ff._not(a)  
    local   op1=ff.d2b(a)  
    local   r={}  
 
    for i=1,32 do  
        if  op1[i]==1   then  
            r[i]=0  
        else  
            r[i]=1  
        end  
    end  
    return  ff.b2d(r)  
end --bit._not  
 
function    ff._rshift(a,n)  
    local   op1=ff.d2b(a)  
    local   r=ff.d2b(0)  
      
    if n < 32 and n > 0 then  
        for i=1,n do  
            for i=31,1,-1 do  
                op1[i+1]=op1[i]  
            end  
            op1[1]=0  
        end  
    r=op1 
    end  
    return  ff.b2d(r)  
end --bit._rshift  
 
function    ff._lshift(a,n)  
    local   op1=ff.d2b(a)  
    local   r=ff.d2b(0)  
      
    if n < 32 and n > 0 then  
        for i=1,n   do  
            for i=1,31 do  
                op1[i]=op1[i+1]  
            end  
            op1[32]=0  
        end  
    r=op1 
    end  
    return  ff.b2d(r)  
end 