require "guide/guideLayer"

GuideControl = {}

GuideControl._debug  = false
GuideControl._isOver = false
GuideControl._init   = false
GuideControl._initRes= false

GuideControl._name = "GuideControl"
GuideControl._curGuideLayer = nil
GuideControl._curGuideLayerEx = nil
GuideControl._curView = nil	   		 --当前进行引导的控件窗口


GuideControl.cfg_guideData = nil


GuideControl.curId  = 1            --引导步骤,从1开始
GuideControl.countly= 1

--监听按钮点击事件
GuideControl.isClickListener = false
GuideControl.isButtonClick = false --是否按钮被点击
GuideControl._lastEffect = 0


GuideControl.mapPoint = nil
GuideControl.gid47 = nil
GuideControl.isSwallow = false

--上一次成功引导的步骤id
GuideControl.preId = nil

--立即显示， 策划配置数据时，可将这个值设为true
GuideControl.showGuideInstant = false
GuideControl._scale = 0
GuideControl._inGuide = false

function GuideControl:IdCheck()
    --检查数据是否有推入下一步，否则中断检测
     if self.preId == self.curId then
        if self.cfg_guideData[self.preId]['step'] == 1 then
            return true
        else
            cclog(">>>>>>>: 数据未进入下一步或重复检测")
            return false       
        end
     end
     return true
end

function GuideControl:new(o)  
    o = o or {}  
    setmetatable(o,self)  
    self.__index = self  
    return o  
end

--读取数据库
function GuideControl:loadData()
    cclog("here...loadData")
	if self.cfg_guideData == nil then
		self.cfg_guideData = {}
		local tmpData = ff.dbmanager:sql_fetch_rows("select * from client_guide")
	    for i=1, tmpData:rowCount() do
	        local id = tonumber(tmpData:getString(i, "id"))
	        self.cfg_guideData[id] = {}
	        self.cfg_guideData[id]['id'] = id
	        self.cfg_guideData[id]['sceneId'] = tonumber(tmpData:getString(i, "sceneid")) 		--触发场景
	        self.cfg_guideData[id]['guideType'] = tonumber(tmpData:getString(i, "guidetype"))
	        self.cfg_guideData[id]['popname'] = tmpData:getString(i, "popname")  				--触发窗口名称
	        self.cfg_guideData[id]['factorType'] = tonumber(tmpData:getString(i, "factortype"))  			--触发条件类型 0:无 1：建筑等级 2：科技等级
	        self.cfg_guideData[id]['factorId'] = tonumber(tmpData:getString(i, "factorid"))  				
	        self.cfg_guideData[id]['factorLv'] = tonumber(tmpData:getString(i, "factorlv"))  				
            self.cfg_guideData[id]['sceneMovePos'] = tmpData:getString(i, "scenemovepos")       --场景移动距离
            self.cfg_guideData[id]['waitime'] = tonumber(tmpData:getString(i, "waitime"))       --引导等待时间，时间到自动结束本次引导
	        self.cfg_guideData[id]['stopId'] = tonumber(tmpData:getString(i, "stopid"))  					--异常步骤Id
            self.cfg_guideData[id]['skipid'] = tonumber(tmpData:getString(i, "skipid"))                     --异常步骤Id
            self.cfg_guideData[id]['datum'] = tonumber(tmpData:getString(i, "datum"))			--坐标基点0=左上，1=左下
            self.cfg_guideData[id]['arrowPos'] = tmpData:getString(i, "arrowpos")               --箭头方向
	        self.cfg_guideData[id]['clickRect'] = tmpData:getString(i, "clickrect")     
            self.cfg_guideData[id]['mapPos'] =  tonumber(tmpData:getString(i, "mappos"))     
            self.cfg_guideData[id]['bid'] =  tonumber(tmpData:getString(i, "bid"))     
            self.cfg_guideData[id]['scale'] =  tonumber(tmpData:getString(i, "scale"))     
            self.cfg_guideData[id]['step'] =  tonumber(tmpData:getString(i, "step"))     
            self.cfg_guideData[id]['key'] =  tonumber(tmpData:getString(i, "key"))     
            self.cfg_guideData[id]['mask'] =  tonumber(tmpData:getString(i, "mask"))     
            self.cfg_guideData[id]['countly'] = tmpData:getString(i, "countly")
            self.cfg_guideData[id]['speak'] = tonumber(tmpData:getString(i, "speak"))
            

            local ddddd =    tonumber(tmpData:getString(i, "mappos")) 
	        if ff.lang == -1 then 	
				self.cfg_guideData[id]['guideInfo'] = tmpData:getString(i, "guideinfo")
			else
				self.cfg_guideData[id]['guideInfo'] = tonumber(tmpData:getString(i, "guideinfo_lan"))
			end
			self.cfg_guideData[id]['infoRect'] = tmpData:getString(i, "inforect")
			self.cfg_guideData[id]['nextId'] = tonumber(tmpData:getString(i, "nextid"))
	    end
	    tmpData:clear()
        
	end
end
function GuideControl:stopGuide()
    if self._curGuideLayer ~= nil then
        self._inGuide = false
        self._curGuideLayer:removeFromParent()
        self._curGuideLayer = nil
    end
end
function GuideControl:getRectByStr(str)
	local rect = Split(str, "|")
	return rect
end

--new
function GuideControl:checkNextGuide()
    if self._init == false then
        return
    end
    if GuideControl._isOver == false then
        if self.isButtonClick == true then
            self.isButtonClick = false
            if self._curGuideLayer ~= nil then
                self._curGuideLayer:goNextGuide()
            end
            GuideControl:ShowMaskLayer(true)
        end
    end
end

function GuideControl:GuideCheck(pos)
    if self._isOver == true then
        return false
    end    
    if self.curId == 1 then
        return false
    end
    if self._init == false then
        return false
    end
    if not self:GuideIsOver() then
        return self:DoCheck(pos)
    end
end
function GuideControl:DoCheck(pos)
    if self._isOver == true then
        cc.Director:getInstance():getOpenGLView():enableTouchMove(true)
        return false
    end
    local saveid = self.curId
    if self._inGuide == true then
        cclog("已经开始引导，等待画出引导")
        return false
    end  

    cclog(" ")
    cclog("-----------------------------------------------")
    cclog(">>>>>>>: 开始引导条件检测。。。")
    cclog(">>>>>>>: 检测步骤："..self.curId)
    if self:CheckScene() --场景判断
    and self:CheckLayer() --面板判断 
    and self:CheckLevel()   --建筑或科技等级
    and self:IdCheck()  --id判断
    then
        --特殊步骤，需要改变数据的，可以在这里处理
        self:dealData()
        cclog(">>>>>>>: 条件检测成功")
        GuideControl:ShowMaskLayer(true)
        self.preId = self.curId
        --添加引导层
        if self._curGuideLayer == nil then
            self._curGuideLayer = createGuideLayer()
            if dd.currentScene ~= nil then
                if dd.currentScene:getChildByTag(8889) ~= nil then
                    dd.currentScene:getChildByTag(8889):addChild(self._curGuideLayer, 100, 99998)
                else
                    return
                end
            end
        end
        --移动场景
        if pos ~= nil and pos > 0 then
            self.cfg_guideData[self.curId]['mapPos'] = pos
        end

        cc.Director:getInstance():getOpenGLView():enableTouchMove(false)
        self._inGuide = true
        --绘出引导界面
        function draw()
            if dd.mainUI ~= nil then
                dd.mainUI:checkGuide()
                if self.cfg_guideData[self.curId]['guideType'] == 1 then
                    dd.mainUI:getChildByName("mainBtns"):getChildByName("task"):setVisible(false)
                else
                    dd.mainUI:getChildByName("mainBtns"):getChildByName("task"):setVisible(true)
                end
            end              
            local tick = ff.gameCore:getTick()
            self._curGuideLayer:Draw(self.cfg_guideData[self.curId]) --参数：当前引导步骤数据，根据此数据绘制
            cclog(">>>>>>>: 引导层绘制完成，用时: "..(ff.gameCore:getTick() - tick).."ms")
            --绘制完成后打开遮罩
            GuideControl:ShowMaskLayer(false)            
            cclog("---------------------------------------------------")
            --开场动画，显示出击按钮
            if self.curId == 5 and dd.mainUI ~= nil then
                dd.mainUI:getChildByName("start"):setVisible(true)
            end
            --音效
            if self._lastEffect ~= nil and self._lastEffect > 0 then
                AudioEngine.stopEffect(self._lastEffect)
            end
            if self.cfg_guideData[self.curId]['speak'] > 0 then
                self._lastEffect = AudioEngine.playEffect(ff.getSounds(self.cfg_guideData[self.curId]['speak']))
            else
                self._lastEffect = 0
            end
        end
        local tmpStr = Split(self.cfg_guideData[self.curId]['sceneMovePos'], "|")
        if tonumber(tmpStr[1]) ~= nil and tonumber(tmpStr[2]) ~= nil and tonumber(tmpStr[1]) > 0 and tonumber(tmpStr[2]) > 0 then
            if tonumber(self.cfg_guideData[self.curId]['scale']) > 0 then
                dd.MoveMapTo(cc.p(tonumber(tmpStr[1]),tonumber(tmpStr[2])),1,self.cfg_guideData[self.curId]['scale']/100)
            else
                dd.MoveMapTo(cc.p(tonumber(tmpStr[1]),tonumber(tmpStr[2])),1)
            end
            if self.curId == 2000 then
                if dd.cityLayer ~= nil then
                    dd.cityLayer:addFj(true)
                end                
                performWithDelay(self._curGuideLayer, draw, 1.01)
            elseif self.curId == 2005 then
                performWithDelay(self._curGuideLayer, draw, 0.01)
            else
                performWithDelay(self._curGuideLayer, draw, 1.01)
            end
        else
            if self.cfg_guideData[self.curId]['key'] == 8 and self.cfg_guideData[self.curId]['waitime'] > 0 then
                performWithDelay(self._curGuideLayer, draw, self.cfg_guideData[self.curId]['waitime'])
            elseif math.abs(self.cfg_guideData[self.curId]['key']) == 3 and self.cfg_guideData[self.curId]['waitime'] > 0 then
                performWithDelay(self._curGuideLayer, draw, self.cfg_guideData[self.curId]['waitime'])
            else
                performWithDelay(self._curGuideLayer, draw, 0.01)
            end
        end

        --移动
        if dd.mainUI ~= nil then
            cclog("移动下面按钮到最左边")
            dd.mainUI:getChildByName("bottom"):getChildByName("btns"):jumpToLeft()
        end

        if self.curId > self.countly then
            self.countly = self.curId
            cc.UserDefault:getInstance():setIntegerForKey("countly",self.countly)
            if self.cfg_guideData[self.countly] ~= nil then
                local countly = self.cfg_guideData[self.countly]['countly']
                if string.len(countly) > 3 then
                    platform_taskFinish(countly,0)
                end
            end
        end
        dd.mainUI:showTaskArrow(false)
        return true
    else
        cc.Director:getInstance():getOpenGLView():enableTouchMove(true)
        --判断失败都应该打开遮罩
        GuideControl:ShowMaskLayer(false)
        if self.cfg_guideData[self.curId]['step'] == 1 then
            cc.Director:getInstance():getOpenGLView():enableTouchMove(true)
            if self._curGuideLayer ~= nil then
                self._curGuideLayer:removeFromParent()
                self._curGuideLayer = nil
            end           
            if dd.mainUI ~= nil then
                dd.mainUI:checkGuide()            
            end
            if self.curId == 800 then
                if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
                    local blue = cc.UserDefault:getInstance():getIntegerForKey("blue",0)
                    local haveblue = cc.UserDefault:getInstance():getIntegerForKey("haveblue",0)
                    if blue == 1 and haveblue == 0 then
                        local function callback()
                            cc.UserDefault:getInstance():setIntegerForKey("haveblue",1)
                            pop.onShowPopDialog("mail",4)
                        end
                        dd.mainUI:onShowSure(ff.langString("查看礼物"), ff.langString("Bluestacks customers, welcome to Z War. We have prepared a gift which you can find in your mailbox."), callback, false, 2,3)
                    end
                end
            end
            cclog(">>>>>>>: 结束阶段性引导")
        else
            cclog(">>>>>>>: 引导失败")
        end
        cclog("---------------------------------------------------")
        return false
    end
    if saveid == 1000 and self.curId == 1070 then
        cclog("立即检查")
        self:GuideCheck()
    end
    return false
end
--判断前提条件
function GuideControl:CheckLevel()
	local factorType = self.cfg_guideData[self.curId]['factorType']
	local factorId = self.cfg_guideData[self.curId]['factorId']
	local factorLv = self.cfg_guideData[self.curId]['factorLv']
    cclog("CheckLevel:"..factorType..","..factorId..","..factorLv)

	if factorType == 0 then
        if GuideControl.curId == 1500 then
            if dd.myUnion:getLong(1,"unionid") > 0 then
                self.curId = 5000
                return false
            else
                return true
            end
        elseif GuideControl.curId == 1000 then
            if dd.getToolsCount(5101) > 0 then
                return true
            else
                self.curId = 1070
                return false
            end
        elseif GuideControl.curId == 1070 then
            local have = false
            for i=1, dd.myGoldTasks:rowCount() do
                if dd.myGoldTasks:getLong(i,"id") == 701 then
                    if dd.myGoldTasks:getLong(i,"state") == 0 then
                        have = true
                    end
                    break
                end
            end       
            if have == true then
                return true
            else
                GuideControl.curId = 1200
                return false
            end
        elseif GuideControl.curId == 1230 then
            if dd.getToolsCount(2013) > 0 then
                return true
            else
                self.curId = 1400
                return false
            end
        elseif GuideControl.curId == 1420 then
            --判断是否直接免费掉了
            if dd.getBuildLevel(5) >= 4 then
                GuideControl.curId = 2000
                return false
            end
        elseif GuideControl.curId == 780 then
            if dd.getBuildLevel(1) >= 3 then
                GuideControl.curId = 785
                return false
            end
        elseif GuideControl.curId == 1360 then
            if dd.getBuildLevel(1) >= 4 then
                GuideControl.curId = 1400
                return false
            end
        elseif GuideControl.curId == 1420 then
            if dd.getBuildLevel(5) >= 4 then
                GuideControl.curId = 2000
                return false
            end
        elseif GuideControl.curId == 5020 then
            if dd.getBuildLevel(1) >= 5 then
                if dd.buildingListWidget and dd.buildingListWidget:isVisible() then
                    GuideControl.curId = 5050
                else
                    GuideControl.curId = 5045
                end                     
                --GuideControl.curId = 5050
                return false
            end
        elseif GuideControl.curId == 1380 then
            if dd.getBuildLevel(1) == 4 then
                GuideControl.curId = 1400
                return false
            end                
        elseif GuideControl.curId == 1440 then
            if dd.getBuildLevel(5) == 4 then
                GuideControl.curId = 2000
                return false
            end                
        elseif GuideControl.curId == 5040 then
            if dd.getBuildLevel(1) == 5 then             
                if dd.buildingListWidget and dd.buildingListWidget:isVisible() then
                    GuideControl.curId = 5050
                else
                    GuideControl.curId = 5045
                end     
                --GuideControl.curId = 5050
                return false
            end                
        end
		return true
	elseif factorType == 1 and dd.getBuildLevel(factorId) >= factorLv then
        if GuideControl.curId == 800 then
            --超过5级不能再引导了
            if dd.getBuildLevel(factorId) >= 5 then
                GuideControl.curId = 1005
                return false
            end
        end
		return true
	elseif factorType == 2 and dd.getTecLevel(factorId) >= factorLv then
		return true
    elseif factorType == 4 and dd.getBuildLevel(factorId) >= (factorLv - 1) then
        if GuideControl.curId == 6015 then
            for i=1,dd.mylists:rowCount() do
                if dd.mylists:getLong(i,"type") == 12 then
                    GuideControl.curId = 9000
                    return false
                end                        
            end
            if dd.getToolsCount(11105) <= 0 then
                GuideControl.curId = 9000
                return false
            end
            return true
        end
        if dd.getBuildLevel(factorId) > (factorLv - 1) then
            if GuideControl.curId == 6015 then
                for i=1,dd.mylists:rowCount() do
                    if dd.mylists:getLong(i,"type") == 12 then
                        GuideControl.curId = 9000
                        return false
                    end                        
                end
                if dd.getToolsCount(11105) <= 0 then
                    GuideControl.curId = 9000
                    return false
                end
                return true
            else
                return false
            end
        else
            if dd.getBuildLevel(factorId) == factorLv then
                if GuideControl.curId == 6015 then
                    for i=1,dd.mylists:rowCount() do
                        if dd.mylists:getLong(i,"type") == 12 then
                            GuideControl.curId = 9000
                            return false
                        end                        
                    end
                    if dd.getToolsCount(11105) <= 0 then
                        GuideControl.curId = 9000
                        return false
                    end
                    return true
                else
                    return false
                end
            else
                for i=1,dd.mylists:rowCount() do
                    if dd.mylists:getLong(i,"type") == 1 or dd.mylists:getLong(i,"type") == 13 then
                        local pos = dd.mylists:getLong(i,"param1")
                        for j=1,dd.mybuilds:rowCount() do
                            if dd.mybuilds:getLong(j,"pos") == pos and dd.mybuilds:getLong(j,"bid") == factorId then
                                cclog(dd.mylists:getLong(i,"param2")..","..dd.mylists:getLong(i,"param4")..","..factorLv)
                                if dd.mylists:getLong(i,"param2") == 1 and dd.mylists:getLong(i,"param4") == factorLv then
                                    if  self.cfg_guideData[self.curId]['key'] > 0 then
                                        if dd.getToolsCount(self.cfg_guideData[self.curId]['key']) > 0 then
                                            return true
                                        else
                                            return false
                                        end
                                    else
                                        return true
                                    end
                                end
                            end
                        end
                    end
                end
            end
        end
    elseif factorType == 6 then 
        local level = dd.getBuildLevel(self.cfg_guideData[self.curId]['bid'])
        local bid   = self.cfg_guideData[self.curId]['bid']
        local pos  = 0
        --是否可以升级了
        for i=1,dd.mybuilds:rowCount() do
            if dd.mybuilds:getLong(i,"bid") == self.cfg_guideData[self.curId]['bid'] then
                pos = dd.mybuilds:getLong(i,"pos")
                break
            end
        end            
        if level == factorLv then
            local have = true
            local bid1   = dd.cfgBuildingUp[bid][level+1]["bid1"]
            local level1 = dd.cfgBuildingUp[bid][level+1]["level1"]
            if bid1 > 0 then
                for i=1,dd.mybuilds:rowCount() do
                    if bid1 == dd.mybuilds:getLong(i,"bid") then
                        if dd.mybuilds:getLong(i,"level") < level1 then
                            have = false
                            break
                        end 
                    end
                end
            end
            bid1   = dd.cfgBuildingUp[bid][level+1]["bid1"]
            level1 = dd.cfgBuildingUp[bid][level+1]["level2"]
            if bid > 0 then
                for i=1,dd.mybuilds:rowCount() do
                    if bid1 == dd.mybuilds:getLong(i,"bid") then
                        if dd.mybuilds:getLong(i,"level") < level1 then
                            have = false
                            break
                        end 
                    end
                end
            end
            if have == false then
                return false
            end
            --如果资源不缺，直接跳转
            if self.curId == 1200 then
                if dd.cfgBuildingUp[bid][level + 1]['wood'] <= dd.wood() then
                    self.curId = 1350
                    return false
                end
            end
        else
            self.curId = 1400
            return false
        end
        local count = dd.getToolsCount(self.cfg_guideData[self.curId]['key'])
        if count <= 0 then
            self.curId = 1350
            return false
        end
        return true
	elseif factorType == 7 then
        local count = dd.getToolsCount(self.cfg_guideData[self.curId]['key'])
        if count < factorLv then
            cclog("没道具不显示")
            self.curId = factorId
            return false
        else
            return true
        end
    elseif factorType == 8 then
        local have = 0
        for i=1,dd.mylists:rowCount() do
            if dd.mylists:getLong(i,"type") == factorId then
                if factorId == 3 and dd.mylists:getLong(i,"param3") ~= 1 then
                    have = 1
                elseif factorId == 1 and dd.mylists:getLong(i,"param1") == factorLv then
                    local count = dd.getToolsCount(self.cfg_guideData[self.curId]['key'])
                    if count <=0 then
                        self.curId = 1400
                        return false
                    else
                        return true
                    end
                end
                break
            end
        end
        if have == factorLv then
            return true
        end
    end
    if factorType == 1 then
        cclog(">>>>>>>: 建筑等级不够 :"..dd.getBuildLevel(factorId).."  需要"..factorLv.."  建筑id :"..factorId.." error")
    else
        cclog(">>>>>>>: 科技等级不够 :"..dd.getTecLevel(factorId).."  需要"..factorLv.."  科技id :"..factorId.." error")
    end
	return false
end
function GuideControl:GuideIsOver()
    if self.curId == 999 then
        if self._curGuideLayer ~= nil then
            self._curGuideLayer:removeFromParent()
            self._curGuideLayer = nil
        end        
        GuideControl:ShowMaskLayer(false)
        cclog(">>>>>>>: 引导已经完全结束!!!!!!!!!")
        self._isOver = true
        cc.Director:getInstance():getOpenGLView():enableTouchMove(true)
        return true
	end
    return false
end

function GuideControl:dealData()
end

function GuideControl:CheckLayer(args)
    local tmpStr = Split(self.cfg_guideData[self.curId]['sceneMovePos'], "|")
    if tonumber(tmpStr[1]) ~= nil and tonumber(tmpStr[2]) ~= nil then
        local movePos = cc.p(tonumber(tmpStr[1]), tonumber(tmpStr[2]))
        if movePos.x > 0 or movePos.y > 0 then
            if pop.isLevelShowing(1) then
                cclog(">>>>>>>:  场景需要移动， 1111号面板是打开状态".." error")
                GuideControl:ShowMaskLayer(false)
                return false
            end
            if pop.isLevelShowing(3) then
                cclog(">>>>>>>:   场景需要移动， 3333号面板是打开状态".." error")
                GuideControl:ShowMaskLayer(false)
                return false
            end
            if pop.isLevelShowing(4) then
                cclog(">>>>>>>:  场景需要移动，  4444号面板是打开状态".." error")
                GuideControl:ShowMaskLayer(false)
                return false
            end
            if dd.buildingListWidget and dd.buildingListWidget:isVisible() then
                cclog(">>>>>>>:   场景需要移动， 升级面板是打开状态".." error")
                GuideControl:ShowMaskLayer(false)
                return false
            end
        end
    end

    --检测配置表的面板名字与当前打开的名字是否相同
    if self.cfg_guideData[self.curId]['popname'] ~= nil and self.cfg_guideData[self.curId]['popname'] ~= "0" and self.cfg_guideData[self.curId]['popname'] ~= "none" then --首先检测配置
        if self._curView ~= nil and self._curView._name ~= nil then
            cclog("check:"..self._curView._name..","..self.cfg_guideData[self.curId]['popname'])
        else
            cclog("check:"..self.cfg_guideData[self.curId]['popname'])
        end

        if dd.cityLayer ~= nil and self._curView ~= nil and self._curView._name ~= nil  and dd.cityLayer._pop ~= nil and dd.cityLayer._pop._upgrade ~= nil then
            if self._curView._name == "buildsListLayer" and self.cfg_guideData[self.curId]['popname'] == "upgradeLayer" then
                if dd.cityLayer._pop._upgrade:isVisible() == true then
                    self._curView = dd.cityLayer._pop._upgrade
                end
            end
        end
        if self.curId == 5000 and dd.cityLayer._pop ~= nil and dd.cityLayer._pop._upgrade ~= nil then
            if self._curView == nil  and self.cfg_guideData[self.curId]['popname'] == "upgradeLayer" then
                if dd.cityLayer._pop._upgrade:isVisible() == true then
                    self._curView = dd.cityLayer._pop._upgrade
                end
            end
        end
        if self._curView and self._curView._name == self.cfg_guideData[self.curId]['popname'] then
            if self.cfg_guideData[self.curId]['bid'] > 0 then
                if self._curView._name == "upgradeLayer" then
                    if self._curView._bid == self.cfg_guideData[self.curId]['bid'] and self._curView:isVisible() == true then
                        return true
                    else
                        return false
                    end
                else
                    if self._curView:isVisible() == true then
                        return true
                    else
                        return false
                    end
                end
            else
                return true
            end
        else
            if self._curView and self._curView._name ~= nil then
                cclog(">>>>>>>: 打开的面板不满足条件："..self._curView._name.." 需要："..self.cfg_guideData[self.curId]['popname'].." error")
            else
                cclog(">>>>>>>: 当前无面板打开。".." 需要："..self.cfg_guideData[self.curId]['popname'].." error")
            end
            return false
	    end
    elseif self.cfg_guideData[self.curId]['popname'] == "none" then
        if pop.isLevelShowing(1) then
            cclog(">>>>>>>:  场景需要移动， 1111号面板是打开状态".." error")
            GuideControl:ShowMaskLayer(false)
            return false
        end
        if pop.isLevelShowing(3) then
            cclog(">>>>>>>:   场景需要移动， 3333号面板是打开状态".." error")
            GuideControl:ShowMaskLayer(false)
            return false
        end
        if pop.isLevelShowing(4) then
            cclog(">>>>>>>:  场景需要移动，  4444号面板是打开状态".." error")
            GuideControl:ShowMaskLayer(false)
            return false
        end
        if dd.buildingListWidget ~= nil and dd.buildingListWidget:isVisible() then
            cclog(">>>>>>>:   场景需要移动， 升级面板是打开状态".." error")
            GuideControl:ShowMaskLayer(false)
            return false
        end        
    end
    return true
end
function GuideControl:CreateDebug()
    if dd.currentScene ~= nil then
        if dd.currentScene:getChildByTag(9999999) == nil then
            require "guide/guideDebugLayer"
            local debugLayer = createGuideDebugLayer()
            if debugLayer ~= nil then
                dd.currentScene:addChild(debugLayer, 100, 9999999)
            end
        end
    end
end
function GuideControl:CheckScene()
    if self._isOver == true then
        return false
    end
    --返回ture引导才能继续
    if dd.cityLayer ~= nil then
		self.curSceneId = 1
	elseif dd.worldLayer ~= nil then
		self.curSceneId = 2
	elseif dd.battleLayer ~= nil then
		self.curSceneId = 3
	elseif dd.pveLayer ~= nil then
		self.curSceneId = 4
	end
    cclog("curid:"..self.curId)
    if self.cfg_guideData[self.curId] == nil then
        return false
    end
    if self.cfg_guideData[self.curId]['sceneId'] == nil then
        return false
    end    
    if self.cfg_guideData[self.curId]['sceneId'] == self.curSceneId then
        return true
    end 

    cclog(">>>>>>>: 引导不能在当前场景触发".." error:"..self.curSceneId..","..self.cfg_guideData[self.curId]['sceneId'])
    return false
end
function GuideControl:QueryMinePos()
    local pos = nil
    ff.net:registerEvent(2,dd.Tjf_guideQueryPos, 
        function (message)  
            self.mapPoint = WorldControl:getInstance()._worldUILayer:getMapPointByGID(message - 1, true)
            self.gid47 = message
            --zyj 适应网格
            local offX = ff.width / 2
            local offY = 320
            if dd.openGrid then
                offX = ff.width / 2
                offY = 320
                local t = dd.changeTouchPos({x = offX, y = offY})
                offX = t.x
                offY = t.y
            end
            dd.currentLayer._scroll:getInnerContainer():setPosition(- self.mapPoint.x + offX, - self.mapPoint.y + offY)
            if GuideControl._curGuideLayer ~= nil then
                GuideControl._curGuideLayer:goNextGuide()
                GuideControl:GuideCheck()
            end
        end)

    local message = ff.net:createMessage()
    message:addCmd(0x0000004b)
    message:addLong(dd.uid)
    ff.net:rpc(message, false)
end
function GuideControl:init()
    if self._init == false then
        if self._debug then
            self:CreateDebug()
        end    
        self:loadData()
        self._inGuide = false
        self._init = true
    end
    self:checkGuideStart()

    --self:ShowMaskLayer(true)
    --self._isOver = true
    return self._isOver
end
function GuideControl:checkGuideStart()
    if self._isOver == true then
        self.curId = -999
    else
        self.curId = dd.myinfo:getLong(1,"newbie")
        cclog("checkGuideStart:"..self.curId)

        if self.curId <= 0 and self.curId ~= -999 then
            local message = ff.net:createMessage()
            message:addCmd(0x00000149)
            message:addLong(dd.uid)
            message:addLong(1)
            ff.net:postMessage(message) 
            self.curId = 1
            dd.myinfo:setLong(1,"newbie",1)
        end

        --测试零时
        --if self.curId == 1060 then
        --    self.curId = 1100
        --end
        --self.curId = 7000
        self.countly = cc.UserDefault:getInstance():getIntegerForKey("countly")
        cclog("countly:"..self.countly)
        if self.curId == -999 then
            self._isOver = true
        else                
            if self.curId ~= -1 and self.cfg_guideData[self.curId] == nil and self.curId ~= 1 then
                self._isOver = true
            else
                ff.net:bindProperty(1, "level",newbie.LevelListener) 
                if self._initRes == false and ff.platform ~= 1 then
                    cc.SpriteFrameCache:getInstance():addSpriteFrames("images/ui/guide.plist")
                end
            end
        end
    end
end

function GuideControl:ShowMaskLayer(show)
    --local mask = dd.currentLayer:getChildByTag(654321)
    if self._isOver == true then
        return
    end    
    if dd.mainUI == nil then
        return
    end
    local mask = dd.mainUI:getChildByName("guidemask")
	if show then
        if mask ~= nil then
            mask:setVisible(true)
        else
            require "guide/GuideMaskLayer"
            mask = createGuideMaskLayer()
            mask:setName("guidemask")
            dd.mainUI:addChild(mask, 654321)
        end
        mask.swallow = true
        self.isSwallow = true
        cclog(">>>>>>>: 屏蔽层-----启用")
    else
        if mask ~= nil then
            mask:setVisible(false)
            mask.swallow = false
        else
            if dd.currentLayer ~= nil  and dd.currentLayer._name ~= nil then
                cclog("here..........xxxx:"..dd.currentLayer._name)
            end
        end
        self.isSwallow  = false
        cclog(">>>>>>>: 屏蔽层-----停用")
    end  
end

function GuideControl:ShowMaskLayerEx(show)
    --local mask = dd.currentLayer:getChildByTag(654321)
    
    if dd.mainUI == nil then
        return
    end
    local mask = dd.mainUI:getChildByName("guidemask")
    if show then
        if mask ~= nil then
            mask:setVisible(true)
        else
            require "guide/GuideMaskLayer"
            mask = createGuideMaskLayer()
            mask:setName("guidemask")
            dd.mainUI:addChild(mask, 654321)
        end
        mask.swallow = true
        self.isSwallow = true
        cclog(">>>>>>>: 屏蔽层-----启用")
    else
        if mask ~= nil then
            mask:setVisible(false)
            mask.swallow = false
        else
            cclog("here..........xxxx:"..dd.currentLayer._name)
        end
        self.isSwallow  = false
        cclog(">>>>>>>: 屏蔽层-----停用")
    end  
end

function GuideControl:ShowBeautyOnce( string,callback )
    self:ShowMaskLayerEx(true)
    if self._curGuideLayerEx == nil then
        self._curGuideLayerEx = createGuideLayerEx(callback)
        if dd.currentScene ~= nil then
            if dd.currentScene:getChildByTag(8889) ~= nil then
                dd.currentScene:getChildByTag(8889):addChild(self._curGuideLayerEx, 100, 99999)
            else
                return
            end
        end
    else
        local sprite = self._curGuideLayerEx.ui_infoview:getChildByName("nvren"):getChildByTag(1)
        if sprite ~= nil then
            sprite:removeFromParent(true)
        end
    end
    --self._curGuideLayer.ui_infoview:setPosition(cc.p(self.infoRect.x, self.infoRect.y))
    self._curGuideLayerEx.ui_infoview:setVisible(true)
    local lab = self._curGuideLayerEx.ui_infoview:getChildByName("lab_info")
    lab:setString(string)

    local sprite = sp.SkeletonAnimation:create("images/guide/Xinshouyindao.json", "images/guide/Xinshouyindao.atlas")
    sprite:setMix("XSYD1_animation","XSYD2_animation",0.2)
    sprite:setMix("XSYD1_animation","XSYD3_animation",0.2)
    sprite:setMix("XSYD2_animation","XSYD1_animation",0.2)
    sprite:setMix("XSYD2_animation","XSYD3_animation",0.2)
    sprite:setMix("XSYD3_animation","XSYD1_animation",0.2)
    sprite:setMix("XSYD3_animation","XSYD2_animation",0.2)
    sprite:setAnimation(0, "XSYD1_animation", false)
    sprite:setTag(1)
    sprite:setAnchorPoint(cc.p(0, 0.5))
    sprite:setPositionX(20)
    self._curGuideLayerEx.ui_infoview:getChildByName("nvren"):addChild(sprite,10)
    local function nextCall(event)
            cclog("next call")
            local nex = math.floor(math.random() * 1000000)%2
            local now = sprite:getTag()
            if nex == 0 then
                now = now - 1
            else
                now = now + 1
            end
            if now <= 0 then
                now = 3
            end
            if now > 3 then
                now = 1
            end
            sprite:setAnimation(0, "XSYD"..now.."_animation", false)
            sprite:setTag(now)
        end
    sprite:registerSpineEventHandler(nextCall,SP_ANIMATION_COMPLETE)

end

function GuideControl:stopGuideEx()
    --cclog("==333===")
    local sprite = self._curGuideLayerEx.ui_infoview:getChildByName("nvren"):getChildByTag(1)
    if sprite ~= nil then
        sprite:removeFromParent(true)
    end
    if self._curGuideLayerEx:getChildByTag(10001) ~= nil then
        self._curGuideLayerEx:removeChildByTag(10001)
    end
    self._curGuideLayerEx.promptLayer = nil
    self._curGuideLayerEx:removeFromParent(true)
    self._curGuideLayerEx = nil
end

