

local GuideDebugLayer = class("GuideDebugLayer")  

GuideDebugLayer._name = "GuideDebugLayer"

function GuideDebugLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, GuideDebugLayer)
    return target
end

function GuideDebugLayer:init()
	local labPos = cc.Label:createWithSystemFont(infoStr, "", 24)
	labPos:setColor(cc.c3b(0,255,0))
	labPos:setPosition(cc.p(ff.width/2, ff.height/2))
	self:addChild(labPos)

	local function onTouchBegan(touch, event)
		cclog("guide layer click")
        local startPos = touch:getLocation()
        local str = string.format("1: x=%d y=%d\n0: x=%d  y=%d\n", startPos.x, startPos.y, startPos.x, ff.height - startPos.y)
        
        if dd.currentLayer == dd.cityLayer then    
        	local mapPos = cc.p(dd.cityLayer._scroll:getInnerContainer():getPositionX() - startPos.x, dd.cityLayer._scroll:getInnerContainer():getPositionY() - (startPos.y - 214))
            local mapStr = string.format("\nmap: x=%d y=%d", (-mapPos.x)/dd.currentLayer._map:getScale(), (-mapPos.y)/dd.currentLayer._map:getScale())
        	str = str..mapStr
        elseif dd.pveLayer ~= dd.currentLayer then
--            local mapPos = cc.p(dd.pveLayer._scroll:getInnerContainer():getPositionX(), dd.pveLayer._scroll:getInnerContainer():getPositionY())
--            local mapStr = string.format("\nmap: x=%d y=%d", -mapPos.x, -mapPos.y)
--            str = str..mapStr
        elseif dd.worldLayer  ~= dd.currentLayer then
--            local mapPos = cc.p(dd.worldLayer._scroll:getInnerContainer():getPositionX(), dd.worldLayer._scroll:getInnerContainer():getPositionY())
--            local mapStr = string.format("\nmap: x=%d y=%d", -mapPos.x, -mapPos.y)
--            str = str..mapStr
      end

        labPos:setString(str)
		return false
    end

    local function onTouchEnd(touch, event)
        
    end

	local listener = cc.EventListenerTouchOneByOne:create()
    listener:registerScriptHandler(onTouchBegan,cc.Handler.EVENT_TOUCH_BEGAN)
    listener:registerScriptHandler(onTouchEnd,cc.Handler.EVENT_TOUCH_ENDED)
    self:getEventDispatcher():addEventListenerWithSceneGraphPriority(listener,self)
end

function createGuideDebugLayer()
    if GuideControl._debug == true then
    	local target = GuideDebugLayer.extend(cc.Layer:create())
    	target:init()
    	return target
    else
        return nil
    end
end