require "guide/maskSprite"

local GuideLayer = class("GuideLayer")  

GuideLayer._name = "GuideLayer"

GuideLayer.curGuidData = {}

GuideLayer.preGuideId = 0

GuideLayer.ui_arrow = nil     --箭头
GuideLayer.ui_infoview = nil  --文本框提示框

GuideLayer.arrowDir = 0       --箭头方向
GuideLayer.arrowPos = nil	  --箭头位置
GuideLayer.clickRect = nil    --当前步骤可点击区域
GuideLayer.infoRect = nil	  --文本框显示位置
-- GuideLayer.curClickRect = nil 

GuideLayer.delayCall = nil
GuideLayer.delayId = 0
GuideLayer._first = true
GuideLayer._xsyd = nil
GuideLayer._callback = nil

--以后记录必要信息做判断
GuideLayer._forWaiting = false
GuideLayer._animFramesZS = {}
GuideLayer._animFramesZX = {}
GuideLayer._animFramesYS = {}
GuideLayer._animFramesYX = {}
GuideLayer._animFramesS = {}
GuideLayer._animFramesX = {}
GuideLayer._animFramesZ = {}
GuideLayer._animFramesY = {}


function GuideLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, GuideLayer)
    return target
end

function GuideLayer:goNextGuide()
    local nextId = self.curGuidData['nextId']
    if tonumber(GuideControl.cfg_guideData[GuideControl.curId]['guideType']) ~= 1 then
        self:widgetHide(false)
    end
    if tonumber(GuideControl.cfg_guideData[nextId]['guideType']) ~= 1 then
        self:widgetHide(false)
    end    
    if tonumber(GuideControl.cfg_guideData[nextId]['guideType']) == 1 and tonumber(GuideControl.cfg_guideData[nextId]['waitime']) > 0 then
        self:widgetHide(false)
    end        
    --数据推入下一步
    GuideControl._inGuide = false	
	GuideControl.curId = nextId 
    if nextId == 0 then
        GuideControl._scale = 0
    else
        GuideControl._scale = GuideControl.cfg_guideData[nextId]['scale']/100
    end
    cclog(">>>>>>> 引导数据进入下一步:  "..nextId)

    if GuideControl.cfg_guideData[nextId]['guideType'] ~= 1 then
        --立即隐藏引导层的控件
        if GuideControl.curId > 2 then
            self:widgetHide(false)
        end
    end
    --取消监听状态
	GuideControl.isButtonClick = false
	GuideControl.isClickListener = false

    --移除上一次的引导框，
    if self:getChildByTag(222) ~= nil then
        self:removeChildByTag(222)
    end  
    if GuideControl.showGuideInstant == true then
        cclog("GuideControl.showGuideInstant")
        GuideControl:GuideCheck()
    end  
end

function GuideLayer:converTableToRect(tarTable)
	local rect = cc.rect(tonumber(tarTable[1]), tonumber(tarTable[2]), tonumber(tarTable[3]), tonumber(tarTable[4]))
	return rect
end

function GuideLayer:setAnyPosByData(guidData)
	--提示箭头
	local tmpRect = Split(guidData['arrowPos'], "|")
    if tmpRect ~= nil and table.getn(tmpRect) == 3 then
    	self.arrowDir = tonumber(tmpRect[3])
        if tmpRect[1] ~= nil and tmpRect[2] ~= nil then
            self.arrowPos = cc.p(tonumber(tmpRect[1]), tonumber(tmpRect[2]))
        else
            self.arrowPos = cc.p(-1000, -1000) -- 不显示
        end
    else
        self.arrowPos = cc.p(-1000, -1000) -- 不显示
    end    
	--加亮提示框
	tmpRect = Split(guidData['clickRect'], "|")
    if tmpRect[1] ~= nil and tmpRect[2] ~= nil and tmpRect[3] ~= nil and tmpRect[4] ~= nil then
        self.clickRect = cc.rect(tonumber(tmpRect[1]), tonumber(tmpRect[2]), tonumber(tmpRect[3]), tonumber(tmpRect[4]))
    else
        self.clickRect = cc.rect(-1000, -1000, 0, 0)
    end

	
	--可点击区域
	tmpRect = Split(guidData['clickRect'], "|")
    if tmpRect[1] ~= nil and tmpRect[2] ~= nil and tmpRect[3] ~= nil and tmpRect[4] ~= nil then
        self.clickRect = cc.rect(tonumber(tmpRect[1]), tonumber(tmpRect[2]), tonumber(tmpRect[3]), tonumber(tmpRect[4]))
    else
        self.clickRect = cc.rect(-1000, -1000, 0, 0)
    end
	--文本框显示区域
	tmpRect = Split(guidData['infoRect'], "|")
    if tmpRect[1] ~= nil and tmpRect[2] ~= nil and tmpRect[3] ~= nil and tmpRect[4] ~= nil then
        self.infoRect = cc.rect(tonumber(tmpRect[1]), tonumber(tmpRect[2]), tonumber(tmpRect[3]), tonumber(tmpRect[4]))
    else
        self.infoRect = cc.rect(-1000, -1000, 0, 0)
    end

    --左上角
	if self.curGuidData['datum'] == 0 then
		self.arrowPos.y = ff.height - self.arrowPos.y
		self.clickRect.y = ff.height - self.clickRect.y
		self.infoRect.y = ff.height - self.infoRect.y
	end
end

--显示引导文字
function GuideLayer:showGuideInfo()
	local infoStr = self.curGuidData['guideInfo']

	if infoStr ~= nil and infoStr ~= "" then
		self.ui_infoview:setPosition(cc.p(self.infoRect.x, self.infoRect.y))
		self.ui_infoview:setVisible(true)
		local lab = self.ui_infoview:getChildByName("lab_info")
		lab:setString(ff.langString(infoStr))
	else
		self.ui_infoview:setVisible(false)
	end

    if self._first then
        local sprite = sp.SkeletonAnimation:create("images/guide/Xinshouyindao.json", "images/guide/Xinshouyindao.atlas")
        sprite:setMix("XSYD1_animation","XSYD2_animation",0.2)
        sprite:setMix("XSYD1_animation","XSYD3_animation",0.2)
        sprite:setMix("XSYD2_animation","XSYD1_animation",0.2)
        sprite:setMix("XSYD2_animation","XSYD3_animation",0.2)
        sprite:setMix("XSYD3_animation","XSYD1_animation",0.2)
        sprite:setMix("XSYD3_animation","XSYD2_animation",0.2)
        sprite:setAnimation(0, "XSYD1_animation", false)
        sprite:setTag(1)
        sprite:setAnchorPoint(cc.p(0, 0.5))
        sprite:setPositionX(20)
	    self.ui_infoview:getChildByName("nvren"):addChild(sprite,10)

        if GuideControl.curId >= 100 then
            sprite:setVisible(true)
            self._xsyd = sprite
        else
            sprite:setVisible(false)
            self._xsyd = sprite

            local face = cc.Sprite:create("images/guide/newbie1.png")
            self.ui_infoview:getChildByName("nvren"):addChild(face,10)
            --30,50,300
            face:setPositionX(30)
            face:setPositionY(-10)
            face:setTag(102)
        end

        local function nextCall(event)
            cclog("next call")
            local nex = math.floor(math.random() * 1000000)%2
            local now = sprite:getTag()
            if nex == 0 then
                now = now - 1
            else
                now = now + 1
            end
            if now <= 0 then
                now = 3
            end
            if now > 3 then
                now = 1
            end
            sprite:setAnimation(0, "XSYD"..now.."_animation", false)
            sprite:setTag(now)
        end
        sprite:registerSpineEventHandler(nextCall,SP_ANIMATION_COMPLETE)
        self._first = false
    end
end

function GuideLayer:widgetHide(param)
    if self.ui_infoview ~= nil then
        self.ui_infoview:setVisible(param)
    end
    if self.ui_arrow ~= nil then
        self.ui_arrow:setVisible(param)
    end
    if self.promptLayer ~= nil then
        self.promptLayer:setVisible(param)
    end
    
end

function GuideLayer:CreateGuideBox(rect)
    local boxlayer = cc.Layer:create()
    self:addChild(boxlayer, 1, 222)

    local xyScale = 1
    if dd.currentLayer._map ~= nil then
        xyScale = dd.currentLayer._map:getScale()
    end
    local fixwh = false
    local orgsc = 0.8
    if dd.currentLayer == dd.pveLayer then
        orgsc = 1
    end    
    --如果是屏幕移动，做缩放修正
    local movePos = cc.p(0,0)
    if GuideControl.cfg_guideData[GuideControl.curId]['mapPos'] > 0 then
        if dd.currentLayer._scroll == nil then
            return
        end
        movePos.x = dd.currentLayer._scroll:getInnerContainer():getPositionX()
        movePos.y = dd.currentLayer._scroll:getInnerContainer():getPositionY()
        --中点
        local pos = GuideControl.cfg_guideData[GuideControl.curId]['mapPos']
        if dd.cfgPos[pos] == nil then
            return
        end
        local x = dd.cfgPos[pos]['x']
        local y = 2208- dd.cfgPos[pos]['y']
        --301 : 城墙 --101 ：司令部
        if pos == 301 then
            x = 2000
            y = 900
        else
            local mod = dd.cfgPos[pos]["mod"] 
            if mod == 2 then
                x = x + 254/2
                y = y + 254/4
                if GuideControl.cfg_guideData[GuideControl.curId]['key'] ~= 2 then
                    local have = false
                    for i=1,dd.mybuilds:rowCount() do
                        if dd.mybuilds:getLong(i,"pos") == pos then
                            have = true
                            break
                        end
                    end
                    if have == true then
                        cclog("fix yy.................")
                        y = y + 20
                    end
                end
            elseif mod == 1 then
                x = x + 648/2
                y = y + 324/2
            else
                x = x + 225
                y = y + 225/2
            end      
        end            
        x = x * xyScale
        y = y * xyScale
        cclog("pos:"..pos..","..movePos.x..","..movePos.y..","..x..","..y)
        x = x + movePos.x
        y = y + movePos.y
        cclog("pos:"..pos..","..movePos.x..","..movePos.y..","..x..","..y)
        rect.x = x - (rect.width/orgsc *  xyScale)/2
        rect.y = y - (rect.height/orgsc *  xyScale)/2 + 214
        if GuideControl.cfg_guideData[GuideControl.curId]['key'] == 2 then
            rect.y = rect.y + 90/orgsc *  xyScale
        end
        rect.width = rect.width/orgsc *  xyScale
        rect.height = rect.height/orgsc *  xyScale
        cclog("pos:"..pos..","..movePos.x..","..movePos.y..","..x..","..y..","..rect.width)


        self.arrowPos.x = rect.x + (rect.width)/2 - 20
        self.arrowPos.y = rect.y + rect.height + 50
    else
        local tmpStr = Split(self.curGuidData['sceneMovePos'], "|")
        if dd.currentLayer._scroll == nil then
            return
        end
        if tmpStr[1] ~= nil and tmpStr[2] ~= nil and tonumber(tmpStr[1])>0 and tonumber(tmpStr[2])>0 then
            local x = tonumber(tmpStr[1])
            local y = tonumber(tmpStr[2])

            local w = ff.width / 2 
            local h = dd.mainUI:getChildByName("mapArea"):getContentSize().height / 2

            local xx = -(x*xyScale - w)
            local yy = -(y*xyScale - h)


            if xx > 0 then
                xx = 0
            end
            if yy > 0 then
                yy = 0
            end
            --4096, 2208
            if xx < (-4096 * xyScale + ff.width) then
                xx = (-4096 * xyScale + ff.width)
            end
            if yy < (-2208 * xyScale + dd.mainUI:getChildByName("mapArea"):getContentSize().height) then
                yy = (-2208 * xyScale + dd.mainUI:getChildByName("mapArea"):getContentSize().height)
            end
            movePos.x = xx
            movePos.y = yy

            --中点
            cclog("x:"..x..","..y)
            x = x * xyScale
            y = y * xyScale
            x = x + movePos.x
            y = y + movePos.y
            cclog("x:"..x..","..y)
            rect.x = x - (rect.width/orgsc *  xyScale)/2
            rect.y = y - (rect.height/orgsc *  xyScale)/2 + 214
            rect.width = rect.width/orgsc *  xyScale
            rect.height = rect.height/orgsc *  xyScale
            self.arrowPos.x = rect.x + (rect.width)/2 - 20
            self.arrowPos.y = rect.y + rect.height + 50
            cclog("here..."..rect.x..","..rect.y..","..rect.width..","..rect.height)
        end
    end
    --特殊处理
    if GuideControl.curId == 840 then
        if dd.worldLayer ~= nil then
            rect.y = 214 + (ff.height - 214 - 112)/2 + rect.height/2
        end
    end
    if GuideControl.curId == 6015 then
        cclog("self.curGuidData:"..self.curGuidData['nextId'])
        if dd.mainUI:getChildByName("action"):getChildByName("quelist"):isVisible() == false then
            self.curGuidData['nextId'] = 6020
        end
    end
    if GuideControl.curId == 2010 or GuideControl.curId == 2050 or GuideControl.curId == 2080 then
        if dd.pveLayer ~= nil then
            rect.y = rect.y - (1280 - ff.height)/2
        end
    end
    self.clickRect = cc.rect(rect.x, rect.y,rect.width,rect.height)

    if self.clickRect.width > 0 and self.clickRect.height > 0 then

        --纠正
        if dd.mainUI ~= nil and self.curGuidData['key'] == -4 then
            local size = dd.mainUI:getChildByName("mainBtns"):getChildByName("task"):getChildByName("tips"):getContentSize()
            self.clickRect.width = size.width - 8
            rect.width = size.width - 8
        end


        local zs = cc.p(rect.x , rect.y + rect.height)
        local ys = cc.p(rect.x + rect.width, rect.y + rect. height)
        local yx = cc.p(rect.x + rect.width, rect.y)
        local zx = cc.p(rect.x, rect.y)


        local w = rect.width  - 70
        local h = rect.height - 70

        --左上
        local zsSprite =  cc.Sprite:create()
        zsSprite:setContentSize(cc.size(70, 70))
        zsSprite:setAnchorPoint(cc.p(0.5,0.5))
        local animation = cc.Animation:createWithSpriteFrames(self._animFramesZS, 0.1)
        zsSprite:runAction(cc.RepeatForever:create(cc.Animate:create(animation)))
        zsSprite:setPosition(zs)
        if h < 0 then
            local layout = ccui.Layout:create()
            layout:setContentSize(cc.size(70,35 + math.floor(rect.height/2)))
            layout:setClippingEnabled(true)
            layout:addChild(zsSprite)
            zsSprite:setPosition(35,math.floor(rect.height/2))
            layout:setPosition(cc.p(zs.x - 35,zs.y - math.floor(rect.height/2)))
            boxlayer:addChild(layout,1)        
        else
            zsSprite:setPosition(zs)
            boxlayer:addChild(zsSprite,1)
        end
        cclog("math.floor(rect.height/2):"..math.floor(rect.height/2))
        --左下
        local zxSprite =  cc.Sprite:create()
        zxSprite:setContentSize(cc.size(70, 70))
        zxSprite:setAnchorPoint(cc.p(0.5,0.5))
        local animation = cc.Animation:createWithSpriteFrames(self._animFramesZX, 0.1)
        zxSprite:runAction(cc.RepeatForever:create(cc.Animate:create(animation)))
        if h < 0 then
            local layout = ccui.Layout:create()
            layout:setContentSize(cc.size(70,35 + rect.height - math.floor(rect.height/2)))
            layout:setClippingEnabled(true)
            layout:addChild(zxSprite)
            zxSprite:setPosition(35,35)
            layout:setPosition(cc.p(zx.x - 35,zx.y - 35))
            boxlayer:addChild(layout,1)        
        else
            zxSprite:setPosition(zx)
            boxlayer:addChild(zxSprite,1)
        end
        --右上
        local ysSprite = cc.Sprite:create()
        ysSprite:setContentSize(cc.size(70, 70))
        ysSprite:setAnchorPoint(cc.p(0.5,0.5))
        local animation = cc.Animation:createWithSpriteFrames(self._animFramesYS, 0.1)
        ysSprite:runAction(cc.RepeatForever:create(cc.Animate:create(animation)))

        local hhh = 0
        if h < 0 then
            hhh = math.floor(rect.height/2)
        else
            hhh = 35
        end
        local www = 0
        if w < 0 then
            www = rect.width
        else
            www = 70
        end
        local layout = ccui.Layout:create()
        layout:setContentSize(cc.size(www,35 + hhh))
        layout:setClippingEnabled(true)
        layout:addChild(ysSprite)
        ysSprite:setPosition(35 - (70 - www),hhh)
        layout:setPosition(cc.p(ys.x - 35 + (70 - www),ys.y - hhh))
        boxlayer:addChild(layout)   
        --右下
        local yxSprite = cc.Sprite:create()
        yxSprite:setContentSize(cc.size(70, 70))
        yxSprite:setAnchorPoint(cc.p(0.5,0.5))
        local animation = cc.Animation:createWithSpriteFrames(self._animFramesYX, 0.1)
        yxSprite:runAction(cc.RepeatForever:create(cc.Animate:create(animation)))


        local ww = 70
        local hh = 70
        if w < 0 then
            ww = rect.width
        end
        if h < 0 then
            hh = rect.height - math.floor(rect.height/2)
        end
        local layout = ccui.Layout:create()
        layout:setContentSize(cc.size(ww,hh + 35))
        yxSprite:setPosition(35 - (70 - ww),35)
        layout:setClippingEnabled(true)
        layout:addChild(yxSprite)
        layout:setPosition(cc.p(yx.x - 35 + (70 - ww),yx.y - 35 ))
        boxlayer:addChild(layout,1)             
          
        if w > 0 then
            local count = math.floor(w/40) + 1
            for i=1,count do
                local sp1 = cc.Sprite:create()
                sp1:setContentSize(cc.size(40, 70))
                sp1:setAnchorPoint(cc.p(0.5,0.5))
                local animation = cc.Animation:createWithSpriteFrames(self._animFramesS, 0.1)
                sp1:runAction(cc.RepeatForever:create(cc.Animate:create(animation)))

                local sp2 = cc.Sprite:create()
                sp2:setContentSize(cc.size(40, 70))
                sp2:setAnchorPoint(cc.p(0.5,0.5))
                local animation = cc.Animation:createWithSpriteFrames(self._animFramesX, 0.1)
                sp2:runAction(cc.RepeatForever:create(cc.Animate:create(animation)))


                if i == count then
                    if (i - 1)*40 ~= w then
                        local layout = ccui.Layout:create()
                        layout:setContentSize(cc.size(w - (i - 1)*40, 70))
                        layout:setClippingEnabled(true)
                        layout:addChild(sp1)
                        sp1:setPosition(20,35)
                        layout:setPosition(cc.p(zs.x + 35 + (i - 1) * 40 , zs.y -35 ))
                        boxlayer:addChild(layout)

                        local layout = ccui.Layout:create()
                        layout:setContentSize(cc.size(w - (i - 1)*40, 70))
                        layout:setClippingEnabled(true)
                        layout:addChild(sp2)
                        sp2:setPosition(20,35)
                        layout:setPosition(cc.p(zx.x + 35 + (i - 1) * 40 , zx.y -35 ))
                        boxlayer:addChild(layout)
                    end
                else
                    sp1:setPosition(cc.p(zs.x + 35 + (i - 1) * 40 + 20, zs.y ))
                    boxlayer:addChild(sp1)
                    sp2:setPosition(cc.p(zx.x + 35 + (i - 1) * 40 + 20, zx.y ))
                    boxlayer:addChild(sp2)
                end
            end        
        end
        if h > 0 then
            local count = math.floor(h/40) + 1
            for i=1,count do
                local sp1 = cc.Sprite:create()
                sp1:setContentSize(cc.size(70, 40))
                sp1:setAnchorPoint(cc.p(0.5,0.5))
                local animation = cc.Animation:createWithSpriteFrames(self._animFramesZ, 0.1)
                sp1:runAction(cc.RepeatForever:create(cc.Animate:create(animation)))

                local sp2 = cc.Sprite:create()
                sp2:setContentSize(cc.size(70, 40))
                sp2:setAnchorPoint(cc.p(0.5,0.5))
                local animation = cc.Animation:createWithSpriteFrames(self._animFramesY, 0.1)
                sp2:runAction(cc.RepeatForever:create(cc.Animate:create(animation)))


                if i == count then
                    if (i - 1)*40 ~= h then
                        local layout = ccui.Layout:create()
                        layout:setContentSize(cc.size(70,h - (i - 1)*40))
                        layout:setClippingEnabled(true)
                        layout:addChild(sp1)
                        sp1:setPosition(35,20)
                        layout:setPosition(cc.p(zx.x -35,zx.y + 35 + (i - 1) * 40 ))
                        boxlayer:addChild(layout)

                        local layout = ccui.Layout:create()
                        layout:setContentSize(cc.size(70,h - (i - 1)*40))
                        layout:setClippingEnabled(true)
                        layout:addChild(sp2)
                        sp2:setPosition(35,20)
                        layout:setPosition(cc.p(yx.x -35,yx.y + 35 + (i - 1) * 40 ))
                        boxlayer:addChild(layout)
                    end
                else
                    sp1:setPosition(cc.p(zx.x, zx.y + 35 + (i - 1) * 40 + 20))
                    boxlayer:addChild(sp1)
                    sp2:setPosition(cc.p(yx.x, yx.y + 35 + (i - 1) * 40 + 20))
                    boxlayer:addChild(sp2)
                end
            end        
        end
    end
end
--显示高亮提示框
function GuideLayer:showPrompt()
	if self.clickRect.width >= 0 and self.clickRect.height >= 0 then
        self:CreateGuideBox(self.clickRect)
		self:removeChildByTag(10001)
        self.promptLayer = nil
        --全局遮罩
     	local function createMaskLayer()
            local lay = nil
            cclog("id:"..GuideControl.curId)
            if GuideControl.cfg_guideData[GuideControl.curId]['mask'] == 1 then
         		lay = cc.LayerColor:create(cc.c4b(0,0,0,0))    
            else
                lay = cc.LayerColor:create(cc.c4b(0,0,0,100))    
            end
            local mask = dd.newSpriteFromUI("public/alpha.png")
            if mask == nil then
                return
            end
	     	mask:setAnchorPoint(cc.p(0,0))
            mask:setScaleX((self.clickRect.width) / mask:getContentSize().width)
            mask:setScaleY(self.clickRect.height/mask:getContentSize().height)
            mask:setPosition(cc.p(self.clickRect.x,self.clickRect.y))
            
			self.promptLayer = createMaskSprite(cc.size(ff.width, ff.height), lay, mask)
			self.promptLayer:setPosition(cc.p(ff.width/2, ff.height/2))
			self:addChild(self.promptLayer, -1, 10001)
     	end
     	createMaskLayer()
	else
        cclog("showPrompt.......")
		self:removeChildByTag(10001)
	end
end

--显示箭头
function GuideLayer:showArrow()
	self.ui_arrow:setAnchorPoint(0,0.5)
	self.ui_arrow:setPosition(cc.p(self.arrowPos.x, self.arrowPos.y))

    if self.arrowPos.x >=0 and self.arrowPos.y >= 0 then
        self.ui_arrow:setVisible(true)
    else
        self.ui_arrow:setVisible(false)
    end
		
    self.ui_arrow:stopAllActions()
	if self.arrowDir == 0 then
        self.ui_arrow:setVisible(false)
    elseif self.arrowDir == 1 then
        self.ui_arrow:setRotation(0)
		self.ui_arrow:runAction(cc.RepeatForever:create(cc.Sequence:create(
            cc.CallFunc:create(function () self.ui_arrow:setPositionY(self.ui_arrow:getPositionY() + 80) end),
            cc.MoveBy:create(0.6, cc.p(0, -80)),
            cc.DelayTime:create(0.6)
            )))
	elseif self.arrowDir == 2 then
		self.ui_arrow:setRotation(90)
        self.ui_arrow:runAction(cc.RepeatForever:create(cc.Sequence:create(
            cc.CallFunc:create(function () self.ui_arrow:setPositionX(self.ui_arrow:getPositionX() + 80) end),
            cc.MoveBy:create(0.6, cc.p(-80, 0)),
            cc.DelayTime:create(0.6)
            )))
	elseif self.arrowDir == 3 then
		self.ui_arrow:setRotation(-90)
        self.ui_arrow:runAction(cc.RepeatForever:create(cc.Sequence:create(
            cc.CallFunc:create(function () self.ui_arrow:setPositionX(self.arrowPos.x - 80) end),
            cc.MoveBy:create(0.6, cc.p(80, 0)),
            cc.DelayTime:create(0.6)
            )))
	end
end


function GuideLayer:saveStopId()
	local stopId = self.curGuidData['stopId']
	if stopId > 0 then
        local message = ff.net:createMessage()
        message:addCmd(0x00000149)
        message:addLong(dd.uid)
        message:addLong(stopId)
        ff.net:postMessage(message) 
        dd.myinfo:setLong(1,"newbie", stopId)
	end  
end

function GuideLayer:setDelayCall()
    if self._forWaiting == false then
        local waitime = self.curGuidData['waitime']
        if waitime > 0 and self.curGuidData['key'] ~= 8 then
            self._forWaiting = true
        end
    end
end
--以后需要加必要的判断
function GuideLayer:checkDelay()
    cclog("checkDelay")
    if self._forWaiting == true then
        cclog("checkDelay:"..GuideControl.curId)
        if GuideControl.curId == 635 or GuideControl.curId == 638 or GuideControl.curId == 632 then
            GuideControl.curId = 640
            GuideControl._inGuide = false
        elseif GuideControl.curId == 780 or GuideControl.curId == 775 or GuideControl.curId == 770 then
            GuideControl.curId = 785
            GuideControl._inGuide = false
        elseif GuideControl.curId == 1350 or GuideControl.curId == 1355 or GuideControl.curId == 1360 or GuideControl.curId == 1370 or GuideControl.curId == 1380 then
            GuideControl.curId = 1400
            GuideControl._inGuide = false
        elseif GuideControl.curId == 1400 or GuideControl.curId == 1410 or GuideControl.curId == 1420 or GuideControl.curId == 1430 or GuideControl.curId == 1440 then
            GuideControl.curId = 2000
            GuideControl._inGuide = false
        elseif GuideControl.curId == 5000 or GuideControl.curId == 5010 or GuideControl.curId == 5020 or GuideControl.curId == 5030 or GuideControl.curId == 5040 then
            if dd.buildingListWidget and dd.buildingListWidget:isVisible() then
                GuideControl.curId = 5050
            else
                GuideControl.curId = 5045
            end                 
            --GuideControl.curId = 5050
            GuideControl._inGuide = false
        else
            self:goNextGuide()
        end
        self._forWaiting = false
    end
end
function GuideLayer:endWaiting()
    self._forWaiting = false
end

function GuideLayer:Draw(guidData)
	self.curGuidData = guidData

    --移除上一次的引导框，防止意外
    if self:getChildByTag(222) ~= nil then
        self:removeChildByTag(222)
    end
    --绘制各个控件和处理一些事情
	self.preGuideId = self.curGuidData['id']
    if self.preGuideId < 100 then
        local face = self.curGuidData['bid']
        self.curGuidData['bid'] = 0
        if self:getChildByName("infoview"):getChildByName("close") ~= nil then
            self:getChildByName("infoview"):getChildByName("close"):setVisible(false)
        end
        if self._xsyd ~= nil then
            if face > 0 and face <= 3 then
                self._xsyd:setVisible(false)
                self.ui_infoview:getChildByName("nvren"):getChildByTag(102):setTexture("images/guide/newbie"..face..".png")
                self.ui_infoview:getChildByName("nvren"):getChildByTag(102):setVisible(true)
                if face == 1 then
                    self.ui_infoview:getChildByName("nvren"):getChildByTag(102):setPositionX(30)
                elseif face == 2 then    
                    self.ui_infoview:getChildByName("nvren"):getChildByTag(102):setPositionX(50)
                else
                    self.ui_infoview:getChildByName("nvren"):getChildByTag(102):setPositionX(300)
                end
            else
                self._xsyd:setVisible(true)
                self.ui_infoview:getChildByName("nvren"):getChildByTag(102):setVisible(false)
            end
        end
    else
        if self:getChildByName("infoview"):getChildByName("close") ~= nil then
            self:getChildByName("infoview"):getChildByName("close"):setVisible(true)
        end
        if self._xsyd ~= nil then
            self._xsyd:setVisible(true)
            if self.ui_infoview:getChildByName("nvren"):getChildByTag(102) ~= nil then
                self.ui_infoview:getChildByName("nvren"):getChildByTag(102):setVisible(false)
            end
        end
    end


	self:setAnyPosByData(guidData)
	self:setVisible(true)
    self:endWaiting()
    self:widgetHide(true)
    self:showPrompt()		--设置高亮提示框
    self:showArrow()		--设置箭头位置
	self:showGuideInfo()	--设置提示文字
	self:setDelayCall()		--设置任务存在时间，超时则直接完成任务
    self:globalMark()
	self:saveStopId()             	
end
function GuideLayer:globalMark()
    --文字信息
    if tonumber(self.curGuidData['guideType']) == 1 then
        self:getChildByName("infoview"):getChildByName("quanjv"):setVisible(true)
    else
        self:getChildByName("infoview"):getChildByName("quanjv"):setVisible(false)
    end
end
function GuideLayer:registListener()
	local function onTouchBegan(touch, event)
        --cclog("===============")
        local startPos = touch:getLocation()
        if not self:isVisible() then
        	return false
        end
        if self.clickRect == nil then
            return false
        end
        --已经是下一个内容了，不能触发
        if self.curGuidData['id'] ~= GuideControl.curId then
            return false
        end
        if cc.rectContainsPoint(self.clickRect, startPos) == true then
            if self.curGuidData['guideType'] == 1 then
                return true
            end
            if self.curGuidData['guideType'] == 2 and tonumber(self.curGuidData['mapPos']) > 0  then
                return true
            end
            if  GuideControl.curId == 620 then     
                GuideControl.isButtonClick = true
                return true
            elseif GuideControl.curId == 1140 then
                self:goNextGuide()
                GuideControl:GuideCheck()   
                return true
            elseif GuideControl.curId == 830 or GuideControl.curId == 840 or GuideControl.curId == 1100 or GuideControl.curId == 2010 or GuideControl.curId == 2050 or GuideControl.curId == 2080 then    
                return true                
            elseif GuideControl.cfg_guideData[GuideControl.curId]['key'] == 2 then
                return true
            end
            GuideControl.isButtonClick = true
            return false
        elseif self.curGuidData['guideType'] == 1 then
            return true
        else
            return true
        end
    end

    local function onTouchEnd(touch, event)
        if self.clickRect == nil then
            return
        end
        if self:isVisible() and self.curGuidData['guideType'] == 1 then
            if GuideControl.cfg_guideData[GuideControl.curId]['key'] == 2 then
                for i=1,dd.mybuilds:rowCount() do
                    if dd.mybuilds:getLong(i,"bid") == GuideControl.cfg_guideData[GuideControl.curId]['bid'] then
                        GuideControl.cfg_guideData[GuideControl.curId]['mapPos'] = dd.mybuilds:getLong(i,"pos")
                        dd.MoveMapPointToScreenCenter(cc.p(0,0),1,dd.mybuilds:getLong(i,"pos"),GuideControl.cfg_guideData[GuideControl.curId]['scale']/100)
                        break
                    end
                end                
                self:goNextGuide()
            elseif GuideControl.cfg_guideData[GuideControl.curId]['key'] == 3 then
                dd.MoveMapPointToScreenCenter(cc.p(0,0),1,GuideControl.cfg_guideData[GuideControl.curId]['mapPos'],GuideControl.cfg_guideData[GuideControl.curId]['scale']/100)
                self:goNextGuide()
            else
                self:goNextGuide()
                GuideControl:ShowMaskLayer(true)
                GuideControl:GuideCheck()   
                if GuideControl.curId == 816 then
                    if dd.worldLayer ~= nil then
                        dd.worldLayer:playGuideArmature()
                    end
                end
            end
        else
            if cc.rectContainsPoint(self.clickRect, touch:getLocation()) then
                --什么都不做，进入下个阶段
                if GuideControl.curId == 620 then
                elseif GuideControl.curId == 830 then
                    --世界地图上，采集按钮
                    self:goNextGuide()
                    dd.worldLayer:setSceneCenterByGid(GuideControl.gid47 - 1,false)   
                    dd.currentLayer._curMapLayer:showMapItem(GuideControl.gid47, cc.p(0, 0))
                elseif GuideControl.curId == 840 then
                    self:goNextGuide()
                    pop.onShowPopDialog("chuzhen",WorldControl:getInstance()._cache['type'],WorldControl:getInstance()._cache)
                    WorldControl:getInstance():closeAll()
                elseif GuideControl.cfg_guideData[GuideControl.curId]['key'] == 3 then    
                    local pos = GuideControl.cfg_guideData[GuideControl.curId]['mapPos']
                    local bid = GuideControl.cfg_guideData[GuideControl.curId]['bid']
                    if bid == 0 then
                        local have = false
                        for i=1,dd.myLocks:rowCount() do
                            if dd.myLocks:getLong(i,"pos") == pos then
                                have = true
                                break
                            end
                        end
                        for i=1,dd.mybuilds:rowCount() do
                            if dd.mybuilds:getLong(i,"pos") == pos then
                                have = true
                                break
                            end
                        end
                        --解锁
                        if have == false then
                            local message = ff.net:createMessage()
                            message:addCmd(0x0000016c)
                            message:addLong(dd.uid)
                            message:addLong(pos)
                            ff.net:rpc(message,false)     
                        end                        
                    else
                        --建造
                        if pos > 0 then
                            if bid > 0 then
                                onShowBuildsListNewbie(dd.currentLayer._widget,tonumber(self.curGuidData['mapPos']),tonumber(self.curGuidData['bid']))    
                            end
                        end
                    end
                    self:goNextGuide()     
                    GuideControl:ShowMaskLayer(true)
                    GuideControl:GuideCheck()   
                elseif GuideControl.cfg_guideData[GuideControl.curId]['key'] == 2 then
                    if dd.cityLayer ~= nil then
                        dd.cityLayer:makeEffects(GuideControl.cfg_guideData[GuideControl.curId]['mapPos'],touch:getLocation())
                    end
                    if GuideControl.cfg_guideData[GuideControl.curId]['bid'] > 0 then
                        for i=1,dd.mybuilds:rowCount() do
                            if dd.mybuilds:getLong(i,"bid") == GuideControl.cfg_guideData[GuideControl.curId]['bid'] then
                                GuideControl.cfg_guideData[GuideControl.curId]['mapPos'] = dd.mybuilds:getLong(i,"pos")
                                dd.MoveMapPointToScreenCenter(cc.p(0,0),1,dd.mybuilds:getLong(i,"pos"),GuideControl.cfg_guideData[GuideControl.curId]['scale']/100)
                                break
                            end
                        end                   
                        self:goNextGuide()
                    else
                        if GuideControl.curId ~= 670 then
                            self:goNextGuide()
                            GuideControl:GuideCheck()
                        else
                            self:widgetHide(false)
                            if self:getChildByTag(222) ~= nil then
                                self:removeChildByTag(222)
                            end                              
                        end
                    end
                elseif GuideControl.curId == 1100 then
                    --打开金币任务
                    self:goNextGuide()
                    pop.onShowPopDialog("goldActivity")
                elseif GuideControl.curId == 2010 or GuideControl.curId == 2050 or GuideControl.curId == 2080 then
                    --打开僵尸
                    cclog("kill zombie....")
                    if dd.pveLayer ~= nil then
                        if GuideControl.curId == 2010 then
                            pop.onShowPopDialog("pve",6,dd.pveLayer._enemy)
                        elseif GuideControl.curId == 2050 then
                            pop.onShowPopDialog("pve",7,dd.pveLayer._enemy)
                        elseif GuideControl.curId == 2080 then
                            pop.onShowPopDialog("pve",8,dd.pveLayer._enemy)
                        end
                        self:goNextGuide()
                    end
                else
                    if tonumber(self.curGuidData['mapPos']) > 0 then
                        if tonumber(self.curGuidData['bid']) > 0 then
                            onShowBuildsListNewbie(dd.mainUI,tonumber(self.curGuidData['mapPos']),tonumber(self.curGuidData['bid']))    
                        else                    
                            onShowBuildsList(dd.mainUI,tonumber(self.curGuidData['mapPos']))    
                        end
                        self:goNextGuide()
                        GuideControl:ShowMaskLayer(true)
                    end
                end
            end
        end
        return
    end

	local listener = cc.EventListenerTouchOneByOne:create()
    listener:registerScriptHandler(onTouchBegan,cc.Handler.EVENT_TOUCH_BEGAN)
    listener:registerScriptHandler(onTouchEnd, cc.Handler.EVENT_TOUCH_ENDED)
    listener:setSwallowTouches(true)
    self:getEventDispatcher():addEventListenerWithSceneGraphPriority(listener,self)

end

function GuideLayer.onPopCancel(sender,eventType)
    if eventType==ccui.TouchEventType.ended then
        GuideControl._curGuideLayer:getChildByName("besure"):setVisible(false) 
    end
end
function GuideLayer.onPopSure(sender,eventType)
    local function endAction()
        if GuideControl._curGuideLayer ~= nil then
            GuideControl._curGuideLayer:getChildByName("besure"):setVisible(false)
        end    
    end
    if eventType==ccui.TouchEventType.ended then
        GuideControl._curGuideLayer:getChildByName("besure"):setVisible(false)
        if GuideControl._curGuideLayer._callback ~= nil then
            GuideControl._curGuideLayer._callback()
            GuideControl._curGuideLayer._callback = nil
        end            
    end
end

function GuideLayer:initUI()
	self.ui_arrow = self:getChildByName("img_arrow")	  --提示箭头
	self.ui_prompt = self:getChildByName("img_prompt")    --高亮提示框

	self.ui_infoview = self:getChildByName("infoview")    --文本框提示框
    self.ui_besure = self:getChildByName("besure")
    if self.ui_besure ~= nil then
        self.ui_besure:setVisible(false)
        self.ui_besure:setContentSize(cc.size(ff.width,ff.height))
        self.ui_besure:setPositionY(0)
        self.ui_besure:getChildByName("warning"):setPositionY(ff.height/2)
        self.ui_besure:getChildByName("warning"):getChildByName("cacel"):addTouchEventListener(self.onPopCancel)
        self.ui_besure:getChildByName("warning"):getChildByName("sure"):addTouchEventListener(self.onPopSure)
    end
    local cache = cc.SpriteFrameCache:getInstance()
    cache:addSpriteFrames("images/guide/guide_box/guide_box0.plist")
    for j = 1, 15 do
        local frame = nil
        local i = j-1
        frame = cache:getSpriteFrame("zx_"..i..".png")
        self._animFramesX[j] = frame
    end
    for j = 1, 15 do
        local frame = nil
        local i = j-1
        frame = cache:getSpriteFrame("y_"..i..".png")
        self._animFramesY[j] = frame
    end
    for j = 1, 15 do
        local frame = nil
        local i = j-1
        frame = cache:getSpriteFrame("ys_"..i..".png")
        self._animFramesYS[j] = frame
    end
    for j = 1, 15 do
        local frame = nil
        local i = j-1
        frame = cache:getSpriteFrame("yx_"..i..".png")
        self._animFramesYX[j] = frame
    end
    for j = 1, 15 do
        local frame = nil
        local i = j-1
        frame = cache:getSpriteFrame("zs_"..i..".png")
        self._animFramesS[j] = frame
    end
    for j = 1, 15 do
        local frame = nil
        local i = j-1
        frame = cache:getSpriteFrame("zuoshang_"..i..".png")
        self._animFramesZS[j] = frame
    end
    for j = 1, 15 do
        local frame = nil
        local i = j-1
        frame = cache:getSpriteFrame("zuoxia_"..i..".png")
        self._animFramesZX[j] = frame
    end
    for j = 1, 15 do
        local frame = nil
        local i = j-1
        frame = cache:getSpriteFrame("z_"..i..".png")
        self._animFramesZ[j] = frame
    end


	self.ui_arrow:setVisible(false)
	self.ui_prompt:setVisible(false)
	self.ui_infoview:setVisible(false)
	self.ui_infoview:setAnchorPoint(0,0)

    function closeBtn(sender,eventType)
        if eventType==ccui.TouchEventType.ended then   
            cclog("here........:"..GuideControl.curId)
            if self:getChildByName("besure") ~= nil then
                function isclose(  )
                    GuideControl:ShowMaskLayer(false)   
                    local message = ff.net:createMessage()
                    message:addCmd(0x00000149)
                    message:addLong(dd.uid)
                    message:addLong(-999)
                    ff.net:postMessage(message)

                    GuideControl._isOver = true
                    GuideControl.curId = -999
                    dd.myinfo:setLong(1,"newbie", GuideControl.curId)


                    --GuideControl.curGuidData = GuideControl.cfg_guideData[GuideControl.cfg_guideData[GuideControl.curId]['skipid']]
                    --GuideControl.curId = GuideControl.cfg_guideData[GuideControl.curId]['skipid']
                    --dd.myinfo:setLong(1,"newbie", GuideControl.curId)
                    platform_taskFinish("skip",0)  
                    GuideControl:ShowMaskLayer(false)
                    if GuideControl._curGuideLayer ~= nil then
                        GuideControl._curGuideLayer:setVisible(false)
                        if dd.mainUI ~= nil then
                            dd.mainUI:checkGuide()
                        end
                    end
                    cc.Director:getInstance():getOpenGLView():enableTouchMove(true)
                    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
                        local blue = cc.UserDefault:getInstance():getIntegerForKey("blue",0)
                        local haveblue = cc.UserDefault:getInstance():getIntegerForKey("haveblue",0)
                        if blue == 1 and haveblue == 0 then
                            local function callback()
                                cc.UserDefault:getInstance():setIntegerForKey("haveblue",1)
                                pop.onShowPopDialog("mail",4)
                            end
                            dd.mainUI:onShowSure(ff.langString("查看礼物"), ff.langString("Bluestacks customers, welcome to Z War. We have prepared a gift which you can find in your mailbox."), callback, false, 2,3)
                        end
                    end
                end
                self:onShowSure(ff.langString("警告"),ff.langString("完成新手引导将获得一定的奖励，确定要跳过新手引导？"),isclose,true,2,1)
            else
                cclog("here........:"..GuideControl.curId)
                GuideControl:ShowMaskLayer(false)   
                local message = ff.net:createMessage()
                message:addCmd(0x00000149)
                message:addLong(dd.uid)
                message:addLong(-999)
                ff.net:postMessage(message)

                GuideControl._isOver = true
                GuideControl.curId = -999
                dd.myinfo:setLong(1,"newbie", GuideControl.curId)


                --GuideControl.curGuidData = GuideControl.cfg_guideData[GuideControl.cfg_guideData[GuideControl.curId]['skipid']]
                --GuideControl.curId = GuideControl.cfg_guideData[GuideControl.curId]['skipid']
                --dd.myinfo:setLong(1,"newbie", GuideControl.curId)
                platform_taskFinish("skip",0)  
                GuideControl:ShowMaskLayer(false)
                if GuideControl._curGuideLayer ~= nil then
                    GuideControl._curGuideLayer:setVisible(false)
                    if dd.mainUI ~= nil then
                        dd.mainUI:checkGuide()
                    end
                end
                cc.Director:getInstance():getOpenGLView():enableTouchMove(true)
            end
        end
    end
    --skip
    --if ff.debug == true then
    --if cc.PLATFORM_OS_ANDROID ~= cc.Application:getInstance():getTargetPlatform() then
        local close = ccui.Button:create("images/ui/guideClose.png")
        close:setPosition(90, 140)
        close:addTouchEventListener(closeBtn)
        close:setName("close")
        self:getChildByName("infoview"):addChild(close)
    --end
end
function GuideLayer:init()
	self:initUI()
	self:registListener()
end

function GuideLayer:onShowSure(title,str,callback,icon,color,type,tips)
    if icon == nil then
        icon = false
    end
    if color == nil then
        color = 1
    end
    if type == nil then
        type = 1
    end
    if type == 1 then
        self:getChildByName("besure"):getChildByName("warning"):getChildByName("cacel"):getChildByName("chu_label"):setString(ff.langString("取消"))
        self:getChildByName("besure"):getChildByName("warning"):getChildByName("cacel"):loadTextureNormal(dd.getPathFromUI('public/v2/blue_on.png',1))
        self:getChildByName("besure"):getChildByName("warning"):getChildByName("sure"):getChildByName("chu_label"):setString(ff.langString("确定"))
        self:getChildByName("besure"):getChildByName("warning"):getChildByName("cacel"):addTouchEventListener(self.onPopCancel)
        self:getChildByName("besure"):getChildByName("warning"):getChildByName("sure"):addTouchEventListener(self.onPopSure)
    else
        self:getChildByName("besure"):getChildByName("warning"):getChildByName("cacel"):getChildByName("chu_label"):setString(tips)
        self:getChildByName("besure"):getChildByName("warning"):getChildByName("cacel"):loadTextureNormal(dd.getPathFromUI('public/v2/green.png',1))
        self:getChildByName("besure"):getChildByName("warning"):getChildByName("cacel"):addTouchEventListener(self.onPopSure)
        self:getChildByName("besure"):getChildByName("warning"):getChildByName("sure"):addTouchEventListener(self.onPopCancel)
    end
    self:getChildByName("besure"):getChildByName("warning"):getChildByName("info"):getChildByName("label"):setString(title)
    self:getChildByName("besure"):getChildByName("warning"):getChildByName("info"):getChildByName("info"):setString(str)
    self:getChildByName("besure"):setVisible(true)
    self:getChildByName("besure"):getChildByName("warning"):getChildByName("info"):getChildByName("icon"):setVisible(icon)
    if color == 1 then
        self:getChildByName("besure"):getChildByName("warning"):getChildByName("info"):getChildByName("label"):setColor(cc.c3b(161,175,175))
    else
        self:getChildByName("besure"):getChildByName("warning"):getChildByName("info"):getChildByName("label"):setColor(cc.c3b(255,0,0))
    end
    self:getChildByName("besure"):getChildByName("warning"):getChildByName("info"):requestDoLayout()
    self:getChildByName("besure"):getChildByName("warning"):setPositionY(ff.height/2 +100)
    pop.showPopEffect(5,self:getChildByName("besure"):getChildByName("warning"))
    self._callback=callback
end


function createGuideLayer() 
    local target
    if ff.platform == 1 then
        target = GuideLayer.extend(dd.loadUi("images/ui/guide.json"))
    else
        target = GuideLayer.extend(dd.loadUi("images/ui/guide.ExportJson"))
    end
	target:init()
	return target
end

local GuideLayerEx = class("GuideLayerEx")  

GuideLayerEx._name = "GuideLayerEx"

GuideLayerEx.ui_arrow = nil     --箭头
GuideLayerEx.ui_infoview = nil  --文本框提示框

function GuideLayerEx.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, GuideLayerEx)
    return target
end

function createGuideLayerEx(callback)
    local target
    if ff.platform == 1 then
        target = GuideLayerEx.extend(dd.loadUi("images/ui/guide.json"))
    else
        target = GuideLayerEx.extend(dd.loadUi("images/ui/guide.ExportJson"))
    end
    target:initEx(callback)
    return target
end

function GuideLayerEx:initUIEx()
    self.ui_arrow = self:getChildByName("img_arrow")      --提示箭头
    self.ui_prompt = self:getChildByName("img_prompt")    --高亮提示框

    self.ui_infoview = self:getChildByName("infoview")    --文本框提示框
    
    self.ui_arrow:setVisible(false)
    self.ui_prompt:setVisible(false)
    self.ui_infoview:setVisible(false)
    self.ui_infoview:setAnchorPoint(0,0)
    if self:getChildByTag(10001) ~= nil then
        self:removeChildByTag(10001)
    end
    self.promptLayer = nil
        --全局遮罩
        
    local lay = nil
    
    lay = cc.LayerColor:create(cc.c4b(0,0,0,100))    
    
    local mask = dd.newSpriteFromUI("public/alpha.png")
    if mask == nil then
        return
    end
    mask:setAnchorPoint(cc.p(0,0))

    mask:setScaleX(0)
    mask:setScaleY(0)
    mask:setPosition(cc.p(0,0))
    
    self.promptLayer = createMaskSprite(cc.size(ff.width, ff.height), lay, mask)
    self.promptLayer:setPosition(cc.p(ff.width/2, ff.height/2))
    self:addChild(self.promptLayer, -1, 10001)
end
function GuideLayerEx:initEx(callback)
    self:initUIEx()
    self:registListenerEx(callback)
end

function GuideLayerEx:registListenerEx(callback)
    local function onTouchBegan(touch, event)
        --cclog("===============")
        local startPos = touch:getLocation()
        if not self:isVisible() then
            return false
        end
        
        return true
           
    end

    local function onTouchEnd(touch, event)
        
        if self:isVisible() then

            if callback ~= nil then
                --GuideControl:ShowMaskLayerEx(false)
                --GuideControl:stopGuideEx()
                callback()
            end
        end
        return
    end


    local listener = cc.EventListenerTouchOneByOne:create()
    listener:registerScriptHandler(onTouchBegan,cc.Handler.EVENT_TOUCH_BEGAN)
    listener:registerScriptHandler(onTouchEnd, cc.Handler.EVENT_TOUCH_ENDED)
    listener:setSwallowTouches(true)
    self:getEventDispatcher():addEventListenerWithSceneGraphPriority(listener,self)

end