local MaskSprite = class("MaskSprite")  

MaskSprite._name = "MaskSprite"

function MaskSprite.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, MaskSprite)
    return target
end

function MaskSprite:init(srcSp, maskSp)

	srcSp:retain()
	maskSp:retain()

	maskSp:setBlendFunc(gl.ZERO, gl.ZERO)
    -- srcSp:setBlendFunc(gl.ONE_MINUS_DST_ALPHA, gl.ONE)
    srcSp:setBlendFunc(gl.SRC_ALPHA, gl.ONE)

    self:begin()
    
    srcSp:visit()
    maskSp:visit()

    self:endToLua()

    local function releaseCall(dt)
        srcSp:release()
        maskSp:release()
    end
    
    performWithDelay(self, releaseCall, 0.1)
end


function createMaskSprite(size,srcSp,maskSp)
    if size.width < 100 then
        size.width = 720
    end
    if size.height < 100 then
        size.height = 1280
    end

    local render = cc.ClippingNode:create()
    render:retain()
    render:setContentSize(size);
    render:setAnchorPoint(cc.p(0.5,0.5))
    render:setPosition(cc.p(size.width * 0.5,size.height))
    render:setStencil(maskSp)
    render:addChild(srcSp)
    render:setInverted(true)
    local target = MaskSprite.extend(render)
    return target
end