require "fatality"
require "httpIf"
require "progress/progress"
require "versionManager"

cclog = function(...)
    if ff.debug == true then
        print("tick:"..ff.gameCore:getTick()..","..string.format(...))
    end
end

cclog2 = function ( ... )
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        local args = { string.format(...) }
        local sigs = "(Ljava/lang/String;)I"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"
        luaj.callStaticMethod(className,"cclog",args,sigs)
    end   
    print(string.format(...))
end

cclog3 = function (msg)
    local message = ff.net:createMessage()
    message:addCmd(0x00000168)
    message:addLong(dd.uid)
    message:addLong(cc.UserDefault:getInstance():getIntegerForKey("testacount"))
    message:addLong(cc.UserDefault:getInstance():getIntegerForKey("dbversion"))
    message:addLong(cc.UserDefault:getInstance():getIntegerForKey("version"))
    message:addLong(ff.set_power)
    message:addLong(cc.Application:getInstance():getTargetPlatform())
    message:addLong(getVersion2())
    message:addLong(ff.acount)
    message:addLong(0)
    message:addString(tostring(msg),512)
    ff.net:postMessage(message)     
end

-- for CCLuaEngine traceback
function __G__TRACKBACK__(msg)
    local message = ff.net:createMessage()
    message:addCmd(0x00000168)
    message:addLong(dd.uid)
    message:addLong(cc.UserDefault:getInstance():getIntegerForKey("testacount"))
    message:addLong(cc.UserDefault:getInstance():getIntegerForKey("dbversion"))
    message:addLong(cc.UserDefault:getInstance():getIntegerForKey("version"))
    message:addLong(ff.set_power)
    message:addLong(cc.Application:getInstance():getTargetPlatform())
    message:addLong(0)
    message:addLong(getVersion2())
    message:addLong(0)
    message:addString(tostring(msg) .. "\n"..debug.traceback(),512)
    ff.net:postMessage(message)     
    cclog("send error.....................")
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        cclog("----------------------------------------")
        cclog("LUA ERROR: " .. tostring(msg) .. "\n")
        cclog(debug.traceback())
        cclog("----------------------------------------")
        local args = { "----------------------------------------\nLUA ERROR: ".. tostring(msg) .. "\n"..debug.traceback().."----------------------------------------"}
        local sigs = "(Ljava/lang/String;)I"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"
        luaj.callStaticMethod(className,"cclog",args,sigs)
    else
        cclog("----------------------------------------")
        cclog("LUA ERROR: " .. tostring(msg) .. "\n")
        cclog(debug.traceback())
        cclog("----------------------------------------")
    end    
end

local function main()
    collectgarbage("setpause", 100)
    collectgarbage("setstepmul", 5000)

    math.randomseed( os.time() )
    platform_screenType(2)


    if cc.PLATFORM_OS_WINDOWS ~= cc.Application:getInstance():getTargetPlatform() then
        if cc.PLATFORM_OS_IPHONE == cc.Application:getInstance():getTargetPlatform() or cc.PLATFORM_OS_IPAD == cc.Application:getInstance():getTargetPlatform() then
            ff.platform = 1
        else
            ff.platform = 0
        end
    end
    --require "define"

    cclog("tick:"..ff.gameCore:getTick())
    --初始化游戏
    ff.initGame()
    --显示预读背景
    runProgressScene(true)    
end
xpcall(main, __G__TRACKBACK__)

