local NetLayer = class("NetLayer")
NetLayer._name = "NetLayer"
NetLayer._id   = 0
NetLayer._init = true
NetLayer._listener = nil
NetLayer._callback = nil
NetLayer._property = nil
NetLayer._delTable = nil

--释放资源函数
NetLayer._realse = nil
NetLayer._callQue= nil

NetLayer._lastTick = 0

function NetLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, NetLayer)
    return target
end

function NetLayer:removeEvent(tag,message)
    cclog("remove event: tag:"..tag.." message:"..message)
	if self._callback ~= nil then
		if self._callback[message] ~= nil then
			self._callback[message][tag] = nil
		end		
	end		
end
function NetLayer:checkEvent(tag,message)
    local ret = false
    if self._callback ~= nil then
        if self._callback[message] ~= nil and self._callback[message][tag] ~= nil then
            ret = true
        end     
    end 
    return ret    
end
function NetLayer:registerEvent(tag,message,callback)
	if self._callback == nil then
		self._callback = {}
	end
	if callback == nil then
		return false
	end
	if self._callback[message] == nil then
		self._callback[message] = {}
	end	
    cclog("regist Event1:"..message..','..tag)
	self._callback[message][tag] = callback
end
function NetLayer:addEventListener(message,listener,relase)
	if message == nil then
		return false
	end		
	if self._listener == nil then
		self._listener = {}
	end
	if listener == nil then
		cclog("error addEventListener:"..message)
		return false
	end
	self._listener[message] = listener

	if relase ~= nil then
		if self._realse == nil then
			self._realse = {}
		end
		self._realse[message] = relase
	end
end
function NetLayer.dealMessage()
	if ff.net._listener == nil then
		ff.net._listener = {}
	end	
	if ff.net._pause == true then
		return
	end		

	if dd.netbroke == true then
        if dd.gameInBack == false then            	
        	dd.netbroke = false
            platform_showDialog(ff.langString("网络连接错误"),ff.langString("网络连接中断！"),2,0)
        end
    end


 	while true do


		local message = ff.net:getMessage()
		if message == nil then
			return
		end	
		local cmd = message:getCmd()
		if ff.net._callQue ~= nil then
			ff.net._callQue[cmd] = 0
		end

		cclog("dealMessage:"..cmd)
		if ff.net._listener[cmd] == nil then
			cclog("error:有未注册的消息或注册函数已经被释放:"..cmd)
			message:clear()
		else
			local result = ff.net._listener[cmd](message)
			if ff.net._callback ~= nil then
				if ff.net._callback[cmd] ~= nil then
					local callbacks = ff.net._callback[cmd]
					for key, value in pairs(callbacks) do
						if value ~= nil then
                            cclog("callBack:"..cmd..' '..tostring(value)..",key:"..key) 
							value(result)
						end					    
					end 					
				end	
			end	
			if result ~= nil then
				if ff.net._realse ~= nil and ff.net._realse[cmd] ~= nil then
					--有注册释放，则提交给释放函数处理
					ff.net._realse[cmd](result)
				end
			end
			if dd.watingLayer ~= nil and dd.watingLayer._cmd == cmd then
				dd.watingLayer:onClear()
			end
		end	
    end
end
function NetLayer:bindDelTable(tag,tableid,callBack)
	if self._delTable == nil then
		self._delTable = {}
	end
	if self._delTable[tableid] == nil then
		self._delTable[tableid] = {}
	end
	self._delTable[tableid][tag] = callBack		
end
function NetLayer:unbindDelTable(tag,tableid)
	if self._delTable ~= nil then
		if self._delTable[tableid] ~= nil then
			self._delTable[tableid][tag] = nil
		end
	end		
end

function NetLayer:bindProperty(tag,property,callBack)
	if self._property == nil then
		self._property = {}
	end
	if self._property[property] == nil then
		self._property[property] = {}
	end
	self._property[property][tag] = callBack		
end
function NetLayer.postProperty(event)
	local name = event:getEventName()
	if name ~= "property" then
		cclog("error customevent!!!!!!!!!!!!!!!!!!!!!")
	end	
	if ff.net == nil then
		return
	end	
	local param = event:getUserData()
	local value = Split(param,",")
	if table.getn(value) == 6 then
		local vtype = value[1]
		local name  = value[2]
		if ff.net._property ~= nil then
			if ff.net._property[name] ~= nil then
				for key, func in pairs(ff.net._property[name]) do
					if func ~= nil then
						if vtype == 1 then
							func(name,tonumber(value[3]),tonumber(value[4]),tonumber(value[5]),tonumber(value[6]))
						else	
							func(name,tonumber(value[3]),value[4],value[5],tonumber(value[6]))
						end	
					end					    
				end 					
			end
		end		
	elseif table.getn(value) == 3 then	
		local vtype    = tonumber(value[1])
		local tableid  = tonumber(value[2])
		local key      = tonumber(value[3])
		if ff.net._delTable[tableid] ~= nil then
			for tag, func in pairs(ff.net._delTable[tableid]) do
				if func ~= nil then
					func(tableid,key)
				end					    
			end 					
		end	
	end	
end
function NetLayer:unbindProperty(property,tag)
	if self._property ~= nil then
		if self._property[property] ~= nil then
			self._property[property][tag] = nil
		end
	end		
end

function NetLayer:pause()
	cclog("暂停接收消息")
	self._pause = true
end
function NetLayer:resume()
	cclog("开始接收消息")
	self._pause = false
end
function NetLayer:startMessages(session)
	cclog("开始接收消息...........")
	if self._id ~= 0 then
		cc.Director:getInstance():getScheduler():unscheduleScriptEntry(self._id)
	end	
	self:session(session)
	self._pause = false
	self._id    = cc.Director:getInstance():getScheduler():scheduleScriptFunc(self.dealMessage, 0.01, false)
end
function NetLayer:setSession(session)
	cclog("setSession")
	self:session(session)
end
function NetLayer:addCmd(message,cmd)
    message:addCmd(cmd)
end
function NetLayer:createMessage(cmd)
	local message = nil
	message = ff.tjfMessage:create()
	if cmd ~= nil then
		self:addCmd(message,cmd)
	end	
	return message
end
function NetLayer:rpc(message,mask,sender)
	local waiting = getWating(sender)
	if sender == nil then
		waiting:onSize(cc.size(ff.width,ff.height))
	else
		local size = sender:getContentSize()
		waiting:onSize(size)
	end	
	if mask == nil then
		waiting:onMask(true)
	else
		waiting:onMask(mask)
	end	
	waiting:onPlay(message:getCmd())

	if self._callQue == nil then
		self._callQue = {}
	end
	ff.net:postMessage(message)
end


function createNet()	
	--rpc调用超时20秒，同步消息超时2秒
    local net = NetLayer.extend(ff.tjfNetbase:create(20,2))
	if net ~= nil then
		cclog(ff.addr..":"..ff.port)
		net:star(ff.addr,ff.port,0,true)
	end	
	local eventDispatcher = cc.Director:getInstance():getEventDispatcher()
	if eventDispatcher == nil then
		cclog("error")
	end	
    local event = cc.EventListenerCustom:create("property",net.postProperty)
    eventDispatcher:addEventListenerWithFixedPriority(event, 1)
	return net
end
function clearNet()
	if ff.net ~= nil then
		local eventDispatcher = cc.Director:getInstance():getEventDispatcher()
		if eventDispatcher ~= nil and ff.net._event ~= nil then
			eventDispatcher:removeEventListener(ff.net._event)
		end	

		ff.net._pause = true
		cc.Director:getInstance():getScheduler():unscheduleScriptEntry(ff.net._id)
		ff.tjfNetbase:close(true)
		ff.net = nil
	end
end