--平台相关的函数放这里
function platform_framChange()
    local glview = cc.Director:getInstance():getOpenGLView()
    if glview ~= nil then
        cc.Director:getInstance():getOpenGLView():setDesignResolutionSize(ff.width,ff.height,2)
        cclog("ff.width1:"..ff.width..","..ff.height)
    end
end


--设置一些初始变量
function platform_initGame(size)
    if cc.PLATFORM_OS_IPHONE == cc.Application:getInstance():getTargetPlatform() or cc.PLATFORM_OS_IPAD == cc.Application:getInstance():getTargetPlatform() then
        local ver = tonumber(ff.iosCore:getLuaBaseVersion())
        local version = cc.UserDefault:getInstance():getIntegerForKey("version")
        cclog("ver:"..ver..","..version)
        if ver > version then
            version = ver
            cc.UserDefault:getInstance():setIntegerForKey("version",version)
        end
        ff.apk_version_name = ff.iosCore:getAppVersion()
        cclog("apk_version:"..ff.apk_version_name)
    else 
        --初始化版本
        if cc.UserDefault:getInstance():getIntegerForKey("version") < 1000 then
            --获取apk版本号
            if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
                local args = {}
                local sigs = "()I"
                local luaj = require "luaj"
                local className = "org/cocos2dx/lib/Cocos2dxHelper"
                local ok,ret = luaj.callStaticMethod(className,"getVersionCode",args,sigs)
                if ok == true then
                    cc.UserDefault:getInstance():setIntegerForKey("apk_version",ret)
                else
                    cclog("getVersionCode error")       
                end             
            elseif cc.PLATFORM_OS_IPHONE == cc.Application:getInstance():getTargetPlatform() or cc.PLATFORM_OS_IPAD == cc.Application:getInstance():getTargetPlatform() then
                            
            else
                cc.UserDefault:getInstance():setIntegerForKey("version","1000")     
            end 
        end
        cclog("apk_version:"..cc.UserDefault:getInstance():getIntegerForKey("apk_version"))
    end        

    cclog("version:"..cc.UserDefault:getInstance():getIntegerForKey("version"))
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        local args = {}
        local sigs = "()Ljava/lang/String;"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"
        local ok,ret = luaj.callStaticMethod(className,"getVersionName",args,sigs)
        if ok == true then
            cclog("ret:"..ret)
            ff.apk_version = tonumber(ret)*1000
            ff.apk_version_name = ret
            cclog(ff.apk_version..","..ff.apk_version_name)
        end     
    end        


    --竖版游戏，以宽度为准
    ff.width  = ff.uiDesignWidth
    ff.height = math.ceil(size.height/(size.width/ff.width))

    ff.frame_width  = size.width
    ff.frame_height = size.height

    cclog("w:"..ff.width..",h:"..ff.height..",uiW:"..ff.uiWidth..",uiH:"..ff.uiHeight)
	if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then    
        --记录初始内存
        local args = {}
        local sigs = "()I"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"
        local ok,memory = luaj.callStaticMethod(className,"displayBriefMemory",args,sigs)
        if ok == true then
            cclog("memory:"..memory)
            ff.memory = memory
        end           
        --记录初始屏幕设计大小  
	    local args = {ff.width,ff.height}
	    local sigs = "(II)V"
	    local luaj = require "luaj"
	    local className = "org/cocos2dx/lib/Cocos2dxHelper"
	    luaj.callStaticMethod(className,"initGame",args,sigs)

        local args = {input.nextInput}
        local sigs = "(I)V"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"
        luaj.callStaticMethod(className,"setNextInputCallback",args,sigs)
	end
end

--添加输入框
--必然是最上层，所以只在需要的时候创建，并且在不用的时候立即去除
--(final int tag, final String content, final int pInputMode, final int pInputFlag, final int pReturnType, final int pMaxLength,final int x,final int y,final int w,final int h,final int fontsize,final int fontcolor)
--tag:唯一标识
--content:当前显示文字,默认是""
--mode:输入模式   0:多行，6单行 
--flag：0：密码输入 4：一般输入
--returntype：0
--maxlen：长度限制
--x:屏幕位置
--y:屏幕位置
--w:宽度
--h:高度
--fontsize：字体大小
--color:(int)字体颜色
--{40016,"",6,4,0,32, 210,260,500,30,40,0}


function platform_updateInputText(tag,clear)
    if tag == nil then
        tag = 0
    end
    if clear == nil then
        clear = 0
    end
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then    
        local args = {tag,clear}
        local sigs = "(II)Ljava/lang/String;"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"

        local ok,ret = luaj.callStaticMethod(className,"updateInputText",args,sigs)
        if ok == true then
            return tostring(ret)
        end
    end     
end
function platform_isInputVisable()
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then    
        local args = {}
        local sigs = "()I"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"

        local ok,ret = luaj.callStaticMethod(className,"isInputVisable",args,sigs)
        if ok == true then
            return ret
        end
    end     
end
function platform_clearInput()
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then    
        local args = {}
        local sigs = "()V"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"
        luaj.callStaticMethod(className,"clearInput",args,sigs)
    elseif cc.PLATFORM_OS_IPHONE == cc.Application:getInstance():getTargetPlatform() or cc.Application:getInstance():getTargetPlatform() == cc.PLATFORM_OS_IPAD then   
        ff.iosCore:clearInput()        
    end    
end

--删除指定输入框
function platform_clearInputText(tag)
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then    
        local args = { tag}
        local sigs = "(I)V"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"
        luaj.callStaticMethod(className,"clearInputText",args,sigs)
    end
    if cc.PLATFORM_OS_WINDOWS == cc.Application:getInstance():getTargetPlatform() then   
        if dd.currentLayer:getChildByTag(tag) ~= nil then
            dd.currentLayer:removeChildByTag(tag)
        end    
    end  
end
--删除所有输入框
function platform_clearAllInputText()

end
 
--设置输入框位置
function platform_setInputPosition(tag,x,y)
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        local args = {tag,x,y}
        local sigs = "(III)V"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"
        luaj.callStaticMethod(className,"setInputPosition",args,sigs)
    end 
end  

--设置允许的最大行数和行间距（写邮件，简介等地方）
function platform_setMultilinePro(lines,linespc)
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        local args = {lines,linespc}
        local sigs = "(II)V"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"
        luaj.callStaticMethod(className,"setMultilinePro",args,sigs)
    elseif cc.PLATFORM_OS_IPHONE == cc.Application:getInstance():getTargetPlatform() or cc.PLATFORM_OS_IPAD == cc.Application:getInstance():getTargetPlatform() then
        --ff.iosCore:setMultilinePro(lines,linespc)
    end 
end    
--设置输入框文本内容
function platform_setEditboxText(tag,text)
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        local args = {tag,text}
        local sigs = "(ILjava/lang/String;)V"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"
        luaj.callStaticMethod(className,"setEditboxText",args,sigs)
    end 
end

--开启或者关闭手机感应器
function platform_screenOriOn(on)
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        local args = {on}
        local sigs = "(I)V"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"
        luaj.callStaticMethod(className,"screenOriOn",args,sigs)
    end 
end
--指定感应器
function platform_screenType(type)
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        local args = {type}
        local sigs = "(I)V"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"
        luaj.callStaticMethod(className,"screenType",args,sigs)
    end 
end

--功能性函数，保存基本UI文字表
function platform_langTable()
    local tips = {}
    for k,v in pairs(pop.jsons) do
        cclog(pop.jsons[k][pop._index_tips])
        if tips[pop.jsons[k][pop._index_json]] == nil then
            tips[pop.jsons[k][pop._index_json]] = pop.jsons[k][pop._index_tips]     
        else
            tips[pop.jsons[k][pop._index_json]] = tips[pop.jsons[k][pop._index_json]]..","..pop.jsons[k][pop._index_tips]     
        end       
    end 

    local db = "lang_0"
    cclog("db table:"..db)
    ff.dbmanager:sql_query("delete from "..db)

    local nt = ff.NetTable:create()
    nt:addStreamCol("key",ff.NET_STRING)
    nt:addStreamCol("text",ff.NET_STRING,512)
    nt:addStreamCol("fontsize",ff.NET_LONG)
    nt:addStreamCol("json",ff.NET_STRING,256)
    nt:addStreamCol("tips",ff.NET_STRING,512)
    
    local texts = ff.gameCore:getLangBaseTable()
    if texts ~= nil then
        for i=1,texts:rowCount() do
            local file = Split(texts:getString(i,"file"),'/')
            local temp = file[table.getn(file)]
            local json = Split(temp,'%.')[1]
            cclog("tips:"..tips[json])
            local row = nt:addRow()
            nt:setString(row,"key",texts:getString(i,"key"))
            nt:setString(row,"text",texts:getString(i,"text"))
            nt:setLong(row,"fontsize",texts:getLong(i,"font"))
            nt:setString(row,"json",texts:getString(i,"file"))
            nt:setString(row,"tips",tips[json])
        end
    end
    ff.dbmanager:sql_nettable(nt,db)
    nt:clear()
end

function platform_showWaiting(arg1,arg2)
    local show = arg1
    local mask = 0
    if arg2 == nil then
        mask = 1
    else
        mask = arg2    
    end    
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        local args = {show,mask}
        local sigs = "(II)V"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"
        luaj.callStaticMethod(className,"showWaiting",args,sigs)
    elseif cc.PLATFORM_OS_IPHONE == cc.Application:getInstance():getTargetPlatform() or cc.PLATFORM_OS_IPAD == cc.Application:getInstance():getTargetPlatform() then
        local waiting = getWating()
        waiting:onSize(cc.size(ff.width,ff.height))
        if mask == 1 then
            waiting:onMask(true)
        else
            waiting:onMask(false)
        end 
        if show == 1 then
            waiting:onPlay()
        else
            waiting:onClear()
        end        
    end
end
--获得G+帐号
function platform_googleplay(type,callback)
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        local args = {type,callback}
        local sigs = "(II)V"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"
        luaj.callStaticMethod(className,"showGooglePlay",args,sigs)
        return true
    elseif cc.PLATFORM_OS_IPHONE == cc.Application:getInstance():getTargetPlatform() or cc.PLATFORM_OS_IPAD == cc.Application:getInstance():getTargetPlatform() then
        ff.iosCore:showSNSAccount(type)
        return true
    else
        return false    
    end
end


function platform_setVersion_Gdx(version)
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        local args = {version}
        local sigs = "(Ljava/lang/String;)V"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"
        luaj.callStaticMethod(className,"setVersion",args,sigs)
    elseif cc.PLATFORM_OS_IPHONE == cc.Application:getInstance():getTargetPlatform() or cc.Application:getInstance():getTargetPlatform() == cc.PLATFORM_OS_IPAD then   
        if ff.loadingLayer ~= nil then
            ff.loadingLayer:getChildByName("version"):setString(version)
        end    
    end
end
function platform_restart()
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        local args = {}
        local sigs = "()V"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"
        luaj.callStaticMethod(className,"restartGame",args,sigs)
    elseif ff.platform == 1 then
        cclog("platform_restart.............")
        if dd.mainUI ~= nil then
            dd.mainUI:getChildByName("mask"):setVisible(true)
            performWithDelay(dd.mainUI,dd.GameReStart, 0.03)
        else
            dd.GameReStart()
        end
    end    
end

--platform_showDialog(ff.langString("退出游戏"),ff.langString("确定要现在退出游戏吗？"),12,0)
--callback表示回调函数
--code%10==1 and callback == nil重启游戏
--code%10==2 and callback == nil退出游戏
--code>3出现取消按钮


function platform_showDialog(title,str,code,callback)
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        local args = {title,str,code,callback}
        local sigs = "(Ljava/lang/String;Ljava/lang/String;II)V"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"
        luaj.callStaticMethod(className,"showAndroidDialog",args,sigs)
    elseif cc.PLATFORM_OS_IPHONE == cc.Application:getInstance():getTargetPlatform() or cc.PLATFORM_OS_IPAD == cc.Application:getInstance():getTargetPlatform() then
        ff.iosCore:showDialog(title,str,code)
    end    
end

function platform_setLang(lang)
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        local args = {lang}
        local sigs = "(I)V"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"
        luaj.callStaticMethod(className,"setLang",args,sigs)
    end    
end

function platform_addNotification(message,delay)
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        local args = {message,delay}
        local sigs = "(Ljava/lang/String;I)V"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"
        luaj.callStaticMethod(className,"sendNotification",args,sigs)
    elseif cc.PLATFORM_OS_IPHONE == cc.Application:getInstance():getTargetPlatform() or cc.PLATFORM_OS_IPAD == cc.Application:getInstance():getTargetPlatform() then
        local params = Split(message,'~')
        if params ~= nil and table.getn(params) == 2 then
            cclog("add notice")
            ff.iosCore:addNotification(tonumber(params[1]),delay,params[2])    
        end
    end  
end
function platform_clearNotificationAlarm()
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        local args = {}
        local sigs = "()V"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"
        luaj.callStaticMethod(className,"clearNotificationAlarm",args,sigs)
    elseif cc.PLATFORM_OS_IPHONE == cc.Application:getInstance():getTargetPlatform() or cc.PLATFORM_OS_IPAD == cc.Application:getInstance():getTargetPlatform() then
        ff.iosCore:clearNotifications()    
    end  
end

function platform_showLoadingBar(show)
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        local args = {show}
        local sigs = "(I)V"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"
        luaj.callStaticMethod(className,"showLoadingBar",args,sigs)        
    --elseif cc.PLATFORM_OS_IPHONE == cc.Application:getInstance():getTargetPlatform() or cc.PLATFORM_OS_IPAD == cc.Application:getInstance():getTargetPlatform() then
    --    ff.iosCore:showLoading(show)
    end       
end
function platform_setLoadingBarTip2(tips)
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        local args = {tips}
        local sigs = "(Ljava/lang/String;)V"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"
        luaj.callStaticMethod(className,"setLoadingBarTip2",args,sigs)
    end    
end

function platform_setLoadingBarTip(tips)
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        local args = {tips}
        local sigs = "(Ljava/lang/String;)V"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"
        luaj.callStaticMethod(className,"setLoadingBarTip",args,sigs)
    --elseif cc.PLATFORM_OS_IPHONE == cc.Application:getInstance():getTargetPlatform() or cc.PLATFORM_OS_IPAD == cc.Application:getInstance():getTargetPlatform() then
    --    ff.iosCore:setLoadingTips(tips)  
    end    
end
function platform_setLoadingBarTipColor(color)
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        local args = {color}
        local sigs = "(I)V"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"
        luaj.callStaticMethod(className,"setLoadingBarTipColor",args,sigs)
    --elseif cc.PLATFORM_OS_IPHONE == cc.Application:getInstance():getTargetPlatform() or cc.PLATFORM_OS_IPAD == cc.Application:getInstance():getTargetPlatform() then
    --    ff.iosCore:setLoadingTipsColor(1)          
    end    
end
function platform_setLoadingBarPercent(percent)
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        local args = {percent}
        local sigs = "(I)V"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"
        luaj.callStaticMethod(className,"setLoadingBarPercent",args,sigs)
    --elseif cc.PLATFORM_OS_IPHONE == cc.Application:getInstance():getTargetPlatform() or cc.PLATFORM_OS_IPAD == cc.Application:getInstance():getTargetPlatform() then
    --    ff.iosCore:setLoading(percent)
    end    
end

function platform_getLastError()
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        local args = {percent}
        local sigs = "()Ljava/lang/String;"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"

        local ok,ret = luaj.callStaticMethod(className,"getError",args,sigs)
        if ok == true then
            if string.len(ret) > 1 then
                local message = ff.net:createMessage()
                message:addCmd(0x00000168)
                message:addLong(dd.uid)
                message:addLong(cc.UserDefault:getInstance():getIntegerForKey("testacount"))
                message:addLong(cc.UserDefault:getInstance():getIntegerForKey("dbversion"))
                message:addLong(cc.UserDefault:getInstance():getIntegerForKey("version"))
                message:addLong(ff.set_power)
                message:addLong(cc.Application:getInstance():getTargetPlatform())
                message:addLong(0)
                message:addLong(0)
                message:addLong(0)
                message:addString(ret,512)
                ff.net:postMessage(message)     
            end
        end
    end      
end
function platform_showServers()
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        local args = {}
        local sigs = "()Ljava/lang/String;"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"

        local ok,ret = luaj.callStaticMethod(className,"showServers",args,sigs)
        if ok == true then
            if ret == "ok" then
                return true
            else
                return false
            end
        end
    elseif cc.PLATFORM_OS_IPHONE == cc.Application:getInstance():getTargetPlatform() or cc.PLATFORM_OS_IPAD == cc.Application:getInstance():getTargetPlatform() then     
        local ver = tonumber(ff.iosCore:showServers())
        if ver > 0 then
            return true
        else
            return false
        end
    else
        return false
    end    
end
function platform_showGooglePlayGame(callback)
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        if ff.apk_version > 1220 then
            --local args = {callback,ff.langString("游戏登录"),ff.langString("新游戏"),ff.langString("已经拥有帐号"),ff.langString("自动开始新游戏")}
            local args = {callback,"Login","New Game","Binded G+ Account","Start new game in"}
            local sigs = "(ILjava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)V"
            local luaj = require "luaj"
            local className = "org/cocos2dx/lib/Cocos2dxHelper"
            luaj.callStaticMethod(className,"showGooglePlayGame",args,sigs)
        end
    end    
end

function platform_isConnectGPG()
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        local args = {}
        local sigs = "()Ljava/lang/String;"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"
        local ok,ret = luaj.callStaticMethod(className,"isConnectGPG",args,sigs)
        if ok == true then
            if ret == "ok" then
                return true
            else
                return false
            end
        end
    end    
end


function platform_showAH()
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        local args = {}
        local sigs = "()V"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"
        luaj.callStaticMethod(className,"showGPGAH",args,sigs)
    end    
end
function platform_showRank()
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        local args = {}
        local sigs = "()V"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"
        luaj.callStaticMethod(className,"showGPGRank",args,sigs)
    end    
end
function platform_submitScore(score)
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        local args = {score}
        local sigs = "(I)V"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"
        luaj.callStaticMethod(className,"submitScore",args,sigs)
    end    
end
function platform_unlockAchievement(id)
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        local args = {id}
        local sigs = "(Ljava/lang/String;)V"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"
        luaj.callStaticMethod(className,"unlockAchievement",args,sigs)
    end    
end

function platform_showGame()    
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        ff.showbar = false
        local args = {}
        local sigs = "()V"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"
        luaj.callStaticMethod(className,"showGame",args,sigs)
    end    
end

function platform_showServerList(type,tip)
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        local args = {type,tip}
        local sigs = "(ILjava/lang/String;)V"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"
        luaj.callStaticMethod(className,"showServersList",args,sigs)
    end    
end


function platform_registerCallBack(callback)
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        local args = {callback}
        local sigs = "(I)V"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"
        luaj.callStaticMethod(className,"registerCallbackServers",args,sigs)
    end    
end

function platform_registerPrivacyCallBack(callback)
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        local args = {callback}
        local sigs = "(I)V"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"
        luaj.callStaticMethod(className,"registerCallbackPrivacy",args,sigs)
    end    
end

-- 版本更新等的内容发送
function platform_showWeihuText(content,color)
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        local args = {content,color}
        local sigs = "(Ljava/lang/String;Ljava/lang/String;)V"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"
        luaj.callStaticMethod(className,"showWeihuText",args,sigs)
    elseif cc.PLATFORM_OS_IPHONE == cc.Application:getInstance():getTargetPlatform() or cc.PLATFORM_OS_IPAD == cc.Application:getInstance():getTargetPlatform() then     
        platform_showDialog("Server maintenance",content,1,0)
    end    
end
function platform_showWeihu()
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        local args = {}
        local sigs = "()V"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"
        luaj.callStaticMethod(className,"showWeihu",args,sigs)
    end    
end
-- 全局配置变量保存 -- 目前只有android实现方法
function platform_saveSettingCount(key,value)
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        local args = {key,value}
        local sigs = "(Ljava/lang/String;Ljava/lang/String;)V"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"
        luaj.callStaticMethod(className,"saveSettingCount",args,sigs)
    end 
end

-- 全局配置变量获取 -- 目前只有android实现方法
function platform_getSettingCount(key,default_value)
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        local args = {key,value}
        local sigs = "(Ljava/lang/String;Ljava/lang/String;)Ljava/lang/String;"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"
        local ok,ret = luaj.callStaticMethod(className,"getSettingCount",args,sigs)
        if ok == true then
           return ret
        else
           return default_value
        end
    end 
end

-- 事件记录接口
function platform_taskFinish(taskid,level)
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        local args = {taskid,level}
        local sigs = "(Ljava/lang/String;I)V"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"
        luaj.callStaticMethod(className,"taskFinish",args,sigs)
    elseif cc.PLATFORM_OS_IPHONE == cc.Application:getInstance():getTargetPlatform() or cc.Application:getInstance():getTargetPlatform() == cc.PLATFORM_OS_IPAD then   
        ff.iosCore:CountlyRecord(taskid,level)
    end 
end

function platform_pay(item,gold)
    cclog("item:"..item)
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        local args = {item,gold}
        local sigs = "(Ljava/lang/String;Ljava/lang/String;)V"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"
        luaj.callStaticMethod(className,"payBuy",args,sigs)
    elseif cc.PLATFORM_OS_IPHONE == cc.Application:getInstance():getTargetPlatform() or cc.Application:getInstance():getTargetPlatform() == cc.PLATFORM_OS_IPAD then   
        ff.iosCore:buyItem(item,gold)     
    end     
end
function platform_consumItems(str)
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        local args = {str}
        local sigs = "(Ljava/lang/String;)V"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"
        luaj.callStaticMethod(className,"payFinish",args,sigs)
    end
end
function platform_initPay(call,str)
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        local args = {call,str}
        local sigs = "(ILjava/lang/String;)V"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"
        luaj.callStaticMethod(className,"initPay",args,sigs)
    elseif cc.PLATFORM_OS_IPHONE == cc.Application:getInstance():getTargetPlatform() or cc.Application:getInstance():getTargetPlatform() == cc.PLATFORM_OS_IPAD then   
        ff.iosCore:initPay(str)     
    end
end
function platform_laterPay()
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        local args = {}
        local sigs = "()V"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"
        luaj.callStaticMethod(className,"laterPay",args,sigs)
    end     
end
--7级后评星级之后调用此接口
function platform_gameStar(star)
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        if tonumber(star) < 5 then
            platform_feedback()
        else
            local args = {star}
            local sigs = "(I)V"
            local luaj = require "luaj"
            local className = "org/cocos2dx/lib/Cocos2dxHelper"
            luaj.callStaticMethod(className,"showStar",args,sigs)
        end
    end    
end
function platform_initUser(uid)
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        local args = {uid,ff.serverid,ff.lang}
        local sigs = "(III)V"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"
        luaj.callStaticMethod(className,"initUser",args,sigs)
    end
end
function platform_showFull()
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        local args = {uid,ff.serverid,ff.lang}
        local sigs = "()V"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"
        luaj.callStaticMethod(className,"showFullS",args,sigs)
    end    
end
function platform_feedback() 
    print("platform_feedback")
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        local name = "None"
        if dd.myinfo ~= nil and dd.myinfo:rowCount() == 1 then
            name = dd.myinfo:getString(1,"name")
        end
        local args = {ff.serverid,dd.uid,name}
        local sigs = "(IILjava/lang/String;)V"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"
        luaj.callStaticMethod(className,"showFeedBack",args,sigs)
    elseif cc.PLATFORM_OS_IPHONE == cc.Application:getInstance():getTargetPlatform() or cc.Application:getInstance():getTargetPlatform() == cc.PLATFORM_OS_IPAD then   
        ff.iosCore:feedback(ff.serverid,dd.uid,cc.UserDefault:getInstance():getIntegerForKey("version"))        
    end    
end
function platform_goMarket()
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        platform_gameStar(5)
    end    
end
function platform_openUrl(url)
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        local args = {url}
        local sigs = "(Ljava/lang/String;)V"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"
        luaj.callStaticMethod(className,"openUrl",args,sigs)
    elseif cc.PLATFORM_OS_IPHONE == cc.Application:getInstance():getTargetPlatform() or cc.Application:getInstance():getTargetPlatform() == cc.PLATFORM_OS_IPAD then   
        ff.iosCore:openUrl(url)        
    end  
end

function platform_loginFB(callback)
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        local args = {callback}
        local sigs = "(I)V"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"
        luaj.callStaticMethod(className,"loginFaceBook",args,sigs)
    end  
end
function platform_queryFacebook()
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        local args = {}
        local sigs = "()Ljava/lang/String;"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"
        local ok,ret = luaj.callStaticMethod(className,"queryFacebook",args,sigs)
        if ok == true then
            if ret == "ok" then
                return true
            else
                return false
            end
        else
           return false
        end
    end 
end
function platform_queryFriends(callback)
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        local args = {callback}
        local sigs = "(I)V"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"
        luaj.callStaticMethod(className,"queryFriends",args,sigs)
    end  
end
function platform_facebookLink(ids,message,open)
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        local read = 1
        if open == false then
            read = 0
        end
        local args = {ids,message,read}
        local sigs = "(Ljava/lang/String;Ljava/lang/String;I)V"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"
        luaj.callStaticMethod(className,"facebookLink",args,sigs)
    end  
end
function platform_setClipBoard(str)
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        local args = {str}
        local sigs = "(Ljava/lang/String;)V"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"
        luaj.callStaticMethod(className,"setClipBoard",args,sigs)
    end      
end
--在进入游戏前打开
function platform_openUrlBox(title,message,url,label1,label2,lua)
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        local args = {title,message,url,label1,label2,lua}
        local sigs = "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;I)V"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"
        luaj.callStaticMethod(className,"showUrlDialog",args,sigs)
    end 
end
function platform_getCountryCode()
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        local args = {}
        local sigs = "()Ljava/lang/String;"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"

        local ok,ret = luaj.callStaticMethod(className,"GetCountryZipCode",args,sigs)
        if ok == true then
            return tostring(ret)
        end
    end 
    return dd.languageCode[ff.lang + 1]
end

function platform_getCurrentLanguage()
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        local args = {}
        local sigs = "()Ljava/lang/String;"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"

        local ok,ret = luaj.callStaticMethod(className,"getCurrentLanguage",args,sigs)
        if ok == true then
            return tostring(ret)
        end
    end
    return dd.languageCode[ff.lang + 1]
end

function platform_helpShift(type,id)
    cclog("platform_helpShift")
    if id == nil then
        id = ""
    end
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        local args = {type,id}
        local sigs = "(ILjava/lang/String;)V"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"
        luaj.callStaticMethod(className,"showHelpShift",args,sigs)
    elseif cc.PLATFORM_OS_IPHONE == cc.Application:getInstance():getTargetPlatform() or cc.Application:getInstance():getTargetPlatform() == cc.PLATFORM_OS_IPAD then   
        ff.iosCore:showHelpShift(type,id)
    end      
end

function platform_doPost(server,url)
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        local args = {server,url}
        local sigs = "(Ljava/lang/String;Ljava/lang/String;)Ljava/lang/String;"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"
        local ok,ret = luaj.callStaticMethod(className,"getPost",args,sigs)
        if ok == true then
            return ret
        else
            return "init net error"
        end
    else    
        return "init net error"
    end
end

function platform_setIconTag(count)
    if cc.PLATFORM_OS_IPHONE == cc.Application:getInstance():getTargetPlatform() or cc.Application:getInstance():getTargetPlatform() == cc.PLATFORM_OS_IPAD then   
        ff.iosCore:setIconTag(count)    
    end      
end

function platform_joinPush(lua)
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then
        local pushkey = cc.UserDefault:getInstance():getStringForKey("push","")
        if string.len(pushkey) > 16 then
            hif.onPush(pushkey)
        end
        local args = {lua}
        local sigs = "(I)V"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"
        luaj.callStaticMethod(className,"joinPush",args,sigs)
    elseif cc.PLATFORM_OS_IPHONE == cc.Application:getInstance():getTargetPlatform() or cc.Application:getInstance():getTargetPlatform() == cc.PLATFORM_OS_IPAD then   
        local token = ff.iosCore:getDeviceToken()
        if string.len(token) > 16 then
            hif.onPush(token)
        end
    end
end


--新接口
function platform_getPrice()
    if cc.PLATFORM_OS_ANDROID == cc.Application:getInstance():getTargetPlatform() then    
        local args = {}
        local sigs = "()Ljava/lang/String;"
        local luaj = require "luaj"
        local className = "org/cocos2dx/lib/Cocos2dxHelper"

        local ok,ret = luaj.callStaticMethod(className,"getPrice",args,sigs)
        if ok == true then
            return tostring(ret)
        end
    end    
    return "" 
end