local pveLayer    = class("pveLayer")
pveLayer._name    = "pve"
pveLayer._widget  = nil
pveLayer._scroll  = nil
pveLayer._map     = nil
pveLayer._pos     = nil
pveLayer._mods    = nil
pveLayer._path    = nil
pveLayer._enemy   = {}
pveLayer.spr      = {}
pveLayer.tempdata = {}
pveLayer._init    = false

pveLayer.zmoblemoveinfo = {}
pveLayer.animation = {}
pveLayer.timedelte = 0

function pveLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, pveLayer)
    return target
end
function pveLayer:initUI()
	self._widget = addCityUI(self)	

end

function pveLayer:initBattle()
    local scroll = ccui.fatalityScrollView:create()
    scroll:setBackGroundColorType(ccui.LayoutBackGroundColorType.none)
    scroll:setBounceEnabled(false)
    scroll:setDirection(ccui.ScrollViewDir.both)
    self._scroll = scroll
    
    local maplayer=cc.Sprite:create("images/pve/back.png")
    maplayer:setContentSize(cc.size(1000, 2000))

    self._maplayer = maplayer
    maplayer:setAnchorPoint(cc.p(0.5,0.5))


    scroll:getInnerContainer():addChild(maplayer)
    scroll:setInnerContainerSize(cc.size(1000, 2000))

    
    scroll:setZoom(0.9,1.0,0.85,1.2)
    self._map = maplayer

    local function initUI()        
        self:initUI()
    end
    performWithDelay(self, initUI, 0.5)
	

    self:addChild(scroll,0,11)
    scroll:setContentSize(self._widget:getChildByName("mapArea"):getContentSize())
    scroll:setPosition(cc.p(0,self._widget:getChildByName("mapArea"):getPositionY()))

    cc.SpriteFrameCache:getInstance():addSpriteFrames("images/pve/pve_1.plist")
    cc.SpriteFrameCache:getInstance():addSpriteFrames("images/pve/pve_5.plist")
    cc.SpriteFrameCache:getInstance():addSpriteFrames("images/pve/pve_2.plist")
    cc.SpriteFrameCache:getInstance():addSpriteFrames("images/pve/pve_3.plist")
    cc.SpriteFrameCache:getInstance():addSpriteFrames("images/pve/pve_4.plist")
    

end

function pveLayer:updateZombie(row)
    cclog("row:"..row)
    self._map:getChildByTag(row):setVisible(false)
    self._map:getChildByTag(row):stopAllActions()
    self._map:getChildByTag(row):removeFromParent(true)
    cclog("here....................................1")
    for i = 1, dd.myZombie:rowCount() do
		if dd.myZombie:getLong(i,"id") == row then
            cclog("here....................................2")
            local id = dd.myZombie:getLong(i,"id")
            self._pos[tostring(self.zmoblemoveinfo[id]["pos"])]["use"] = 0

			local pos = self:addZombie(i)
            if pos[1] ~= 0 and pos[2] ~= nil then
                dd.myZombie:setLong(i,"pos",pos[1])
                self.spr[id] = pos[2]
                pos[2].idx = id
                self.zmoblemoveinfo[id] = {}
                self.zmoblemoveinfo[id]["canmove"] = true
                self.zmoblemoveinfo[id]["count"] = 0
                self.zmoblemoveinfo[id]["pos"] = pos[1]
                dd.myZombie:setLong(i,"state",1)
                schedule(self.spr[id], function (sender)self:updateMove(sender) end, 5)
            else
                dd.myZombie:setLong(i,"state",0)
            end
			
        end
    end
end

function pveLayer:getDis(pos, r, pos2)
    if r == 0 then
        return pos2
    end

    local new = nil
    while (true) do
       local rr = math.random()*r
       local ra = math.random()*360
       ra = ra*math.pi/180
       local dx = rr*math.sin(ra)
       local dy = rr*math.cos(ra)
       new = cc.p(pos.x - dx, pos.y - dy)
       if pos2.x ~= new.x or pos2.y ~= new.y then
           return new
       end
    end
end 

function pveLayer:test()
    effect = cc.Sprite:create("images/pve/walk/nut 1_00.png")
    effect:setPosition(100, 100)
    self._map:addChild(effect) 
    local idx = 0
    local str = "walk/walk 1_0"
    local callfss = cc.CallFunc:create( 
        function () 
                effect:setTexture("images/pve/"..str..idx..".png")
                idx=idx+1
                if idx >= 8 then
                    if str == "walk/nut 1_0" then
                        str = "walk1/nut 2_0"
                    else
                        str = "walk/nut 1_0"
                    end
                    idx = 0
                end
        end)
    local delay = cc.DelayTime:create(0.1)
    effect:runAction(cc.RepeatForever:create(cc.Sequence:create(delay, callfss, nil)))
end

function pveLayer:addZombie(num)	
    local info = dd.myZombie:getLong(num,"info")
    local pos = 0
    cclog("id:"..dd.myZombie:getLong(num,"id"))
    if dd.myZombie:getLong(num,"id") == 6 and GuideControl.curId == 2010 and self._pos[tostring(8)]["use"] == 0 then
        pos = 8
        self._pos[tostring(pos)]["use"] = 1
    elseif dd.myZombie:getLong(num,"id") == 7 and GuideControl.curId == 2010 and self._pos[tostring(20)]["use"] == 0 then
        pos = 20
        self._pos[tostring(pos)]["use"] = 1
    elseif dd.myZombie:getLong(num,"id") == 8 and GuideControl.curId == 2010 and self._pos[tostring(2)]["use"] == 0 then
        pos = 2
        self._pos[tostring(pos)]["use"] = 1
    else
    	
        cclog("addZombie  " .. num)
        local i = 0
        local _type__ = dd.myZombie:getLong(num, "info")

        while i < 50 do
            if _type__ == 1 or _type__ == 2 or _type__ == 3 or _type__ == 4 then
                pos = math.random(self._pos.len/2+1, self._pos.len)
            else
                pos = math.random(self._pos.len/2)
            end
            if self._pos[tostring(pos)]["use"] == 0 then
                cclog("zombiestartpos..."..pos)
    			self._pos[tostring(pos)]["use"] = 1
    			break
            else
                pos = 0
    		end
            i = i + 1
        end
        if _type__ == 1 or _type__ == 2 or _type__ == 3 or _type__ == 4 then
            if pos == 0 then
                for i=self._pos.len/2+1, self._pos.len do 
                    if self._pos[tostring(i)]["use"] == 0 then
                        cclog("zombiestartpos..."..pos)
    			        self._pos[tostring(i)]["use"] = 1
                        pos = i
    			        break
                    end
                end
            end
        end

        if pos == 0 then
            for i, v in pairs(self._pos) do
                if type(v) == 'table' then
                    if v["use"] == 0 then
                        cclog("zombiestartpos..."..pos)
    			        v["use"] = 1
                        pos = tonumber(i)
    			        break
                    end
                end
            end
        end
    end    

    if info > 5 then
        info = 1
    end

    local effect = nil
	if pos > 0 then
        local animFrames = {}
        for j = 1, 8 do
            local frame = cc.SpriteFrameCache:getInstance():getSpriteFrame(info.."_1_1_"..j..".png")
            animFrames[j] = frame
        end

        local tick = math.random(100)
        local animation = cc.Animation:createWithSpriteFrames(animFrames, 100/(800-tick))

	    effect = dd.newSpriteFromUI("public/alpha.png")
	    effect:setAnchorPoint(cc.p(0.5,0.5))
	    effect:setTag(dd.myZombie:getLong(num,"id"))

        cclog("add id:"..dd.myZombie:getLong(num,"id"))

	    effect:setPosition(cc.p(self._pos[tostring(pos)]['x'],self._pos[tostring(pos)]['y']))
        self._pos[tostring(pos)]["use"] = 1
        effect:runAction(cc.RepeatForever:create(cc.Animate:create(animation)))	
        effect:setOpacity(0) 
        effect:runAction(cc.FadeIn:create(1))
        self._map:addChild(effect) 
        
       
        local level = dd.myZombie:getLong(num,"level");

        local node = cc.Node:create()
        node:setPosition(cc.p(70, 50))
        node:setTag(10)

        local stars = dd.myZombie:getLong(num,"star")
        local bg  = nil
        if stars < 4 then
            bg = cc.Sprite:create("images/pve/zombieLevel/levelBG1.png")
        else
            bg = cc.Sprite:create("images/pve/zombieLevel/levelBG.png")
        end
        node:addChild(bg)

        local Lvlabel = cc.Sprite:create("images/pve/zombieLevel/number_Lv.png")
        Lvlabel:setPosition(cc.p(-15, 0))
        node:addChild(Lvlabel, 1)
        
        if level < 10 then
            local sp1 = cc.Sprite:create("images/pve/zombieLevel/number_"..level..".png")
            sp1:setPosition(cc.p( 0, 0));
            node:addChild(sp1, 1)
        elseif level < 100 then
            local sp1 = cc.Sprite:create("images/pve/zombieLevel/number_"..(level % 10)..".png")
            sp1:setPosition(cc.p( 10, 0));
            node:addChild(sp1, 1)

            local sp2 = cc.Sprite:create("images/pve/zombieLevel/number_"..math.floor(level / 10)..".png")
            sp2:setPosition(cc.p( 0, 0));
            node:addChild(sp2, 1)
         else
            local sp1 = cc.Sprite:create("images/pve/zombieLevel/number_"..(level % 10)..".png")
            sp1:setPosition(cc.p( 20, 0));
            node:addChild(sp1, 1)
            local sp2 = cc.Sprite:create("images/pve/zombieLevel/number_".. math.floor((level%100) / 10) ..".png")
            sp2:setPosition(cc.p( 10, 0));
            node:addChild(sp2, 1)
            local sp3 = cc.Sprite:create("images/pve/zombieLevel/number_"..math.floor(level / 100)..".png")
            sp3:setPosition(cc.p( 0, 0));
            node:addChild(sp3, 1)
        end
        

        effect:addChild(node)
       
        if math.random(100) > 50 then
            effect:setScaleX(-1)
            node:setScaleX(-1)
        end
	end
	return {pos, effect}
end

function pveLayer:getDir(pos1, pos2)
    local pnt1x = pos1['x']
    local pnt1y = pos1['y']
    local pnt2x = pos2['x']
    local pnt2y = pos2['y']

    if pnt1x >= pnt2x and pnt1y >= pnt2y then

        return 1
    elseif pnt1x <= pnt2x and pnt1y >= pnt2y then

        return 2
    elseif pnt1x <= pnt2x and pnt1y <= pnt2y then

        return 3
    elseif pnt1x >= pnt2x and pnt1y <= pnt2y then
        return 4
    end
end

function pveLayer:getTowPosLegth(pos1, pos2)
    local pnt1x = pos1['x']
    local pnt1y = pos1['y']
    local pnt2x = pos2['x']
    local pnt2y = pos2['y']
    
    local legth = math.sqrt((pnt1x - pnt2x) * (pnt1x - pnt2x) + (pnt1y - pnt2y) * (pnt1y - pnt2y))
    return legth

end
function pveLayer:updateMove(sender)
    local ID = sender.idx
    local index = 0
    for i=1,dd.myZombie:rowCount() do
        if ID == dd.myZombie:getLong(i,"id") then
            index = i
            break
        end
    end
    local id = dd.myZombie:getLong(index,"id")
    local _type__ = dd.myZombie:getLong(index, "info")
    local state = dd.myZombie:getLong(index,"state")

   
   if state ~= 1 then
        sender:unscheduleUpdate()
        sender:stopAllActions()
        return
    end
    if _type__ == 1 or _type__ == 2 or _type__ == 3 or _type__ == 4 then 

        if self.zmoblemoveinfo ~= nil and self.zmoblemoveinfo[id] ~= nil and self.zmoblemoveinfo[id]["canmove"] then

            local nowpos = dd.myZombie:getLong(index, "pos")
            self.zmoblemoveinfo[id]["canmove"] = false

            local x, y = self.spr[id]:getPosition()

          
            
            if self.spr[id] ~= nil then
                local goalPos = self:getDis(self._pos[tostring(nowpos)], self._pos[tostring(nowpos)]['radius'], cc.p(x, y))
                if self._pos[tostring(nowpos)]['radius'] == 0 then
                    return
                end
                
                self.spr[id]:stopAllActions()
                self.spr[id]:setScaleX(1)
                self.spr[id]:getChildByTag(10):setScaleX(1)
                local dir = self:getDir({x=self.spr[id]:getPositionX(), y=self.spr[id]:getPositionY()}, goalPos)
                if dir <= 2 then
                    local animFrames = {}
                    for j = 1, 8 do
                        local frame = cc.SpriteFrameCache:getInstance():getSpriteFrame(_type__.."_2_1_"..j..".png")
                        animFrames[j] = frame
                    end 
                    self.spr[id]:runAction(cc.RepeatForever:create(cc.Animate:create(cc.Animation:createWithSpriteFrames(animFrames, 100 /(800 - math.random(100))))))
                else
                    local animFrames = {}
                    for j = 1, 8 do
                        local frame = cc.SpriteFrameCache:getInstance():getSpriteFrame(_type__.."_2_2_"..j..".png")
                        animFrames[j] = frame
                    end 
                    self.spr[id]:runAction(cc.RepeatForever:create(cc.Animate:create(cc.Animation:createWithSpriteFrames(animFrames, 100 /(800 - math.random(100))))))
                end
                if dir == 2 or dir == 3 then
                    self.spr[id]:setScaleX(-1)
                    self.spr[id]:getChildByTag(10):setScaleX(-1)
                end

                
                local moveto = cc.MoveTo:create(self:getTowPosLegth({x=self.spr[id]:getPositionX(), y=self.spr[id]:getPositionY()}, goalPos) / 20, goalPos)
                local calback = cc.CallFunc:create(
                    function ()
                        
                        if self.spr[id] ~= nil then
                            self.spr[id]:stopAllActions()
                            
                            if dir <= 2 then
                                local animFrames = {}
                                for j = 1, 8 do
                                    local frame = cc.SpriteFrameCache:getInstance():getSpriteFrame(_type__.."_1_1_"..j..".png")
                                    animFrames[j] = frame
                                end 
                                self.spr[id]:runAction(cc.RepeatForever:create(cc.Animate:create(cc.Animation:createWithSpriteFrames(animFrames, 100 /(800 - math.random(100))))))
                            else
                                local animFrames = {}
                                for j = 1, 8 do
                                    local frame = cc.SpriteFrameCache:getInstance():getSpriteFrame(_type__.."_1_2_"..j..".png")
                                    animFrames[j] = frame
                                end 
                                self.spr[id]:runAction(cc.RepeatForever:create(cc.Animate:create(cc.Animation:createWithSpriteFrames(animFrames, 100 /(800 - math.random(100))))))
                            end
                            if dir == 2 or dir == 3 then
                                self.spr[id]:setScaleX(-1)
                                self.spr[id]:getChildByTag(10):setScaleX(-1)
                            end

                            local delaytime = 2
                            local action1 = cc.DelayTime:create(delaytime)

                            local callfss = cc.CallFunc:create( 
                                function () 
                                    self.zmoblemoveinfo[id]["canmove"] = true 
                                    schedule(self.spr[id], function (sender)self:updateMove(sender) end, 1)
                                end)
                            self.spr[id]:runAction(cc.Sequence:create(action1, callfss))
                        end
                    end)
                local action3 = cc.Sequence:create(moveto, calback)
            
                self.spr[id]:runAction(action3)
            end
        end
    end      
end
function pveLayer:update(sender)
	for i = 1, dd.myZombie:rowCount() do
		local state = dd.myZombie:getLong(i,"state")

		if state == 0 then
			local pos = self:addZombie(i)
            if pos[1] ~= 0 and pos[2] ~= nil then
    			dd.myZombie:setLong(i,"pos",pos[1])

                local id = dd.myZombie:getLong(i,"id")
                self.spr[id] = pos[2]
                pos[2].idx = id
                self.zmoblemoveinfo[id] = {}
                self.zmoblemoveinfo[id]["canmove"] = true

                self.zmoblemoveinfo[id]["count"] = 0
                self.zmoblemoveinfo[id]["pos"] = pos[1]
                dd.myZombie:setLong(i,"state",1)
                schedule(self.spr[id], function (sender)self:updateMove(sender) end, 5)
                return
            end
		end
	end
end
function pveLayer:showPve()
 
    function setZombieZoder(dt)
        if self.timedelte > 0.1 then
             for i,v in ipairs(self._map:getChildren()) do
                v:setLocalZOrder(3000 - v:getPositionY())
             end   
            self.timedelte = 0
        end
        self.timedelte = self.timedelte + dt
    end
    self:scheduleUpdateWithPriorityLua(setZombieZoder, 0)

	schedule(self, function (sender) self:update() end, 0.1)

    if dd.myZombie ~= nil and dd.myZombie:rowCount() > 0 and GuideControl.curId == 2010 then
        self._map:setPosition(500,1000)
        self._scroll:getInnerContainer():setPosition(cc.p(-500 + 360,-1000 + self._scroll:getContentSize().height/2))
        GuideControl:GuideCheck()
    end       
    
    local startp = nil
    local endp   = nil	
    local startpos = 0
    local function onTouchBegan(touch, event)
    	startp = touch:getLocation()
    	startpos = 0
	    local xx, yy = self._scroll:getInnerContainer():getPosition()
    	local scale  = self._map:getScale()
	    xx = math.floor(startp.x - xx)
    	yy = math.floor(startp.y - 214 - yy)
		for i,v in ipairs(self._map:getChildren()) do
			local px,py = v:getPosition()
			px = px * scale
			py = py * scale
			local ww = v:getContentSize().width *scale
			local hh = v:getContentSize().height *scale
			local rect = cc.rect(px-ww/2,py-hh/2,ww,hh)
			if cc.rectContainsPoint( rect, cc.p(xx,yy)) == true then
				startpos = v:getTag()
				return true
			end
		end
		return false
    end
    local function onTouchEnded(touch, event)
        endp = touch:getLocation()
        if math.abs(endp.x - startp.x) <= 10 and math.abs(endp.y - startp.y) <= 10 then
		    local xx, yy = self._scroll:getInnerContainer():getPosition()
	    	local scale  = self._map:getScale()
		    xx = math.floor(endp.x - xx)
	    	yy = math.floor(endp.y - 214 - yy)
			for i,v in ipairs(self._map:getChildren()) do
				if v:getTag() == startpos then
					local px,py = v:getPosition()
					px = px * scale
					py = py * scale
					local ww = 132 *scale
					local hh = 160 *scale
					local rect = cc.rect(px-ww/2,py-hh/2,ww,hh)
					if cc.rectContainsPoint( rect, cc.p(xx,yy)) == true then
						
 
                        local targetzom = self._map:getChildByTag(startpos)
                        if not pop.isShowing("pve") then
                            pop.onShowPopDialog("pve",startpos,self._enemy)
                        end
						
						startpos = 0
						return
					end
				end
			end
        end
       
    end

    local listener = cc.EventListenerTouchOneByOne:create()
    listener:registerScriptHandler(onTouchBegan,cc.Handler.EVENT_TOUCH_BEGAN)
    listener:registerScriptHandler(onTouchEnded,cc.Handler.EVENT_TOUCH_ENDED)
    self:getEventDispatcher():addEventListenerWithSceneGraphPriority(listener,self._map)
end
function pveLayer.onGetCityZombie(code)
	if code == 0 then
		if dd.currentLayer._name == "pve" then
			dd.currentLayer:showPve()
		end
	else
        dd.mainUI:onShowCodeTips(code)
	end
end

function pveLayer.onSNZombie( params )
    if params[1] == 1 then
        if dd.currentLayer._name == "pve" and params[2] ~= nil  then
            if params[2] > 0 then
                
                if dd.currentLayer.zmoblemoveinfo[tonumber(params[2])] ~= nil then
                    dd.currentLayer._pos[tostring(dd.currentLayer.zmoblemoveinfo[tonumber(params[2])]["pos"])]["use"] = 0
                    dd.currentLayer.zmoblemoveinfo[tonumber(params[2])] = {}
                end
                dd.currentLayer.zmoblemoveinfo[tonumber(params[2])] = nil
                if dd.currentLayer.spr[tonumber(params[2])] ~= nil then
                    
                    dd.currentLayer.spr[tonumber(params[2])]:unscheduleUpdate()
                    dd.currentLayer.spr[tonumber(params[2])]:stopAllActions()
                    dd.currentLayer.spr[tonumber(params[2])] = nil
                end
                local item = dd.currentLayer._map:getChildByTag(tonumber(params[2]))
                if item ~= nil then
                    item:setVisible(false)
                    item:unscheduleUpdate()
                    item:stopAllActions()
                    item:removeFromParent(true)
                end
            end

        end
        
    end

end

function pveLayer:onStart()
    dd.yunOpen()
	ff.net:registerEvent(1,dd.Tjf_Pve_GetCityZombie,self.onGetCityZombie)
    ff.net:registerEvent(1,dd.Tjf_notify_SNCityZombie,self.onSNZombie)
    self.zmoblemoveinfo = {}
    local rows = ff.dbmanager:sql_fetch_rows("select * from cfg_zombie_pos")
    self._pos = {}
    local total = rows:rowCount()
    for i=1,total do
        local row = math.ceil(math.random() * rows:rowCount())
        local id = rows:getString(row,"pos")
        self._pos[id] = {}
        self._pos[id]['x'] = tonumber(rows:getString(row,"x"))
        self._pos[id]['y'] = 2000 - tonumber(rows:getString(row,"y"))
        self._pos[id]['use'] = 0
        self._pos[id]['radius'] = tonumber(rows:getString(row, "radius"))

        rows:delRow(row)
    end
    self._pos.len = total
    rows:clear()

    rows = ff.dbmanager:sql_fetch_rows("select * from cfg_zombie")
    self._mods = {}
    for i=1,rows:rowCount() do
        local id = tonumber(rows:getString(i,"id"))
        self._mods[id] = {}
        self._mods[id]["type"] = tonumber(rows:getString(i,"type"))
        self._mods[id]["frame1"] = tonumber(rows:getString(i,"frame1"))
        self._mods[id]["frame2"] = tonumber(rows:getString(i,"frame2"))
        self._mods[id]["frame3"] = tonumber(rows:getString(i,"frame3"))
        self._mods[id]['use'] = 1
    end
    rows:clear()

    rows = ff.dbmanager:sql_fetch_rows("select * from cfg_zombie_path")
    self._path = {}
    local count_ = 1
    for i = 1, rows:rowCount() do
        local start = tonumber(rows:getString(i,"start"))
        if self._path[start] == nil then
            self._path[start] = {}
            if self._path[start]["num"] == nil then 
                count_ = 1
                self._path[start][count_] = {}
                self._path[start][count_]["path"] = tonumber(rows:getString(i,"end"))
                self._path[start][count_]["dis"] = tonumber(rows:getString(i,"dis"))
                self._path[start][count_]["dir"] = tonumber(rows:getString(i,"dir"))
                self._path[start][count_]["waiting"] = tonumber(rows:getString(i,"waiting"))
                self._path[start]["num"] = count_
                count_ = count_ + 1
            end            
        else
            self._path[start][count_] = {}
            self._path[start][count_]["path"] = tonumber(rows:getString(i,"end"))
            self._path[start][count_]["dis"] = tonumber(rows:getString(i,"dis"))
            self._path[start][count_]["dir"] = tonumber(rows:getString(i,"dir"))
            self._path[start][count_]["waiting"] = tonumber(rows:getString(i,"waiting"))
            self._path[start]["num"] = count_
            count_ = count_ + 1 
        end
        
    end
    rows:clear()
    if self._init == false then
        rows = ff.dbmanager:sql_fetch_rows("select * from cfg_enemy_inf")
        self._enemy = {}
        for i=1,rows:rowCount() do
            local id = tonumber(rows:getString(i,"enemyid"))
            self._enemy[id] = {}
            if ff.lang == -1 then
                self._enemy[id]["name"] = rows:getString(i,"name")
                self._enemy[id]["tips"] = rows:getString(i,"disc")                
            else
                self._enemy[id]["name"] = tonumber(rows:getString(i,"name_lan"))
                self._enemy[id]["tips"] = tonumber(rows:getString(i,"disc_lan"))             
            end                  
            
            self._enemy[id]["image"] = tonumber(rows:getString(i,"pic"))
        end
        rows:clear()
        self._init = true
    end

    if dd.myZombie ~= nil then
        dd.myZombie:clear()
        dd.myZombie = nil
    end
	dd.myZombie = ff.NetTable:create(true)
	dd.myZombie:addStreamCol("id",ff.NET_LONG)
	dd.myZombie:addStreamCol("time",ff.NET_LONG)
	dd.myZombie:addStreamCol("hp",ff.NET_LONG)
	dd.myZombie:addStreamCol("level",ff.NET_LONG)
	dd.myZombie:addStreamCol("star",ff.NET_LONG)
	dd.myZombie:addStreamCol("att",ff.NET_LONG)
	dd.myZombie:addStreamCol("def",ff.NET_LONG)
	dd.myZombie:addStreamCol("total",ff.NET_LONG)
	dd.myZombie:addStreamCol("mz",ff.NET_LONG)
	dd.myZombie:addStreamCol("sb",ff.NET_LONG)
	dd.myZombie:addStreamCol("bj",ff.NET_LONG)
	dd.myZombie:addStreamCol("kb",ff.NET_LONG)
	dd.myZombie:addStreamCol("hg",ff.NET_LONG)
	dd.myZombie:addStreamCol("hk",ff.NET_LONG)
	dd.myZombie:addStreamCol("mg",ff.NET_LONG)
	dd.myZombie:addStreamCol("info",ff.NET_LONG)
	dd.myZombie:addStreamCol("type",ff.NET_LONG)
	dd.myZombie:addStreamCol("show",ff.NET_STRING,64)
    local message = ff.net:createMessage()
    message:addCmd(0x00000046)
    message:addLong(dd.uid)
    ff.net:rpc(message,false)	

	self._widget:onShow()
    self.animation["walk"] = {}
    local animFrames = {}
    for j = 1, 8 do
        local frame = cc.SpriteFrameCache:getInstance():getSpriteFrame("1_2_1_"..j..".png")
        animFrames[j] = frame
    end 
    self.animation["walk"][1] =cc.RepeatForever:create( cc.Animate:create(cc.Animation:createWithSpriteFrames(animFrames, 100 /(800 - math.random(100)))))

    for j = 1, 8 do
        local frame = cc.SpriteFrameCache:getInstance():getSpriteFrame("1_2_2_"..j..".png")
        animFrames[j] = frame
    end
    self.animation["walk"][2] =cc.RepeatForever:create(  cc.Animate:create(cc.Animation:createWithSpriteFrames(animFrames, 100 /(800 - math.random(100)))))
    self.animation["stand"] = {}
    for j = 1, 8 do
        local frame = cc.SpriteFrameCache:getInstance():getSpriteFrame("1_1_1_"..j..".png")
        animFrames[j] = frame
    end
    self.animation["stand"][1] = cc.RepeatForever:create(  cc.Animate:create(cc.Animation:createWithSpriteFrames(animFrames, 100 /(800 - math.random(100)))))

    for j = 1, 8 do
        local frame = cc.SpriteFrameCache:getInstance():getSpriteFrame("1_1_2_"..j..".png")
        animFrames[j] = frame
    end
    self.animation["stand"][2] = cc.RepeatForever:create(  cc.Animate:create(cc.Animation:createWithSpriteFrames(animFrames, 100 /(800 - math.random(100)))))
    schedule(self, self.dealScript,1)
end
function pveLayer.dealScript()
    if dd.mainUI ~= nil then
        dd.mainUI:checkBattles()
        dd.mainUI:checkTags()
    end
end
function pveLayer:onEnd(sender)
    self:stopAllActions()
    dd.mainUI:clearDangrous()

    if GuideControl._curGuideLayer ~= nil then
        GuideControl._curGuideLayer:removeFromParent()
        GuideControl._curGuideLayer = nil
    end

	ff.net:removeEvent(1,dd.Tjf_Pve_GetCityZombie)
    ff.net:removeEvent(1,dd.Tjf_notify_SNCityZombie)
    self._map:stopAllActions()
	self._map:removeFromParent(true)
	for k,v in pairs(self._mods) do
		if self._mods[k]['use'] == 1 then
            if ff.set_power <= 1 then
                local cache = cc.SpriteFrameCache:getInstance()
                cache:removeSpriteFramesFromFile("images/pve/pve_"..k..".plist")
            end
		end
		self._mods[k]['use'] = 0
	end

    for i=1,dd.myZombie:rowCount() do
    	dd.myZombie:setLong(i,"state",0)
    end

    if ff.set_power <= 1 then
       
    end
    
    GuideControl._curGuideLayer = nil

    
end


function runPveScene()
    dd.clearBackEvent()

    local scene = cc.Director:getInstance():getRunningScene()
    local widget = scene:getChildByTag(1)
    if widget ~= nil then
        if widget == dd._cityLayer then
            dd._cityLayer:retain()
        end        
        widget:stopAllActions()
        widget:removeFromParent(true)
    end

    local layer = pveLayer.extend(cc.Layer:create())
    dd.clearScene()
    dd.pveLayer = layer
    dd.currentLayer= layer  
    dd.currentLayer._widget = dd.mainUI
    layer:initBattle()

   
    local function onEnterOrExit(tag)
	    if tag == "enter" then
            dd.playBackMusic(914,true)
	    	layer._map:setPosition(500,1000)
	    	layer._scroll:getInnerContainer():setPosition(cc.p(-500 + 360,-1000 + layer._scroll:getContentSize().height/2))
	    elseif tag == "enterTransitionFinish" then
	    	layer:onStart()
            
	    elseif tag == "exitTransitionStart" then	
	    elseif tag == "exit" then   
	    	layer:onEnd()
        elseif tag == "cleanup" then
            if ff.set_power <= 1 then
                cc.Director:getInstance():getTextureCache():removeUnusedTextures()     
            end
	    end        	
    end
	layer:registerScriptHandler(onEnterOrExit)        
    scene:addChild(layer,1,1)    
end
