require "fatality"

--新功能摘要



function test()
    testNetTable()
    testNetMessage()
    testDB()
    testSocket()
end


-- 测试了NetTable数据结构的lua支持的所有方法
function testNetTable()
    local nt = ff.NetTable:create()
    nt:addCol("test",ff.NET_LONG)
    nt:addCol("test1",ff.NET_STRING)
    nt:addCol("test2",ff.NET_DOUBLE)
    nt:addCol("test3",ff.NET_TABLE)


    nt:addRow()
    nt:addRow()
    nt:setLong(1,"test",99)
    nt:setString(1,"test1","我是测试用的")
    nt:setDouble(1,"test2",1.1)

    local nt2 = ff.NetTable:create()
    nt2:addCol("nt1",ff.NET_LONG)
    nt2:addRow()
    nt2:setLong(1,"nt1",888)

    nt:setNetTable(1,"test3",nt2)

    nt:setLong(2,"test",992)
    nt:setString(2,"test1","2我是测试用的")
    nt:setDouble(2,"test2",2.2)

    local x = nt:getLong(1,"test")
    local s = nt:getString(1,"test1")
    local d = nt:getDouble(1,"test2")
    cclog("--------------"..tostring(x).."--------------------")
    cclog("--------------"..s.."--------------------")
    cclog("--------------"..tostring(d).."--------------------")

    x = nt:getLong(2,"test")
    s = nt:getString(2,"test1")
    d = nt:getDouble(2,"test2")
    cclog("--------------"..tostring(x).."--------------------")
    cclog("--------------"..s.."--------------------")
    cclog("--------------"..tostring(d).."--------------------")

    local nt3 = nt:getNetTable(1,"test3")
    local xx  = nt3:getLong(1,"nt1")
    cclog("-------nt{nt}-------"..tostring(xx).."--------------------")

    nt:rowCount()
    nt:clear()
    cclog("--------------clear ok--------------------")
end        
-- 测试NetMessage数据结构.该结构被用来发送和接收网络消息,是顺序的字节流
function testNetMessage()
    --1. 创建
    local message = ff.NetMessage:create()
    cclog("--------------NetMessage:create ok--------------------")
    --2. 命令
    message:addCmd("test")
    cclog("--------------cmd:test ok--------------------")
    --设置参数
    message:addLong(998)
    cclog("--------------param:int ok--------------------")
    message:addDouble(2.0)
    cclog("--------------param:double ok--------------------")
    message:addString("测试消息")
    cclog("--------------param:string ok--------------------")
    --可以使用复杂的NetTable结构,NetTable的使用参考testNetTable
    local nt = ff.NetTable:create()
    nt:addCol("test1",ff.NET_LONG)
    nt:addRow()
    nt:setLong(1,"test1",777)
    message:addNetTable(nt)
    cclog("--------------param:nettable ok--------------------")

    -- 需要自己释放
    message:clear()
    cclog("--------------NetMessage clear ok--------------------")

    --该结构在Lua中一旦生成，必须经过网络传输才能解析
    --假设message是通过网络接收到的消息
    --1. local cmd = message:getCmd()
    --2. local iv  = message:getLong()   
    --3. local dv  = message:getDouble()   
    --4. local sv  = message:getString()
    --5. local nt  = message:getNetTable()
end
function testDB()

    -- 程序启动的时候设置数据库
    --ff.dbmanager:create(path)
    -- 测试取多条记录 返回是NetTable结构
    local nt = ff.dbmanager:sql_fetch_rows("select * from prf_world where `id` = '1001'")
    if nt ~= nil then
        cclog("--------------sql_fetch_rows:"..nt:getString(1,"type").."--------------------")
        -- 需要释放内存
        nt:clear();
    end
    -- 测试单个字段
    local value = ff.dbmanager:sql_fetch_one_cell("select `tid` from prf_tools where `tid`='22'")
    cclog("--------------sql_fetch_one_cell:"..tostring(value).."--------------------")
    -- 另外提供一个修改数据库的函数，一般不使用
    -- sql_query("update prf_tools set `name`='测试' where `tid`='1'");

    -- 程序退出前，关闭数据库连接
    -- ff.dbmanager:close()
end
function testSocket()
    -- 参数为超时设定
    local socket = ff.netbase:create(20)
    local ret = socket:connect("127.0.0.1",8003)
    if ret == 1 then
        cclog("网络连接成功")
        -- sendMessage为长连接使用，发送一个NetMessage结构到服务器
        -- recvMessage为长连接使用，接收一个NetMessage结构来处理
        -- call 为rpc调用，发送消息后等待接收。超时失败

        local message = ff.NetMessage:create()
        message:addCmd("test")
        message:addLong(998)
        message:addDouble(2.0)
        local result = socket:call(message)

        local cmd   = result:getCmd()
        local value = result:getLong()
        local dd    = result:getDouble()
        cclog("--------------收到返回cmd:"..cmd.."--------------------")
        cclog("--------------收到返回param:"..tostring(value).."--------------------")
        cclog("--------------收到返回param:"..tostring(dd).."--------------------")

        message:clear()
        result:clear()
    end
    socket:close()
end
function test_tjf()
    local message = ff.tjfMessage:create()
    message:addCmd(1)
    message:addLong(0)
    message:addLong(0)
    message:addLong(0)
    message:addString("fatality",64)
    message:addLong(1)
    message:addString("fatality",32)
    message:addString("fatality",15)
    message:addLong(1)
    --同步调用，直接收到返回
    local result = ff.net:call(message)

    local nt = ff.NetTable:create()
    nt:addStreamCol("ret",ff.NET_LONG)
    nt:addStreamCol("uid",ff.NET_LONG)
    result:getData(1, nt);

    cclog("uid:"..nt:getLong(1,"uid")..",ret:"..nt:getLong(1,"ret"))

    nt:clear()
    message:clear()
    result:clear()

    --异步
    --ff.net:postMessage(message)
end
