function pop.onShowPopDialog(name,...)
    cclog("show pop:"..name)
    dd.current_layer_name = name
    local tick = ff.gameCore:getTick()
    if dd.currentLayer == nil then
        return false
    end
    if pop.jsons[name] == nil then
        cclog("未注册的面板")
        return false
    end
    platform_clearAllInputText()
    cclog("use tick1:"..ff.gameCore:getTick() - tick)

    local widget = nil
    if pop.jsons[name][pop._index_loading] == 1 then
        widget = ff.gameCore:getWidget(pop.getJsonPath(pop.jsons[name][pop._index_json],pop.jsons[name][pop._index_type]))
        widget:stopAllActions()
    else
        widget = dd.loadUi(pop.getJsonPath(name,pop.jsons[name][pop._index_type]))
    end
    if widget == nil then
        cclog("未初始化的面板:"..name)
        return false
    end

    widget:stopAllActions()
    if pop.jsons[name][pop._index_type] == 1 and pop.jsons[name][pop._index_show] ~= 4 and ff.set_power <= 1 then
        if pop.jsons[name][pop._index_plist] ~= "" then
            cc.SpriteFrameCache:getInstance():removeSpriteFramesFromFile("images/ui/"..pop.jsons[name][pop._index_plist]..".plist")
        end            
    end
    
    cclog("use tick2:"..ff.gameCore:getTick() - tick)

    --预读
    if pop.jsons[name][pop._index_loading] == 1 then
        platform_showWaiting(1,0)
    else
        if ff.set_power <= 1 then
            platform_showWaiting(1,0)
        end    
    end

    local dialog = pop.jsons[name]
    local level  = dialog[pop._index_level]
    if level == 2 then
        platform_showWaiting(0)
        return false
    end    

    local tag   = dialog[pop._index_tag]
    local class = dialog[pop._index_func]
    local showtype = tonumber(dialog[pop._index_effect])    

    --确定父窗体
    local current = nil
    if level == 1 then
        if dd.currentLayer._widget ~= nil and dd.currentLayer._pop ~= nil then
            current = dd.currentLayer._pop
        end
    elseif level == 3 then
        if dd.currentLayer._widget ~= nil then
            current = dd.currentLayer._widget:getChildByName("pop3")
        end        
    elseif level == 4 then
        if dd.currentLayer._widget ~= nil then
            current = dd.currentLayer._widget:getChildByName("pop4")
        end        
    end
    if current == nil then
        cclog("场景切换中？")
    end    
    --发现有相同的弹窗被打开
    local target = current:getChildByTag(tag)
    if target ~= nil then   
        local item = pop.getWidgetJson(target)
        if item ~= nil then
            if item[pop._index_state] ~= target then
                pop.onCloseEffect(showtype,target)
            end    
        end    
    end
    if pop.jsons[name][pop._index_state] ~= nil and ff.platform == 1 then
        cclog("have one...")
        return
    end
    cclog("use tick3:"..(ff.gameCore:getTick() - tick))

    --根据set_power来确定是否释放    
    if pop.jsons[name][pop._index_free] == 2 then
        if ff.set_power <= 1 or pop.jsons[name][pop._index_state] == nil then
            cclog(pop.jsons[name][pop._index_json])
            if pop.jsons[name][pop._index_plist] ~= "" then
                cc.SpriteFrameCache:getInstance():addSpriteFrames("images/ui/"..pop.jsons[name][pop._index_plist]..".plist")
                ff.gameCore:updateJson(pop.getJsonPath(pop.jsons[name][pop._index_json]),pop.jsons[name][pop._index_type])  
            end                        
        end
    end
    --显示界面
    pop.jsons[name][pop._index_state] = widget
    if pop.jsons[name][pop._index_loading] == 1 then
        pop.initJsonText(widget)
        cclog("use tick51:"..ff.gameCore:getTick() - tick)
    end
    --调用初始化函数
    local call = dialog[pop._index_func]
    local ret  = call(widget,...)
    if ret == nil then
        platform_showWaiting(0)
        return
    end    

    dialog[pop._index_relase] = 1

    cclog("use tick5:"..ff.gameCore:getTick() - tick)
    if widget:getParent() == nil then
        if level == 3 or level == 4 then
            current:addChild(widget,tag,tag)
        else     
            current:addChild(widget,4,tag)
        end
    else    
        widget:setTag(tag)
    end    
    cclog("use tick7:"..(ff.gameCore:getTick() - tick))
    --置顶
    if dialog[pop._index_level] == 3 or dialog[pop._index_level] == 4 then
        pop.topSender(dialog[pop._index_level],widget)
    end    

    cclog("use tick6:"..(ff.gameCore:getTick() - tick))
    if ret ~= nil then
        pop.showPopEffect(showtype,widget)
    end    
    cclog("show use tick:"..(ff.gameCore:getTick() - tick))
end

function pop.popDialog(name,parent,...)
    if dd.currentLayer == nil then
        return false
    end
    if pop.jsons[name] == nil then
        return false
    end
    if parent == nil then
        return false
    end
    platform_clearAllInputText()

    local tick = ff.gameCore:getTick()

    local widget = nil
    if pop.jsons[name][pop._index_loading] == 1 then
        widget = ff.gameCore:getWidget(pop.getJsonPath(pop.jsons[name][pop._index_json],pop.jsons[name][pop._index_type]))   
    else
        widget = dd.loadUi(pop.getJsonPath(name,pop.jsons[name][pop._index_type]))
    end
    if widget == nil then
        cclog("未初始化的面板:"..name)
        return false
    end
    widget:stopAllActions()
    cclog("use tick2:"..ff.gameCore:getTick() - tick)
    
    --预读
    if pop.jsons[name][pop._index_loading] == 1 then
        platform_showWaiting(1,0)
    else
        if ff.set_power <= 1 then
            platform_showWaiting(1,0)
        end    
    end

    local dialog = pop.jsons[name]
    local level  = dialog[pop._index_level]
    if level ~= 2 then
        platform_showWaiting(0)
        return false
    end    

    local tag   = dialog[pop._index_tag]
    local class = dialog[pop._index_func]
    local showtype = tonumber(dialog[pop._index_effect])    
    
    --确定父窗体
    local current = parent
    if current == nil then
        cclog("场景切换中？")
    end    
    --发现有相同的弹窗被打开
    local target = current:getChildByTag(tag)
    if target ~= nil then   
        local item = pop.getWidgetJson(target)
        if item ~= nil then
            if item[pop._index_class] ~= pop.jsons[target._name][pop._index_class] then
                pop.onCloseEffect(showtype,target)
            end    
        end    
    end


    cclog("use tick3:"..ff.gameCore:getTick() - tick)
    --显示界面
    pop.jsons[name][pop._index_relase] = 1

    --根据set_power来确定是否释放    
    if pop.jsons[name][pop._index_free] == 2 then
        if ff.set_power <= 1 or pop.jsons[name][pop._index_state] == nil then
            cclog(pop.jsons[name][pop._index_json])
            if pop.jsons[name][pop._index_plist] ~= "" then
                cc.SpriteFrameCache:getInstance():addSpriteFrames("images/ui/"..pop.jsons[name][pop._index_plist]..".plist")
                ff.gameCore:updateJson(pop.getJsonPath(pop.jsons[name][pop._index_json]),pop.jsons[name][pop._index_type])  
            end                        
        end
    end
    --显示界面
    pop.jsons[name][pop._index_state] = widget
    if pop.jsons[name][pop._index_loading] == 1 then
        pop.initJsonText(widget)
        cclog("use tick51:"..ff.gameCore:getTick() - tick)
    end
    --调用初始化函数
    local call = dialog[pop._index_func]
    local ret  = call(widget,parent,...)
    if ret == nil then
        platform_showWaiting(0)
        return
    end    

    cclog("use tick5:"..ff.gameCore:getTick() - tick)
    if widget:getParent() == nil then
        cclog("zorder:"..(tag - 10000))
        current:addChild(widget,tag-10000,tag)
    else    
        widget:setTag(tag)
    end    

    cclog("use tick6:"..ff.gameCore:getTick() - tick)
    if ret ~= nil then
        pop.showPopEffect(showtype,widget)
    end    
    cclog("show use tick:"..ff.gameCore:getTick() - tick)
end
function pop.CloseAll()
    if ff.platform == 1 then
        if dd.currentLayer._pop ~= nil then
            dd.currentLayer._pop.onEnd(dd.currentLayer._pop)
        end
    end
    for k,v in pairs(pop.jsons) do
        if pop.jsons[k][pop._index_relase] == 1 then
            pop.closeNow(pop.jsons[k][pop._index_state])
        end 
    end 
end
--params表示给onEnd函数带的参数
function pop.closeNow(sender,params)
    if sender == nil then
        return
    end    
    if sender:isVisible() == false then
        return
    end    

    local item = pop.getWidgetJson(sender)
    if item == nil then
        sender:setVisible(false)
        return
    end    
    item[pop._index_show] = 4
    item[pop._index_relase] = 0

    cclog("pop.closeNow:"..item[pop._index_class])

    local close = sender.onEnd
    if close ~= nil then
        close(sender,params)
    end

    sender:setVisible(false)
    --释放内存
    local name = item[pop._index_json]
    if item[pop._index_free] == 1 then
        cclog("清理面板")
        if dd.currentLayer._pop ~= nil then
            if dd.currentLayer._pop._widget == sender then
                dd.currentLayer._pop._widget = nil
            end
        end
        sender:runAction(cc.RemoveSelf:create())
        item[pop._index_state] = nil
    else
        sender:setTag(0)
        if sender._init ~= nil  and sender._init == false then
            return
        end
    end    



    --5表示调试模式
    if item ~= nil and item[pop._index_free] ~= 1 then
        local free = 1
        if item[pop._index_free] == 2 and ff.set_power > 1 then
            free = 0
        end

        local tick = ff.gameCore:getTick()
        if free == 1 then
            ff.gameCore:updateJson(pop.getJsonPath(name,item[1]),0)
        end

        if item[pop._index_plist] ~= "" then
            local have = false
            for i=1,table.getn(pop.needclear) do
                if pop.needclear[i] == item[pop._index_plist] then
                    have = true
                    break
                end
            end
            if have == false then
                pop.needclear[table.getn(pop.needclear) + 1] = item[pop._index_plist]
            end
        end
        if pop.showCount() == 0 and free == 1 then
            for k,v in pairs(pop.needclear) do
                cc.SpriteFrameCache:getInstance():removeSpriteFramesFromFile("images/ui/"..v..".plist")
            end
            pop.needclear = {}
            cc.Director:getInstance():getTextureCache():removeUnusedTextures()
        end
    end    
end

function pop.topSender(level,sender)
    for k,v in pairs(pop.jsons) do
        if pop.jsons[k][pop._index_state] ~= nil and pop.jsons[k][pop._index_level] == level then
            if pop.jsons[k][pop._index_state] == sender then
                pop.jsons[k][pop._index_state]:setLocalZOrder(10000 + pop.jsons[k][pop._index_tag])
                if level == 3 then
                    pop._toper = pop.jsons[k][pop._index_state]
                end
            else
                pop.jsons[k][pop._index_state]:setLocalZOrder(pop.jsons[k][pop._index_tag])
            end
        end    
    end   
end
function pop.closeOtherNow(level,sender)
    if level == 1 and ff.platform == 1 then
        cclog("1234")
        if dd.currentLayer._pop ~= nil then
            dd.currentLayer._pop.onEnd(dd.currentLayer._pop)
        end
    end
    for k,v in pairs(pop.jsons) do
        if pop.jsons[k][pop._index_state] ~= nil and pop.jsons[k][pop._index_level] == level then
            if pop.jsons[k][pop._index_state] ~= sender then
                pop.closeNow(pop.jsons[k][pop._index_state],false)                
            end
        end    
    end      
end
function pop.onClosePopDialog(name)
    cclog('onClosePopDialog:'..name)
    if dd.currentLayer == nil then
        return false
    end
    if pop.jsons[name] == nil then
        return false
    end

    local level   = pop.jsons[name][pop._index_level]
    local current = nil
    if level == 1 then
        current = dd.currentLayer._pop
    elseif level == 2 then
        current = dd.currentLayer._widget:getChildByName("pop2")
    elseif level == 3 then        
        current = dd.currentLayer._widget:getChildByName("pop3")
    else
        current = dd.currentLayer._widget:getChildByName("pop4")
    end    
    if current == nil then
        return false
    end

    platform_clearAllInputText()
    pop.jsons[name][pop._index_show] = 3

    local tag = pop.jsons[name][pop._index_tag]
    local level = pop.jsons[name][pop._index_level]
    local showtype = tonumber(pop.jsons[name][pop._index_effect])
    pop.onCloseEffect(showtype,pop.jsons[name][pop._index_state])
end

function pop.getJsonPath(name,debug)
    if debug == 5 then
        return "images/debug/"..name..".json"
    else
        if pop.jsons[name] == nil then
            return "images/ui/"..name..".ExportJson"
        end
        if pop.jsons[name][pop._index_type] == 1 then
            return "images/ui/"..name..".ExportJson"
        else
            return "images/ui/".. pop.jsons[name][pop._index_json] ..".json"
        end
    end    
end
function pop.getWidgetJson(sender)
    for k,v in pairs(pop.jsons) do
        if pop.jsons[k][pop._index_state] ~= nil and pop.jsons[k][pop._index_state] == sender then
            return pop.jsons[k]
        end    
    end      
    return nil
end
function pop.isShowing(name)
    if pop.jsons[name] == nil then
        return false
    else
        if pop.jsons[name][pop._index_state] ~= nil then
            return pop.jsons[name][pop._index_state]:isVisible()
        end
    end     
    return false
end
function pop.isLevelShowing(level)
    for k,v in pairs(pop.jsons) do
        if pop.jsons[k][pop._index_level] == level then
            if pop.isShowing(k) == true then
                return true
            end    
        end    
    end  
    return false
end
function pop.onCloseEffect(showtype,sender)
    if sender == nil then
        return
    end    

    local close = sender.onEnd
    if close ~= nil then
        if showtype == 99 then
            sender:setVisible(false)
        end
        close(sender)
    end

    local item = pop.getWidgetJson(sender)
    if item ~= nil then
        if tonumber(item[pop._index_level]) ~= 2 then
            sender:setTag(9999)
        end    
        if tonumber(item[pop._index_level]) == 3 and showtype < 15 then
            showtype = 15
        end
    end    

    local function endAction(target)
        cclog("endAction:"..target:getName())
        if item == nil then
            target:setVisible(false)
            GuideControl:GuideCheck()
            return
        end    
        item[pop._index_show] = 4
        item[pop._index_relase] = 0

        --释放内存
        local name = item[pop._index_json]
        if item[pop._index_free] == 1 then
            cclog("清理面板")     
            if dd.currentLayer._pop ~= nil then
                if dd.currentLayer._pop._widget == sender then
                    dd.currentLayer._pop._widget = nil
                end
            end
            target:runAction(cc.RemoveSelf:create())
            item[pop._index_state] = nil
        else
            cclog("here:"..name)
            target:setVisible(false)
            target:setTag(0)
        end
    
        cclog("endaction...check")
        GuideControl._curView = nil
        GuideControl:GuideCheck()
        --guide end
        if item[pop._index_free] ~= 1 then
            local free = 1
            if item[pop._index_free] == 2 and ff.set_power > 1 then
                free = 0
            end

            local tick = ff.gameCore:getTick()
            if free == 1 then
                ff.gameCore:updateJson(pop.getJsonPath(name,item[1]),0)
            end

            if item[pop._index_plist] ~= "" then
                local have = false
                for i=1,table.getn(pop.needclear) do
                    if pop.needclear[i] == item[pop._index_plist] then
                        have = true
                        break
                    end
                end
                if have == false then
                    pop.needclear[table.getn(pop.needclear) + 1] = item[pop._index_plist]
                end
            end
            if pop.showCount() == 0 and free == 1 then
                for k,v in pairs(pop.needclear) do
                    cclog("remove plist:"..v)
                    cc.SpriteFrameCache:getInstance():removeSpriteFramesFromFile("images/ui/"..v..".plist")
                end
                pop.needclear = {}
                cc.Director:getInstance():getTextureCache():removeUnusedTextures()
            end
        end    
    end

    if showtype == 1 then
        sender:runAction(cc.Sequence:create(cc.EaseExponentialOut:create(cc.MoveTo:create(1, cc.p(0,-ff.height))),cc.CallFunc:create(endAction)))
    elseif showtype == 2 then
        sender:runAction(cc.Sequence:create(cc.EaseExponentialOut:create(cc.MoveTo:create(1, cc.p(0,ff.height))),cc.CallFunc:create(endAction)))
    elseif showtype == 3 then
        sender:runAction(cc.Sequence:create(cc.EaseExponentialOut:create(cc.MoveTo:create(1, cc.p(-ff.width,0))),cc.CallFunc:create(endAction)))
    elseif showtype == 4 then
        sender:runAction(cc.Sequence:create(cc.EaseExponentialOut:create(cc.MoveTo:create(1, cc.p(ff.width,0))),cc.CallFunc:create(endAction)))
    elseif showtype == 5 then
        local action = cc.Spawn:create(
                    cc.ScaleTo:create(0.5, 0.5),
                    cc.FadeOut:create(0.5)
                    )
        sender:runAction(cc.Sequence:create(action,cc.CallFunc:create(endAction)))
    elseif showtype == 8 then
        sender:runAction(cc.Sequence:create(cc.EaseExponentialOut:create(cc.MoveTo:create(1, cc.p(0,-sender:getContentSize().height - 222))),cc.CallFunc:create(endAction)))
    else
        endAction(sender)
    end  
end
function pop.showPopEffect(showtype,sender,skip,newbie)    
    if sender == nil then
        return
    end
    if skip == nil then
        skip = false
    end    
    if skip == false then
        local before = sender.onBefore
        if before ~= nil then
            if before(sender) == false then
                platform_showWaiting(0)
                return
            end    
        end
    end    

    if ff.platform == 1 then
        cc.Director:getInstance():getTextureCache():removeUnusedTextures()
    end
    
    local function startAction()
        if sender ~= nil then 
            local item = pop.getWidgetJson(sender)
            if item ~= nil then
                item[pop._index_show] = 2
            end    
            
            local star = sender.onStart
            if star ~= nil then
                star(sender)           
                     
                if item ~= nil and item[pop._index_level] == 3 then
                    if dd.mainUI ~= nil then
                        dd.mainUI:canTouchSelectBtns()
                    end
                end
                if sender._name ~= nil then
                    cclog("popCore:check1,"..sender._name)
                    GuideControl._curView = sender
                    GuideControl:GuideCheck()
                end
            --guide end
            elseif newbie == true then
                cclog("popCore:check2")
                GuideControl._curView = sender
                GuideControl:GuideCheck()                
            end
            --关闭其他面板
            if item ~= nil and item[pop._index_level] == 3 then
                if pop._toper == sender then
                    pop.closeOtherNow(3,sender)
                end
            end
            platform_showWaiting(0)
        end    
    end

    local item = pop.getWidgetJson(sender)
    if item ~= nil then
        item[pop._index_show] = 1
    end
    cclog("showtype:"..showtype)
    if showtype == 1 then
        sender:setPosition(cc.p(0,-ff.height))
        --sender:runAction(cc.Sequence:create(cc.EaseExponentialOut:create(cc.MoveTo:create(1, cc.p(0,0))),cc.CallFunc:create(startAction)))
        sender:runAction(cc.Sequence:create(cc.EaseBackOut:create(cc.MoveTo:create(1, cc.p(0,0))),cc.CallFunc:create(startAction)))
    elseif showtype == 2 then    
        sender:setPosition(cc.p(0,ff.height))
        sender:runAction(cc.Sequence:create(cc.EaseExponentialOut:create(cc.MoveTo:create(1, cc.p(0,0))),cc.CallFunc:create(startAction)))
    elseif showtype == 3 then
        sender:setPosition(cc.p(-ff.width,0))
        sender:runAction(cc.Sequence:create(cc.EaseExponentialOut:create(cc.MoveTo:create(1, cc.p(0,0))),cc.CallFunc:create(startAction)))
    elseif showtype == 4 then    
        sender:setPosition(cc.p(ff.width,0))
        sender:runAction(cc.Sequence:create(cc.EaseExponentialOut:create(cc.MoveTo:create(1, cc.p(0,0))),cc.CallFunc:create(startAction)))
    elseif showtype == 5 then
        sender:setScale(0.5)
        local action = cc.Spawn:create(
                    cc.EaseExponentialOut:create(cc.EaseBackOut:create(cc.ScaleTo:create(1, 1))),
                    cc.FadeIn:create(0.3)
                    )
        sender:runAction(cc.Sequence:create(action,cc.CallFunc:create(startAction)))
    elseif showtype == 6 then
        --渐显，并且向下        
        sender:setPosition(cc.p(0,300))
        local action = cc.Spawn:create(
                    cc.EaseExponentialOut:create(cc.MoveTo:create(1, cc.p(0,0))),
                    cc.FadeIn:create(1)
                    )
        sender:runAction(cc.Sequence:create(action,cc.CallFunc:create(startAction)))
        --sender:runAction(cc.Sequence:create(cc.EaseExponentialOut:create(cc.MoveTo:create(1, cc.p(0,0))),cc.CallFunc:create(startAction)))
    elseif showtype == 7 then       
        sender:setPosition(cc.p(0,-sender:getContentSize().height))
        sender:runAction(cc.Sequence:create(cc.EaseExponentialOut:create(cc.MoveTo:create(0.5, cc.p(0,214))),cc.CallFunc:create(startAction)))
    elseif showtype == 8 then    
        --渐显，并且向上      
        sender:setPosition(cc.p(0,-sender:getContentSize().height - 214))
        sender:runAction(cc.Sequence:create(cc.EaseExponentialOut:create(cc.MoveTo:create(0.5, cc.p(0,0))),cc.CallFunc:create(startAction)))
    elseif showtype == 9 then    
        --渐显，并且向下        
        sender:setPosition(cc.p(0,sender:getContentSize().height))
        sender:setOpacity(0)
        local action = cc.Spawn:create(
                    cc.EaseBackOut:create(cc.MoveTo:create(1, cc.p(0,0))),
                    cc.FadeIn:create(1)
                    )
        sender:runAction(cc.Sequence:create(action,cc.CallFunc:create(startAction)))
    elseif showtype == 10 or showtype == 12 then    
        --渐显，并且向上      
        sender:setPosition(cc.p(0,-sender:getContentSize().height))
        sender:runAction(cc.Sequence:create(cc.EaseExponentialOut:create(cc.MoveTo:create(0.3, cc.p(0,0))),cc.CallFunc:create(startAction)))
    elseif showtype == 11 then    
        sender:setPosition(cc.p(0,-sender:getContentSize().height))
        sender:runAction(cc.Sequence:create(cc.EaseExponentialOut:create(cc.MoveTo:create(0.3, cc.p(0,214))),cc.CallFunc:create(startAction)))
    elseif showtype == 13 then    
        sender:setPosition(cc.p(0,-sender:getContentSize().height))
        sender:runAction(cc.Sequence:create(cc.EaseExponentialOut:create(cc.MoveTo:create(0.3, cc.p(0,214))),cc.CallFunc:create(startAction)))
    elseif showtype == 14 then    
        sender:setOpacity(0)
        sender:runAction(cc.Sequence:create(cc.FadeIn:create(1),cc.CallFunc:create(startAction)))
    elseif showtype == 15 then    
        sender:setOpacity(0)
        sender:runAction(cc.Sequence:create(cc.FadeIn:create(0.3),cc.CallFunc:create(startAction)))
    elseif showtype == 16 then    
        sender:setPosition(cc.p(0,-sender:getContentSize().height))
        sender:runAction(cc.Sequence:create(cc.EaseExponentialOut:create(cc.MoveTo:create(0.5, cc.p(0,214))),cc.CallFunc:create(startAction)))
    elseif showtype == 97 then
        sender:runAction(cc.Sequence:create(cc.DelayTime:create(0.05),cc.CallFunc:create(startAction)))
    elseif showtype == 98 then
        sender:runAction(cc.Sequence:create(cc.DelayTime:create(0.3),cc.CallFunc:create(startAction)))
    elseif showtype == 99 then
        --新手引导需要先显示界面。没有缓动
        sender:setVisible(true)
        startAction(sender)
    end

    sender:setVisible(true)
end
function pop.getDialog(name)
    if pop.jsons[name] == nil then
        return nil
    end
    if pop.jsons[name][pop._index_state] ~= nil then
        return pop.jsons[name][pop._index_state]
    end
    return nil
end
function pop.showCount()
    local count = 0
    for k,v in pairs(pop.jsons) do
        if pop.jsons[k][pop._index_relase] == 1 then
            count = count + 1
        end    
    end 
    return count
end
--城市
function pop.initInnerCityPop()
    for k,v in pairs(pop.jsons) do
        if pop.jsons[k][pop._index_type] == 1 then
            ff.gameCore:addAsyncJson("images/ui/"..pop.jsons[k][pop._index_json]..".ExportJson")
        end    
    end    
end
--预先处理一些打开比较慢的界面
function pop.initAllDialog()
    if ff.set_power > 1 then
        for k,v in pairs(pop.creates) do
            local tick = ff.gameCore:getTick()
            if pop.jsons[k][pop._index_level] == 3 or pop.jsons[k][pop._index_level] == 4 then
                local current = nil 
                if pop.jsons[k][pop._index_level] == 3 then
                    current = dd.currentLayer._widget:getChildByName("pop3")
                else
                    current = dd.currentLayer._widget:getChildByName("pop4")
                end
                local widget = ff.gameCore:getWidget(pop.getJsonPath(pop.jsons[k][pop._index_json],pop.jsons[k][pop._index_type]))
                if widget:getParent() == nil then
                    current:addChild(widget,-1,-1)
                    if pop.creates[k] ~= nil then
                        local create = pop.creates[k][2]
                        if create ~= nil then
                            pop.jsons[k][pop._index_lang] = ff.lang
                            ff.gameCore:updateText(pop.getJsonPath(pop.jsons[k][pop._index_json]))
                            --加载纹理                            
                            pop.initJsonText(widget)
                            if pop.creates[k][3] == 1 then
                                if pop.jsons[k][pop._index_plist] ~= "" then
                                    cc.SpriteFrameCache:getInstance():addSpriteFrames("images/ui/"..pop.jsons[k][pop._index_plist]..".plist")
                                    ff.gameCore:updateJson(pop.getJsonPath(pop.jsons[k][pop._index_json]),pop.jsons[k][pop._index_type])  
                                end                        
                            end
                            create(widget)
                        end
                    end
                    widget:setVisible(false)
                end  
            end    
            cclog(k.." use:"..(ff.gameCore:getTick() - tick))
        end        
    end
end

--初始化文本包括多语言版本UI
function pop.initJsonText(sender)
    local json = pop.getWidgetJson(sender)
    if json ~= nil then
        if json[pop._index_lang] == nil or json[pop._index_lang] ~= ff.lang then      
            json[pop._index_lang] = ff.lang
            ff.gameCore:updateText(pop.getJsonPath(json[pop._index_json]))
        end    
    end    
end

function pop.onClose(showtype,sender,parent)
    local function endAction(target)
        target:stopAllActions()
        if parent ~= nil then
            parent:setVisible(false)
            parent:setEnabled(false)
        else 
            target:setVisible(false)
            target:setEnabled(false)
        end    
    end
    if showtype == 1 then
        sender:runAction(cc.Sequence:create(cc.EaseExponentialOut:create(cc.MoveTo:create(1, cc.p(ff.width/2,-ff.height - sender:getContentSize().height/2))),cc.CallFunc:create(endAction)))
    elseif showtype == 2 then
        sender:runAction(cc.Sequence:create(cc.EaseExponentialOut:create(cc.MoveTo:create(1, cc.p(ff.width/2,ff.height + sender:getContentSize().height/2))),cc.CallFunc:create(endAction)))
    elseif showtype == 3 then
        sender:runAction(cc.Sequence:create(cc.EaseExponentialOut:create(cc.MoveTo:create(1, cc.p(-ff.width - sender:getContentSize().width/2,ff.height/2))),cc.CallFunc:create(endAction)))
    elseif showtype == 4 then
        sender:runAction(cc.Sequence:create(cc.EaseExponentialOut:create(cc.MoveTo:create(1, cc.p(ff.width + sender:getContentSize().width/2,ff.height/2))),cc.CallFunc:create(endAction)))
    elseif showtype == 5 then
        sender:runAction(cc.Sequence:create(cc.ScaleTo:create(0.2, 0.2),cc.CallFunc:create(endAction)))
    end
end
function pop.onClick(sender,eventType)
    if eventType == ccui.TouchEventType.ended then   
        pop.onShowPopDialog(sender:getName(),sender,eventType)
    end
end

--领地
function pop.initOutCityPop()
    for k,v in pairs(pop.jsons) do
        if pop.jsons[k][pop._index_type] == 2 then
            ff.gameCore:addAsyncJson("images/ui/"..pop.jsons[k][pop._index_json]..".ExportJson")
        end    
    end    
end
--世界
function pop.initWorldPop()
    for k,v in pairs(pop.jsons) do
        if pop.jsons[k][pop._index_type] == 3 then
            ff.gameCore:addAsyncJson("images/ui/"..pop.jsons[k][pop._index_json]..".ExportJson")
        end    
    end
end
--共享
function pop.initPublicPop()
    for k,v in pairs(pop.jsons) do
        if pop.jsons[k][pop._index_loading] == 1 then
            if pop.jsons[k][pop._index_type] == 1 then
                ff.gameCore:addAsyncJson("images/ui/"..pop.jsons[k][pop._index_json]..".ExportJson")
            else
                ff.gameCore:addAsyncJson("images/ui/"..pop.jsons[k][pop._index_json]..".json")
            end
        end       
    end
end

