local WarningLayer   = class("WarningLayer")
WarningLayer._name = "warnning"
WarningLayer._init = false

--约定，确认面板
--function onWarning(widget,info,title,onSure)
--info要显示的信息
--title为标题栏文字
--onSure为回调函数


function WarningLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, WarningLayer)
    return target
end
function WarningLayer:onInit(widget)
	local cancel = self:getChildByName("closeBtn")
	cancel:addTouchEventListener(self.onCancel)
	self._mask = widget:getChildByName("mask")
    widget:getChildByName("mask"):setVisible(true)
    widget:getChildByName("mask"):setEnabled(true)
    self:getChildByName("info"):setVisible(false)
end
function WarningLayer:setInfo(info)
	self._info = info
	--self:getChildByName("info"):setString(info)
end
function WarningLayer:setTitle(title)
	if title == nil then
		self:getChildByName("title"):getChildByName("label"):setVisible(false)
	else
		local label = self:getChildByName("title"):getChildByName("label")
		label:setString(title)
		label:getVirtualRenderer():enableOutline(cc.c4b(0,0,0,255),3)	
		label:setVisible(true)
	end	
end
function WarningLayer:setOnSure(onSure)
	local sure   = self:getChildByName("sure")
	if onSure == nil then
		sure:addTouchEventListener(self.onCancel)
	else
		sure:addTouchEventListener(onSure)
	end		
end

function WarningLayer.onCancel(sender,eventType)
	if eventType == ccui.TouchEventType.ended then   
    	pop.onClosePopDialog("warnning")
    end	
end
function WarningLayer:showInfo()
	if self._richText ~= nil then
		self._richText:removeFromParent(true)
		self._richText = nil 
	end		
	self._richText = ccui.RichText:create()
    self._richText:ignoreContentAdaptWithSize(false)
    self._richText:setContentSize(self:getChildByName("info"):getContentSize())
    self:addChild(self._richText,3)


    self._richText:setPosition(cc.p(324,182))

	dd.getHtmlStr(self._info,"Helvetica",24,self._richText,cc.c3b(123, 99, 72)) 
end

function WarningLayer.onEnd(sender)
	cclog("WarningLayer.onEnd")
	sender._mask:setVisible(false)
	sender._mask:setEnabled(false)
end
function WarningLayer.onStart(sender)
	sender._mask:setVisible(true)
	sender._mask:setEnabled(true)
	sender:showInfo()
end
function onWarning(widget,info,title,onSure)
	local warnning = widget:getChildByName("warnning")
	local layer = WarningLayer.extend(warnning)
    if layer._init == false then
        layer:onInit(widget)
        layer._init = true
    end 
    layer:setTitle(title)
    layer:setOnSure(onSure)
    layer:setInfo(info)

    --如果已经显示了，需要自己调用onStart
	if layer:isVisible() == true then
		layer.onStart(layer)
		return nil
	else
		return layer	
	end
end