local WatingLayer   = class("WatingLayer")
WatingLayer._name = "watingLayer"
WatingLayer._init = false
WatingLayer._cmd  = 0
WatingLayer._animFrames = nil

function WatingLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, WatingLayer)
    return target
end

function WatingLayer:onInit()
    self:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
    self:setBackGroundColor(cc.c3b(0, 0, 0))
    self:setContentSize(cc.size(ff.width, ff.height))
    self:setBackGroundColorOpacity(100)

    local cache = cc.SpriteFrameCache:getInstance()
    cache:addSpriteFrames("images/mv/waiting.plist")
	self:setPosition(cc.p(0,0))

	local mv = cc.Sprite:createWithSpriteFrameName("loading_1.png")
    mv:setContentSize(cc.size(102,102))
    mv:setPosition(cc.p(ff.width/2,ff.height/2))
    self:addChild(mv,1,1)

    self._animFrames = {}
    for j = 1, 32 do
        local frame = cache:getSpriteFrame("loading_"..j..".png")
        self._animFrames[j] = frame
    end

end
function WatingLayer:onPlay(cmd)
    if cmd ~= nil then
        self._cmd = cmd + 0x00001000
    end    
    self:setTouchEnabled(true,true)
    local animation = cc.Animation:createWithSpriteFrames(self._animFrames, 0.1)
    self:getChildByTag(1):stopAllActions()
	self:getChildByTag(1):runAction(cc.RepeatForever:create(cc.Animate:create(animation)))
end
function WatingLayer:onStop()
	self:getChildByTag(1):stopAllActions()
end
function WatingLayer:onMask(tag)
	if tag == true then
		self:setBackGroundColorOpacity(100)
		self:setTouchEnabled(true,true)
	else
		self:setBackGroundColorOpacity(0)
		self:setTouchEnabled(false)
	end
end
function WatingLayer:onSize(size)
	self:setContentSize(size)
    local mv = self:getChildByTag(1)
    mv:setPosition(cc.p(size.width/2,size.height/2))

    local xx,yy = self:getPosition()
    cclog("xx:"..xx..",yy:"..yy)
end
--net模块使用
function WatingLayer:onClear()
    if self:getParent() ~= nil then
        self:removeFromParent(true)
    end    
    self._cmd = 0
    self:onStop()
end


function initWating()
	if WatingLayer._init == false then
		local layer = WatingLayer.extend(ccui.Layout:create())
		layer:retain()
		layer:onInit()		
		cclog("initWating")
		dd.watingLayer = layer
		WatingLayer._init = true
		return layer
	else
		return dd.watingLayer	
	end
end

--clone出来，自己负责remove
function addWating()
    local wat = WatingLayer.extend(dd.watingLayer:clone())
    wat:retain()
    wat:onInit()
    return wat
end
--用模版直接显示
--net模块使用，其他模块别调用，用addWating
function getWating(sender)
    if dd.watingLayer:getParent() == nil then
        if sender == nil then
            dd.mainUI:addChild(dd.watingLayer,999999,999999)
        else
            sender:addChild(dd.watingLayer,999999,999999)
        end    
    end
	return dd.watingLayer
end