require "version"
--重字符串里获取参数
function getHttpsParams(str)
    local result = Split(str,",")
    local retcode = {}
    for i=1,table.getn(result) do
        local temp = Split(result[i],":")
        if table.getn(temp) == 2 then
            if temp[2] == "null" then
                retcode[temp[1]] = ""
            else
                retcode[temp[1]] = temp[2]
           end
        end
    end
    return retcode       
end

function downDB(success,onerror)
    local assetsManager = cc.AssetsManager:new(cc.FileUtils:getInstance():getWritablePath())

    local cdns  = nil
    local index = 2

    local function doAssetsManager(ver)
        --去掉第一条无效的
        if cdns == nil or table.getn(cdns) <= 1 then
            return platform_showDialog("Network connection error","Network connection was lost!0x901",2,0)
        end        

        for i=index,table.getn(cdns) do
            local pk = cdns[i]
            for j=1,string.len(pk) do
                if string.sub(pk,string.len(pk) - (j - 1),string.len(pk) - (j - 1)) == "/" then
                    pk = string.sub(cdns[i],1,string.len(cdns[i]) - (j - 1))
                    assetsManager:update(pk..hif._lists:getString(1,"dbname")..ver..".zip")
                    break
                end
            end

            return
        end
        platform_showLoadingBar(99)
        platform_setLoadingBarTipColor(cc.c3b(255,0,0))      
        platform_showDialog("Update error","Connection Error.Please check your wifi or data network and re-login.",2,0)
        return
    end    

    local function onProgress(percent)
        if ff.loadingLayer ~=nil then
            ff.loadingLayer:setProgress(percent)
        end 
    end
    local function onError(errorCode)
        local action = 0
        local function callNextCDN()
            cc.Director:getInstance():getScheduler():unscheduleScriptEntry(action)
            index = index + 1
            doAssetsManager(ff.db_version)
        end
        if errorCode == cc.ASSETSMANAGER_NO_NEW_VERSION then
            cclog("no new version")
        elseif errorCode == cc.ASSETSMANAGER_NETWORK then
            cclog("network error")
            action = cc.Director:getInstance():getScheduler():scheduleScriptFunc(callNextCDN, 1, false)
            return
        end
        if assetsManager ~= nil then
            assetsManager:release()
            assetsManager = nil
        end
        if onerror ~= nil then
            onerror(errorCode)
        end
    end
    local function onSuccess()
        cclog("onSuccess")
        assetsManager:release()
        assetsManager = nil

        cc.UserDefault:getInstance():setIntegerForKey("dbversion",ff.db_version)
        if success ~= nil then
            success()
        end 
    end

    assetsManager:retain()
    assetsManager:setDelegate(onError, cc.ASSETSMANAGER_PROTOCOL_ERROR )
    assetsManager:setDelegate(onProgress, cc.ASSETSMANAGER_PROTOCOL_PROGRESS)
    assetsManager:setDelegate(onSuccess, cc.ASSETSMANAGER_PROTOCOL_SUCCESS )
    assetsManager:setConnectionTimeout(30)

    if ff.loadingLayer ~=nil then
        platform_showLoadingBar(1)
        --ff.loadingLayer:setTips(ff.langString("更新配置文件").."...")
        ff.loadingLayer:setTips("Updating Files...")
    end 
    --获取cdn地址
    local ret = hif.doPost("server","code=cdn2&version="..cc.UserDefault:getInstance():getIntegerForKey("version"))
    cdns = Split(ret,",")
    doAssetsManager(ff.db_version)
end

function checkVersionIOS()
    ff.loadingLayer._params['checkVersion'] = ""
    hif.doPost("server","code=version&version="..cc.UserDefault:getInstance():getIntegerForKey("version"),"checkVersion")
    local action = nil
    function backCheck()
        if ff.loadingLayer._params['checkVersion'] ~= "" then
            ff.loadingLayer:stopAction(action)
            checkVersion(ff.loadingLayer.onSuccess,ff.loadingLayer.onError,ff.loadingLayer._params['checkVersion'])
        end
    end
    action = schedule(ff.loadingLayer, backCheck, 1)
end

--cdn1
function checkVersion(success,error,version)	
    cclog("checkVersion")

    if version == nil then
        cclog("do check version")
        version = hif.doPost("server","code=version&version="..cc.UserDefault:getInstance():getIntegerForKey("version"))
        if version == "init net error" then
            platform_showDialog("Network connection error","Network connection was lost!0x901",2,0)
            return
        end
    end
    cclog("version:"..version)
    local result = getHttpsParams(version)

    cclog(result['min'])
    cclog(result['cur'])
    cclog(result['db'])
    cclog(result['state'])
    --连接不上服务器
    if result == nil or result['min'] == nil or result['cur'] == nil then
        return platform_showDialog("Network connection error","Network connection was lost!0x901",2,0)
    end
    --服务维护中
    if result['state'] ~= nil and tonumber(result['state']) == 0 then
        platform_showWeihu()
        local notice = hif.doPost("server","code=notice&lang="..ff.lang.."&version="..cc.UserDefault:getInstance():getIntegerForKey("version"))
        cclog("notice:"..notice)
        local params = Split(notice,"%^")
        if table.getn(params) == 2 then
            cclog(params[2])
            if params[2] ~= nil then
                platform_showWeihuText(params[2],"161~175~175")
            else
                platform_showWeihuText("Server maintenance, please try again later.",cc.c3b(255,0,0))
            end
        else
            platform_showWeihuText("Server maintenance, please try again later.",cc.c3b(255,0,0))
        end
        return
    end

    local index = 2
    local assetsManager = cc.AssetsManager:new(cc.FileUtils:getInstance():getWritablePath())
    assetsManager:retain()
    local cdns = nil


    local function doAssetsManager(ver)
        --去掉第一条无效的
        if cdns == nil or table.getn(cdns) <= 1 then
            return platform_showDialog("Network connection error","Network connection was lost!0x901",2,0)
        end        

        for i=index,table.getn(cdns) do
            local pk = cdns[i]
            for j=1,string.len(pk) do
                if string.sub(pk,string.len(pk) - (j - 1),string.len(pk) - (j - 1)) == "/" then
                    pk = string.sub(cdns[i],1,string.len(cdns[i]) - (j - 1))
                    hif._lists:setString(i,"package",pk)
                    assetsManager:update(pk.."package/"..cc.UserDefault:getInstance():getIntegerForKey("version")..".zip",ver)
                    break
                end
            end
            --assetsManager:update(cdns[i].."package/"..cc.UserDefault:getInstance():getIntegerForKey("version")..".zip",ver)
            return
        end
        platform_showLoadingBar(99)
        platform_setLoadingBarTipColor(cc.c3b(255,0,0))      
        platform_showDialog("Update error","Connection Error.Please check your wifi or data network and re-login.",1,0)
        return
    end

    local function onProgress(percent)
        if ff.loadingLayer ~=nil then
            ff.loadingLayer:setProgress(percent)
        end           
    end

    local function onError(errorCode)
        local action = 0
        local function callNextCDN()
            cc.Director:getInstance():getScheduler():unscheduleScriptEntry(action)
            index = index + 1
            doAssetsManager(result['cur'])
        end
        if errorCode == cc.ASSETSMANAGER_NO_NEW_VERSION then
            cclog("no new version")
        elseif errorCode == cc.ASSETSMANAGER_NETWORK then
            cclog("network error")
            action = cc.Director:getInstance():getScheduler():scheduleScriptFunc(callNextCDN, 1, false)
            return
        end
        if assetsManager ~= nil then
            assetsManager:release()
            assetsManager = nil
        end
        if ff.loadingLayer ~= nil then               
            ff.loadingLayer:setVersion(getVersion())
        end        
        if error ~= nil then
            error(errorCode)
        end
    end
    local function onSuccess()
        cclog("onSuccess")
        if ff.loadingLayer ~= nil then
            package.loaded["version"] = nil  
            require("version")  
            
            platform_setVersion_Gdx("version:"..ff.apk_version_name.."."..cc.UserDefault:getInstance():getIntegerForKey("version"))
            ff.needUpdate = true
            --重读字典
            package.loaded["lang"] = nil  
            require("lang")              
            ff.loadingLayer:showVersionDetail(ff.old_version)
        end
        if assetsManager ~= nil then
            assetsManager:release()
            assetsManager = nil
        end
        if success ~= nil then
            success()
        end 
    end


    assetsManager:setDelegate(onError, cc.ASSETSMANAGER_PROTOCOL_ERROR )
    assetsManager:setDelegate(onProgress, cc.ASSETSMANAGER_PROTOCOL_PROGRESS)
    assetsManager:setDelegate(onSuccess, cc.ASSETSMANAGER_PROTOCOL_SUCCESS )
    assetsManager:setConnectionTimeout(30)
    --版本判断
    ff.db_version = cc.UserDefault:getInstance():getIntegerForKey("dbversion")
    ff.old_version= cc.UserDefault:getInstance():getIntegerForKey("version")
    cclog("min:"..tonumber(result['min'])..","..cc.UserDefault:getInstance():getIntegerForKey("version"))
    if tonumber(result['min']) > cc.UserDefault:getInstance():getIntegerForKey("version") then
        --platform_showDialog(ff.langString("更新错误"),ff.langString("版本太旧，不能更新了。"),999,0)
        platform_showDialog("New Version", "Commander, new version is available on Google Play. Go to Google Play to update your apk.You can update your apk with Dropbox if you DO NOT have installed Google Play.",999,0)
        platform_showLoadingBar(99)
        platform_setLoadingBarTipColor(cc.c3b(255,0,0))      
        --ff.loadingLayer:setTips(ff.langString("版本太旧，不能更新了。"))
        ff.loadingLayer:setTips("Please Update your Z War.")
    else
        if result['db'] ~= nil then
            ff.db_version = tonumber(result['db'])
        end
        cclog("当前使用数据库版本:"..ff.db_version)
        if tonumber(result['cur']) <= cc.UserDefault:getInstance():getIntegerForKey("version") then
            onError(cc.ASSETSMANAGER_NO_NEW_VERSION)
        elseif tonumber(result['cur']) > cc.UserDefault:getInstance():getIntegerForKey("version") then
            if ff.loadingLayer ~=nil then
                platform_showLoadingBar(1)
                --ff.loadingLayer:setTips(ff.langString("更新版本").."...")
                ff.loadingLayer:setTips("Updated version...")
            end           
            --获取cdn地址
            local ret = hif.doPost("server","code=cdn1&version="..cc.UserDefault:getInstance():getIntegerForKey("version"))
            cdns = Split(ret,",")
            doAssetsManager(result['cur'])
        end
    end
end