AlchemistSkillLayer = class("AlchemistSkillLayer")
AlchemistSkillLayer._name = "AlchemistSkill"
AlchemistSkillLayer._init = false


function AlchemistSkillLayer.extend( target )
	-- body
	local t = tolua.getpeer(target)
	if not t then
		t = {}
		tolua.setpeer(target,t)
	end
	setmetatable(t,AlchemistSkillLayer)
	return target
end

function AlchemistSkillLayer:onInit(  )
	if self._init == false then
		local hh = ff.height
        self:setContentSize(cc.size(720,hh))
        self:getChildByName("mask"):setContentSize(cc.size(720,hh))

        self:getChildByName("view"):setPositionY(214)

        self:getChildByName("view"):getChildByName("close"):addTouchEventListener(self.onReturn)
        for i=1,4 do
            self:getChildByName("view"):getChildByName("item"..i):setTag(i)
            self:getChildByName("view"):getChildByName("item"..i):addTouchEventListener(self.onUse)
        end
        self._init = true
	end
end

function AlchemistSkillLayer.onUse( sender,eventType  )
    local close = false
    if sender == nil then
        close = true
    end
    if eventType == ccui.TouchEventType.ended then
        close = true
    end
    if close == true then
        local widget = pop.getDialog("AlchemistSkill")
        if widget == nil then
            return
        end
        local i = sender:getTag()
        if dd.myAlchemist:getLong(1,"level") >= dd.Cfg_Alchemist_Skill[i]["kaifanglv"] and dd.myAlchemist:getLong(1,"skill"..i.."CD") < dd.getServerTime() then        
            local message = ff.net:createMessage()
            message:addCmd(0x00000143)
            message:addLong(dd.uid)         
            message:addLong(6) 
            message:addLong(i)

            for i=1,7 do
                message:addLong(0)
            end
            
            ff.net:rpc(message, false)
        end
    end
end

function AlchemistSkillLayer.onStart( sender )
    sender:showList()
    schedule(sender, sender.update,1)
end


function AlchemistSkillLayer.onReturn( sender,eventType )
	local close = false
    if sender == nil then
        close = true
    end
    if eventType == ccui.TouchEventType.ended then
        close = true
    end
    if close == true then
        local widget = pop.getDialog("AlchemistSkill")
		if widget == nil then
			return
		end
        pop.onClosePopDialog("AlchemistSkill")
    end
end

function AlchemistSkillLayer.onEnd( sender )
    -- body
    dd.delBackEvent()
    
    sender:stopAllActions()

end

function onShowAlchemistSkill(widget)
	-- body
	local layer = AlchemistSkillLayer.extend(widget)
	dd.regeditBackEvent(layer.onReturn)
    layer:onInit()
    return layer
end

function AlchemistSkillLayer.onBefore( sender)
    
end


function AlchemistSkillLayer.update( sender )
    if dd.myAlchemist ~= nil then
        for i=1,4 do

            if dd.myAlchemist:getLong(1,"skill"..i.."CD") > dd.getServerTime() then
                local time = dd.myAlchemist:getLong(1,"skill"..i.."CD") - dd.getServerTime()
                sender:getChildByName("view"):getChildByName("item"..i):getChildByName("time"):setString(ff.getLeftTime(time,":"))
            else
            	sender:getChildByName("view"):getChildByName("item"..i):getChildByName("time"):setString("")
            end
            
        end
    end
end


function AlchemistSkillLayer:showList(  )
    if dd.myAlchemist ~= nil then
        for i=1,4 do
            self:getChildByName("view"):getChildByName("item"..i):getChildByName("icon"):getChildByName("icon"):loadTexture("images/icon/tools/"..dd.Cfg_Alchemist_Skill[i]["pic"]..".png",0)
            self:getChildByName("view"):getChildByName("item"..i):getChildByName("name"):getChildByName("name"):setString(ff.langString(dd.Cfg_Alchemist_Skill[i]["name"]))
            if dd.myAlchemist:getLong(1,"level") >= dd.Cfg_Alchemist_Skill[i]["kaifanglv"] then
                self:getChildByName("view"):getChildByName("item"..i):getChildByName("icon"):getChildByName("lock"):setVisible(false)
            else
                self:getChildByName("view"):getChildByName("item"..i):getChildByName("icon"):getChildByName("lock"):setVisible(true)
            end
            if dd.myAlchemist:getLong(1,"skill"..i.."CD") > dd.getServerTime() then
                local time = dd.myAlchemist:getLong(1,"skill"..i.."CD") - dd.getServerTime()
                self:getChildByName("view"):getChildByName("item"..i):getChildByName("time"):setString(ff.getLeftTime(time,":"))
            end
            self:getChildByName("view"):getChildByName("item"..i):getChildByName("count"):getChildByName("value"):setString("LV."..dd.myAlchemist:getLong(1,"level") )
        end
    end
end
