ExchangeItemLayer = class("ExchangeItemLayer")
ExchangeItemLayer._name = "ExchangeItem"
ExchangeItemLayer._init = false
ExchangeItemLayer._info = {}
ExchangeItemLayer._list = {}

function ExchangeItemLayer.extend( target )
	-- body
	local t = tolua.getpeer(target)
	if not t then
		t = {}
		tolua.setpeer(target,t)
	end
	setmetatable(t,ExchangeItemLayer)
	return target
end

function ExchangeItemLayer:onInit(  )
	-- body
	if self._init == false then
		local hh = ff.height
		self:setContentSize(cc.size(720,hh))
		
		self:getChildByName("bg"):setContentSize(cc.size(720,hh))
		self:getChildByName("topArea"):setPositionY(hh - 105)
		self:getChildByName("list"):setContentSize(cc.size(720,hh- 105 - 160))
    	self:getChildByName("list"):setPositionY(160)
        self:getChildByName("oper"):getChildByName("join"):getChildByName("Label"):setString(ff.langString("刷新"))
        self:getChildByName("oper"):getChildByName("join"):addTouchEventListener(self.onJoin)
        self:getChildByName("topArea"):getChildByName("backbtn"):addTouchEventListener(self.onReturn)
        self:getChildByName("item"):getChildByName("buy"):addTouchEventListener(self.onBtn)
        self:getChildByName("topArea"):getChildByName("addbtn"):addTouchEventListener(dd.onPay)
        --self:getChildByName("topArea"):getChildByName("title"):getChildByName("chu_title"):setString(ff.langString("交易所"))
        --self:getChildByName("topArea"):getChildByName("title"):getChildByName("chu_title"):getVirtualRenderer():enableBold(true)
        --self:getChildByName("topArea"):getChildByName("title"):requestDoLayout()
        self:getChildByName("item"):getChildByName("ico"):addTouchEventListener(self.onShowTips)
       
        self._init = true
	end
	self.updateGold()
end

function ExchangeItemLayer.onShowTips(sender, eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end

    if eventType==ccui.TouchEventType.ended then    
        doaction = true
    end
    if doaction == true then        
        local widget = pop.getDialog("ExchangeItem")
        local pos2word = widget:getWorldPos(sender)
        local pos = widget:convertToNodeSpace(pos2word) 
        pos = cc.p(pos.x, pos.y+30)
        widget:showTips(sender.type, sender.id, sender.count, pos)
    end
end

function ExchangeItemLayer:showTips(type, id, count, pos)
    local ret  = dd.getGiftsTips(type, id, count)
    local name = ret[1]
    local str  = ret[2]
    
    local tips = self:getChildByName("tips")
    local wid  = 360
    tips:stopAllActions()
    tips:setVisible(true)
    tips:getChildByName("tips"):removeAllChildren(true)

    local richText = ccui.RichText:create()
    richText:ignoreContentAdaptWithSize(false)
    richText:setContentSize(cc.size(wid-30,600))    
    richText:setAutoHeight()

    local chat = ccui.RichElementText:create(1, cc.c3b(161,175,175), 255, str, "Helvetica", 20)
    richText:insertElement(chat,0)
    richText:formatText()

    local size = richText:getContentSize()
    richText:setPosition(cc.p(172,size.height/2 + 15))
    tips:setContentSize(cc.size(wid, size.height + 60))
    tips:getChildByName("tips"):setContentSize(cc.size(wid, size.height + 60))
    tips:getChildByName("tips"):addChild(richText)

    tips:getChildByName("name"):setString(name) 
    tips:getChildByName("name"):setPositionY(size.height + 40)

    tips:setPosition(pos)
    if pos.x < 300 then
        tips:setAnchorPoint(cc.p(0.2,0))
        tips:getChildByName("flag"):setPositionX(wid*0.2)
    elseif pos.x > 550 then
        tips:setAnchorPoint(cc.p(0.8,0))
        tips:getChildByName("flag"):setPositionX(wid*0.8)
    else
        tips:setAnchorPoint(cc.p(0.5,0))
        tips:getChildByName("flag"):setPositionX(wid*0.5)
    end       
    local function sched()
        tips:setVisible(false)
    end 

    performWithDelay(tips,sched,1.5) 
end

function ExchangeItemLayer.onJoin(sender,eventType)
    if eventType==ccui.TouchEventType.ended then 
        local widget = pop.getDialog("ExchangeItem")     
        if widget == nil or next(widget._info) == nil then
            return
        end
        local count = tonumber(widget._info.needGold)
        if count < dd.gold() then
            local message = ff.net:createMessage()
            message:addCmd(0x0000017f)
            message:addLong(dd.uid)         
            message:addLong(9)   
            message:addLong(0)
            ff.net:rpc(message, false)
            sender:setTouchEnabled(false)
        else
            local function sure()
                pop.onShowPopDialog("charge")
            end
            dd.mainUI:onShowSure(ff.langString("金币不足"),ff.langString("充值可以让你立即拥有大量金币.\n是否现在就去?"),sure,true,2,2,ff.langString("充值"))
            return
        end
        
        local function sched()
            sender:setTouchEnabled(true)
        end 
        performWithDelay(sender,sched,0.5)
    end
end

function ExchangeItemLayer.onStart( sender )
	ff.net:bindProperty(2337,"gold",sender.updateGold)
    dd.initGoldSpine(sender:getChildByName("topArea"):getChildByName("gold"),sender:getChildByName("topArea"):getChildByName("addbtn"))
    sender:getList()
    
    --schedule(sender, sender.update,1)
    
end

function ExchangeItemLayer.onReturn( sender,eventType )
	local close = false
    if sender == nil then
        close = true
    end
    if eventType == ccui.TouchEventType.ended then
        close = true
    end
    if close == true then
        local widget = pop.getDialog("ExchangeItem")
		if widget == nil then
			return
		end
        pop.onClosePopDialog("ExchangeItem")
    end
end


function ExchangeItemLayer.onBtn( sender,eventType )
    
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("ExchangeItem")     
        if widget == nil or next(widget._info) == nil then
            return
        end
        local slot = sender:getTag()
        
            local message = ff.net:createMessage()
            message:addCmd(0x0000017f)
            message:addLong(dd.uid)         
            message:addLong(1)   
            message:addLong(slot)
            ff.net:rpc(message, false)

    end
    
end

function ExchangeItemLayer.onEnd( sender )
    -- body
    dd.delBackEvent()
    ff.net:removeEvent(2,dd.Tjf_ExchangeItemAction)
    ff.net:removeEvent(2,dd.Tjf_notify_SNSoldierTrap)
    sender:stopAllActions()
    sender:getChildByName("list"):removeAllChildren(true)
    ff.net:unbindProperty("gold",2337)
end

function onShowExchangeItem(widget)
	-- body
	local layer = ExchangeItemLayer.extend(widget)
	dd.regeditBackEvent(layer.onReturn)
    layer:onInit()
    return layer
end

function ExchangeItemLayer:getList()
    local message = ff.net:createMessage()
    message:addCmd(0x0000017f)
    message:addLong(dd.uid)
    message:addLong(0)
    message:addLong(0)
    ff.net:rpc(message,false)
end

function ExchangeItemLayer.onBefore( sender)
  -- bod
    ff.net:registerEvent(2,dd.Tjf_ExchangeItemAction, function (message)sender:ExchangeItemAction(message)end)
    ff.net:registerEvent(2,dd.Tjf_notify_SNSoldierTrap, function ()sender:SNSoldierTrap()end)
    
end

function ExchangeItemLayer:SNSoldierTrap()
     if dd.cityLayer ~= nil then
        dd.cityLayer:updateCityArmys()
    end
end
function ExchangeItemLayer:ExchangeItemAction(params)
    local code = params[1]
    if code == 0 then
        self._info = params[2]
        self._list = params[3]
        self:showList()
        if self._info.type == 1 then
            local gifts = {}
            gifts[1] = {}
            gifts[1]["type"] = self._info.ttype
            gifts[1]["id"] = self._info.tid
            gifts[1]["count"] = self._info.getcount
            if gifts ~= nil then
                pop.onShowPopDialog("reward",gifts,ff.langString("购买成功"))
            end

        end
        if self._info.type == 9 then
            if dd.currentLayer._widget ~= nil then
               dd.currentLayer._widget:onShowTips("\t"..ff.langString("刷新成功！"),true)
            end
        end
        
    else
        dd.mainUI:onShowCodeTips(code)
    end
end


function ExchangeItemLayer.update( sender )
    if next(sender._info) == nil then
        return
    end
    if sender._list == nil or next(sender._list) == nil then
        return
    end
    local time = sender._info.refreshTime - dd.getServerTime()
    sender:getChildByName("oper"):getChildByName("time"):setString(ff.langString("CD")..":"..ff.getLeftTime(time,":"))
end

function ExchangeItemLayer:getWorldPos(node)
    local anr   = node:getAnchorPoint()
    local size  = node:getContentSize()
    local p = node:convertToWorldSpace(cc.p(anr.x * size.width,anr.y * size.height)) --世界坐标
    return p
end


function ExchangeItemLayer:showList(  )
    if next(self._info) == nil then
        return
    end
    if self._list == nil or next(self._list) == nil then
        return
    end
            
    for k,v in pairs(self._list) do
        local item = self:getChildByName("list"):getChildByTag(k)
        if item == nil then
            item = self:getChildByName("item"):clone()
            item:setVisible(true)
            item:setTag(k)

            self:getChildByName("list"):pushBackCustomItem(item)
        end
        cclog("======="..v["buyId"])
        item:getChildByName("ico").type = v["buytype"]
        item:getChildByName("ico").id = v["buyId"]
        item:getChildByName("ico").count = v["buycount"]
        item:getChildByName("buy"):setTag(v["slot"])
        if v["state"] == 1 then
            local effect = ff.Effect:effectGrey()    
            item:getChildByName("buy"):getVirtualRenderer():setGLProgramState(effect:getGLProgramState())
            item:getChildByName("buy"):setTouchEnabled(false)
            dd.setContainGLState(item,1)
            --item:getChildByName("ico"):getChildByName("ico"):getVirtualRenderer():setGLProgramState(effect:getGLProgramState())
            
        else
            item:getChildByName("buy"):getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
            item:getChildByName("buy"):setTouchEnabled(true)
            dd.setContainGLState(item,2)
            --item:getChildByName("ico"):getChildByName("ico"):setGLProgramState(ff.gameCore:getNormalGLState())
        end
        if dd.cfgProp[v["buyId"]] ~= nil then
            item:getChildByName("ico"):loadTexture(dd.getPathFromUI("ExchangeItem_color"..dd.cfgProp[v["buyId"]]["color"]..".png",1))
        else
            item:getChildByName("ico"):loadTexture(dd.getPathFromUI("ExchangeItem_color1.png",1))
        end
        if v["buytype"] == 1 then
            item:getChildByName("name"):setString(ff.langString(dd.cfgProp[v["buyId"]]['name'],{dd.cfgProp[v["buyId"]]['name1_lan']}))
            item:getChildByName("count"):setString("X "..v["buycount"])
        else
            item:getChildByName("name"):setString(dd.getGiftsTips(v["buytype"],v["buyId"],v["buycount"])[1])
            item:getChildByName("count"):setString("X "..v["buycount"])
        end
        item:getChildByName("ico"):getChildByName("ico"):loadTexture(dd.getGiftsIcon(tonumber(v["buytype"]), tonumber(v["buyId"]))[1],dd.getGiftsIcon(tonumber(v["buytype"]), tonumber(v["buyId"]))[2])
        local sale = 100 - v["sale"]/10
        item:getChildByName("sale"):getChildByName("value"):setString(sale.."%")
        item:getChildByName("buy"):getChildByName("now"):setString(v["nowprace"])
        item:getChildByName("buy"):getChildByName("yuan"):setString(v["needcount"])
    end
    self:getChildByName("oper"):getChildByName("join"):getChildByName("count"):setString(self._info.needGold)

    self:getChildByName("oper"):getChildByName("time"):setString(ff.langString("今日剩余次数")..":"..self._info.left.."/10")
    cclog("==="..self._info.left)
    if self._info.left < 1 then
        local effect = ff.Effect:effectGrey()    
        self:getChildByName("oper"):getChildByName("join"):getVirtualRenderer():setGLProgramState(effect:getGLProgramState())
        self:getChildByName("oper"):getChildByName("join"):setTouchEnabled(false)
        self:getChildByName("oper"):getChildByName("join"):setEnabled(false)
    else
        self:getChildByName("oper"):getChildByName("join"):getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
        self:getChildByName("oper"):getChildByName("join"):setTouchEnabled(true)
        self:getChildByName("oper"):getChildByName("join"):setEnabled(true)
    end
end

function ExchangeItemLayer.updateGold(name,row,old,value)
    local widget = pop.getDialog("ExchangeItem")
    if widget ~= nil then
        widget:getChildByName("topArea"):getChildByName("money"):setString(dd.myinfo:getLong(1,"gold"))
        local w = widget:getChildByName("topArea"):getChildByName("money"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        widget:getChildByName("topArea"):getChildByName("title"):setContentSize(cc.size(w,100))
        widget:getChildByName("topArea"):getChildByName("title"):requestDoLayout()
        widget:getChildByName("topArea"):requestDoLayout()
    end
end