local bankLayer = class("bankLayer")
bankLayer._name = "bankLayer"
bankLayer._init = false 
bankLayer._pos  = 0
bankLayer._bid  = 0
bankLayer._lv   = 0
bankLayer._type = 1
bankLayer._jjType = 1 
bankLayer._Cfg_growthFund = {}

function bankLayer.extend( target )
	local b = tolua.getpeer(target)
	if not b then
		b = {}
		tolua.setpeer(target,b)
	end
	setmetatable(b,bankLayer)
	return target
end

function onShowBank( widget ,pos)
	local layer = bankLayer.extend(widget)
	layer._pos = pos
	layer:onInit()
	return layer
end

function bankLayer:onInit(  )
	for i=1,dd.mybuilds:rowCount() do
        if dd.mybuilds:getLong(i,"pos") == self._pos then

            self._bid = dd.mybuilds:getLong(i,"bid")
            self._lv = dd.mybuilds:getLong(i,"level")
 
            break
        end
    end

    if self._lv == 0 then
        self._lv = 1 --刚建造的时候按照1级的数据处理
    end

    if self._init == false then
    	if dd.currentLayer._pop ~= nil then
			self:onAutoSize()
		end
    	self._init = true
    end
    self:initDate()
    self:getChildByName("info"):getChildByName("ico"):loadTexture("images/bank/bank_back.jpg",0)

    self._jjType = 1 
end

function bankLayer:initDate(  )
	local propData1 = ff.dbmanager:sql_fetch_rows("SELECT * FROM `cfg_growthfund`  ORDER BY `type` ASC")
    for i=1, propData1:rowCount() do
        local type = tonumber(propData1:getString(i, "type"))
        self._Cfg_growthFund[type] = {}
        self._Cfg_growthFund[type]['banklv']   = tonumber(propData1:getString(i, "lv"))
        self._Cfg_growthFund[type]['gold'] = tonumber(propData1:getString(i, "gold"))
        self._Cfg_growthFund[type]['sum'] = tonumber(propData1:getString(i, "sum"))
        self._Cfg_growthFund[type]['hqlv1'] = tonumber(propData1:getString(i, "hqlv1"))
        self._Cfg_growthFund[type]['hqlv2'] = tonumber(propData1:getString(i, "hqlv2"))
        self._Cfg_growthFund[type]['hqlv3'] = tonumber(propData1:getString(i, "hqlv3"))
        self._Cfg_growthFund[type]['hqlv4'] = tonumber(propData1:getString(i, "hqlv4"))
        self._Cfg_growthFund[type]['reward1'] = propData1:getString(i, "reward1")
        self._Cfg_growthFund[type]['reward2'] = propData1:getString(i, "reward2")
        self._Cfg_growthFund[type]['reward3'] = propData1:getString(i, "reward3")
        self._Cfg_growthFund[type]['reward4'] = propData1:getString(i, "reward4")
    end
    propData1:clear()
end

function bankLayer.openPop(sender,eventType)
    -- body
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true

    end

    if doaction == true then
        local widget = pop.getDialog("bank") 
        widget._jjType = sender:getTag()
        widget:updatePopInfo()
        pop.showPopEffect(12,widget:getChildByName("pop"))
        --widget:getChildByName("pop"):setVisible(true)
    end
end

function bankLayer.buyJJ(sender,touchEventType)
    if touchEventType==ccui.TouchEventType.ended then  
        local widget = pop.getDialog("bank") 
        local tag = sender:getTag()
        if tag == 1 then
            local canbuy = true
            
            if widget._lv < widget._Cfg_growthFund[widget._jjType]['banklv'] then
                dd.mainUI:onShowTips(ff.langString("银行等级不足")) 
                return
            end
            local message = ff.net:createMessage()
            message:addCmd(0x00000133)
            message:addLong(dd.uid)
            message:addLong(widget._jjType)
            ff.net:rpc(message,false)      
        else
            widget:getChildByName("pop"):setVisible(false)
        end   

        --widget:getChildByName("pop"):setVisible(true)
    end
end

function bankLayer.getLevelRe(sender,eventType)
    -- body
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end
    if doaction == true then
        local widget = pop.getDialog("bank") 
        local tag = sender:getTag()
        
        local message = ff.net:createMessage()
        message:addCmd(0x00000134)
        message:addLong(dd.uid)
        message:addLong(35)
        message:addLong(tag)
        ff.net:rpc(message,false)   

        --widget:getChildByName("pop"):setVisible(true)
    end
end

function bankLayer:updatePopInfo(  )
    local view = self:getChildByName("pop"):getChildByName("view")
    view:getChildByName("infoex"):getChildByName("tiao1"):setColor(cc.c3b(255,195,0))
    view:getChildByName("infoex"):getChildByName("tiao2"):setColor(cc.c3b(255,195,0))
    view:getChildByName("infoex"):getChildByName("tiao3"):setColor(cc.c3b(255,195,0))
    view:getChildByName("infoex"):getChildByName("tiao4"):setColor(cc.c3b(255,195,0))
    if self._jjType == 1 then
        view:getChildByName("title"):getChildByName("chu_title"):setString(ff.langString("初级成长基金"))
        view:getChildByName("info"):getChildByName("icon"):loadTexture(dd.getPathFromUI("bank_1.png",1))
        view:getChildByName("info"):getChildByName("count"):setString(self._Cfg_growthFund[1]['sum'])

        view:getChildByName("info"):getChildByName("need"):setString(ff.langString("需要银行LV.{0}",{self._Cfg_growthFund[1]['banklv']}))
        if self._lv >= self._Cfg_growthFund[1]['banklv'] then
            view:getChildByName("info"):getChildByName("need"):setColor(cc.c3b(7,159,0))
        else
            view:getChildByName("info"):getChildByName("need"):setColor(cc.c3b(237,101,101))
        end
        view:getChildByName("infoex"):getChildByName("tiao1"):setString(ff.langString("司令部达到{0}后获得",{self._Cfg_growthFund[1]['hqlv1']}))
        view:getChildByName("infoex"):getChildByName("tiao2"):setString(ff.langString("司令部达到{0}后获得",{self._Cfg_growthFund[1]['hqlv2']}))
        view:getChildByName("infoex"):getChildByName("tiao3"):setString(ff.langString("司令部达到{0}后获得",{self._Cfg_growthFund[1]['hqlv3']}))
        view:getChildByName("infoex"):getChildByName("tiao4"):setString(ff.langString("司令部达到{0}后获得",{self._Cfg_growthFund[1]['hqlv4']}))
        
        local gift = Split(self._Cfg_growthFund[1]['reward1'],'%^')
        view:getChildByName("infoex"):getChildByName("cost1"):setString(gift[3])
        gift = Split(self._Cfg_growthFund[1]['reward2'],'%^')
        view:getChildByName("infoex"):getChildByName("cost2"):setString(gift[3])
        gift = Split(self._Cfg_growthFund[1]['reward3'],'%^')
        view:getChildByName("infoex"):getChildByName("cost3"):setString(gift[3])
        gift = Split(self._Cfg_growthFund[1]['reward4'],'%^')
        view:getChildByName("infoex"):getChildByName("cost4"):setString(gift[3])
        for i=1,dd.myGrowthFund:rowCount() do
            if dd.myGrowthFund:getLong(i,"type") == 1 then
                if dd.myGrowthFund:getLong(i,"state") > 99 then
                    local time = dd.myGrowthFund:getLong(i,"state")-dd.getServerTime()
                    view:getChildByName("title"):getChildByName("time"):setString(ff.getLeftTime(time,":")) 
                    view:getChildByName("pay"):getChildByName("info1"):setVisible(true) 
                    view:getChildByName("pay"):getChildByName("info2"):setVisible(false) 
                    view:getChildByName("pay"):setTag(1)
                    view:getChildByName("pay"):getChildByName("info1"):getChildByName("sell"):setString(self._Cfg_growthFund[1]['gold'])
                else
                    if dd.myGrowthFund:getLong(i,"state") ~= -1  then
                        if dd.myinfo:getLong(1,"level") >= self._Cfg_growthFund[1]['hqlv1'] then
                            view:getChildByName("infoex"):getChildByName("tiao1"):setColor(cc.c3b(113,128,133))
                        else
                            view:getChildByName("infoex"):getChildByName("tiao1"):setColor(cc.c3b(255,195,0))
                        end
                        if dd.myinfo:getLong(1,"level") >= self._Cfg_growthFund[1]['hqlv2'] then
                            view:getChildByName("infoex"):getChildByName("tiao2"):setColor(cc.c3b(113,128,133))
                        else
                            view:getChildByName("infoex"):getChildByName("tiao2"):setColor(cc.c3b(255,195,0))
                        end
                        if dd.myinfo:getLong(1,"level") >= self._Cfg_growthFund[1]['hqlv3'] then
                            view:getChildByName("infoex"):getChildByName("tiao3"):setColor(cc.c3b(113,128,133))
                        else
                            view:getChildByName("infoex"):getChildByName("tiao3"):setColor(cc.c3b(255,195,0))
                        end
                        if dd.myinfo:getLong(1,"level") >= self._Cfg_growthFund[1]['hqlv4'] then
                            view:getChildByName("infoex"):getChildByName("tiao4"):setColor(cc.c3b(113,128,133))
                        else
                            view:getChildByName("infoex"):getChildByName("tiao4"):setColor(cc.c3b(255,195,0))
                        end
                    end
                    view:getChildByName("title"):getChildByName("time"):setString("")
                   
                    view:getChildByName("pay"):getChildByName("info1"):setVisible(false) 
                    view:getChildByName("pay"):getChildByName("info2"):setVisible(true) 
                    view:getChildByName("pay"):setTag(2)
                end
                break
            end
        end
        
    elseif self._jjType == 2 then
        view:getChildByName("title"):getChildByName("chu_title"):setString(ff.langString("中级成长基金"))
        view:getChildByName("info"):getChildByName("icon"):loadTexture(dd.getPathFromUI("bank_2.png",1))
        view:getChildByName("info"):getChildByName("count"):setString(self._Cfg_growthFund[2]['sum'])
        view:getChildByName("info"):getChildByName("need"):setString(ff.langString("需要银行LV.{0}",{self._Cfg_growthFund[2]['banklv']}))
        if self._lv >= self._Cfg_growthFund[2]['banklv'] then
            view:getChildByName("info"):getChildByName("need"):setColor(cc.c3b(7,159,0))
        else
            view:getChildByName("info"):getChildByName("need"):setColor(cc.c3b(237,101,101))
        end
        view:getChildByName("infoex"):getChildByName("tiao1"):setString(ff.langString("司令部达到{0}后获得",{self._Cfg_growthFund[2]['hqlv1']}))
        view:getChildByName("infoex"):getChildByName("tiao2"):setString(ff.langString("司令部达到{0}后获得",{self._Cfg_growthFund[2]['hqlv2']}))
        view:getChildByName("infoex"):getChildByName("tiao3"):setString(ff.langString("司令部达到{0}后获得",{self._Cfg_growthFund[2]['hqlv3']}))
        view:getChildByName("infoex"):getChildByName("tiao4"):setString(ff.langString("司令部达到{0}后获得",{self._Cfg_growthFund[2]['hqlv4']}))
        
        local gift = Split(self._Cfg_growthFund[2]['reward1'],'%^')
        view:getChildByName("infoex"):getChildByName("cost1"):setString(gift[3])
        gift = Split(self._Cfg_growthFund[2]['reward2'],'%^')
        view:getChildByName("infoex"):getChildByName("cost2"):setString(gift[3])
        gift = Split(self._Cfg_growthFund[2]['reward3'],'%^')
        view:getChildByName("infoex"):getChildByName("cost3"):setString(gift[3])
        gift = Split(self._Cfg_growthFund[2]['reward4'],'%^')
        view:getChildByName("infoex"):getChildByName("cost4"):setString(gift[3])
        for i=1,dd.myGrowthFund:rowCount() do
            if dd.myGrowthFund:getLong(i,"type") == 2 then
                if dd.myGrowthFund:getLong(i,"state") > 99 then
                    local time = dd.myGrowthFund:getLong(i,"state")-dd.getServerTime()
                    view:getChildByName("title"):getChildByName("time"):setString(ff.getLeftTime(time,":")) 
                    view:getChildByName("pay"):getChildByName("info1"):setVisible(true) 
                    view:getChildByName("pay"):getChildByName("info2"):setVisible(false) 
                    view:getChildByName("pay"):setTag(1)
                    view:getChildByName("pay"):getChildByName("info1"):getChildByName("sell"):setString(self._Cfg_growthFund[2]['gold'])
                else
                    if dd.myGrowthFund:getLong(i,"state") ~= -1 then
                        if dd.myinfo:getLong(1,"level") >= self._Cfg_growthFund[2]['hqlv1'] then
                            view:getChildByName("infoex"):getChildByName("tiao1"):setColor(cc.c3b(113,128,133))
                        else
                            view:getChildByName("infoex"):getChildByName("tiao1"):setColor(cc.c3b(255,195,0))
                        end
                        if dd.myinfo:getLong(1,"level") >= self._Cfg_growthFund[2]['hqlv2'] then
                            view:getChildByName("infoex"):getChildByName("tiao2"):setColor(cc.c3b(113,128,133))
                        else
                            view:getChildByName("infoex"):getChildByName("tiao2"):setColor(cc.c3b(255,195,0))
                        end
                        if dd.myinfo:getLong(1,"level") >= self._Cfg_growthFund[2]['hqlv3'] then
                            view:getChildByName("infoex"):getChildByName("tiao3"):setColor(cc.c3b(113,128,133))
                        else
                            view:getChildByName("infoex"):getChildByName("tiao3"):setColor(cc.c3b(255,195,0))
                        end
                        if dd.myinfo:getLong(1,"level") >= self._Cfg_growthFund[2]['hqlv4'] then
                            view:getChildByName("infoex"):getChildByName("tiao4"):setColor(cc.c3b(113,128,133))
                        else
                            view:getChildByName("infoex"):getChildByName("tiao4"):setColor(cc.c3b(255,195,0))
                        end
                    end
                    view:getChildByName("title"):getChildByName("time"):setString("")
                
                    view:getChildByName("pay"):getChildByName("info1"):setVisible(false) 
                    view:getChildByName("pay"):getChildByName("info2"):setVisible(true) 
                    view:getChildByName("pay"):setTag(2)
                end
                break
            end
        end
    elseif self._jjType == 3 then
        view:getChildByName("title"):getChildByName("chu_title"):setString(ff.langString("高级成长基金"))
        view:getChildByName("info"):getChildByName("icon"):loadTexture(dd.getPathFromUI("bank_3.png",1))
        view:getChildByName("info"):getChildByName("count"):setString(self._Cfg_growthFund[3]['sum'])
        view:getChildByName("info"):getChildByName("need"):setString(ff.langString("需要银行LV.{0}",{self._Cfg_growthFund[3]['banklv']}))
        if self._lv >= self._Cfg_growthFund[3]['banklv'] then
            view:getChildByName("info"):getChildByName("need"):setColor(cc.c3b(7,159,0))
        else
            view:getChildByName("info"):getChildByName("need"):setColor(cc.c3b(237,101,101))
        end
        view:getChildByName("infoex"):getChildByName("tiao1"):setString(ff.langString("司令部达到{0}后获得",{self._Cfg_growthFund[3]['hqlv1']}))
        view:getChildByName("infoex"):getChildByName("tiao2"):setString(ff.langString("司令部达到{0}后获得",{self._Cfg_growthFund[3]['hqlv2']}))
        view:getChildByName("infoex"):getChildByName("tiao3"):setString(ff.langString("司令部达到{0}后获得",{self._Cfg_growthFund[3]['hqlv3']}))
        view:getChildByName("infoex"):getChildByName("tiao4"):setString(ff.langString("司令部达到{0}后获得",{self._Cfg_growthFund[3]['hqlv4']}))
        
        local gift = Split(self._Cfg_growthFund[3]['reward1'],'%^')
        view:getChildByName("infoex"):getChildByName("cost1"):setString(gift[3])
        gift = Split(self._Cfg_growthFund[3]['reward2'],'%^')
        view:getChildByName("infoex"):getChildByName("cost2"):setString(gift[3])
        gift = Split(self._Cfg_growthFund[3]['reward3'],'%^')
        view:getChildByName("infoex"):getChildByName("cost3"):setString(gift[3])
        gift = Split(self._Cfg_growthFund[3]['reward4'],'%^')
        view:getChildByName("infoex"):getChildByName("cost4"):setString(gift[3])
        for i=1,dd.myGrowthFund:rowCount() do
            if dd.myGrowthFund:getLong(i,"type") == 3 then
                if dd.myGrowthFund:getLong(i,"state") > 99 then
                    local time = dd.myGrowthFund:getLong(i,"state")-dd.getServerTime()
                    view:getChildByName("title"):getChildByName("time"):setString(ff.getLeftTime(time,":")) 
                    view:getChildByName("pay"):getChildByName("info1"):setVisible(true) 
                    view:getChildByName("pay"):getChildByName("info2"):setVisible(false) 
                    view:getChildByName("pay"):setTag(1)
                    view:getChildByName("pay"):getChildByName("info1"):getChildByName("sell"):setString(self._Cfg_growthFund[3]['gold'])
                else
                    if dd.myGrowthFund:getLong(i,"state") ~= -1 then
                        if dd.myinfo:getLong(1,"level") >= self._Cfg_growthFund[3]['hqlv1'] then
                            view:getChildByName("infoex"):getChildByName("tiao1"):setColor(cc.c3b(113,128,133))
                        else
                            view:getChildByName("infoex"):getChildByName("tiao1"):setColor(cc.c3b(255,195,0))
                        end
                        if dd.myinfo:getLong(1,"level") >= self._Cfg_growthFund[3]['hqlv2'] then
                            view:getChildByName("infoex"):getChildByName("tiao2"):setColor(cc.c3b(113,128,133))
                        else
                            view:getChildByName("infoex"):getChildByName("tiao2"):setColor(cc.c3b(255,195,0))
                        end
                        if dd.myinfo:getLong(1,"level") >= self._Cfg_growthFund[3]['hqlv3'] then
                            view:getChildByName("infoex"):getChildByName("tiao3"):setColor(cc.c3b(113,128,133))
                        else
                            view:getChildByName("infoex"):getChildByName("tiao3"):setColor(cc.c3b(255,195,0))
                        end
                        if dd.myinfo:getLong(1,"level") >= self._Cfg_growthFund[3]['hqlv4'] then
                            view:getChildByName("infoex"):getChildByName("tiao4"):setColor(cc.c3b(113,128,133))
                        else
                            view:getChildByName("infoex"):getChildByName("tiao4"):setColor(cc.c3b(255,195,0))
                        end
                    end
                    view:getChildByName("title"):getChildByName("time"):setString("")

                    view:getChildByName("pay"):getChildByName("info1"):setVisible(false) 
                    view:getChildByName("pay"):getChildByName("info2"):setVisible(true) 
                    view:getChildByName("pay"):setTag(2)
                end
                break
            end
        end
    end
end

function bankLayer:onBuy(params)
    local code = params[1]
    if code == 0 then      
        self:showListInfo(false)
        self:updatePopInfo()
        --dd.currentLayer._widget:onShowTips("\t"..ff.langString("购买成功"),true)
    else
        dd.mainUI:onShowCodeTips(code)
    end
end

function bankLayer:onGet(params)
    local code = params[1]
    if code == 0 then      
        self:showListInfo(false)
        self:updateTips()
        dd.currentLayer._widget:onShowTips("\t"..ff.langString("成功领取奖励 ！"),true)
    else
        dd.mainUI:onShowCodeTips(code)
    end
end

function bankLayer.onStart( sender )
    -- body
    sender._type = 1
    sender:selectType(sender:getChildByName("types"):getChildByName("type"):getChildByName("type1"))
    schedule(sender, sender.update,1)
    sender:updateTips()
end

function bankLayer.onBefore( sender )
    -- body
    ff.net:registerEvent(2,dd.Tjf_ActiveGrowthFund, function (message)sender:onBuy(message)end)
    ff.net:registerEvent(2,dd.Tjf_TakeBuildingBonus, function (message)sender:onGet(message)end)
end

function bankLayer:onAutoSize(  )
	local hh = dd.currentLayer._pop:getContentSize().height
	self:setContentSize(cc.size(720,hh - 184 ))
	self:getChildByName("info"):setPositionY(hh - 184 - 313)
	self:getChildByName("types"):setContentSize(cc.size(720 ,hh - 184 - 313))
	self:getChildByName("types"):setPositionY(0)
	self:getChildByName("types"):getChildByName("list"):setContentSize(cc.size(720 ,hh - 184 - 313 - 85 ))
    self:getChildByName("types"):getChildByName("list2"):setContentSize(cc.size(720 ,hh - 184 - 313 - 85 ))
	self:getChildByName("types"):getChildByName("type"):getChildByName("type1"):setTag(1)
	self:getChildByName("types"):getChildByName("type"):getChildByName("type2"):setTag(2)
	self:getChildByName("types"):getChildByName("type"):getChildByName("type3"):setTag(3)
	self:getChildByName("types"):getChildByName("type"):getChildByName("type3"):addTouchEventListener(self.onSelectType)
    self:getChildByName("types"):getChildByName("type"):getChildByName("type2"):addTouchEventListener(self.onSelectType)
    self:getChildByName("types"):getChildByName("type"):getChildByName("type1"):addTouchEventListener(self.onSelectType)
    self:getChildByName("pop"):getChildByName("view"):getChildByName("close"):addTouchEventListener(self.closePop)
    self:getChildByName("pop"):getChildByName("view"):getChildByName("pay"):addTouchEventListener(self.buyJJ)
end

function bankLayer.onSelectType( sender,eventType )
	if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("bank")
        if widget ~= nil then
            widget._type = sender:getTag()
            widget:selectType()
            
            --local a = string.format("%#x",1)--转16
            --local b = string.format("%#x",4)
            --local x = bit.bor(a,b)--或
            --local c = bit.band(x,2)
            --cclog("========="..c)
            --cclog(string.format("%#x",x))
        end
    end
end

function bankLayer.closePop( sender,eventType )
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("bank")
        if widget ~= nil then
            widget:getChildByName("pop"):setVisible(false)
        end
    end
end

function bankLayer.onReturn(sender)
    if sender:getChildByName("pop"):isVisible() == true then
        sender:getChildByName("pop"):setVisible(false)
        return true
    else
        return false
    end     
end

function bankLayer:selectType( sender)
	self:getChildByName("types"):getChildByName("type"):getChildByName("type1"):getChildByName("Label_100"):setColor(cc.c3b(97,117,123))
    self:getChildByName("types"):getChildByName("type"):getChildByName("type1"):setSelectedState(false)

    self:getChildByName("types"):getChildByName("type"):getChildByName("type2"):getChildByName("Label_100"):setColor(cc.c3b(97,117,123))
    self:getChildByName("types"):getChildByName("type"):getChildByName("type2"):setSelectedState(false)

    self:getChildByName("types"):getChildByName("type"):getChildByName("type3"):getChildByName("Label_100"):setColor(cc.c3b(97,117,123))
    self:getChildByName("types"):getChildByName("type"):getChildByName("type3"):setSelectedState(false)
    if self._type == 1 then
        self:getChildByName("types"):getChildByName("type"):getChildByName("type1"):getChildByName("Label_100"):setColor(cc.c3b(233, 239, 244))
    elseif self._type == 2 then
        self:getChildByName("types"):getChildByName("type"):getChildByName("type2"):getChildByName("Label_100"):setColor(cc.c3b(233, 239, 244))
    else
        self:getChildByName("types"):getChildByName("type"):getChildByName("type3"):getChildByName("Label_100"):setColor(cc.c3b(233, 239, 244))
    end
    if sender ~= nil then
        sender:setSelectedState(true)
    end
    self:showListInfo( true)
end

function bankLayer.onEnd( sender )
	-- body
    sender:stopAllActions()
    if ff.platform ~= 1 then
        sender:getChildByName("pop"):getChildByName("view"):getChildByName("info"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        sender:getChildByName("pop"):setVisible(false)
    	sender:getChildByName("info"):getChildByName("ico"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
    end
    ff.net:removeEvent(2,dd.Tjf_ActiveGrowthFund)
    ff.net:removeEvent(2,dd.Tjf_TakeBuildingBonus)
end

function bankLayer:updateTips(  )
    local tips = 0
    for i=2,dd.cfgBuilding[self._bid]['maxlevel'] do
        local giftInfo = Split(dd.cfgBuildingUp[self._bid][i]['rews'],'|')
        for k,v in pairs(giftInfo) do
            local gift = Split(v,'%^')
           
            if self._lv >= i then
                
                local a = string.format("%#x",dd.mygifts:getLong(1,"bankGetLevel"))--转16
                --cclog("========="..a)
                local b = string.format("%#x",math.pow(2,(i-1)))
                local c = ff._and(a,b)
                --cclog("=========="..a.."-----------"..b)
                if c == 0 then
                    
                    tips = tips + 1 
                end
            end
        end
        
    end
    if tips > 0 then
        self:getChildByName("types"):getChildByName("type"):getChildByName("type2"):getChildByName("tip"):setVisible(true)
        self:getChildByName("types"):getChildByName("type"):getChildByName("type2"):getChildByName("tip"):getChildByName("count"):setString(tips)
    else
        self:getChildByName("types"):getChildByName("type"):getChildByName("type2"):getChildByName("tip"):setVisible(false)
    end
end

function bankLayer.update( sender )
    if sender:getChildByName("pop"):isVisible() == true then
        local item1 = sender:getChildByName("pop"):getChildByName("view"):getChildByName("title")
        if sender._jjType == 1 then
            
            for i=1,dd.myGrowthFund:rowCount() do
                if dd.myGrowthFund:getLong(i,"type") == 1 then
                    if dd.myGrowthFund:getLong(i,"state") > 99 then
                        local time = dd.myGrowthFund:getLong(i,"state")-dd.getServerTime()
                        item1:getChildByName("time"):setString(ff.getLeftTime(time,":")) 
                    else
                        item1:getChildByName("time"):setString("") 
                    end
                    break
                end
            end
            
        elseif sender._jjType == 2 then
           
            for i=1,dd.myGrowthFund:rowCount() do

                if dd.myGrowthFund:getLong(i,"type") == 2 then
                    if dd.myGrowthFund:getLong(i,"state") > 99 then
                       local time = dd.myGrowthFund:getLong(i,"state")-dd.getServerTime()
                        item1:getChildByName("time"):setString(ff.getLeftTime(time,":")) 
                    else
                        item1:getChildByName("time"):setString("") 
                    end
                    break
                end
            end
        elseif sender._jjType == 3 then
           
            for i=1,dd.myGrowthFund:rowCount() do
                if dd.myGrowthFund:getLong(i,"type") == 3 then
                    if dd.myGrowthFund:getLong(i,"state") > 99 then
                       local time = dd.myGrowthFund:getLong(i,"state")-dd.getServerTime()
                        item1:getChildByName("time"):setString(ff.getLeftTime(time,":")) 
                    else
                        item1:getChildByName("time"):setString("") 
                    end
                    break
                end
            end
        end
    end

    if sender._type == 1 then
        if sender._Cfg_growthFund == nil then
            return
        end
   
        for i=1,dd.myGrowthFund:rowCount() do
          
            if dd.myGrowthFund:getLong(i,"type") == 1 then
                local item1 = sender:getChildByName("types"):getChildByName("list"):getChildByTag(1)
                if item1 ~= nil then
                    if dd.myGrowthFund:getLong(i,"state") > 99 then
                        item1:getChildByName("time"):setVisible(true)
                        local time = dd.myGrowthFund:getLong(i,"state")-dd.getServerTime()
                        item1:getChildByName("time"):setString(ff.getLeftTime(time,":")) 
                    else
                        item1:getChildByName("time"):setVisible(false)
                    end
                end
            elseif  dd.myGrowthFund:getLong(i,"type") == 2 then
               
                local item1 = sender:getChildByName("types"):getChildByName("list"):getChildByTag(2)
                if item1 ~= nil then
                    if dd.myGrowthFund:getLong(i,"state") > 99 then
                        item1:getChildByName("time"):setVisible(true)
                        local time = dd.myGrowthFund:getLong(i,"state")-dd.getServerTime()
                        item1:getChildByName("time"):setString(ff.getLeftTime(time,":")) 
                    else
                        item1:getChildByName("time"):setVisible(false)
                    end
                end
            elseif  dd.myGrowthFund:getLong(i,"type") == 3 then
                local item1 = sender:getChildByName("types"):getChildByName("list"):getChildByTag(3)
                if item1 ~= nil then
                    if dd.myGrowthFund:getLong(i,"state") > 99 then
                        item1:getChildByName("time"):setVisible(true)
                        local time = dd.myGrowthFund:getLong(i,"state")-dd.getServerTime()
                        item1:getChildByName("time"):setString(ff.getLeftTime(time,":")) 
                    else
                        item1:getChildByName("time"):setVisible(false)
           
                    end
                end
            end
        end
         
    end

end

function bankLayer:showListInfo( refresh)
	
	if self._type == 1 then
        self:getChildByName("types"):getChildByName("list"):setVisible(true)
        self:getChildByName("types"):getChildByName("list2"):setVisible(false)
        self:getChildByName("types"):getChildByName("list3"):setVisible(false)
        self:getChildByName("info"):getChildByName("info"):setString(ff.langString("购买一份基金吧。非常超值"))
		if self._Cfg_growthFund == nil then
			return
		end

		
        for i=1,dd.myGrowthFund:rowCount() do
            --cclog(dd.myGrowthFund:getLong(i,"type").."======="..i.."=="..dd.myGrowthFund:getLong(i,"state"))
            if dd.myGrowthFund:getLong(i,"type") == 1 and dd.myGrowthFund:getLong(i,"state") ~= -1 then
                local item1 = self:getChildByName("types"):getChildByName("list"):getChildByTag(1)
                if item1 == nil then
                   item1 = self:getChildByName("item2"):clone()
                   self:getChildByName("types"):getChildByName("list"):pushBackCustomItem(item1)
                   item1:addTouchEventListener(self.openPop)
                    item1:getChildByName("get"):addTouchEventListener(self.openPop)
                    item1:setTag(1)
                end
                item1:setVisible(true)
                item1:getChildByName("image"):getChildByName("ico"):loadTexture("images/bank/bank_jj1.jpg",0)
                item1:getChildByName("name"):setString(ff.langString("初级成长基金"))
                
                item1:getChildByName("get"):setTag(1)
                item1:getChildByName("Label_246_0"):setString(self._Cfg_growthFund[1]['gold'])
                item1:getChildByName("Label_246"):setString(self._Cfg_growthFund[1]['sum'])
                --local level = dd.myinfo:getLong(1,"level")
                item1:getChildByName("get"):setVisible(false)
                if self._lv >= self._Cfg_growthFund[1]['banklv'] then
                    item1:getChildByName("needlevel"):setVisible(false)
                else
                    
                    item1:getChildByName("needlevel"):setVisible(true)
                    item1:getChildByName("needlevel"):setString(ff.langString("需要银行LV.{0}",{self._Cfg_growthFund[1]['banklv']}))
                end
                
                if dd.myGrowthFund:getLong(i,"state") > 99 then
                    item1:getChildByName("time"):setVisible(true)
                    local time = dd.myGrowthFund:getLong(i,"state")-dd.getServerTime()
                    item1:getChildByName("time"):setString(ff.getLeftTime(time,":")) 
                    item1:getChildByName("get"):setVisible(true)
                elseif dd.myGrowthFund:getLong(i,"state") <= 99 and dd.myGrowthFund:getLong(i,"state") >= 0 then
                    item1:getChildByName("time"):setVisible(false)
                    item1:getChildByName("have"):setVisible(true)
                elseif dd.myGrowthFund:getLong(i,"state") <0 then
                    item1:getChildByName("time"):setVisible(false)
                    item1:getChildByName("have"):setVisible(false)
                end
            elseif  dd.myGrowthFund:getLong(i,"type") == 2 and dd.myGrowthFund:getLong(i,"state") ~= -1 then
                local item2 = self:getChildByName("types"):getChildByName("list"):getChildByTag(2)
                if item2 == nil then
                   item2 = self:getChildByName("item2"):clone()
                   self:getChildByName("types"):getChildByName("list"):pushBackCustomItem(item2)
                   item2:addTouchEventListener(self.openPop)
                    item2:getChildByName("get"):addTouchEventListener(self.openPop)
                    item2:setTag(2)
                end
                item2:setVisible(true)
                item2:getChildByName("image"):getChildByName("ico"):loadTexture("images/bank/bank_jj2.jpg",0)
                item2:getChildByName("name"):setString(ff.langString("中级成长基金"))
                
                item2:getChildByName("get"):setTag(2)
                item2:getChildByName("Label_246_0"):setString(self._Cfg_growthFund[2]['gold'])
                item2:getChildByName("Label_246"):setString(self._Cfg_growthFund[2]['sum'])
                item2:getChildByName("get"):setVisible(false)
                --local level = dd.myinfo:getLong(1,"level")
                if self._lv >= self._Cfg_growthFund[2]['banklv'] then
                    item2:getChildByName("needlevel"):setVisible(false)
                else
                  
                    item2:getChildByName("needlevel"):setVisible(true)
                    item2:getChildByName("needlevel"):setString(ff.langString("需要银行LV.{0}",{self._Cfg_growthFund[2]['banklv']}))
                end
                if dd.myGrowthFund:getLong(i,"state") > 99 then
                    item2:getChildByName("time"):setVisible(true)
                    local time = dd.myGrowthFund:getLong(i,"state")-dd.getServerTime()
                    item2:getChildByName("get"):setVisible(true)
                    item2:getChildByName("time"):setString(ff.getLeftTime(time,":")) 
                elseif dd.myGrowthFund:getLong(i,"state") <= 99 and dd.myGrowthFund:getLong(i,"state") >= 0 then
                    item2:getChildByName("time"):setVisible(false)
                    item2:getChildByName("have"):setVisible(true)
                elseif dd.myGrowthFund:getLong(i,"state") <0 then
                    item2:getChildByName("time"):setVisible(false)
                    item2:getChildByName("have"):setVisible(false)
                end
            elseif  dd.myGrowthFund:getLong(i,"type") == 3 and dd.myGrowthFund:getLong(i,"state") ~= -1 then
                local item1 = self:getChildByName("types"):getChildByName("list"):getChildByTag(3)
                if item1 == nil then
                   item1 = self:getChildByName("item2"):clone()
                   self:getChildByName("types"):getChildByName("list"):pushBackCustomItem(item1)
                   item1:addTouchEventListener(self.openPop)
                    item1:getChildByName("get"):addTouchEventListener(self.openPop)
                    item1:setTag(3)
                end
                item1:setVisible(true)
                item1:getChildByName("image"):getChildByName("ico"):loadTexture("images/bank/bank_jj3.jpg",0)
                item1:getChildByName("name"):setString(ff.langString("高级成长基金"))
                
                item1:getChildByName("get"):setTag(3)
                item1:getChildByName("Label_246_0"):setString(self._Cfg_growthFund[3]['gold'])
                item1:getChildByName("Label_246"):setString(self._Cfg_growthFund[3]['sum'])
                item1:getChildByName("get"):setVisible(false)
                --local level = dd.myinfo:getLong(1,"level")
                if self._lv >= self._Cfg_growthFund[3]['banklv'] then
                    item1:getChildByName("needlevel"):setVisible(false)
                else
                    --item1:getChildByName("get"):setVisible(false)
                    item1:getChildByName("needlevel"):setVisible(true)
                    item1:getChildByName("needlevel"):setString(ff.langString("需要银行LV.{0}",{self._Cfg_growthFund[3]['banklv']}))
                end
                if dd.myGrowthFund:getLong(i,"state") > 99 then
                    item1:getChildByName("time"):setVisible(true)
                    local time = dd.myGrowthFund:getLong(i,"state")-dd.getServerTime()
                    item1:getChildByName("time"):setString(ff.getLeftTime(time,":")) 
                    item1:getChildByName("get"):setVisible(true)
                elseif dd.myGrowthFund:getLong(i,"state") <= 99 and dd.myGrowthFund:getLong(i,"state") >= 0 then
                    item1:getChildByName("time"):setVisible(false)
                    item1:getChildByName("have"):setVisible(true)
                elseif dd.myGrowthFund:getLong(i,"state") <0 then
                    item1:getChildByName("time"):setVisible(false)
                    item1:getChildByName("have"):setVisible(false)
                end
            end
        end
        
        
        
	elseif self._type == 2 then
        self:getChildByName("types"):getChildByName("list"):setVisible(false)
        self:getChildByName("types"):getChildByName("list2"):setVisible(true)
        self:getChildByName("types"):getChildByName("list3"):setVisible(false)
        --local pos = 0
        self:getChildByName("info"):getChildByName("info"):setString(ff.langString("升级银行可获得绝无仅有的赞助奖励。"))
        for i=2,dd.cfgBuilding[self._bid]['maxlevel'] do
            local giftInfo = Split(dd.cfgBuildingUp[self._bid][i]['rews'],'|')
            for k,v in pairs(giftInfo) do
                local gift = Split(v,'%^')
                local item  = self:getChildByName("types"):getChildByName("list2"):getChildByTag(i)
                if item == nil then
                  item  = self:getChildByName("item"):clone()
                  self:getChildByName("types"):getChildByName("list2"):pushBackCustomItem(item)
                  item:getChildByName("get"):addTouchEventListener(self.getLevelRe)
                end
                item:setTag(i)
                item:setVisible(true)
                item:getChildByName("get"):setTag(i)
                item:getChildByName("image"):getChildByName("ico"):loadTexture(dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[1],dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[2])
                if tonumber(gift[1]) == 16 then
                    item:getChildByName("name"):setString(ff.langString(dd.cfgEquip[tonumber(gift[2])]['name']))
                    item:getChildByName("level"):setString(ff.langString("LV.")..dd.cfgEquip[tonumber(gift[2])]['level'])
                    local string = ""
                    for j=1,4 do
                        local effectid = dd.cfgArms[tonumber(gift[2])]["param"..j]
                        if effectid > 0 then
                            local effect = dd.cfgArms[tonumber(gift[2])]['value'..j]
                            local effectex  = effect/dd.cfgEffect[dd.cfgArms[tonumber(gift[2])]["param"..j]]['value']
                            local value = tostring(effectex)
                            local effectid2 = dd.cfgArms[tonumber(gift[2])]["param"..j]
                            local effect2 = dd.cfgArms[tonumber(gift[2])]['value'..j]
                            local effectex2  = effect2/dd.cfgEffect[dd.cfgArms[tonumber(gift[2])]["param"..j]]['value']
                            local value2 = tostring(effectex2)

                            string = tostring(string) .. ff.langString(dd.cfgEffect[dd.cfgArms[tonumber(gift[2])]["param"..j]]['tips1'],{value2}).."\n"
                        end
                    end
                    item:getChildByName("info"):setString(string)
                elseif tonumber(gift[1]) == 1 then
                    item:getChildByName("name"):setString(ff.langString(dd.cfgProp[tonumber(gift[2])]['name'],{dd.cfgProp[tonumber(gift[2])]['name1_lan']}))
                    item:getChildByName("info"):setString(ff.langString(dd.cfgProp[tonumber(gift[2])]['tips'],{dd.cfgProp[tonumber(gift[2])]['tips1_lan']}))
                end

                if self._lv >= i then
                    item:getChildByName("chu_can"):setVisible(false)
                    local a = string.format("%#x",dd.mygifts:getLong(1,"bankGetLevel"))--转16
                    --cclog("========="..a)
                    local b = string.format("%#x",math.pow(2,(i-1)))
                    local c = ff._and(a,b)
                    --cclog("=========="..a.."-----------"..b)
                    if c == 0 then
                        
                        --if pos == 0 then
                        --    pos = i - 1
                        --end
                        item:getChildByName("get"):setVisible(true)
                        
                    else
                        item:getChildByName("get"):setVisible(false)
                        item:getChildByName("chu_can"):setVisible(true)
                    item:getChildByName("chu_can"):setString(ff.langString("已领奖"))
                    end

                else
                    item:getChildByName("get"):setVisible(false)
                    item:getChildByName("chu_can"):setVisible(true)
                    item:getChildByName("chu_can"):setString(ff.langString("需要银行LV.{0}",{i}))
                end
                item:getChildByName("name"):getVirtualRenderer():enableBold(true)
                item:requestDoLayout()
                
            end
            
            if (self._lv + 3) == i or i == dd.cfgBuilding[self._bid]['maxlevel'] then
                self:getChildByName("types"):getChildByName("list2"):refreshView()
                --if pos == 0 then
                --    pos = self._lv
                --end
                --cclog("===========sdf=="..pos)
               -- local ps = pos * 100/(i-1)
                --cclog("========"..ps)
                --self:getChildByName("types"):getChildByName("list2"):scrollToPercentVertical(ps,0.1,false)
                break
            end
            
            
        end
        if refresh == true then
            self:getChildByName("types"):getChildByName("list2"):jumpToTop()
        end
	elseif self._type == 3 then
        self:getChildByName("types"):getChildByName("list"):setVisible(false)
        self:getChildByName("types"):getChildByName("list2"):setVisible(false)
        self:getChildByName("types"):getChildByName("list3"):setVisible(true)
        self:getChildByName("info"):getChildByName("info"):setString(ff.langString(""))
	end
end