barrackHelpLayer = class("barrackHelpLayer")
barrackHelpLayer._name = "barrackHelp"
barrackHelpLayer._init = false

function barrackHelpLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, barrackHelpLayer)
    return target
end

function barrackHelpLayer:onInit()
    local pannel_center = nil
	if self._init == false then
        local hh = ff.height-214
        self:setContentSize(cc.size(720, hh))
        self:getChildByName("bgLayer"):setContentSize(cc.size(720, hh))
        self:getChildByName("main"):setContentSize(cc.size(720, hh-110))
        self:getChildByName("bgLayer"):setPositionY(0)
        self:getChildByName("main"):setPositionY(0)

        self:getChildByName("top"):setPositionY(hh-105)
        pannel_center = self:getChildByName("itemA")
        pannel_center:setPositionY(hh-105-700)
        self:getChildByName("itemB"):setPositionY(hh-105-700)
        self:getChildByName("listview"):setContentSize(cc.size(690,hh-105-50-500-50-10))
        self:getChildByName("listview"):setPositionY(10)
        self:getChildByName("top"):getChildByName("chu_title"):setString("Barracks")
        self:getChildByName("top"):getChildByName("addgold"):addTouchEventListener(dd.onPay)
        self:getChildByName("info"):getChildByName("labelR"):setString(ff.langString("训练速度"))
        self._init = true

        self:getChildByName("itemA"):setVisible(true)
        self:getChildByName("itemB"):setVisible(false)
    end
    self:getChildByName("listview"):setVisible(false)
    self:initEvent()
    self:initDB()
    self.updateGold()
end

function barrackHelpLayer:initEvent()
    local itemA = self:getChildByName("itemA")
    local itemB = self:getChildByName("itemB")
    local itemA_btn = itemA:getChildByName("btn_next")
    local itemB_btn = itemB:getChildByName("btn_front")
    local btn_back  = self:getChildByName("top"):getChildByName("back")

    local info = self:getChildByName("topInfo")
    local function clickEvent(sender, touchType)
        if touchType == ccui.TouchEventType.ended then
            if sender == btn_back then
                pop.onClosePopDialog("barrackHelp")
            elseif sender == itemA_btn then
                info:getChildByName("lab"):setVisible(false)
                info:getChildByName("list"):setVisible(true)
                itemA:setVisible(false)
                itemA:setPosition(cc.p(-720,itemA:getPositionY()))
                itemB:setVisible(true)
                itemB:runAction(cc.EaseExponentialOut:create(cc.MoveTo:create(1, cc.p(15, itemB:getPositionY()))))
            elseif sender == itemB_btn then
                info:getChildByName("lab"):setVisible(true)
                info:getChildByName("list"):setVisible(false)
                itemB:setVisible(false)
                itemB:setPosition(cc.p(720,itemB:getPositionY()))
                itemA:setVisible(true)
                itemA:runAction(cc.EaseExponentialOut:create(cc.MoveTo:create(1, cc.p(15, itemA:getPositionY()))))
            end
        end
    end
    btn_back:addTouchEventListener(clickEvent)
    itemA_btn:addTouchEventListener(clickEvent)
    itemB_btn:addTouchEventListener(clickEvent)
end

function barrackHelpLayer:initDB()
    local sqlStr = "select t1.id,t1.bid,t1.name,t1.value1,t1.level,t2.tips1_lan from cfg_build_upgrade t1,cfg_effect t2 where  bid=21 and t1.param1=t2.id"
    local info = ff.dbmanager:sql_fetch_rows(sqlStr)
    if(info) then
        local count=info:rowCount()
        local barrackWidget = pop.getDialog("barrack")
        local lv = 0
        if barrackWidget ~= nil then
            lv = barrackWidget._lv
        end
        for i=1,count do
            local cloneItem=self:getChildByName("item"):clone()
            if lv == i then 
                cloneItem:getChildByName("bg"):loadTexture("images/icon/rank/help_back.png",0)
            end
            cloneItem:getChildByName("labRank"):setString(info:getString(i,"level"))

            local per = tonumber(info:getString(i,"value1")) / 10
            --local tips_lan = ff.langString(tonumber(info:getString(i,"tips1_lan")))
            --local newStr = string.gsub(tips_lan, "%{(.*)%}", per) 

            cloneItem:getChildByName("labArmy"):setString(per.."%")

            cloneItem:setVisible(true)
            cloneItem:setTouchEnabled(true)
            self:getChildByName("listview"):pushBackCustomItem(cloneItem)
            self:getChildByName("listview"):refreshView(true)
            --self:getChildByName("listview"):addChild(item)
        end
        self:getChildByName("listview"):scrollToTop(0.2,true)
        performWithDelay(self,function()
            self:getChildByName("listview"):setVisible(true)
        end, 0.3)
        self:getChildByName("listview"):setItemsMargin(5)
    end
end

function barrackHelpLayer.onStart(sender)
    ff.net:bindProperty(2605,"gold",sender.updateGold)
end

function barrackHelpLayer.updateGold()
    local widget = pop.getDialog("barrackHelp")
    if widget ~= nil then
        widget:getChildByName("top"):getChildByName("number"):setString(dd.gold())
        widget:getChildByName("top"):requestDoLayout()
    end
end

function barrackHelpLayer.onEnd(sender)
	 dd.delBackEvent(sender.onReturn)
     ff.net:unbindProperty("gold",2605)
    
     if sender:getChildByName("listview"):getChildrenCount() > 0 then
        sender:getChildByName("listview"):removeAllChildren(true)
     end
end

function barrackHelpLayer.onBefore(sender)
    dd.initGoldSpine(sender:getChildByName("top"):getChildByName("img"),sender:getChildByName("top"):getChildByName("addgold"))
	return true
end

function barrackHelpLayer.onReturn(sender)
	local close = false
    if sender == nil then
        close = true
    end
    if eventType==ccui.TouchEventType.ended then     
        close = true
    end
    if close == true then
        pop.onClosePopDialog("barrackHelp")
    end
end

function onShowBarrackHelp(widget)
	local layer = barrackHelpLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)
	layer:onInit()
	return layer
end