local equipbuildLayer = class("equipbuildLayer")
equipbuildLayer._name = "equipbuildLayer"
--equipbuildLayer._init = false
equipbuildLayer._pos = 0
equipbuildLayer._bid = 0
equipbuildLayer._lv = 0
equipbuildLayer._start = false
equipbuildLayer._end = 0

function equipbuildLayer.extend( target )
	-- body
	local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, equipbuildLayer)
    return target
end

function onShowEquipBuild( widget,pos )
	-- body
	local layer = equipbuildLayer.extend(widget)
    layer:setVisible(false)
    layer._pos = pos
    layer:onInit()
    return layer
end

function equipbuildLayer:onInit( )
	-- body
	for i=1,dd.mybuilds:rowCount() do
		if dd.mybuilds:getLong(i,"pos") == self._pos then
			self._bid = dd.mybuilds:getLong(i,"bid")
            self._lv = dd.mybuilds:getLong(i,"level")
			break
		end
	end

	--if self._init == false then
		
		if dd.currentLayer._pop ~= nil then
			self:onAutoSize()
		end
		--self._init = true
	--end
    local function showHelp(sender,eventType)
        if eventType==ccui.TouchEventType.ended then     
            pop.onShowPopDialog("buildHelp",self._bid,self._lv)
        end
    end
    self:getChildByName("info"):getChildByName("help"):addTouchEventListener(showHelp)
	self:showItems()
	self._start = false
end

function equipbuildLayer:onAutoSize( )
	-- body        
	local hh = ff.height - 214

	self:setContentSize(cc.size(720,hh - 184))
	self:getChildByName("back"):setContentSize(cc.size(720,hh - 184))
	self:getChildByName("back"):setPositionY(0)
	self:getChildByName("info"):setPositionY(hh - 184 - 52)
	self:getChildByName("info"):setVisible(true)
	--self:getChildByName("info"):getChildByName("tips"):setString(ff.langString(dd.cfgBuilding[4]['tips']))
    self:getChildByName("info"):getChildByName("tips"):setString(ff.langString("点击查看建筑效果"))
	self:getChildByName("forgeinfo"):getChildByName("speedup"):addTouchEventListener(self.onSpeedUp)
    self:getChildByName("forgeinfo"):getChildByName("forge"):getChildByName("cancel"):addTouchEventListener(self.onCancel)

		--self:getChildByName("forgeinfo"):setPositionY(hh - 100 -70 - 38 - 60)
		--self:getChildByName("mainarea"):setContentSize(cc.size(720,hh - 100 -70 - 38 - 65))
	
		self:getChildByName("forgeinfo"):setPositionY(1000000)
		self:getChildByName("mainarea"):setContentSize(cc.size(720,hh - 184 - 38 - 35))
	
	
	self:getChildByName("mainarea"):setPositionY(0)
end

function equipbuildLayer.onSpeedUp(sender, touchEventType)
    if touchEventType == ccui.TouchEventType.ended then    
        local message = ff.net:createMessage()
        local function speedUp()
            message:addCmd(0x104)
            message:addLong(dd.uid)
            message:addLong(8) --speedUp
            message:addLong(0)
            message:addLong(8) 
            ff.net:rpc(message,false)
        end
        dd.currentLayer._widget:onShowBuyTime(8,speedUp)
    end 
end

function equipbuildLayer.onCancel(sender, touchEventType)
        if touchEventType == ccui.TouchEventType.ended then     
            
        local function sureCancel()
            local message = ff.net:createMessage()
            message:addCmd(0x104)
            message:addLong(dd.uid)
            message:addLong(9) --speedUp
            message:addLong(0)
            message:addLong(8) 
            ff.net:rpc(message,false)           
        end
        --提示
        dd.currentLayer._widget:onShowSure(ff.langString("铸造取消提示"),ff.langString("取消锻造并不会返还之前资源。\n你确定要取消吗？"),sureCancel,true,2)
        end 
end

function equipbuildLayer:showItems( )
	-- body
	self:getChildByName("mainarea"):removeAllChildren(true)
    local level = dd.myinfo:getLong(1,"level")
	for i=1,5 do
		if i == 1 then
            local item = self:getChildByName("item"):clone()
            item:setTag(i)
            item:setVisible(true)
            item:setTouchEnabled(true)
            item:addTouchEventListener(self.openOther)
			item:getChildByName("name"):setString(ff.langString("锻造"))
			item:getChildByName("ico"):loadTexture(dd.getPathFromUI("ic01_smithy.png",1))
            self:getChildByName("mainarea"):pushBackCustomItem(item)
		elseif i == 2 then
            --if level >= 14 then
                local item = self:getChildByName("item"):clone()
                item:setTag(i)
                item:setVisible(true)
                item:setTouchEnabled(true)
                item:addTouchEventListener(self.openOther)
    			item:getChildByName("name"):setString(ff.langString("镶嵌"))
    			item:getChildByName("ico"):loadTexture(dd.getPathFromUI("ic02_smithy.png",1))
                self:getChildByName("mainarea"):pushBackCustomItem(item)
            --end
		elseif i == 3 then
            local item = self:getChildByName("item"):clone()
            item:setTag(i)
            item:setVisible(true)
            item:setTouchEnabled(true)
            item:addTouchEventListener(self.openOther)
			item:getChildByName("name"):setString(ff.langString("融合"))
			item:getChildByName("ico"):loadTexture(dd.getPathFromUI("ic03_smithy.png",1))
            self:getChildByName("mainarea"):pushBackCustomItem(item)
		elseif i == 4 then
            --if level >= 12 then
             --   local item = self:getChildByName("item"):clone()
             --   item:setTag(i)
            --    item:setVisible(true)
            --    item:setTouchEnabled(true)
            --    item:addTouchEventListener(self.openOther)
    		--	item:getChildByName("name"):setString(ff.langString("勋章"))
    		--	item:getChildByName("ico"):loadTexture(dd.getPathFromUI("ic04_smithy.png",1))
             --   self:getChildByName("mainarea"):pushBackCustomItem(item)
            --end
		elseif i == 5 then
            local item = self:getChildByName("item"):clone()
            item:setTag(i)
            item:setVisible(true)
            item:setTouchEnabled(true)
            item:addTouchEventListener(self.openOther)
			item:getChildByName("name"):setString(ff.langString("仓库"))
			item:getChildByName("ico"):loadTexture(dd.getPathFromUI("ic05_smithy.png",1))
            self:getChildByName("mainarea"):pushBackCustomItem(item)
		end

		
	end
	self:getChildByName("mainarea"):scrollToTop(0.5,true)
    self:getChildByName("mainarea"):setItemsMargin(5)
end

function equipbuildLayer.onStart( sender )
	-- body
	sender.updatemake(sender)
end

function equipbuildLayer.updatemake( sender )
    -- body
    local time = 0
    for i=1,dd.mylists:rowCount() do
        if dd.mylists:getLong(i,"type") == 8 then
        	local start = dd.mylists:getLong(i,"start")
        	local endtime   = dd.mylists:getLong(i,"end")
            local per = 0
            if (endtime - start )>0 then
                per = (endtime - start - (endtime - dd.getServerTime()))/(endtime - start)*100
            end
            
            time = endtime - dd.getServerTime()
            sender:getChildByName("forgeinfo"):getChildByName("forge"):getChildByName("time"):getChildByName("progressbar"):setPercent(per)
            local equipType = dd.mylists:getLong(i,"param1")
            --cclog("===="..equipType)
            for j,v in pairs(dd.cfgEquip) do    

                if tonumber(dd.cfgEquip[j]['type'])== equipType then
                    sender:getChildByName("forgeinfo"):getChildByName("forge"):getChildByName("making"):setString(ff.langString(dd.cfgEquip[j]['name']).."  "..ff.langString("制作中"))
                    break
                end
            end
            break
       end
        
    end
    local hh = ff.height - 214
    if time > 0 then
        if sender._start == false then
            sender:getChildByName("forgeinfo"):setPositionY(hh - 100 -70 - 48 - 95)
			sender:getChildByName("mainarea"):setContentSize(cc.size(720,hh - 100 -70 - 48 - 100))	
			sender._start = true
		end
            sender:getChildByName("forgeinfo"):getChildByName("forge"):getChildByName("showtime"):setString(ff.getLeftTime(time,":"))
   else
        if sender._start == true then
            sender:getChildByName("forgeinfo"):setPositionY(1000000)
			sender:getChildByName("mainarea"):setContentSize(cc.size(720,hh - 100 -70 - 48 - 25))
			sender._start = false
		end
        sender:getChildByName("forgeinfo"):getChildByName("forge"):getChildByName("showtime"):setString("")
    end

    local level = dd.myinfo:getLong(1,"level")
    --if level >= 12 then
    --    local item = sender:getChildByName("mainarea"):getChildByTag(4)
    --    if item == nil then
    --        local item = sender:getChildByName("item"):clone()
    --        item:setTag(4)
    --        item:setVisible(true)
    --        item:setTouchEnabled(true)
    --        item:addTouchEventListener(sender.openOther)
    --        item:getChildByName("name"):setString(ff.langString("勋章"))
    --        item:getChildByName("ico"):loadTexture(dd.getPathFromUI("ic04_smithy.png",1))
     --       sender:getChildByName("mainarea"):insertCustomItem(item,3)
     --   end
    --end
    --if level >= 14 then
        local item = sender:getChildByName("mainarea"):getChildByTag(2)
        if item == nil then
            local item = sender:getChildByName("item"):clone()
            item:setTag(2)
            item:setVisible(true)
            item:setTouchEnabled(true)
            item:addTouchEventListener(sender.openOther)
            item:getChildByName("name"):setString(ff.langString("镶嵌"))
            item:getChildByName("ico"):loadTexture(dd.getPathFromUI("ic02_smithy.png",1))
            --sender:getChildByName("mainarea"):pushBackCustomItem(item)
            sender:getChildByName("mainarea"):insertCustomItem(item,2)
        end
    --end
 
end

function equipbuildLayer.onBefore( sender )
	-- body
    schedule(sender,sender.updatemake,1)
	--return false
end

function equipbuildLayer.onEnd( sender )
	-- body
    sender:stopAllActions()
	-- dd.delBackEvent()
    local help = pop.getDialog("buildHelp")
    if help ~= nil and help:isVisible() then
        help:setVisible(false)    
    end
end

function equipbuildLayer.updateEquipForge( sender )
	-- body
end

function equipbuildLayer.openOther( sender,eventType )
	-- body
	if eventType == ccui.TouchEventType.ended then
        local tag = sender:getTag()
        --cclog("========="..tag)
        if tag == 1 then
        	pop.onShowPopDialog("equipforge")
        	--锻造
        elseif tag == 2 then

            pop.onShowPopDialog("equipgem",0)
        	--镶嵌
        elseif tag == 3 then

        	pop.onShowPopDialog("equipcompose")

        	--融合
        elseif tag == 4 then
        	--外设
            pop.onShowPopDialog("crystalUp",0)
        elseif tag == 5 then
        	--仓库
            pop.onShowPopDialog("warehouse")
        end
    end
end