equipgemLayer = class("equipgemLayer")
equipgemLayer._name = "equipgem"
equipgemLayer._init = false
equipgemLayer._pop = false
equipgemLayer._gems = nil
equipgemLayer._equips = nil
equipgemLayer._aitems = {}
equipgemLayer._equipIndex = 0
equipgemLayer._index = 0

function equipgemLayer.extend( target )
	local t = tolua.getpeer(target)
	if not t then
		t = {}
		tolua.setpeer(target,t)
	end
	setmetatable(t,equipgemLayer)
	return target
end


function equipgemLayer.onReturn( sender,eventType )
	-- body
	local close = false
    if sender == nil then
        close = true
    end
    if eventType == ccui.TouchEventType.ended then
        close = true
    end
    if close == true then
        local widget = pop.getDialog("equipgem")
        
        if widget then
            if widget._pop == true then
                widget.openPop(widget:getChildByName("equipinfo"):getChildByName("ico"),ccui.TouchEventType.ended)
                return
            end
           	pop.onClosePopDialog("equipgem")
        end
    end
end

function equipgemLayer:onInit(equipIndex)
	if self._init == false then
		self:onAutoSize()
        self:getChildByName("main"):addEventListener(self.scrollViewEvent)      
        self:getChildByName("line"):getChildByName("showall"):setSelectedState(true)
		self._init = true
	end
    --self:getChildByName("top"):getChildByName("count"):setString(dd.gold())
    self.updateGold()
    self:getChildByName("main"):getChildByName("tips"):setVisible(false)
    self:getChildByName("equipinfo"):getChildByName("unselect"):setVisible(true)
    self:getChildByName("equipinfo"):getChildByName("info"):setVisible(false)
    self:getChildByName("equipinfo"):getChildByName("tips"):setVisible(false)
    self:getChildByName("equipinfo"):getChildByName("tip"):setVisible(true)
    self:InitData(equipIndex)
end

function equipgemLayer:InitData(equipIndex)
    self._pop =false

    self:getChildByName("equipinfo"):getChildByName("info"):setVisible(false)
    self:getChildByName("equipinfo"):getChildByName("tip"):setVisible(true)
    self:getChildByName("equipinfo"):getChildByName("unselect"):setVisible(true)
    self:getChildByName("equipinfo"):getChildByName("ico"):getChildByName("add"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
    --self:getChildByName("equipinfo"):getChildByName("ico"):getChildByName("add"):setVisible(true)
    self:getChildByName("equipinfo"):addTouchEventListener(self.closeTip)
    for i=1,3 do
        self:getChildByName("equipinfo"):getChildByName("block"..i):getChildByName("have"):setVisible(true)
        self:getChildByName("equipinfo"):getChildByName("block"..i):getChildByName("ico"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        self:getChildByName("equipinfo"):getChildByName("block"..i):getChildByName("checkbox"):setVisible(false)
        self:getChildByName("equipinfo"):getChildByName("block"..i):getChildByName("checkbox"):setTag(i)
        self:getChildByName("equipinfo"):getChildByName("block"..i):getChildByName("checkbox"):setTouchEnabled(false)
    end

    if self._gems == nil then
        self._gems = ff.NetTable:create()
        self._gems:addCol("id",ff.NET_LONG)
        self._gems:addCol("count",ff.NET_LONG)
        self._gems:addCol("color",ff.NET_LONG)
        self._gems:addCol("level",ff.NET_LONG)
        self._gems:addCol("type",ff.NET_LONG)
    else
        self._gems:delRows()
    end

    self:onGetEquipsInfo()
    if equipIndex ~= 0 then
        self._equipIndex = equipIndex
        self:onEquipChoice()
        self:onGetGemsInfo()
    end
end

function equipgemLayer:onGetEquipsInfo(params)
    self._equips = dd.myArms
end

function equipgemLayer.openPop( sender,eventType )
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("equipgem")
        if widget ~= nil then
            local arms = {}
            for i=1,dd.myArms:rowCount() do
                local hole = dd.cfgArms[dd.myArms:getLong(i,"aid")]['hole']
                if hole > 0 then
                    arms[table.getn(arms) + 1] = dd.myArms:getLong(i,"tid")
                end
            end

            local function callback(aid)
                for i=1,dd.myArms:rowCount() do
                    if dd.myArms:getLong(i,"tid") == aid then
                        widget._equipIndex = i
                        widget:onEquipChoice()
                        widget:onGetGemsInfo()
                        break
                    end
                end
            end            
            pop.onShowPopDialog("arms",arms,callback)
        end
    end
end

function equipgemLayer:onAutoSize( )
	local hh = ff.height
	self:setContentSize(cc.size(720,hh))
    self:setPositionY(0)
	self:getChildByName("back"):setContentSize(cc.size(720,hh))
    self:getChildByName("back"):setPositionY(0)
	self:getChildByName("top"):setPositionY(ff.height - 105)

    self:getChildByName("top"):getChildByName("title"):getChildByName("chu_title"):getVirtualRenderer():enableBold(true)
    self:getChildByName("top"):getChildByName("title"):getChildByName("chu_title"):setString(ff.langString("镶嵌"))

    self:getChildByName("top"):getChildByName("return"):addTouchEventListener(self.onReturn)
    self:getChildByName("top"):getChildByName("addgold"):addTouchEventListener(dd.onPay)
    self:getChildByName("equipinfo"):setPositionY(ff.height - 500 - 105 )
    self:getChildByName("line"):setPositionY(ff.height - 610 - 47)

    self:getChildByName("main"):setContentSize(cc.size(700,ff.height - 610 - 47 - 4))
    self:getChildByName("main"):setInnerContainerSize(cc.size(700,ff.height - 610 - 47 - 4))
    self:getChildByName("main"):setPositionY(0)

    self:getChildByName("equipinfo"):getChildByName("ico"):addTouchEventListener(self.openPop)
    self:getChildByName("equipinfo"):getChildByName("unselect"):getChildByName("select"):addTouchEventListener(self.openPop)

    self:getChildByName('main'):getChildByName("tips"):getChildByName("info"):getChildByName("xiangqian"):addTouchEventListener(self.gemOn)
    self:getChildByName("equipinfo"):getChildByName("tips"):getChildByName("info"):getChildByName("xiezai"):addTouchEventListener(self.gemDown)
    self:getChildByName("equipinfo"):getChildByName("block1"):addTouchEventListener(self.showTips)
    self:getChildByName("equipinfo"):getChildByName("block2"):addTouchEventListener(self.showTips)
    self:getChildByName("equipinfo"):getChildByName("block3"):addTouchEventListener(self.showTips)
end
--卸载
function equipgemLayer.closeTip(sender,eventType)
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("equipgem")
        if widget ~= nil then
            widget:getChildByName("equipinfo"):getChildByName("tips"):setVisible(false)
        end    
    end
end
function equipgemLayer.showTips(sender,eventType)
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("equipgem")
        if widget ~= nil then
            if sender:getChildByName("have"):isVisible() == true then
                widget:getChildByName("equipinfo"):getChildByName("tips"):setVisible(false)
            else
                if sender:getTag() > 0 then
                    widget:onShowTips(sender:getTag())
                else
                    widget:getChildByName("equipinfo"):getChildByName("tips"):setVisible(false)
                end
            end
        end
    end
end
function equipgemLayer:onShowTips(gid)
    self:getChildByName("equipinfo"):getChildByName("tips"):getChildByName("info"):getChildByName("chu_name"):setString(ff.langString(dd.cfgProp[gid]['name'],{dd.cfgProp[gid]['name1_lan']}))
    cclog("=========sdfsdf--"..dd.cfgGems[gid]['param2'])
    if dd.cfgGems[gid]['param2'] > 0 then
        local value = dd.cfgGems[gid]['value1']/dd.cfgEffect[dd.cfgGems[gid]['param1']]['value']
        local param = dd.cfgGems[gid]['param1']
        local value2 = dd.cfgGems[gid]['value2']/dd.cfgEffect[dd.cfgGems[gid]['param2']]['value']
        local param2 = dd.cfgGems[gid]['param2']
        local string1 = ""
        local string2 = ""
        if ff.langString(dd.cfgEffect[param]['tips2']) ~= 0 then
            string1 = ff.langString(dd.cfgEffect[dd.cfgGems[gid]['param1']]['name']).."+"..value..ff.langString(dd.cfgEffect[param]['tips2'])
        else
            string1 = ff.langString(dd.cfgEffect[dd.cfgGems[gid]['param1']]['name']).."+"..value
        end
        if ff.langString(dd.cfgEffect[param2]['tips2']) ~= 0 then
            string2 = ff.langString(dd.cfgEffect[dd.cfgGems[gid]['param2']]['name']).."+"..value2..ff.langString(dd.cfgEffect[param2]['tips2'])
        else
            string2 = ff.langString(dd.cfgEffect[dd.cfgGems[gid]['param2']]['name']).."+"..value2
        end
        --self:getChildByName("equipinfo"):getChildByName("tips"):getChildByName("info"):getChildByName("sx"):setString(ff.langString(dd.cfgEffect[dd.cfgGems[gid]['param1']]['name']))
        
        self:getChildByName("equipinfo"):getChildByName("tips"):getChildByName("info"):getChildByName("sx"):setString(string1..","..string2)
        self:getChildByName("equipinfo"):getChildByName("tips"):getChildByName("info"):getChildByName("value"):setString("")
    else
        local value = dd.cfgGems[gid]['value1']/dd.cfgEffect[dd.cfgGems[gid]['param1']]['value']
        local param = dd.cfgGems[gid]['param1']
        self:getChildByName("equipinfo"):getChildByName("tips"):getChildByName("info"):getChildByName("sx"):setString(ff.langString(dd.cfgEffect[dd.cfgGems[gid]['param1']]['name']))
        if ff.langString(dd.cfgEffect[param]['tips2']) ~= 0 then
            self:getChildByName("equipinfo"):getChildByName("tips"):getChildByName("info"):getChildByName("value"):setString("+"..value..ff.langString(dd.cfgEffect[param]['tips2']))
        else
            self:getChildByName("equipinfo"):getChildByName("tips"):getChildByName("info"):getChildByName("value"):setString("+"..value)
        end
    end
    self:getChildByName("equipinfo"):getChildByName("tips"):getChildByName("info"):getChildByName("xiezai"):setTag(0)
    if self._equips ~= nil and self._equipIndex > 0 and self._equipIndex <= self._equips:rowCount() then
        if gid == self._equips:getLong(self._equipIndex,"gem1") then
            self:getChildByName("equipinfo"):getChildByName("tips"):getChildByName("arrow"):setPositionX(283)
            self:getChildByName("equipinfo"):getChildByName("tips"):getChildByName("info"):getChildByName("xiezai"):setTag(1)            
        elseif gid == self._equips:getLong(self._equipIndex,"gem2") then
            self:getChildByName("equipinfo"):getChildByName("tips"):getChildByName("arrow"):setPositionX(440)
            self:getChildByName("equipinfo"):getChildByName("tips"):getChildByName("info"):getChildByName("xiezai"):setTag(2)            
        else
            self:getChildByName("equipinfo"):getChildByName("tips"):getChildByName("arrow"):setPositionX(600)
            self:getChildByName("equipinfo"):getChildByName("tips"):getChildByName("info"):getChildByName("xiezai"):setTag(3)            
        end
    end
    local money = dd.cfgGems[gid]['money']
    self:getChildByName("equipinfo"):getChildByName("tips"):getChildByName("info"):getChildByName("count"):setString(dd.showKM(money,5))
    if money > dd.silver() then
        self:getChildByName("equipinfo"):getChildByName("tips"):getChildByName("info"):getChildByName("count"):setColor(cc.c3b(255,0,0))
    else
        self:getChildByName("equipinfo"):getChildByName("tips"):getChildByName("info"):getChildByName("count"):setColor(cc.c3b(255,255,255))
    end
    self:getChildByName("equipinfo"):getChildByName("tips"):getChildByName("info"):requestDoLayout()
    self:getChildByName("equipinfo"):getChildByName("tips"):setVisible(true)
end
function equipgemLayer.gemDown( sender,eventType)
    if eventType == ccui.TouchEventType.ended then
        if sender:getTag() < 1 or sender:getTag() > 3 then
            return
        end
        local widget = pop.getDialog("equipgem")
        if widget ~= nil then
            local message = ff.net:createMessage()
            message:addCmd(0x00000112)
            message:addLong(dd.uid)
            message:addLong(12)
            message:addLong(widget._equips:getLong(widget._equipIndex,"tid"))
            message:addLong(sender:getTag())
            message:addLong(0)
            ff.net:rpc(message, false)
        end
    end
end
--镶嵌
function equipgemLayer.gemOn( sender,eventType)
    local doaction = false
    local widget = pop.getDialog("equipgem")
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType==ccui.TouchEventType.ended then    
        doaction = true
    end
    if doaction == true then
        local widget = pop.getDialog("equipgem")
        if widget ~= nil then
            widget:onGemOn(sender:getTag())
        end
    end
end
function equipgemLayer:onGemOn(gid)
    if self._equipIndex <= 0 or self._equipIndex > self._equips:rowCount() then
        dd.currentLayer._widget:onShowTips("\t"..ff.langString("请先选择需要镶嵌的装备"))
        return
    end
    local hole = dd.cfgArms[self._equips:getLong(self._equipIndex,"aid")]['hole']
    local index = 0
    for i=1,hole do
        if self._equips:getLong(self._equipIndex,"gem"..i) > 0 then
            if dd.cfgGems[self._equips:getLong(self._equipIndex,"gem"..i)]['type'] == dd.cfgGems[self._gems:getLong(self._index,"id")]['type'] then
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("已镶嵌同属性合金"))
                return
            end
        else
            if index == 0 then
                index = i
            end
        end
    end
    if index == 0 then
        dd.currentLayer._widget:onShowTips("\t"..ff.langString("没有多余的镶嵌孔"))
        return
    end
    local message = ff.net:createMessage()
    message:addCmd(0x00000112)
    message:addLong(dd.uid)
    message:addLong(11)
    message:addLong(self._equips:getLong(self._equipIndex,"tid"))
    message:addLong(index)
    message:addLong(gid)
    ff.net:rpc(message, false)
end
function equipgemLayer:onSetGems(params)
    local code = params[1]
    if code == 0 then        
        self:onEquipChoice()
        self:onGetGemsInfo()
        if params[2] == 11 then
            local sprite = self:getChildByName("equipinfo"):getChildByName("ico"):getChildByTag(99)
            if self:getChildByName("equipinfo"):getChildByName("ico"):getChildByName("99") == nil then
                sprite = sp.SkeletonAnimation:create("images/equipsp/xiangqian1.json", "images/equipsp/xiangqian1.atlas")
                sprite:setAnchorPoint(cc.p(0.5,0.5))
                sprite:setPosition(cc.p(300,325))
                self:getChildByName("equipinfo"):getChildByName("ico"):addChild(sprite,99,99)
            end
            sprite:setAnimation(0, "XX_animation", false)
            AudioEngine.playEffect(ff.sounds[603])
            self._index = 0
            self:showGemsInfo()
        end
    else
        dd.mainUI:onShowCodeTips(code)
    end
end

--选中装备
function equipgemLayer:onEquipChoice()
    if self._equipIndex <= 0 or self._equipIndex > self._equips:rowCount() then
        self._equipIndex = 0
        return
    end
    if  self._equipIndex <= self._equips:rowCount() then
        self._holeIndex = 0

        --self:getChildByName("equipinfo"):getChildByName("ico"):getChildByName("add"):setVisible(false)
        self:getChildByName("equipinfo"):getChildByName("ico"):getChildByName("add"):loadTexture(dd.getArmIcon(self._equips:getLong(self._equipIndex,"aid")),0)

        --self:getChildByName("equipinfo"):getChildByName("unselect"):setVisible(false)
        self:getChildByName("equipinfo"):getChildByName("tips"):setVisible(false)
        self:getChildByName("equipinfo"):getChildByName("info"):setVisible(true)
        self:getChildByName("equipinfo"):getChildByName("tip"):setVisible(false)
        --装备基本信息
        local str = ff.langString(dd.cfgArms[self._equips:getLong(self._equipIndex,"aid")]['name'])
        local hid = self._equips:getLong(self._equipIndex,"heroid")
        if hid > 0 then
            for i=1,dd.heros:rowCount() do
                if dd.heros:getLong(i,"hid") == hid then
                    str =  str.."("..ff.langString(dd.cfgHero[dd.heros:getLong(i,"id")]['name'])..")"
                    break
                end
            end
            self:getChildByName("equipinfo"):getChildByName("ico"):getChildByName("hero"):setVisible(true)
        else
            self:getChildByName("equipinfo"):getChildByName("ico"):getChildByName("hero"):setVisible(false)
        end
        self:getChildByName("equipinfo"):getChildByName("info"):getChildByName("chu_arms_name"):setString(str)
        --装备基本属性
        self:getChildByName("equipinfo"):getChildByName("info"):getChildByName("lists"):removeAllChildren()
        for i=1,3 do
            local param = dd.cfgArms[self._equips:getLong(self._equipIndex,"aid")]['param'..i]
            local value = dd.cfgArms[self._equips:getLong(self._equipIndex,"aid")]['value'..i]/dd.cfgEffect[param]['value']
            if param > 0 then
                local temp = self:getChildByName("equipinfo"):getChildByName("info"):getChildByName("item"):clone()
                temp:setVisible(true)
                self:getChildByName("equipinfo"):getChildByName("info"):getChildByName("lists"):addChild(temp)
                temp:getChildByName("sx"):setString(ff.langString(dd.cfgEffect[param]['name']))

                if ff.langString(dd.cfgEffect[param]['tips2']) ~= 0 then
                    temp:getChildByName("value"):setString("+"..value..ff.langString(dd.cfgEffect[param]['tips2']))
                else
                    temp:getChildByName("value"):setString("+"..value)
                end
                temp:requestDoLayout()
            end
        end


        --宝石
        local hole = dd.cfgArms[self._equips:getLong(self._equipIndex,"aid")]['hole']
        for i=1,3 do
            local item = self:getChildByName("equipinfo"):getChildByName("block"..i)
            local gid = self._equips:getLong(self._equipIndex,"gem"..i)
            if gid > 0 then
                item:getChildByName("have"):setVisible(false)
                item:getChildByName('ico'):setVisible(true)
                item:getChildByName("ico"):loadTexture(dd.getToolsIcon(gid),0)
                item:getChildByName('checkbox'):setVisible(true)
                item:getChildByName("checkbox"):setSelectedState(true)
                --
                local param = dd.cfgGems[gid]['param1']
                local value = dd.cfgGems[gid]['value1']/dd.cfgEffect[param]['value']
                

                local temp = self:getChildByName("equipinfo"):getChildByName("info"):getChildByName("item"):clone()
                temp:setVisible(true)
                self:getChildByName("equipinfo"):getChildByName("info"):getChildByName("lists"):addChild(temp)
                temp:getChildByName("sx"):setString(ff.langString("["..ff.langString(dd.cfgProp[gid]['name'],{dd.cfgProp[gid]['name1_lan']}).."]"))
                temp:getChildByName("value"):setString("")
                local temp2 = self:getChildByName("equipinfo"):getChildByName("info"):getChildByName("item"):clone()
                temp2:setVisible(true)
                self:getChildByName("equipinfo"):getChildByName("info"):getChildByName("lists"):addChild(temp2)
                temp2:getChildByName("sx"):setString(ff.langString(dd.cfgEffect[dd.cfgGems[gid]['param1']]['name']))
                if ff.langString(dd.cfgEffect[param]['tips2']) ~= 0 then
                    temp2:getChildByName("value"):setString("+"..value..ff.langString(dd.cfgEffect[param]['tips2']))
                else
                    temp2:getChildByName("value"):setString("+"..value)
                end
                if dd.cfgGems[gid]['param2'] > 0 then
                    local param2 = dd.cfgGems[gid]['param2']
                    local value2 = dd.cfgGems[gid]['value2']/dd.cfgEffect[param2]['value']
                    local temp3 = self:getChildByName("equipinfo"):getChildByName("info"):getChildByName("item"):clone()
                    temp3:setVisible(true)
                    self:getChildByName("equipinfo"):getChildByName("info"):getChildByName("lists"):addChild(temp3)
                    temp3:getChildByName("sx"):setString(ff.langString(dd.cfgEffect[dd.cfgGems[gid]['param2']]['name']))
                    if ff.langString(dd.cfgEffect[param2]['tips2']) ~= 0 then
                        temp3:getChildByName("value"):setString("+"..value2..ff.langString(dd.cfgEffect[param2]['tips2']))
                    else
                        temp3:getChildByName("value"):setString("+"..value2)
                    end
                end
                item:setTag(gid)
            else
                item:setTag(0)
                if hole >= i then
                    item:getChildByName("have"):setVisible(false)
                    item:getChildByName('ico'):setVisible(true)
                    item:getChildByName("ico"):loadTexture(dd.getPathFromUI('public/alpha.png',1))
                    item:getChildByName('checkbox'):setVisible(true)
                    item:getChildByName("checkbox"):setSelectedState(false)                    
                else
                    item:getChildByName("have"):setVisible(true)
                    item:getChildByName('ico'):setVisible(false)
                    item:getChildByName('checkbox'):setVisible(false)
                end
            end
        end
        self:getChildByName("equipinfo"):getChildByName("info"):getChildByName("lists"):refreshView()
        self:getChildByName("equipinfo"):getChildByName("info"):requestDoLayout()
    end
end

function equipgemLayer:updatePosition()
    local list = self:getChildByName("main")
    local line = self:getChildByName("main"):getChildrenCount()
    local tips = self:getChildByName("main"):getChildByName("tips")
    local min  = ff.height - 610 - 47 - 4
    local hh   = (line - 1) * 170
    if tips:isVisible() == true then
        hh = hh + 130
    end
    if min < hh then
        min = hh
    end
    self:getChildByName("main"):setInnerContainerSize(cc.size(700,min))
    local index = math.floor((tips:getTag()%10000)/10)
    local col   = (tips:getTag()%10000)%10
    for i,v in ipairs(self:getChildByName("main"):getChildren()) do
        local tag = v:getTag()
        if tag > 10000 then
            if v:isVisible() == true then
                v:setPositionX(0)
                v:setPositionY(min - index * 170 - 130)
                v:getChildByName("arrow"):setPositionX(87 + (col - 1) * 175)
            end
        else
            v:setPositionX(0)
            if tag > index then
                if tips:isVisible() == true then
                    v:setPositionY(min - 130 - tag * 170)
                else
                    v:setPositionY(min - tag * 170)
                end
            else
                v:setPositionY(min - tag * 170)
            end
        end
    end 

    if tips:isVisible() == true then
        cclog("y:"..self:getChildByName("main"):getInnerContainer():getPositionY()..",tips:"..tips:getPositionY())
        local fixy = self:getChildByName("main"):getInnerContainer():getPositionY() + tips:getPositionY()
        if fixy < 0 then
            self:getChildByName("main"):getInnerContainer():runAction(cc.MoveBy:create(0.3,cc.p(0,-fixy)))
        end
    end
end
function equipgemLayer:updateView()
    local list = self:getChildByName("main")
    local line = self:getChildByName("main"):getChildrenCount()
    line = line - 1
    local num   = 1
    local index = 1
    cclog("row:"..self._gems:rowCount().."line"..line)
    if self._gems ~= nil and self._gems:rowCount() then
        for i=1,self._gems:rowCount() do
            local block = list:getChildByTag(num):getChildByName("block"..index)
            if block == nil then
                return
            end
            block:setVisible(true)
            block:setTag(index)
            block:getChildByName("ico"):loadTexture(dd.getToolsIcon(self._gems:getLong(i,"id")),0)
            block:getChildByName("count"):getChildByName("count"):setString(ff.langString("LV.")..self._gems:getLong(i,"level").."  "..self._gems:getLong(i,"count"))
            block:getChildByName("heigh"):setVisible(false)
            block:getChildByName("checkbox"):setTag(i)
            block:getChildByName("checkbox"):setTouchEnabled(true)
            block:getChildByName("checkbox"):addTouchEventListener(self.selectGem)
            index = index + 1
            if index == 5 then
                index = 1
                num = num + 1
                if num > line then
                    break
                end
            end
        end
        for i=num,line do
            for j=index,4 do
                local block = list:getChildByTag(i):getChildByName("block"..j)
                if block == nil then
                    return
                end
                if block:getTag() > 0 then
                    block:setTag(0)
                    block:setVisible(true)
                    block:getChildByName("ico"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                    block:getChildByName("count"):getChildByName("count"):setString("")
                    block:getChildByName("heigh"):setVisible(false)
                    block:getChildByName("checkbox"):setTag(0)
                    block:getChildByName("checkbox"):setTouchEnabled(false)
                end
                index = index + 1
                if index == 5 then
                    index = 1
                    num = num + 1
                    if num > line then
                        break
                    end
                end
            end
        end
    end

    for i=num,line do
        local item = list:getChildByTag(i)
        for j=index,4 do
            item:getChildByName("block"..j):getChildByName("ico"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
            item:getChildByName("block"..j):getChildByName("heigh"):setVisible(false)
            item:getChildByName("block"..j):getChildByName("count"):getChildByName("count"):setString("")
            item:getChildByName("block"..j):getChildByName("checkbox"):setTag(0)
            item:getChildByName("block"..j):getChildByName("checkbox"):setTouchEnabled(false)
            index = index + 1
            if index == 5 then
                index = 1
                num = num + 1
                if num > line then
                    break
                end
            end
        end
    end
    list:requestDoLayout()
end

function equipgemLayer:showGemsInfo( )
    cclog("self._index:"..self._index)
    if self._index > 0 and self._index <= self._gems:rowCount() then
        local line = self:getChildByName("main"):getChildrenCount() - 1        
        for i=1,line do
            local item = self:getChildByName("main"):getChildByTag(i)
            if item ~= nil then
                for j=1,4 do
                    local target = item:getChildByName("block"..j)
                    if target ~= nil and target:getChildByName("checkbox"):getTag() == self._index then
                        local tips = self:getChildByName('main'):getChildByName("tips")
                        if tips:isVisible() == true then
                            tips:setVisible(false)
                            tips:stopAllActions()
                        end
                        cclog("i:"..i)
                        tips:setTag(10000 + i*10 + target:getTag())       
                    end
                end
                item:stopAllActions()
            end
        end        
        --先关闭之前的
        --self:updatePosition()
        local tips = self:getChildByName('main'):getChildByName("tips")
        tips:setVisible(true)
        self:updatePosition()

        local info = tips:getChildByName('info')
        local string = ""
        local gid = self._gems:getLong(self._index,"id")

        info:getChildByName("chu_name"):setString(ff.langString(dd.cfgProp[gid]['name'],{dd.cfgProp[gid]['name1_lan']}))
        if dd.cfgGems[gid]['param2'] > 0 then
            local param = dd.cfgGems[gid]['param1']
            local value = dd.cfgGems[gid]['value1']/dd.cfgEffect[param]['value']
            local param2 = dd.cfgGems[gid]['param2']
            local value2 = dd.cfgGems[gid]['value2']/dd.cfgEffect[param2]['value']
            local string1 = ""
            local string2 = ""
            info:getChildByName("sx"):setString()
            if ff.langString(dd.cfgEffect[param]['tips2']) ~= 0 then
                string1 =ff.langString(dd.cfgEffect[param]['name']).."+"..value..ff.langString(dd.cfgEffect[param]['tips2'])
            else
                string1 =ff.langString(dd.cfgEffect[param]['name']).."+"..value
                
            end
            if ff.langString(dd.cfgEffect[param2]['tips2']) ~= 0 then
                string2 =ff.langString(dd.cfgEffect[param2]['name']).."+"..value2..ff.langString(dd.cfgEffect[param2]['tips2'])
            else
                string2 =ff.langString(dd.cfgEffect[param2]['name']).."+"..value2
                
            end
            info:getChildByName("sx"):setString(string1..","..string2)
            info:getChildByName("value"):setString("")
        else
            local param = dd.cfgGems[gid]['param1']
            local value = dd.cfgGems[gid]['value1']/dd.cfgEffect[param]['value']
            
            info:getChildByName("sx"):setString(ff.langString(dd.cfgEffect[param]['name']))
            if ff.langString(dd.cfgEffect[param]['tips2']) ~= 0 then
                info:getChildByName("value"):setString("+"..value..ff.langString(dd.cfgEffect[param]['tips2']))
            else
                info:getChildByName("value"):setString("+"..value)
            end
        end
        info:requestDoLayout()
        tips:getChildByName("info"):getChildByName("xiangqian"):setTag(gid)
    else
        local tips = self:getChildByName('main'):getChildByName("tips")
        tips:setVisible(false)
        self:updatePosition()
    end
end

function equipgemLayer.cancelTips(sender,eventType)
    cclog("doaction cancelTips1")
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end        
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end    
    if doaction == true then
        cclog("doaction cancelTips")
        local widget = pop.getDialog("equipgem")
        if widget ~= nil and widget:getChildByName("main"):getChildByName("tips"):isVisible() == true then
            local line = widget:getChildByName("main"):getChildrenCount() - 1
            for i=1,line do
                local item = widget:getChildByName("main"):getChildByTag(i)
                if item ~= nil then
                    for j=1,4 do
                        item:getChildByName("block"..j):getChildByName("checkbox"):setSelectedState(false)
                    end
                end
            end
            widget._index = 0
            widget:showGemsInfo()
        end
    end
end
function equipgemLayer.selectGem(sender,eventType)
    local doaction = false
    local state    = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
            if sender:getSelectedState() == true then
                sender:setSelectedState(false)
                state = false
            else
                sender:setSelectedState(true)
                state = true
            end
        end
    end
    if eventType == ccui.TouchEventType.ended then
        if sender:getSelectedState() == true then
            state = false
        else
            state = true
        end    
        doaction = true
    end
    if doaction == true then
        local widget = pop.getDialog("equipgem")
        if widget ~= nil then
            local line = widget:getChildByName("main"):getChildrenCount() - 1
            for i=1,line do
                local item = widget:getChildByName("main"):getChildByTag(i)
                if item ~= nil then
                    for j=1,4 do
                        if item:getChildByName("block"..j):getChildByName("checkbox") ~= sender then
                            item:getChildByName("block"..j):getChildByName("checkbox"):setSelectedState(false)
                        end
                    end
                end
            end
            if state == false then
                widget._index = 0
            else
                widget._index = sender:getTag()
            end
            widget:showGemsInfo()            
        end
    end
end

function equipgemLayer.updateGold(name,row,old,value)
    local sender = pop.getDialog("equipgem")
    if sender ~= nil then
        sender:getChildByName("top"):getChildByName("count"):setString(dd.myinfo:getLong(1,"gold"))
        local w = sender:getChildByName("top"):getChildByName("count"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        sender:getChildByName("top"):getChildByName("title"):setContentSize(cc.size(w,100))
        sender:getChildByName("top"):getChildByName("title"):requestDoLayout()
        sender:getChildByName("top"):requestDoLayout()
    end
end



--拖动显示更多宝石
function equipgemLayer:getMoreGems()
    local num = self:getChildByName("main"):getChildrenCount()-1
    if self._gems:rowCount() > num * 4 then
        platform_showWaiting(1,0)
        if self._gems:rowCount() <= (num + 1)*4 then
            self:showGems(1)
        else
            self:showGems(2)
        end        
        --自动上浮30像素，
        self:getChildByName("main"):requestDoLayout()
        self:getChildByName("main"):getInnerContainer():runAction(cc.MoveBy:create(0.3,cc.p(0,30)))
        platform_showWaiting(0)
    end
end
function equipgemLayer.scrollViewEvent(sender, evenType)
    if evenType ==  ccui.ScrollviewEventType.bounceBottom then
        local widget = pop.getDialog("equipgem")
        if widget:isVisible() == true then
            widget:getMoreGems()
        end 
    end
end

--显示列表
function equipgemLayer:showGems(num)
    --去掉tips
    local count = self:getChildByName("main"):getChildrenCount() - 1
    if count < 4 then
        for i=(count + 1),4 do
            item = self:getChildByName("list"):clone()
            item:setVisible(true)
            item:setTag(i)
            self:getChildByName("main"):addChild(item)
            item:addTouchEventListener(self.cancelTips)  
        end        
    end

    if num > 0 then
        local count = self:getChildByName("main"):getChildrenCount() - 1
        for i=1,num do
            item = self:getChildByName("list"):clone()
            item:setVisible(true)
            item:setTag(count + i)
            self:getChildByName("main"):addChild(item)
            item:addTouchEventListener(self.cancelTips)  
        end        
    end
    self:updatePosition()
    self:updateView()
end
--获取宝石列表
--根据showorder排序的
function equipgemLayer:onGetGemsInfo()
    if self._gems == nil then
        self._gems = ff.NetTable:create()
        self._gems:addCol("id",ff.NET_LONG)
        self._gems:addCol("count",ff.NET_LONG)
        self._gems:addCol("color",ff.NET_LONG)
        self._gems:addCol("level",ff.NET_LONG)
        self._gems:addCol("type",ff.NET_LONG)
    else
        self._gems:delRows()
    end

    for var=1, dd.mytools:rowCount() do
        local id = dd.mytools:getLong(var,'tid')
        local count = dd.mytools:getLong(var,'count')
        if tonumber(dd.cfgProp[id]['type']) == 8 then
            if self._equips ~= nil and self._equipIndex > 0 and self._equipIndex <= self._equips:rowCount() then
                local equipid = self._equips:getLong(self._equipIndex,"aid")
                if tonumber(ff.to2str(dd.cfgArms[equipid]['gemtype'],dd.cfgGems[id]['equipshow']))  == 1  then
  
                    local index = self._gems:addRow()
                    self._gems:setLong(index,"id",id)
                    self._gems:setLong(index,"count",count)
                    self._gems:setLong(index,"color",tonumber(dd.cfgProp[id]['color']))
                    self._gems:setLong(index,"level",tonumber(dd.cfgGems[id]['level']))
                    self._gems:setLong(index,"type",tonumber(dd.cfgGems[id]['type']))
                end
            else
                local index = self._gems:addRow()
                self._gems:setLong(index,"id",id)
                self._gems:setLong(index,"count",count)
                self._gems:setLong(index,"color",tonumber(dd.cfgProp[id]['color']))
                self._gems:setLong(index,"level",tonumber(dd.cfgGems[id]['level']))
                self._gems:setLong(index,"type",tonumber(dd.cfgGems[id]['type']))
            end
        end
    end
    self:showGems(0)
    local tips = self:getChildByName('main'):getChildByName("tips")
    tips:setVisible(false)
    tips:stopAllActions()
    local line = self:getChildByName("main"):getChildrenCount() - 1
    for i=1,line do
        local item = self:getChildByName("main"):getChildByTag(i)
        if item ~= nil then
            for j=1,4 do
                item:getChildByName("block"..j):getChildByName("checkbox"):setSelectedState(false)
            end
        end
    end
    self:updatePosition()
end

function equipgemLayer.onStart(sender)
    dd.initGoldSpine(sender:getChildByName("top"):getChildByName("gold"),sender:getChildByName("top"):getChildByName("addgold"))
    sender:onGetGemsInfo()
end

function equipgemLayer.onBefore( sender )
    ff.net:registerEvent(2,dd.Tjg_equip_set_gem, function (message)sender:onSetGems(message)end)
    ff.net:bindProperty(2305,"gold",sender.updateGold)
end

function equipgemLayer.onEnd( sender )
    sender._index      = 0 -- 宝石
    sender._equipIndex = 0
    sender._holeIndex  = 0
    sender:getChildByName("equipinfo"):getChildByName("ico"):getChildByName("hero"):setVisible(false)
    if ff.platform ~= 1 then
        sender:getChildByName("equipinfo"):getChildByName("ico"):getChildByName("add"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        sender:getChildByName("equipinfo"):getChildByName("block1"):getChildByName("ico"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        sender:getChildByName("equipinfo"):getChildByName("block2"):getChildByName("ico"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        sender:getChildByName("equipinfo"):getChildByName("block3"):getChildByName("ico"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
    end

    ff.net:removeEvent(2,dd.Tjg_equip_set_gem)
    ff.net:unbindProperty("gold",2305)

    dd.delBackEvent()

    local line = sender:getChildByName("main"):getChildrenCount()
    for i=1,line do
        local item = sender:getChildByName("main"):getChildByTag(i)
        if item ~= nil then
            for j=1,4 do
                item:getChildByName("block"..j):getChildByName("ico"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                item:getChildByName("block"..j):getChildByName("count"):getChildByName("count"):setString("")
            end
        end
    end

    for i=1,3 do   
        local name = "block"..tostring(i)
        local ico = sender:getChildByName("equipinfo"):getChildByName(name):getChildByTag(99)
        if ico ~= nil then
            ico:removeFromParent()
        end
    end
end

function onShowEquipGem(widget,equipIndex)
    local layer = equipgemLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)
    layer:onInit(equipIndex)
    return layer
end
