equipcomposeLayer = class("equipcomposeLayer")
equipcomposeLayer._name = "equipcompose"
equipcomposeLayer._init = false
equipcomposeLayer._index = 0
equipcomposeLayer._type = 1 --1材料，2，宝石
equipcomposeLayer._compcfg = {}
equipcomposeLayer._items = {}
equipcomposeLayer._gems = {}
equipcomposeLayer._itemID = 0

function equipcomposeLayer.extend( target )
	-- body\
	local t = tolua.getpeer(target)
	if not t then
		t = {}
		tolua.setpeer(target,t)
	end
	setmetatable(t,equipcomposeLayer)
	return target
end

function onShowEquipCompose(widget)
	-- body
	local layer = equipcomposeLayer.extend(widget)
	dd.regeditBackEvent(layer.onReturn)
    layer:onInit()
    return layer
end

function equipcomposeLayer.onReturn( sender,eventType )
	-- body
	local close = false
    if sender == nil then
        close = true
    end
    if eventType == ccui.TouchEventType.ended then
        close = true
    end
    if close == true then
        local widget = pop.getDialog("equipcompose")
        
        if widget then
           	pop.onClosePopDialog("equipcompose")
        end
    end
end

function equipcomposeLayer:onInit()
	-- body
	if self._init == false then
		self:onAutoSize()
        self:getChildByName("main"):addEventListener(self.scrollViewEvent)  
        self:getChildByName("mainitem"):addEventListener(self.scrollViewEventEx)      
		self._init = true
	end
    self._type = 1
    self.updateGold()
    self:InitData()
    self:getChildByName("topNavi"):getChildByName("navi1"):setSelectedState(true)
    if self._type ==1 then
        self:getChildByName("mainitem"):setVisible(true)
        self:getChildByName("main"):setVisible(false)
    else
        self:getChildByName("mainitem"):setVisible(false)
        self:getChildByName("main"):setVisible(true)
    end
    self:getChildByName("info"):getChildByName("Image_132"):loadTexture("images/ui/block01_smithy.jpg",0)
end

function equipcomposeLayer.scrollViewEvent(sender, evenType)
    if evenType ==  ccui.ScrollviewEventType.bounceBottom then
        local widget = pop.getDialog("equipcompose")
        if widget:isVisible() == true then
            widget:getMoreGems()
        end 
    end
end

function equipcomposeLayer.scrollViewEventEx(sender, evenType)
    if evenType ==  ccui.ScrollviewEventType.bounceBottom then
        local widget = pop.getDialog("equipcompose")
        if widget:isVisible() == true then
            widget:getMoreItems()
        end 
    end
end

function equipcomposeLayer:getMoreGems()
    local num = self:getChildByName("main"):getChildrenCount() - 1
    if table.getn(self._gems) > num * 4 then
        platform_showWaiting(1,0)
        if table.getn(self._gems) <= (num + 1)*4 then
            self:showGems(1)
        else
            self:showGems(2)
        end        
        --自动上浮30像素，
        self:getChildByName("main"):requestDoLayout()
        self:getChildByName("main"):getInnerContainer():runAction(cc.MoveBy:create(0.3,cc.p(0,30)))
        platform_showWaiting(0)
    end
end

function equipcomposeLayer:getMoreItems()
    local num = self:getChildByName("mainitem"):getChildrenCount() - 1
    if table.getn(self._items) > num * 4 then
        platform_showWaiting(1,0)
        if table.getn(self._items) <= (num + 1)*4 then
            self:showItems(1)
        else
            self:showItems(2)
        end        
        --自动上浮30像素，
        self:getChildByName("mainitem"):requestDoLayout()
        self:getChildByName("mainitem"):getInnerContainer():runAction(cc.MoveBy:create(0.3,cc.p(0,30)))
        platform_showWaiting(0)
    end
end

function equipcomposeLayer:showGems(num)
    --去掉tips
        local count = self:getChildByName("main"):getChildrenCount() - 1
        if count < 5 then
            for i=(count + 1),5 do
                item = self:getChildByName("gemslist"):clone()
                item:setVisible(true)
                item:setTag(i)
                self:getChildByName("main"):addChild(item)
                item:addTouchEventListener(self.cancelTips)  
            end        
        end

        if num > 0 then
            local count = self:getChildByName("main"):getChildrenCount() - 1
            for i=1,num do
                item = self:getChildByName("gemslist"):clone()
                item:setVisible(true)
                item:setTag(count + i)
                self:getChildByName("main"):addChild(item)
                item:addTouchEventListener(self.cancelTips)  
            end        
        end

    self:updatePosition()
    self:updateView()
end

function equipcomposeLayer:showItems(num)
    --去掉tips
    local count = self:getChildByName("mainitem"):getChildrenCount() - 1
    if count < 5 then
        for i=(count + 1),5 do
            item = self:getChildByName("itemslist"):clone()
            item:setVisible(true)
            item:setTag(i)
            self:getChildByName("mainitem"):addChild(item)
            item:addTouchEventListener(self.cancelItemTips)  
        end        
    end

    if num > 0 then
        local count = self:getChildByName("mainitem"):getChildrenCount() - 1
        for i=1,num  do
            item = self:getChildByName("itemslist"):clone()
            item:setVisible(true)
            item:setTag(count + i)
            self:getChildByName("mainitem"):addChild(item)
            item:addTouchEventListener(self.cancelItemTips)  
        end        
    end

    self:updatePosition()
    self:updateView()
end

function equipcomposeLayer.cancelTips(sender,eventType)
   
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end        
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end    
    if doaction == true then
        
        local widget = pop.getDialog("equipcompose")
        if widget ~= nil and widget:getChildByName("main"):getChildByName("tips"):isVisible() == true then
            local line = widget:getChildByName("main"):getChildrenCount() - 1
            for i=1,line do
                local item = widget:getChildByName("main"):getChildByTag(i)
                if item ~= nil then
                    for j=1,4 do
                        item:getChildByName("block"..j):getChildByName("checkbox"):setSelectedState(false)
                    end
                end
            end
            
            widget._index = 0
            widget:showGemsInfo()
            widget:showInfoForGems()
        end
    end
end

function equipcomposeLayer.cancelItemTips(sender,eventType)
    
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end        
    end
    if eventType == ccui.TouchEventType.ended then
        doaction = true
    end    
    if doaction == true then
        
        local widget = pop.getDialog("equipcompose")
        if widget ~= nil and widget:getChildByName("mainitem"):getChildByName("tips"):isVisible() == true then
            local line = widget:getChildByName("mainitem"):getChildrenCount() - 1
            for i=1,line do
                local item = widget:getChildByName("mainitem"):getChildByTag(i)
                if item ~= nil then
                    for j=1,4 do
                        item:getChildByName("block"..j):getChildByName("checkbox"):setSelectedState(false)
                    end
                end
            end
           
            widget._index = 0
            widget:showItemsInfo()
            widget:showInfoForItems()     
        end
    end
end

function equipcomposeLayer:showGemsInfo( )
   
    if self._index > 0 and self._index <= table.getn(self._gems) then
        local line = self:getChildByName("main"):getChildrenCount() - 1        
        for i=1,line do
            local item = self:getChildByName("main"):getChildByTag(i)
            if item ~= nil then
                for j=1,4 do
                    local target = item:getChildByName("block"..j)
                    if target ~= nil and target:getChildByName("checkbox"):getTag() == self._index then
                        local tips = self:getChildByName('main'):getChildByName("tips")
                        if tips:isVisible() == true then
                            tips:setVisible(false)
                            tips:stopAllActions()
                        end
                       
                        tips:setTag(10000 + i*10 + target:getTag())       
                    end
                end
                item:stopAllActions()
            end
        end        
        --先关闭之前的
        local tips = self:getChildByName('main'):getChildByName("tips")
        tips:setVisible(true)
        self:updatePosition()

        local info = tips:getChildByName('info')
        local string = ""
        local gid =self._gems[self._index]["id"] --self._gems:getLong(self._index,"id")

        info:getChildByName("chu_name"):setString(ff.langString(dd.cfgProp[gid]['name'],{dd.cfgProp[gid]['name1_lan']}))
        if dd.cfgGems[gid]['param2'] > 0 then
            local value = dd.cfgGems[gid]['value1']/10
            local param = dd.cfgGems[gid]['param1']
            local value2 = dd.cfgGems[gid]['value2']/10
            local param2 = dd.cfgGems[gid]['param2']
            local string1 = ""
            local string2 = ""
            if ff.langString(dd.cfgEffect[param]['tips2']) ~= 0 then
                string1 = ff.langString(dd.cfgEffect[param]['name']).."+"..value..ff.langString(dd.cfgEffect[param]['tips2'])
            else
                string1 = ff.langString(dd.cfgEffect[param]['name']).."+"..value
            end
            if ff.langString(dd.cfgEffect[param2]['tips2']) ~= 0 then
                string2 = ff.langString(dd.cfgEffect[param2]['name']).."+"..value2..ff.langString(dd.cfgEffect[param2]['tips2'])
            else
                string2 = ff.langString(dd.cfgEffect[param2]['name']).."+"..value2
            end
            info:getChildByName("sx"):setString(string1..","..string2)

            info:getChildByName("value"):setString("")
        else
            local value = dd.cfgGems[gid]['value1']/10
            local param = dd.cfgGems[gid]['param1']
            info:getChildByName("sx"):setString(ff.langString(dd.cfgEffect[param]['name']))
            if ff.langString(dd.cfgEffect[param]['tips2']) ~= 0 then
                info:getChildByName("value"):setString("+"..value..ff.langString(dd.cfgEffect[param]['tips2']))
            else
                info:getChildByName("value"):setString("+"..value)
            end
        end
        local money = self._gems[self._index]["money"]
        info:getChildByName("count"):setString(dd.showKM(money,5))
        if money > dd.silver() then
            info:getChildByName("count"):setColor(cc.c3b(255,0,0))
        else
            info:getChildByName("count"):setColor(cc.c3b(255,255,255))
        end
        info:requestDoLayout()
        --tips:getChildByName("info"):getChildByName("xiangqian"):setTag(gid)
    else
        self._index = 0
        local tips = self:getChildByName('main'):getChildByName("tips")
        tips:setVisible(false)
        self:updatePosition()
    end
end

function equipcomposeLayer:showItemsInfo( )
    
    if self._index > 0 and self._index <= table.getn(self._items) then
        local line = self:getChildByName("mainitem"):getChildrenCount() - 1 
        
        for i=1,line do
            local item = self:getChildByName("mainitem"):getChildByTag(i)
           
            if item ~= nil then
            
                for j=1,4 do
                    local target = item:getChildByName("block"..j)
                    if target ~= nil and target:getChildByName("checkbox"):getTag() == self._index then
                        local tips = self:getChildByName('mainitem'):getChildByName("tips")
                        if tips:isVisible() == true then
                            tips:setVisible(false)
                            tips:stopAllActions()
                        end
 
                        tips:setTag(10000 + i*10 + target:getTag())       
                    end
                end
                item:stopAllActions()
            end
        end        
        --先关闭之前的

        local tips = self:getChildByName('mainitem'):getChildByName("tips")
        tips:setVisible(true)
        self:updatePosition()

        local info = tips:getChildByName('info')
        local string = ""
        local gid =self._items[self._index]["id"] 

        info:getChildByName("chu_name"):setString(ff.langString(dd.cfgProp[self._items[self._index]["id"]]['name'],{dd.cfgProp[self._items[self._index]["id"]]['name1_lan']}))
        local type = self._items[self._index]["color"] 
        local colorcode = cc.c3b(196,213,214)
        if type == 1 then
            colorcode = cc.c3b(196,213,214)
        elseif type == 2 then
            colorcode = cc.c3b(75,137,81)
        elseif type == 3 then
            colorcode = cc.c3b(63,116,160)
        elseif type == 4 then
            colorcode = cc.c3b(164,80,151)
        elseif type == 5 then
            colorcode = cc.c3b(255,250,106)
        else
            colorcode = cc.c3b(196,213,214)
        end
        info:getChildByName("chu_name"):setColor(colorcode)

        info:getChildByName("sx"):setString(ff.langString(dd.cfgProp[self._items[self._index]["id"]]['tips'],{dd.cfgProp[self._items[self._index]["id"]]['tips1_lan']}))

        

        info:getChildByName("value"):setString("")
        
        local money = self._items[self._index]["money"]
        info:getChildByName("count"):setString(dd.showKM(money,5))
        if money > dd.silver() then
            info:getChildByName("count"):setColor(cc.c3b(255,0,0))
        else
            info:getChildByName("count"):setColor(cc.c3b(255,255,255))
        end
        
        info:requestDoLayout()

    else
        self._index = 0
        local tips = self:getChildByName('mainitem'):getChildByName("tips")
        tips:setVisible(false)
        self:updatePosition()
    end
end

function equipcomposeLayer:updatePosition()
    if self._type ==2 then
        local list = self:getChildByName("main")
        local line = self:getChildByName("main"):getChildrenCount()
        local tips = self:getChildByName("main"):getChildByName("tips")
        local min  = ff.height - 105 -85 - 244  - 60
        local hh   = (line - 1) * 170
        if tips:isVisible() == true then
            hh = hh + 130
        end
        if min < hh then
            min = hh
        end
        self:getChildByName("main"):setInnerContainerSize(cc.size(700,min))
        local index = math.floor((tips:getTag()%10000)/10)
        local col   = (tips:getTag()%10000)%10
        for i,v in ipairs(self:getChildByName("main"):getChildren()) do
            local tag = v:getTag()
            if tag > 10000 then
                if v:isVisible() == true then
                    v:setPositionX(0)
                    v:setPositionY(min - index * 170 - 130)
                    v:getChildByName("arrow"):setPositionX(87 + (col - 1) * 175)
                end
            else
                v:setPositionX(-10)
                if tag > index then
                    if tips:isVisible() == true then
                        v:setPositionY(min - 130 - tag * 170)
                    else
                        v:setPositionY(min - tag * 170)
                    end
                else
                    v:setPositionY(min - tag * 170)
                end
            end
        end 

        if tips:isVisible() == true then
            local fixy = self:getChildByName("main"):getInnerContainer():getPositionY() + tips:getPositionY()
            if fixy < 0 then
                self:getChildByName("main"):getInnerContainer():runAction(cc.MoveBy:create(0.3,cc.p(0,-fixy)))
            end
        end
    else
        local list = self:getChildByName("mainitem")
        local line = self:getChildByName("mainitem"):getChildrenCount()
        local tips = self:getChildByName("mainitem"):getChildByName("tips")
        local min  = ff.height - 105 -85 - 244  - 60
        local hh   = (line - 1) * 170
        if tips:isVisible() == true then
            hh = hh + 130
        end
        if min < hh then
            min = hh
        end
        self:getChildByName("mainitem"):setInnerContainerSize(cc.size(700,min))
        local index = math.floor((tips:getTag()%10000)/10)
        local col   = (tips:getTag()%10000)%10
        for i,v in ipairs(self:getChildByName("mainitem"):getChildren()) do
            
            local tag = v:getTag()
            if tag > 10000 then
                if v:isVisible() == true then
                    v:setPositionX(0)
                    v:setPositionY(min - index * 170 - 130)
                    v:getChildByName("arrow"):setPositionX(87 + (col - 1) * 175)
                end
            else
                v:setPositionX(-10)
                local  y = 1
                if tag > index then
                    if tips:isVisible() == true then
                        v:setPositionY(min - 130 - tag * 170)
                        y = min - 130 - tag * 170
                        
                    else
                        v:setPositionY(min - tag * 170)
                        y = min - tag * 170
                        
                    end
                else
                    v:setPositionY(min - tag * 170)
                    y = min - tag * 170
                    
                end
            end
        end 

        if tips:isVisible() == true then
            local fixy = self:getChildByName("mainitem"):getInnerContainer():getPositionY() + tips:getPositionY()
            if fixy < 0 then
                self:getChildByName("mainitem"):getInnerContainer():runAction(cc.MoveBy:create(0.3,cc.p(0,-fixy)))
            end
        end
    end
end

function equipcomposeLayer:InitData(  )
    -- body
    self._compcfg = {}
    local propData = ff.dbmanager:sql_fetch_rows("select `needtool`,`tool`,`type`,`money` from `cfg_props_make` order by `needtool`")
    for i=1, propData:rowCount() do
        local pId = tonumber(propData:getString(i, "needtool"))
        self._compcfg[pId] = {}
        self._compcfg[pId]['tool']   = tonumber(propData:getString(i, "tool"))
        self._compcfg[pId]['type'] = tonumber(propData:getString(i, "type"))
        self._compcfg[pId]['money'] = tonumber(propData:getString(i, "money"))
    end
    propData:clear()

    self._gems = {} --ff.NetTable:create()

    self._items = {} --ff.NetTable:create()

end

function equipcomposeLayer:unselectType(  )
    -- body
    self:getChildByName("topNavi"):getChildByName("navi1"):setSelectedState(false)
    self:getChildByName("topNavi"):getChildByName("navi2"):setSelectedState(false)
   
    self:getChildByName("topNavi"):getChildByName("navi1"):getChildByName("Label"):setColor(cc.c3b(135,89,89))
    self:getChildByName("topNavi"):getChildByName("navi2"):getChildByName("Label"):setColor(cc.c3b(135,89,89))
  
end

function equipcomposeLayer:updateView()
    if self._type ==2 then
        local list = self:getChildByName("main")
        local line = self:getChildByName("main"):getChildrenCount()
        line = line - 1
        local num   = 1
        local index = 1
        if table.getn(self._gems) then
            for i=1,table.getn(self._gems) do
                local block = list:getChildByTag(num):getChildByName("block"..index)
                if block == nil then
                    return
                end
                block:setVisible(true)
                block:setTag(index)
                block:getChildByName("ico"):loadTexture(dd.getToolsIcon(self._gems[i]["id"]),0)
                block:getChildByName("count"):getChildByName("count"):setString(ff.langString("LV.")..self._gems[i]["level"].."  "..self._gems[i]["count"])
                
                block:getChildByName("checkbox"):setTag(i)
                block:getChildByName("checkbox"):setTouchEnabled(true)
                block:getChildByName("checkbox"):addTouchEventListener(self.selectGem)
                index = index + 1
                if index == 5 then
                    index = 1
                    num = num + 1
                    if num > line then
                        break
                    end
                end
            end
            for i=num,line do
                local block = list:getChildByTag(i):getChildByName("block"..index)
                if block == nil then
                    return
                end
                if block:getTag() > 0 then
                    --block:setTag(0)
                    block:setVisible(true)
                    block:getChildByName("ico"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                    block:getChildByName("count"):getChildByName("count"):setString("")
                    
                    block:getChildByName("checkbox"):setTag(0)
                    block:getChildByName("checkbox"):setTouchEnabled(false)
                end
                index = index + 1
                if index == 5 then
                    index = 1
                    num = num + 1
                    if num > line then
                        break
                    end
                end
            end
        end
        for i=num,line do
            local item = list:getChildByTag(i)
            for j=index,4 do
                item:getChildByName("block"..j):getChildByName("ico"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                item:getChildByName("block"..j):getChildByName("count"):getChildByName("count"):setString("")
                item:getChildByName("block"..j):getChildByName("checkbox"):setTag(0)
                item:getChildByName("block"..j):getChildByName("checkbox"):setTouchEnabled(false)
                index = index + 1
                if index == 5 then
                    index = 1
                    num = num + 1
                    if num > line then
                        break
                    end
                end
            end
        end
        list:requestDoLayout()
    else
        local list = self:getChildByName("mainitem")
        local line = self:getChildByName("mainitem"):getChildrenCount()
        line = line - 1
        local num   = 1
        local index = 1
        
        if table.getn(self._items) then
            for i=1,table.getn(self._items) do
                local block = list:getChildByTag(num):getChildByName("block"..index)
                if block == nil then
                    return
                end
                block:setVisible(true)
                block:setTag(index)
                block:getChildByName("ico"):loadTexture(dd.getToolsIcon(self._items[i]["id"]),0)
                block:getChildByName("count"):getChildByName("count"):setString(self._items[i]["count"])
                block:getChildByName("checkbox"):setTag(i)
                block:getChildByName("checkbox"):setTouchEnabled(true)
                block:getChildByName("checkbox"):addTouchEventListener(self.selectItem)
                local color = self._items[i]["color"]

                if color == 1 then
                    block:loadTexture(dd.getPathFromUI("white01on.png",1))
                    block:getChildByName("checkbox"):loadTextureBackGroundSelected(
                        dd.getPathFromUI("white01.png",1))
                    block:getChildByName("checkbox"):loadTextureFrontCross(
                        dd.getPathFromUI("white01.png",1))
                elseif color ==2 then
                    block:loadTexture(dd.getPathFromUI("green01on.png",1))
                    block:getChildByName("checkbox"):loadTextureBackGroundSelected(
                        dd.getPathFromUI("green01.png",1))
                    block:getChildByName("checkbox"):loadTextureFrontCross(
                        dd.getPathFromUI("green01.png",1))
                elseif color == 3 then
                    block:loadTexture(dd.getPathFromUI("blue01on.png",1))
                    block:getChildByName("checkbox"):loadTextureBackGroundSelected(
                        dd.getPathFromUI("blue01.png",1))
                    block:getChildByName("checkbox"):loadTextureFrontCross(
                        dd.getPathFromUI("blue01.png",1))
                elseif color == 4 then
                    block:loadTexture(dd.getPathFromUI("purple01on.png",1))
                    block:getChildByName("checkbox"):loadTextureBackGroundSelected(
                        dd.getPathFromUI("purple01.png",1))
                    block:getChildByName("checkbox"):loadTextureFrontCross(
                        dd.getPathFromUI("purple01.png",1))
                elseif color == 5 then
                    block:loadTexture(dd.getPathFromUI("orange01on.png",1))
                    block:getChildByName("checkbox"):loadTextureBackGroundSelected(
                        dd.getPathFromUI("orange01.png",1))
                    block:getChildByName("checkbox"):loadTextureFrontCross(
                        dd.getPathFromUI("orange01.png",1))
                end
                index = index + 1
                if index == 5 then
                    index = 1
                    num = num + 1
                    if num > line then
                        break
                    end
                end
            end
            for i=num,line do
                local block = list:getChildByTag(i):getChildByName("block"..index)
                if block == nil then
                    return
                end
                if block:getTag() > 0 then
                    block:setTag(0)
                    block:setVisible(true)
                    block:getChildByName("ico"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                    block:getChildByName("count"):getChildByName("count"):setString("")
                    block:getChildByName("checkbox"):setTag(0)
                    block:getChildByName("checkbox"):setTouchEnabled(false)
                    block:loadTexture(dd.getPathFromUI("white01on.png",1))
                    block:getChildByName("checkbox"):loadTextureBackGroundSelected(
                        dd.getPathFromUI("white01.png",1))
                    block:getChildByName("checkbox"):loadTextureFrontCross(
                        dd.getPathFromUI("white01.png",1))
                end
                index = index + 1
                if index == 5 then
                    index = 1
                    num = num + 1
                    if num > line then
                        break
                    end
                end
            end
        end
        for i=num,line do
            local item = list:getChildByTag(i)
            for j=index,4 do
                item:getChildByName("block"..j):getChildByName("ico"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                item:getChildByName("block"..j):getChildByName("count"):getChildByName("count"):setString("")
                item:getChildByName("block"..j):getChildByName("checkbox"):setTag(0)
                item:getChildByName("block"..j):getChildByName("checkbox"):setTouchEnabled(false)
                item:getChildByName("block"..j):loadTexture(dd.getPathFromUI("white01on.png",1))
                item:getChildByName("block"..j):getChildByName("checkbox"):loadTextureBackGroundSelected(
                    dd.getPathFromUI("white01.png",1))
                item:getChildByName("block"..j):getChildByName("checkbox"):loadTextureFrontCross(
                    dd.getPathFromUI("white01.png",1))
                index = index + 1
                if index == 5 then
                    index = 1
                    num = num + 1
                    if num > line then
                        break
                    end
                end
            end
        end
        list:requestDoLayout()
    end
end

function equipcomposeLayer.selectType(sender,eventType)
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("equipcompose")
        if widget ~= nil then
            local type  = sender:getTag()
            widget:unselectType()
            sender:getChildByName("Label"):setColor(cc.c3b(239,223,223))
            if widget._type == type then
                return
            else
                widget._type = type
                widget.cancelTips(widget:getChildByName("gemslist"),ccui.TouchEventType.canceled)
                widget.cancelItemTips(widget:getChildByName("itemslist"),ccui.TouchEventType.canceled)
                widget._index = 0
            end
            --根据type进入不用界面
            widget:switchmenu()
        end
    end
    -- body
end

function equipcomposeLayer:switchmenu( )
    self:getChildByName("info"):getChildByName("item"):getChildByName("block"):loadTexture(dd.getPathFromUI("white01on.png",1))
    self:getChildByName("info"):getChildByName("item"):getChildByName("block2"):loadTexture(dd.getPathFromUI("white01on.png",1))
    self:getChildByName("info"):getChildByName("item"):getChildByName("block"):getChildByName("ico"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
    self:getChildByName("info"):getChildByName("item"):getChildByName("block2"):getChildByName("ico"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
    self:getChildByName("info"):getChildByName("gem"):getChildByName("block"):getChildByName("ico"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
    self:getChildByName("info"):getChildByName("gem"):getChildByName("block1"):getChildByName("ico1"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
    self:getChildByName("info"):getChildByName("num"):loadTexture(dd.getPathFromUI("e_number0.png",1))
    --self:getChildByName("main"):getChildByName("tips"):setVisible(false)
    --self:getChildByName("mainitem"):getChildByName("tips"):setVisible(false)

    if self._type == 1 then
        self:getChildByName("info"):getChildByName("item"):setVisible(true)
        self:getChildByName("pro"):getChildByName("chu_Label_156"):getVirtualRenderer():enableBold(true)
        self:getChildByName("pro"):getChildByName("chu_Label_156"):setString(ff.langString("你储备的材料"))
        self:getChildByName("main"):setVisible(false)
        self:getChildByName("mainitem"):setVisible(true)
        self:getChildByName("info"):getChildByName("gem"):setVisible(false)
        self:getChildByName("topNavi"):getChildByName("navi2"):setSelectedState(false)
        self:getChildByName("topNavi"):getChildByName("navi1"):getChildByName("Label"):setColor(cc.c3b(239,223,223))
        self:getChildByName("topNavi"):getChildByName("navi2"):getChildByName("Label"):setColor(cc.c3b(128,102,102))

        self:showItems(0)
        self:showInfoForItems()

    else
        self:getChildByName("main"):setVisible(true)
        self:getChildByName("mainitem"):setVisible(false)
        self:getChildByName("info"):getChildByName("item"):setVisible(false)
        self:getChildByName("pro"):getChildByName("chu_Label_156"):getVirtualRenderer():enableBold(true)
        self:getChildByName("pro"):getChildByName("chu_Label_156"):setString(ff.langString("你储备的合金"))
        self:getChildByName("topNavi"):getChildByName("navi1"):setSelectedState(false)
        self:getChildByName("info"):getChildByName("gem"):setVisible(true)
        self:getChildByName("topNavi"):getChildByName("navi2"):getChildByName("Label"):setColor(cc.c3b(239,223,223))
        self:getChildByName("topNavi"):getChildByName("navi1"):getChildByName("Label"):setColor(cc.c3b(128,102,102))   
        self:showGems(0)
        self:showInfoForGems()
    end
end

function equipcomposeLayer:showInfoForItems(  )
    -- body
    local block = self:getChildByName("info"):getChildByName("item")
    if self._index == 0 or self._items[self._index] == nil then
        block:getChildByName("block"):loadTexture(dd.getPathFromUI("white01on.png",1))
        block:getChildByName("block2"):loadTexture(dd.getPathFromUI("white01on.png",1))
        block:getChildByName("block"):getChildByName("ico"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        block:getChildByName("block2"):getChildByName("ico"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        block:getChildByName("count2"):getChildByName("count"):setString("")
        block:getChildByName("count"):getChildByName("count"):setString("")
        self:getChildByName("info"):getChildByName("num"):loadTexture(dd.getPathFromUI("e_number0.png",1))
    else
        block:getChildByName("block"):getChildByName("ico"):loadTexture(dd.getToolsIcon(self._items[self._index]["id"]),0)
        block:getChildByName("count"):getChildByName("count"):setString(dd.getToolsCount(self._items[self._index]["id"]))
        if self._items[self._index]["tool"] ~= 0 then
            block:getChildByName("block2"):getChildByName("ico"):loadTexture(dd.getToolsIcon(self._items[self._index]["tool"]),0)
            block:getChildByName("count2"):getChildByName("count"):setString(dd.getToolsCount(self._items[self._index]["tool"]))
            local color = dd.cfgProp[self._items[self._index]["tool"]]['color'] 
            if color == 1 then
                block:getChildByName("block"):loadTexture(dd.getPathFromUI("white01on.png",1))
                block:getChildByName("block2"):loadTexture(dd.getPathFromUI("white01on.png",1))
            elseif color ==2 then
                block:getChildByName("block"):loadTexture(dd.getPathFromUI("white01on.png",1))
                block:getChildByName("block2"):loadTexture(dd.getPathFromUI("green01on.png",1))
            elseif color == 3 then
                block:getChildByName("block"):loadTexture(dd.getPathFromUI("green01on.png",1))
                block:getChildByName("block2"):loadTexture(dd.getPathFromUI("blue01on.png",1))
            elseif color == 4 then
                block:getChildByName("block"):loadTexture(dd.getPathFromUI("blue01on.png",1))
                block:getChildByName("block2"):loadTexture(dd.getPathFromUI("purple01on.png",1))
            elseif color == 5 then
                block:getChildByName("block"):loadTexture(dd.getPathFromUI("purple01on.png",1))
                block:getChildByName("block2"):loadTexture(dd.getPathFromUI("orange01on.png",1))
            end
            
        else
            block:getChildByName("block"):loadTexture(dd.getPathFromUI("orange01on.png",1))
            block:getChildByName("block2"):loadTexture(dd.getPathFromUI("white01on.png",1))
            block:getChildByName("count2"):getChildByName("count"):setString("")
            block:getChildByName("block2"):getChildByName("ico"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        end
        if 5 <= self._items[self._index]["count"]  then
            self:getChildByName("info"):getChildByName("num"):loadTexture(dd.getPathFromUI("e_number5.png",1))
        else
           local string = "e_number"..tostring(self._items[self._index]["count"])..".png"
           self:getChildByName("info"):getChildByName("num"):loadTexture(dd.getPathFromUI(string,1))
        end
    end
end

function equipcomposeLayer:showInfoForGems(  )
    -- body
    local block = self:getChildByName("info"):getChildByName("gem")
    if self._index == 0 and self._index <= table.getn(self._gems) then
        block:getChildByName("block"):getChildByName("ico"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        block:getChildByName("block1"):getChildByName("ico1"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        self:getChildByName("info"):getChildByName("num"):loadTexture(dd.getPathFromUI("e_number0.png",1))
        block:getChildByName("count1"):getChildByName("count"):setString("")
        block:getChildByName("count"):getChildByName("count"):setString("")
    else
        block:getChildByName("block1"):getChildByName("ico1"):loadTexture(dd.getToolsIcon(self._gems[self._index]["id"]),0)
        block:getChildByName("count1"):getChildByName("count"):setString(ff.langString("LV.")..self._gems[self._index]["level"].."  "..dd.getToolsCount(self._gems[self._index]["id"]))
        if self._gems[self._index]["tool"] ~= 0 then
            block:getChildByName("block"):getChildByName("ico"):loadTexture(dd.getToolsIcon(self._gems[self._index]["tool"]),0)
            block:getChildByName("count"):getChildByName("count"):setString(ff.langString("LV.")..(self._gems[self._index]["level"]+1).."  "..dd.getToolsCount(self._gems[self._index]["tool"]))
        else
            block:getChildByName("block"):getChildByName("ico"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
            block:getChildByName("count"):getChildByName("count"):setString("")
        end
        if 5 <= self._gems[self._index]["count"]  then
            self:getChildByName("info"):getChildByName("num"):loadTexture(dd.getPathFromUI("e_number5.png",1))
        else
           local string = "e_number"..tostring(self._gems[self._index]["count"])..".png"
           self:getChildByName("info"):getChildByName("num"):loadTexture(dd.getPathFromUI(string,1))
        end

        
    end
end

function equipcomposeLayer.selectGem(sender,eventType)
    -- body
    local doaction = false
    local state    = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
            if sender:getSelectedState() == true then
                sender:setSelectedState(false)
                state = false
            else
                sender:setSelectedState(true)
                state = true
            end
        end
    end
    if eventType == ccui.TouchEventType.ended then
        if sender:getSelectedState() == true then
            state = false
        else
            state = true
        end    
        doaction = true
    end
    if doaction == true then
        local widget = pop.getDialog("equipcompose")
        if widget ~= nil then
            local line = widget:getChildByName("main"):getChildrenCount() - 1
            for i=1,line do
                local item = widget:getChildByName("main"):getChildByTag(i)
                if item ~= nil then
                    for j=1,4 do
                        if item:getChildByName("block"..j):getChildByName("checkbox") ~= sender then
                            item:getChildByName("block"..j):getChildByName("checkbox"):setSelectedState(false)
                        end
                    end
                end
            end
            if state == false then
               
                widget._index = 0
            else
                widget._index = sender:getTag()
            end
            widget:showGemsInfo()  
            widget:showInfoForGems()          
        end
    end

end

function equipcomposeLayer.selectItem(sender,eventType)
    -- body
    local doaction = false
    local state    = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
            if sender:getSelectedState() == true then
                sender:setSelectedState(false)
                state = false
            else
                sender:setSelectedState(true)
                state = true
            end
        end
    end
    if eventType == ccui.TouchEventType.ended then
        if sender:getSelectedState() == true then
            state = false
        else
            state = true
        end    
        doaction = true
    end
    if doaction == true then
        local widget = pop.getDialog("equipcompose")
        if widget ~= nil then
            local line = widget:getChildByName("mainitem"):getChildrenCount() - 1
            for i=1,line do
                local item = widget:getChildByName("mainitem"):getChildByTag(i)
                if item ~= nil then
                    for j=1,4 do
                        if item:getChildByName("block"..j):getChildByName("checkbox") ~= sender then
                            item:getChildByName("block"..j):getChildByName("checkbox"):setSelectedState(false)
                        end
                    end
                end
            end
            if state == false then
              
                widget._index = 0
            else
                widget._index = sender:getTag()
            end
            widget:showItemsInfo()     
            widget:showInfoForItems()      
        end
    end


end

function equipcomposeLayer:onAutoSize( )
	-- body
	local hh = ff.height
	self:setContentSize(cc.size(720,hh))
	self:getChildByName("back"):setContentSize(cc.size(720,hh))
	self:getChildByName("top"):setPositionY(ff.height - 105)
    self:getChildByName("top"):getChildByName("title"):getChildByName("chu_title"):getVirtualRenderer():enableBold(true)
    --self:getChildByName("top"):getChildByName("count"):setString(dd.myinfo:getLong(1,"gold"))
    
    self:getChildByName("top"):getChildByName("title"):getChildByName("chu_title"):setString(ff.langString("融合"))
    self:getChildByName("top"):getChildByName("return"):addTouchEventListener(self.onReturn)
    self:getChildByName("top"):getChildByName("addgold"):addTouchEventListener(dd.onPay)

    self:getChildByName("topNavi"):setPositionY(ff.height - 105 -85)
    self:getChildByName("info"):setPositionY(ff.height - 105 -85-244)
    --self:getChildByName("operate"):setPositionY(ff.height - 105 -85 - 244 - 103)
    self:getChildByName("pro"):setPositionY(ff.height - 105 -85 - 244  - 55)

    self:getChildByName("main"):setContentSize(cc.size(700,ff.height - 105 -85 - 244  - 60))
    self:getChildByName("main"):setInnerContainerSize(cc.size(700,ff.height - 105 -85 - 244  - 60))
    self:getChildByName("main"):setPositionY(0)
    self:getChildByName("main"):setPositionX(10)

    self:getChildByName("mainitem"):setContentSize(cc.size(700,ff.height - 105 -85 - 244  - 60))
    self:getChildByName("mainitem"):setInnerContainerSize(cc.size(700,ff.height - 105 -85 - 244  - 60))
    self:getChildByName("mainitem"):setPositionY(0)
    self:getChildByName("mainitem"):setPositionX(10)

    self:getChildByName("topNavi"):getChildByName("navi1"):setTag(1)
    self:getChildByName("topNavi"):getChildByName("navi2"):setTag(2)

    self:getChildByName("topNavi"):getChildByName("navi1"):addTouchEventListener(self.selectType)
    self:getChildByName("topNavi"):getChildByName("navi2"):addTouchEventListener(self.selectType)

    self:getChildByName('main'):getChildByName("tips"):getChildByName("info"):getChildByName("ok"):addTouchEventListener(self.okEvent)
    self:getChildByName('mainitem'):getChildByName("tips"):getChildByName("info"):getChildByName("ok"):addTouchEventListener(self.okEvent)

    --self:getChildByName("operate"):getChildByName("button"):getChildByName("ok"):addTouchEventListener(self.okEvent)
end

function equipcomposeLayer.okEvent( sender,eventType )
    -- body
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("equipcompose")
        if widget ~= nil and widget._index ~= 0  then
            if widget._type == 1 then
                if widget._items[widget._index]["tool"] == 0 then
                    dd.currentLayer._widget:onShowTips("\t"..ff.langString("该物品不可融合"))
                    return
                end
                if 5 > widget._items[widget._index]["count"]  then
                    dd.currentLayer._widget:onShowTips("\t"..ff.langString("材料不足！"))
                    return
                end
                if dd.silver() < widget._items[widget._index]["money"] then
                    dd.currentLayer._widget:onShowTips("\t"..ff.langString("银币不足！"))
                    return
                end
            else
                if widget._gems[widget._index]["tool"] == 0 then
                    dd.currentLayer._widget:onShowTips("\t"..ff.langString("该物品不可融合"))
                    return
                end
                if 5 > widget._gems[widget._index]["count"]  then
                    dd.currentLayer._widget:onShowTips("\t"..ff.langString("材料不足！"))
                    return
                end
                if dd.silver() < widget._gems[widget._index]["money"] then
                    dd.currentLayer._widget:onShowTips("\t"..ff.langString("银币不足！"))
                    return
                end
            end
            local message = ff.net:createMessage()
            message:addCmd(0x0000011e)
            message:addLong(dd.uid)
            if widget._type == 1 then
                message:addLong(widget._items[widget._index]["tool"])
            else
                message:addLong(widget._gems[widget._index]["tool"])
            end
        
            ff.net:rpc(message, false)
        end
    end
end

function equipcomposeLayer.onEnd( sender )
    -- body
    local line = sender:getChildByName("mainitem"):getChildrenCount() - 1
    for i=1,line do
        local item = sender:getChildByName("mainitem"):getChildByTag(i)
        if item ~= nil then
            item:removeFromParent()
        end
    end
    if ff.platform ~= 1 then
        sender:getChildByName("info"):getChildByName("Image_132"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        sender:getChildByName("info"):getChildByName("item"):getChildByName("block"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        sender:getChildByName("info"):getChildByName("item"):getChildByName("block2"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        sender:getChildByName("info"):getChildByName("item"):getChildByName("block"):getChildByName("ico"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        sender:getChildByName("info"):getChildByName("item"):getChildByName("block2"):getChildByName("ico"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        sender:getChildByName("info"):getChildByName("gem"):getChildByName("block"):getChildByName("ico"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        sender:getChildByName("info"):getChildByName("gem"):getChildByName("block1"):getChildByName("ico1"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        sender:getChildByName("info"):getChildByName("num"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
    end
    sender.cancelTips(sender:getChildByName("gemslist"),ccui.TouchEventType.canceled)
    sender.cancelItemTips(sender:getChildByName("itemslist"),ccui.TouchEventType.canceled)
    ff.net:removeEvent(2,dd.Tjf_gem_compose)
    dd.delBackEvent()
    ff.net:unbindProperty("gold",2306)
end

function equipcomposeLayer.onStart(sender)
   
    sender:onGetGemsInfo()
    ff.net:registerEvent(2,dd.Tjf_gem_compose,function (message)sender:onGemsCompose(message)end)
    ff.net:bindProperty(2306,"gold",sender.updateGold)
    dd.initGoldSpine(sender:getChildByName("top"):getChildByName("gold"),sender:getChildByName("top"):getChildByName("addgold"))
end

function equipcomposeLayer.updateGold(name,row,old,value)
    local sender = pop.getDialog("equipcompose")
    if sender ~= nil then
        sender:getChildByName("top"):getChildByName("count"):setString(dd.myinfo:getLong(1,"gold"))
        local w = sender:getChildByName("top"):getChildByName("count"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        sender:getChildByName("top"):getChildByName("title"):setContentSize(cc.size(w,100))
        sender:getChildByName("top"):getChildByName("title"):requestDoLayout()
        sender:getChildByName("top"):requestDoLayout()
    end
end

function equipcomposeLayer:onGetGemsInfo()
    self._gems={}
    self._items={}
    for var=1, dd.mytools:rowCount() do
        local id = dd.mytools:getLong(var,'tid')
        local count = dd.mytools:getLong(var,'count')
        if tonumber(dd.cfgProp[id]['type']) == 8 then
            local index = table.getn(self._gems) + 1
            self._gems[index] = {}
            self._gems[index]["id"] = id-- :setLong(index,"id",id)
            self._gems[index]["count"] =count
            self._gems[index]["color"]=tonumber(dd.cfgProp[id]['color'])
            if self._compcfg[id] ~= nil then
                self._gems[index]["tool"]=tonumber(self._compcfg[id]['tool'])
                self._gems[index]["money"]=tonumber(self._compcfg[id]['money'])
                self._gems[index]["type"]=tonumber(self._compcfg[id]['type'])
            else
                self._gems[index]["tool"]=0
                self._gems[index]["money"]=0
                self._gems[index]["type"]=0
            end
            self._gems[index]["level"]=tonumber(dd.cfgGems[id]['level'])
            
        elseif tonumber(dd.cfgProp[id]['type']) > 100 and tonumber(dd.cfgProp[id]['type']) < 200 then
            local key = table.getn(self._items) + 1
            self._items[key] = {}
            self._items[key]["id"] = id
            self._items[key]["count"] = count
            self._items[key]["color"]=tonumber(dd.cfgProp[id]['color'])
            if self._compcfg[id] ~= nil then
                self._items[key]["tool"]=tonumber(self._compcfg[id]['tool'])
                self._items[key]["money"]=tonumber(self._compcfg[id]['money'])
                self._items[key]["type"]=tonumber(self._compcfg[id]['type'])
            else
                self._items[key]["tool"]=0
                self._items[key]["money"]=0
                self._items[key]["type"]=0
            end
           
        end
    end
    table.sort(self._items, self.sortFun)
    table.sort(self._gems, self.sortFun1)
    if self._type == 1 then
        if table.getn(self._items) < self._index then
            self.cancelTips(self:getChildByName("gemslist"),ccui.TouchEventType.canceled)
            self.cancelItemTips(self:getChildByName("itemslist"),ccui.TouchEventType.canceled)
            self._index = 0
        end
    else
        if table.getn(self._gems) < self._index then
            self.cancelTips(self:getChildByName("gemslist"),ccui.TouchEventType.canceled)
            self.cancelItemTips(self:getChildByName("itemslist"),ccui.TouchEventType.canceled)
            self._index = 0
        end
    end
    self:switchmenu()
    
end

function equipcomposeLayer.sortFun( d1, d2 )
    -- body
    if (d1["id"] == d2["id"]) then
        return (d1["color"] < d2["color"])
    else
        return (d1["id"] < d2["id"])
    end
end 

function equipcomposeLayer.sortFun1( d1, d2 )
    -- body
    if (d1["id"] == d2["id"]) then
        return (d1["level"] < d2["level"])
    else
        return (d1["id"] < d2["id"])
    end
end 

function equipcomposeLayer:onGemsCompose(params)
    local code = params[1]
    if code == 0 then
        local sprite = sp.SkeletonAnimation:create("images/equipsp/ronghe.json", "images/equipsp/ronghe.atlas")
        sprite:setAnchorPoint(cc.p(0.5,0.5))
        sprite:setPosition(cc.p(83,148))
        sprite:setAnimation(0, "CLRH_animation", false)
        local sp1 = self:getChildByName("info"):getChildByName("sp"):getChildByTag(1)
        if sp1 == nil then
            AudioEngine.playEffect(ff.sounds[602])
            self:getChildByName("info"):getChildByName("sp"):addChild(sprite, 5,1)
        end
        local item = nil
        if self._type == 1 then
            item = self:getChildByName("info"):getChildByName("item"):getChildByName("block"):getChildByName("ico"):clone()
            item:setPosition(self:getChildByName("info"):getChildByName("item"):getChildByName("block"):getPosition())
            self:getChildByName("info"):addChild(item,3)
            item:setVisible(true)
        else
            item = self:getChildByName("info"):getChildByName("gem"):getChildByName("block1"):getChildByName("ico1"):clone()
            item:setPosition(self:getChildByName("info"):getChildByName("gem"):getChildByName("block1"):getPosition())
            self:getChildByName("info"):addChild(item,3)
            item:setVisible(true)
        end
        local sequence = cc.Sequence:create(cc.MoveBy:create(0.3,cc.p(467,0)), cc.CallFunc:create(function () item:removeFromParent()end))
        item:runAction(sequence)
        local function remove( sender )
            -- body
            sender:removeFromParent()
        end 
        performWithDelay(sprite, remove, 0.5)

        self:onGetGemsInfo()

    else
        dd.mainUI:onShowCodeTips(code)
    end
end

function equipcomposeLayer.onBefore( sender )
    -- body
    local level = dd.myinfo:getLong(1,"level")
    local hh = ff.height
   
        sender:getChildByName("topNavi"):setPositionY(ff.height - 105 -85)
        sender:getChildByName("info"):setPositionY(ff.height - 105 -85-244)
    
        sender:getChildByName("pro"):setPositionY(ff.height - 105 -85 - 244  - 55)
        sender:getChildByName("main"):setContentSize(cc.size(700,ff.height - 105 -85 - 244  - 60))
        sender:getChildByName("main"):setInnerContainerSize(cc.size(700,ff.height - 105 -85 - 244  - 60))
        sender:getChildByName("mainitem"):setPositionY(0)
        sender:getChildByName("mainitem"):setPositionX(10)
        sender:getChildByName("mainitem"):setContentSize(cc.size(700,ff.height - 105 -85 - 244  - 60))
        sender:getChildByName("mainitem"):setInnerContainerSize(cc.size(700,ff.height - 105 -85 - 244  - 60))
        sender:getChildByName("mainitem"):setPositionY(0)
        sender:getChildByName("mainitem"):setPositionX(10)
    --end
end