--select hero
local selectHeroLayer = class("selectHero")
selectHeroLayer._name = "selectHero"
selectHeroLayer._init = false
selectHeroLayer._type = 2                  --防御 2    内政 4
selectHeroLayer._lastAct = 0               --0 卸任    1.任命   

function selectHeroLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, selectHeroLayer)
    return target
end

function selectHeroLayer:onAutoSize()
    if self._init == false then 
        local hh = ff.height
        self:setContentSize(cc.size(720,hh))
        self:getChildByName("back"):setContentSize(cc.size(720,hh-105))
        self:getChildByName("back"):setPositionY(0)

        self:getChildByName("topArea"):setPositionY(hh - 105)
        self:getChildByName("top"):setPositionY(hh - 105-440)
        self:getChildByName("lists"):setContentSize(cc.size(720,hh-105-10-440))
    end
end

function selectHeroLayer:onInit()
    if self._init == false then     
        --任命   
        local function onSelectHero(sender, eventType)
            local doaction = false
            if eventType == ccui.TouchEventType.canceled then
                local startp = sender:getTouchBeganPosition()
                local endp   = sender:getTouchEndPosition()
                if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                    doaction = true
                end
            end

            if eventType==ccui.TouchEventType.ended then    
                doaction = true
            end
            if doaction == true then
                local message = ff.net:createMessage()
                message:addCmd(0x0000015d)
                message:addLong(dd.uid)
                message:addLong(sender:getTag())
                for i=1,dd.heros:rowCount() do
                    if dd.heros:getLong(i,"type") == self._type then
                        self:setHeroPos(dd.heros:getLong(i,"hid"),0)
                        break
                    end
                end
                message:addLong(self._type)
                ff.net:rpc(message,false)
                self._lastAct = 1 
            end
        end
        --卸任
        local function onOffHero(sender, eventType)
            local doaction = false
            if eventType == ccui.TouchEventType.canceled then
                local startp = sender:getTouchBeganPosition()
                local endp   = sender:getTouchEndPosition()
                if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                    doaction = true
                end
            end

            if eventType==ccui.TouchEventType.ended then    
                doaction = true
            end
            if doaction == true then
                self._lastAct = 0 
                self:setHeroPos(sender:getTag(),0)
            end
        end
        self:getChildByName("topArea"):getChildByName("title"):getChildByName("chu_title"):getVirtualRenderer():enableOutline(cc.c4b(0,0,0,255),3) 
        self:getChildByName("topArea"):getChildByName("backbtn"):addTouchEventListener(self.onBack)
        self:getChildByName("topArea"):getChildByName("addbtn"):addTouchEventListener(dd.onPay)
        self:getChildByName("item"):getChildByName("pickbtn"):addTouchEventListener(onSelectHero)
        self:getChildByName("item"):getChildByName("giveupbtn"):addTouchEventListener(onOffHero)
        self._init = true
    end
    self.updateGold()
    self:getChildByName("top"):getChildByName("ico"):getChildByName("ico"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
    if self._type == 2 then
        self:getChildByName("top"):getChildByName("Image_119"):loadTexture("images/icon/task/gold/1900004.jpg",0)
        self:getChildByName("top"):getChildByName("heroname"):setString(ff.langString("警长将指挥士兵参加守城战斗，设置警长后，守城部队获得10%HP加成。当佩戴警长专属装备后，激活装备效果。使守城部队更强。"))
        
        for i=1,dd.heros:rowCount() do
            if self._type == dd.heros:getLong(i,"type") then
                self:getChildByName("top"):getChildByName("ico"):getChildByName("ico"):loadTexture(dd.getHeroIcon(dd.heros:getLong(i,"id")),0)
                break
            end
        end
    elseif self._type == 4 then
        self:getChildByName("top"):getChildByName("Image_119"):loadTexture("images/icon/task/gold/1900005.jpg",0)
        self:getChildByName("top"):getChildByName("heroname"):setString(ff.langString("工程师可以为建筑提供增益效果，设置工程师后，立即获得5%建筑升级加速效果。当佩戴工程师专属装备后，激活装备效果，使建筑效果更强。"))
        for i=1,dd.heros:rowCount() do
            if self._type == dd.heros:getLong(i,"type") then
                self:getChildByName("top"):getChildByName("ico"):getChildByName("ico"):loadTexture(dd.getHeroIcon(dd.heros:getLong(i,"id")),0)
                break
            end
        end
    end
end

function selectHeroLayer:updateList()
    local hh = self:getChildByName("lists"):getContentSize().height
    local num = dd.heros:rowCount()
    local ihh = 0
    ihh = num * 130
    if ihh < hh then
        ihh = hh
    end
    self:getChildByName("lists"):setInnerContainerSize(720, ihh)
    
    for i, item in ipairs(self:getChildByName("lists"):getChildren()) do
        item:setVisible(false)
    end
    for i=1,dd.heros:rowCount() do
        local off = dd.heros:getLong(i,"type")
        self:addItemWithRow(i, off,ihh)
    end
end

function selectHeroLayer:addItemWithRow(i, off, ihh)
    local id= dd.heros:getLong(i,"id")
    local star = dd.cfgHero[id]["star"]
    local type = dd.cfgHero[id]["type"]
    local level = dd.heros:getLong(i,"level")
    local name = ""
    if dd.heros:getString(i,"name") == "" then
        name = ff.langString(dd.cfgHero[id]['name'])
    else
        name = dd.heros:getString(i,"name")
    end
    local item = self:getChildByName("lists"):getChildByTag(i)
    if item == nil then
        item = self:getChildByName("item"):clone()
        item:setTag(i)
        self:getChildByName("lists"):addChild(item)
    end  
    item:setVisible(true)
    item:setPositionX(0)
    item:setPositionY(ihh - i*130)
    item:getChildByName("name"):setString(name.." LV."..level)
    item:getChildByName("power"):setString(ff.getFormatMoney(dd.heros:getLong(i,"power")))
    item:getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getHeroIcon(id),0)
    item:getChildByName("icon"):getChildByName("icon2"):loadTexture("images/icon/hero/type/"..type..".png", 0)
    if off == 0 then
        item:getChildByName("pickbtn"):setVisible(true)
        item:getChildByName("giveupbtn"):setVisible(false)
        self:setBtnLight(item:getChildByName("pickbtn"), true)
    elseif off == self._type then
        item:getChildByName("pickbtn"):setVisible(false)
        item:getChildByName("giveupbtn"):setVisible(true)
        self:setBtnLight(item:getChildByName("pickbtn"), false)
    else
        item:getChildByName("pickbtn"):setVisible(true)
        item:getChildByName("giveupbtn"):setVisible(false)
        self:setBtnLight(item:getChildByName("pickbtn"), false)
    end
    item:getChildByName("pickbtn"):setTag(dd.heros:getLong(i,"hid"))
    item:getChildByName("giveupbtn"):setTag(dd.heros:getLong(i,"hid"))
end

function selectHeroLayer.updateGold()
    local widget = pop.getDialog("selectHero")
    widget:getChildByName("topArea"):getChildByName("money"):setString(dd.gold())
    widget:getChildByName("topArea"):requestDoLayout()
    
    local w = widget:getChildByName("topArea"):getChildByName("money"):getContentSize().width
    w = 720 - (w + 94 + 75 + 104)
    widget:getChildByName("topArea"):getChildByName("title"):setContentSize(cc.size(w,100))
    widget:getChildByName("topArea"):getChildByName("title"):requestDoLayout()
end

function selectHeroLayer:setHeroPos(hid, type)
    local message = ff.net:createMessage()
    message:addCmd(0x0000015d)
    message:addLong(dd.uid)
    message:addLong(hid)
    message:addLong(0)
    ff.net:rpc(message,false)   
end

function selectHeroLayer:onSetHeroPosition(params)
    local code = params[1]
    if code == 0 then
        pop.onClosePopDialog("selectHero")
        if self._lastAct == 0 then
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("卸任成功"),true)
        elseif self._lastAct == 1 then
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("任命成功"),true)
        end
    else
        dd.mainUI:onShowCodeTips(code)
    end
end

function selectHeroLayer:setBtnLight(node, light)
    if light == true then
        node:getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
        node:setTouchEnabled(true)
        node:getChildByName("chu_label"):setColor(cc.c3b(255,255,255))
    else 
        local effect = ff.Effect:effectGrey()    
        node:getVirtualRenderer():setGLProgramState(effect:getGLProgramState())
        node:setTouchEnabled(false)
        node:getChildByName("chu_label"):setColor(cc.c3b(116,123,125))
    end
end

--接口
function selectHeroLayer.onBack(sender,eventType)
    if eventType==ccui.TouchEventType.ended then     
        pop.onClosePopDialog("selectHero")
    end
end


function selectHeroLayer.onStart(sender)
    ff.net:bindProperty(2513,"gold",sender.updateGold)
    ff.net:registerEvent(5,dd.Tjf_hero_office, function (message)sender:onSetHeroPosition(message)end)
    sender:updateList()
end
function selectHeroLayer.onBefore(sender)
    dd.initGoldSpine(sender:getChildByName("topArea"):getChildByName("gold"),sender:getChildByName("topArea"):getChildByName("addbtn"))
    return true
end
function selectHeroLayer.onEnd(sender)
    dd.delBackEvent()
    ff.net:removeEvent(5,dd.Tjf_hero_office)
    ff.net:unbindProperty("gold",2513)
    if ff.platform ~= 1 then
        for i, item in ipairs(sender:getChildByName("lists"):getChildren()) do
            item:getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
            item:getChildByName("icon"):getChildByName("icon2"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        end
    end
end

function selectHeroLayer.onReturn(sender, eventType)
    pop.onClosePopDialog("selectHero")
end

function onShowSelectHeroLayer(widget, type)
    local layer = selectHeroLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)
    layer._type = type
    layer:onAutoSize()
    layer:onInit()
    return layer
end