--arms
local armsLayer = class("arms")
armsLayer._name = "arms"
armsLayer._init = false

armsLayer._arms = {}
armsLayer._aitems = {}
armsLayer._callback = nil
armsLayer._oldArmRow = 0

function armsLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, armsLayer)
    return target
end

function armsLayer:onAutoSize()
    if self._init == false then 
        local hh = ff.height
        self:setContentSize(cc.size(720,hh))
        self:getChildByName("masking"):setContentSize(cc.size(720,hh + 700))
    end
end

function armsLayer:onInit()
    if self._init == false then        
        self:getChildByName("show"):getChildByName("close"):addTouchEventListener(self.onBack)
        
        --选中装备
        local function onArmCheck(sender, eventType)
            local doaction = false
            if eventType == ccui.TouchEventType.canceled then
                local startp = sender:getTouchBeganPosition()
                local endp   = sender:getTouchEndPosition()
                if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                    sender:setSelectedState(true)
                    if self._oldArmRow ~= sender:getTag() then
                        self:updateArms(sender:getTag(),sender.acount)
                        local item = self:getChildByName("show"):getChildByName("arms"):getChildByName("armslist"):getChildByTag(self._oldArmRow)
                        if item ~= nil then
                            item:getChildByName("check"):setSelectedState(true)
                        end
                    else
                        self:updateArms(0,0)
                        sender:setSelectedState(true)
                    end
                    doaction = true
                end
            end

            if eventType==ccui.TouchEventType.ended then 
                if self._oldArmRow ~= sender:getTag() then
                    self:updateArms(sender:getTag(),sender.acount)
                else
                    self:updateArms(0,0)
                    --设置选中状态 底层才会设置成相反的
                    sender:setSelectedState(true)
                end
                doaction = true
            end
            if doaction == true then
            end
        end
        --确定
        local function onConfirm(sender, eventType)
            local doaction = false
            if eventType == ccui.TouchEventType.canceled then
                local startp = sender:getTouchBeganPosition()
                local endp   = sender:getTouchEndPosition()
                if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                    doaction = true
                end
            end

            if eventType==ccui.TouchEventType.ended then 
                doaction = true
            end
            if doaction == true then
                if self._callback ~= nil then
                    self._callback(dd.myArms:getLong(self._oldArmRow,"tid"))
                end
                pop.onClosePopDialog("arms")
            end
        end

        self:getChildByName("show"):getChildByName("arms"):getChildByName("aitem"):getChildByName("check"):addTouchEventListener(onArmCheck) 
        self:getChildByName("show"):getChildByName("arms"):getChildByName("armslist"):getChildByName("tips"):getChildByName("equipbtn"):addTouchEventListener(onConfirm) 
        self._init = true
    end
end

function armsLayer:updateArms(armrow, acount)
    local count = 1
    local nums = table.getn(self._arms)
    local hh = self:getChildByName("show"):getChildByName("arms"):getChildByName("armslist"):getContentSize().height
    local ihh = 0
    local addhh = 0
    local addline = 1000
    self._oldArmRow = armrow
    --隐藏
    self:getChildByName("show"):getChildByName("arms"):getChildByName("armslist"):getChildByName("tips"):setVisible(false)
    for i,v in ipairs(self._aitems) do
        if tolua.isnull(v) then
            self._aitems[i] = nil
        else
            v:setVisible(false)
            v:setTag(i)
            v:getChildByName("check"):setSelectedState(false)
            v:getChildByName("check"):setTouchEnabled(true)
        end
    end
    
    --补足3行
    if nums < 15 then    
        nums = 15
    end
    if armrow > 0 then
        --显示tips 最后设置位置
        addhh   = self:showArmTips(armrow,acount)    
        addline = math.floor((acount-1)/5)
    end
    ihh = 147* math.ceil(nums/5) + addhh
    if ihh < hh then
        ihh = hh
    end
    self:getChildByName("show"):getChildByName("arms"):getChildByName("armslist"):setInnerContainerSize(cc.size(720,ihh))
    for k=1, table.getn(self._arms) do
        local i = self:getArmRow(self._arms[k])
        local tid = dd.myArms:getLong(i,"aid")
        local item = self._aitems[count]
        if item == nil then
            item = self:getChildByName("show"):getChildByName("arms"):getChildByName("aitem"):clone()
            self._aitems[count] = item
            self:getChildByName("show"):getChildByName("arms"):getChildByName("armslist"):addChild(item)
        end
        item:setVisible(true)
        item:getChildByName("icon"):loadTexture(dd.getArmIcon(tid),0)
        item:getChildByName("bg"):loadTexture(dd.getPathFromUI("arms_boxs_"..dd.cfgArms[tid]['color']..".png",1))
        item:getChildByName("check"):loadTextureBackGroundSelected(
            dd.getPathFromUI("arms_onboxs_"..dd.cfgArms[tid]['color']..".png",1))
        item:getChildByName("check"):loadTextureFrontCross(
            dd.getPathFromUI("arms_onboxs_"..dd.cfgArms[tid]['color']..".png",1))
        item:getChildByName("word_e"):setVisible(false)
        --计算tips空间
        if math.floor((count-1)/5) > addline then
            item:setPositionX(13 + ((count-1)%5)*140 )
            item:setPositionY(ihh - addhh - 147 - math.floor((count-1)/5)*147 )
        else
            item:setPositionX(13 + ((count-1)%5)*140 )
            item:setPositionY(ihh - 147 - math.floor((count-1)/5)*147 )
        end

        item:setTag(i)
        item:getChildByName("check"):setTag(i)
        item:getChildByName("check").acount = count

        for j=1,dd.cfgArms[tid]['hole'] do
            item:getChildByName("gem"..j):setVisible(true)    
            item:getChildByName("gem"..j):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))            
        end            
        for j=dd.cfgArms[tid]['hole']+1,4 do
            item:getChildByName("gem"..j):setVisible(false) 
        end

        for j=1,3 do
            local gid = dd.myArms:getLong(i,"gem"..j)    --好像cfgid 也是这个
            if gid > 0 then
                local color = dd.cfgGems[gid]['color']
                item:getChildByName("gem"..j):getChildByName("icon"):loadTexture(dd.getToolsIcon(gid), 0)
            else
                item:getChildByName("gem"..j):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
            end                    
        end
        count = count + 1
    end
    --不够3排补足
    for i=count, nums do
        local item = self._aitems[i]
        if item == nil then
            item = self:getChildByName("show"):getChildByName("arms"):getChildByName("aitem"):clone()
            self._aitems[i] = item
            self:getChildByName("show"):getChildByName("arms"):getChildByName("armslist"):addChild(item)
        end
        if math.floor((count-1)/5) > addline then
            item:setPositionX(13 + ((count-1)%5)*140 )
            item:setPositionY(ihh - addhh - 147 - math.floor((count-1)/5)*147 )
        else
            item:setPositionX(13 + ((count-1)%5)*140 )
            item:setPositionY(ihh - 147 - math.floor((count-1)/5)*147 )
        end
        item:getChildByName("check"):setTouchEnabled(false)
        item:getChildByName("word_e"):setVisible(false)
        item:getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        item:getChildByName("bg"):loadTexture(dd.getPathFromUI("arms_boxs_1.png",1))
        item:getChildByName("gem1"):setVisible(false) 
        item:getChildByName("gem2"):setVisible(false) 
        item:getChildByName("gem3"):setVisible(false) 
        item:getChildByName("gem4"):setVisible(false) 
        item:setVisible(true)
        count = count + 1
    end
    if armrow > 0 then
        --设置tips位置
        local tips = self:getChildByName("show"):getChildByName("arms"):getChildByName("armslist"):getChildByName("tips")
        tips:setPositionY(ihh - addhh - 147 - addline*147)
        if tips:isVisible() == true then
            local fixy = self:getChildByName("show"):getChildByName("arms"):getChildByName("armslist"):getInnerContainer():getPositionY() + tips:getPositionY()
            if fixy < 0 then
                self:getChildByName("show"):getChildByName("arms"):getChildByName("armslist"):getInnerContainer():runAction(cc.MoveBy:create(0.3,cc.p(0,-fixy)))
            end
        end
    end
end
function armsLayer:showArmTips(row,count)
    local tid   = dd.myArms:getLong(row,"aid")   --cfgid
    local col   = dd.cfgArms[tid]["color"] 
    local name  = ff.langString(dd.cfgArms[tid]['name']) 

    self:getChildByName("show"):getChildByName("arms"):getChildByName("armslist"):getChildByName("tips"):getChildByName("tips"):removeAllChildren(true)
    self:getChildByName("show"):getChildByName("arms"):getChildByName("armslist"):getChildByName("tips"):setVisible(true)
    --左边
    local richText1 = ccui.RichText:create()
    richText1:ignoreContentAdaptWithSize(false)
    richText1:setContentSize(cc.size(310,600)) 
    richText1:setAutoHeight()

    --name
    if dd.myArms:getLong(row,"heroid") > 0 then
        for i=1,dd.heros:rowCount() do
            if dd.myArms:getLong(row,"heroid") == dd.heros:getLong(i,"hid") then
                if dd.heros:getString(row,"name") == "" then
                    name = name.."("..ff.langString(dd.cfgHero[dd.heros:getLong(i,"id")]['name'])..")"
                else
                    name = name.."("..dd.heros:getString(row,"name")..")"
                end
                break
            end
        end
    end

    self:getChildByName("show"):getChildByName("arms"):getChildByName("armslist"):getChildByName("tips"):getChildByName("name"):setString(name)
    --装备效果
    local count1 = 0

    local chatlv = ccui.RichElementText:create(1, cc.c3b(161, 175, 175), 255, "\n".."LV."..dd.cfgArms[tid]['level'], "Helvetica", 20)
    richText1:insertElement(chatlv,count1)
    count1 = count1 + 1

    for i=1,3 do
        local param = dd.cfgArms[tid]["param"..i]
        if param > 0 then
            local value = dd.cfgArms[tid]['value'..i]
            if dd.cfgEffect[param]['value'] > 0 then
                value = value/dd.cfgEffect[param]['value']
            end
            local chat1 = ccui.RichElementText:create(1, cc.c3b(161, 175, 175), 255, "\n"..ff.langString(dd.cfgEffect[param]['name']), "Helvetica", 20)
            richText1:insertElement(chat1,count1)
            --cclog(ff.langString(dd.cfgEffect[param]['name']))
            count1 = count1 + 1
            if tonumber(dd.cfgEffect[param]['tips2']) ~= 0 then
                local valuestr = "+"..value..ff.langString(dd.cfgEffect[param]['tips2'])
                local chat2 = ccui.RichElementText:create(1, cc.c3b(7, 159, 0), 255, " "..valuestr, "Helvetica", 20)
                richText1:insertElement(chat2,count1)
            else
                local valuestr = "+"..value
                local chat2 = ccui.RichElementText:create(1, cc.c3b(7, 159, 0), 255, " "..valuestr, "Helvetica", 20)
                richText1:insertElement(chat2,count1)
            end
            count1 = count1 + 1
        end
    end
    richText1:formatText()

    --右边
    local richText2 = ccui.RichText:create()
    richText2:ignoreContentAdaptWithSize(false)
    richText2:setContentSize(cc.size(310,600)) 
    richText2:setAutoHeight()

    --宝石效果   富文本要从0开始
    local count2 = 0
    for i=1,3 do
        local gid = dd.myArms:getLong(row,"gem"..i)    --好像cfgid 也是这个
        if gid > 0 then
            if dd.cfgGems[gid]['param1'] > 0 then
                local value = dd.cfgGems[gid]['value1']
                local param = dd.cfgGems[gid]['param1']
                if dd.cfgEffect[param]['value'] > 0 then
                    value = value/dd.cfgEffect[param]['value']
                end
                local chat1 = ccui.RichElementText:create(1, cc.c3b(161, 175, 175), 255, "\n"..ff.langString(dd.cfgEffect[param]['name']), "Helvetica", 20)
                richText2:insertElement(chat1,count2)
                count2 = count2 + 1

                if tonumber(dd.cfgEffect[param]['tips2']) ~= 0 then
                    local valuestr = "+"..value..ff.langString(dd.cfgEffect[param]['tips2'])
                    local chat2 = ccui.RichElementText:create(1, cc.c3b(7, 159, 0), 255, " "..valuestr, "Helvetica", 20)
                    richText2:insertElement(chat2,count2)
                else
                    local valuestr = "+"..value
                    local chat2 = ccui.RichElementText:create(1, cc.c3b(7, 159, 0), 255, " "..valuestr, "Helvetica", 20)
                    richText2:insertElement(chat2,count2)
                end
                count2 = count2 + 1
            end
            if dd.cfgGems[gid]['param2'] > 0 then
                local value = dd.cfgGems[gid]['value2']
                local param = dd.cfgGems[gid]['param2']
                if dd.cfgEffect[param]['value'] > 0 then
                    value = value/dd.cfgEffect[param]['value']
                end
                local chat1 = ccui.RichElementText:create(1, cc.c3b(161, 175, 175), 255, "\n"..ff.langString(dd.cfgEffect[param]['name']), "Helvetica", 20)
                richText2:insertElement(chat1,count2)
                count2 = count2 + 1
                if tonumber(dd.cfgEffect[param]['tips2']) ~= 0 then
                    local valuestr = "+"..value..ff.langString(dd.cfgEffect[param]['tips2'])
                    local chat2 = ccui.RichElementText:create(1, cc.c3b(7, 159, 0), 255, " "..valuestr, "Helvetica", 20)
                    richText2:insertElement(chat2,count2)
                else
                    local valuestr = "+"..value
                    local chat2 = ccui.RichElementText:create(1, cc.c3b(7, 159, 0), 255, " "..valuestr, "Helvetica", 20)
                    richText2:insertElement(chat2,count2)
                end
                count2 = count2 + 1
            end                     
        end
    end
    richText2:formatText()
    --计算高度
    local height = 0
    local size1 = richText1:getContentSize()
    local size2 = richText2:getContentSize()
    if size1.height > size2.height then
        height = size1.height
    else
        height = size2.height
    end
    richText1:setPosition(cc.p(163,height - size1.height/2 + 80 -30))
    richText2:setPosition(cc.p(520,height - size2.height/2 + 80 -30))

    self:getChildByName("show"):getChildByName("arms"):getChildByName("armslist"):getChildByName("tips"):setContentSize(cc.size(696, height + 85))
    self:getChildByName("show"):getChildByName("arms"):getChildByName("armslist"):getChildByName("tips"):getChildByName("tips"):setContentSize(cc.size(696, height + 85))
    self:getChildByName("show"):getChildByName("arms"):getChildByName("armslist"):getChildByName("tips"):getChildByName("tips"):addChild(richText1)
    self:getChildByName("show"):getChildByName("arms"):getChildByName("armslist"):getChildByName("tips"):getChildByName("tips"):addChild(richText2)

    self:getChildByName("show"):getChildByName("arms"):getChildByName("armslist"):getChildByName("tips"):getChildByName("name"):setPositionY(height + 85 - 18)
    self:getChildByName("show"):getChildByName("arms"):getChildByName("armslist"):getChildByName("tips"):getChildByName("flag"):setPositionX(71 + ((count-1)%5)*140)
    self:getChildByName("show"):getChildByName("arms"):getChildByName("armslist"):getChildByName("tips"):getChildByName("flag"):setPositionY(height + 85 - 4)

    return height + 85 + 20
end

function armsLayer:getArmRow(id)
    local row = 0
    for i=1,dd.myArms:rowCount() do
        if dd.myArms:getLong(i,"tid") == id then
            row = i
            break
        end
    end
    if row == 0 then
        cclog("数据错误 找不到该装备!!")
    end
    return row
end

--接口
function armsLayer.onBack(sender,eventType)
    if eventType==ccui.TouchEventType.ended then     
        pop.onClosePopDialog("arms")
    end
end

function armsLayer:onClose()

end

function armsLayer.onStart(sender)
    sender._oldArmRow = 0
    sender:updateArms(0, 0)
end

function armsLayer.onEnd(sender)
    dd.delBackEvent()    
    sender:updateArms(0, 0)
    --装备
    if ff.platform ~= 1 then
        for i,item in ipairs(sender._aitems) do
            if item then
                item:getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                item:getChildByName("bg"):loadTexture(dd.getPathFromUI("public/v2/ui_boxs_1.png",1))
                item:getChildByName("check"):loadTextureBackGroundSelected(dd.getPathFromUI("public/alpha.png",1))
                item:getChildByName("check"):loadTextureFrontCross(dd.getPathFromUI("public/alpha.png",1))
                item:getChildByName("word_e"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                for k=1,4 do    
                    item:getChildByName("gem"..k):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))            
                end 
            end
        end
    end
end

function armsLayer.onBefore(sender)
    return true
end

function armsLayer.onReturn(sender,eventType)
    pop.onClosePopDialog("arms")
end

function onShowArmsLayer(widget, arms, callBack)
    local layer = armsLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)
    layer._callback = callBack
    layer._arms = arms
    layer:onAutoSize()
    layer:onInit()
    return layer
end