--heroInfo
local heroInfoLayer = class("heroInfo")
heroInfoLayer._name = "heroInfo"
heroInfoLayer._init = false
heroInfoLayer._row = 1
heroInfoLayer._cfgheroskillup = {}
function heroInfoLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, heroInfoLayer)
    return target
end

function heroInfoLayer:onAutoSize()
    if self._init == false then 
        local hh = ff.height
        self:setContentSize(cc.size(720,hh))
        self:getChildByName("masking"):setContentSize(cc.size(720,hh + 700))
    end
end

function heroInfoLayer:onInit()
    if self._init == false then        
        self:getChildByName("show"):getChildByName("close"):addTouchEventListener(self.onBack)
        self._init = true
    end
    self:updates(self._row)
end

function heroInfoLayer:updates(row)
    if row <= dd.heros:rowCount() and row > 0 then
        local name = ""
        local lv   = dd.heros:getLong(row,"level")
        if dd.heros:getString(row,"name") == "" then
            name = ff.langString(dd.cfgHero[dd.heros:getLong(row,"id")]['name'])
        else
            name = dd.heros:getString(row,"name")
        end        
        self:getChildByName("show"):getChildByName("chu_title"):setString(name.." LV."..lv)
        self:updatePvpList(row)
        self:updatePveList(row)
    end
end

--弹窗 -pve pvp数据
function heroInfoLayer:updatePvpList(index)
    local list = self:getChildByName("show"):getChildByName("infos"):getChildByName("pvplist")
    local hh = list:getContentSize().height
    self._pvparr = {}           --数据清空
    self:getEffectList(index)

    local sorttable = {} 
    for key, item in pairs(self._pvparr) do
        local row = table.getn(sorttable) + 1
        sorttable[row] = {}
        sorttable[row]["param"] = key
        sorttable[row]["value"] = item["value"]
        sorttable[row]["showorder"] = item["showorder"]
    end
    table.sort(sorttable,function(v1,v2) return v1["showorder"] < v2["showorder"] end)

    for i, item in ipairs(list:getChildren()) do
        item:setVisible(false)
    end

    local num = table.getn(sorttable)
    local ihh = num * 52
    if ihh < hh then
        ihh = hh
    end
    list:setInnerContainerSize(cc.size(720, ihh))

    for i,effect in ipairs(sorttable) do
        if effect then
            local param = effect["param"]
            local value = effect["value"]  
            local item = list:getChildByTag(i)
            if item == nil then
                item = self:getChildByName("show"):getChildByName("infos"):getChildByName("info_item"):clone()
                item:setTag(i)
                list:addChild(item)
            end 
            item:setPositionX(0)
            item:setPositionY(ihh - i*52)
            item:setVisible(true) 
            item:getChildByName("tips1"):setString(ff.langString(dd.cfgEffect[param]['name']))
            if tonumber(dd.cfgEffect[param]['tips2']) ~= 0 then
                item:getChildByName("value1"):setString("+"..value..ff.langString(dd.cfgEffect[param]['tips2']))
            else
                item:getChildByName("value1"):setString("+"..value)
            end
            item:getChildByName("tips2"):setString("")
            item:getChildByName("value2"):setString("")
            if i%2 == 1 then
                item:getChildByName("Image_117"):loadTexture(dd.getPathFromUI("public/v2/title3.png",1))
            end
        else
            cclog("有问题===========================here")
        end
    end
end 

function heroInfoLayer:updatePveList(index)
    local list = self:getChildByName("show"):getChildByName("infos"):getChildByName("pvelist")
    --list:removeAllChildren(true)
    local id= dd.heros:getLong(index,"id")
    local lv = dd.heros:getLong(index,"level")  
    local type = dd.cfgHero[id]["crystal1"]
    local flag = math.log(type)/math.log(2) + 1
    local toolarr = {
        dd.heros:getLong(index,"tools1"),
        dd.heros:getLong(index,"tools2"),
        dd.heros:getLong(index,"tools3"),
        dd.heros:getLong(index,"tools4"),
        dd.heros:getLong(index,"tools5"),
        dd.heros:getLong(index,"tools6"),
        dd.heros:getLong(index,"tools7"),
        dd.heros:getLong(index,"tools8")
    }
    local armarr = {
        dd.heros:getLong(index,"arms1"),
        dd.heros:getLong(index,"arms2"),
        dd.heros:getLong(index,"arms3"),
        dd.heros:getLong(index,"arms4"),
        dd.heros:getLong(index,"arms5"),
        dd.heros:getLong(index,"arms6")
    }

    local namearr = {"攻击","防御","血量","劈砍","搏击","枪械","狙击","火焰"}
    local herovalue = {
        dd.cfgHero[id]["atk"] + dd.cfgHero[id]["atkadd"]*(lv-1)/10 + dd.heros:getLong(index,"PVEAct"),
        dd.cfgHero[id]["def"] + dd.cfgHero[id]["defadd"]*(lv-1)/10 + dd.heros:getLong(index,"PVEDfc"),
        dd.cfgHero[id]["hp"] + dd.cfgHero[id]["hpadd"]*(lv-1)/10 + dd.heros:getLong(index,"PVEHp")*10,
        dd.cfgHero[id]["shoot"] + dd.cfgHero[id]["shootadd"]*(lv-1)/10,
        dd.cfgHero[id]["miss"] + dd.cfgHero[id]["missadd"]*(lv-1)/10,
        dd.cfgHero[id]["double"] + dd.cfgHero[id]["doubleadd"]*(lv-1)/10,
        dd.cfgHero[id]["ddouble"] + dd.cfgHero[id]["ddoubleadd"]*(lv-1)/10,
        dd.cfgHero[id]["fire"] + dd.cfgHero[id]["fireadd"]*(lv-1)/10,
        dd.cfgHero[id]["dfire"] + dd.cfgHero[id]["dfireadd"]*(lv-1)/10,
        dd.cfgHero[id]["extraatk"] + dd.cfgHero[id]["extraatkadd"]*(lv-1)/10
    }
    local cryvalue = {
        self:getCrystalsValue(toolarr,901),
        self:getCrystalsValue(toolarr,902),
        self:getCrystalsValue(toolarr,903),
        self:getCrystalsValue(toolarr,904),
        self:getCrystalsValue(toolarr,905),
        self:getCrystalsValue(toolarr,906),
        self:getCrystalsValue(toolarr,907),
        self:getCrystalsValue(toolarr,908),
        self:getCrystalsValue(toolarr,909),
        self:getCrystalsValue(toolarr,910),
    }
    local armsvalue = {
        self:getArmsValue(armarr,901),
        self:getArmsValue(armarr,902),
        self:getArmsValue(armarr,903),
        self:getArmsValue(armarr,904),
        self:getArmsValue(armarr,905),
        self:getArmsValue(armarr,906),
        self:getArmsValue(armarr,907),
        self:getArmsValue(armarr,908),
        self:getArmsValue(armarr,909),
        self:getArmsValue(armarr,910)
    }
    local gemvalue = {
        self:getGemsValue(armarr,901),
        self:getGemsValue(armarr,902),
        self:getGemsValue(armarr,903),
        self:getGemsValue(armarr,904),
        self:getGemsValue(armarr,905),
        self:getGemsValue(armarr,906),
        self:getGemsValue(armarr,907),
        self:getGemsValue(armarr,908),
        self:getGemsValue(armarr,909),
        self:getGemsValue(armarr,910),
    }

    local indexs = { {1,2,3,4},{1,2,3,5},{1,2,3,6},{1,2,3,7},{1,2,3,8} }
    local row = ( table.getn( indexs[id] ) )/2
    
    for i = 1, row do
        local item = list:getChildByTag(i)

        if item == nil then
            item = self:getChildByName("show"):getChildByName("infos"):getChildByName("info_item"):clone()
            item:setTag(i)
            list:addChild(item)
            list:requestRefreshView()
        end
        local k = i + row
        item:setVisible(true)  

        local index_1 = indexs[id][i]
        item:getChildByName("tips1"):setString(ff.langString(namearr[index_1]))
        item:getChildByName("value1"):setString("+"..math.floor(herovalue[index_1] + cryvalue[index_1] + armsvalue[index_1] + gemvalue[index_1]))
        
        local index_2 = indexs[id][k]
        item:getChildByName("tips2"):setString(ff.langString(namearr[index_2]))
        item:getChildByName("value2"):setString("+"..math.floor(herovalue[index_2] + cryvalue[index_2] + armsvalue[index_2] + gemvalue[index_2]))
        if i == flag then
            item:getChildByName("flag1"):setVisible(true)
        elseif k == flag then
            item:getChildByName("flag2"):setVisible(true)
        end
        if i%2 == 1 then
            item:getChildByName("Image_117"):loadTexture(dd.getPathFromUI("public/v2/title3.png",1))
        end
        item:requestDoLayout()
    end
end

function heroInfoLayer:getEffectList(index)
    local id= dd.heros:getLong(index,"id")
    local lv = dd.heros:getLong(index,"level")
    local hid = dd.heros:getLong(index,"hid")
    cclog("id===="..id)
    cclog("英雄id===="..hid)
    cclog("英雄等级===="..lv)
    cclog("英雄名字===="..dd.heros:getLong(index,"name"))
    cclog("晶体1====".. dd.heros:getLong(index,"tools1"))
    cclog("晶体2====".. dd.heros:getLong(index,"tools2"))
    cclog("晶体3====".. dd.heros:getLong(index,"tools3"))
    cclog("晶体4====".. dd.heros:getLong(index,"tools4"))
    cclog("装备1====".. dd.heros:getLong(index,"arms1"))
    --晶体
    local cryarr = {
        dd.heros:getLong(index,"tools1"),
        dd.heros:getLong(index,"tools2"),
        dd.heros:getLong(index,"tools3"),
        dd.heros:getLong(index,"tools4"),
        dd.heros:getLong(index,"tools5"),
        dd.heros:getLong(index,"tools6"),
        dd.heros:getLong(index,"tools7"),
        dd.heros:getLong(index,"tools8")
    }
    local armarr = {
        dd.heros:getLong(index,"arms1"),
        dd.heros:getLong(index,"arms2"),
        dd.heros:getLong(index,"arms3"),
        dd.heros:getLong(index,"arms4"),
        dd.heros:getLong(index,"arms5"),
        dd.heros:getLong(index,"arms6")
    }
    --获取固定显示的
    local effs = Split(dd.cfgHero[id]['heroshow'],"|")
    for i=1,table.getn(effs) do
        self:addEffectParam(tonumber(effs[i]), math.floor(0))
    end

    --晶体_pve_effect 
    for i,cid in ipairs(cryarr) do
        for i=1,dd.myCrystals:rowCount() do
            if dd.myCrystals:getLong(i,"cid") == cid and cid ~= 0 then
                local cryid = dd.myCrystals:getLong(i,"id")
                local clv = dd.myCrystals:getLong(i,"level")
                local param1 = dd.cfgCrystal[cryid]["param1"]
                local value1 = dd.cfgCrystal[cryid]["value1"]+dd.cfgCrystal[cryid]["addvalue1"]*(clv-1)/10
                local param2 = dd.cfgCrystal[cryid]["param2"]
                local value2 = dd.cfgCrystal[cryid]["value2"]+dd.cfgCrystal[cryid]["addvalue2"]*(clv-1)/10
                self:addEffectParam(param1, math.floor(value1))
                self:addEffectParam(param2, math.floor(value2))
            end
        end
    end
    --装备
    for i,aid in ipairs(armarr) do
        for k=1,dd.myArms:rowCount() do
            if dd.myArms:getLong(k,"tid") == aid then
                local cfgid = dd.myArms:getLong(k,"aid")
                for i=1, 4 do
                    local param = dd.cfgArms[cfgid]["param"..i]
                    local value = dd.cfgArms[cfgid]["value"..i]
                    self:addEffectParam(param, value)
                end
    
                --宝石                   
                for j=1,4 do
                    local gid = dd.myArms:getLong(k,"gem"..j)
                    if dd.cfgGems[gid] ~= nil then
                        local param1 = dd.cfgGems[gid]['param1']
                        local param2 = dd.cfgGems[gid]['param2']
                        local value1 = dd.cfgGems[gid]['value1']
                        local value2 = dd.cfgGems[gid]['value2']
                        self:addEffectParam(param1, value1)
                        self:addEffectParam(param2, value2)
                    end
                end 
                break              
            end     
        end        
    end
    --英雄技能
    for i=1,dd.heros:rowCount() do
        if dd.heros:getLong(i,"hid") == hid then
            local skills = dd.heros:getNetTable(i,"skills")
            for j=1,skills:rowCount() do
                local sid = skills:getLong(j,"sid")
                local lv = skills:getLong(j,"level")
                if sid > 0 then
                    self:getEffectParamBy(sid,lv) 
                    local param1 = self._cfgheroskillup[sid][lv]["param1"]
                    local param2 = self._cfgheroskillup[sid][lv]["param2"]
                    local param3 = self._cfgheroskillup[sid][lv]["param3"]
                    local value1 = self._cfgheroskillup[sid][lv]["value1"]
                    local value2 = self._cfgheroskillup[sid][lv]["value2"]
                    local value3 = self._cfgheroskillup[sid][lv]["value3"]
                    self:addEffectParam(param1, value1)
                    self:addEffectParam(param2, value2)
                    self:addEffectParam(param3, value3)
                end
            end
            break
        end
    end
    --要除以value cfg_effect_value
    local count = 0
    for i,effect in pairs(self._pvparr) do
        if effect then
            cclog("param =="..i)
            cclog("value =="..effect["value"])
            local value = dd.cfgEffect[i]["value"]
            if value > 0 then
                effect["value"] = effect["value"]/value
            end
            count = count + 1
        end
    end
end

function heroInfoLayer:addEffectParam(param,value)
    if param ~= 0 and dd.cfgEffect[param]["showorder"] > 0 then
        if self._pvparr[param] ~= nil then                    
            self._pvparr[param]["value"] = self._pvparr[param]["value"]+ value
        else
            self._pvparr[param] = {}
            self._pvparr[param]["showorder"] = dd.cfgEffect[param]["showorder"]
            self._pvparr[param]["value"] = value
        end
    end
end

--获取晶体的属性值
function heroInfoLayer:getCrystalsValue(tools,param)
    local value = 0
    for i,item in ipairs(tools) do
        if item ~= 0 then
            value = value + self:getACrystalValue(item,param)
        end
    end
    return value
end
function heroInfoLayer:getACrystalValue(tid,param)
    --要获取等级
    for i=1,dd.myCrystals:rowCount() do
        if dd.myCrystals:getLong(i,"cid") == tid then
            local cryid = dd.myCrystals:getLong(i,"id")
            if dd.cfgCrystal[cryid]["param1"] == param then
                local lv = dd.myCrystals:getLong(i,"level")
                local value = dd.cfgCrystal[cryid]["value1"]+dd.cfgCrystal[cryid]["addvalue1"]*(lv-1)/10
                return value
            else
                return 0
            end
        end
    end
    return 0 
end

--获取装备的属性值  装备数组
function heroInfoLayer:getArmsValue(arms,param)
    local value = 0
    for i,item in ipairs(arms) do
        for k=1,dd.myArms:rowCount() do
            if item == dd.myArms:getLong(k,"tid") then
                local cfgid = dd.myArms:getLong(k,"aid")
                if dd.cfgArms[cfgid] ~= nil then
                    for i=1, 4 do
                        if dd.cfgArms[cfgid]["param"..i] == param then
                            value = value + dd.cfgArms[cfgid]["value"..i]
                        end
                    end
                end
            end
        end
    end
    return value
end
--获取宝石的属性值  一件装备4个宝石
function heroInfoLayer:getGemsValue(arms,param)
    local value = 0
    for i,item in ipairs(arms) do
        for k=1,dd.myArms:rowCount() do
            if dd.myArms:getLong(k,"tid")== item then
                value = value + self:getAGemValue(dd.myArms:getLong(k,"gem1"),param)
                value = value + self:getAGemValue(dd.myArms:getLong(k,"gem2"),param)
                value = value + self:getAGemValue(dd.myArms:getLong(k,"gem3"),param)
                value = value + self:getAGemValue(dd.myArms:getLong(k,"gem4"),param)
            end
        end
    end
    return value
end
function heroInfoLayer:getAGemValue(gid,param)
    if dd.cfgGems[gid] ~= nil then
        if dd.cfgGems[gid]['param1'] == param then
            return dd.cfgGems[gid]['value1']
        end
        if dd.cfgGems[gid]['param2'] == param then
            return dd.cfgGems[gid]['value2']
        end
        return 0
    else
        return 0
    end
end
--sid  = 技能id + level
function heroInfoLayer:getEffectParamBy(sid,lv)
    if self._cfgheroskillup[sid] == nil or self._cfgheroskillup[sid][lv] == nil then
        local rows = ff.dbmanager:sql_fetch_rows("select * from cfg_hero_skill_levelup where id="..sid*100 + lv)
        local info = {}
        info['id'] = tonumber(rows:getString(1, "id"))
        info['skillid'] = tonumber(rows:getString(1, "skillid"))
        info['skilllevel'] = tonumber(rows:getString(1, "skilllevel"))

        info['param1'] = tonumber(rows:getString(1, "param1"))
        info['value1'] = tonumber(rows:getString(1, "value1"))
        info['param2'] = tonumber(rows:getString(1, "param2"))
        info['value2'] = tonumber(rows:getString(1, "value2"))
        info['param3'] = tonumber(rows:getString(1, "param3"))
        info['value3'] = tonumber(rows:getString(1, "value3"))
        self._cfgheroskillup[info['skillid']] = self._cfgheroskillup[info['skillid']] or {}
        self._cfgheroskillup[info['skillid']][info['skilllevel']] = info
        rows:clear()
    end
end
--接口
function heroInfoLayer.onBack(sender,eventType)
    if eventType==ccui.TouchEventType.ended then     
        pop.onClosePopDialog("heroInfo")
    end
end

function heroInfoLayer:onClose()

end

function heroInfoLayer.onStart(sender)
end

function heroInfoLayer.onEnd(sender)
    dd.delBackEvent()
    sender:getChildByName("show"):getChildByName("infos"):getChildByName("pvplist"):removeAllChildren(true)
end

function heroInfoLayer.onBefore(sender)
    return true
end

function heroInfoLayer.onReturn(sender,eventType)
    pop.onClosePopDialog("heroInfo")
end

function onShowHeroInfoLayer(widget, heroid)
    local layer = heroInfoLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)
    layer._row = nil
    for i=1,dd.heros:rowCount() do
        if dd.heros:getLong(i,"hid") == heroid then
            layer._row = i
            break
        end
    end
    layer:onAutoSize()
    layer:onInit()
    return layer
end