--[[
    战争会所
    self.warData
    self.timelist  --倒计时集合
    self.warInfotimelist  --战斗详情倒计时集合
    self.openSites  当前开启的槽位数量
    
    self.schedulerEntry
    self.warinfoSchedulerEntry
]]

local warHouse   = class("warHouse")
warHouse._name   = "warHouse"
warHouse.state   = 1
warHouse.warData = nil
warHouse._init   = false


function warHouse.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, warHouse)
    return target
end

function warHouse:init()
    if self._init == false then
        self:doAutoSize()
        self:initUi()
        self.warData = dd.myUnionBattle
        self._init = true
    end
    self:initWarList()
    self.updateTime()
end

function warHouse:setTipsInfos()
    --联军总数上限 self.bid 15
    for i=1,dd.mybuilds:rowCount() do
        if dd.mybuilds:getLong(i,"pos") == self.pos then
            self.bid = dd.mybuilds:getLong(i,"bid")
            self.lv = dd.mybuilds:getLong(i,"level")
            break
        end
    end
    local data=dd.cfgBuildingUp[self.bid]
    local maxMembers=data[self.lv]["value1"]
    self:getChildByName("contain1"):getChildByName("bar01"):getChildByName("soldernums"):setString(ff.langString("盟军总数上限")..maxMembers)
end

function warHouse:initUi()
    self:getChildByName("contain1"):setVisible(true)
    --self:getChildByName("contain2"):setVisible(false)
    
    --建筑详情 
    local infobtn=self:getChildByName("contain1"):getChildByName("bar01"):getChildByName("infobtn")    
    infobtn:addTouchEventListener(self.openBuildInfo)
    
    local function showHelp(sender,eventType)
        if eventType==ccui.TouchEventType.ended then 
            pop.onShowPopDialog("warHouseHelp")
        end
    end
    self:getChildByName("contain1"):getChildByName("bar01"):getChildByName("infobtn"):addTouchEventListener(showHelp)
end 

--初始化战争列表
function warHouse:initWarList()
    --初始化战争列表
    local itemModle=self:getChildByName("contain1"):getChildByName("mainArea"):getChildByName("item")
    local listcontain=self:getChildByName("contain1"):getChildByName("mainArea"):getChildByName("listcontain")

    local l=self.warData:rowCount()
    for i=1,l do
        local item=itemModle:clone()
        self:drawItem(item,i)
        listcontain:addChild(item)
    end
    self:setTipsInfos()
end
--设置行
function warHouse:drawItem(item,index)
    item:setVisible(true)
    item:setTag(self.warData:getLong(index,"attackUid"))
    
    local attackedUnionOffical = self.warData:getLong(index,"attackedUnionOffical")
    local attackedUnionFlag=self.warData:getString(index,"attackedUnionFlag")
    local attackedUname=self.warData:getString(index,"attackedUname")
    local status=self.warData:getLong(index,"status")

    local statusStart=self.warData:getLong(index,"statusStart")
    local statusEnd=self.warData:getLong(index,"statusEnd")

    local attackUid=self.warData:getLong(index,"attackUid")

    local attackUnionFlag=self.warData:getString(index,"attackUnionFlag")
    local attackUname=self.warData:getString(index,"attackUname")
        
    cclog("发起人:"..attackUname)

    local currentSoldiers=self.warData:getLong(index,"currentSoldiers")--当前兵力

    local site=self.warData:getLong(index,"site")
    local type=self.warData:getLong(index,"type")

    local unionOffical=self.warData:getLong(index,"unionOffical")

    local processbar=nil
    if type==1 then--主动攻击
        if status == 3 then
            processbar=item:getChildByName("panel"):getChildByName("bg"):getChildByName("progress")
            item:getChildByName("panel"):getChildByName("bg"):getChildByName("progress1"):setVisible(false)
            item:getChildByName("panel"):getChildByName("bg"):getChildByName("progress"):setVisible(true)
            item:getChildByName("reinforcebtn"):setVisible(false)
            item:getChildByName("reinforcebtn"):setTouchEnabled(false)
            item:getChildByName("box"):getChildByName("icon"):loadTexture("images/icon/union_mark/img03_un.png")

            item:getChildByName("lab_name"):setString(ff.langString("发起人").."：")
            --
            item:getChildByName("name"):setString(attackUname)
            --显示隐藏官员标示
            --[[if(unionOffical>=4) then
                item:getChildByName("uLevel"):setVisible(true)
            else
                item:getChildByName("uLevel"):setVisible(false)
            end]]
            item:getChildByName("uLevel"):setString(unionOffical)
            local site=item:getChildByName("site")
            local str=""
            str = ff.langString("目标").." : "..ff.langString("据点")
            site:setString(str)
            item:getChildByName("armys"):setString(ff.langString("总兵力").."：")
        else
            processbar=item:getChildByName("panel"):getChildByName("bg"):getChildByName("progress")
            item:getChildByName("panel"):getChildByName("bg"):getChildByName("progress1"):setVisible(false)
            item:getChildByName("panel"):getChildByName("bg"):getChildByName("progress"):setVisible(true)
            item:getChildByName("reinforcebtn"):setVisible(false)
            item:getChildByName("reinforcebtn"):setTouchEnabled(false)
            item:getChildByName("box"):getChildByName("icon"):loadTexture("images/icon/union_mark/img01_un.png")

            item:getChildByName("lab_name"):setString(ff.langString("发起人").."：")
            --
            item:getChildByName("name"):setString(attackUname)
            --显示隐藏官员标示
            --[[if(unionOffical>=4) then
                item:getChildByName("uLevel"):setVisible(true)
            else
                item:getChildByName("uLevel"):setVisible(false)
            end]]
            item:getChildByName("uLevel"):setString(unionOffical)
            local site=item:getChildByName("site")
            local str=""
            if tonumber(self.warData:getLong(index,"targetType")) == 2 then
                cclog("=========="..attackUid)
                if dd.cfgNpc[tonumber(self.warData:getLong(index,"attackedUid"))] ~= nil then
                    str = ff.langString("攻击目标").." : "..ff.langString(dd.cfgNpc[tonumber(self.warData:getLong(index,"attackedUid"))]["name"]).."  LV."..dd.cfgNpc[tonumber(self.warData:getLong(index,"attackedUid"))]["level"]   
                end
            elseif self.warData:getString(index,"targetType") == 1 then
                if string.len(attackedUnionFlag) == 3 then
                    str = ff.langString("目标:[{0}] {1} 的城市",{attackedUnionFlag,attackedUname})
                else
                    str = ff.langString("目标: {0} 的城市",{attackedUname})     
                end
            end
            site:setString(str)
            item:getChildByName("armys"):setString(ff.langString("总兵力").."：")
        end
        
    elseif type==2 then--被攻击
        processbar=item:getChildByName("panel"):getChildByName("bg"):getChildByName("progress")
        item:getChildByName("panel"):getChildByName("bg"):getChildByName("progress1"):setVisible(true)
        item:getChildByName("panel"):getChildByName("bg"):getChildByName("progress"):setVisible(false)
        item:getChildByName("box"):getChildByName("icon"):loadTexture("images/icon/union_mark/img02_un.png")

        item:getChildByName("lab_name"):setString(ff.langString("被攻击人").."：")
        item:getChildByName("name"):setString(attackedUname)
        --显示隐藏官员标示
        --[[if(attackedUnionOffical>=4) then
            item:getChildByName("uLevel"):setVisible(true)
        else
            item:getChildByName("uLevel"):setVisible(false)
        end]]
        item:getChildByName("uLevel"):setString(attackedUnionOffical)
        item:getChildByName("reinforcebtn"):setVisible(true)
        item:getChildByName("reinforcebtn"):setTouchEnabled(true)   

        item:getChildByName("site"):setString(ff.langString("发起人").."：【"..attackUnionFlag.."】"..attackUname)
        item:getChildByName("armys"):setString(ff.langString("防御兵力").."：")
        item:getChildByName("Image_86"):setVisible(false)

    end

    item:setTouchEnabled(true)
    item:addTouchEventListener(self.openWarInfo)
    item:getChildByName("reinforcebtn"):setTag(self.warData:getLong(index,"attackUid"))
    item:getChildByName("reinforcebtn"):addTouchEventListener(self.openWarInfo2)
end

function warHouse.updateTime()
    local widget = pop.getDialog("warHouse")
    local lists=widget:getChildByName("contain1"):getChildByName("mainArea"):getChildByName("listcontain")
    --先更新
    for i=1,dd.myUnionBattle:rowCount() do
        local id = dd.myUnionBattle:getLong(i,"attackUid")
        local item = lists:getChildByTag(id)
        if item == nil then
            item = widget:getChildByName("contain1"):getChildByName("mainArea"):getChildByName("item"):clone()
            widget:drawItem(item,i)
            lists:addChild(item)
        end
        local panel=item:getChildByName("panel")
        local status = dd.myUnionBattle:getLong(i,"status")
        if status ==0 then
            panel:getChildByName("label"):setString(ff.langString("联军集结中"))
        elseif status==1 then
            panel:getChildByName("label"):setString(ff.langString("联军已出发"))
        elseif status==2 then
            panel:getChildByName("label"):setString(ff.langString("等待中"))
        elseif status==3 then
            panel:getChildByName("label"):setString(ff.langString("联合驻守"))
        end
        item:getChildByName("soldiers"):setString(dd.myUnionBattle:getLong(i,"currentSoldiers").."/"..dd.myUnionBattle:getLong(i,"maxSoldiers"))
        if dd.myUnionBattle:getLong(i,"type") == 1 then
            item:getChildByName("panel"):getChildByName("bg"):getChildByName("progress"):setVisible(true)
        else
            item:getChildByName("panel"):getChildByName("bg"):getChildByName("progress1"):setVisible(true)
        end
        local progress = 100
        if status==2 then
            panel:getChildByName("time"):setString("00:00:00")
        else
            progress = 100 * (dd.getServerTime() - dd.myUnionBattle:getLong(i,"statusStart"))/(dd.myUnionBattle:getLong(i,"statusEnd") - dd.myUnionBattle:getLong(i,"statusStart"))
            panel:getChildByName("time"):setString(ff.getLeftTime(dd.myUnionBattle:getLong(i,"statusEnd") - dd.getServerTime(),":"))
        end
        item:getChildByName("panel"):getChildByName("bg"):getChildByName("progress1"):setPercent(progress)
        item:getChildByName("panel"):getChildByName("bg"):getChildByName("progress"):setPercent(progress)
    end
    --再删除
    local update = false
    for id,item in ipairs(lists:getChildren()) do
        local masterid = item:getTag()
        local have = false
        for i=1,dd.myUnionBattle:rowCount() do
            if dd.myUnionBattle:getLong(i,"attackUid") == masterid then
                have = true
                break
            end
        end
        if have == false then
            lists:removeChild(item)
        end
    end
    lists:refreshView()
end

--打开建筑Help信息
function warHouse.openBuildInfo(sender,eventType)
    if eventType==ccui.TouchEventType.ended then  
        local widget=pop.getDialog("warHouse")
        local binfo=widget:getChildByName("binfo")
        local h=binfo:getContentSize().height
        binfo:setPositionY(-1*h)
        binfo:setVisible(true)

        widget:initBuildInfo()

        binfo:runAction(cc.MoveTo:create(0.2,cc.p(0,0)))
    end
end

--关闭建筑Help信息
function warHouse.closeBuildInfo(sender,eventType)
    if eventType==ccui.TouchEventType.ended then  
        local widget=pop.getDialog("warHouse")
        local binfo=widget:getChildByName("binfo")
        local h=binfo:getContentSize().height

        local callfunc = cc.CallFunc:create(function () 
            local list=binfo:getChildByName("list")
            list:removeAllChildren()
            binfo:setVisible(false)
        end)

        local  pSequence = cc.Sequence:create(cc.MoveTo:create(0.2,cc.p(0,-1*h)),callfunc)

        binfo:runAction(pSequence)
    end
end

--初始化建筑信息
function warHouse:initBuildInfo()
    local binfo=self:getChildByName("binfo")
    local list=binfo:getChildByName("list")

    local th=binfo:getChildByName("th"):clone()
    local td=binfo:getChildByName("td")

    th:setVisible(true)
    th:getChildByName("label"):setString(ff.langString("升级效果"))
    list:insertCustomItem(th, 0)
    
    local data=dd.cfgBuildingUp[15]
    
    for i=1,15 do
        local items_count = table.getn(list:getItems())
        local item=td:clone()
        item:setVisible(true)
        item:getChildByName("Label_9"):setString(i)

        local _data=data[i]
        local value1=_data["value1"]
        item:getChildByName("Label_9_0"):setString(value1)
        --self:drawWarInfoItem(item,i,type)
        list:insertCustomItem(item, items_count)
    end

    local closebtn=binfo:getChildByName("bar"):getChildByName("closebtn")
    closebtn:addTouchEventListener(self.closeBuildInfo)

    binfo:getChildByName("bar"):getChildByName("title"):setString("联合作战中心")
end


--打开战争详情
function warHouse.openWarInfo(sender,eventType)
    if eventType==ccui.TouchEventType.ended then    
        local id = sender:getTag()
        for i=1,dd.myUnionBattle:rowCount() do
            if dd.myUnionBattle:getLong(i,"attackUid") == id then
                local uid=dd.myUnionBattle:getLong(i,"attackUid")
                local type=dd.myUnionBattle:getLong(i,"type")
                local uname=dd.myUnionBattle:getString(i,"attackedUname")
                local attackedUnionFlag=dd.myUnionBattle:getString(i,"attackedUnionFlag")
                pop.onShowPopDialog("warhouseinfo",uid,type,uname,attackedUnionFlag)
                break
            end
        end
    end
end
function warHouse.openWarInfo2(sender,eventType)
    if eventType==ccui.TouchEventType.ended then   
        local id = sender:getTag()
        for i=1,dd.myUnionBattle:rowCount() do
            if dd.myUnionBattle:getLong(i,"attackUid") == id then
                local uid=dd.myUnionBattle:getLong(i,"attackUid")
                local type=dd.myUnionBattle:getLong(i,"type")
                local uname=dd.myUnionBattle:getString(i,"attackUname")
                local attackedUnionFlag=dd.myUnionBattle:getString(i,"attackUnionFlag")
                pop.onShowPopDialog("warhouseinfo",uid,type,uname,attackedUnionFlag)
                break
            end
        end
    end
end



function warHouse.onEnd(sender)
    sender:stopAllActions()
    sender:quit()
end

function warHouse.onStart(sender)
    schedule(sender,sender.updateTime,1)
end

--返回战争列表 (之前在详情中用的返回)
function warHouse:backToList()
    self:getChildByName("contain1"):setVisible(true)
end
--退出清理
function warHouse:quit()
    local listcontain=self:getChildByName("contain1"):getChildByName("mainArea"):getChildByName("listcontain")
    cclog("count:"..listcontain:getChildrenCount())
    listcontain:removeAllChildren(true)
end

function warHouse.onReturn(sender)
    local widget = pop.getDialog("warHouse")
    if widget ~= nil then
        --print("widget========",widget.state)
        if(widget.state==1) then
            pop.onClosePopDialog("warHouse")
        else
            widget:backToList()
            widget.state=1
            return true          
        end
    end
    return false
end

function warHouse.onBefore(sender)
    return false
end

--自适应 计算list行高
function warHouse:doAutoSize()
    local w=ff.width
    local h=dd.currentLayer._pop:getContentSize().height

    local size=cc.size(0,0)
    size.height=h-184
    size.width=w
    self:setContentSize(size)

    local contain1=self:getChildByName("contain1")
    contain1:setContentSize(size)
    contain1:setPositionY(0)



    local mainArea=contain1:getChildByName("mainArea")  

    local bar01=contain1:getChildByName("bar01")
    mainAreah=contain1:getContentSize().height-bar01:getContentSize().height
    size.height=mainAreah - 30
    bar01:setPositionY(mainAreah - 15)
    mainArea:setContentSize(size)

    local listcontain=contain1:getChildByName("mainArea"):getChildByName("listcontain")
    listcontain:setContentSize(size)
    listcontain:setPositionY(4)
end

function onShowWarHouse(widget,pos)
    local layer = warHouse.extend(widget)    
    layer.pos=pos
    layer:init()
	return layer
end