--[[
    战争详情
    self.index=0  --当前操作的列表item
    self.uid      --发起人id
    self.attackedName
    self.attackedUnionFlag
]]
local warhouseinfo   = class("warhouseinfo")
warhouseinfo._name = "warhouseinfo"
warhouseinfo._init = false
warhouseinfo._type = 0
warhouseinfo._canjoin = true

function warhouseinfo.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, warhouseinfo)
    return target
end

function warhouseinfo:init(type,uid,attackedName,attackedUnionFlag)
    self:doAutoSize()
    self._type = type
    self.attackedName=attackedName
    self.attackedUnionFlag=attackedUnionFlag

    cclog("self.attackedName:"..attackedName)
    if not self.attackedName then
        self.attackedName=""
    end

    if not self.attackedUnionFlag then
        self.attackedUnionFlag=""
    end
    
    local returnbtn=self:getChildByName("top"):getChildByName("return")
    returnbtn:addTouchEventListener(self.onReturn) --self.onClose)
    self.updateGold()
    
    cclog("type:"..type..",uid:"..uid)
    self:addListener()
    if type > 0 and uid > 0 then
        local message = ff.net:createMessage()
        ff.net:addCmd(message,0x00000023)
        message:addLong(dd.uid)
        message:addLong(type)
        message:addLong(uid)
        ff.net:rpc(message,false)
    else
        cclog("type or uid is nil")    
    end
end

function warhouseinfo.updateGold()
    local widget = pop.getDialog("warhouseinfo")
    if widget ~= nil then
        widget:getChildByName("top"):getChildByName("count"):setString(dd.myinfo:getLong(1,"gold"))
        local w = widget:getChildByName("top"):getChildByName("count"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        widget:getChildByName("top"):getChildByName("title"):setContentSize(cc.size(w,100))
        widget:getChildByName("top"):getChildByName("title"):requestDoLayout()
        widget:getChildByName("top"):requestDoLayout()
    end
end

--初始化战争详情
function warhouseinfo:initWarInfo()
    self:getChildByName("contain2"):setVisible(true)
    
    local contain2=self:getChildByName("contain2")
    local info=contain2:getChildByName("mainArea"):getChildByName("info")


    --数组中第一项是发起者 被攻击人信息
    self.uid=self.warInfoData.data:getLong(1,"uid")
    --城市坐标
    self.site=self.warInfoData.site

    local name=self.warInfoData.data:getString(1,"name")
    local unionJob=self.warInfoData.data:getLong(1,"unionJob")  

    
    --计算开启的格子数量

    --查询联盟科技带来的格子加成效果 
    local effectvalue=0
    local l=dd.myeffect:rowCount()
    for i=1,l do
        local id=dd.myUnionTecs:getLong(i,"id")
        if(id==1006) then
            effectvalue=dd.myUnionTecs:getLong(i,"param")
            break
        end
    end

    --计算出已经花钱开启的格子数量 (3为 自己和初始化的2个)
    local openSites=self.warInfoData.slotOpened
    self.openSites=openSites
    local allSites=openSites
    if openSites<25 then--总槽位是25 固定死的
        --if self.uid == dd.uid then
            allSites=allSites+1--添加一个要解锁的格子数量
        --end
    end

    local opennums=self.openSites-3-effectvalue
    self.opennums=opennums

    --被攻击 攻击者 联盟简称获取不到

    --self.attackedUnionFlag
    if not self.attackedName then
        self.attackedName=""
    end
    info:getChildByName("chu_power"):setString("Power:"..ff.getFormatMoney(self.warInfoData.fighting))
    --攻击目标
    if self._type==1 then
        if self.warInfoData.status == 3 then
            info:getChildByName("attacklabel"):setString(ff.langString("联合驻守")..": "..ff.langString("据点"))
            info:getChildByName("chu_power"):setString("")
        else
            if string.len(self.attackedUnionFlag) > 0 then
                info:getChildByName("attacklabel"):setString(ff.langString("攻击目标")..": ["..self.attackedUnionFlag.."] "..self.attackedName)
            else            
                info:getChildByName("attacklabel"):setString(ff.langString("攻击目标")..": "..self.attackedName)
            end
        end
        local mapsite=dd.MapidToXY(self.warInfoData.site)
        info:getChildByName("site"):setString("(X:"..mapsite.x.." Y:"..mapsite.y..")")
    else
        if string.len(self.attackedUnionFlag) > 0 then
            info:getChildByName("attacklabel"):setString(ff.langString("攻击来自")..": ["..self.attackedUnionFlag.."] "..self.attackedName)
        else
            info:getChildByName("attacklabel"):setString(ff.langString("攻击来自")..": "..self.attackedName)
        end            
        local mapsite=dd.MapidToXY(self.warInfoData.buildMapID)
        info:getChildByName("site"):setString("(X:"..mapsite.x.." Y:"..mapsite.y..")")
        info:loadTexture(dd.getPathFromUI("block01_hs.png",1))
    end
    
    

        
    local listcontain=contain2:getChildByName("mainArea"):getChildByName("listcontain")
    listcontain:removeAllChildren()

    --自己不可以加入
    self._canjoin = true
    for i=1,self.warInfoData.data:rowCount() do
        if dd.uid == self.warInfoData.data:getLong(i,"uid") then
            self._canjoin = false
            break
        end
    end

    --设置出兵信息
    self:drawWarDetail()    

    --基本信息
    local itemModle=contain2:getChildByName("mainArea"):getChildByName("item")
    if self._type==2 then
        allSites=self.warInfoData.data:rowCount()
    end
    for i=2,allSites do
        local item=itemModle:clone()
        self:drawWarInfoItem(item,i,self._type)
        listcontain:addChild(item)
    end
    listcontain:refreshView()
    listcontain:scrollToTop(0.2,true)

    self.updateTime()
    schedule(self,self.updateTime,1)
end
function warhouseinfo.updateTime()
    local widget = pop.getDialog("warhouseinfo")
    for i=1,dd.myUnionBattle:rowCount() do
        local id = dd.myUnionBattle:getLong(i,"attackUid")
        if widget.warInfoData ~= nil and  id == widget.warInfoData.data:getLong(1,"uid") then
            widget.warInfoData.currentSoldiers = dd.myUnionBattle:getLong(i,"currentSoldiers")
            widget.warInfoData.status = dd.myUnionBattle:getLong(i,"status")
            widget.warInfoData.statusEnd   = dd.myUnionBattle:getLong(i,"statusEnd")
            widget.warInfoData.statusStart = dd.myUnionBattle:getLong(i,"statusStart")
        end
    end
    if widget ~= nil then
        for i,item in ipairs(widget:getChildByName("contain2"):getChildByName("mainArea"):getChildByName("listcontain"):getChildren()) do
            local row = item:getTag()
            local str = ""
            if widget.warInfoData.status == 0 then
                str=ff.langString("集结中")
            elseif widget.warInfoData.status == 1 then
                str=ff.langString("出征中")  
            elseif widget.warInfoData.status == 3 then
                str=ff.langString("驻守中")              
            else
                str=ff.langString("等待中")
                widget._canjoin = false
            end
            local progress = 0
            if row == 1 then
                if widget._type == 1 then
                    item:getChildByName("zengyuan"):setString(ff.langString("进攻部队上线")..":"..widget.warInfoData.currentSoldiers.."/"..widget.warInfoData.maxSoldiers)
                    item:getChildByName("panel"):getChildByName("panel"):getChildByName("label"):setString(str)

                    if widget.warInfoData.status == 2 then
                        progress = 100
                        item:getChildByName("panel"):getChildByName("panel"):getChildByName("time"):setString("00:00:00")
                    else
                        progress = (dd.getServerTime() - widget.warInfoData.statusStart)*100/(widget.warInfoData.statusEnd - widget.warInfoData.statusStart)
                        item:getChildByName("panel"):getChildByName("panel"):getChildByName("time"):setString(ff.getLeftTime(widget.warInfoData.statusEnd - dd.getServerTime(),":"))
                    end          
                    if widget.warInfoData.status == 1 then
                        widget:setProgressSize(item)
                        --item:getChildByName("panel"):getChildByName("cancelbtn"):setVisible(false)          
                    end
                else
                    item:getChildByName("zengyuan"):setString(ff.langString("增援部队上线")..":"..widget.warInfoData.currentSoldiers.."/"..widget.warInfoData.maxSoldiers)
                    item:getChildByName("panel"):getChildByName("panel"):getChildByName("label"):setString(ff.langString("敌军行进中:"))
                    progress = (dd.getServerTime() - widget.warInfoData.statusStart)*100/(widget.warInfoData.statusEnd - widget.warInfoData.statusStart)
                    item:getChildByName("panel"):getChildByName("panel"):getChildByName("time"):setString(ff.getLeftTime(widget.warInfoData.statusEnd - dd.getServerTime(),":"))
                    --item:getChildByName("panel"):getChildByName("cancelbtn"):setVisible(false)
                end
            else
                --设置参与者的进度信息
                if widget._type == 2 then
                    item:getChildByName("panel"):getChildByName("panel"):getChildByName("label"):setString(ff.langString("援军集结中:"))
                else
                    item:getChildByName("panel"):getChildByName("panel"):getChildByName("label"):setString(str)
                end
   
                if widget.warInfoData.status == 2 then
                    progress = 100
                    item:getChildByName("panel"):getChildByName("panel"):getChildByName("time"):setString("00:00:00")
                else
                    progress = (dd.getServerTime() - widget.warInfoData.statusStart)*100/(widget.warInfoData.statusEnd - widget.warInfoData.statusStart)
                    item:getChildByName("panel"):getChildByName("panel"):getChildByName("time"):setString(ff.getLeftTime(widget.warInfoData.statusEnd - dd.getServerTime(),":"))
                end          
                if widget.warInfoData.status == 1 then
                    item:getChildByName("panel"):getChildByName("cancelbtn"):setBright(false)        
                end
                
                --
                if dd.uid ~= widget.warInfoData.data:getLong(1,"uid") then
                    if widget.warInfoData.data:rowCount() >= row then
                        if widget._type == 1 then
                            widget:setProgressSize(item)
                        end
                    end
                end 
            end            
            item:getChildByName("panel"):getChildByName("bg"):getChildByName("progress"):setPercent(progress)
            item:getChildByName("panel"):getChildByName("bg"):getChildByName("progress1"):setPercent(progress)

            if widget.warInfoData.data:getLong(1,"uid") == dd.uid then
                if row < widget:getChildByName("contain2"):getChildByName("mainArea"):getChildByName("listcontain"):getChildrenCount() then
                    item:getChildByName("btn_join"):setBright(widget._canjoin)
                    item:getChildByName("btn_join"):setTouchEnabled(widget._canjoin)
                end
            else
                item:getChildByName("btn_join"):setBright(widget._canjoin)
                item:getChildByName("btn_join"):setTouchEnabled(widget._canjoin)
            end
        end
    end
end

function warhouseinfo:drawWarDetail()
    local item=self:getChildByName("contain2"):getChildByName("mainArea"):getChildByName("item"):clone()
    item:setVisible(true)
    item:setTag(1)

    --为被攻击时 第一个栏位(不显示进度条) 高度不改变 为260
    if self._type==2 then
        item:getChildByName("zengyuan"):setString(ff.langString("增援部队上线")..":"..self.warInfoData.currentSoldiers.."/"..self.warInfoData.maxSoldiers)

        item:getChildByName("panelname"):getChildByName("lab_name"):setString(ff.langString("防御方").."：")
        item:getChildByName("panelname"):getChildByName("name"):setString(self.warInfoData.data:getString(1,"name"))
        --联盟职位标志
        item:getChildByName("panelname"):getChildByName("uLevel"):setString(self.warInfoData.data:getLong(1,"unionJob"))
        
        --数量
        item:getChildByName("nums"):setString(self:getArmysCount(1))
        --face
        item:getChildByName("box"):getChildByName("icon"):loadTexture(dd.getPlayerIcon(self.warInfoData.data:getLong(1,"face")),0)
        --取消攻击
        item:getChildByName("panel"):getChildByName("cancelbtn"):setVisible(false)
        if dd.uid == self.warInfoData.data:getLong(1,"uid") then
            item:getChildByName("zengyuanbtn"):setVisible(false)
            self:setProgressSize(item)
        else
            item:getChildByName("zengyuanbtn"):setVisible(true)
        end
        item:getChildByName("zengyuanbtn"):addTouchEventListener(self.zengyuan)
        item:getChildByName("panel"):getChildByName("bg"):getChildByName("progress"):setVisible(false)
        item:getChildByName("panel"):getChildByName("bg"):getChildByName("progress1"):setVisible(true)
    else

        if self.warInfoData.status == 3 then
            item:getChildByName("zengyuan"):setString(ff.langString("进攻部队上线")..":"..self.warInfoData.currentSoldiers.."/"..self.warInfoData.maxSoldiers)

            item:getChildByName("panelname"):getChildByName("lab_name"):setString(ff.langString("发起人").."：")
            item:getChildByName("panelname"):getChildByName("name"):setString(self.warInfoData.data:getString(1,"name"))
            --联盟职位标志
            item:getChildByName("panelname"):getChildByName("uLevel"):setString(self.warInfoData.data:getLong(1,"unionJob"))
            --数量
            item:getChildByName("nums"):setString(self:getArmysCount(1))
            --face
            item:getChildByName("box"):getChildByName("icon"):loadTexture(dd.getPlayerIcon(self.warInfoData.data:getLong(1,"face")),0)
            --取消攻击
            local cancelbtn=item:getChildByName("panel"):getChildByName("cancelbtn")

            cancelbtn:setVisible(false)
            cancelbtn:setTouchEnabled(false)
            item:getChildByName("infobtn"):loadTextureNormal(dd.getPathFromUI("public/img01_next.png",1))

            item:getChildByName("panel"):getChildByName("bg"):getChildByName("progress"):setVisible(true)
            item:getChildByName("panel"):getChildByName("bg"):getChildByName("progress1"):setVisible(false)
            self:setProgressSize(item)
        else
            item:getChildByName("zengyuan"):setString(ff.langString("进攻部队上线")..":"..self.warInfoData.currentSoldiers.."/"..self.warInfoData.maxSoldiers)

            item:getChildByName("panelname"):getChildByName("lab_name"):setString(ff.langString("发起人").."：")
            item:getChildByName("panelname"):getChildByName("name"):setString(self.warInfoData.data:getString(1,"name"))
            --联盟职位标志
            item:getChildByName("panelname"):getChildByName("uLevel"):setString(self.warInfoData.data:getLong(1,"unionJob"))
            --数量
            item:getChildByName("nums"):setString(self:getArmysCount(1))
            --face
            item:getChildByName("box"):getChildByName("icon"):loadTexture(dd.getPlayerIcon(self.warInfoData.data:getLong(1,"face")),0)
            --取消攻击
            local cancelbtn=item:getChildByName("panel"):getChildByName("cancelbtn")
            if dd.uid == self.warInfoData.data:getLong(1,"uid") then
                cancelbtn:setVisible(true)
                cancelbtn:setTouchEnabled(true)
                cancelbtn:addTouchEventListener(self.cancelAttack)
            else
                cancelbtn:setVisible(false)
                cancelbtn:setTouchEnabled(false)
                self:setProgressSize(item)
            end
            item:getChildByName("panel"):getChildByName("bg"):getChildByName("progress"):setVisible(true)
            item:getChildByName("panel"):getChildByName("bg"):getChildByName("progress1"):setVisible(false)
        end
    end
    local infobtn=item:getChildByName("infobtn")
    infobtn:setTag(1)
    infobtn:addTouchEventListener(self.openSoilderInfo)
    
    self:getChildByName("contain2"):getChildByName("mainArea"):getChildByName("listcontain"):addChild(item)
end

--设置战争详情 listitem 行
function warhouseinfo:drawWarInfoItem(item,index,type)
    item:setVisible(true)
    item:setTag(index)

    local isEmpty=false
    local uid=nil
    local uname=""
    local startTime=nil
    local arrival=nil
    item.type=type
    --
    local show = false

    item:getChildByName("background"):loadTexture(dd.getPathFromUI("public/block04.png",1))
    item:getChildByName("imgblood"):loadTexture(dd.getPathFromUI("public/alpha.png",1))

    --空的槽位或未解锁的
    if self.warInfoData.data:rowCount() < index then
        isEmpty=true
        if index>self.openSites then
            --锁住的槽位
            item:getChildByName("box"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
            item:getChildByName("btn_open").islock=true
            item:getChildByName("btn_open"):setVisible(true)
            item:getChildByName("btn_join"):setVisible(false)
            item:getChildByName("btn_open"):getChildByName("chu_label"):setString("Open")

            local itemcount=self.opennums+1
            if dd.getToolsCount(1016) >= itemcount then
                item:getChildByName("btn_open"):getChildByName("chu_label"):setPositionY(50)
                item:getChildByName("btn_open"):getChildByName("icon"):setVisible(false)
                item:getChildByName("btn_open"):getChildByName("nums"):setVisible(false)
            else
                item:getChildByName("needitempanel"):getChildByName("nums"):setColor(cc.c3b(255,0,0))
                local price = dd.cfgProp[1016]['value']
                item:getChildByName("btn_open"):getChildByName("nums"):setString(price*itemcount)

                if dd.myinfo:getLong(1,"gold") < price*itemcount then
                    item:getChildByName("btn_open"):getChildByName("nums"):setColor(cc.c3b(255,0,0))
                end
            end

            --item:getChildByName("needitempanel"):getChildByName("icon"):loadTexture(dd.getToolsIcon(1016),0)
            item:getChildByName("needitempanel"):getChildByName("nums"):setString("x"..itemcount)
            item:getChildByName("needitempanel"):setVisible(true)
            item:getChildByName("chu_emptysite"):setVisible(true)
        else
            item:getChildByName("box"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
            item:getChildByName("chu_emptysite"):setVisible(true)
            item:getChildByName("needitempanel"):setVisible(false)
            --空的槽位
            item:getChildByName("btn_open"):setVisible(false)
            item:getChildByName("btn_join"):setVisible(true)
            item:getChildByName("btn_join"):getChildByName("chu_label"):setString(ff.langString("加入"))
            item:getChildByName("btn_join"):setBright(self._canjoin)
        end
        
        --加入 or 开启槽位
        local function fun(sender,eventType)
            local doaction = false
            if eventType == ccui.TouchEventType.canceled then
                local startp = sender:getTouchBeganPosition()
                local endp   = sender:getTouchEndPosition()
                if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                    doaction = true
                end
            end

            if eventType == ccui.TouchEventType.ended then
                doaction = true
            end
            if doaction == true then
                if sender.islock then
                    --解锁
                    self:unlock(item)
                else
                    --加入
                    self:addToTeam(item,index)
                end
            end
        end
        --Register Event
        item:getChildByName("btn_open"):addTouchEventListener(fun)
        item:getChildByName("btn_join"):addTouchEventListener(fun)
       
        item:getChildByName("chu_emptysite"):setString(ff.langString("空闲位置"))
        item:getChildByName("panelname"):setVisible(false)

        item:getChildByName("lab_num"):setVisible(false)
        item:getChildByName("nums"):setVisible(false)
        item:getChildByName("infobtn"):setVisible(false)
        --
        item:getChildByName("panel"):setVisible(false)
    else
        --有数据的槽位
        local unionJob=self.warInfoData.data:getLong(index,"unionJob")
        uname=self.warInfoData.data:getString(index,"name")
        local face=self.warInfoData.data:getLong(index,"face")
        item:getChildByName("panel"):setVisible(true)

        --nums
        --计算兵力数量
        local allnums=self:getArmysCount(index)

        item:getChildByName("btn_open"):setVisible(false)
        item:getChildByName("btn_join"):setVisible(false)
        item:getChildByName("chu_emptysite"):setVisible(false)
        --
        item:getChildByName("panelname"):setVisible(true)

        item:getChildByName("lab_num"):setVisible(true)
        item:getChildByName("nums"):setVisible(true)
        item:getChildByName("infobtn"):setVisible(true)
        if self.warInfoData.status == 3 then
            item:getChildByName("infobtn"):loadTextureNormal(dd.getPathFromUI("public/img01_next.png",1))
        end

        local cancelbtn = item:getChildByName("panel"):getChildByName("cancelbtn")
        cancelbtn:setTag(index)
        if dd.uid == self.warInfoData.data:getLong(1,"uid") then
            if type == 1 then
            show = false
            cancelbtn:getChildByName("chu_label"):setString(ff.langString("送回"))
            elseif type == 2 then
                show = true
            end
        end
        item:getChildByName("panelname"):getChildByName("lab_name"):setString(ff.langString("增援人").."：")
        --将部队送回
        local function armysBackEvent(sender,eventType)
            local doaction = false
            if eventType == ccui.TouchEventType.canceled then
                local startp = sender:getTouchBeganPosition()
                local endp   = sender:getTouchEndPosition()
                if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                    doaction = true
                end
            end

            if eventType == ccui.TouchEventType.ended then
                doaction = true
            end
            if doaction == true then
                if sender:getName() == "cancelbtn" then
                    local itemIndex = sender:getTag()
                    local uid = self.warInfoData.data:getLong(itemIndex,"uid")
                    self.callBackSoilder(uid)
                end
            end
        end
        cancelbtn:addTouchEventListener(armysBackEvent)

        --
        uid=self.warInfoData.data:getLong(index,"uid")
        item:getChildByName("panelname"):getChildByName("uLevel"):setString(unionJob)  
        item:getChildByName("nums"):setString(allnums)
        item:getChildByName("box"):getChildByName("icon"):loadTexture(dd.getPlayerIcon(face),0)

        --item:getChildByName("nums"):setString()
        local infobtn=item:getChildByName("infobtn")
        infobtn:setTag(index)
        infobtn:addTouchEventListener(self.openSoilderInfo)
    end

    item.uid=uid
    item.index=index
    item:getChildByName("panelname"):getChildByName("name"):setVisible(true)
    item:getChildByName("panelname"):getChildByName("name"):setString(uname)
    item:getChildByName("zengyuan"):setVisible(false)

    self:resetItem(item,show)
end

function warhouseinfo:resetItem(item,show)
    local size=item:getContentSize()
    size.height=170
    size.width=720
    item:setContentSize(size)
    item:getChildByName("background"):setContentSize(cc.size(698,160))

    -- +3
    item:getChildByName("background"):setPositionX(11)
    -- -15
    item:getChildByName("box"):setPositionY(77)
    item:getChildByName("lab_num"):setPositionY(74)
    item:getChildByName("nums"):setPositionY(74)
    item:getChildByName("panelname"):setPositionY(100)
    item:getChildByName("infobtn"):setPositionY(119)
    if show == true then
        self:setProgressSize(item)
    end
    item:getChildByName("panel"):setPositionY(15)
end

function warhouseinfo:setProgressSize(item)
    item:getChildByName("panel"):setContentSize(cc.size(534,35))
    item:getChildByName("panel"):getChildByName("cancelbtn"):setVisible(false)
    item:getChildByName("panel"):getChildByName("bg"):setContentSize(cc.size(534,35))
    item:getChildByName("panel"):getChildByName("bg"):getChildByName("progress"):setPosition(cc.p(267,17))
    item:getChildByName("panel"):getChildByName("bg"):getChildByName("progress1"):setPosition(cc.p(267,17))
    item:getChildByName("panel"):getChildByName("bg"):getChildByName("progress"):setContentSize(cc.size(528,29))
    item:getChildByName("panel"):getChildByName("bg"):getChildByName("progress1"):setContentSize(cc.size(528,29))
end

function warhouseinfo:getArmysCount(index)
    local count = 0
    if self.warInfoData.data:rowCount() >= index then
        count = count + self.warInfoData.data:getLong(index,"b1")
        count = count + self.warInfoData.data:getLong(index,"b2")
        count = count + self.warInfoData.data:getLong(index,"b3")
        count = count + self.warInfoData.data:getLong(index,"b4")
        count = count + self.warInfoData.data:getLong(index,"b5")
        count = count + self.warInfoData.data:getLong(index,"b6")

        count = count + self.warInfoData.data:getLong(index,"q1")
        count = count + self.warInfoData.data:getLong(index,"q2")
        count = count + self.warInfoData.data:getLong(index,"q3")
        count = count + self.warInfoData.data:getLong(index,"q4")
        count = count + self.warInfoData.data:getLong(index,"q5")
        count = count + self.warInfoData.data:getLong(index,"q6")

        count = count + self.warInfoData.data:getLong(index,"g1")
        count = count + self.warInfoData.data:getLong(index,"g2")
        count = count + self.warInfoData.data:getLong(index,"g3")
        count = count + self.warInfoData.data:getLong(index,"g4")
        count = count + self.warInfoData.data:getLong(index,"g5")
        count = count + self.warInfoData.data:getLong(index,"g6")

        count = count + self.warInfoData.data:getLong(index,"w1")
        count = count + self.warInfoData.data:getLong(index,"w2")
        count = count + self.warInfoData.data:getLong(index,"w3")
        count = count + self.warInfoData.data:getLong(index,"w4")
    end
    return count
end

--获取战争详情数据返回
function warhouseinfo:geUnionWarInfoBack(message)
    if message ~= nil then
        self.warInfoData=message
        if self.warInfoData.code ~= 0 then
            dd.mainUI:onShowCodeTips(self.warInfoData.code)
            return
        end        
        self:initWarInfo()
    else
        cclog("message is nil ")
    end
end

--开启军队槽位返回
function warhouseinfo:unlockUnionWarSiteBack(message)
    if(message) then
        if(message.code==0) then
            local contain2=self:getChildByName("contain2")
            local itemModle=contain2:getChildByName("mainArea"):getChildByName("item")
            local listcontain=contain2:getChildByName("mainArea"):getChildByName("listcontain")

            --根据返回的开启位置 找到item 
            local item=listcontain:getItem(message.nSlot-1)
            self:clearItem(item)
            --cclog("=========1111111111111111============"..self.openSites.."---"..self.opennums)
            --如果总槽位数量小于25 则新添加空的需解锁的槽位
            local items_count = table.getn(listcontain:getItems())
            if(items_count<25) then
                self.opennums=self.opennums+1--金币开启的格子数量+1

                local item=itemModle:clone()
                self:drawWarInfoItem(item,items_count+1,self._type)
                listcontain:addChild(item)
                listcontain:refreshView()
            end
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("新槽位开启!"),true)
        else
            dd.mainUI:onShowCodeTips(message.code)
        end
    end
end

--添加槽位通知 成员加入返回
function warhouseinfo:addItemNotify(message)
    cclog("addItemNotify...............")
    local name=message.name
    local uid=message.newuid    
    cclog("name2:"..name..",uid:"..uid.."slot"..message.nSlot)
    
    if uid==0 then--为开启新格子
        dd.currentLayer._widget:onShowTips("\t"..ff.langString("新槽位开启!"),true)
        local contain2=self:getChildByName("contain2")
        local itemModle=contain2:getChildByName("mainArea"):getChildByName("item")
        local listcontain=contain2:getChildByName("mainArea"):getChildByName("listcontain")
        local item=listcontain:getItem(message.nSlot-1)
        self:clearItem(item)

        --如果总槽位数量小于25 则新添加空的需解锁的槽位
        local items_count = table.getn(listcontain:getItems())
        if(items_count<25) then
            self.opennums=self.opennums+1--金币开启的格子数量+1

            local item1=itemModle:clone()
            self:drawWarInfoItem(item1,items_count+1,self._type)
            listcontain:addChild(item1)
            listcontain:refreshView()
        end
    elseif uid < 0 then    
        if self.warInfoData == nil then
            return
        end
        --删除这个槽位
        local index = message.nSlot
        uid = math.abs(uid)
        local data=self.warInfoData.data
        for i=2,self.warInfoData.data:rowCount() do
            if self.warInfoData.data:getLong(i,"uid") == uid then
                cclog("type:"..self._type..","..i..","..(self.openSites-1))
                if self._type == 2 then
                    self:getChildByName("contain2"):getChildByName("mainArea"):getChildByName("listcontain"):removeChildByTag(i)
                    self.warInfoData.data:delRow(i)
                else
                    self.warInfoData.data:delRow(i)
                    local total = self.openSites
                    for j=i,total do
                        local item = self:getChildByName("contain2"):getChildByName("mainArea"):getChildByName("listcontain"):getChildByTag(j)
                        if item ~= nil then
                            self:drawWarInfoItem(item,j,self._type)
                        end
                    end
                end
                
                self:getChildByName("contain2"):getChildByName("mainArea"):getChildByName("listcontain"):refreshView()
                if uid == dd.uid then
                    self._canjoin = true
                    self:updateTime()
                end
                break
            end
        end
    else
        if self.warInfoData == nil then
            return
        end

        local data=self.warInfoData.data
        if data ~= nil then
            local index = 0
            local have = false
            for i=1,self.warInfoData.data:rowCount() do
                if self.warInfoData.data:getLong(i,"uid") == uid then
                    index = i
                    have = true
                    break
                end
            end
            if index == 0 then
                index=data:addRow()
            end
            data:setLong(index,"uid",uid)
            data:setString(index,"name",name)
            data:setLong(index,"face",message.face)

            data:setLong(index,"startTime",message.nStart)
            data:setLong(index,"arrival",message.nArrival)
            data:setString(index,"heroName",message.heroName)
            data:setLong(index,"heroGID",message.nHeroGID)
            data:setLong(index,"heroLevel",message.nHeroGrade)
            
            data:setLong(index,"b1",message.b1)
            data:setLong(index,"b2",message.b2)
            data:setLong(index,"b3",message.b3)
            data:setLong(index,"b4",message.b4)
            data:setLong(index,"b5",message.b5)
            data:setLong(index,"b6",message.b6)

            data:setLong(index,"q1",message.q1)
            data:setLong(index,"q2",message.q2)
            data:setLong(index,"q3",message.q3)
            data:setLong(index,"q4",message.q4)
            data:setLong(index,"q5",message.q5)
            data:setLong(index,"q6",message.q6)

            data:setLong(index,"g1",message.g1)
            data:setLong(index,"g2",message.g2)
            data:setLong(index,"g3",message.g3)
            data:setLong(index,"g4",message.g4)
            data:setLong(index,"g5",message.g5)
            data:setLong(index,"g6",message.g6)

            data:setLong(index,"w1",message.w1)
            data:setLong(index,"w2",message.w2)
            data:setLong(index,"w3",message.w3)
            data:setLong(index,"w4",message.w4)
            data:setLong(index,"w5",message.w5)
            data:setLong(index,"w6",message.w6)

            data:setLong(index,"gInfantryNums",message.gInfantryNums)
            data:setLong(index,"gInfantryLevel",message.gInfantryLevel)
            data:setLong(index,"gCavalryNums",message.gCavalryNums)
            data:setLong(index,"gCavalryLevel",message.gCavalryLevel)
            data:setLong(index,"gArcherNums",message.gArcherNums)
            data:setLong(index,"gArcherLevel",message.gArcherLevel) 
            
            data:setLong(index,"unionJob",message.unionJob) 

            if have == false then
                local item = self:getChildByName("contain2"):getChildByName("mainArea"):getChildByName("listcontain"):getChildByTag(index)
                self:drawWarInfoItem(item,index,self._type)
                listcontain:refreshView()
            end
            if uid == dd.uid then
                self._canjoin = false
                self:updateTime()
            end
        end
    end
end

--验证自己是否在列表中
function warhouseinfo:checkIsInList(uid)
    local l=self.warInfoData.data:rowCount()
    for i=1,l do
        local _uid=self.warInfoData.data:getLong(i,"uid")
        if(uid==_uid) then
            return true
        end
    end
    return false
end

--解锁槽位
function warhouseinfo:unlock(item)
    --使用道具返回
    --local function backSure()
    --self:clearItem(item)

    --if(self.uid~=dd.uid) then
        --不是创建者不能开格子
    --    dd.currentLayer._widget:onShowTips("\t"..ff.langString("只有创建者才能开启!"))
     --   return
    --end

    local index=item.index

    --需要的道具数量计算   开启的格子数量-3(自己和初始化的2个)-联盟科技的加成

    --需要的道具数量 1~n 递增为1
    local needcount=self.opennums+1--需要的道具数量  

    --记录当前操作的行号
    self.index=index

    local function sureUse()
        cmd.unlockUnionWarSite(self.uid,2)
    end

    --判断当前是否有道具 旌旗 1016
    local count=dd.getToolsCount(1016) 
    if(count>=needcount) then--当前道具充足
        cmd.unlockUnionWarSite(self.uid,1)
    else
        dd.currentLayer._widget:onShowSure(ff.langString("道具不足提示"),ff.langString("您的道具不足，但可以直接花费金币完成?\n确定要直接使用金币吗?"),sureUse,true,2)
    end
    --end
    --旌旗
    --[[
    if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
        dd.currentLayer._widget:onShowUseTools("购买道具",1016,1,backSure)
    end ]]
end

--取消攻击
function warhouseinfo.cancelAttack(sender,eventType)
    if eventType==ccui.TouchEventType.ended then
        local function sureCancel()
            local message = ff.net:createMessage()
            ff.net:addCmd(message,0x00000166)
            message:addLong(dd.uid)
            ff.net:rpc(message,false)

            local widget = pop.getDialog("warhouseinfo")
            if widget ~= nil then
                widget:stopAllActions()
            end
            pop.onClosePopDialog("warhouseinfo")            
        end
        --提示
        dd.currentLayer._widget:onShowSure(ff.langString("警告"),ff.langString("确定取消攻击么?"),sureCancel)
    end
end

function warhouseinfo.cancelAttackEx(sender,eventType)
    if eventType==ccui.TouchEventType.ended then
        local function sureCancel()
            local message = ff.net:createMessage()
            ff.net:addCmd(message,0x00000166)
            message:addLong(dd.uid)
            ff.net:rpc(message,false)

            local widget = pop.getDialog("warhouseinfo")
            if widget ~= nil then
                widget:stopAllActions()
            end
            pop.onClosePopDialog("warhouseinfo")            
        end
        --提示
        dd.currentLayer._widget:onShowSure(ff.langString("警告"),ff.langString("由于你是集结攻击发起者，退出驻守后所有成员都将退出据点防守，是否确定要撤离？"),sureCancel)
    end
end

function warhouseinfo.BuBing(sender,eventType)
    if eventType==ccui.TouchEventType.ended then
        local widget = pop.getDialog("warhouseinfo")
        if widget == nil then
            return
        end
         if widget:checkIsInList(dd.uid) == false then
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("您不在队伍里!"))
            return
         end
        local params = {}
        params.cid = widget.site
        cclog("=====111111111111111======="..widget.site)
        params.uid = widget.uid
        params.unionid = dd.myUnion:getLong(1,"unionid")
        params.short =dd.myUnion:getString(1,"unionflag") 
        params.ulevel=dd.myUnion:getLong(1,"level")
        params.name = dd.myUnion:getString(1,"unionname")  
        params.level= dd.myinfo:getLong(1,"level")

        params.count=0
        params.res  = 0
        params.friend=0
        params.protect=0
        params.maxarmys = widget.warInfoData.maxSoldiers - widget.warInfoData.currentSoldiers

        --打开出征界面
        pop.onShowPopDialog("chuzhen",12,params)
    end
end

--增援
function warhouseinfo.zengyuan(sender,eventType)
    if eventType==ccui.TouchEventType.ended then
        local widget=pop.getDialog("warhouseinfo")
        if widget ~= nil and dd.uid ~= widget.uid then
            local params = {}
            params.cid = widget.site--坐标
            params.uid = widget.uid--攻击目标 被攻击人
            params.unionid = dd.myUnion:getLong(1,"unionid")
            params.short =dd.myUnion:getString(1,"unionflag") 
            params.ulevel=dd.myUnion:getLong(1,"level")
            params.name = dd.myUnion:getString(1,"unionname")  
            params.level= dd.myinfo:getLong(1,"level")

            params.count=0
            params.res  = 0
            params.friend=0
            params.protect=0

            --打开出征界面
            pop.onShowPopDialog("chuzhen",4,params)
        end
    end
end


--设置状态为出征 不可取消攻击 不可加入和open 和遣返
function warhouseinfo:setStatus(item)
    --item:getChildByName("panel"):getChildByName("cancelbtn"):setVisible(false)
    --item:getChildByName("panel"):getChildByName("cancelbtn"):setTouchEnabled(false)

    item:getChildByName("panel"):getChildByName("panel"):getChildByName("label"):setString(ff.langString("出征中"))
    

    local listcontain=self:getChildByName("contain2"):getChildByName("mainArea"):getChildByName("listcontain") 
    local tab=listcontain:getChildren()
    for i,item in ipairs(tab) do
        item:getChildByName("btn_join"):setTouchEnabled(false)
    end
end

--加入队伍
function warhouseinfo:addToTeam(item,index)
    if(dd.uid==self.uid) then--发起人是自己
        dd.currentLayer._widget:onShowTips("\t"..ff.langString("您不能加入!"))
        return
    end
    local params = {}
    params.cid = dd.mycity:getLong(1,"cid")
    params.uid = self.uid
    params.unionid = dd.myUnion:getLong(1,"unionid")
    params.short =dd.myUnion:getString(1,"unionflag") 
    params.ulevel=dd.myUnion:getLong(1,"level")
    params.name = dd.myUnion:getString(1,"unionname")  
    params.level= dd.myinfo:getLong(1,"level")

    params.count=0
    params.res  = 0
    params.friend=0
    params.protect=0
    params.maxarmys = self.warInfoData.maxSoldiers - self.warInfoData.currentSoldiers

    --打开出征界面
    pop.onShowPopDialog("chuzhen",15,params)
end


--设置为空栏位(加入)
function warhouseinfo:clearItem(item)
    if item == nil then
        return
    end
    item:getChildByName("zengyuan"):setVisible(false)
    item:getChildByName("nums"):setVisible(false)
    item:getChildByName("infobtn"):setVisible(false)
    item:getChildByName("infobtn"):setTouchEnabled(false)
    item:getChildByName("chu_emptysite"):setVisible(true)
    item:getChildByName("needitempanel"):setVisible(false)
    item:getChildByName("panelname"):setVisible(false)
    item:getChildByName("panel"):setVisible(false)
    item:getChildByName("zengyuanbtn"):setTouchEnabled(false)

    item:getChildByName("btn_join"):setVisible(true)
    item:getChildByName("btn_open"):setVisible(false)
        
    item:getChildByName("btn_join"):setTouchEnabled(true)
    item:getChildByName("btn_join"):getChildByName("chu_label"):setString(ff.langString("加入"))
    item:getChildByName("btn_join"):setBright(self._canjoin)

    --加入
    local function fun(sender,eventType)
        local doaction = false
        if eventType == ccui.TouchEventType.canceled then
            local startp = sender:getTouchBeganPosition()
            local endp   = sender:getTouchEndPosition()
            if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                doaction = true
            end
        end

        if eventType == ccui.TouchEventType.ended then
            doaction = true
        end

        if doaction == true then
            if(self:checkIsInList(dd.uid)) then
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("您已经加入!"))
            else
                --加入
                self:addToTeam(item)
            end
        end
    end

    item:getChildByName("btn_join"):addTouchEventListener(fun)
end
        
--打开士兵详情
function warhouseinfo.openSoilderInfo(sender,eventtype)
    if eventtype==ccui.TouchEventType.ended then
        local widget=pop.getDialog("warhouseinfo")  
        if widget ~= nil then
            widget:initSoilderInfo(sender:getTag())
        end
    end
end

--送回士兵(只有ui演示 服务端未做接口)
function warhouseinfo.callBackSoilder(uid)
    cclog("callBackSoilder:"..uid)
    local function sureCancel()
        --遣返
        local message = ff.net:createMessage()
        ff.net:addCmd(message,0x00000167)
        message:addLong(dd.uid)
        message:addLong(uid)
        ff.net:rpc(message,false)
    end
    dd.currentLayer._widget:onShowSure(ff.langString("警告"),ff.langString("确定送回该队伍么?"),sureCancel)
end

--初始化士兵详情
function warhouseinfo:initSoilderInfo(row)
    if row > self.warInfoData.data:rowCount() then
        return
    end

    local view = self:getChildByName("armyInfo"):getChildByName("view")
    
    local count = 0
    count = count + self.warInfoData.data:getLong(row,"b1")
    count = count + self.warInfoData.data:getLong(row,"b2")
    count = count + self.warInfoData.data:getLong(row,"b3")
    count = count + self.warInfoData.data:getLong(row,"b4")
    count = count + self.warInfoData.data:getLong(row,"b5")
    count = count + self.warInfoData.data:getLong(row,"b6")

    count = count + self.warInfoData.data:getLong(row,"q1")
    count = count + self.warInfoData.data:getLong(row,"q2")
    count = count + self.warInfoData.data:getLong(row,"q3")
    count = count + self.warInfoData.data:getLong(row,"q4")
    count = count + self.warInfoData.data:getLong(row,"q5")
    count = count + self.warInfoData.data:getLong(row,"q6")

    count = count + self.warInfoData.data:getLong(row,"g1")
    count = count + self.warInfoData.data:getLong(row,"g2")
    count = count + self.warInfoData.data:getLong(row,"g3")
    count = count + self.warInfoData.data:getLong(row,"g4")
    count = count + self.warInfoData.data:getLong(row,"g5")
    count = count + self.warInfoData.data:getLong(row,"g6")

    count = count + self.warInfoData.data:getLong(row,"w1")
    count = count + self.warInfoData.data:getLong(row,"w2")
    count = count + self.warInfoData.data:getLong(row,"w3")
    count = count + self.warInfoData.data:getLong(row,"w4")
    view:getChildByName("num_text"):setString(ff.getFormatMoney(count))
    view:getChildByName("chu_title"):setString(ff.langString("{0}的军队",{self.warInfoData.data:getString(row,'name')}))       

    self:loadArmys(row, view) 
    self:getChildByName("armyInfo"):setVisible(true)
    self:getChildByName("armyInfo"):runAction(cc.MoveTo:create(0.5, cc.p(0, 0)))
end

function warhouseinfo:loadArmys(row, view )
    local hid =  self.warInfoData.data:getLong(row,"heroGID")
    local level= self.warInfoData.data:getLong(row,"heroLevel")

    local num = 0
    local lists = view:getChildByName("list")
    for i=1,6 do
        local col = 7 - i
        if self.warInfoData.data:getLong(row,"b"..col) > 0 then
            num = num + 1
        end
        if self.warInfoData.data:getLong(row,"q"..col) > 0 then
            num = num + 1
        end
        if self.warInfoData.data:getLong(row,"g"..col) > 0 then
            num = num + 1
        end
        if col<=4 and self.warInfoData.data:getLong(row,"w"..col) > 0 then
            num = num + 1
        end        
    end
    if hid > 0 then
        num = num + 1
    end 

    --设置控件
    local line = math.ceil(num/3)
    cclog("num:"..num.." line:"..line)
    local hh = 0
    if line >= 2 then
        hh   = 270 * 2 + 3 * 13
    else
        hh   = 270 + 2 * 13
    end

    local total = hh + 100
    local addhh = 0
    if self.warInfoData.status == 3 and self.warInfoData.data:getLong(row,"uid") == dd.uid then
        view:getChildByName("oper"):setVisible(true)
        if row == 1 then
            view:getChildByName("oper"):getChildByName("cancel"):setVisible(true)
        else
            view:getChildByName("oper"):getChildByName("cancel"):setVisible(false)
        end
        view:getChildByName("oper"):getChildByName("cancel"):setTag(row)
        view:getChildByName("oper"):getChildByName("join"):setTag(row)
        total = total+ 120
        addhh = 120
    else
        view:getChildByName("oper"):setVisible(false)
    end
    cclog("total:"..total)   
    view:setContentSize(cc.size(720,total))     
    view:getChildByName("back"):setContentSize(cc.size(720,total))

    local offY = 172
    if line >= 2 then
        lists:setContentSize(cc.size(720,270 * 2 + 3 * 13 - 3 + addhh))
        view:getChildByName("mainBg"):setContentSize(cc.size(720,270 * 2 + 3 * 13 + addhh))
        offY = 178
    else
        lists:setContentSize(cc.size(720,270 + 2 * 13 - 3+ addhh))
        view:getChildByName("mainBg"):setContentSize(cc.size(720,270 + 2 * 13+ addhh))
    end
    lists:setInnerContainerSize(cc.size(720,270 * line + (line + 1) * 13+ addhh))

    --重新排列
    num = 0
    local yline = 1
    if hid > 0 then
        cclog("hero name:"..hid)
        local name = ""
        if self.warInfoData.data:getString(row,"heroName") == "" then
            name = ff.langString(dd.cfgHero[hid]['name'])
        else
            name = ff.langString(self.warInfoData.data:getString(row,"heroName"))
        end
        
        local item = view:getChildByName("armyItem"):clone()
        item:setVisible(true)
        item:setTag(hid)
        item:getChildByName("nums"):setString("LV."..level)
        item:getChildByName("icon"):loadTexture(dd.getHeroIcon(hid),0)
        item:getChildByName("star"):setVisible(false)
        item:getChildByName("name_text"):setString(name)
 
        lists:addChild(item)
        --暂时都放第一排
        local xx = 110 + 15 
        local yy = (line - yline) * 280 + offY+ addhh
        item:setPosition(cc.p(xx,yy))
        num = num + 1
        yline = math.ceil(num/3)
    end
   
    local function addItem(star,sid,count)
        cclog("addItem sid:"..sid)
        local item = view:getChildByName("armyItem"):clone()
        item:setTag(sid)
        item:setVisible(true)
        item:getChildByName("star"):setVisible(true)
        item:getChildByName("nums"):setString(ff.getFormatMoney(count))
        item:getChildByName("icon"):loadTexture(dd.getArmyIcon(sid),0)
        lists:addChild(item)
        local str = ""
        for i=1,star do
            str = str.."0"
        end
        item:getChildByName("star"):setString(str)
        --暂时都放第一排
        local xx = num%3 * 220 + 15 * (num%3 + 1) + 110
        local yy = (line - yline) * 280 + offY+ addhh
        item:setPosition(cc.p(xx,yy))
        num = num + 1
        yline = math.ceil(num/3)
        if num%3 == 0 then
            yline = yline + 1
        end
    end

    for i=1,6 do
        local col = 7 - i
        if self.warInfoData.data:getLong(row,"b"..col) > 0 then
            addItem(col,dd.cfgSoldierIndex2["b"..col],self.warInfoData.data:getLong(row,"b"..col))
        end
        if self.warInfoData.data:getLong(row,"q"..col) > 0 then
            addItem(col,dd.cfgSoldierIndex2["q"..col],self.warInfoData.data:getLong(row,"q"..col))
        end
        if self.warInfoData.data:getLong(row,"g"..col) > 0 then
            addItem(col,dd.cfgSoldierIndex2["g"..col],self.warInfoData.data:getLong(row,"g"..col))
        end
        if col<=4 and self.warInfoData.data:getLong(row,"w"..col) > 0 then
            addItem(col,dd.cfgSoldierIndex2["w"..col],self.warInfoData.data:getLong(row,"w"..col))
        end        
    end
end

function warhouseinfo.onBefore(sender)
    ff.net:bindProperty(2231,"gold",sender.updateGold)
    dd.initGoldSpine(sender:getChildByName("top"):getChildByName("icon"),sender:getChildByName("top"):getChildByName("addgold"))     
    return true
end

function warhouseinfo.onEnd(sender)
    sender:getChildByName("armyInfo"):setVisible(false)
    dd.delBackEvent(sender.onReturn)
    ff.net:unbindProperty("gold",2231)
    if sender.warInfoData then
        if sender.warInfoData.data then
            sender.warInfoData.data:clear()
            sender.warInfoData.data=nil
        end
        sender.warInfoData=nil
    end
    sender:stopAllActions()
    sender:removeListener()
    sender:getChildByName("contain2"):getChildByName("mainArea"):getChildByName("listcontain"):removeAllChildren()
end

--关闭
--[[function warhouseinfo.onClose(sender,eventtype)
    if eventtype==ccui.TouchEventType.ended then  
        local widget=pop.getDialog("warhouseinfo")
        if widget ~= nil then
            widget:close()
        end
    end
end

function warhouseinfo:close()
    pop.onClosePopDialog("warhouseinfo")    
end]]
--关闭
function warhouseinfo.onReturn( sender, eventType )
    local widget = pop.getDialog("warhouseinfo")

    local close = false
    local view = nil
    if widget ~= nil then
        view = widget:getChildByName("armyInfo")
    end
    if sender == nil then
        close = true
    end
    if eventType == ccui.TouchEventType.ended then
        close = true
    end

    if close == true then
        if view ~= nil then
            view:getChildByName("view"):getChildByName("list"):removeAllChildren()
            if view:isVisible() then
                view:setVisible(false)
                view:setPosition(cc.p(0, -view:getContentSize().height))
            else
                pop.onClosePopDialog("warhouseinfo")
            end
        else
            pop.onClosePopDialog("warhouseinfo")
        end
    end
end

--添加事件监听
function warhouseinfo:addListener()
    --查询联盟战争详情
    ff.net:registerEvent(2,dd.Tjf_getUnionWarInfo,function (message) self:geUnionWarInfoBack(message)  end)
    --开启军队槽位
    ff.net:registerEvent(2,dd.Tjf_unlockUnionWarSite,function (message) self:unlockUnionWarSiteBack(message)  end)
    --槽位添加通知 新成员加入
    ff.net:registerEvent(2,dd.Tjf_unionWarAddItemNotify,function (message) self:addItemNotify(message)  end)
    ff.net:registerEvent(2,dd.Tjf_unionWarAllyWarReturn,function (params) self:onUnionWarAllyWarReturn(params)  end)
    ff.net:registerEvent(2,dd.Tjf_unionWarNotify,self.exitBattle)
end

function warhouseinfo.exitBattle(params)
    local code = params[1]
    local id   = params[2]
    cclog("code:"..code..",id:"..id)
    if code == 1 or code == 2 then
        local widget = pop.getDialog("warhouseinfo")
        if widget ~= nil then
            if widget.warInfoData ~= nil  and widget.warInfoData.data:getLong(1,"uid") == id then
                if code == 2 then
                    dd.currentLayer._widget:onShowTips("\t"..ff.langString("本次联合攻击被取消"))            
                else
                    dd.currentLayer._widget:onShowTips("\t"..ff.langString("本次联合攻击结束"))            
                end
                            
            end
            widget:stopAllActions()
            pop.onClosePopDialog("warhouseinfo")
        end
    end
end
--移除事件监听
function warhouseinfo:removeListener()
    ff.net:removeEvent(2,dd.Tjf_unionWarAddItemNotify)
    ff.net:removeEvent(2,dd.Tjf_unlockUnionWarSite)
    ff.net:removeEvent(2,dd.Tjf_getUnionWarInfo)
    ff.net:removeEvent(2,dd.Tjf_unionWarAllyWarReturn)
    ff.net:removeEvent(2,dd.Tjf_unionWarNotify)
end

function warhouseinfo:onUnionWarAllyWarReturn(params)
    local code = params[1]
    if code ~= 0 then
        dd.mainUI:onShowCodeTips(code)
    else
        local uid = params[2]
    end
end

function warhouseinfo:doAutoSize()
    if self._init == false then

        self:setContentSize(cc.size(720,ff.height - 214))
        self:getChildByName("bg"):setContentSize(cc.size(720,ff.height - 214))

        local hh = ff.height - 214 - 105

        local contain2=self:getChildByName("contain2")
        contain2:setContentSize(cc.size(720,hh))
        contain2:setPositionY(0)
        
        contain2:getChildByName("mainArea"):setContentSize(cc.size(720,hh))
        contain2:getChildByName("mainArea"):setPositionY(0)

        local info=contain2:getChildByName("mainArea"):getChildByName("info")
        info:setPositionY(hh - 140)

        listcontain=contain2:getChildByName("mainArea"):getChildByName("listcontain")
        listcontain:setContentSize(cc.size(720,hh - 200 - 4))
        listcontain:setPositionY(4)

        self:getChildByName("top"):setPositionY(ff.height - 214 -105)
        self:getChildByName("top"):getChildByName("addgold"):addTouchEventListener(dd.onPay)
    
        local btnClose = self:getChildByName("armyInfo"):getChildByName("view"):getChildByName("close")
        --[[local function closeArmys(sender, eventType)
            self:getChildByName("armyInfo"):setVisible(false)
            self:getChildByName("armyInfo"):setPosition(cc.p(0, -self:getChildByName("armyInfo"):getContentSize().height))
            self:getChildByName("armyInfo"):getChildByName("view"):getChildByName("list"):removeAllChildren()
        end]]
        btnClose:addTouchEventListener(self.onReturn) --closeArmys)
        self:getChildByName("armyInfo"):getChildByName("view"):getChildByName("oper"):getChildByName("cancel"):addTouchEventListener(self.cancelAttackEx)
        self:getChildByName("armyInfo"):getChildByName("view"):getChildByName("oper"):getChildByName("join"):addTouchEventListener(self.BuBing)
        self:getChildByName("armyInfo"):getChildByName("view"):getChildByName("oper"):getChildByName("cancel"):getChildByName("Label"):setString(ff.langString("撤回"))
        self:getChildByName("armyInfo"):getChildByName("view"):getChildByName("oper"):getChildByName("join"):getChildByName("Label"):setString(ff.langString("部队补充"))
        self:getChildByName("armyInfo"):setVisible(false)
        self:getChildByName("armyInfo"):setPosition(cc.p(0, -self:getChildByName("armyInfo"):getContentSize().height))

        self._init = true
    end
end

--显示战争详情
--uid 发起人id
--warType 1=主动攻击  2=被联盟攻击
--attackedName 攻击目标名称  
--attackedUnionFlag 攻击目标联盟简称
function onShowWarInfo(widget,uid,warType,attackedName,attackedUnionFlag)
    local layer = warhouseinfo.extend(widget)
    dd.regeditBackEvent(layer.onReturn)  
    layer:init(warType,uid,attackedName,attackedUnionFlag)
    return layer
end