--helpList
local helpListLayer = class("helpList")
helpListLayer._name = "helpList"
helpListLayer._init = false
helpListLayer.cfgHelpList = {}
helpListLayer.tIndex = 1
helpListLayer._type = 1
helpListLayer._items = {}
helpListLayer._items2 = {}
helpListLayer._maxDisc = 12

function helpListLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, helpListLayer)
    return target
end

function helpListLayer:onAutoSize()
    if self._init == false then 
        local hh = ff.height
        self:setContentSize(cc.size(720,hh))
        self:getChildByName("bg"):setContentSize(cc.size(720,hh-105))
        self:getChildByName("bg"):setPositionY(0)
        
        self:getChildByName("topArea"):setPositionY(hh - 105)
        
        self:getChildByName("mainArea"):setContentSize(cc.size(720,hh-105))
        self:getChildByName("mainArea"):getChildByName("list"):setContentSize(cc.size(720,hh-105 - 8))
        self:getChildByName("mainArea"):getChildByName("list2"):setContentSize(cc.size(720,hh-105 - 8))
        self:getChildByName("mainArea"):getChildByName("tips"):setContentSize(cc.size(720,hh-105 - 8))
        self:getChildByName("mainArea"):getChildByName("tips"):getChildByName("chu_title"):setPositionY(hh-105 - 50)
        self:getChildByName("mainArea"):getChildByName("tips"):getChildByName("bg"):setContentSize(cc.size(660,hh-105 - 60))
        self:getChildByName("mainArea"):getChildByName("tips"):getChildByName("bg"):setPositionX(30)
        self:getChildByName("mainArea"):getChildByName("tips"):getChildByName("bg"):setPositionY(40)

        self:getChildByName("mainArea"):getChildByName("tips"):getChildByName("lists"):setContentSize(cc.size(640,hh-105 - 8 - 160))
        self:getChildByName("mainArea"):getChildByName("tips"):getChildByName("lists"):setPositionY(80)
    end
end

function helpListLayer:onInit()
    if self._init == false then        
        self:getChildByName("topArea"):getChildByName("backbtn"):addTouchEventListener(self.onBack)
        self:getChildByName("topArea"):getChildByName("addbtn"):addTouchEventListener(dd.onPay)
        self:getChildByName("topArea"):getChildByName("title"):getChildByName("chu_title"):getVirtualRenderer():enableOutline(cc.c4b(0,0,0,255),3)
        --加粗
        self:getChildByName("mainArea"):getChildByName("tips"):getChildByName("chu_title"):getVirtualRenderer():enableBold(true)
        self:getChildByName("mainArea"):getChildByName("itemmode2"):getChildByName("chu_name"):getVirtualRenderer():enableBold(true)
        self:initCfg()
        self._init = true
    end
    self.updateGold()
end

function helpListLayer:initCfg()
    local help = ff.dbmanager:sql_fetch_rows("select * from cfg_howtoplay")
    for i=1, help:rowCount() do
        local id = tonumber(help:getString(i, "id"))
        self.cfgHelpList[id] = {}
        self.cfgHelpList[id]['type'] = tonumber(help:getString(i, "type"))
        self.cfgHelpList[id]['littletype'] = tonumber(help:getString(i, "littletype"))
        self.cfgHelpList[id]['pic'] = tonumber(help:getString(i, "pic"))
        if ff.lang == -1 then
            self.cfgHelpList[id]['name'] = help:getString(i, "name")
            for k=1,self._maxDisc do
                self.cfgHelpList[id]['disc'..k] = help:getString(i, "disc"..k)
            end  
        else
            self.cfgHelpList[id]['name'] = tonumber(help:getString(i, "name_lan"))
            for k=1,self._maxDisc do
                self.cfgHelpList[id]['disc'..k] = tonumber(help:getString(i, "disc"..k.."_lan"))
            end  
        end    
    end
    help:clear()
end

function helpListLayer.updateGold()
    local widget = pop.getDialog("helpList")
    widget:getChildByName("topArea"):getChildByName("money"):setString(dd.gold())
    widget:getChildByName("topArea"):requestDoLayout()

    local w = widget:getChildByName("topArea"):getChildByName("money"):getContentSize().width
    w = 720 - (w + 94 + 75 + 104)
    widget:getChildByName("topArea"):getChildByName("title"):setContentSize(cc.size(w,100))
    widget:getChildByName("topArea"):getChildByName("title"):requestDoLayout()
end

function helpListLayer:updateBigType()
    self:getChildByName("mainArea"):getChildByName("list"):setVisible(true)
    self:getChildByName("mainArea"):getChildByName("list2"):setVisible(false)
    self:getChildByName("mainArea"):getChildByName("tips"):setVisible(false)
    self:getChildByName("mainArea"):getChildByName("list"):jumpToTop()
    self.tIndex = 1
    for i,v in ipairs(self._items) do
        if tolua.isnull(v) then
            self._items[i] = nil
        else
            v:setVisible(false)
            v:setTag(i)
        end
    end
    
    local hh = 0
	local arr = {"建筑介绍","热门问题","联盟","账号问题","付费问题"}	
    local max = table.getn(arr)
    hh = max*150
    
    if hh < self:getChildByName("mainArea"):getChildByName("list"):getContentSize().height then
        hh = self:getChildByName("mainArea"):getChildByName("list"):getContentSize().height
    end    
    self:getChildByName("mainArea"):getChildByName("list"):setInnerContainerSize(cc.size(720,hh))
	for i=1, table.getn(arr) do
        local item = self._items[i]
        if item == nil then
            item = self:getChildByName("mainArea"):getChildByName("itemmode"):clone()
            self._items[i] = item
            self:getChildByName("mainArea"):getChildByName("list"):addChild(item)
        end  
        item:getChildByName("name"):setString(ff.langString(arr[i]))
        item:setVisible(true)
        item:setTag(i)
        item:setPositionX(360)
        item:setPositionY(hh-80-150*(i-1))
        item:getChildByName("icon"):loadTexture(self.getTypeIcon(i),0)
        item:addTouchEventListener(self.clickBigType)
        --item:getChildByName("gobtn"):addTouchEventListener(self.clickBigType)
	end
end

function helpListLayer:updateSmallType(type)
    self:getChildByName("mainArea"):getChildByName("list"):setVisible(false)
    self:getChildByName("mainArea"):getChildByName("list2"):setVisible(true)
    self:getChildByName("mainArea"):getChildByName("tips"):setVisible(false)
    self:getChildByName("mainArea"):getChildByName("list2"):jumpToTop()
    local count = 1
    local hh = 0
    local max = 0
    for i,v in ipairs(self._items2) do
        if tolua.isnull(v) then
            self._items2[i] = nil
        else
            v:setVisible(false)
            v:setTag(i)
        end
    end
    for id, v in pairs(self.cfgHelpList) do
        if v["type"] == type then 
             max = max + 1
        end
    end
    hh = max*150
    if hh < self:getChildByName("mainArea"):getChildByName("list2"):getContentSize().height then
        hh = self:getChildByName("mainArea"):getChildByName("list2"):getContentSize().height
    end
    self:getChildByName("mainArea"):getChildByName("list2"):setInnerContainerSize(cc.size(720,hh))
    self.tIndex = 2
    self._type = type
    for id, v in pairs(self.cfgHelpList) do
        if v["type"] == type then 
            local item = self._items2[count]
            if item == nil then
                item = self:getChildByName("mainArea"):getChildByName("itemmode2"):clone()
                self._items2[count] = item
                self:getChildByName("mainArea"):getChildByName("list2"):addChild(item)
            end                 
            item:getChildByName("chu_name"):setString(ff.langString(v["name"]))
            item:setVisible(true)
            item:setTag(id)
            item:setPositionX(360)
            item:setPositionY(hh-75-150*(count-1))
            --item:getChildByName("icon"):loadTexture(self:getHelpIcon(id),0)
            item:addTouchEventListener(self.clickSmallType)      
            count = count + 1      
        end
    end
end

function helpListLayer:updateTips(id)
    self:getChildByName("mainArea"):getChildByName("list"):setVisible(false)
    self:getChildByName("mainArea"):getChildByName("list2"):setVisible(false)
    self:getChildByName("mainArea"):getChildByName("tips"):setVisible(true)
    self.tIndex = 3

    self:getChildByName("mainArea"):getChildByName("tips"):getChildByName("chu_title"):setString(ff.langString(self.cfgHelpList[id]["name"]))
    self:getChildByName("mainArea"):getChildByName("tips"):getChildByName("lists"):removeAllChildren(true)

    local hh = self:getChildByName("mainArea"):getChildByName("tips"):getContentSize().height
    if self.cfgHelpList[id] ~= nil then
        for i=1,self._maxDisc do
            if tonumber(self.cfgHelpList[id]['disc'..i]) ~= 0 then                
                local richText = ccui.RichText:create()
                richText:ignoreContentAdaptWithSize(false)
                richText:setContentSize(cc.size(580,960)) 
                richText:setAutoHeight()

                local str = ff.langString(self.cfgHelpList[id]['disc'..i])
                local chat = ccui.RichElementText:create(1, cc.c3b(161, 175, 175), 255, str, "Helvetica", 26)
                richText:insertElement(chat,0)
                richText:formatText()
                self:getChildByName("mainArea"):getChildByName("tips"):getChildByName("lists"):addChild(richText)
            end        
        end
    end
    self:getChildByName("mainArea"):getChildByName("tips"):getChildByName("lists"):refreshView()
end

function helpListLayer.clickBigType(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end

    if eventType==ccui.TouchEventType.ended then    
        doaction = true
    end
    if doaction == true then
        AudioEngine.playEffect(ff.sounds[109])
        local widget = pop.getDialog("helpList")
        widget:updateSmallType(sender:getTag())
    end
end

function helpListLayer.clickSmallType(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end

    if eventType==ccui.TouchEventType.ended then    
        doaction = true
    end
    if doaction == true then
        AudioEngine.playEffect(ff.sounds[109])
        local widget = pop.getDialog("helpList")
        widget:updateTips(sender:getTag())
    end
end

function helpListLayer:getHelpIcon(id)
    if self.cfgHelpList[id] ~= nil then
        return "images/icon/helplist/"..self.cfgHelpList[id]["pic"]..".png"
    else
        return "images/icon/helplist/101.png"
    end
end
function helpListLayer.getTypeIcon(type)
    if type == 1 then
        return "images/icon/helplist/101.png"
    elseif type == 2 then
        return "images/icon/helplist/201.png"
    elseif type == 3 then
        return "images/icon/helplist/301.png"
    elseif type == 4 then
        return "images/icon/helplist/401.png"
    elseif type == 5 then
        return "images/icon/helplist/501.png"
    end
end

--接口
function helpListLayer.onBack(sender,eventType)
    if eventType==ccui.TouchEventType.ended then     
        local widget = pop.getDialog("helpList")
        if widget.tIndex == 1 then
            pop.onClosePopDialog("helpList")
        elseif widget.tIndex == 2 then
            widget:updateBigType()
        elseif widget.tIndex == 3 then
            widget:updateSmallType(widget._type)
        end
    end
end

function helpListLayer.onStart(sender)
    ff.net:bindProperty(2511,"gold",sender.updateGold)
    sender:updateBigType()
end
function helpListLayer.onBefore(sender)
    dd.initGoldSpine(sender:getChildByName("topArea"):getChildByName("gold"),sender:getChildByName("topArea"):getChildByName("addbtn"))
    return true
end
function helpListLayer.onEnd(sender)
    dd.delBackEvent()
    ff.net:unbindProperty("gold",2511)
    if ff.platform ~= 1 then
        for i,item in ipairs(sender._items) do
            if item ~= nil then
                item:getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
            end
        end
    end
end

function helpListLayer.onReturn(sender,eventType)
    local widget = pop.getDialog("helpList")
    if widget.tIndex == 1 then
        pop.onClosePopDialog("helpList")
    elseif widget.tIndex == 2 then
        widget:updateBigType()
    elseif widget.tIndex == 3 then
        widget:updateSmallType(widget._type)
    end
end

function onShowHelpList(widget)
    local layer = helpListLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)
    layer:onAutoSize()
    layer:onInit()
    return layer
end