--reward
local rewardLayer = class("reward")
rewardLayer._name = "reward"
rewardLayer._init = false
rewardLayer._rewards = {}
rewardLayer._title   = ""
rewardLayer._share   = false
rewardLayer._getShare= false
rewardLayer._friends = {}
--[[
1   道具  道具编号    数量  
2   石   0   数量  
3   木   0   数量  
4   铁   0   数量  
5   粮   0   数量  
6   银币  0   数量  
7   金币  0   数量  
8   士兵  兵种编号    数量  
9   英雄经验    0   数量  
10  联盟贡献    0   数量  
11  VIP点数   0   数量  
12  联盟礼物
（联盟掉落）  礼物编号    数量  
13  联盟商店
（联盟掉落）  道具编号    数量  
14  联盟基金
（联盟掉落）  0   数量  
15  晶体  配置编号    数量  
--]]

function rewardLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, rewardLayer)
    return target
end

function rewardLayer:onAutoSize(type)
    if type == nil then
        type = 0 
    end
    local hh = ff.height
    local count = table.getn(self._rewards)
    local row = math.ceil(count/5)
    local rhh = 0
    if type == 1 then
        row = math.ceil(table.getn(self._friends)/5)
    end
    if row < 1 then
        row = 1
    end
    if row > 2 then
        row = 2
    end 

    rhh = 120 + 260 + row*165
    local shareh = 0
    if self._share == true then
        shareh = 40
    end
    self:setContentSize(cc.size(720,rhh + shareh))
    
    self:getChildByName("back1"):setContentSize(720,rhh + shareh)
    self:getChildByName("back1"):setPositionY(0)    
    self:getChildByName("back2"):setContentSize(cc.size(720,190 + row*165 + shareh))
    self:getChildByName("back2"):setPositionY(120)    
    self:getChildByName("top"):setPositionY(rhh + shareh - 260)
    --self:getChildByName("share"):setPositionY(120)
    self:getChildByName("touch"):setContentSize(cc.size(720,190 + row*165 + shareh))
    self:getChildByName("touch"):setPositionY(0)

    if type == 0 then
        self:getChildByName("list"):setContentSize(cc.size(720,row*165 + shareh))
        self:getChildByName("list"):setPositionY(120 + shareh)
    else
        self:getChildByName("friends"):setContentSize(cc.size(720,row*165 + shareh))
        self:getChildByName("friends"):setPositionY(120 + shareh)
    end    

    
    cclog("row == "..row)
    self:getChildByName("masking"):setContentSize(cc.size(720,hh))
    self:getChildByName("masking"):setPositionY(-214)
    --居中显示  effect 99
    self:setPositionY(214)
end

function rewardLayer:onInit()
    if self._init == false then   
        local function clickShare(sender,eventType)
            if eventType==ccui.TouchEventType.ended then    
                if self:getChildByName("share"):getChildByName("share"):getSelectedState() == true then
                    self:getChildByName("share"):getChildByName("share"):setSelectedState(false)
                else
                    self:getChildByName("share"):getChildByName("share"):setSelectedState(true)
                end
            end
        end
        local function close(sender, eventType)
            if eventType==ccui.TouchEventType.ended then    
                self:playDropAct() 
                cclog("sender:"..sender:getName())
                if sender:getName() == "confirm" then
                    if self._share == true then
                        if self:getChildByName("share"):getChildByName("share"):getSelectedState() == true then
                            local ids = ""
                            if table.getn(self._friends) > 0 then
                                for i=1,table.getn(self._friends) do
                                    local item = self:getChildByName("friends"):getChildByTag(i)
                                    if item:getChildByName("share"):getSelectedState() == true then
                                        if ids == "" then
                                            ids = self._friends[i]['id']
                                        else
                                            ids = ids..","..self._friends[i]['id']
                                        end
                                    end
                                end
                            end
                            platform_facebookLink(ids,ff.langString("fb共享语句"),self._getShare)
                        end
                    end
                end
                pop.onClosePopDialog("reward")
            end
        end
        local function clickItem(sender, eventType)
            local doaction = false
            if eventType == ccui.TouchEventType.canceled then
                local startp = sender:getTouchBeganPosition()
                local endp   = sender:getTouchEndPosition()
                if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                    doaction = true
                end
            end

            if eventType==ccui.TouchEventType.ended then    
                doaction = true
            end
            if doaction == true then
                if self:getChildByName("friends"):isVisible() == false then
                    local index = sender:getTag()
                    local pos   = self:getWorldPos(sender)
                    pos = self:convertToNodeSpace(pos)
                    pos = cc.p(pos.x + 68,pos.y + 140)
                    self:showTips(self._rewards[index]["type"], self._rewards[index]["id"], self._rewards[index]["count"], pos)
                end                    
            end
        end
        self:getChildByName("top"):getChildByName("close"):addTouchEventListener(close)
        self:getChildByName("confirm"):addTouchEventListener(close)
        self:getChildByName("itemmode"):addTouchEventListener(clickItem)
        self:getChildByName("share"):getChildByName("tips"):addTouchEventListener(clickShare)
        local function onTouchBegan(touch, event)
            self:unshowTips()
            return false
        end
        local listener = cc.EventListenerTouchOneByOne:create()
        listener:registerScriptHandler(onTouchBegan,cc.Handler.EVENT_TOUCH_BEGAN)
        --listener:setSwallowTouches(true)
        self:getChildByName("touch"):getEventDispatcher():addEventListenerWithSceneGraphPriority(listener,self:getChildByName("touch"))
        
        --加粗
        self:getChildByName("top"):getChildByName("chu_title"):getVirtualRenderer():enableBold(true)

        --共享
        self:getChildByName("share"):getChildByName("friends"):addTouchEventListener(self.showFriends)
        self._init = true
    end    
    --共享
    self:getChildByName("share"):setVisible(false)
    self:getChildByName("friends"):setVisible(false)
    self:getChildByName("list"):setVisible(true)

    self:getChildByName("top"):getChildByName("chu_title"):setString(self._title)
    self:updateList()

    self._getShare = false
    self._friends  = {}
    if self._share == true then
        self:getChildByName("share"):getChildByName("share"):getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
        self:getChildByName("share"):getChildByName("share"):setSelectedState(true)
        self:getChildByName("share"):setVisible(true)
        self:getChildByName("share"):getChildByName("share"):setTouchEnabled(true)
        self:getChildByName("share"):getChildByName("friends"):setVisible(true)
        --platform_queryFriends(facebook_friends)
    end

end

function rewardLayer:updateList()
    local list = self:getChildByName("list")
    local num = table.getn(self._rewards)
    local row = math.ceil(num/5)
    local hh = list:getContentSize().height
    local offset = 165
    local ihh = row*offset
    list:setInnerContainerSize(cc.size(720,ihh))
    for i,item in ipairs(list:getChildren()) do
        if item ~= nil then
            item:setVisible(false)
        end
    end
    
    for i=1,table.getn(self._rewards) do
        local type = self._rewards[i]["type"]
        local id = self._rewards[i]["id"]
        local count = self._rewards[i]["count"]
        if type == 18 then
            count = 1
        end
        --local count = self._rewards[i]["count"]
        local item = list:getChildByName(i)
        if item == nil then
            item = self:getChildByName("itemmode"):clone()
            item:setName(i)
            list:addChild(item)
        end
        item:getChildByName("back"):removeAllChildren(true)
        local sprite = sp.SkeletonAnimation:create("images/pve/PveAnimation/zhuchengshengji.json", "images/pve/PveAnimation/zhuchengshengji.atlas")
        sprite:setPosition(cc.p(70, 70))
        sprite:setAnimation(0, "Guangquan_animation", true)
        item:getChildByName("back"):addChild(sprite,0,101)
                
        item:setVisible(true)
        item:getChildByName("count"):setString(dd.showKM(count,5))
        item:getChildByName("icon"):loadTexture(dd.getGiftsIcon(type, id)[1],dd.getGiftsIcon(type, id)[2])        
        item:getChildByName("back"):loadTexture(dd.getPathFromUI("r_box_"..self.getBoxColor(type, id)..".png",1))
        item:setPositionX(12 + 140*((i-1)%5))
        item:setPositionY(ihh + 8 - offset - offset*( math.floor((i-1)/5) ))
        item:setTag(i)
        item:setTouchEnabled(true)
    end
    for i = num + 1, row*5 do
        local item = list:getChildByName(i)
        if item == nil then
            item = self:getChildByName("itemmode"):clone()
            item:setName(i)
            list:addChild(item)
        end
        item:getChildByName("back"):removeAllChildren(true)
        
        item:setVisible(true)
        item:getChildByName("count"):setString("")
        item:getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))        
        item:getChildByName("back"):loadTexture(dd.getPathFromUI("r_box_1.png",1))
        item:setPositionX(12 + 140*((i-1)%5))
        item:setPositionY(ihh + 8 - offset - offset*( math.floor((i-1)/5) ) )
        item:setTouchEnabled(false)
    end
end

function rewardLayer:showTips(type, id, count, pos)
    local ret  = dd.getGiftsTips(type, id, count)
    local name = ret[1]
    local str  = ret[2]
    local tips = self:getChildByName("tips")
    local wid  = 360

    tips:setVisible(true)
    tips:getChildByName("tips"):removeAllChildren(true)

    local richText = ccui.RichText:create()
    richText:ignoreContentAdaptWithSize(false)
    richText:setContentSize(cc.size(wid-30,600))    
    richText:setAutoHeight()

    local chat = ccui.RichElementText:create(1, cc.c3b(161,175,175), 255, str, "Helvetica", 20)
    richText:insertElement(chat,0)
    richText:formatText()

    local size = richText:getContentSize()
    richText:setPosition(cc.p(172,size.height/2 + 15))
    tips:setContentSize(cc.size(wid, size.height + 60))
    tips:getChildByName("tips"):setContentSize(cc.size(wid, size.height + 60))
    tips:getChildByName("tips"):addChild(richText)

    tips:getChildByName("name"):setString(name) 
    tips:getChildByName("name"):setPositionY(size.height + 40)

    tips:setPosition(pos)
    if pos.x < 100 then
        tips:setAnchorPoint(cc.p(0.2,0))
        tips:getChildByName("flag"):setPositionX(wid*0.2)
    elseif pos.x > 550 then
        tips:setAnchorPoint(cc.p(0.8,0))
        tips:getChildByName("flag"):setPositionX(wid*0.8)
    else
        tips:setAnchorPoint(cc.p(0.5,0))
        tips:getChildByName("flag"):setPositionX(wid*0.5)
    end  
end

function rewardLayer:unshowTips()
    self:getChildByName("tips"):setVisible(false)
end

function rewardLayer:playBezier(nodeparent, node)
    local spr = node:clone()
    self:addChild(spr,2)
    
    local function callback()  
        local guang = nodeparent:getChildByName("back"):getChildByTag(101)
        node:setVisible(true)
        if guang ~= nil then
            guang:setVisible(true)
        end
        performWithDelay(node,function() spr:removeFromParent(true) end,0.1)
    end
    --popDialog 动作会改变self的位置
    local startp = cc.p(-150, -100)                             
    local endp = self:convertToNodeSpace(self:getWorldPos(node))    
    local dis = cc.pGetDistance(endp,startp) 
    local time = dis/1000
    spr:setPosition(startp)
    node:setVisible(false)
    cclog("start "..startp.x.." "..startp.y)
    cclog("endp  "..endp.x.." "..endp.y)
    local bezier = {  startp
                    , cc.p(endp.x, 0)
                    , endp,}

    local delay    = cc.DelayTime:create(1)          
    local action   = cc.BezierTo:create(time, bezier)
    local toScal1  = cc.ScaleTo:create(0.1,2)
    local toScal2  = cc.ScaleTo:create(0.1,1)
    local sequence = cc.Sequence:create(delay,action, toScal1, toScal2, cc.CallFunc:create(callback))
    spr:runAction(sequence)
end

function rewardLayer:getWorldPos(node)
    local anr   = node:getAnchorPoint()
    local size  = node:getContentSize()
    local p = node:convertToWorldSpace(cc.p(anr.x * size.width,anr.y * size.height)) --世界坐标
    return p
end

function rewardLayer.getBoxColor(type, tid)
    if type == 1 then               --道具
        if dd.cfgProp[tid]['type'] == 8 then       --宝石
            return 1
        elseif dd.cfgProp[tid]['type'] > 100 then  --材料
            if dd.cfgProp[tid]['color'] ~= nil then
                return dd.cfgProp[tid]['color']
            else
                return 1
            end
        else 
            return 1
        end
    elseif type == 15 then          --晶体
        if dd.cfgCrystal[tid]['color'] ~= nil then
            return dd.cfgCrystal[tid]['color']
        else
            return 1
        end        
    else   
        return 1
    end
end

function rewardLayer:playDropAct()
    --屏蔽就注释以下代码
    local endPos = cc.p(200,100)
    local count = table.getn(self._rewards)
    local num   = count
    if count > 10 then
        num = 10
        count = 10
    end
    for i=1,num do
        local item = self:getChildByName("list"):getChildByName(count)
        if item ~= nil then
            local icon = item:getChildByName("icon"):clone()
            local pos  = self:getWorldPos(item:getChildByName("icon"))
            dd.mainUI:getChildByName("effect"):addChild(icon)
            icon:setPosition(cc.p(pos.x,pos.y))
            local moveup  = cc.EaseExponentialOut:create( cc.MoveTo:create(0.1, cc.p(pos.x,pos.y + 30)) )
            --local movedown = cc.MoveTo:create(0.8,endPos)
            local movedown = cc.EaseExponentialIn:create(cc.MoveTo:create(0.8,endPos))
            local seq  = cc.Sequence:create(cc.DelayTime:create(0.5),cc.FadeOut:create(0.3))
            local spaw = cc.Spawn:create(movedown,seq)
            local sequence = cc.Sequence:create(moveup,spaw,cc.RemoveSelf:create())
            icon:runAction(sequence)
        end 
        count = count - 1
    end
end

function rewardLayer.showFriends(sender,eventType)
    if eventType==ccui.TouchEventType.ended then     
        local widget = pop.getDialog("reward")
        if widget:getChildByName("list"):isVisible() == true then
            widget:getChildByName("list"):setVisible(false)
            widget:getChildByName("friends"):setVisible(true)
            widget:onShowFriends()
            widget:onAutoSize(1)            
        else
            widget:getChildByName("list"):setVisible(true)
            widget:getChildByName("friends"):setVisible(false)
            widget:onAutoSize(0)
        end            
    end
end

function rewardLayer:onShowFriends()
    local row = math.ceil(table.getn(self._friends)/5)
    if row < 1 then
        row = 1
    end
    if row > 2 then
        row = 2
    end
    local list = self:getChildByName("friends")
    local offset = 165
    local ihh = row*offset

    for i=1,row do
        for j=1,5 do
            local id = (i - 1)*5 + j
            local item = list:getChildByTag(id)
            if item == nil then
                item = self:getChildByName("itemmode"):clone()
                item:getChildByName("share"):setVisible(true)
                item:setTag(id)
                item:setVisible(true)
                list:addChild(item)
                item:setPositionX(12 + 140*((j-1)%5))
                item:setPositionY(ihh + 8 - offset - offset*( math.floor((i-1)/5) ))
            end                
            if self._friends[id] ~= nil then
                if self._friends[id]['cache'] == 1 then
                    item:getChildByName("icon"):loadTexture("images/facebook/"..self._friends[id]['id']..".jpg",0)
                else
                    item:getChildByName("icon"):loadTexture("images/fb/def.jpg",0)
                end
                item:getChildByName("count"):setString(self._friends[id]['name'])
                item:getChildByName("share"):setVisible(true)
            else
                item:getChildByName("count"):setString("")
                item:getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                item:getChildByName("share"):setVisible(false)
            end
        end
    end
    if self._getShare == false then
        platform_showWaiting(1,0)
        platform_queryFriends(facebook_friends)
    end
end
function rewardLayer:updateFBFace(id)
    for i=1,table.getn(self._friends) do
        if self._friends[i]['id'] == id then
            self._friends[i]['cache'] = 1
            local list = self:getChildByName("friends")
            item = list:getChildByTag(i)
            if item ~= nil then
                item:getChildByName("icon"):loadTexture("images/facebook/"..self._friends[i]['id']..".jpg",0)
            end
            break
        end
    end
end
--回调好友
function facebook_friends(str)
    local widget = pop.getDialog("reward")
    if widget == nil or widget:isVisible() == false then
        return
    else
        widget._getShare = true        
        platform_showWaiting(0,0)
        widget._friends = {}
        local temp = Split(str, "%,")
        if temp ~= nil then
            for i=1,table.getn(temp) do
                local info = Split(temp[i],"%|")
                if info ~= nil and table.getn(info) == 3 then
                    widget._friends[table.getn(widget._friends) + 1] = {}
                    widget._friends[table.getn(widget._friends)]['id']   = info[1]
                    widget._friends[table.getn(widget._friends)]['name'] = info[2]
                    widget._friends[table.getn(widget._friends)]['url']  = info[3]     
                    widget._friends[table.getn(widget._friends)]['cache']  = 0

                    local list = widget:getChildByName("friends")
                    item = list:getChildByTag(table.getn(widget._friends))
                    if item ~= nil then
                        item:getChildByName("icon"):loadTexture("images/fb/def.jpg",0)
                        item:getChildByName("count"):setString(info[2])
                        item:getChildByName("share"):setVisible(true)
                        item:getChildByName("share"):setSelectedState(true)
                    end
                    ff.gameCore:getFaceBookFace(info[3],info[1])
                end
            end
        end
    end
end

function updateFaceShare(str)
    if str ~= "" then
        cclog("updateFaceShare")
        local sender = pop.getDialog("reward")
        if sender == nil or sender:isVisible() == false then
            return
        end
        sender:getChildByName("share"):getChildByName("share"):getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
        sender:getChildByName("share"):getChildByName("share"):setSelectedState(true)
        sender:getChildByName("share"):getChildByName("share"):setTouchEnabled(true)
        sender:getChildByName("share"):getChildByName("friends"):setVisible(true)
        sender:getChildByName("share"):getChildByName("tips"):setColor(cc.c3b(183,197,199))
        sender:getChildByName("share"):getChildByName("tips"):setTouchEnabled(true)
    end
end

function rewardLayer.onStart(sender)
    if sender._share == true then
        if platform_queryFacebook() == true then
            sender:getChildByName("share"):getChildByName("share"):getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
            sender:getChildByName("share"):getChildByName("share"):setSelectedState(true)
            sender:getChildByName("share"):getChildByName("share"):setTouchEnabled(true)
            sender:getChildByName("share"):getChildByName("friends"):setVisible(true)
            sender:getChildByName("share"):getChildByName("tips"):setColor(cc.c3b(183,197,199))
            sender:getChildByName("share"):getChildByName("tips"):setTouchEnabled(true)
        else 
            sender:getChildByName("share"):getChildByName("share"):getVirtualRenderer():setGLProgramState(ff.Effect:effectGrey())
            sender:getChildByName("share"):getChildByName("share"):setTouchEnabled(false)
            sender:getChildByName("share"):getChildByName("share"):setSelectedState(false)
            sender:getChildByName("share"):getChildByName("friends"):setVisible(false)
            sender:getChildByName("share"):getChildByName("tips"):setTouchEnabled(false)
            sender:getChildByName("share"):getChildByName("tips"):setColor(cc.c3b(85,85,85))

            local facebook   = cc.UserDefault:getInstance():getStringForKey("facebook","")
            if string.len(facebook) == 32 then
                platform_loginFB(updateFaceShare)
            end
        end
    end
end


function rewardLayer.onEnd(sender)
    dd.delBackEvent()
    sender:stopAllActions()
    if ff.platform ~= 1 then
        for i,item in ipairs(sender:getChildByName("list"):getChildren()) do
            if item ~= nil then
                item:getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))        
                item:getChildByName("back"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                item:getChildByName("back"):removeAllChildren(true)
            end
        end
    end
    sender:getChildByName("friends"):removeAllChildren(true)
end

function rewardLayer.onReturn(sender,eventType)
    local widget = pop.getDialog("reward")
    if widget then
        pop.onClosePopDialog("reward")
    end
end
--[[
     gifts格式 = {{["type"] = ,["id"] = ,["count"] = },{["type"] = ,["id"] = ,["count"] = }..}  
             详情见  礼包内容格式定义
--]]
function onShowReward(widget, gifts, title,share)
    if share == nil then
        share = false
    end
    local layer = rewardLayer.extend(widget)
    --layer._rewards = {{["type"]=2,["id"]=0,["count"]=1000}}
    if gifts ~= nil then
        layer._rewards = gifts
    else
        cclog("数据异常==")
        layer._rewards = {}
    end
    if title ~= nil then
        layer._title = title
    else
        layer._title = ff.langString("宝箱")
    end
    layer._share = share

    dd.regeditBackEvent(layer.onReturn)
    layer:onAutoSize()
    layer:onInit()
    return layer
end