
SurpriseRechargeLayer = class("SurpriseRechargeLayer")
SurpriseRechargeLayer._name = "SurpriseRecharge"
SurpriseRechargeLayer._init = false
SurpriseRechargeLayer._Acive = 0
SurpriseRechargeLayer._id = 0
SurpriseRechargeLayer._callback = nil


function SurpriseRechargeLayer.extend( target )
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target,t)
    end
    setmetatable(t,SurpriseRechargeLayer)
    return target
    -- body
end

function SurpriseRechargeLayer:onAutoSize()
    local hh = ff.height
    self:setContentSize(cc.size(720,hh))
    self:getChildByName("mask"):setContentSize(cc.size(720,hh))
    local h = hh/2 - 350
    self:getChildByName("view"):setPositionY(h)

    self:getChildByName("view"):getChildByName("close"):addTouchEventListener(self.onReturn)
    self:getChildByName("view"):getChildByName("pay"):getChildByName("pay"):addTouchEventListener(self.onPay)
    self:getChildByName("view"):getChildByName("info"):getChildByName("item"):addTouchEventListener(self.onShowTips)
    self:getChildByName("mask"):addTouchEventListener(self.unShowTips)
    self:getChildByName("view"):getChildByName("pay1"):getChildByName("pay"):addTouchEventListener(self.onPay1)
end

function SurpriseRechargeLayer.onShowTips(sender, eventType)
    local doaction = false
    
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end

    if eventType==ccui.TouchEventType.ended then    
        doaction = true
    end
    if doaction == true then        
        local widget = pop.getDialog("SurpriseRecharge")
        local pos2word = widget:getWorldPos(sender)
        local pos = widget:convertToNodeSpace(pos2word) 
        pos = cc.p(pos.x+65, pos.y+110)
        widget:showTips(sender.type, sender.id, sender.count, pos)
    end
end

function  SurpriseRechargeLayer.unShowTips(sender, eventType)

    if eventType == ccui.TouchEventType.began then

        local widget = pop.getDialog("SurpriseRecharge")
        if widget ~= nil then

            widget:getChildByName("tips"):setVisible(false)
        end
    end
    
end

function SurpriseRechargeLayer:showTips(type, id, count, pos)
    local ret  = dd.getGiftsTips(type, id, count)
    local name = ret[1]
    local str  = ret[2]

    local tips = self:getChildByName("tips")
    local wid  = 360
    tips:setVisible(true)
    tips:getChildByName("tips"):removeAllChildren(true)

    local richText = ccui.RichText:create()
    richText:ignoreContentAdaptWithSize(false)
    richText:setContentSize(cc.size(wid-30,600))    
    richText:setAutoHeight()

    local chat = ccui.RichElementText:create(1, cc.c3b(161,175,175), 255, str, "Helvetica", 20)
    richText:insertElement(chat,0)
    richText:formatText()

    local size = richText:getContentSize()
    richText:setPosition(cc.p(172,size.height/2 + 15))
    tips:setContentSize(cc.size(wid, size.height + 60))
    tips:getChildByName("tips"):setContentSize(cc.size(wid, size.height + 60))
    tips:getChildByName("tips"):addChild(richText)

    tips:getChildByName("name"):setString(name) 
    tips:getChildByName("name"):setPositionY(size.height + 40)

    tips:setPosition(pos)
    if pos.x < 100 then
        tips:setAnchorPoint(cc.p(0.2,0))
        tips:getChildByName("flag"):setPositionX(wid*0.2)
    elseif pos.x > 550 then
        tips:setAnchorPoint(cc.p(0.8,0))
        tips:getChildByName("flag"):setPositionX(wid*0.8)
    else
        tips:setAnchorPoint(cc.p(0.5,0))
        tips:getChildByName("flag"):setPositionX(wid*0.5)
    end        
end

function SurpriseRechargeLayer:getWorldPos(node)
    local anr   = node:getAnchorPoint()
    local size  = node:getContentSize()
    local p = node:convertToWorldSpace(cc.p(anr.x * size.width,anr.y * size.height)) --世界坐标
    return p
end

function SurpriseRechargeLayer.onPay( sender,eventType  )
    -- body

    local close = false
    if sender == nil then
        close = true
    end
    if eventType == ccui.TouchEventType.ended then
        close = true
    end
    if close == true then
        local widget = pop.getDialog("SurpriseRecharge")
        if widget == nil then
            return
        end
      
        local row  = cc.UserDefault:getInstance():getIntegerForKey("httpif")
        local type = hif._lists:getLong(row,"type") 
       
        cclog("type:"..type..","..row)

        if type == 1 then
            --模拟充值
            local message = ff.net:createMessage()
            message:addCmd(0x135)
            message:addLong(dd.uid)
            local id = 0
            if widget._Acive == 1  then
                if dd.mygifts:getLong(1,"SurpriseRechargeIdEx") ~= 0 then
                    id  = dd.mygifts:getLong(1,"SurpriseRechargeIdEx")
                end
            elseif widget._Acive == 2  then
                if dd.mygifts:getLong(1,"ActiveCharge") ~= 0 then
                    id  = dd.mygifts:getLong(1,"ActiveCharge")
                end
            elseif widget._Acive == 3  then
                if dd.mygifts:getLong(1,"ResCharge") ~= 0 then
                    id  = dd.mygifts:getLong(1,"ResCharge")
                end
            elseif widget._Acive == 4  then
                if dd.mygifts:getLong(1,"BonusCharge") ~= 0 then
                    id  = dd.mygifts:getLong(1,"BonusCharge")
                end
            elseif widget._Acive == 5  then
                if dd.mygifts:getLong(1,"OnceCharge") ~= 0 then
                    id  = dd.mygifts:getLong(1,"OnceCharge")
                end
            elseif widget._Acive == 6  then
                if dd.EvtSpreeATopup ~= nil and dd.EvtSpreeATopup:rowCount() > 0 then
                    id  = dd.EvtSpreeATopup:getLong(1,"id")
                end
            elseif widget._Acive == 8  then

                id  = widget._id

            else
                if dd.mygifts:getLong(1,"SurpriseRechargeId") ~= 0 then
                    id  = dd.mygifts:getLong(1,"SurpriseRechargeId")
                elseif dd.mygifts:getLong(1,"LevelRechargeId") ~= 0 then
                    id  = dd.mygifts:getLong(1,"LevelRechargeId")
                end
            end
            
            message:addLong(id)
            ff.net:rpc(message,false)
            sender:setTouchEnabled(false)
        else
            local function delay_fun()
                local id = 0
                local product = ""
                local gold = 0
                if widget._Acive == 1  then
                    if dd.mygifts:getLong(1,"SurpriseRechargeIdEx") ~= 0 then
                        id  = dd.mygifts:getLong(1,"SurpriseRechargeIdEx")
                    end
                elseif widget._Acive == 2  then
                    if dd.mygifts:getLong(1,"ActiveCharge") ~= 0 then
                        id  = dd.mygifts:getLong(1,"ActiveCharge")
                    end
                elseif widget._Acive == 3  then
                    if dd.mygifts:getLong(1,"ResCharge") ~= 0 then
                        id  = dd.mygifts:getLong(1,"ResCharge")
                    end
                elseif widget._Acive == 4  then
                    if dd.mygifts:getLong(1,"BonusCharge") ~= 0 then
                        id  = dd.mygifts:getLong(1,"BonusCharge")
                    end
                elseif widget._Acive == 5  then
                    if dd.mygifts:getLong(1,"OnceCharge") ~= 0 then
                        id  = dd.mygifts:getLong(1,"OnceCharge")
                    end
                elseif widget._Acive == 8  then

                    id  = widget._id
                else
                    if dd.mygifts:getLong(1,"SurpriseRechargeId") ~= 0 then
                        id  = dd.mygifts:getLong(1,"SurpriseRechargeId")
                    elseif dd.mygifts:getLong(1,"LevelRechargeId") ~= 0 then
                        id  = dd.mygifts:getLong(1,"LevelRechargeId")
                    end
                end
                if widget._Acive == 6 then
                    if dd.EvtSpreeATopup ~= nil and dd.EvtSpreeATopup:rowCount() > 0 then
                        product  = dd.EvtSpreeATopup:getString(1,"product")
                        gold  = dd.EvtSpreeATopup:getLong(1,"gold")
                    end
                    
                else
                    product = dd.cfgCharge[id]['product']
                    gold = dd.cfgCharge[id]['gold']
                end
                platform_pay(product,gold)
            end
            performWithDelay(sender,delay_fun,0.1)
            --dd.currentLayer._widget:onShowTips("\t"..ff.langString("该功能尚未开放，敬请期待！"))
        end        
    end
end

function SurpriseRechargeLayer.onPay1( sender,eventType  )
    -- body

    local close = false
    if sender == nil then
        close = true
    end
    if eventType == ccui.TouchEventType.ended then
        close = true
    end
    if close == true then
        local widget = pop.getDialog("SurpriseRecharge")
        if widget == nil then
            return
        end
        local message = ff.net:createMessage()
        message:addCmd(0x0000014b)
        message:addLong(dd.uid)
        message:addLong(widget._id)
        message:addLong(0)
        message:addLong(0)
        message:addLong(0)
        message:addLong(0)
        ff.net:rpc(message,false)
        
    end
end

function onShowSurpriseRecharge( widget,type ,id,call)
    -- body
    local layer = SurpriseRechargeLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)
    if type ~= nil then
        layer._Acive = type
        if id ~= nil then
            layer._id = id 
        else
            layer._id = 0
        end
        if call ~= nil then
            layer._callback = call
        else
            layer._callback = nil 
        end

    else
        layer._Acive = 0
        layer._id = 0
    end
    
    layer:onInit()
    return layer
end

function SurpriseRechargeLayer:onInit( )
    -- body
    if self._init == false then
        self:onAutoSize()
        self._init = true
  end
  self:getChildByName("view"):getChildByName("pay"):getChildByName("pay"):setTouchEnabled(true)
end


function SurpriseRechargeLayer.onReturn( sender,eventType )
    -- body
    local close = false
    if sender == nil then
        close = true
    end
    if eventType == ccui.TouchEventType.ended then
        close = true
    end
    if close == true then
        local widget = pop.getDialog("SurpriseRecharge")
            if widget == nil then
                return
            end
            if widget._callback ~= nil then
                widget._callback()
            end
        pop.onClosePopDialog("SurpriseRecharge")

    end
end

function SurpriseRechargeLayer:showList(  )
    local id = 0 
    local time = 0

    if self._Acive  == 1 then
        if dd.mygifts:getLong(1,"SurpriseRechargeIdEx") ~= 0 then
            id  = dd.mygifts:getLong(1,"SurpriseRechargeIdEx")
            time = dd.mygifts:getLong(1,"SurpriseRechargeTimeEx") - dd.getServerTime()
            self:getChildByName("view"):getChildByName("title"):getChildByName("time"):setVisible(false)
            self:getChildByName("view"):getChildByName("info"):getChildByName("Label_150"):setString(ff.getLeftTime(time,":"))
            self:getChildByName("view"):getChildByName("title"):getChildByName("Image_28"):loadTexture("images/icon/charge/301.png",0)
        end
    elseif self._Acive  == 2 then
        if dd.mygifts:getLong(1,"ActiveCharge") ~= 0 then
            id  = dd.mygifts:getLong(1,"ActiveCharge")
            time = dd.mygifts:getLong(1,"ActiveChargeTime") - dd.getServerTime()
            self:getChildByName("view"):getChildByName("title"):getChildByName("time"):setVisible(false)
            self:getChildByName("view"):getChildByName("info"):getChildByName("Label_150"):setString(ff.getLeftTime(time,":"))
            self:getChildByName("view"):getChildByName("title"):getChildByName("Image_28"):loadTexture("images/icon/charge/301.png",0)
        end
    elseif self._Acive  == 3 then
        if dd.mygifts:getLong(1,"ResCharge") ~= 0 then
            id  = dd.mygifts:getLong(1,"ResCharge")
            time = dd.mygifts:getLong(1,"ResChargeTime") - dd.getServerTime()
            self:getChildByName("view"):getChildByName("title"):getChildByName("Image_28"):loadTexture(dd.getPathFromUI("chongzhi_time.png",1))
            self:getChildByName("view"):getChildByName("title"):getChildByName("time"):setVisible(true)
            self:getChildByName("view"):getChildByName("title"):getChildByName("time"):setString(ff.getLeftTime(time,"   "))
            self:getChildByName("view"):getChildByName("info"):getChildByName("Label_150"):setString(ff.langString("仅此一次，机不可失！"))
        end
    elseif self._Acive  == 4 then
        if dd.mygifts:getLong(1,"BonusCharge") ~= 0 then
            id  = dd.mygifts:getLong(1,"BonusCharge")
            time = dd.mygifts:getLong(1,"BonusChargeTime") - dd.getServerTime()
            self:getChildByName("view"):getChildByName("title"):getChildByName("Image_28"):loadTexture(dd.getPathFromUI("chongzhi_time.png",1))
            self:getChildByName("view"):getChildByName("title"):getChildByName("time"):setVisible(true)
            self:getChildByName("view"):getChildByName("title"):getChildByName("time"):setString(ff.getLeftTime(time,"   "))
            self:getChildByName("view"):getChildByName("info"):getChildByName("Label_150"):setString(ff.langString(""))
        end
    elseif self._Acive  == 5 then
        if dd.mygifts:getLong(1,"OnceCharge") ~= 0 then
            id  = dd.mygifts:getLong(1,"OnceCharge")
            time = dd.mygifts:getLong(1,"OnceChargeTime") - dd.getServerTime()
            self:getChildByName("view"):getChildByName("title"):getChildByName("time"):setVisible(false)
            self:getChildByName("view"):getChildByName("info"):getChildByName("Label_150"):setString(ff.getLeftTime(time,":"))
            self:getChildByName("view"):getChildByName("title"):getChildByName("Image_28"):loadTexture("images/icon/charge/301.png",0)
        end
    elseif self._Acive  == 6 then
        if dd.EvtSpreeATopup ~= nil and dd.EvtSpreeATopup:rowCount() > 0 then
            id = dd.EvtSpreeATopup:getLong(1,"id")
            time = dd.EvtSpreeATopup:getLong(1,"endtime") - dd.getServerTime()
            self:getChildByName("view"):getChildByName("title"):getChildByName("time"):setVisible(false)
            self:getChildByName("view"):getChildByName("info"):getChildByName("Label_150"):setString(ff.getLeftTime(time,":"))
            self:getChildByName("view"):getChildByName("title"):getChildByName("Image_28"):loadTexture("images/icon/charge/301.png",0)
        end
    elseif self._Acive  == 7 then

        if dd.myEvtMall ~= nil and dd.myEvtMall:rowCount() > 0 then
            local index = 0
            for i=1,dd.myEvtMall:rowCount() do
               
                if dd.myEvtMall:getLong(i,"id") == self._id then
                    index = i
                end
            end

            id = dd.myEvtMall:getLong(index,"id")
            time = dd.myEvtMall:getLong(index,"latetime") - dd.getServerTime()
            self:getChildByName("view"):getChildByName("title"):getChildByName("time"):setVisible(false)
            self:getChildByName("view"):getChildByName("info"):getChildByName("Label_150"):setString(ff.getLeftTime(time,":"))
            self:getChildByName("view"):getChildByName("title"):getChildByName("Image_28"):loadTexture("images/icon/charge/301.png",0)
        end
    elseif self._Acive  == 8 then
            id  = self._id
            time = dd.RestrictedGiftInfo:getLong(1,"chongExpired") - dd.getServerTime()
            self:getChildByName("view"):getChildByName("title"):getChildByName("Image_28"):loadTexture("images/icon/charge/301.png",0)
            self:getChildByName("view"):getChildByName("title"):getChildByName("time"):setVisible(false)
            self:getChildByName("view"):getChildByName("info"):getChildByName("Label_150"):setString(ff.getLeftTime(time,":"))

    else
        if dd.mygifts:getLong(1,"SurpriseRechargeId") ~= 0 then
            id  = dd.mygifts:getLong(1,"SurpriseRechargeId")
            time = dd.mygifts:getLong(1,"SurpriseRechargeTime") - dd.getServerTime()
            self:getChildByName("view"):getChildByName("title"):getChildByName("Image_28"):loadTexture(dd.getPathFromUI("chongzhi_time.png",1))
            self:getChildByName("view"):getChildByName("title"):getChildByName("time"):setVisible(true)
            self:getChildByName("view"):getChildByName("title"):getChildByName("time"):setString(ff.getLeftTime(time,"   "))
            self:getChildByName("view"):getChildByName("info"):getChildByName("Label_150"):setString(ff.langString("仅此一次，机不可失！"))
        elseif dd.mygifts:getLong(1,"LevelRechargeId") ~= 0 then
            id  = dd.mygifts:getLong(1,"LevelRechargeId")
            time = dd.mygifts:getLong(1,"LevelRechargeTime") - dd.getServerTime()
            self:getChildByName("view"):getChildByName("title"):getChildByName("time"):setVisible(false)
            self:getChildByName("view"):getChildByName("info"):getChildByName("Label_150"):setString(ff.getLeftTime(time,":"))
            self:getChildByName("view"):getChildByName("title"):getChildByName("Image_28"):loadTexture("images/icon/charge/301.png",0)
       
        end
    end
    self:getChildByName("view"):getChildByName("info"):requestDoLayout()
    if id ~= 0 and time ~= 0 then
        local name = ""
        local value = 0
        local getgold = 0
        local  yuanjia = 0
        local gold = 0
        local giftInfo = ""
        local moregold = 0
        local leaguebox = 0
        local fuhao = "$"
        if self._Acive == 6 then
            if dd.EvtSpreeATopup ~= nil and dd.EvtSpreeATopup:rowCount() > 0 then
                name = dd.EvtSpreeATopup:getString(1,"name")
                value = dd.EvtSpreeATopup:getLong(1,"value")
                getgold = dd.EvtSpreeATopup:getLong(1,"getgold")
                yuanjia = dd.EvtSpreeATopup:getLong(1,"yuanjia")
                gold = dd.EvtSpreeATopup:getLong(1,"goldforshow")
                giftInfo = Split(dd.EvtSpreeATopup:getString(1,"otherthing"),'|')
                moregold = dd.EvtSpreeATopup:getLong(1,"moregold") + dd.EvtSpreeATopup:getLong(1,"getgold")
                leaguebox = dd.EvtSpreeATopup:getLong(1,"leaguebox")
                fuhao = dd.EvtSpreeATopup:getString(1,"fuhao")
            end
        elseif self._Acive == 7 then
            if dd.myEvtMall ~= nil and dd.myEvtMall:rowCount() > 0 then
                local index = 0
                for i=1,dd.myEvtMall:rowCount() do
                    if dd.myEvtMall:getLong(i,"id") == self._id then
                        index = i
                    end
                end
                name = ff.langString(dd.myEvtMall:getLong(index,"name"))
                value = dd.myEvtMall:getLong(index,"zhe")/10
                getgold = dd.myEvtMall:getLong(index,"getgold")
                yuanjia = dd.myEvtMall:getLong(index,"yuan")
                gold = dd.myEvtMall:getLong(index,"xian")
                giftInfo = Split(dd.myEvtMall:getString(index,"jiang"),'|')
                
            end
        else
            name = ff.langString(dd.cfgCharge[id]["name"])
            value = dd.cfgCharge[id]["value"]
            getgold = dd.cfgCharge[id]["getgold"]
            yuanjia = dd.cfgCharge[id]["yuanjia"]
            gold = dd.cfgCharge[id]["goldforshow"]
            giftInfo = Split(dd.cfgCharge[id]["otherthing"],'|')
            moregold = dd.cfgCharge[id]['moregold'] + dd.cfgCharge[id]["getgold"]
            leaguebox = dd.cfgCharge[id]['leaguebox']
            fuhao = dd.cfgCharge[id]['fuhao']
        end
        
        self:getChildByName("view"):getChildByName("title"):getChildByName("chu_title"):setString(name)

        self:getChildByName("view"):getChildByName("sale"):getChildByName("value"):setString(value.."%")
   
        self:getChildByName("view"):getChildByName("info"):getChildByName("goldnum"):setString(getgold)
        
        
        if self._Acive == 7 then
            self:getChildByName("view"):getChildByName("info"):getChildByName("Label_56"):setVisible(true)
            self:getChildByName("view"):getChildByName("info"):getChildByName("Image_55"):setVisible(true)
            self:getChildByName("view"):getChildByName("info"):getChildByName("Label_56"):setString(" X "..dd.getToolsCount(1255))
            self:getChildByName("view"):getChildByName("pay1"):setVisible(true)
            self:getChildByName("view"):getChildByName("pay"):setVisible(false)
            self:getChildByName("view"):getChildByName("pay1"):getChildByName("chu_old"):setString(yuanjia)
            self:getChildByName("view"):getChildByName("pay1"):getChildByName("chu_new"):setString(gold)
            self:getChildByName("view"):getChildByName("info"):getChildByName("Image_55"):getChildByName("Image_51"):loadTexture(dd.getToolsIcon(1255),0)
            local yong = math.floor(gold * 0.3 / 10)
            if yong > dd.getToolsCount(1255) then
                yong = dd.getToolsCount(1255)
            end
            if yong > 0 then
                self:getChildByName("view"):getChildByName("info"):getChildByName("Label_150_0"):setString(ff.langString("可使用{0}抵扣券",{yong}))
            else
                self:getChildByName("view"):getChildByName("info"):getChildByName("Label_150_0"):setString(ff.langString("您没有抵扣券"))
            end
            
        else
            yuanjia = tonumber(string.format("%.2f", yuanjia/100)) 
            gold = tonumber(string.format("%.2f", gold/100) )
            self:getChildByName("view"):getChildByName("info"):getChildByName("Image_55"):setVisible(false)
            self:getChildByName("view"):getChildByName("info"):getChildByName("Label_56"):setString("")
            self:getChildByName("view"):getChildByName("info"):getChildByName("Label_150_0"):setString(ff.langString(""))
            self:getChildByName("view"):getChildByName("pay"):setVisible(true)
            self:getChildByName("view"):getChildByName("pay1"):setVisible(false)
            self:getChildByName("view"):getChildByName("pay"):getChildByName("chu_old"):setString(fuhao..yuanjia)
            self:getChildByName("view"):getChildByName("pay"):getChildByName("chu_new"):setString(fuhao..gold)
            self:getChildByName("view"):getChildByName("pay"):requestDoLayout()

        end
        local index = 0
        local row = math.ceil((table.getn(giftInfo)+2)/5)
    
        local offset = 167
        if row ==1 then
            row = 2
        end
        local ihh = row*offset
        local list = self:getChildByName("view"):getChildByName("info"):getChildByName("list")
        list:setInnerContainerSize(cc.size(720,ihh))
        for i,item in ipairs(list:getChildren()) do
            if item ~= nil then
                item:setVisible(false)
            end
        end
        if moregold > 0 then
            index = index + 1
            local item = list:getChildByTag(index)
            if item == nil then
                item = self:getChildByName("view"):getChildByName("info"):getChildByName("item"):clone()
                item:setName(i)
                list:addChild(item)
            end
            item:setVisible(true)
            item:setPositionX(15 + 135*((index-1)%5))
            item:setPositionY(ihh + 8 - offset - offset*( math.floor((index-1)/5) ))
            --local mitem = self:getChildByName("view"):getChildByName("info"):getChildByName("item1")
            item:getChildByName("count"):getChildByName("value"):setString(moregold)
            item:getChildByName("icon"):getChildByName("icon"):loadTexture("images/icon/charge/gold.png",0)
            item.type = 7
            item.id = 0
            item.count = moregold
        end
        if leaguebox > 0 then
            index = index + 1
            local item = list:getChildByTag(index)
            if item == nil then
                item = self:getChildByName("view"):getChildByName("info"):getChildByName("item"):clone()
                item:setName(i)
                list:addChild(item)
            end
            item:setVisible(true)
            item:setPositionX(15 + 135*((index-1)%5))
            item:setPositionY(ihh + 8 - offset - offset*( math.floor((index-1)/5) ))
            --local mitem = self:getChildByName("view"):getChildByName("info"):getChildByName("item2")
            item:getChildByName("count"):getChildByName("value"):setString(1)
            item:getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getUnionGiftIcon(leaguebox),0)
            item.type = 12
            item.id = leaguebox
            item.count = 1
            
        end
        
        
       
        for k,v in pairs(giftInfo) do
            local gift = Split(v,'%^')
            index = index + 1
            local item = list:getChildByTag(index)
            if item == nil then
                item = self:getChildByName("view"):getChildByName("info"):getChildByName("item"):clone()
                item:setName(i)
                list:addChild(item)
            end
            item:setVisible(true)
            item:setPositionX(15 + 135*((index-1)%5))
            item:setPositionY(ihh + 8 - offset - offset*( math.floor((index-1)/5) ))
            item:getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[1],dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[2])
            item:getChildByName("count"):getChildByName("value"):setString(gift[3])
            item.type = tonumber(gift[1])
            item.id = tonumber(gift[2])
            item.count = tonumber(gift[3]) 
        end
    
        list:jumpToTop()
   end
end

function SurpriseRechargeLayer.update( sender )
    -- body
    if sender._Acive == 1 then
        if dd.mygifts:getLong(1,"SurpriseRechargeIdEx") ~= 0 then
            local id  = dd.mygifts:getLong(1,"SurpriseRechargeIdEx")
            local time = dd.mygifts:getLong(1,"SurpriseRechargeTimeEx") - dd.getServerTime()
     
            sender:getChildByName("view"):getChildByName("info"):getChildByName("Label_150"):setString(ff.getLeftTime(time,":"))
        end
    elseif sender._Acive  ==2 then
        if dd.mygifts:getLong(1,"ActiveCharge") ~= 0 then
            local id  = dd.mygifts:getLong(1,"ActiveCharge")
            local time = dd.mygifts:getLong(1,"ActiveChargeTime") - dd.getServerTime()
            if dd.cfgCharge[id] ~= nil then
                if id > 61040 and id < 61050 then
                    sender:getChildByName("view"):getChildByName("info"):getChildByName("Label_150"):setString(ff.langString("充值后，所有联盟成员获得资源赠礼"))
                else
                    if dd.cfgCharge[id]["alliancegold"] > 0 then
                        sender:getChildByName("view"):getChildByName("info"):getChildByName("Label_150"):setString(ff.langString("充值后，联盟每个成员均可获得{0}金币奖励。",{dd.cfgCharge[id]["alliancegold"]}))
                    else
                        sender:getChildByName("view"):getChildByName("info"):getChildByName("Label_150"):setString(ff.getLeftTime(time,":"))
                    end
                end
            end
        end
    elseif sender._Acive  == 3 then
        if dd.mygifts:getLong(1,"ResCharge") ~= 0 then
            local id  = dd.mygifts:getLong(1,"ResCharge")
            local time = dd.mygifts:getLong(1,"ResChargeTime") - dd.getServerTime()
            sender:getChildByName("view"):getChildByName("title"):getChildByName("time"):setString(ff.getLeftTime(time,"   "))
        end
    elseif sender._Acive  == 4 then
        if dd.mygifts:getLong(1,"BonusCharge") ~= 0 then
            local id  = dd.mygifts:getLong(1,"BonusCharge")
            local time = dd.mygifts:getLong(1,"BonusChargeTime") - dd.getServerTime()
            sender:getChildByName("view"):getChildByName("title"):getChildByName("time"):setString(ff.getLeftTime(time,"   "))
        end
    elseif sender._Acive == 5 then
        if dd.mygifts:getLong(1,"OnceCharge") ~= 0 then
            local id  = dd.mygifts:getLong(1,"OnceCharge")
            local time = dd.mygifts:getLong(1,"OnceChargeTime") - dd.getServerTime()
     
            sender:getChildByName("view"):getChildByName("info"):getChildByName("Label_150"):setString(ff.getLeftTime(time,":"))
        end
    elseif sender._Acive == 6 then
        if dd.EvtSpreeATopup ~= nil and dd.EvtSpreeATopup:rowCount() > 0 then
            
            time = dd.EvtSpreeATopup:getLong(1,"endtime") - dd.getServerTime()
            sender:getChildByName("view"):getChildByName("info"):getChildByName("Label_150"):setString(ff.getLeftTime(time,":"))

        end
    elseif sender._Acive == 7 then
        if dd.myEvtMall ~= nil and dd.myEvtMall:rowCount() > 0 then
            local index = 0
            for i=1,dd.myEvtMall:rowCount() do
                if dd.myEvtMall:getLong(i,"id") == sender._id then
                    index = i
                end
            end
        
            time = dd.myEvtMall:getLong(index,"latetime") - dd.getServerTime()
            sender:getChildByName("view"):getChildByName("title"):getChildByName("time"):setString(ff.getLeftTime(time,"   "))
        end    
    elseif sender._Acive  == 8 then
            time = dd.RestrictedGiftInfo:getLong(1,"chongExpired") - dd.getServerTime()
            sender:getChildByName("view"):getChildByName("info"):getChildByName("Label_150"):setString(ff.getLeftTime(time,":"))
    else
        if dd.mygifts:getLong(1,"SurpriseRechargeId") ~= 0 then
            local id  = dd.mygifts:getLong(1,"SurpriseRechargeId")
            local time = dd.mygifts:getLong(1,"SurpriseRechargeTime") - dd.getServerTime()
     
            sender:getChildByName("view"):getChildByName("title"):getChildByName("time"):setString(ff.getLeftTime(time,"   "))
        elseif dd.mygifts:getLong(1,"LevelRechargeId") ~= 0 then
            local id  = dd.mygifts:getLong(1,"LevelRechargeId")
            local time = dd.mygifts:getLong(1,"LevelRechargeTime") - dd.getServerTime()
     
            sender:getChildByName("view"):getChildByName("info"):getChildByName("Label_150"):setString(ff.getLeftTime(time,":"))
        end
    end
    
end

function SurpriseRechargeLayer.onEnd( sender )
    -- body

    sender:getChildByName("view"):getChildByName("info"):getChildByName("list"):removeAllChildren(true)
    sender:getChildByName("tips"):setVisible(false)
    sender:getChildByName("tips"):getChildByName("tips"):removeAllChildren(true)
    if ff.platform ~= 1 then
        sender:getChildByName("view"):getChildByName("title"):getChildByName("Image_28"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
    end
    ff.net:removeEvent(2,dd.Tjf_notify_SNCharge)
    ff.net:removeEvent(2,dd.Tjf_notify_EvtMallBuy)
    
    sender:stopAllActions()
    dd.delBackEvent(sender.onReturn)
end

function SurpriseRechargeLayer:onSNCharge(params)
    local id = params[1]
    if dd.cfgCharge[id] ~= nil then
        --local type = dd.cfgCharge[id]["type"]
    
        --if type ~= nil and (type == 11 or type == 100 or type == 6 or type == 600 or type == 500 or type == 2 or type == 200) then
            local message = ff.net:createMessage()
            message:addCmd(0x043)
            message:addLong(dd.uid)
            ff.net:rpc(message,false)
            local gifts = params[2]
            
            if gifts ~= nil then
                pop.onShowPopDialog("reward",gifts,ff.langString("充值成功"))
            end

            pop.onClosePopDialog("SurpriseRecharge")
        --end
    end
end

function SurpriseRechargeLayer:onEvtMallBuy(params)

    pop.onClosePopDialog("SurpriseRecharge")
    
end

function SurpriseRechargeLayer.onBefore( sender)
  -- body
    --ff.net:registerEvent(2,dd.Tjf_Attendance, function (message)sender:haveAttendance(message)end)
    ff.net:registerEvent(2,dd.Tjf_notify_SNCharge, function (message)sender:onSNCharge(message)end)
    ff.net:registerEvent(2,dd.Tjf_notify_EvtMallBuy, function (message)sender:onEvtMallBuy(message)end)
    schedule(sender, sender.update,1)
    sender:showList()
	sender.update(sender)
end

function SurpriseRechargeLayer.onStart( sender )
  -- body

    
end

