--reward
local giftsLayer = class("gifts")
giftsLayer._name = "gifts"
giftsLayer._init = false
giftsLayer._rewards = {}
giftsLayer._callBack = nil
--[[
1   道具  道具编号    数量  
2   石   0   数量  
3   木   0   数量  
4   铁   0   数量  
5   粮   0   数量  
6   银币  0   数量  
7   金币  0   数量  
8   士兵  兵种编号    数量  
9   英雄经验    0   数量  
10  联盟贡献    0   数量  
11  VIP点数   0   数量  
12  联盟礼物
（联盟掉落）  礼物编号    数量  
13  联盟商店
（联盟掉落）  道具编号    数量  
14  联盟基金
（联盟掉落）  0   数量  
15  晶体  配置编号    数量  
--]]

function giftsLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, giftsLayer)
    return target
end

function giftsLayer:onAutoSize()
    local hh    = ff.height
    local count = table.getn(self._rewards)
    local row   = math.ceil(count/5)
    local oldhh = 360
    local rhh = 0
    if row <= 0 then
        row = 1
    end
    if row > 2 then
        row = 2
    end 
    rhh = oldhh + (row-1)*171

    self:setContentSize(cc.size(720,hh))
    self:getChildByName("masking"):setContentSize(cc.size(720,hh + hh))
    self:getChildByName("masking"):setVisible(true)
    self:getChildByName("pop"):getChildByName("back1"):setContentSize(cc.size(720,rhh))
    self:getChildByName("pop"):getChildByName("back1"):setPositionY(0)    
    self:getChildByName("pop"):getChildByName("back2"):setContentSize(cc.size(720,180 + (row-1)*171))
    self:getChildByName("pop"):getChildByName("back2"):setPositionY(120)    
    self:getChildByName("pop"):getChildByName("topbar"):setPositionY(rhh - 10)
    self:getChildByName("pop"):getChildByName("close"):setPositionY(rhh - 23)
    self:getChildByName("pop"):getChildByName("list"):setContentSize(cc.size(720,180 -3+ (row-1)*171))
    cclog("row == "..row)
    --居中显示  effect 99
    --self:setPositionY((hh-rhh)/2)
end

function giftsLayer:onInit()
    if self._init == false then   
        local function close(sender, eventType)
            if eventType==ccui.TouchEventType.ended then    
                pop.onClosePopDialog("gifts")
            end
        end
        local function clickItem(sender, eventType)
            local doaction = false
            if eventType == ccui.TouchEventType.canceled then
                local startp = sender:getTouchBeganPosition()
                local endp   = sender:getTouchEndPosition()
                if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                    doaction = true
                end
            end

            if eventType==ccui.TouchEventType.ended then    
                doaction = true
            end
            if doaction == true then
                cclog("点击了物品")
            end
        end
        local function confirm(sender, eventType)
            if eventType==ccui.TouchEventType.ended then    
                if self._callBack ~= nil then
                    self._callBack()
                end
                pop.onClosePopDialog("gifts")
            end
        end
        self:getChildByName("pop"):getChildByName("close"):addTouchEventListener(close)
        self:getChildByName("pop"):getChildByName("confirm"):addTouchEventListener(confirm)
        self:getChildByName("pop"):getChildByName("item"):addTouchEventListener(clickItem)

        local function onTouchBegan(touch, event)
            self:unShowTips()
            return false
        end
        local listener = cc.EventListenerTouchOneByOne:create()
        listener:registerScriptHandler(onTouchBegan,cc.Handler.EVENT_TOUCH_BEGAN)
        listener:setSwallowTouches(true)
        self:getChildByName("touch"):getEventDispatcher():addEventListenerWithSceneGraphPriority(listener,self:getChildByName("touch"))

        self._init = true
    end    
    if self._callBack == nil then
        self:getChildByName("pop"):getChildByName("confirm"):getChildByName("chu_label"):setString(ff.langString("确定"))
    else
        self:getChildByName("pop"):getChildByName("confirm"):getChildByName("chu_label"):setString(ff.langString("领取"))
    end
    self:updateList()
end

function giftsLayer:updateList()
    local list = self:getChildByName("pop"):getChildByName("list")
    local num = table.getn(self._rewards)
    local row = math.ceil(num/5)
    local hh = list:getContentSize().height
    local offset = 171
    local ihh = row*offset
    list:setInnerContainerSize(cc.size(720,ihh))
    for i,item in ipairs(list:getChildren()) do
        if item ~= nil then
            item:setVisible(false)
        end
    end
    
    for i=1,table.getn(self._rewards) do
        local type = self._rewards[i]["type"]
        local id = self._rewards[i]["id"]
        local count = self._rewards[i]["count"]
        local item = list:getChildByName(i)
        if item == nil then
            item = self:getChildByName("pop"):getChildByName("item"):clone()
            item:setName(i)
            list:addChild(item)
        end
        item:setVisible(true)
        item:getChildByName("count"):getChildByName("count"):setString(dd.showKM(count,5))
        item:getChildByName("back"):getChildByName("icon"):loadTexture(dd.getGiftsIcon(type, id)[1],dd.getGiftsIcon(type, id)[2])        
        item:setPositionX(15 + 140*((i-1)%5))
        item:setPositionY(ihh + 8 - offset - offset*( math.floor((i-1)/5) ))
        item:getChildByName("back"):getChildByName("icon"):setTouchEnabled(true)
        item:getChildByName("back"):getChildByName("icon"):addTouchEventListener(self.onShowTips)
        item:getChildByName("back"):getChildByName("icon").type = type
        item:getChildByName("back"):getChildByName("icon").id = id
        item:getChildByName("back"):getChildByName("icon").count = count
    end
    for i = num + 1, row*5 do
        local item = list:getChildByName(i)
        if item == nil then
            item = self:getChildByName("pop"):getChildByName("item"):clone()
            item:setName(i)
            list:addChild(item)
        end        
        item:setVisible(true)
        item:getChildByName("count"):getChildByName("count"):setString("")
        item:getChildByName("back"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))   
        item:setPositionX(15 + 140*((i-1)%5))
        item:setPositionY(ihh + 8 - offset - offset*( math.floor((i-1)/5) ) )
        item:getChildByName("back"):getChildByName("icon"):setTouchEnabled(false)
    end
end

function giftsLayer.getBoxColor(type, tid)
    local color = 1
    if type == 1 then                              --道具
        if dd.cfgProp[tid]['type'] == 8 then       --宝石
            color = 1
        elseif dd.cfgProp[tid]['type'] > 100 then  --材料
            if dd.cfgProp[tid]['color'] ~= nil then
                color = dd.cfgProp[tid]['color']
            else
                color = 1
            end
        else 
            color = 1
        end
    elseif type == 15 then          --晶体
        if dd.cfgCrystal[tid]['color'] ~= nil then
            color = dd.cfgCrystal[tid]['color']
        else
            color = 1
        end        
    else   
        color = 1
    end
    return color
end

function giftsLayer.onShowTips(sender, eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end

    if eventType==ccui.TouchEventType.ended then    
        doaction = true
    end
    if doaction == true then        
        local widget = pop.getDialog("gifts")
        local pos2word = widget:getWorldPos(sender)
        local pos = widget:convertToNodeSpace(pos2word) 
        pos = cc.p(pos.x, pos.y+30)
        widget:showTips(sender.type, sender.id, sender.count, pos)
    end
end

function giftsLayer:showTips(type, id, count, pos)
    local ret  = dd.getGiftsTips(type, id, count)
    local name = ret[1]
    local str  = ret[2]
    
    local tips = self:getChildByName("tips")
    local wid  = 360
    tips:setVisible(true)
    tips:getChildByName("tips"):removeAllChildren(true)

    local richText = ccui.RichText:create()
    richText:ignoreContentAdaptWithSize(false)
    richText:setContentSize(cc.size(wid-30,600))    
    richText:setAutoHeight()

    local chat = ccui.RichElementText:create(1, cc.c3b(161,175,175), 255, str, "Helvetica", 20)
    richText:insertElement(chat,0)
    richText:formatText()

    local size = richText:getContentSize()
    richText:setPosition(cc.p(172,size.height/2 + 15))
    tips:setContentSize(cc.size(wid, size.height + 60))
    tips:getChildByName("tips"):setContentSize(cc.size(wid, size.height + 60))
    tips:getChildByName("tips"):addChild(richText)

    tips:getChildByName("name"):setString(name) 
    tips:getChildByName("name"):setPositionY(size.height + 40)

    tips:setPosition(pos)
    if pos.x < 100 then
        tips:setAnchorPoint(cc.p(0.2,0))
        tips:getChildByName("flag"):setPositionX(wid*0.2)
    elseif pos.x > 550 then
        tips:setAnchorPoint(cc.p(0.8,0))
        tips:getChildByName("flag"):setPositionX(wid*0.8)
    else
        tips:setAnchorPoint(cc.p(0.5,0))
        tips:getChildByName("flag"):setPositionX(wid*0.5)
    end        
end

function  giftsLayer:unShowTips()
    self:getChildByName("tips"):setVisible(false)
end

function giftsLayer:getWorldPos(node)
    local anr   = node:getAnchorPoint()
    local size  = node:getContentSize()
    local p = node:convertToWorldSpace(cc.p(anr.x * size.width,anr.y * size.height)) --世界坐标
    return p
end

function giftsLayer.onStart(sender)

end

function giftsLayer.onEnd(sender)
    dd.delBackEvent()
    sender:stopAllActions()
    if ff.platform ~= 1 then
        for i,item in ipairs(sender:getChildByName("pop"):getChildByName("list"):getChildren()) do
            if item ~= nil then
                item:getChildByName("back"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))  
            end
        end
    end
end

function giftsLayer.onReturn(sender,eventType)
    local widget = pop.getDialog("gifts")
    if widget then
        pop.onClosePopDialog("gifts")
    end
end
--[[
     gifts格式 = {{["type"] = ,["id"] = ,["count"] = },{["type"] = ,["id"] = ,["count"] = }..}  
             详情见  礼包内容格式定义
--]]
function onShowGifts(widget, gifts,callBack)
    local layer = giftsLayer.extend(widget)
    if gifts ~= nil then
        layer._rewards = gifts
    else
        cclog("数据异常==")
        layer._rewards = {}
    end
    if callBack ~= nil then
        layer._callBack = callBack
    else
        layer._callBack = nil
    end
    dd.regeditBackEvent(layer.onReturn)
    layer:onAutoSize()
    layer:onInit()
    return layer
end