chatLayer   = class("chatLayer")
chatLayer._name = "chat"
chatLayer._init = false
--选中的下方按钮
chatLayer._type = 0
--聊天类型 1=世界2联盟3私聊4群组
chatLayer._chattype = 0
chatLayer._targetid = 0
--聊天对象名称 世界 联盟 为空
chatLayer._targetname=nil

chatLayer._worldData = nil
chatLayer._unionData = nil

chatLayer._chatbox = nil
chatLayer._privatebox = nil
--最大消息id
chatLayer._lastID    = {}
chatLayer._privateID = {}
chatLayer._groupID   = {}

chatLayer._animFrames = {}

--未读消息
--chatLayer.noReadMsgTable={}
chatLayer._firstUnion = false
chatLayer._getMore = false
chatLayer.currentReturnFun=nil--当前回退执行的方法
chatLayer._fromShare = false
chatLayer._fromShareType = 0
chatLayer._fromShareString = ""

--好友面板
chatLayer._friendPannel = nil
chatLayer._groupPannel  = nil
chatLayer._addMemberPannel = nil

chatLayer._index =0

chatLayer._targetuid = 0
chatLayer._targetname = ""

--世界和联盟聊天函数
require "view/chat/ChatControl"
require "view/chat/chatPannel"
require "view/chat/chatFriends"
require "view/chat/chatGroup"
require "view/chat/chatAddMembers"


function chatLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, chatLayer)
    return target
end

--设置返回方法
function chatLayer:setReturnFun(fun)
    if(not fun) then--默认为关闭
        self:getChildByName("top"):getChildByName("return"):addTouchEventListener(self.onReturn)
        self.currentReturnFun=self.onReturn
    else
        self:getChildByName("top"):getChildByName("return"):addTouchEventListener(fun)
        self.currentReturnFun=fun
    end
end

function chatLayer.onReturn(sender,eventType)
    local close = false
    if sender == nil then
        close = true
    end
    if eventType==ccui.TouchEventType.ended then     
        close = true
    end
    if close == true then
        --如果在消息的批量删除状态 则先退出删除状态
        local chat=pop.getDialog("chat")
        --print(chat.msgChatState,chat._type)
        if chat ~= nil and chat._addMemberPannel ~= nil and chat._addMemberPannel:isVisible() == true then
            chat:getChildByName("top"):getChildByName("title"):getChildByName("title"):setString(chat._addMemberPannel._saveTitle)
            chat._addMemberPannel:onEnd()
        else
            pop.onClosePopDialog("chat")        
        end

    end
end

function chatLayer:onInit(index,table)
	if self._init == false then
        local hh = ff.height
        self:setContentSize(cc.size(720,hh))
        self:getChildByName("top"):setPositionY(hh - 105)
        self:getChildByName("back"):setContentSize(cc.size(ff.width,ff.height))
        self:getChildByName("back"):setPosition(cc.p(0,0))
        self:getChildByName("btns"):setPositionY(0)

        self:getChildByName('top'):getChildByName("title"):getChildByName("title"):getVirtualRenderer():enableBold(true)

        --设置控件大小
        --聊天面板大小
        self:getChildByName("chatpanel"):setContentSize(cc.size(ff.width,hh - 105 - 190))
        self:getChildByName("chatpanel"):setPositionY(190)
        self:autoSizeInput(1)

        --选择
        self:getChildByName("btns"):getChildByName("friends"):setTag(1)
        self:getChildByName("btns"):getChildByName("private"):setTag(2)
        self:getChildByName("btns"):getChildByName("union"):setTag(3)
        self:getChildByName("btns"):getChildByName("world"):setTag(4)

        self:getChildByName("btns"):getChildByName("friends"):addTouchEventListener(self.selectGroup)
        self:getChildByName("btns"):getChildByName("private"):addTouchEventListener(self.selectGroup)
        self:getChildByName("btns"):getChildByName("union"):addTouchEventListener(self.selectGroup)
        self:getChildByName("btns"):getChildByName("world"):addTouchEventListener(self.selectGroup)

        --self:getChildByName("top"):getChildByName("return"):addTouchEventListener(self.onReturn)
        self:setReturnFun()

        --稍后界面
        local cache = cc.SpriteFrameCache:getInstance()
        cache:addSpriteFrames("images/mv/normaleffect.plist")

        for j = 1, 12 do
            local frame = nil
            if j < 10 then
                frame = cache:getSpriteFrame("of_native_loader_progress_0"..j..".png")
            else    
                frame = cache:getSpriteFrame("of_native_loader_progress_"..j..".png")
            end 
            self._animFrames[j] = frame
        end
        self:getChildByName("top"):getChildByName("waiting"):getChildByName("icon"):loadTexture("of_native_loader_progress_01.png",1)
        --聊天面板
        self:getChildByName("chatpanel"):getChildByName("chatInput"):getChildByName("skip_send"):addTouchEventListener(self.onSendMessage)    
        self:getChildByName("chatpanel"):getChildByName("privateInput"):getChildByName("skip_send"):addTouchEventListener(self.onSendMessage)    
        self:getChildByName("chatpanel"):getChildByName("privateInput"):getChildByName("addfriend"):addTouchEventListener(self.onShowFriends)    
        --控制条数
        self:getChildByName("chatpanel"):getChildByName("lists"):setMaxLine(200)
        self:getChildByName("chatpanel"):getChildByName("lists"):addScrollViewEventListener(self.scrollViewEvent)

        
        --editbox
        local input      = self:getChildByName("chatpanel"):getChildByName("chatInput"):getChildByName("input")
        local editBoxSize= input:getChildByName("input"):getContentSize()
        cclog("ww:"..editBoxSize.width..",hh:"..editBoxSize.height)
        self._chatbox    = dd.addEditBox(input,editBoxSize,"images/editbox.png",110101,cc.p(0,0),cc.p(5,4),cc.c3b(255,255,255),20,6,4,30 * 100 + 1,120,true,true,true)

        input      = self:getChildByName("chatpanel"):getChildByName("privateInput"):getChildByName("input")
        editBoxSize= input:getChildByName("input"):getContentSize()
        self._privatebox    = dd.addEditBox(input,editBoxSize,"images/editbox.png",110102,cc.p(0,0),cc.p(5,4),cc.c3b(255,255,255),20,6,4,30 * 100 + 1,120,true,true,true)
        

        if cc.PLATFORM_OS_IPHONE == cc.Application:getInstance():getTargetPlatform() or cc.Application:getInstance():getTargetPlatform() == cc.PLATFORM_OS_IPAD then   
            self._chatbox:setAutoStop(false)
            self._privatebox:setAutoStop(false)
        end

        self.copyitem=self:getChildByName("copyitem")
        self.copyitem:getChildByName("copybtn"):addTouchEventListener(self.onCopy)
        self.copyitem:getChildByName("reportbtn"):addTouchEventListener(self.onReport)
        self:getChildByName("top"):getChildByName("addbtn"):addTouchEventListener(dd.onPay)

        self._firstUnion = false
        self._init = true
	end
    self.copyitem:setVisible(false)
    self:showWaiting(false)

    --ID状态 当前id,服务端数据是否已读完，最近一次查询数据ID
    self._lastID = {0,0,0,0}
    self._privateID = {}
    self._targetid  = 0
    self._groupID   = {}
    
    --记录按钮1的位置
    self._fromShare = false
    self._fromShareType = 0
    self._fromShareString = ""
    self:initEvent()

    self:updateTag()
    self:unselectGroup()

    self:getChildByName("chatpanel"):getChildByName("chatInput"):setVisible(false)
    self:getChildByName("chatpanel"):getChildByName("privateInput"):setVisible(false)

    
    if index == 3 then
        self:getChildByName("btns"):getChildByName("union"):loadTextureNormal(dd.getPathFromUI("select.png",1))
        self:getChildByName("btns"):getChildByName("union"):getChildByName("label"):setColor(cc.c3b(255,255,255))
    elseif index == 2 then
        self._fromShare = true
        if table ~= nil and table ~= 0 then
            self._fromShareType = table.type
            self._fromShareString = table.number
        end
        self:getChildByName("btns"):getChildByName("private"):loadTextureNormal(dd.getPathFromUI("select.png",1))
        self:getChildByName("btns"):getChildByName("private"):getChildByName("label"):setColor(cc.c3b(255,255,255))
    elseif index == 4 then
        self:getChildByName("btns"):getChildByName("world"):loadTextureNormal(dd.getPathFromUI("select.png",1))
        self:getChildByName("btns"):getChildByName("world"):getChildByName("label"):setColor(cc.c3b(255,255,255))
    elseif index == 1 then
        self:getChildByName("btns"):getChildByName("friends"):loadTextureNormal(dd.getPathFromUI("select.png",1))
        self:getChildByName("btns"):getChildByName("friends"):getChildByName("label"):setColor(cc.c3b(255,255,255))
    end        
    self._type  = 0
    self._index = index
    self.updateGold()

    self:getChildByName("chatgroup"):setVisible(false)
    self:getChildByName("friendpanel"):setVisible(false)
    self:getChildByName("addmember"):setVisible(false)
    self:getChildByName("chatpanel"):getChildByName("lists"):removeAllChildren(true)
    self:getChildByName("chatpanel"):setVisible(true)
    self:getChildByName("chatpanel"):getChildByName("chatInput"):setVisible(true)

    self._targetuid = 0
    self._targetname = ""        
    if index == 1 and table ~= nil and table['uid'] ~= nil and table['name'] ~= nil then
        self._targetuid  = table['uid']
        self._targetname = table['name']        
    end
end

--角标
function chatLayer:updateTag()
    cclog("updateTag")
    if dd.myFriendsInvite ~= nil and dd.myFriendsInvite:rowCount() > 0 then
        self:getChildByName("btns"):getChildByName("friends"):getChildByName("tag"):setVisible(true)
        self:getChildByName("btns"):getChildByName("friends"):getChildByName("tag"):getChildByName("num"):setString(dd.myFriendsInvite:rowCount())

        if self._friendPannel ~= nil then
            self._friendPannel:getChildByName("btns"):getChildByName("apply"):getChildByName("tag"):setVisible(true)
            self._friendPannel:getChildByName("btns"):getChildByName("apply"):getChildByName("tag"):getChildByName("count"):setString(dd.myFriendsInvite:rowCount())
        end
    else
        if self._friendPannel ~= nil then
            self._friendPannel:getChildByName("btns"):getChildByName("apply"):getChildByName("tag"):setVisible(false)
        end
        self:getChildByName("btns"):getChildByName("friends"):getChildByName("tag"):setVisible(false)
    end
    if dd.myChatHistroy ~= nil then
        local count = 0
        for i=1,dd.myChatHistroy:rowCount() do
            count = count + dd.myChatHistroy:getLong(i,"unread")
        end
        if count <= 0 then
            self:getChildByName("btns"):getChildByName("private"):getChildByName("tag"):setVisible(false)         
        else
            self:getChildByName("btns"):getChildByName("private"):getChildByName("tag"):setVisible(true)
            self:getChildByName("btns"):getChildByName("private"):getChildByName("tag"):getChildByName("num"):setString(count)
        end
    else
        self:getChildByName("btns"):getChildByName("private"):getChildByName("tag"):setVisible(false)         
    end

    if self._type ~= 2 then
        if dd.myChatHistroy ~= nil then
            local count = 0
            for i=1,dd.myChatHistroy:rowCount() do
                count = count + dd.myChatHistroy:getLong(i,"unread")
            end

            if count > 0 then
                self:getChildByName("btns"):getChildByName("private"):getChildByName("tag"):setVisible(true)
                self:getChildByName("btns"):getChildByName("private"):getChildByName("tag"):getChildByName("num"):setString(count)
            else
                self:getChildByName("btns"):getChildByName("private"):getChildByName("tag"):setVisible(false)
            end
        end
    end
    if self._chattype ~= 2 then
        if dd.myinfo:getLong(1,"chat_union") <= 0 then
            self:getChildByName("btns"):getChildByName("union"):getChildByName("tag"):setVisible(false)
        else
            self:getChildByName("btns"):getChildByName("union"):getChildByName("tag"):setVisible(true)
            self:getChildByName("btns"):getChildByName("union"):getChildByName("tag"):getChildByName("num"):setString(dd.myinfo:getLong(1,"chat_union"))
        end
    else
        self:getChildByName("btns"):getChildByName("union"):getChildByName("tag"):setVisible(false)
    end
end

--显示稍等界面
function chatLayer:showWaiting(play)
    self:getChildByName("top"):getChildByName("waiting"):getChildByName("icon"):getVirtualRenderer():stopAllActions()
    if play == true then
        local animation = cc.Animation:createWithSpriteFrames(self._animFrames, 0.1)
        self:getChildByName("top"):getChildByName("waiting"):getChildByName("icon"):getVirtualRenderer():runAction(cc.RepeatForever:create(cc.Animate:create(animation)))
        self:getChildByName("top"):getChildByName("waiting"):setVisible(true) 
    else        
        self:getChildByName("top"):getChildByName("waiting"):setVisible(false)
    end
end

--设置标题
function chatLayer:setTitle(titlestr)
    self:getChildByName("top"):getChildByName("title"):getChildByName("title"):setString(ff.langString(titlestr))
end

--选择按钮
function chatLayer.selectGroup(sender,eventType)
    if eventType==ccui.TouchEventType.ended then     
        local widget = pop.getDialog("chat")
        if widget ~= nil then
            widget:unselectGroup()

            --隐藏角标
            --sender:getChildByName("tag"):setVisible(false)
            local type = sender:getTag()
            sender:loadTextureNormal(dd.getPathFromUI("select.png",1))
            sender:getChildByName("label"):setColor(cc.c3b(255,255,255))
            widget:showPanel(type)
        end    
    end
end

function chatLayer:showPanel(type,share)
    if self._type == type then
        return
    else
        self._type = type    
    end

    self:getChildByName("chatpanel"):setVisible(false)
    self:getChildByName("chatpanel"):getChildByName("chatInput"):setVisible(false)
    self:getChildByName("chatpanel"):getChildByName("privateInput"):setVisible(false)
    if self._friendPannel ~= nil then
        self._friendPannel:onEnd()
    end
    if self._groupPannel ~= nil then
        self._groupPannel:onEnd()
    end
    if self._addMemberPannel ~= nil then
        self._addMemberPannel:onEnd()
    end

    if self._type == 1 then
        self:onShowFriend(true)
        if self._targetuid > 0 then
            self:onShowPrivate(self._targetuid,self._targetname,1)
        end
    elseif self._type == 2 then
        self:onShowChatGroup()
    elseif self._type == 3 then
        self:onShowUnion()
    elseif self._type == 4 then
        self:onShowWorld()
    end    
end

function chatLayer:unselectGroup()
    self:getChildByName("btns"):getChildByName("friends"):loadTextureNormal(dd.getPathFromUI("public/alpha.png",1))
    self:getChildByName("btns"):getChildByName("private"):loadTextureNormal(dd.getPathFromUI("public/alpha.png",1))
    self:getChildByName("btns"):getChildByName("union"):loadTextureNormal(dd.getPathFromUI("public/alpha.png",1))
    self:getChildByName("btns"):getChildByName("world"):loadTextureNormal(dd.getPathFromUI("public/alpha.png",1))

    self:getChildByName("btns"):getChildByName("friends"):getChildByName("label"):setColor(cc.c3b(145,161,166))
    self:getChildByName("btns"):getChildByName("private"):getChildByName("label"):setColor(cc.c3b(145,161,166))
    self:getChildByName("btns"):getChildByName("union"):getChildByName("label"):setColor(cc.c3b(145,161,166))
    self:getChildByName("btns"):getChildByName("world"):getChildByName("label"):setColor(cc.c3b(145,161,166))
end

function chatLayer.scrollViewEvent(sender, evenType)
    if evenType ==  ccui.ScrollviewEventType.bounceTop then
        local chat = pop.getDialog("chat")
        if chat:isVisible() == true and chat:getChildByName("top"):getChildByName("waiting"):isVisible() == false then
            chat:getMoreMessage()
        end    
    end
end

--复制
function chatLayer.onCopy(sender,eventType)
    if eventType == ccui.TouchEventType.ended then     
        local widget = pop.getDialog("chat")
        if widget ~= nil then
            local id = sender:getTag()
            local nt = ff.dbmanager:sql_fetch_rows("select `uid`,`chat` from client_chat where `type`='"..widget._chattype.."' and `targetid`='"..widget._targetid.."' and `id`='"..id.."'")
            if nt ~= nil then
                if nt:rowCount() == 1 then
                    platform_setClipBoard(nt:getString(1,"chat"))
                    --widget._chatbox:setText(widget._chatbox:getText()..nt:getString(1,"chat"))
                end
                nt:clear()
            end
            widget.copyitem:setVisible(false)
        end
    end
end
function chatLayer.onReport(sender,eventType)
    if eventType == ccui.TouchEventType.ended then     
        local widget = pop.getDialog("chat")
        if widget ~= nil then
            widget.copyitem:setVisible(false)
        end
    end
end
--设置输入框的行数
function chatLayer:autoSizeInput(lines)
    local hh = 70 
    local ph = self:getChildByName("chatpanel"):getContentSize().height
    self:getChildByName("chatpanel"):getChildByName("lists"):setContentSize(cc.size(720,ph - hh - 8))
    self:getChildByName("chatpanel"):getChildByName("lists"):setPositionY(hh + 4)
end

function chatLayer.updateGold()
    local widget = pop.getDialog("chat")
    if widget ~= nil then
        widget:getChildByName("top"):getChildByName("nums"):setString(dd.myinfo:getLong(1,"gold"))
        local w = widget:getChildByName("top"):getChildByName("nums"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        widget:getChildByName("top"):getChildByName("title"):setContentSize(cc.size(w,100))
        widget:getChildByName("top"):getChildByName("title"):requestDoLayout()
        widget:getChildByName("top"):requestDoLayout()
    end    
end

function chatLayer:initEvent()
    --更新金币
    ff.net:bindProperty(2611,"gold",self.updateGold) 
    --接收消息返回
    ff.net:registerEvent(2,dd.Tjf_CHAT_GETMESSAGE,self.onChatMessage)
    --离线消息列表
    ff.net:registerEvent(2,dd.Tjf_Chat_GetOutLineMsg,function (message) self:updateTag() end)        
    --有好友邀请
    ff.net:registerEvent(4,dd.Tjf_InviteList,function (message) self:updateTag() end)
    
    --好友列表更新
    ff.net:registerEvent(5,dd.Tjf_Chat_FriendListBack,function (message) self:updateTag() end)

    --群组设置返回
    ff.net:registerEvent(4,dd.Tjf_ChatGroupSetting,function (message) self:updateTag()  end)
    --翻译
    ff.net:registerEvent(4,dd.Tjf_Lang_trans,function (message) self:onTranslate(message)  end)
end

function chatLayer:clearEvent()
    ff.net:unbindProperty("gold",2611)
    ff.net:removeEvent(2,dd.Tjf_Chat_GetOutLineMsg)
    ff.net:removeEvent(2,dd.Tjf_CHAT_GETMESSAGE)
    ff.net:removeEvent(4,dd.Tjf_InviteList)
    ff.net:removeEvent(5,dd.Tjf_Chat_FriendListBack)
    ff.net:removeEvent(4,dd.Tjf_ChatGroupSetting)
    ff.net:removeEvent(4,dd.Tjf_Lang_trans)
    --cclog("=222222222222222222222222")
end

function chatLayer.onBefore(sender)
    dd.initGoldSpine(sender:getChildByName("top"):getChildByName("icon"),sender:getChildByName("top"):getChildByName("addbtn"))
    return true
end
function chatLayer.onEnd(sender)
    sender:showWaiting(false)
    sender:getChildByName("chatpanel"):getChildByName("lists"):removeAllChildren(true)
    sender:clearEvent()
    dd.delBackEvent()

    if sender._friendPannel ~= nil then
        sender._friendPannel:onClose()
    end
    if sender._groupPannel ~= nil then
        sender._groupPannel:onClose()
    end


    --移除复制框

    sender.copyIsAdd=0
end
function chatLayer.onStart(sender)
    sender:showPanel(sender._index)
end

function onShowChat(widget,index,table)
    local layer = chatLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)
	layer:onInit(index,table)
	return layer
end