local chatAddMembers   = class("chatAddMembers")
chatAddMembers._name   = "chatAddMembers"

chatAddMembers._init   = false
chatAddMembers._index  = 0
chatAddMembers._parant = nil
chatAddMembers._view   = nil
chatAddMembers._callback = nil
chatAddMembers._saveTitle = ""
chatAddMembers._data = nil
chatAddMembers._targetid = 0



function chatAddMembers.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, chatAddMembers)
    return target
end

function chatAddMembers:onInit(data,groupid,callback)
    if self._init == false then
        local hh = ff.height - 105 - 190

        self:setContentSize(cc.size(ff.width,hh))
        self:setPositionY(190)

        self:getChildByName("back"):setContentSize(cc.size(720,ff.height))
        self:getChildByName("back"):setPositionY(-190)
        self:getChildByName("pannel"):setPositionY(0)

        self:getChildByName("friends"):setContentSize(cc.size(720,hh - 110 - 8))
        self:getChildByName("friends"):setPositionY(110 + 4)
        self:getChildByName("chu_label"):setPositionY(hh - 300)


        local tableView = cc.TableView:create(self:getChildByName("friends"):getContentSize())
        tableView:setTag(1)
        tableView:setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL)
        tableView:setDelegate()
        tableView:setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN)
        tableView:setPosition(cc.p(0, 0))
        self:getChildByName("friends"):addChild(tableView)

        self:getChildByName("pannel"):getChildByName("infos"):getChildByName("return"):addTouchEventListener(self.onBack)
        self:getChildByName("pannel"):getChildByName("infos"):getChildByName("sure"):addTouchEventListener(self.onSure)
        
        self:getChildByName("pannel"):getChildByName("options"):getChildByName("return"):addTouchEventListener(self.onBack)
        self:getChildByName("pannel"):getChildByName("options"):getChildByName("del"):addTouchEventListener(self.onKick)
        self:getChildByName("pannel"):getChildByName("options"):getChildByName("block"):addTouchEventListener(self.onOver)

        tableView:registerScriptHandler(self.tableCellTouched,cc.TABLECELL_TOUCHED)
        tableView:registerScriptHandler(self.cellSizeForTable,cc.TABLECELL_SIZE_FOR_INDEX)
        tableView:registerScriptHandler(self.tableCellAtIndex,cc.TABLECELL_SIZE_AT_INDEX)
        tableView:registerScriptHandler(self.numberOfCellsInTableView,cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
        self._view = tableView
        self._init = true
    end
    
    if data == nil then
        self._index = 1
        ff.net:registerEvent(2,dd.Tjf_Chat_CreateGroup,self.onShowGroup)
        if self._data ~= nil then
            self._data:clear()
        end
        if dd.myfriends ~= nil then
            self._data = dd.myfriends:copyTo()
            if self._data ~= nil then
                if self._parant._chattype == 3 then
                    for i=1,self._data:rowCount() do
                        if self._data:getLong(i,"uid") == self._parant._targetid then
                            self._data:delRow(i)
                            break
                        end
                    end
                end
            end
        end
        if self._data == nil or self._data:rowCount() <= 0 then
            self:getChildByName("chu_label"):setVisible(true)
            self._view:setVisible(false)
            self:getChildByName("pannel"):setVisible(false)
        else
            self:getChildByName("chu_label"):setVisible(false)
            self._view:setVisible(true)
            self:getChildByName("pannel"):setVisible(true)
            self:getChildByName("pannel"):getChildByName("infos"):setVisible(true)
            self:getChildByName("pannel"):getChildByName("options"):setVisible(false)
        end
    else
        cclog("====dataCount: "..data:rowCount().."===groupid: "..groupid)
        self._targetid = groupid
        self._index = 2
        self._data = data:copyTo()
        for i=1,self._data:rowCount() do
            if self._data:getLong(i,"uid") == dd.uid then
                self._data:delRow(i)
                break
            end
        end
        self:getChildByName("pannel"):setVisible(true)
        self:getChildByName("pannel"):getChildByName("infos"):setVisible(false)
        self:getChildByName("pannel"):getChildByName("options"):setVisible(true)

        self._callback = callback
        self._view:setVisible(true)
    end
    self._saveTitle = self._parant:getChildByName("top"):getChildByName("title"):getChildByName("title"):getString() 
    if self._index == 1 then
        self._parant:setTitle("选择好友")
    elseif self._index == 2 then
        self._parant:setTitle("管理组员")
    end
    self._view:reloadData()
    platform_showWaiting(0)
end

function chatAddMembers.onShowPlayer(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end    
    if eventType==ccui.TouchEventType.ended then    
        doaction = true
    end    
    if doaction == true then
        local uid = sender:getTag()
        if uid == dd.uid then
            return
        end
        pop.onShowPopDialog("power2",pop.getDialog("chat"),uid)
    end
end

function chatAddMembers.tableCellAtIndex(table,idx)
    cclog("chatAddMembers tableCellAtIndex:"..idx)
    local widget = pop.getDialog("chat")
    if widget ~= nil and widget._addMemberPannel ~= nil then
        return widget._addMemberPannel:darwItem(table,idx)
    end
    return nil
end
function chatAddMembers:darwItem(table,idx)
    local users = self._data
    if self._data == nil then
        return nil
    end
    if users:rowCount() < idx + 1 then
        return nil
    end    
    cclog("rows:"..users:rowCount())
    local function onSelect(sender,eventType)
        local doaction = false
        if eventType == ccui.TouchEventType.canceled then
            local startp = sender:getTouchBeganPosition()
            local endp   = sender:getTouchEndPosition()
            if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                doaction = true
            end
        end    
        if eventType==ccui.TouchEventType.ended then    
            doaction = true
        end    
        if doaction == true then
            for i=1,self._data:rowCount() do
                if self._data:getLong(i,"uid") == sender:getTag() then
                    if sender:getSelectedState() == true then
                        self._data:setLong(i,"select",0)
                    else
                        self._data:setLong(i,"select",1)
                    end            
                    break                
                end
            end
        end        
    end


    local row = idx + 1
    local cell = table:dequeueCell()
    local item = nil
    if nil == cell then
        cell = cc.TableViewCell:new()
        item = self:getChildByName("item"):clone()
        item:setTag(1)
        item:setPosition(cc.p(10,0))
        item:setVisible(true)
        item:getChildByName("face"):addTouchEventListener(self.onShowPlayer)
        item:setTouchEnabled(true,false)
        item:getChildByName("selected"):addTouchEventListener(onSelect)
        cell:addChild(item)
    else
        item=cell:getChildByTag(1)
        item:setVisible(true)
        if item:getChildByName("face"):getTag() == users:getLong(row,"id") then
            return cell
        end
    end

    if item ~= nil then
        if users:getLong(row,"select") == 1 then
            item:getChildByName("selected"):setSelectedState(true)
        else
            item:getChildByName("selected"):setSelectedState(false)
        end
        item:getChildByName("face"):setTag(users:getLong(row,"uid"))  
        item:getChildByName("face"):getChildByName("face"):loadTexture(dd.getPlayerIcon(users:getLong(row,"face")),0)
        cclog("self._index is "..self._index)
        if self._index == 1 then
            if users:getLong(row,"online") == 0 then
                local effect = ff.Effect:effectGrey()    
                item:getChildByName("face"):getChildByName("face"):getVirtualRenderer():setGLProgramState(effect:getGLProgramState())
            else    
                item:getChildByName("face"):getChildByName("face"):getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
            end    
            if users:getLong(row,"unionid") > 0 then
                if users:getLong(row,"job") >= 5 then
                    item:getChildByName("info"):getChildByName("ulevel"):setString(users:getLong(row,"job"))
                else
                    item:getChildByName("info"):getChildByName("ulevel"):setString("")
                end
                item:getChildByName("info"):getChildByName("short"):setString("["..users:getString(row,"unionsname").."]")
            else
                item:getChildByName("info"):getChildByName("ulevel"):setString("")
                item:getChildByName("info"):getChildByName("short"):setString("")
            end
        else
            if users:getLong(row,"job") > 0 then
                if users:getLong(row,"job") >= 5 then
                    item:getChildByName("info"):getChildByName("ulevel"):setString(users:getLong(row,"job"))
                else
                    item:getChildByName("info"):getChildByName("ulevel"):setString("")
                end
                item:getChildByName("info"):getChildByName("short"):setString("["..users:getString(row,"unionsname").."]")
            else
                item:getChildByName("info"):getChildByName("ulevel"):setString("")
                item:getChildByName("info"):getChildByName("short"):setString("")
            end
        end

        item:getChildByName("selected"):setTag(users:getLong(row,"uid"))
        item:getChildByName("info"):getChildByName("name"):setString(users:getString(row,"name").." LV."..users:getLong(row,"level"))
        item:getChildByName("info"):requestDoLayout()
    end
    return cell
end

function chatAddMembers.tableCellTouched(table,cell)
end
    
    
function chatAddMembers.cellSizeForTable(table)
    return 144,720
end
    
function chatAddMembers.numberOfCellsInTableView(table)
    local widget = pop.getDialog("chat")
    if widget == nil or widget._addMemberPannel == nil then
        return 0
    else
        if widget._addMemberPannel._data == nil then
            return 0
        else
            return widget._addMemberPannel._data:rowCount()
        end
    end
    return 0
end
--踢人
function chatAddMembers.onKick(sender,eventType)
    if eventType==ccui.TouchEventType.ended then    
        local widget = pop.getDialog("chat")
        if widget ~= nil and widget._addMemberPannel ~= nil then
            local count = 0
            for i=1,widget._addMemberPannel._data:rowCount() do
                if widget._addMemberPannel._data:getLong(i,"select") == 1 then
                    count = count + 1
                end
            end
            if count > 0 then
                local message = ff.net:createMessage()
                ff.net:addCmd(message,0x00000F07)
                message:addLong(dd.uid)
                message:addLong(2)--成员退出
                message:addLong(widget._addMemberPannel._targetid)
                message:addLong(count)
                for i=1,widget._addMemberPannel._data:rowCount() do
                    if widget._addMemberPannel._data:getLong(i,"select") == 1 then
                        message:addLong(widget._addMemberPannel._data:getLong(i,"uid"))
                    end
                end                
                ff.net:rpc(message,false)
                widget:getChildByName("top"):getChildByName("title"):getChildByName("title"):setString(widget._addMemberPannel._saveTitle)
                widget._addMemberPannel:onEnd()      
            end
        end
    end
end
--解散
function chatAddMembers.onOver(sender,eventType)
    if eventType==ccui.TouchEventType.ended then    
        local widget = pop.getDialog("chat")
        if widget ~= nil and widget._addMemberPannel ~= nil then
            local message = ff.net:createMessage()
            ff.net:addCmd(message,0x00000F07)
            message:addLong(dd.uid)
            message:addLong(4)
            message:addLong(widget._addMemberPannel._targetid)
            message:addLong(1)
            message:addLong(dd.uid)
            ff.net:rpc(message,false)
            widget:getChildByName("top"):getChildByName("title"):getChildByName("title"):setString(widget._addMemberPannel._saveTitle)
            widget._addMemberPannel:onEnd()     
        end
    end
end


function chatAddMembers.onBack(sender,eventType)
    if eventType==ccui.TouchEventType.ended then    
        local widget = pop.getDialog("chat")
        if widget ~= nil and widget._addMemberPannel ~= nil then
            widget:getChildByName("top"):getChildByName("title"):getChildByName("title"):setString(widget._addMemberPannel._saveTitle)
            widget._addMemberPannel:onEnd()
        end
    end
end
function chatAddMembers.onSure(sender,eventType)
    if eventType==ccui.TouchEventType.ended then    
        local widget = pop.getDialog("chat")
        if widget ~= nil and widget._addMemberPannel ~= nil then
            widget._addMemberPannel:endSelected()
        end
    end
end
function chatAddMembers.onShowGroup(params)
    cclog("onShowGroup")
    local code = params[1]
    if code == 0 then
        local widget = pop.getDialog("chat")
        if widget ~= nil and widget._addMemberPannel ~= nil then
            widget:getChildByName("top"):getChildByName("title"):getChildByName("title"):setString(widget._addMemberPannel._saveTitle)
            widget._addMemberPannel:onEnd()
            local groupid = params[2]
            for i=1,dd.myChatHistroy:rowCount() do
                if dd.myChatHistroy:getLong(i,"type") == 4 and dd.myChatHistroy:getLong(i,"id") == groupid then
                    widget:onShowGroup(groupid,ff.langString("{0}的聊天组",{dd.myChatHistroy:getString(i,"name")}))
                    break
                end
            end
        end
    else
        dd.mainUI:onShowCodeTips(code)
    end
end
function chatAddMembers:endSelected()
    cclog("endSelected:"..self._parant._chattype)
    local count = 1
    for i=1,self._data:rowCount() do
        if self._data:getLong(i,"select") == 1 then
            count = count + 1
        end
    end
    if self._parant._chattype == 3 then
        if count > 1 then
            local message = ff.net:createMessage()
            ff.net:addCmd(message,0x00000F05)
            message:addLong(dd.uid)
            message:addLong(count)
            message:addLong(self._parant._targetid)
            for i=1,self._data:rowCount() do
                if self._data:getLong(i,"select") == 1 then
                    message:addLong(self._data:getLong(i,"uid"))
                end
            end
            ff.net:rpc(message,false)
        else
            self._parant:getChildByName("top"):getChildByName("title"):getChildByName("title"):setString(self._saveTitle)
            self:onEnd()
        end
    elseif self._parant._chattype == 4 then
        if count > 1 then
            cclog("here............................")
            local message = ff.net:createMessage()
            ff.net:addCmd(message,0x00000F07)
            message:addLong(dd.uid)
            message:addLong(1)
            message:addLong(self._parant._targetid)
            message:addLong(count - 1)
            for i=1,self._data:rowCount() do
                if self._data:getLong(i,"select") == 1 then
                    message:addLong(self._data:getLong(i,"uid"))
                end
            end
            ff.net:rpc(message,false)
            self._parant:getChildByName("top"):getChildByName("title"):getChildByName("title"):setString(self._saveTitle)
            self:onEnd()
        else
            self._parant:getChildByName("top"):getChildByName("title"):getChildByName("title"):setString(self._saveTitle)
            self:onEnd()
        end
    elseif self._parant._type == 2 then
        if count == 2 then
            for i=1,self._data:rowCount() do
                if self._data:getLong(i,"select") == 1 then

                    self._parant:onShowPrivate(self._data:getLong(i,"uid"),self._data:getString(i,"name"),2)
                    break
                end
            end          
            --self._parant:getChildByName("top"):getChildByName("title"):setString(self._saveTitle)
            self:onEnd()              
        elseif count > 2 then
            local message = ff.net:createMessage()
            ff.net:addCmd(message,0x00000F05)
            message:addLong(dd.uid)
            message:addLong(count - 1)
            for i=1,self._data:rowCount() do
                if self._data:getLong(i,"select") == 1 then
                    message:addLong(self._data:getLong(i,"uid"))
                end
            end
            ff.net:rpc(message,false)
        end
    end
end
function chatAddMembers:onEnd()
    self:setVisible(false)
    ff.net:removeEvent(2,dd.Tjf_Chat_CreateGroup)
    if self._data ~= nil then
        self._data:clear()
        self._data = nil 
    end
end
function chatLayer:showAddMember(data,groupid,callback)
    platform_showWaiting(1,0)
    if self._addMemberPannel == nil then
        local widget   = chatAddMembers.extend(self:getChildByName("addmember"))
        self._addMemberPannel = widget
        self._addMemberPannel._parant = self
    end

    self._addMemberPannel:setVisible(true)
    self._addMemberPannel:onInit(data,groupid,callback)
end
