local chatFriends   = class("chatFriends")
chatFriends._name   = "chatFriends"

chatFriends._init   = false
chatFriends._index  = 0
chatFriends._parant = nil
chatFriends._edit   = nil
chatFriends._search = {}
chatFriends._insearch = false
chatFriends._ineditor = false

function chatFriends.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, chatFriends)
    return target
end

function chatFriends:onInit()
    if self._init == false then
        --好友列表面板大小
        local hh = ff.height - 105 - 190

        self:setContentSize(cc.size(ff.width,hh))
        self:setPositionY(190)

        self:getChildByName("btns"):setPositionY(hh - 85)
        self:getChildByName("searchbg"):setPositionY(hh - 90 -30)

        self:getChildByName("addfriend"):setPositionY(hh - 90 - 140)
        self:getChildByName("sysinfo"):setPositionY(hh - 90 - 60 - 80)

        self:getChildByName("friendlist"):setContentSize(cc.size(720,hh - 90 - 140 - 110 -8))
        self:getChildByName("friendlist"):setPositionY(110 + 4)   

        self:getChildByName("searchlist"):setContentSize(cc.size(720,hh - 90 - 80 - 110 - 60-8))
        self:getChildByName("searchlist"):setPositionY(110 + 4)   

        self:getChildByName("blacklist"):setContentSize(cc.size(720,hh - 90 - 110 -8)) 
        self:getChildByName("blacklist"):setPositionY(110 + 4)
        self:getChildByName("applylist"):setContentSize(cc.size(720,hh - 90 -8)) 
        self:getChildByName("applylist"):setPositionY(4)

        self:getChildByName("btns"):getChildByName("friendbtn"):addTouchEventListener(self.showChatFriends)
        self:getChildByName("btns"):getChildByName("blackbtn"):addTouchEventListener(self.showChatBlacks)
        self:getChildByName("btns"):getChildByName("apply"):addTouchEventListener(self.showChatApply)

        self:getChildByName("addfriend"):addTouchEventListener(self.showChatSearch)
        self:getChildByName("addfriend"):getChildByName("addbtn"):addTouchEventListener(self.showChatSearch)

        self:getChildByName("searchbg"):getChildByName("sure"):addTouchEventListener(self.searchPlayer)
        self:getChildByName("pannel"):getChildByName("update"):addTouchEventListener(self.updateSearch)
        self:getChildByName("pannel"):getChildByName("editor"):addTouchEventListener(self.editFriends)
        self:getChildByName("pannel"):getChildByName("infos"):getChildByName("return"):addTouchEventListener(self.returnFriends)
        self:getChildByName("pannel"):getChildByName("infos"):getChildByName("del"):addTouchEventListener(self.delFriends)
        self:getChildByName("pannel"):getChildByName("infos"):getChildByName("block"):addTouchEventListener(self.blockFriends)
        self:getChildByName("pannel"):getChildByName("blackinfo"):getChildByName("return"):addTouchEventListener(self.returnFriends)
        self:getChildByName("pannel"):getChildByName("blackinfo"):getChildByName("del"):addTouchEventListener(self.delBlack)


        self:getChildByName("searchlist"):addScrollViewEventListener(self.scrollViewEvent)


        local editBoxSize = self:getChildByName("searchbg"):getChildByName("input"):getContentSize()
        self._edit    = dd.addEditBox(self:getChildByName("searchbg"):getChildByName("input"),editBoxSize,"images/editbox.png",110105,cc.p(0,0),cc.p(0,0),cc.c3b(255,255,255),20,6,4,1,32,true,true,true)
        self._edit:registerScriptEditBoxHandler(self.searchEditBoxEventHandle)


        --好友
        local tableView = cc.TableView:create(self:getChildByName("friendlist"):getContentSize())
        tableView:setTag(1)
        tableView:setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL)
        tableView:setDelegate()
        tableView:setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN)
        tableView:setPosition(cc.p(0, 0))
        self:getChildByName("friendlist"):addChild(tableView)

        --tableView:registerScriptHandler(self.scrollViewDidScroll,cc.SCROLLVIEW_SCRIPT_SCROLL)
        tableView:registerScriptHandler(self.tableCellTouched,cc.TABLECELL_TOUCHED)
        tableView:registerScriptHandler(self.cellSizeForTable,cc.TABLECELL_SIZE_FOR_INDEX)
        tableView:registerScriptHandler(self.tableCellAtIndex,cc.TABLECELL_SIZE_AT_INDEX)
        tableView:registerScriptHandler(self.numberOfCellsInTableView,cc.NUMBER_OF_CELLS_IN_TABLEVIEW)

        --黑名单
        tableView = cc.TableView:create(self:getChildByName("blacklist"):getContentSize())
        tableView:setTag(3)
        tableView:setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL)
        tableView:setDelegate()
        tableView:setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN)
        tableView:setPosition(cc.p(0, 0))
        self:getChildByName("blacklist"):addChild(tableView)

        --tableView:registerScriptHandler(self.scrollViewDidScroll,cc.SCROLLVIEW_SCRIPT_SCROLL)
        tableView:registerScriptHandler(self.tableCellTouched,cc.TABLECELL_TOUCHED)
        tableView:registerScriptHandler(self.cellSizeForTable,cc.TABLECELL_SIZE_FOR_INDEX)
        tableView:registerScriptHandler(self.tableCellAtIndex,cc.TABLECELL_SIZE_AT_INDEX)
        tableView:registerScriptHandler(self.numberOfCellsInTableView,cc.NUMBER_OF_CELLS_IN_TABLEVIEW)

        --申请列表
        cclog("www:"..self:getChildByName("applylist"):getContentSize().width)
        tableView = cc.TableView:create(self:getChildByName("applylist"):getContentSize())
        tableView:setTag(5)
        tableView:setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL)
        tableView:setDelegate()
        tableView:setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN)
        tableView:setPosition(cc.p(0, 0))
        self:getChildByName("applylist"):addChild(tableView)

        --tableView:registerScriptHandler(self.scrollViewDidScroll,cc.SCROLLVIEW_SCRIPT_SCROLL)
        tableView:registerScriptHandler(self.tableCellTouched,cc.TABLECELL_TOUCHED)
        tableView:registerScriptHandler(self.cellSizeForTable,cc.TABLECELL_SIZE_FOR_INDEX)
        tableView:registerScriptHandler(self.tableCellAtIndex,cc.TABLECELL_SIZE_AT_INDEX)
        tableView:registerScriptHandler(self.numberOfCellsInTableView,cc.NUMBER_OF_CELLS_IN_TABLEVIEW)


        self._init = true
    end

    ff.net:registerEvent(2,dd.Tjf_SerachFriend,self.onSearchBack)
    ff.net:registerEvent(2,dd.Tjf_ChatFriendSetting,self.onDealFriendsBack)
    ff.net:registerEvent(2,dd.Tjf_RecommendFriend,self.onRecommendBack)
    ff.net:registerEvent(2,dd.Tjf_InviteList,self.onInviteList)
    ff.net:registerEvent(2,dd.Tjf_Chat_FriendListBack,self.onFriendList)
    --ff.net:registerEvent(2,dd.Tjf_GetBlackList,self.onBlackBack)
    

    self._search   = {"",0,0}
    self._insearch = false
    self._ineditor = false

    self._index = 1

    self:getChildByName("btns"):getChildByName("friendbtn"):setSelectedState(true)
    self:getChildByName("btns"):getChildByName("apply"):setSelectedState(false)
    self:getChildByName("btns"):getChildByName("blackbtn"):setSelectedState(false)
    self:getChildByName("btns"):getChildByName("friendbtn"):getChildByName("chu_label"):setColor(cc.c3b(239,223,223))
    self:getChildByName("btns"):getChildByName("apply"):getChildByName("chu_label"):setColor(cc.c3b(135,89,89))
    self:getChildByName("btns"):getChildByName("blackbtn"):getChildByName("chu_label"):setColor(cc.c3b(135,89,89))

    self:showFriendType(self._index)

    if dd.myFriendsInvite ~= nil and dd.myFriendsInvite:rowCount() > 0 then
        self:getChildByName("btns"):getChildByName("apply"):getChildByName("tag"):setVisible(true)
        self:getChildByName("btns"):getChildByName("apply"):getChildByName("tag"):getChildByName("count"):setString(dd.myFriendsInvite:rowCount())
    else
        self:getChildByName("btns"):getChildByName("apply"):getChildByName("tag"):setVisible(false)
    end

    platform_showWaiting(0)
end

function chatFriends:unSelect(sender)
    self:getChildByName("btns"):getChildByName("friendbtn"):setSelectedState(false)
    self:getChildByName("btns"):getChildByName("apply"):setSelectedState(false)
    self:getChildByName("btns"):getChildByName("blackbtn"):setSelectedState(false)

    self:getChildByName("btns"):getChildByName("friendbtn"):getChildByName("chu_label"):setColor(cc.c3b(135,89,89))
    self:getChildByName("btns"):getChildByName("apply"):getChildByName("chu_label"):setColor(cc.c3b(135,89,89))
    self:getChildByName("btns"):getChildByName("blackbtn"):getChildByName("chu_label"):setColor(cc.c3b(135,89,89))
    sender:getChildByName("chu_label"):setColor(cc.c3b(239,223,223))
end
function chatFriends:showFriendType(index)
    local hh = self:getContentSize().height
    self:getChildByName("sysinfo"):setVisible(false)
    self:getChildByName("sysinfo"):setPositionY(hh - 90 - 60 - 80)

    self:getChildByName("pannel"):getChildByName("infos"):setVisible(false)
    self:getChildByName("pannel"):getChildByName("blackinfo"):setVisible(false)
    self:getChildByName("pannel"):getChildByName("update"):setVisible(false)


    self._ineditor = false

    self._index = index
    if index == 1 or index == 4 then
        self:getChildByName("btns"):getChildByName("friendbtn"):getChildByName("chu_label"):setColor(cc.c3b(239,223,223))
    else
        self:getChildByName("btns"):getChildByName("friendbtn"):getChildByName("chu_label"):setColor(cc.c3b(135,89,89))
    end
    if index == 2 then
        self:getChildByName("btns"):getChildByName("apply"):getChildByName("chu_label"):setColor(cc.c3b(239,223,223))
    else
        self:getChildByName("btns"):getChildByName("apply"):getChildByName("chu_label"):setColor(cc.c3b(135,89,89))
    end
    if index == 3 then
        self:getChildByName("btns"):getChildByName("blackbtn"):getChildByName("chu_label"):setColor(cc.c3b(239,223,223))
    else
        self:getChildByName("btns"):getChildByName("blackbtn"):getChildByName("chu_label"):setColor(cc.c3b(135,89,89))
    end
    if index == 1 then
        self:showFriends()
    elseif index == 2 then
        self:showFriendsApply()
    elseif index == 3 then
        self:showBlock()
    else
        self:showSearch()
    end    
end
--好友，申请，黑名单 3个按钮
function chatFriends:showFriends()
    local hh = self:getContentSize().height
    self:getChildByName("searchbg"):setVisible(false)
    self:getChildByName("blacklist"):setVisible(false)
    self:getChildByName("applylist"):setVisible(false)
    self:getChildByName("searchlist"):setVisible(false)
    self:getChildByName("friendlist"):setVisible(true)

    self:getChildByName("addfriend"):setVisible(true)
    self:getChildByName("addfriend"):setPositionY(hh - 90 - 140)

    self:getChildByName("pannel"):setVisible(true)
    self:getChildByName("pannel"):getChildByName("editor"):setVisible(true)
    self:getChildByName("pannel"):getChildByName("update"):setVisible(false)
    self:getChildByName("pannel"):getChildByName("infos"):setVisible(false)

    self._parant:setTitle("好友")
    self:updateView(1)
end
function chatFriends:showFriendsApply()
    local hh = self:getContentSize().height
    self:getChildByName("searchbg"):setVisible(false)
    self:getChildByName("friendlist"):setVisible(false)
    self:getChildByName("blacklist"):setVisible(false)
    self:getChildByName("searchlist"):setVisible(false)
    self:getChildByName("addfriend"):setVisible(false)
    self:getChildByName("pannel"):setVisible(false)

    self:getChildByName("sysinfo"):setPositionY(hh - 90 - 80)
    self:getChildByName("applylist"):setVisible(true)
    self._parant:setTitle("好友申请")
    self:updateView(5)
    --self:updateApplyPannel()
end
function chatFriends:showBlock()
    local hh = self:getContentSize().height
    self:getChildByName("searchbg"):setVisible(false)
    self:getChildByName("friendlist"):setVisible(false)
    self:getChildByName("applylist"):setVisible(false)
    self:getChildByName("searchlist"):setVisible(false)
    self:getChildByName("addfriend"):setVisible(false)

    self:getChildByName("blacklist"):setVisible(true)
    self:getChildByName("pannel"):setVisible(true)
    self:getChildByName("pannel"):getChildByName("editor"):setVisible(true)
    
    self._parant:setTitle("黑名单")
    self:updateView(3)
end
function chatFriends:updateView(type)
    if self:isVisible() == true then
        local tableview = nil
        if type == 1 then
            tableview = self:getChildByName("friendlist"):getChildByTag(1)
        elseif type == 3 then    
            tableview = self:getChildByName("blacklist"):getChildByTag(3)
        elseif type == 5 then
            tableview = self:getChildByName("applylist"):getChildByTag(5)
            if dd.myFriendsInvite == nil or dd.myFriendsInvite:rowCount() == 0 then
                self:getChildByName("sysinfo"):getChildByName("chu_label"):setString(ff.langString("暂时没有玩家邀请"))
                self:getChildByName("sysinfo"):setVisible(true)
                self:getChildByName("sysinfo"):requestDoLayout()
            else
                self:getChildByName("sysinfo"):setVisible(false)
            end
        end
        if tableview ~= nil then
            tableview:reloadData()
        end
    end
end
function chatFriends.onFriendList(params)
    local code = params[1]
    if code == 0 then
        local type = params[2]
        if type ~= 0 then
            local widget = pop.getDialog("chat")
            if widget ~= nil and widget._friendPannel ~= nil then
                widget._friendPannel:updateView(1)
            end
        end
    end
end
--[[
function chatFriends.onBlackBack(params)
    local code = params[1]
    if code == 0 then
        local widget = pop.getDialog("chat")
        if widget ~= nil and widget._friendPannel ~= nil then
            widget._friendPannel:updateApplyPannel()
            widget._parant:updateTag()
        end        
    end
end
]]
function chatFriends.onInviteList(params)
    local code = params[1]
    if code == 0 then
        local type = params[2]
        cclog("onInviteList:"..type)
        if type ~= 0 then
            local widget = pop.getDialog("chat")
            if widget ~= nil and widget._friendPannel ~= nil then
                widget._friendPannel:updateView(5)
            end
        end
    end
end

function chatFriends:showSearch()
    local hh = self:getContentSize().height
    self:getChildByName("friendlist"):setVisible(false)
    self:getChildByName("applylist"):setVisible(false)
    self:getChildByName("blacklist"):setVisible(false)
    self:getChildByName("addfriend"):setVisible(false)
    
    self:getChildByName("addfriend"):setVisible(false)
    self:getChildByName("searchbg"):setVisible(true)
    self:getChildByName("searchlist"):setVisible(true)

    self:getChildByName("sysinfo"):setVisible(true)
    self:getChildByName("pannel"):setVisible(true)
    self:getChildByName("pannel"):getChildByName("editor"):setVisible(false)
    self:getChildByName("pannel"):getChildByName("update"):setVisible(true)
    self:getChildByName("pannel"):getChildByName("infos"):setVisible(false)
    self._parant:setTitle("好友查找")

    self._insearch = false
    self._search = {"",0,0}
    self._edit:setText("")
    self:getChildByName("searchbg"):getChildByName("label"):setVisible(true)

    cmd.getRecommendFriend()
    --self:updatePannel()
end
function chatFriends.searchEditBoxEventHandle(strEventName,pSender)
    local edit = pSender
    local widget = pop.getDialog("chat")        
    if widget ~= nil and widget._friendPannel ~= nil then
        if strEventName == "began" then
            widget._friendPannel:getChildByName("searchbg"):getChildByName("label"):setVisible(false)
        elseif strEventName == "ended" then
            local str = widget._friendPannel._edit:getText()
            if string.len(str) > 0 then
                widget._friendPannel:getChildByName("searchbg"):getChildByName("label"):setVisible(false)
            else
                widget._friendPannel:getChildByName("searchbg"):getChildByName("label"):setVisible(true)
            end
        elseif strEventName == "return" then
            local str = widget._friendPannel._edit:getText()
            if string.len(str) > 0 then
                widget._friendPannel:getChildByName("searchbg"):getChildByName("label"):setVisible(false)
            else
                widget._friendPannel:getChildByName("searchbg"):getChildByName("label"):setVisible(true)
            end
        end
    end
end


function chatFriends:updatePannel()    
    local lists = nil
    if self._index == 1 then
        lists = self:getChildByName("friendlist")
    elseif self._index == 2 then
        lists = self:getChildByName("applylist")
    elseif self._index == 3 then
        lists = self:getChildByName("blacklist")
    else
        lists = self:getChildByName("searchlist")
    end
end

function chatFriends.onShowPlayer(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end    
    if eventType==ccui.TouchEventType.ended then    
        doaction = true
    end    
    if doaction == true then
        local uid = sender:getTag()
        if uid == dd.uid then
            return
        end
        pop.onShowPopDialog("power2",pop.getDialog("chat"),uid)
    end
end
--显示私聊
function chatFriends.onShowPrivate(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end    
    if eventType==ccui.TouchEventType.ended then    
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end    
    if doaction == true then
        local widget = pop.getDialog("chat")
        local uid = sender:getChildByName("face"):getTag()
        if uid ~= dd.uid and widget._friendPannel._ineditor == false then
            for i=1,dd.myfriends:rowCount() do
                if dd.myfriends:getLong(i,"uid") == uid then
                    if widget ~= nil then
                        widget:onShowPrivate(uid,dd.myfriends:getString(i,"name"),1)
                    end
                    break
                end
            end
        end
    end
end

function chatFriends.searchPlayer(sender,eventType)
    if eventType==ccui.TouchEventType.ended then 
        local widget = pop.getDialog("chat")
        if widget ~= nil and widget._friendPannel ~= nil then
            local name = widget._friendPannel._edit:getText()
            if string.len(name) <= 0 then
                dd.mainUI:onShowTips("\t"..ff.langString("输入的用户名不能为空"))
            elseif name == dd.myinfo:getString(1,"name") then
                dd.mainUI:onShowTips("\t"..ff.langString("不能添加自己为好友"))
            else
                widget._friendPannel._search = {name,0,0}
                cmd.searchFriendListByName(1,name)
            end
        end
    end
end
function chatFriends.onSearchBack(params)
    local code = params[1]
    if code == 0 then
        local users = params[2]
        local page  = params[3]
        local all   = params[4]
        local nums  = params[5]
        local widget = pop.getDialog("chat")
        cclog("page:"..page..",num:"..nums..",all:"..all)
        if widget ~= nil and widget._friendPannel ~= nil then
            if page == 1 then
                widget._friendPannel._insearch = true
                widget._friendPannel:getChildByName("sysinfo"):getChildByName("chu_label"):setString(ff.langString("查询结果"))
                widget._friendPannel:getChildByName("sysinfo"):requestDoLayout()
                widget._friendPannel:onUpdateSearch(users,true)
            else
                widget._friendPannel:onUpdateSearch(users,false)
            end
            widget._friendPannel._search[2] = page
            widget._friendPannel._search[3] = all    
        end
    else
        dd.mainUI:onShowCodeTips(code)
    end
end
function chatFriends.scrollViewEvent(sender, evenType)
    if evenType ==  ccui.ScrollviewEventType.bounceBottom then
        local chat = pop.getDialog("chat")
        if chat ~= nil and chat._friendPannel ~= nil then
            if chat._friendPannel._index == 4 then
                if chat._friendPannel._insearch == true then
                    local params = chat._friendPannel._search
                    if table.getn(params) == 3 then
                        local name = params[1]
                        local page = params[2]
                        local all  = params[3]
                        if all > (page + 1) * 10 and page < 10 then
                            cmd.searchFriendListByName(page + 1,name)
                        end
                    end
                end
            end
        end
    end
end

function chatFriends:onUpdateSearch(users,clear)
    local function addFriend(sender,eventType)
        local doaction = false
        if eventType == ccui.TouchEventType.canceled then
            local startp = sender:getTouchBeganPosition()
            local endp   = sender:getTouchEndPosition()
            if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                doaction = true
            end
        end    
        if eventType==ccui.TouchEventType.ended then    
            doaction = true
        end    
        if doaction == true then    
            local message = ff.net:createMessage()
            ff.net:addCmd(message,0x00000F03)
            message:addLong(dd.uid)
            message:addLong(1)
            message:addLong(1)
            message:addLong(sender:getTag())
            ff.net:rpc(message,false)            
        end
    end
    if clear == nil then
        clear = true
    end
    if clear == true then
        self:getChildByName("searchlist"):removeAllChildren()
    end
    if users ~= nil then
        for i=1,users:rowCount() do
            local item = self:getChildByName("item"):clone()
            item:setTag(users:getLong(i,"uid"))
            item:getChildByName("face"):setTag(users:getLong(i,"uid"))
            item:getChildByName("face"):getChildByName("face"):loadTexture(dd.getPlayerIcon(users:getLong(i,"face")),0)

            local show = true
            for row=1,dd.myfriends:rowCount() do
                if dd.myfriends:getLong(row,"uid") == users:getLong(i,"uid") then
                    show = false
                    break
                end
            end
            item:getChildByName("add"):setVisible(show)
            item:getChildByName("add"):setTag(users:getLong(i,"uid"))

            if users:getLong(i,"unionid") > 0 then
                if users:getLong(i,"ulevel") >= 5 then
                    item:getChildByName("info"):getChildByName("ulevel"):setString(users:getLong(i,"ulevel"))
                else
                    item:getChildByName("info"):getChildByName("ulevel"):setString("")
                end
                item:getChildByName("info"):getChildByName("name"):setString("["..users:getString(i,"unionsname").."]"..users:getString(i,"name").." LV."..users:getLong(i,"level"))
            else
                item:getChildByName("info"):getChildByName("ulevel"):setString("")
                item:getChildByName("info"):getChildByName("name"):setString(users:getString(i,"name").." LV."..users:getLong(i,"level"))
            end
            item:getChildByName("add"):addTouchEventListener(addFriend)
            item:getChildByName("face"):addTouchEventListener(self.onShowPlayer)
            item:setVisible(true)
            self:getChildByName("searchlist"):addChild(item)
        end
        self:getChildByName("searchlist"):refreshView()
        if self._insearch == true then
            if clear == true then
                self:getChildByName("searchlist"):scrollToTop(0.5,true)
            else
                if users:rowCount() <= 5 then
                    self:getChildByName("searchlist"):scrollToTop(0.5,true)
                else
                    self:getChildByName("searchlist"):getInnerContainer():runAction(cc.MoveBy:create(0.3,cc.p(0,20)))
                end
            end
        else
            if users:rowCount() <= 5 then
                self:getChildByName("searchlist"):scrollToTop(0.5,true)
            end
        end
    end
end
--好友，黑名单编辑
function chatFriends.editFriends(sender,eventType)
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("chat")
        if widget ~= nil and widget._friendPannel ~= nil then
            sender:setVisible(false)
            widget._friendPannel._ineditor = true
            
            if widget._friendPannel._index == 1 then
                widget._friendPannel:getChildByName("pannel"):getChildByName("infos"):setVisible(true)
                for i=1,dd.myfriends:rowCount() do
                    dd.myfriends:setLong(i,"effect",0)
                    dd.myfriends:setLong(i,"select",0)
                end
                for j,cell in ipairs(widget._friendPannel:getChildByName("friendlist"):getChildByTag(1):getContainer():getChildren()) do
                    local item = cell:getChildByTag(1)
                    if item ~= nil and item:isVisible() == true then
                        item:getChildByName("face"):setPositionX(70)
                        item:getChildByName("info"):setPositionX(145)
                        item:getChildByName("selected"):setPositionX(-20)
                        item:getChildByName("selected"):setSelectedState(false)

                        item:getChildByName("selected"):setOpacity(0)
                        local action = cc.Spawn:create(
                                    cc.EaseExponentialOut:create(cc.MoveBy:create(0.5,cc.p(50,0))),
                                    cc.FadeIn:create(0.5)
                                    )            
                        item:getChildByName("face"):runAction(cc.EaseExponentialOut:create(cc.MoveBy:create(0.5,cc.p(50,0))))
                        item:getChildByName("selected"):runAction(action)
                        item:getChildByName("info"):runAction(cc.EaseExponentialOut:create(cc.MoveBy:create(0.5,cc.p(50,0))))
                        item:getChildByName("selected"):setVisible(true)
                    end
                end
            else
                widget._friendPannel:getChildByName("pannel"):getChildByName("blackinfo"):setVisible(true)
                for i=1,dd.myBlackList:rowCount() do
                    dd.myBlackList:setLong(i,"effect",0)
                    dd.myBlackList:setLong(i,"select",0)
                end
                for j,cell in ipairs(widget._friendPannel:getChildByName("blacklist"):getChildByTag(3):getContainer():getChildren()) do
                    local item = cell:getChildByTag(1)
                    if item ~= nil and item:isVisible() == true then
                        item:getChildByName("face"):setPositionX(70)
                        item:getChildByName("info"):setPositionX(145)
                        item:getChildByName("selected"):setPositionX(-20)
                        item:getChildByName("selected"):setSelectedState(false)

                        item:getChildByName("selected"):setOpacity(0)
                        local action = cc.Spawn:create(
                                    cc.EaseExponentialOut:create(cc.MoveBy:create(0.5,cc.p(50,0))),
                                    cc.FadeIn:create(0.5)
                                    )            
                        item:getChildByName("face"):runAction(cc.EaseExponentialOut:create(cc.MoveBy:create(0.5,cc.p(50,0))))
                        item:getChildByName("selected"):runAction(action)
                        item:getChildByName("info"):runAction(cc.EaseExponentialOut:create(cc.MoveBy:create(0.5,cc.p(50,0))))
                        item:getChildByName("selected"):setVisible(true)
                    end
                end            
            end
        end
    end
end
function chatFriends.returnFriends(sender,eventType)
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("chat")
        if widget ~= nil and widget._friendPannel ~= nil then
            widget._friendPannel._ineditor = false
            widget._friendPannel:getChildByName("pannel"):getChildByName("editor"):setVisible(true)
            if widget._friendPannel._index == 1 then
                widget._friendPannel:getChildByName("pannel"):getChildByName("infos"):setVisible(false)
                local offset = widget._friendPannel:getChildByName("friendlist"):getChildByTag(1):getContentOffset()
                widget._friendPannel:getChildByName("friendlist"):getChildByTag(1):reloadData()
                widget._friendPannel:getChildByName("friendlist"):getChildByTag(1):setContentOffset(offset)
            else
                widget._friendPannel:getChildByName("pannel"):getChildByName("blackinfo"):setVisible(false)
                local offset = widget._friendPannel:getChildByName("blacklist"):getChildByTag(3):getContentOffset()
                widget._friendPannel:getChildByName("blacklist"):getChildByTag(3):reloadData()
                widget._friendPannel:getChildByName("blacklist"):getChildByTag(3):setContentOffset(offset)
                widget._friendPannel:getChildByName("blacklist"):getChildByTag(3):reloadData()
            end
        end
    end
end
function chatFriends.delFriends(sender,eventType)    
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("chat")
        if widget ~= nil and widget._friendPannel ~= nil then
            local count = 0
            for i=1,dd.myfriends:rowCount() do
                if dd.myfriends:getLong(i,"select") == 1 then
                    count = count + 1
                end
            end
            if count > 0 then
                local message = ff.net:createMessage()
                ff.net:addCmd(message,0x00000F03)
                message:addLong(dd.uid)
                message:addLong(5)
                message:addLong(count)
                for i=1,dd.myfriends:rowCount() do
                    if dd.myfriends:getLong(i,"select") == 1 then
                        cclog("uid:"..dd.myfriends:getLong(i,"uid")..","..dd.myfriends:getString(i,"name"))
                        message:addLong(dd.myfriends:getLong(i,"uid"))
                    end
                end
                ff.net:rpc(message,false)      
            end
        end
    end    
end


function chatFriends.delBlack(sender,eventType)
    if eventType == ccui.TouchEventType.ended then
        cclog("delBlack")
        local widget = pop.getDialog("chat")
        if widget ~= nil and widget._friendPannel ~= nil then
            local count = 0
            for i=1,dd.myBlackList:rowCount() do
                if dd.myBlackList:getLong(i,"select") == 1 then
                    count = count + 1
                end
            end
            if count > 0 then
                local message = ff.net:createMessage()
                ff.net:addCmd(message,0x00000F03)
                message:addLong(dd.uid)
                message:addLong(7)
                message:addLong(count)
                cclog("count:"..count)
                for i=1,dd.myBlackList:rowCount() do
                    if dd.myBlackList:getLong(i,"select") == 1 then
                        cclog("uid:"..dd.myBlackList:getLong(i,"uid")..","..dd.myBlackList:getString(i,"name"))
                        message:addLong(dd.myBlackList:getLong(i,"uid"))
                    end
                end
                ff.net:rpc(message,false)      
            end
        end
    end    
end

function chatFriends.blockFriends(sender,eventType)
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("chat")
        if widget ~= nil and widget._friendPannel ~= nil then
            local count = 0
            for i=1,dd.myfriends:rowCount() do
                if dd.myfriends:getLong(i,"select") == 1 then
                    count = count + 1
                end
            end
            if count > 0 then
                local message = ff.net:createMessage()
                ff.net:addCmd(message,0x00000F03)
                message:addLong(dd.uid)
                message:addLong(6)
                message:addLong(count)
                cclog("count:"..count)
                for i=1,dd.myfriends:rowCount() do
                    if dd.myfriends:getLong(i,"select") == 1 then
                        cclog("uid:"..dd.myfriends:getLong(i,"uid")..","..dd.myfriends:getString(i,"name"))
                        message:addLong(dd.myfriends:getLong(i,"uid"))
                    end
                end
                ff.net:rpc(message,false)      
            end
        end
    end    
end

function chatFriends.showChatFriends(sender,eventType)
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("chat")
        if widget ~= nil then
            if sender:getSelectedState() == true and widget._friendPannel._index ~= 4 then
                sender:setSelectedState(false)
                return
            end
            widget._friendPannel:unSelect(sender)
            widget._friendPannel:showFriendType(1)
        end
    end
end
function chatFriends.showChatBlacks(sender,eventType)
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("chat")
        if widget ~= nil then
            if sender:getSelectedState() == true then
                sender:setSelectedState(false)
                return
            end
            widget._friendPannel:unSelect(sender)
            widget._friendPannel:showFriendType(3)
        end
    end
end
function chatFriends.showChatApply(sender,eventType)
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("chat")
        if widget ~= nil then
            if sender:getSelectedState() == true then
                sender:setSelectedState(false)
                return
            end
            widget._friendPannel:unSelect(sender)
            widget._friendPannel:showFriendType(2)
        end
    end
end
function chatFriends.showChatSearch(sender,eventType)
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("chat")
        if widget ~= nil then
            widget._friendPannel:showFriendType(4)
        end
    end
end

function chatFriends.updateSearch(sender,eventType)
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("chat")
        if widget ~= nil and widget._friendPannel ~= nil then
            widget._friendPannel._search = {"",0,0}
        end
        cmd.getRecommendFriend()
    end
end

function chatFriends.onDealFriendsBack(param)
    local code = param[1]
    if code == 0 then
        local widget = pop.getDialog("chat")
        if widget == nil or widget._friendPannel == nil then
            return
        end
        local type = param[2]
        local users = param[3]
        if type == 1 then
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("成功发送好友邀请"),true)
        elseif type == 3 or type == 4 then
            if widget._friendPannel._index == 2 then
                if dd.myFriendsInvite ~= nil and dd.myFriendsInvite:rowCount() <= 0 then
                    widget._friendPannel:getChildByName("sysinfo"):getChildByName("chu_label"):setString(ff.langString("暂时没有玩家邀请"))
                    widget._friendPannel:getChildByName("sysinfo"):setVisible(true)
                    widget._friendPannel:getChildByName("sysinfo"):requestDoLayout()
                    widget._friendPannel:getChildByName("applylist"):getChildByTag(5):reloadData()
                else
                    if dd.myFriendsInvite ~= nil then
                        widget._friendPannel:getChildByName("sysinfo"):setVisible(false)
                        if dd.myFriendsInvite:rowCount() * 144 > 1280 then
                            local offset = widget._friendPannel:getChildByName("applylist"):getChildByTag(5):getContentOffset()
                            widget._friendPannel:getChildByName("applylist"):getChildByTag(5):reloadData()
                            cclog("offset:"..offset.x..","..offset.y)
                            widget._friendPannel:getChildByName("applylist"):getChildByTag(5):setContentOffset(offset)
                        else
                            widget._friendPannel:getChildByName("applylist"):getChildByTag(5):reloadData()
                        end
                    end
                end
            end
            widget:updateTag()            
        elseif type == 5 then
            widget._friendPannel:updateView(1)
        elseif type == 7 then
            widget._friendPannel:updateView(3)
        end
    else
        dd.mainUI:onShowCodeTips(code)
    end
end
function chatFriends.onRecommendBack(param)
    local code = param[1]
    if code == 0 then
        local widget = pop.getDialog("chat")
        if widget ~= nil and widget._friendPannel ~= nil then
            widget._friendPannel:getChildByName("sysinfo"):getChildByName("chu_label"):setString(ff.langString("以下为系统为您推荐的好友"))
            widget._friendPannel:getChildByName("sysinfo"):requestDoLayout()
            widget._friendPannel._insearch = false
            widget._friendPannel:onUpdateSearch(param[2])
        end
    else
        dd.mainUI:onShowCodeTips(code)
    end
end

function chatFriends.tableCellAtIndex(table,idx)
    cclog("tableCellAtIndex:"..idx)
    local widget = pop.getDialog("chat")
    if widget ~= nil and widget._friendPannel ~= nil then
        if table:getTag() == 5 then
            return widget._friendPannel:darwApplyItem(table,idx)
        else
            return widget._friendPannel:darwItem(table,idx)
        end
    end
    return nil
end
function chatFriends:darwItem(table,idx)
    local function onSelect(sender,eventType)
        local doaction = false
        if eventType == ccui.TouchEventType.canceled then
            local startp = sender:getTouchBeganPosition()
            local endp   = sender:getTouchEndPosition()
            if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                doaction = true
            end
        end    
        if eventType==ccui.TouchEventType.ended then    
            doaction = true
        end    
        if doaction == true then
            local uid = sender:getTag()
            if table:getTag() == 1 then
                for i=1,dd.myfriends:rowCount() do
                    if dd.myfriends:getLong(i,"uid") == uid then
                        if sender:getSelectedState() == true then
                            dd.myfriends:setLong(i,"select",0)
                        else
                            dd.myfriends:setLong(i,"select",1)
                        end
                    end
                end
            elseif table:getTag() == 3 then
                for i=1,dd.myBlackList:rowCount() do
                    if dd.myBlackList:getLong(i,"uid") == uid then
                        if sender:getSelectedState() == true then
                            dd.myBlackList:setLong(i,"select",0)
                        else
                            dd.myBlackList:setLong(i,"select",1)
                        end
                    end
                end
            end
        end        
    end

    local users = nil
    if table:getTag() == 1 then
        users = dd.myfriends
    elseif table:getTag() == 3 then
        users = dd.myBlackList
    end
    if users == nil then
        return nil
    end
    if users:rowCount() < idx + 1 then
        return nil
    end
    local row = idx + 1
    local cell = table:dequeueCell()
    local item = nil
    if nil == cell then
        cell = cc.TableViewCell:new()
        item = self:getChildByName("item"):clone()
        item:setTag(1)
        item:setPosition(cc.p(10,0))
        item:setVisible(true)
        item:getChildByName("face"):addTouchEventListener(self.onShowPlayer)
        item:setTouchEnabled(true,false)
        item:addTouchEventListener(self.onShowPrivate)
        item:getChildByName("selected"):addTouchEventListener(onSelect)
        cell:addChild(item)
    else
        item=cell:getChildByTag(1)
        --内容相同，直接显示
        if item:getChildByName("face"):getTag() == users:getLong(row,"uid") then
            if self._ineditor == true then
                if dd.myfriends:getLong(row,"select") == 1 then
                    item:getChildByName("selected"):setSelectedState(true)
                else
                    item:getChildByName("selected"):setSelectedState(false)
                end                    
                item:getChildByName("face"):setPositionX(120)
                item:getChildByName("selected"):setPositionX(30)
                item:getChildByName("info"):setPositionX(195)
                item:getChildByName("selected"):setVisible(true)
            else
                item:getChildByName("face"):setPositionX(70)
                item:getChildByName("selected"):setVisible(false)
                item:getChildByName("info"):setPositionX(145)
            end   
            return cell
        end
    end
    
    if item ~= nil then      
        if self._ineditor == true then
            item:getChildByName("face"):setPositionX(120)
            item:getChildByName("selected"):setPositionX(30)            
            item:getChildByName("info"):setPositionX(195)
            item:getChildByName("selected"):setVisible(true)                        
            if dd.myfriends:getLong(row,"select") == 1 then
                item:getChildByName("selected"):setSelectedState(true)
            else
                item:getChildByName("selected"):setSelectedState(false)
            end                  
        else
            item:getChildByName("face"):setPositionX(70)
            item:getChildByName("selected"):setVisible(false)
            item:getChildByName("info"):setPositionX(145)
        end        
        item:getChildByName("face"):setTag(users:getLong(row,"uid"))
        item:getChildByName("face"):getChildByName("face"):loadTexture(dd.getPlayerIcon(users:getLong(row,"face")),0)
        if users:getLong(row,"online") == 0 then
            local effect = ff.Effect:effectGrey()    
            item:getChildByName("face"):getChildByName("face"):getVirtualRenderer():setGLProgramState(effect:getGLProgramState())
        else    
            item:getChildByName("face"):getChildByName("face"):getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
        end    

        if users:getLong(row,"unionid") > 0 then
            if users:getLong(row,"job") >= 5 then
                item:getChildByName("info"):getChildByName("ulevel"):setString(users:getLong(row,"job"))
            else
                item:getChildByName("info"):getChildByName("ulevel"):setString("")
            end
            item:getChildByName("info"):getChildByName("short"):setString("["..users:getString(row,"unionsname").."]")
        else
            item:getChildByName("info"):getChildByName("ulevel"):setString("")
            item:getChildByName("info"):getChildByName("short"):setString("")
        end
        item:getChildByName("selected"):setTag(users:getLong(row,"uid"))
        item:getChildByName("info"):getChildByName("name"):setString(users:getString(row,"name").." LV."..users:getLong(row,"level"))
        item:getChildByName("info"):requestDoLayout()
    end
    return cell
end
--[[
function chatFriends:updateApplyPannel()
    local function sureApply(sender,eventType)
        local doaction = false
        if eventType == ccui.TouchEventType.canceled then
            local startp = sender:getTouchBeganPosition()
            local endp   = sender:getTouchEndPosition()
            if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                doaction = true
            end
        end    
        if eventType==ccui.TouchEventType.ended then    
            doaction = true
        end    
        if doaction == true then
            local uid = sender:getTag()
            if uid == dd.uid then
                return
            end
            local message = ff.net:createMessage()
            ff.net:addCmd(message,0x00000F03)
            message:addLong(dd.uid)
            message:addLong(3)
            message:addLong(1)
            message:addLong(sender:getTag())
            ff.net:rpc(message,false)      
        end    
    end
    local function cacelApply(sender,eventType)
        local doaction = false
        if eventType == ccui.TouchEventType.canceled then
            local startp = sender:getTouchBeganPosition()
            local endp   = sender:getTouchEndPosition()
            if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                doaction = true
            end
        end    
        if eventType==ccui.TouchEventType.ended then    
            doaction = true
        end    
        if doaction == true then
            local uid = sender:getTag()
            if uid == dd.uid then
                return
            end
            local message = ff.net:createMessage()
            ff.net:addCmd(message,0x00000F03)
            message:addLong(dd.uid)
            message:addLong(4)
            message:addLong(1)
            message:addLong(sender:getTag())
            ff.net:rpc(message,false)      
        end       
    end
    self:getChildByName("sysinfo"):setVisible(false)
    local users = dd.myFriendsInvite
    if users == nil then
        self:getChildByName("sysinfo"):getChildByName("chu_label"):setString(ff.langString("暂时没有玩家邀请"))
        self:getChildByName("sysinfo"):setVisible(true)
        self:getChildByName("sysinfo"):requestDoLayout()
        return
    end
    if users:rowCount() < 1 then
        self:getChildByName("applylist"):removeAllChildren()
        self:getChildByName("sysinfo"):getChildByName("chu_label"):setString(ff.langString("暂时没有玩家邀请"))
        self:getChildByName("sysinfo"):setVisible(true)
        self:getChildByName("sysinfo"):requestDoLayout()
    else
        for i=1,dd.myFriendsInvite:rowCount() do
            cclog("add:"..dd.myfriends:getLong(i,"uid"))
            local item = nil
            item = self:getChildByName("applylist"):getChildByTag(users:getLong(i,"uid"))
            if item == nil then
                item = self:getChildByName("item2"):clone()
                item:setTag(users:getLong(i,"uid"))
                item:getChildByName("face"):setTag(users:getLong(i,"uid"))
                item:getChildByName("face"):getChildByName("face"):loadTexture(dd.getPlayerIcon(users:getLong(i,"face")),0)

                if users:getLong(i,"unionid") > 0 then
                    if users:getLong(i,"ulevel") >= 5 then
                        item:getChildByName("ulevel"):setString(users:getLong(i,"ulevel"))
                    else
                        item:getChildByName("ulevel"):setString("")
                    end
                    item:getChildByName("info"):getChildByName("name"):setString("["..users:getString(i,"short").."]"..users:getString(i,"name").." LV."..users:getLong(i,"level"))
                else
                    item:getChildByName("info"):getChildByName("name"):setString(users:getString(i,"name").." LV."..users:getLong(i,"level"))
                    item:getChildByName("ulevel"):setString("")
                end
                item:getChildByName("info"):requestDoLayout()

                item:getChildByName("yes"):setTag(users:getLong(i,"uid"))
                item:getChildByName("no"):setTag(users:getLong(i,"uid"))
                item:getChildByName("yes"):addTouchEventListener(sureApply)
                item:getChildByName("no"):addTouchEventListener(cacelApply)
                item:getChildByName("face"):addTouchEventListener(self.onShowPlayer)
                item:setVisible(true)
                self:getChildByName("applylist"):addChild(item)
            end
        end
        --去掉无效的
        for j,item in ipairs(self:getChildByName("applylist"):getChildren()) do
            local uid = item:getTag()
            local have = false
            for i=1,dd.myFriendsInvite:rowCount() do
                if dd.myFriendsInvite:getLong(i,"uid") == uid then
                    have = true
                    break
                end
            end            
            if have == false then
                cclog("remove..........")
                item:removeFromParent(true)
            end
        end
        self:getChildByName("applylist"):refreshView()
    end
end
]]
function chatFriends:darwApplyItem(table,idx)
    local function sureApply(sender,eventType)
        local doaction = false
        if eventType == ccui.TouchEventType.canceled then
            local startp = sender:getTouchBeganPosition()
            local endp   = sender:getTouchEndPosition()
            if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                doaction = true
            end
        end    
        if eventType==ccui.TouchEventType.ended then    
            doaction = true
        end    
        if doaction == true then
            local uid = sender._uid
            if uid == dd.uid then
                return
            end
            local message = ff.net:createMessage()
            ff.net:addCmd(message,0x00000F03)
            message:addLong(dd.uid)
            message:addLong(3)
            message:addLong(1)
            message:addLong(sender:getTag())
            ff.net:rpc(message,false)      
        end    
    end
    local function cacelApply(sender,eventType)
        local doaction = false
        if eventType == ccui.TouchEventType.canceled then
            local startp = sender:getTouchBeganPosition()
            local endp   = sender:getTouchEndPosition()
            if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                doaction = true
            end
        end    
        if eventType==ccui.TouchEventType.ended then    
            doaction = true
        end        
        if doaction == true then
            local uid = sender._uid
            if uid == dd.uid then
                return
            end
            local message = ff.net:createMessage()
            ff.net:addCmd(message,0x00000F03)
            message:addLong(dd.uid)
            message:addLong(4)
            message:addLong(1)
            message:addLong(sender:getTag())
            ff.net:rpc(message,false)      
        end       
    end

    local users = dd.myFriendsInvite
    if users == nil then
        return nil
    end
    if users:rowCount() < idx + 1 then
        return nil
    end
    local row = idx + 1
    local cell = table:dequeueCell()
    local item = nil
    if nil == cell then
        cell = cc.TableViewCell:new()
        item = self:getChildByName("item2"):clone()
        item:setTag(1)
        item:setPosition(cc.p(10,0))
        item:setVisible(true)
        item:getChildByName("yes"):addTouchEventListener(sureApply)
        item:getChildByName("no"):addTouchEventListener(cacelApply)
        item:getChildByName("face"):addTouchEventListener(self.onShowPlayer)
        item:setTouchEnabled(true,false)
        item._uid = 0
        cell:addChild(item)
    else
        item=cell:getChildByTag(1)
        if item._uid == users:getLong(row,"uid") then
            item:setVisible(true)
            return cell
        end
    end
    if item ~= nil then      
        item._uid = users:getLong(row,"uid")
        item:getChildByName("face"):setTag(users:getLong(row,"uid"))
        item:getChildByName("face"):getChildByName("face"):loadTexture(dd.getPlayerIcon(users:getLong(row,"face")),0)

        if users:getLong(row,"unionid") > 0 then
            if users:getLong(row,"ulevel") >= 5 then
                item:getChildByName("ulevel"):setString(users:getLong(row,"ulevel"))
            else
                item:getChildByName("ulevel"):setString("")
            end
            item:getChildByName("info"):getChildByName("name"):setString("["..users:getString(row,"short").."]"..users:getString(row,"name").." LV."..users:getLong(row,"level"))
        else
            item:getChildByName("info"):getChildByName("name"):setString(users:getString(row,"name").." LV."..users:getLong(row,"level"))
            item:getChildByName("ulevel"):setString("")
        end
        item:getChildByName("info"):requestDoLayout()

        item:getChildByName("yes"):setTag(users:getLong(row,"uid"))
        item:getChildByName("no"):setTag(users:getLong(row,"uid"))
        item:setVisible(true)
    end
    return cell
end

function chatFriends.tableCellTouched(table,cell)
    cclog("tableCellTouched")
    local widget = pop.getDialog("chat")
    if widget ~= nil and widget._friendPannel ~= nil then
    end
end
    
    
function chatFriends.cellSizeForTable(table)
    return 144,720
end
    
function chatFriends.numberOfCellsInTableView(table)
    if table:getTag() == 1 then
        if dd.myfriends == nil then
            return 0
        else
            return dd.myfriends:rowCount()
        end
    elseif table:getTag() == 3 then
        if dd.myBlackList == nil then
            return 0
        else    
            return dd.myBlackList:rowCount()
        end
    elseif table:getTag() == 5 then
        if dd.myFriendsInvite == nil then
            return 0
        else
            return dd.myFriendsInvite:rowCount()
        end   
    end
    return 0
end


function chatFriends:onClose()
    ff.net:removeEvent(2,dd.Tjf_SerachFriend)
    ff.net:removeEvent(2,dd.Tjf_ChatFriendSetting)
    ff.net:removeEvent(2,dd.Tjf_RecommendFriend)
    ff.net:removeEvent(2,dd.Tjf_Chat_FriendListBack)
    ff.net:removeEvent(2,dd.Tjf_InviteList)    
    --ff.net:removeEvent(2,dd.Tjf_GetBlackList)    
end
function chatFriends:onEnd()
    self:setVisible(false)
    self:getChildByName("friendlist"):setVisible(false)
    self:getChildByName("blacklist"):setVisible(false)
end
function chatLayer:onShowFriend()
    platform_showWaiting(1,0)
    if self._friendPannel == nil then
        local widget   = chatFriends.extend(self:getChildByName("friendpanel"))
        self._friendPannel = widget
        self._friendPannel._parant = self
    end

    self._friendPannel:setVisible(true)
    self._friendPannel:onInit()
end
