local gameIntroduceLayer   = class("gameIntroduceLayer")
gameIntroduceLayer._name = "gameIntroduce"
gameIntroduceLayer._init = false
gameIntroduceLayer.lastID = 0
gameIntroduceLayer.pageNum = 10
gameIntroduceLayer.wait = false

function gameIntroduceLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, gameIntroduceLayer)
    return target
end
function gameIntroduceLayer:onInit()
    if self._init == false then
        local hh = ff.height
        self:setContentSize(cc.size(720,hh))
        self:getChildByName("back"):setContentSize(cc.size(720,hh))
        self:getChildByName("list"):setContentSize(cc.size(690,hh - 170 - 70))
        self:getChildByName("info"):setContentSize(cc.size(690,hh - 170 - 60))
        self:getChildByName("list"):addScrollViewEventListener(self.scrollViewEvent)
        self._init = true
    end
    self:getChildByName("bottom"):getChildByName("sureBtn"):addTouchEventListener(self.onReturn)
end
function gameIntroduceLayer.scrollViewEvent(sender, evenType)
    if evenType == ccui.ScrollviewEventType.bounceBottom then
        local rank = pop.getDialog("gameIntroduce")
        if rank.wait == false and rank:isVisible() == true  then
            rank:checkUpdate()
        end    
    elseif evenType ==  ccui.ScrollviewEventType.scrollToTop then
    end
end
function gameIntroduceLayer:checkUpdate()  
    if self.lastID < table.getn(dd.sysBroadMsg) then
        self:showWaiting(true)
        self:initInfo(true)
    end
end
function gameIntroduceLayer:showWaiting(play)
    self.wait = play
end
function gameIntroduceLayer:initInfo(flag)
    local nextpage = false
    if flag ~= nil then
        nextpage = flag
    end
    local beforey = self:getChildByName("list"):getInnerContainer():getPositionY()
    local tick = ff.gameCore:getTick()
    for var=1, table.getn(dd.sysBroadMsg) do
        if var > self.lastID and var <= self.lastID+self.pageNum and dd.getTableLen(dd.sysBroadMsg[var]) > 0 then
    	   local item = self:getChildByName("infoItem"):clone()
    	   item:setVisible(true)
           item:getChildByName("chu_title"):setString(dd.sysBroadMsg[var]['title'])
            local len_one_line = 35
            if ff.lang == 0 then
                len_one_line = 60
            end
            local hh = math.ceil((dd.sysBroadMsg[var]['content_len'] - 1)/len_one_line) * 30
            local num = 0 
            local content = '' 
            content,num = string.gsub(dd.sysBroadMsg[var]['content'],"/n","\n")  
            local table = Split(content,"%\\")
            hh = hh + num * 30   
            local dh = hh - 230
            item:setContentSize(cc.size(660,350 + dh)) 
            item:getChildByName("content"):setString(table[1])
            item:getChildByName("content"):setContentSize(cc.size(600,hh))
            item:getChildByName("time"):setString(ff.showData(dd.sysBroadMsg[var]['time']).." "..ff.showTimes(dd.sysBroadMsg[var]['time']))
            self:getChildByName("list"):addChild(item)
            item:requestDoLayout()
    	end
    end
    cclog("use tick for gameIntroduce:"..ff.gameCore:getTick() - tick)
    self.lastID = self.lastID + self.pageNum
    if self.lastID > table.getn(dd.sysBroadMsg) then
        self.lastID = table.getn(dd.sysBroadMsg)    
    end    
    if nextpage then
        self:getChildByName("list"):getInnerContainer():setPositionY(beforey)     
        self:getChildByName("list"):refreshView()
        if table.getn(dd.sysBroadMsg) > 0 then
            local function func()
                self:showWaiting(false)   
            end
            local seq = cc.Sequence:create(cc.MoveBy:create(0.3,cc.p(0,20)),cc.CallFunc:create(func))
            self:getChildByName("list"):getInnerContainer():runAction(seq)
        end
    else
        self:showWaiting(false)   
    end
    self:getChildByName("list"):refreshView()
end
--界面显示后调用
function gameIntroduceLayer.onStart(sender)
    sender:getChildByName("list"):refreshView()
    sender:getChildByName("list"):jumpToTop()
end

--界面关闭效果结束后调用
function gameIntroduceLayer.onEnd(sender)
    dd.delBackEvent()
    sender:getChildByName("list"):removeAllChildren()
    sender.lastID = 0
end
--界面即将播放显示缓动时调用，返回false界面显示将终止
function gameIntroduceLayer.onBefore(sender)
    sender:initInfo()
    return true
end

function gameIntroduceLayer:onClose()
    return false
end

function gameIntroduceLayer.onReturn(sender,eventType)
    local close = false
    if sender == nil then
        close = true
    end
    if eventType==ccui.TouchEventType.ended then     
        close = true
    end
    if close == true then
        local widget = pop.getDialog("gameIntroduce")
        if widget~=nil and widget:onClose() == false then
            pop.onClosePopDialog("gameIntroduce")
        end    
    end
end
function onShowGameIntroduce(widget)
    local layer = gameIntroduceLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)
    layer:onInit()
    return layer
end