local lotterypaidLayer = class ("lotterypaidLayer")
lotterypaidLayer._name = "lotterypaid"
lotterypaidLayer._init = false
lotterypaidLayer._start = false
--lotterypaidLayer._cfglottery = {}
lotterypaidLayer._award = 0
lotterypaidLayer._awardCnt = 0
lotterypaidLayer._coin = 0
lotterypaidLayer._showIndex = 1
lotterypaidLayer._actionCenter = nil
lotterypaidLayer._actionmove = nil
lotterypaidLayer._count = 1
lotterypaidLayer._posItem = {nil,nil,nil,nil}

lotterypaidLayer._targetValue = 0
lotterypaidLayer._currValue = 0
lotterypaidLayer._speedValue = 0
lotterypaidLayer._isStarted = false
lotterypaidLayer._tagCount = 0
lotterypaidLayer._temptargetValueCount = 0
lotterypaidLayer._type = 0
lotterypaidLayer._time = 1
lotterypaidLayer._Active = false
lotterypaidLayer._itemId = 2041

function lotterypaidLayer.extend( target )
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target,t)
    end
    setmetatable(t,lotterypaidLayer)
    return target
end

function onShowLotteryPaid(widget,type)
    -- body
    local layer = lotterypaidLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)
    if type ~= nil then
        layer._Active = true 
        layer._itemId = dd.LotteryPaidItem
    else
        layer._Active = false 
        layer._itemId = 2041
    end
    layer:onInit()
    return layer
end

function lotterypaidLayer:showTips( type, id, count, pos )
    -- body
    local ret  = dd.getGiftsTips(type, id, count)
    local name = ret[1]
    local str  = ret[2]
    local tips = self:getChildByName("mainArea"):getChildByName("tips")
    local wid  = 360

    tips:setVisible(true)
    tips:getChildByName("tips"):removeAllChildren(false)

    local richText = ccui.RichText:create()
    richText:ignoreContentAdaptWithSize(false)
    richText:setContentSize(cc.size(wid-30,600))    
    richText:setAutoHeight()

    local chat = ccui.RichElementText:create(1, cc.c3b(161,175,175), 255, str, "Helvetica", 20)
    richText:insertElement(chat,0)
    richText:formatText()

    local size = richText:getContentSize()
    richText:setPosition(cc.p(172,size.height/2 + 15))
    tips:setContentSize(cc.size(wid, size.height + 60))
    tips:getChildByName("tips"):setContentSize(cc.size(wid, size.height + 60))
    tips:getChildByName("tips"):addChild(richText)

    tips:getChildByName("name"):setString(name) 
    tips:getChildByName("name"):setPositionY(size.height + 40)

    tips:setPositionX(pos.x)
    tips:setPositionY(pos.y+50)
    if pos.x < 250 then
        tips:setAnchorPoint(cc.p(0.2,0))
        tips:getChildByName("flag"):setPositionX(wid*0.2)
    elseif pos.x > 550 then
        tips:setAnchorPoint(cc.p(0.8,0))
        tips:getChildByName("flag"):setPositionX(wid*0.8)
    else
        tips:setAnchorPoint(cc.p(0.5,0))
        tips:getChildByName("flag"):setPositionX(wid*0.5)
    end  
end

function lotterypaidLayer.onReturn( sender,eventType )
    -- body
    local close = false
    if sender == nil then
        close = true
    end
    if eventType == ccui.TouchEventType.ended then
        close = true
    end
    if close == true then
        local widget = pop.getDialog("lotterypaid")
        if widget == nil then
            return
        end
        if widget._start == false then
            pop.onClosePopDialog("lotterypaid")
        end
    end
end

function lotterypaidLayer:onInit( )
    -- body
    if self._init == false then
        self:AutoSize()
        self._init = true
    end
    if self._Active == true then
        self:getChildByName("mainArea"):getChildByName("coin"):getChildByName("Image_173"):loadTexture(dd.getToolsIcon(self._itemId),0)
        self:getChildByName("mainArea"):getChildByName("normal"):getChildByName("Image_77"):loadTexture(dd.getToolsIcon(self._itemId),0)
        self:getChildByName("mainArea"):getChildByName("ten"):getChildByName("Image_77_0"):loadTexture(dd.getToolsIcon(self._itemId),0)
        
    else
        self:getChildByName("mainArea"):getChildByName("coin"):getChildByName("Image_173"):loadTexture(dd.getPathFromUI("ic27.png",1))
        self:getChildByName("mainArea"):getChildByName("normal"):getChildByName("Image_77"):loadTexture(dd.getPathFromUI("ic27.png",1))
        self:getChildByName("mainArea"):getChildByName("ten"):getChildByName("Image_77_0"):loadTexture(dd.getPathFromUI("ic27.png",1))
    end
    if dd.HolidayAppearance == 2 then
        self:getChildByName("mainArea"):getChildByName("Image_172"):loadTexture("images/active/LotteryPaid_bback.png",0)
        self:getChildByName("mainArea"):getChildByName("Image_41"):loadTexture("images/active/LotteryPaid_hua.png",0)
    end
    self:InitData()
    self.updateGold()
    pop.closeOtherNow(3,nil)
end

function lotterypaidLayer:InitData(  )
    -- body
    self._award = 0
    self._type = 0
    self:getChildByName("get"):setVisible(false)
    self:getChildByName("get"):getChildByName("zhuan"):stopAllActions()

    self._count = 1
    self._currTag = 0 
    self._coin = dd.getToolsCount(self._itemId)
    self:getChildByName("top"):getChildByName("count"):setString(dd.gold())
    --self:getChildByName("mainArea"):getChildByName("move"):setPosition(cc.p(100,705))
    self:getChildByName("mainArea"):getChildByName("center"):loadTexture(dd.getPathFromUI("public/alpha.png",1))

    function update()
        -- perduce random number
        local x = math.floor((math.random() * 999999)% 500) + 100
        local y = math.floor((math.random() * 999999)% 150) + self:getChildByName("mainArea"):getPositionY()+710
        local dir = math.floor((math.random() * 999999)% 2) + 1

        -- create star sprite
        local star = dd.newSpriteFromUI("lightEffectex.png")
        star:setPosition(x, y)
        star:setScale(0.1)
        self:getChildByName("start"):addChild(star, 1)

        -- create action
        local scto1 = cc.ScaleTo:create(1, 1.6)
        local delay = cc.DelayTime:create(0.5)
        local scto2 = cc.ScaleTo:create(1, 0.2)
        local remove = cc.CallFunc:create(function () star:removeFromParent() end)

        local rotation = nil
        if dir == 2 then
            rotation = cc.RotateTo:create(2.5, 900)    
        else
            rotation = cc.RotateTo:create(2.5, -900)
        end

        local seq1 = cc.Sequence:create(scto1, delay, scto2, remove)

        star:runAction(seq1)
        star:runAction(rotation)
        if self._Active == true then
            if dd.LotteryPaidTimeEndActive > dd.getServerTime() then
                local time = dd.LotteryPaidTimeEndActive - dd.getServerTime()
                self:getChildByName("info"):getChildByName("tips"):setString(ff.langString("关闭时间:")..ff.getLeftTime(time,":"))
                self:getChildByName("info"):requestDoLayout()
            end
        else
            if dd.LotteryPaidTime > dd.getServerTime() then
                local time = dd.LotteryPaidTime - dd.getServerTime()
                self:getChildByName("info"):getChildByName("tips"):setString(ff.langString("刷新时间:")..ff.getLeftTime(time,":"))
                self:getChildByName("info"):requestDoLayout()
            end
        end

        if self._coin ~= dd.getToolsCount(self._itemId) then
            self._coin = dd.getToolsCount(self._itemId)
            self:getChildByName("mainArea"):getChildByName("coin"):getChildByName("coincnt"):setString(self._coin)
        end
    end
    schedule(self:getChildByName("start"), update, 0.5)


    for i=1,4 do
        self._posItem[i] = dd.newSpriteFromUI("fruit_box.png")
        self._posItem[i]:setOpacity(255 * (1 - i * 0.2))
        self._posItem[i]:setVisible(false)
        self._posItem[i]:setPosition(self:getChildByName("mainArea"):getChildByName("r1"):getPosition())
        self:getChildByName("mainArea"):addChild(self._posItem[i],0)
        self._posItem[i]:setTag(i)
        if self._posItem[i]:getTag() == 1 then
            self._posItem[i]:setVisible(true)
        end
    end

    for i=1,28 do
        local name = "light"..i
        self:getChildByName("mainArea"):getChildByName("light"):getChildByName(name):setTag(i)
    end

    self:getChildByName("touch"):setTouchEnabled(false)
end

function lotterypaidLayer:startCenter(  )
    -- body
    self._count = 1
    local function asyncBack(sender)
        self._count = self._count + 1
        local index = 8
        for i=1,28 do
        --cclog("==========")
            
            if index == 15 then
                index = 1
            end
            local picName1 = "light"..index.."_light.png"
            local picName2 = "light"..index.."_dark.png"

            if self._count % 2 == 0 then
                if index % 2 == 0 then
                    sender:getChildByTag(i):loadTexture(dd.getPathFromUI(picName1,1))
                else
                    sender:getChildByTag(i):loadTexture(dd.getPathFromUI(picName2,1))
                end
            else
                if index % 2 == 0 then
                    sender:getChildByTag(i):loadTexture(dd.getPathFromUI(picName2,1))
                else
                    sender:getChildByTag(i):loadTexture(dd.getPathFromUI(picName1,1))
                end
            end
            index = index + 1

        end
        --end
    end
    
    self._action = schedule(self:getChildByName("mainArea"):getChildByName("light"), asyncBack, 0.5)
end

function lotterypaidLayer:endCenter(  )
    -- body
    if self._action ~= nil then
        self:stopAction(self._action)
        self._action = nil    
    end
end

function lotterypaidLayer:AutoSize(  )
    -- body
    local hh = ff.height
    self:setContentSize(cc.size(720,hh))
    local viewhh = self:getContentSize().height - 105
    if viewhh > 960 then
        self:getChildByName("mainArea"):setPositionY((viewhh-960)/2)
    else
        self:getChildByName("mainArea"):setPositionY(0)
    end
   -- self:getChildByName("mainArea"):getChildByName("move"):loadTexture(dd.getPathFromUI("public/bag07.png",1))
    --self:getChildByName("mainArea"):getChildByName("move"):setVisible(true)
    self:getChildByName("back"):setContentSize(cc.size(720,hh))
    self:getChildByName("touch"):setContentSize(cc.size(720,hh))
    self:getChildByName("touch"):setTouchEnabled(false)
    self:getChildByName("touch"):setPositionY(0)
    self:getChildByName("top"):setPositionY(viewhh)
    self:getChildByName("info"):setPositionY(viewhh-41)
    self:getChildByName("top"):getChildByName("addgold"):addTouchEventListener(dd.onPay)
    
    --self:getChildByName("top"):getChildByName("chu_title"):setString(ff.langString("抽奖"))
    --self:getChildByName("top"):getChildByName("chu_title"):getVirtualRenderer():enableBold(true)

    self:getChildByName("top"):getChildByName("return"):addTouchEventListener(self.onReturn)
    self:getChildByName("mainArea"):getChildByName("normal"):addTouchEventListener(self.lotteryOnce)
    self:getChildByName("mainArea"):getChildByName("ten"):addTouchEventListener(self.lotteryTen)

    self:getChildByName("get"):addTouchEventListener(self.CloseGet)

    self:getChildByName("back"):addTouchEventListener(self.unShowTips)


    for i=1,16 do
        local name  = "r"..tostring(i)
        self:getChildByName("mainArea"):getChildByName(name):setTag(i)
        self:getChildByName("mainArea"):getChildByName(name):addTouchEventListener(self.onShowTips)
    end

end

function lotterypaidLayer.onBefore( sender )
    -- body
    ff.net:registerEvent(1,dd.Tjg_lottery_paid,function (message)sender:onGetRetInfo(message)end)
    ff.net:registerEvent(1,dd.Tjg_LotteryHolidayAction,function (message)sender:onGetRetInfoEx(message)end)
    ff.net:registerEvent(1,dd.Tjf_notify_SNLotteryPaid,function (message)sender:onGetInfo(message)end)
    ff.net:registerEvent(1,dd.Tjf_notify_SNLotteryHoliday,function (message)sender:onGetInfo(message)end)
    
end

function lotterypaidLayer:getItems(  )
    if self._Active == true then
        if dd.LotteryPaidActive == nil then
            
            local message = ff.net:createMessage()
            message:addCmd(0x0000017a)
            message:addLong(dd.uid)
            message:addLong(0)
            message:addLong(1)
            ff.net:rpc(message, false)
        end
    else
        if dd.LotteryPaid == nil then
            
            local message = ff.net:createMessage()
            message:addCmd(0x00000179)
            message:addLong(dd.uid)
            message:addLong(0)
            message:addLong(1)
            ff.net:rpc(message, false)
        end
    end
end



function lotterypaidLayer:onGetInfo(params)
    --self:getChildByName("touch"):setTouchEnabled(false)
    local code = params[1]
    if code == 0 then
        self:showAward()
    else
        
        dd.mainUI:onShowCodeTips(code)
    end
end

function lotterypaidLayer.onShowTips( sender,eventType  )
    -- body
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("lotterypaid")
        if widget ~= nil then
           local tag = sender:getTag()
           
           local x,y = sender:getPosition()
           local level = dd.myinfo:getLong(1,"level")
           if widget._Active == true then
                if dd.LotteryPaidActive ~= nil then
                    widget:showTips(1,dd.LotteryPaidActive:getLong(tag,"id"),1,cc.p(x,y))     
                end 
           else
               if dd.LotteryPaid ~= nil then
                    widget:showTips(1,dd.LotteryPaid:getLong(tag,"id"),1,cc.p(x,y))     
                end      
            end 
        end
    end
end

function lotterypaidLayer.unShowTips( sender,eventType  )
    -- body
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("lotterypaid")
        if widget ~= nil then
            widget:getChildByName("mainArea"):getChildByName("tips"):getChildByName("tips"):removeAllChildren(true)
           widget:getChildByName("mainArea"):getChildByName("tips"):setVisible(false)
        end
    end
end

function lotterypaidLayer.onStart(sender)
    --关闭可能打开在那边的3层窗口
    if sender._Active == true then
        if dd.LotteryPaidActive == nil then
            sender:getItems()
        else
            sender:showAward()
        end
    else
        if dd.LotteryPaid == nil then
            sender:getItems()
        else
            sender:showAward()
        end
    end
    
    
    sender:startCenter()
    ff.net:bindProperty(2301,"gold",sender.updateGold)
    dd.initGoldSpine(sender:getChildByName("top"):getChildByName("gold"),sender:getChildByName("top"):getChildByName("addgold"))
end

function lotterypaidLayer.updateGold(name,row,old,value)
    local widget = pop.getDialog("lotterypaid")
    if widget ~= nil then
        widget:getChildByName("top"):getChildByName("count"):setString(dd.myinfo:getLong(1,"gold"))
        local w = widget:getChildByName("top"):getChildByName("count"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        widget:getChildByName("top"):getChildByName("title"):setContentSize(cc.size(w,100))
        widget:getChildByName("top"):getChildByName("title"):requestDoLayout()
        widget:getChildByName("top"):requestDoLayout()
    end
end

function lotterypaidLayer.onEnd( sender,btns )
    if ff.effects[202] ~= nil then
        AudioEngine.stopEffect(ff.effects[202])
        ff.effects[202] = nil
        --cclog("=========================="..ff.effects[202])
    end
    sender._time = 1
    
    if btns == nil then
        if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
            dd.currentLayer._widget:unSelectBtns()
        end 
    end
    sender:getChildByName("mainArea"):getChildByName("tips"):getChildByName("tips"):removeAllChildren(true)
    sender:getChildByName("mainArea"):getChildByName("tips"):setVisible(false)
    -- body
    -- sender:getChildByName("mainArea"):stopAllActions()
    sender:endCenter()
    sender:getChildByName("mainArea"):getChildByName("light"):stopAllActions()
    sender:getChildByName("mainArea"):stopAllActions()
    sender:getChildByName("start"):stopAllActions()
    sender:stopAllActions()
    ff.net:removeEvent(1,dd.Tjg_lottery_paid)
    ff.net:removeEvent(1,dd.Tjg_LotteryHolidayAction)
    ff.net:removeEvent(1,dd.Tjf_notify_SNLotteryPaid)
    dd.delBackEvent()

    if ff.platform ~= 1 then
        for i=1,28 do
            --cclog("==========")   
            sender:getChildByName("mainArea"):getChildByName("light"):getChildByTag(i):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        end
    end

    for i=1,4 do
        if sender._posItem[i] ~= nil then
           sender._posItem[i]:removeFromParent()
       end
    end

    for i=1,16 do
        local name = "r"..i
        sender:getChildByName("mainArea"):getChildByName(name):removeAllChildren(true)
    end
    
   sender:getChildByName("start"):removeAllChildren(true)
   sender:getChildByName("mainArea"):getChildByName("center"):removeAllChildren(true)
   ff.net:unbindProperty("gold",2301)
end

function lotterypaidLayer:onGetRetInfo(params)
    --self:getChildByName("touch"):setTouchEnabled(false)
    local code = params[1]
    if code == 0 then
        if params[3] ~= 0 then
           -- cclog(params[2].."==="..params[3])
            self._award = params[2]
            self._awardCnt = params[3]
            self._time = 1
            self:startAction()
            self._actionmove = schedule(self,self.update,0.001)
            self:getChildByName("get"):getChildByName("ico"):loadTexture(dd.getToolsIcon(self._award),0)
            if self._type == 1 then
                self:getChildByName("get"):getChildByName("info"):getChildByName("name"):setString(ff.langString(dd.cfgProp[self._award]['name'],{dd.cfgProp[self._award]['name1_lan']}).."  X".."  "..self._awardCnt)
                self:getChildByName("get"):getChildByName("info"):getChildByName("count"):setVisible(false)
                self:getChildByName("get"):getChildByName("info"):getChildByName("Label_72"):setVisible(false)
                self:getChildByName("get"):getChildByName("info"):getChildByName("name"):setPositionX(ff.width/2)
                self:getChildByName("get"):getChildByName("info"):getChildByName("name"):setAnchorPoint(cc.p(0.5,0.5))
            elseif self._type == 2 then
                self:getChildByName("get"):getChildByName("info"):getChildByName("name"):setString(ff.langString(dd.cfgProp[self._award]['name'],{dd.cfgProp[self._award]['name1_lan']}).."  X".."  "..self._awardCnt)
                self:getChildByName("get"):getChildByName("info"):getChildByName("count"):setVisible(false)
                self:getChildByName("get"):getChildByName("info"):getChildByName("Label_72"):setVisible(false)
                self:getChildByName("get"):getChildByName("info"):getChildByName("name"):setAnchorPoint(cc.p(0.5,0.5))
                self:getChildByName("get"):getChildByName("info"):getChildByName("name"):setPositionX(ff.width/2)
            end
        end
    else
        self:getChildByName("touch"):setTouchEnabled(false)
        dd.mainUI:onShowCodeTips(code)
    end
end

function lotterypaidLayer:onGetRetInfoEx(params)
    --self:getChildByName("touch"):setTouchEnabled(false)
    local code = params[1]
    if code == 0 then
        if params[3] ~= 0 then
           -- cclog(params[2].."==="..params[3])
            self._award = params[2]
            self._awardCnt = params[3]
            self._time = 1
            self:startAction()
            self._actionmove = schedule(self,self.update,0.001)
            self:getChildByName("get"):getChildByName("ico"):loadTexture(dd.getToolsIcon(self._award),0)
            if self._type == 1 then
                self:getChildByName("get"):getChildByName("info"):getChildByName("name"):setString(ff.langString(dd.cfgProp[self._award]['name'],{dd.cfgProp[self._award]['name1_lan']}).."  X".."  "..self._awardCnt)
                self:getChildByName("get"):getChildByName("info"):getChildByName("count"):setVisible(false)
                self:getChildByName("get"):getChildByName("info"):getChildByName("Label_72"):setVisible(false)
                self:getChildByName("get"):getChildByName("info"):getChildByName("name"):setPositionX(ff.width/2)
                self:getChildByName("get"):getChildByName("info"):getChildByName("name"):setAnchorPoint(cc.p(0.5,0.5))
            elseif self._type == 2 then
                self:getChildByName("get"):getChildByName("info"):getChildByName("name"):setString(ff.langString(dd.cfgProp[self._award]['name'],{dd.cfgProp[self._award]['name1_lan']}).."  X".."  "..self._awardCnt)
                self:getChildByName("get"):getChildByName("info"):getChildByName("count"):setVisible(false)
                self:getChildByName("get"):getChildByName("info"):getChildByName("Label_72"):setVisible(false)
                self:getChildByName("get"):getChildByName("info"):getChildByName("name"):setAnchorPoint(cc.p(0.5,0.5))
                self:getChildByName("get"):getChildByName("info"):getChildByName("name"):setPositionX(ff.width/2)
            end
        end
    else
        self:getChildByName("touch"):setTouchEnabled(false)
        dd.mainUI:onShowCodeTips(code)
    end
end

function lotterypaidLayer.update( sender )

    sender._getTick = sender._getTick + 1

    sender._tagCount = 1

    if sender._targetValue > (sender._temptargetValueCount - 2)  then
        sender._tagCount = 8
    elseif sender._targetValue > (sender._temptargetValueCount - 3) and sender._targetValue <= (sender._temptargetValueCount - 2) then
        sender._tagCount = 7
    elseif sender._targetValue > (sender._temptargetValueCount - 4) and sender._targetValue <= (sender._temptargetValueCount - 3) then
        sender._tagCount = 6
    elseif sender._targetValue > (sender._temptargetValueCount - 5) and sender._targetValue <= (sender._temptargetValueCount - 4) then
        sender._tagCount = 5
    elseif sender._targetValue > (sender._temptargetValueCount - 6) and sender._targetValue <= (sender._temptargetValueCount - 5) then
        sender._tagCount = 4
    elseif sender._targetValue > (sender._temptargetValueCount - 7) and sender._targetValue <= (sender._temptargetValueCount - 6) then
        sender._tagCount = 3
    elseif sender._targetValue > (sender._temptargetValueCount - 8) and sender._targetValue <= (sender._temptargetValueCount - 7) then
        sender._tagCount = 2

    elseif sender._targetValue > 7 and sender._targetValue <= (sender._temptargetValueCount - 8) then
        sender._tagCount = 1

    elseif sender._targetValue >6 and sender._targetValue <=7 then
        sender._tagCount = 3
    elseif sender._targetValue >5 and sender._targetValue <=6 then
        sender._tagCount = 5
    elseif sender._targetValue >4 and sender._targetValue <=5 then
        sender._tagCount = 7
    elseif sender._targetValue >3 and sender._targetValue <=4 then
        sender._tagCount = 9
    elseif sender._targetValue >2 and sender._targetValue <=3 then
        sender._tagCount = 11
    elseif sender._targetValue >1 and sender._targetValue <=2 then
        sender._tagCount = 13
    elseif sender._targetValue >0 and sender._targetValue <=1 then
        sender._tagCount = 15
    end

    if (sender._tagCount == 1) or (sender._getTick % math.floor(sender._tagCount /2) == 0) then
        if sender._tagCount > 0 then
        local index = 8
            for i=1,28 do
        --cclog("==========")
                
                if index == 15 then
                    index = 1
                end
                local picName1 = "light"..index.."_light.png"
                local picName2 = "light"..index.."_dark.png"
                sender:getChildByName("mainArea"):getChildByName("light"):getChildByTag(i):
                    loadTexture(dd.getPathFromUI(picName2,1))

                local id = sender._targetValue%28
                for i=1,4 do
                    local num = (id  - i <= 0) and (28 + id - i) or (id -i)
                    local index2 = (index -i <= 0 ) and (14 + index - i) or (index -i)
                    
                    --cclog("=="..index.."=="..i)
                    local picName11 = "light"..index2.."_light.png"
                    sender:getChildByName("mainArea"):getChildByName("light"):getChildByTag(num):
                        loadTexture(dd.getPathFromUI(picName11,1))
                end
                index = index + 1

            end
        end
    end

    if sender._getTick % sender._tagCount == 0 then
        sender._getTick = 1
        if sender._targetValue > 0 then

            sender._targetValue = sender._targetValue - 1
            sender._currValue = sender._currValue + 1 
            if sender._currValue == 17 then 
                sender._currValue = 1 
            end
            sender:setItemPos(sender._currValue)
         
            if sender._targetValue > 0 then
                
                local soundsid = 914 + sender._time
                sender._time = sender._time + 1
                if sender._time == 5 then
                    sender._time = 1 
                end
                --cclog("==========="..soundsid)
                ff.effects[202] =  AudioEngine.playEffect(ff.sounds[soundsid])
            end   
            
        else
            sender._isStarted = false
            sender:setItemPos(sender._currValue)

            local function endAtSecond()
                for i=1,40 do
                    local x = 0
                    local y = 0
                    local xto = 0
                    local yto = 0
                    --math.randomseed( os.time() )
                    local dir = math.floor((math.random() * 999999)% 2) + 1
                    if i <=10 then
                        y= 200 
                        if dir == 2 then
                            x = math.floor((math.random() * 999999)% 100)  + 100
                            yto = math.floor((math.random() * 999999)% 50)  + 50
                            xto =math.floor((math.random() * 999999)% 50)  + 50
                        else
                            x = math.floor((math.random() * 999999)% 100)* -1+ 100
                            yto = math.floor((math.random() * 999999)% 50)  + 50
                            xto =math.floor((math.random() * 999999)% 50)* -1  + 50
                        end
                    elseif i> 10 and i <= 20 then
                        y= 0
                        if dir == 2 then
                            x = math.floor((math.random() * 999999)% 100)  + 100
                            yto = math.floor((math.random() * 999999)% 50)*-1  - 50
                            xto =math.floor((math.random() * 999999)% 50)  + 50
                        else
                            x = math.floor((math.random() * 999999)% 100)* -1+ 100
                            yto = math.floor((math.random() * 999999)% 50)* -1  - 50
                            xto =math.floor((math.random() * 999999)% 50)*-1  + 50
                        end
                    elseif i>20 and i <= 30 then
                        x= 200
                        if dir == 2 then
                            y = math.floor((math.random() * 999999)% 100)  + 100
                            yto = math.floor((math.random() * 999999)% 50)  + 50
                            xto =math.floor((math.random() * 999999)% 50)  + 50
                        else
                            y = math.floor((math.random() * 999999)% 100)* -1+ 100
                            yto = math.floor((math.random() * 999999)% 50)*-1  + 50
                            xto =math.floor((math.random() * 999999)% 50)  + 50
                        end
                    elseif i>30 then
                        x= 0
                        if dir == 2 then
                            y = math.floor((math.random() * 999999)% 100)  + 100
                            yto = math.floor((math.random() * 999999)% 50)  + 50
                            xto =math.floor((math.random() * 999999)% 50)* -1  - 50
                        else
                            y = math.floor((math.random() * 999999)% 100)* -1+ 100
                            yto = math.floor((math.random() * 999999)% 50)*-1  + 50
                            xto =math.floor((math.random() * 999999)% 50)* -1  - 50
                         
                        end

                    end
                  
        -- create star sprite
                    local star = dd.newSpriteFromUI("fruit_light.png")
                    star:setPosition(x, y)
                    star:setScale(0.8)
                    sender:getChildByName("mainArea"):getChildByName("center"):addChild(star, 1)

        -- create action
                    local scto1 = cc.ScaleTo:create(0.4, 1.2)
                    local delay = cc.DelayTime:create(0.1)
                    local scto2 = cc.ScaleTo:create(0.2, 0)
                    local remove = cc.CallFunc:create(function () star:removeFromParent() end)

                    local rotation = nil
                    if dir == 2 then
                        rotation = cc.RotateTo:create(0.3, 100)    
                    else
                        rotation = cc.RotateTo:create(0.3, -100)
                    end
                    local moveTo = cc.MoveTo:create(1, cc.p(x+xto,y+yto))
                   -- cclog(i.."=="..(x+xto)..","..x.."=="..(y+yto)..","..y)
                    local seq1 = nil
                    if dir == 2 then
                        seq1 = cc.Sequence:create(scto1,scto2, remove)
                    else 
                        seq1 = cc.Sequence:create(delay,scto1,scto2, remove)
                    end
                    
                    local run = cc.Spawn:create(seq1,moveTo,rotation)
                    star:runAction(run)
                    --star:runAction(rotation)       
                    end      
                    sender:getChildByName("touch"):setTouchEnabled(false)     
                    sender:getChildByName("mainArea"):getChildByName("center"):loadTexture(dd.getToolsIcon(sender._award),0)
                   --cclog("11111==="..sender._award)
                    sender:getChildByName("top"):getChildByName("count"):setString(dd.myinfo:getLong(1,"gold"))
                    sender._coin = dd.getToolsCount(sender._itemId)
                    sender:getChildByName("mainArea"):getChildByName("coin"):getChildByName("coincnt"):setString(sender._coin) 
                    sender:getChildByName("get"):setVisible(true)
                    ff.effects[202] =  AudioEngine.playEffect(ff.sounds[919])
                    sender:getChildByName("get"):setTouchEnabled(true)
                    
                    
                    local angle = 0
                    local bg = sender:getChildByName("get"):getChildByName("zhuan")
                    bg:setScale(0.8)
                    local function ratote()
                        angle = angle + 1
                        bg:setRotation(angle)
                    end
                    schedule(bg, ratote, 0)
            end
            local delay = cc.DelayTime:create(0.5)
            local endDelay = cc.CallFunc:create(function () endAtSecond() end)
            local seq = cc.Sequence:create(delay, endDelay)
            sender:runAction(seq)
           
        end

    end

end

function lotterypaidLayer:setItemPos( pos )
    if self._isStarted == true then
        self:endCenter()
        for i=1,4 do
            self._posItem[i]:setVisible(true)
            local inde  = (pos - i +1) > 0 and  (pos - i +1) or (pos - i +17) 
            local name = "r" .. tostring(inde)
            self._posItem[i]:setPosition(self:getChildByName("mainArea"):getChildByName(name):getPosition())
            local level = dd.myinfo:getLong(1,"level")
            if i == 1 then
                if self._Active == true then
                    self:getChildByName("mainArea"):getChildByName("center"):loadTexture(dd.getToolsIcon(dd.LotteryPaidActive:getLong(self._currValue,"id")),0)

                else
                    self:getChildByName("mainArea"):getChildByName("center"):loadTexture(dd.getToolsIcon(dd.LotteryPaid:getLong(self._currValue,"id")),0)
                end
                
                --ff.effects[202] =  AudioEngine.playEffect(ff.sounds[202])
                
                for i=1,10 do
                    local x = 0
                    local y = 0
                    local dir = math.floor((math.random() * 999999)% 2) + 1
                    if i <=3 then
                        y= 125 
                        if dir == 2 then
                            x = math.floor((math.random() * 999999)% 63)  + 63
                        else
                            x = math.floor((math.random() * 999999)% 63)* -1+ 63
                        end
                        
                    elseif i> 3 and i <= 6 then
                        y= 0
                        if dir == 2 then
                            x = math.floor((math.random() * 999999)% 63)  + 63
                        else
                            x = math.floor((math.random() * 999999)% 63)* -1+ 63
                        end
                    elseif i>6 and i <= 9 then
                        x= 125
                        if dir == 2 then
                            y = math.floor((math.random() * 999999)% 63)  + 63
                        else
                            y = math.floor((math.random() * 999999)% 63)* -1+ 63
                        end
                    elseif i>9 then
                        x= 0
                        if dir == 2 then
                            y = math.floor((math.random() * 999999)% 63)  + 63
                        else
                            y = math.floor((math.random() * 999999)% 63)* -1+ 63
                        end
                    end
                  
        -- create star sprite
                    local star = dd.newSpriteFromUI("fruit_light.png")
                    star:setPosition(x, y)
                    star:setScale(0.8)
                    self:getChildByName("mainArea"):getChildByName(name):addChild(star, 1)

        -- create action
                    local scto1 = cc.ScaleTo:create(0.3, 0.5)
                    local delay = cc.DelayTime:create(0.1)
                    local scto2 = cc.ScaleTo:create(0.5, 0)
                    local remove = cc.CallFunc:create(function () star:removeFromParent() end)

                    local rotation = nil
                    if dir == 2 then
                        rotation = cc.RotateTo:create(0.5, 100)    
                    else
                        rotation = cc.RotateTo:create(0.5, -100)
                    end
                    local moveTo = cc.MoveTo:create(1, cc.p(x-30,y-30))
                    local seq1 = nil
                    if dir == 2 then
                        seq1 = cc.Sequence:create(scto1,scto2, remove)
                    else 
                        seq1 = cc.Sequence:create(delay,scto1,scto2, remove)
                    end
                    
                    local run = cc.Spawn:create(seq1,moveTo,rotation)
                    star:runAction(run)
                    --star:runAction(rotation)       
                end            
            end
        end
    else
        for i=1,4 do
            self._posItem[i]:setVisible(false)
            if i == 1 then
                self._posItem[i]:setVisible(true)
            end
        end
        self._targetValue = 0
        self:stopAction(self._actionmove)
        self._actionmove = nil 
        self:startCenter()
        self:getChildByName("mainArea"):getChildByName("center"):loadTexture(dd.getToolsIcon(self._award),0)
       -- cclog("22222==="..self._award)
        
    end
    
end

function lotterypaidLayer:startAction(  )
    --local num = 1
    local have = false
    local level = dd.myinfo:getLong(1,"level")
    for i=1,16 do
        local name  = "r"..tostring(i)
        --if i %4 ~= 3 then
        if self._Active == true then
            if dd.LotteryPaidActive:getLong(i,"id") == self._award then
                have = true
                self._showIndex = i
                break
            end
        else

            if dd.LotteryPaid:getLong(i,"id") == self._award then
                have = true
                self._showIndex = i
                break
            end
        end
            --num = num +1
        --end
    end

        if have == false then
            math.randomseed(ff.gameCore:getTick())
            self._showIndex = math.random(0,3)*4 + 3
        end

        self._targetValue = self._showIndex  + 16 * 3 + (16 - self._currValue)
        self._temptargetValueCount = self._targetValue
        self._isStarted = true
        self._getTick = 1
        self._tagCount = 2
    --ff.effects[202] =  AudioEngine.playEffect(ff.sounds[200])
end

function lotterypaidLayer.endAction( )
    -- body
    local widget = pop.getDialog("lotterypaid")
    widget:stopAllActions()
    widget:getChildByName("touch"):setTouchEnabled(false)
    widget:getChildByName("mainArea"):getChildByName("center"):loadTexture(dd.getToolsIcon(widget._award),0)
    widget:getChildByName("top"):getChildByName("count"):setString(dd.myinfo:getLong(1,"gold"))
    widget._coin = dd.getToolsCount(widget._itemId)
    widget:getChildByName("mainArea"):getChildByName("coin"):getChildByName("coincnt"):setString(widget._coin)
end

function lotterypaidLayer:showAward( )
    -- body
    local level = dd.myinfo:getLong(1,"level")
    for i=1,16 do
        local name  = "r"..tostring(i)
        if self._Active == true then
            self:getChildByName("mainArea"):getChildByName(name):loadTexture(dd.getToolsIcon(dd.LotteryPaidActive:getLong(i,"id")),0)

        else
            self:getChildByName("mainArea"):getChildByName(name):loadTexture(dd.getToolsIcon(dd.LotteryPaid:getLong(i,"id")),0)
       end
    end
    self:getChildByName("mainArea"):getChildByName("coin"):getChildByName("coincnt"):setString(self._coin)
end

function lotterypaidLayer.lotteryOnce( sender,eventType )
    -- body
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("lotterypaid")
        if widget ~= nil then
            
            
            if dd.getToolsCount(widget._itemId) > 0 then 
              
                local message = ff.net:createMessage()
                if widget._Active ~= true then
                    message:addCmd(0x00000179)
                else
                    message:addCmd(0x0000017a)
                end
                message:addLong(dd.uid)
                message:addLong(1)
                message:addLong(1)
                ff.net:rpc(message, false)
                widget:getChildByName("touch"):setTouchEnabled(true)
                widget._type = 1 
            else
                if widget._Active == true then
                    local function sure()
                        pop.onShowPopDialog("charge")
                    end
                    dd.mainUI:onShowSure(ff.langString("警告"),ff.langString("道具不足提示"),sure,true,2,2,ff.langString("充值"))
                    return
                end
                local function sureCancel()
                    local message = ff.net:createMessage()
                    message:addCmd(0x00000179)
                    message:addLong(dd.uid)
                    message:addLong(2)
                    message:addLong(1)
                    ff.net:rpc(message, false)
                    widget:getChildByName("touch"):setTouchEnabled(true)
                    widget._type = 1 
                end
                --提示
                local count = 150
                if dd.cfgProp[2041] ~= nil then
                    count = dd.cfgProp[2041]['value']
                end
                dd.currentLayer._widget:onShowSure(ff.langString("纪念币不足"),ff.langString("纪念币不足，将使用{0}金币.\n是否继续？",{count}),sureCancel,true,2)
            end
            

            
            
            --widget:startAction()
        end
    end
end

function lotterypaidLayer.lotteryTen( sender,eventType )
    -- body
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("lotterypaid")
        if widget ~= nil then
            if dd.getToolsCount(widget._itemId) >= 10 then 
                local message = ff.net:createMessage()
                if widget._Active ~= true then
                    message:addCmd(0x00000179)
                else
                    message:addCmd(0x0000017a)
                end
                message:addLong(dd.uid)
                message:addLong(9)
                message:addLong(1)
                ff.net:rpc(message, false)
                widget:getChildByName("touch"):setTouchEnabled(true)
                
                widget._type = 2
            else
                if widget._Active == true then
                    local function sure()
                        pop.onShowPopDialog("charge")
                    end
                    dd.mainUI:onShowSure(ff.langString("警告"),ff.langString("道具不足提示"),sure,true,2,2,ff.langString("充值"))
                    return
                end
                local function sureCancel()
                    local message = ff.net:createMessage()
                    message:addCmd(0x00000179)
                    message:addLong(dd.uid)
                    message:addLong(9)
                    message:addLong(1)
                    ff.net:rpc(message, false)
                    widget:getChildByName("touch"):setTouchEnabled(true)
                    
                    widget._type = 2
                end
                --提示
                local count = 150
                if dd.cfgProp[2041] ~= nil then
                    count = dd.cfgProp[2041]['value']
                end
                --cclog("====sdfsd==="..count)
                local cnt =(10- dd.getToolsCount(2041))*count
                dd.currentLayer._widget:onShowSure(ff.langString("纪念币不足"),ff.langString("纪念币不足，将使用{0}金币.\n是否继续？",{cnt}),sureCancel,true,2)
            end
        end
    end
end

function lotterypaidLayer.CloseGet( sender,eventType )
    -- body
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("lotterypaid")
        if widget ~= nil then
           widget:getChildByName("get"):setVisible(false)
           widget:getChildByName("get"):setTouchEnabled(false)
           widget:getChildByName("get"):getChildByName("zhuan"):stopAllActions()
        end
    end
end

