repViewLayer = class("repViewLayer")
repViewLayer._name = "repView"
repViewLayer._init = false
repViewLayer._repData = nil
repViewLayer._type = 0
repViewLayer._repCount = 0
repViewLayer._enemy   = {}
repViewLayer._isGet = false
repViewLayer._animFrames = {}

function repViewLayer.extend( target )
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target,t)
    end
    setmetatable(t,repViewLayer)
    return target
    -- body
end

function onShowRepView( widget,type )
    -- body
    local layer = repViewLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)
    cclog("=================="..type)
    layer:onInit(type)
    return layer
end

function repViewLayer.onReturn( sender,eventType )
    -- body
    local close = false
    if sender == nil then
        close = true
    end
    if eventType == ccui.TouchEventType.ended then
        close = true
    end
    if close == true then
        local widget = pop.getDialog("repView")
        if widget == nil then
            return
        end
        pop.onClosePopDialog("repView")
    end
end

function repViewLayer:onInit( type )
    -- body
    if self._init == false then
        self:AutoSize()
        self._init = true 
    end
    self:showWaiting(false)
    self._type = type
    self._repCount = 0
    self._isGet = false
    self._repData = ff.NetTable:create()
    self._repData:addStreamCol("id",ff.NET_SUPER_LONG)
    self._repData:addStreamCol("time",ff.NET_LONG)
    self._repData:addStreamCol("state",ff.NET_LONG)
    self._repData:addStreamCol("type",ff.NET_LONG)
    self._repData:addStreamCol("content",ff.NET_STRING,512)
    self._repData:addStreamCol("awardTime",ff.NET_LONG)
    self._repData:addStreamCol("awardStr",ff.NET_STRING,512)
    self._repData:addStreamCol("selected",ff.NET_LONG) 

    if  self._type == 201 then
        self:getChildByName("title"):getChildByName("title"):setString(ff.langString("采集战报"))
        self:getChildByName("title"):getChildByName("ico"):getChildByName("ico"):loadTexture("images/icon/battle/type/1.jpg",0)
    elseif self._type == 211 then
        self:getChildByName("title"):getChildByName("title"):setString(ff.langString("英雄战报"))
        self:getChildByName("title"):getChildByName("ico"):getChildByName("ico"):loadTexture("images/icon/battle/type/PVE_pic.png",0)
    elseif self._type == 214 then
        self:getChildByName("title"):getChildByName("title"):setString(ff.langString("怪物战报"))
        self:getChildByName("title"):getChildByName("ico"):getChildByName("ico"):loadTexture("images/icon/battle/type/active_2.jpg",0)
    elseif self._type == 215 then
        self:getChildByName("title"):getChildByName("title"):setString(ff.langString("生化危机")..ff.langString("战报"))
        self:getChildByName("title"):getChildByName("ico"):getChildByName("ico"):loadTexture("images/icon/battle/type/active_2.jpg",0)
    elseif self._type == 216 then
        self:getChildByName("title"):getChildByName("title"):setString(ff.langString("百鬼来袭")..ff.langString("战报"))
        self:getChildByName("title"):getChildByName("ico"):getChildByName("ico"):loadTexture("images/icon/battle/type/PVE_pic.png",0)
    elseif self._type == 217 then
        self:getChildByName("title"):getChildByName("title"):setString(ff.langString("地下城堡")..ff.langString("战报"))
        self:getChildByName("title"):getChildByName("ico"):getChildByName("ico"):loadTexture("images/icon/battle/type/PVE_pic.png",0)
    elseif self._type == 218 then
        self:getChildByName("title"):getChildByName("title"):setString(ff.langString("进击的巨人")..ff.langString("战报"))
        self:getChildByName("title"):getChildByName("ico"):getChildByName("ico"):loadTexture("images/icon/battle/type/PVE_pic.png",0)
    end
    self:getChildByName("title"):getChildByName("title"):getVirtualRenderer():enableBold(true)
    self:getChildByName("title"):requestDoLayout()
    self.updateGold()
    --self:showInfo()
end

function repViewLayer.updateGold(name,row,old,value)
    local widget = pop.getDialog("repView")
    if widget ~= nil then
        widget:getChildByName("top"):getChildByName("count"):setString(dd.myinfo:getLong(1,"gold"))
        local w = widget:getChildByName("top"):getChildByName("count"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        widget:getChildByName("top"):getChildByName("title"):setContentSize(cc.size(w,100))
        widget:getChildByName("top"):getChildByName("title"):requestDoLayout()
        widget:getChildByName("top"):requestDoLayout()
    end
end


function repViewLayer:AutoSize(  )
    -- body
    local hh = ff.height
    self:setContentSize(cc.size(720,hh))
    self:setPositionY(0)
    self:getChildByName("back"):setContentSize(cc.size(720,hh))
    self:getChildByName("top"):setPositionY(hh - 105)
    --self:getChildByName("top"):getChildByName("chu_title"):setString(ff.langString("列表"))
    --self:getChildByName("top"):getChildByName("chu_title"):getVirtualRenderer():enableBold(true)
    self:getChildByName("top"):getChildByName("return"):addTouchEventListener(self.onReturn)
    self:getChildByName("top"):getChildByName("addgold"):addTouchEventListener(dd.onPay)
    self:getChildByName("top"):getChildByName("count"):setString(dd.myinfo:getLong(1,"gold"))

    self:getChildByName("back"):setPositionY(0)

    self:getChildByName("title"):setPositionY(hh - 105 - 320)
    self:getChildByName("scrollview"):setContentSize(cc.size(720,hh-110 - 330))
    self:getChildByName("scrollview"):setPositionY(0)
    self:getChildByName("scrollview"):addScrollViewEventListener(self.scrollViewEvent)
    self:getChildByName("title"):getChildByName("clear"):addTouchEventListener(self.BtnDeleteEvent)
    self:getChildByName("waiting"):setPositionY(0)

    local cache = cc.SpriteFrameCache:getInstance()
    cache:addSpriteFrames("images/mv/normaleffect.plist")
    for j = 1, 12 do
        local frame = nil
        if j < 10 then
            frame = cache:getSpriteFrame("of_native_loader_progress_0"..j..".png")
        else
            frame = cache:getSpriteFrame("of_native_loader_progress_"..j..".png")
        end 
            self._animFrames[j] = frame
    end
    self:getChildByName("waiting"):getChildByName("icon"):loadTexture("of_native_loader_progress_01.png", 1)

end

function repViewLayer.onStart(sender)
    -- body
    ff.net:registerEvent(2,dd.Tjf_User_Report_GetList, function (message)sender:onGetRepInfo(message)end)
    local getRepMsg = ff.net:createMessage()
    getRepMsg:addCmd(0x00000045)
    getRepMsg:addLong(dd.uid)
    getRepMsg:addLong(sender._type)
    getRepMsg:addLong(0)
    getRepMsg:addSuperLong(sender._repCount)
    getRepMsg:addSuperLong(0)
    ff.net:rpc(getRepMsg,false)

    if sender._type == 211 then
        rows = ff.dbmanager:sql_fetch_rows("select * from cfg_enemy_inf")
        sender._enemy = {}
        for i=1,rows:rowCount() do
            local id = tonumber(rows:getString(i,"enemyid"))
            sender._enemy[id] = {}
            if ff.lang == -1 then
                sender._enemy[id]["name"] = rows:getString(i,"name")
                sender._enemy[id]["tips"] = rows:getString(i,"disc")
            else
                sender._enemy[id]["name"] = tonumber(rows:getString(i,"name_lan"))
                sender._enemy[id]["tips"] = tonumber(rows:getString(i,"disc_lan"))
            end
            --sender._enemy[id]["name"] = rows:getString(i,"name")
            --sender._e


            sender._enemy[id]["tips"] = rows:getString(i,"disc")
            sender._enemy[id]["image"] = tonumber(rows:getString(i,"pic"))
        end
        rows:clear()
    end

    ff.net:bindProperty(2314,"gold",sender.updateGold)
    dd.initGoldSpine(sender:getChildByName("top"):getChildByName("gold"),sender:getChildByName("top"):getChildByName("addgold"))
end

function repViewLayer.onEnd( sender )
    -- body
    ff.net:removeEvent(2,dd.Tjf_User_Report_GetList)
    dd.delBackEvent()
    sender:showWaiting(false)

    if sender._repData ~= nil then 
        sender._repData:clear()
        sender._repData = nil
    end
    sender:getChildByName("scrollview"):removeAllChildren(true)
    ff.net:unbindProperty("gold",2314)
end

function repViewLayer.openItems( sender, eventType )
    -- body
    local doaction = false
    local widget = pop.getDialog("repView")
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType==ccui.TouchEventType.ended then    
        doaction = true
    end
    if doaction == true then
        local widget = pop.getDialog("repView")
        if widget == nil then
            return
        end
        local index = sender:getTag()
        if widget ~= nil  and widget._repData ~= nil and widget._repData:rowCount() >= index then
            local item = widget:getChildByName("scrollview"):getChildByTag(index)
            item:getChildByTag(1):getChildByName("open"):setVisible(false)
            item:getChildByTag(1):getChildByName("down"):setVisible(true)
            item:getChildByTag(1):getChildByName("down"):setTouchEnabled(true) 
            local block1 = item:getChildByTag(1)

            local table = Split(widget._repData:getString(index,"content"),"%\\")
            local giftInfo = Split(table[8],'|')
            local count = 0
            local hh2 = 0
            local hh3 = 0
            local block2 = nil
            local block3 = nil
            for key, var in pairs(giftInfo) do
                
                local gift = Split(var,'%^')
                if tonumber(gift[1]) == 15 then
                    block3 = widget:getChildByName("block4"):clone()
                    block3:setVisible(true)
                    item:addChild(block3)
                    block3:setTag(3)
                    hh3 = 200
                    item:setContentSize(cc.size(700,140 + hh2 + hh3))
                    block1:setPosition(cc.p(0,hh2 + hh3))
                    block3:setPosition(cc.p(0,0))
                    if block2 ~= nil  then
                        block2:setPosition(cc.p(0,hh3))
                    end
                    --cclog("000=="..hh3)

                    local color = dd.cfgCrystal[tonumber(gift[2])]['color']
                    if color > 0 and color <6 then
                        block3:getChildByName("item"):loadTexture(dd.getPathFromUI("cp_boxex_"..color..".png",1))
                    end
                    block3:getChildByName("item"):getChildByName("ico"):loadTexture(dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[1],dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[2])
                    block3:getChildByName("name"):setString(ff.langString(dd.cfgCrystal[tonumber(gift[2])]['name']).." X 1")
                elseif tonumber(gift[1]) == 9 then
                    --block2:getChildByName("exp"):setString("EXP + "..tonumber(gift[3])                    
                else
                    if count == 0 then
                        block2 = widget:getChildByName("block3"):clone()
                        block2:setVisible(true)
                        item:addChild(block2)
                        block2:setTag(2)
                        hh2 = 215
                        item:setContentSize(cc.size(700,140 + hh2 + hh3))
                        block1:setPosition(cc.p(0,hh2 + hh3))
                        block2:setPosition(cc.p(0,hh3))
                        if block3 ~= nil then
                            block3:setPosition(cc.p(0,0))
                        end
                        --cclog("2ss=="..hh2.."--"..hh3)
                    end
                    count = count + 1
                    local name = "item"..count
                    local num = "count"..count
                    if block2:getChildByName(name) ~= nil then
                    --cclog("========="..gift[2].."=="..gift[3])
                        block2:getChildByName(name):getChildByName("ico"):loadTexture(dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[1],dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[2])
                        block2:getChildByName(num):getChildByName("count"):setString(gift[3])
                    else
                        break
                    end
                   
                end
        
            end
        end
        widget:getChildByName("scrollview"):refreshView()
    end

end

function repViewLayer.openItems214( sender, eventType )
    -- body
    local doaction = false
    local widget = pop.getDialog("repView")
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType==ccui.TouchEventType.ended then    
        doaction = true
    end
    if doaction == true then
        local widget = pop.getDialog("repView")
        if widget == nil then
            return
        end
        local index = sender:getTag()
        if widget ~= nil  and widget._repData ~= nil and widget._repData:rowCount() >= index then
            local item = widget:getChildByName("scrollview"):getChildByTag(index)
            item:getChildByTag(1):getChildByName("open"):setVisible(false)
            item:getChildByTag(1):getChildByName("down"):setVisible(true)
            item:getChildByTag(1):getChildByName("down"):setTouchEnabled(true) 
            local block1 = item:getChildByTag(1)

            local table = Split(widget._repData:getString(index,"content"),"%\\")
            local giftInfo = Split(table[8],'|')
            local count = 0

        
            local block3 = item:getChildByTag(3)
            for key, var in pairs(giftInfo) do
                
                local gift = Split(var,'%^')
                
                if count == 0 then
                    if block3 == nil then
                        block3 = widget:getChildByName("block3"):clone()
                        block3:setVisible(true)
                        item:addChild(block3)
                        block3:setTag(3)
                        item:setContentSize(cc.size(700,140 + 200 + 215))
                        block1:setPosition(cc.p(0,200+215))
                        block3:setPosition(cc.p(0,200))
                    end
                end
                count = count + 1
                local name = "item"..count
                local num = "count"..count
                block3:getChildByName(name):getChildByName("ico"):loadTexture(dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[1],dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[2])
                block3:getChildByName(num):getChildByName("count"):setString(gift[3])
            end
            if tonumber(table[9]) ~= nil and tonumber(table[9]) == 1 then
                local block4 = item:getChildByTag(4)
                if block4 == nil then
                    block4 = widget:getChildByName("block7"):clone()
                end
                block4:getChildByName("ico"):loadTexture("images/icon/battle/type/repViewFist.jpg",0)
                local level = dd.cfgNpc[tonumber(table[2])]["level"] + 1
                block4:getChildByName("label"):setString(ff.langString("恭喜你首次击杀Lv.{0}的怪物，现在你可以挑战Lv.{1}的怪物了。",{dd.cfgNpc[tonumber(table[2])]["level"],level}))
                block4:setVisible(true)
                item:addChild(block4)
                item:setContentSize(cc.size(700,140 + 200 + 215 + 195))
                block4:setPosition(cc.p(0,200 + 215))
                block4:setTag(4)
                block1:setPosition(cc.p(0,200+215+195))
                block3:setPosition(cc.p(0,200))
               
            end
        end
        widget:getChildByName("scrollview"):refreshView()
    end

end

function repViewLayer.openItems216( sender, eventType )
    -- body
    local doaction = false
    local widget = pop.getDialog("repView")
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType==ccui.TouchEventType.ended then    
        doaction = true
    end
    if doaction == true then
        local widget = pop.getDialog("repView")
        if widget == nil then
            return
        end
        local index = sender:getTag()
        if widget ~= nil  and widget._repData ~= nil and widget._repData:rowCount() >= index then
            local item = widget:getChildByName("scrollview"):getChildByTag(index)
            item:getChildByTag(1):getChildByName("open"):setVisible(false)
            item:getChildByTag(1):getChildByName("down"):setVisible(true)
            item:getChildByTag(1):getChildByName("down"):setTouchEnabled(true) 
            local block1 = item:getChildByTag(1)

            local table = Split(widget._repData:getString(index,"content"),"%\\")
            local block12 = widget:getChildByName("block12"):clone()
            if block12 ~= nil then
                block12:setVisible(true)
                block12:setTag(2)
                item:addChild(block12)
                item:setContentSize(cc.size(700,340+180))
                block1:setPosition(cc.p(0,340))
                block12:setPosition(cc.p(0,0))
                block12:getChildByName("point1"):setString(table[7])
                block12:getChildByName("point2"):setString(table[6])
                block12:getChildByName("point3"):setString(table[5])
                local giftInfo = Split(table[8],'|')
                cclog("======="..table[8])
                for key, var in pairs(giftInfo) do
                    
                    local gift = Split(var,'%^')
                    if tonumber(gift[1]) == 5 then
                        cclog("555="..gift[3])
                        block12:getChildByName("count1"):getChildByName("count"):setString(gift[3])
                    elseif tonumber(gift[1]) == 3 then
                        cclog("222="..gift[3])
                        block12:getChildByName("count2"):getChildByName("count"):setString(gift[3])
                    elseif tonumber(gift[1]) == 6 then
                        cclog("666="..gift[3])
                        block12:getChildByName("count3"):getChildByName("count"):setString(gift[3])
                    end 
                end
                block12:getChildByName("Image_214"):loadTexture("images/icon/boss/back.jpg",0)
                local per = tonumber(table[13])/tonumber(table[12])*100
                block12:getChildByName("progresshp"):getChildByName("progress"):setPercent(per)
                block12:getChildByName("progresshp"):getChildByName("exp"):setString(table[13].."/"..table[12])
                block12:getChildByName("ico"):getChildByName("Image_207"):loadTexture(dd.getPlayerIcon(dd.myinfo:getLong(1,"face")),0)
            end
            
        end
        widget:getChildByName("scrollview"):refreshView()
    end

end

function repViewLayer.openItems217( sender, eventType )
    -- body
    local doaction = false
    local widget = pop.getDialog("repView")
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType==ccui.TouchEventType.ended then    
        doaction = true
    end
    if doaction == true then
        local widget = pop.getDialog("repView")
        if widget == nil then
            return
        end
        local index = sender:getTag()
        if widget ~= nil  and widget._repData ~= nil and widget._repData:rowCount() >= index then
            local item = widget:getChildByName("scrollview"):getChildByTag(index)
            item:getChildByTag(1):getChildByName("open"):setVisible(false)
            item:getChildByTag(1):getChildByName("down"):setVisible(true)
            item:getChildByTag(1):getChildByName("down"):setTouchEnabled(true) 
            local block1 = item:getChildByTag(1)

            local table = Split(widget._repData:getString(index,"content"),"%\\")
            local block3 = widget:getChildByName("block3"):clone()
            local hh = 0
            local count = 0
            if block3 ~= nil then
                block3:setVisible(true)
                block3:setTag(2)
                item:addChild(block3)
                
                --item:setContentSize(cc.size(700,340+180))
                --block1:setPosition(cc.p(0,hh))
                block3:setPosition(cc.p(0,hh))
                hh =hh + 215
               
                local giftInfo = Split(table[6],'|')
                cclog("======="..table[8])
                for key, var in pairs(giftInfo) do
                    
                    local gift = Split(var,'%^')
                    count = count + 1
                    local name = "item"..count
                    local num = "count"..count
                    if block3 ~= nil and block3:getChildByName(name) ~= nil then
                        block3:getChildByName(name):getChildByName("ico"):loadTexture(dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[1],dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[2])
                        block3:getChildByName(num):getChildByName("count"):setString(gift[3])
                    end
                end
            end

            local block13 = widget:getChildByName("block13"):clone()
            if block13 ~= nil then
                block13:setVisible(true)
                block13:setTag(3)
                item:addChild(block13)
                block13:getChildByName("name"):setString(dd.myinfo:getString(1,"name"))
                block13:getChildByName("ico"):getChildByName("ico"):loadTexture(dd.getPlayerIcon(dd.myinfo:getLong(1,"face")),0)
                block13:getChildByName("power"):getChildByName("name"):setString(ff.langString("总兵力")..":")
                block13:getChildByName("wonder"):getChildByName("name"):setString(ff.langString("剩余")..":")
                block13:getChildByName("killed"):getChildByName("name"):setString(ff.langString("撤退")..":")
                block13:getChildByName("power"):getChildByName("count"):setString(table[3])
                block13:getChildByName("wonder"):getChildByName("count"):setString(table[4])
                block13:getChildByName("killed"):getChildByName("count"):setString(table[5])
                --item:setContentSize(cc.size(700,340+180))
                --block1:setPosition(cc.p(0,hh))
                block13:setPosition(cc.p(0,hh))
                hh =hh + 200
            end
            block1:setPosition(cc.p(0,hh))
            hh = hh + 180
            item:setContentSize(cc.size(700,hh))
        end
        widget:getChildByName("scrollview"):refreshView()
    end

end

function repViewLayer.openItemsEx( sender, eventType )
    -- body
    local doaction = false
    local widget = pop.getDialog("repView")
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType==ccui.TouchEventType.ended then    
        doaction = true
    end
    if doaction == true then
        local widget = pop.getDialog("repView")
        if widget == nil then
            return
        end
        --cclog("=============")
        if sender:getParent():getChildByName("open"):isVisible() == true then
     
            widget.openItems(sender:getParent():getChildByName("open"),ccui.TouchEventType.ended)
        else
      
            widget.closeItems(sender:getParent():getChildByName("down"),ccui.TouchEventType.ended)
        end
    end
end

function repViewLayer.openItemsEx214( sender, eventType )
    -- body
    local doaction = false
    local widget = pop.getDialog("repView")
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType==ccui.TouchEventType.ended then    
        doaction = true
    end
    if doaction == true then
        local widget = pop.getDialog("repView")
        if widget == nil then
            return
        end
        --cclog("=============")
        if sender:getParent():getChildByName("open"):isVisible() == true then
     
            widget.openItems214(sender:getParent():getChildByName("open"),ccui.TouchEventType.ended)
        else
      
            widget.closeItems214(sender:getParent():getChildByName("down"),ccui.TouchEventType.ended)
        end
    end
end

function repViewLayer.openItemsEx216( sender, eventType )
    -- body
    local doaction = false
    local widget = pop.getDialog("repView")
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType==ccui.TouchEventType.ended then    
        doaction = true
    end
    if doaction == true then
        local widget = pop.getDialog("repView")
        if widget == nil then
            return
        end
        --cclog("=============")
        if sender:getParent():getChildByName("open"):isVisible() == true then
     
            widget.openItems216(sender:getParent():getChildByName("open"),ccui.TouchEventType.ended)
        else
      
            widget.closeItems216(sender:getParent():getChildByName("down"),ccui.TouchEventType.ended)
        end
    end
end

function repViewLayer.openItemsEx217( sender, eventType )
    -- body
    local doaction = false
    local widget = pop.getDialog("repView")
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType==ccui.TouchEventType.ended then    
        doaction = true
    end
    if doaction == true then
        local widget = pop.getDialog("repView")
        if widget == nil then
            return
        end
        --cclog("=============")
        if sender:getParent():getChildByName("open"):isVisible() == true then
     
            widget.openItems217(sender:getParent():getChildByName("open"),ccui.TouchEventType.ended)
        else
      
            widget.closeItems217(sender:getParent():getChildByName("down"),ccui.TouchEventType.ended)
        end
    end
end

function repViewLayer.closeItems( sender, eventType )
    -- body
    local doaction = false
    local widget = pop.getDialog("repView")
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType==ccui.TouchEventType.ended then    
        doaction = true
    end
    if doaction == true then
        local widget = pop.getDialog("repView")
        if widget == nil then
            return
        end
        local index = sender:getTag()
        if widget ~= nil  and widget._repData ~= nil and widget._repData:rowCount() >= index then
            local item = widget:getChildByName("scrollview"):getChildByTag(index)
            item:getChildByTag(1):getChildByName("open"):setVisible(true)
            item:getChildByTag(1):getChildByName("open"):setTouchEnabled(true)
            item:getChildByTag(1):getChildByName("down"):setVisible(false)
            local block1 = item:getChildByTag(2)
            if block1 ~= nil then
                block1:removeFromParent(true)
            end
            local block2 = item:getChildByTag(3)
            if block2 ~= nil then
                block2:removeFromParent(true)
            end
            item:setContentSize(cc.size(700,140))
            item:getChildByTag(1):setPosition(cc.p(0,0))
        end
        widget:getChildByName("scrollview"):refreshView()
    end
end

function repViewLayer.closeItems214( sender, eventType )
    -- body
    local doaction = false
    local widget = pop.getDialog("repView")
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType==ccui.TouchEventType.ended then    
        doaction = true
    end
    if doaction == true then
        local widget = pop.getDialog("repView")
        if widget == nil then
            return
        end
        local index = sender:getTag()
        if widget ~= nil  and widget._repData ~= nil and widget._repData:rowCount() >= index then
            local item = widget:getChildByName("scrollview"):getChildByTag(index)
            item:getChildByTag(1):getChildByName("open"):setVisible(true)
            item:getChildByTag(1):getChildByName("open"):setTouchEnabled(true)
            item:getChildByTag(1):getChildByName("down"):setVisible(false)
            local block2 = item:getChildByTag(3)
            if block2 ~= nil then
                block2:removeFromParent(true)
            end
            local block4 = item:getChildByTag(4)
            if block4 ~= nil then
                block4:removeFromParent(true)
            end
            item:setContentSize(cc.size(700,140 + 200))
            item:getChildByTag(1):setPosition(cc.p(0,200))
        end
        widget:getChildByName("scrollview"):refreshView()
    end
end

function repViewLayer.closeItems216( sender, eventType )
    -- body
    local doaction = false
    local widget = pop.getDialog("repView")
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType==ccui.TouchEventType.ended then    
        doaction = true
    end
    if doaction == true then
        local widget = pop.getDialog("repView")
        if widget == nil then
            return
        end
        local index = sender:getTag()
        if widget ~= nil  and widget._repData ~= nil and widget._repData:rowCount() >= index then
            local item = widget:getChildByName("scrollview"):getChildByTag(index)
            item:getChildByTag(1):getChildByName("open"):setVisible(true)
            item:getChildByTag(1):getChildByName("open"):setTouchEnabled(true)
            item:getChildByTag(1):getChildByName("down"):setVisible(false)
            local block2 = item:getChildByTag(2)
            if block2 ~= nil then
                block2:removeFromParent(true)
            end

            item:setContentSize(cc.size(700,180))
            item:getChildByTag(1):setPosition(cc.p(0,0))
        end
        widget:getChildByName("scrollview"):refreshView()
    end
end

function repViewLayer.closeItems217( sender, eventType )
    -- body
    local doaction = false
    local widget = pop.getDialog("repView")
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType==ccui.TouchEventType.ended then    
        doaction = true
    end
    if doaction == true then
        local widget = pop.getDialog("repView")
        if widget == nil then
            return
        end
        local index = sender:getTag()
        if widget ~= nil  and widget._repData ~= nil and widget._repData:rowCount() >= index then
            local item = widget:getChildByName("scrollview"):getChildByTag(index)
            item:getChildByTag(1):getChildByName("open"):setVisible(true)
            item:getChildByTag(1):getChildByName("open"):setTouchEnabled(true)
            item:getChildByTag(1):getChildByName("down"):setVisible(false)
            local block2 = item:getChildByTag(2)
            if block2 ~= nil then
                block2:removeFromParent(true)
            end
            local block3 = item:getChildByTag(3)
            if block3 ~= nil then
                block3:removeFromParent(true)
            end

            item:setContentSize(cc.size(700,180))
            item:getChildByTag(1):setPosition(cc.p(0,0))
        end
        widget:getChildByName("scrollview"):refreshView()
    end
end

function repViewLayer.toMap( sender, eventType )
    -- body
    local doaction = false
    local widget = pop.getDialog("repView")
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    if eventType==ccui.TouchEventType.ended then    
        doaction = true
    end
    if doaction == true then
        local widget = pop.getDialog("repView")
        if widget == nil then
            return
        end
        local index = sender:getTag()
        if widget ~= nil  and widget._repData ~= nil and widget._repData:rowCount() >= index then
            local table = Split(widget._repData:getString(index,"content"),"%\\")
            local function close( event )
                widget.onReturn()
                local widgetex = pop.getDialog("mail")
                widgetex.onReturn()
            end 
            local function toMap2(event)
               if dd.currentLayer._name ~= "WorldUILayer" then
                dd.yunClose(2,nil,nil,tonumber(table[3]))
                else
                    if dd.worldLayer ~= nil then
                        WorldControl:getInstance():closePannel()
                        performWithDelay(sender, close,0.5)
                        dd.worldLayer:setSceneCenterByGid(tonumber(table[3])-1,true)   
                    end
                end
            end
            performWithDelay(sender, toMap2,0.5)
        end
        
    end
end


function repViewLayer:showInfo( removeAll )
    -- body
    --cclog("================"..self._repData:rowCount())
    if self._repData == nil then
        return
    end

    local count = 1
    if removeAll ==true then
        self:getChildByName("scrollview"):removeAllChildren(true)
    else
        count  = table.getn(self:getChildByName("scrollview"):getItems())+1
    end

    if self._type == 201 then
        for i=count,self._repData:rowCount() do
            item = self:getChildByName("block1"):clone()
            item:setVisible(true)
            item:setTouchEnabled(true)
            item:setTag(i)

            local dateStr = ff.showData(self._repData:getLong(i,"time"))

            item:getChildByName('time'):setString(dateStr)

            local table = Split(self._repData:getString(i,"content"),"%\\")

            local giftInfo = Split(table[3],'|')
            
            for key, var in pairs(giftInfo) do
                
                local gift = Split(var,'%^')
                if key == 1 then
                    item:getChildByName("block"):getChildByName("item1"):loadTexture(dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[1],dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[2])
                    item:getChildByName("block"):getChildByName("count1"):setString(ff.getFormatMoney(gift[3]))
                else
                    if tonumber(gift[1]) == 1 then
                        if key == 2 then
                            item:getChildByName("block"):getChildByName("count2"):setVisible(true)
                            item:getChildByName("block"):getChildByName("item2"):setVisible(true)
                            item:getChildByName("block"):getChildByName("count2"):setString("X "..ff.getFormatMoney(gift[3]))
                          
                            item:getChildByName("block"):getChildByName("item2"):loadTexture(dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[1],dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[2])
                        else
                            item:getChildByName("block"):getChildByName("count3"):setVisible(true)
                            item:getChildByName("block"):getChildByName("item3"):setVisible(true)
                            item:getChildByName("block"):getChildByName("count3"):setString("X "..ff.getFormatMoney(gift[3]))
                          
                            item:getChildByName("block"):getChildByName("item3"):loadTexture(dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[1],dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[2])
                        end
                    end
                end
        
            end
        
            local mapsite=dd.MapidToXY(tonumber(table[2]))

            local info =  item:getChildByName("info")
            info:getVirtualRenderer():enableBold(true)
    
            info:setString(ff.langString(dd.cfgWorldRes[tonumber(table[1])]['name']).." LV."..dd.cfgWorldRes[tonumber(table[1])]['level'].."  ( "..mapsite.x..","..mapsite.y.." )")
            item:requestDoLayout()
            item:setTag(i)

            self:getChildByName("scrollview"):pushBackCustomItem(item)
        end
    elseif self._type == 211 then
        for i=count,self._repData:rowCount() do
            item = self:getChildByName("block"):clone()
            item:setVisible(true)
            item:setTouchEnabled(true)
            item:setTag(i)
            local block2 = self:getChildByName("block2"):clone()
            block2:setVisible(true)
            item:addChild(block2)
            local hh = 0
            
            block2:setPosition(cc.p(0,0))
            block2:setTag(1)
            hh = hh + 140
            item:setContentSize(cc.size(700,hh))
            
            local dateStr = ff.showData(self._repData:getLong(i,"time"))

            block2:getChildByName('time'):setString(dateStr)

            local table = Split(self._repData:getString(i,"content"),"%\\")

            if table[10]~=nil then
                block2:getChildByName("heroname"):setVisible(true)
                block2:getChildByName("heroname"):setString(ff.langString(dd.cfgHero[tonumber(table[10])]['name']).." LV."..table[11] )
            else
                block2:getChildByName("heroname"):setVisible(false)
            end

            block2:getChildByName("enemy"):setString(ff.langString(self._enemy[tonumber(table[4])]["name"]).." LV."..table[2])

            local info =  block2:getChildByName("info")
            if tonumber(table[7]) == 1 then
                info:setString(ff.langString("战斗胜利"))
                block2:getChildByName("heroname"):setColor(cc.c3b(161,175,175))
                block2:getChildByName("enemy"):setColor(cc.c3b(237,101,103))
                block2:getChildByName("iswin"):loadTexture(dd.getPathFromUI("vs_win.png",1))
                --info:setString(ff.langString("攻击").." "..ff.langString(self._enemy[tonumber(table[4])]["name"]).."LV."..table[2].." "..ff.langString("成功"))
            else
                info:setString(ff.langString("战斗失败"))
                block2:getChildByName("enemy"):setColor(cc.c3b(161,175,175))
                block2:getChildByName("heroname"):setColor(cc.c3b(237,101,103))
                block2:getChildByName("iswin"):loadTexture(dd.getPathFromUI("vs_loss.png",1))
                --info:setString(ff.langString("攻击").." "..ff.langString(self._enemy[tonumber(table[4])]["name"]).."LV."..table[2].." "..ff.langString("失败"))
            end
            info:getVirtualRenderer():enableBold(true)
            block2:requestDoLayout()
            local giftInfo = Split(table[8],'|')
            local index = 1
            block2:getChildByName("open"):setVisible(false)
            block2:getChildByName("open"):setTouchEnabled(false)
            block2:getChildByName("down"):setVisible(false)
            block2:getChildByName("down"):setTouchEnabled(false)
            block2:getChildByName("open"):setTag(i)
            block2:getChildByName("down"):setTag(i)
            block2:getChildByName("open"):addTouchEventListener(self.openItems)
            block2:getChildByName("down"):addTouchEventListener(self.closeItems)
            block2:getChildByName("exp"):setString("EXP + 0")
            block2:getChildByName("Image_57"):setTouchEnabled(false)
            block2:getChildByName("Image_57"):addTouchEventListener(self.openItemsEx)
            for key, var in pairs(giftInfo) do
                
                local gift = Split(var,'%^')
                if tonumber(gift[1]) == 15 then

                    block2:getChildByName("open"):setVisible(true)
                    block2:getChildByName("open"):setTouchEnabled(true)
                    block2:getChildByName("Image_57"):setTouchEnabled(true)
                elseif tonumber(gift[1]) == 9 then
                    block2:getChildByName("exp"):setString("EXP + "..tonumber(gift[3]))
                elseif tonumber(gift[1]) == 6 then
      
                    block2:getChildByName("open"):setVisible(true)
                    block2:getChildByName("open"):setTouchEnabled(true)
                    block2:getChildByName("Image_57"):setTouchEnabled(true)
                else
                    block2:getChildByName("open"):setVisible(true)
                    block2:getChildByName("open"):setTouchEnabled(true)
                    block2:getChildByName("Image_57"):setTouchEnabled(true)
                end
        
            end

            self:getChildByName("scrollview"):pushBackCustomItem(item)
        end
    elseif self._type == 214 then
        for i=count,self._repData:rowCount() do
            local table = Split(self._repData:getString(i,"content"),"%\\")
            item = self:getChildByName("block"):clone()
            item:setVisible(true)
            item:setTouchEnabled(true)
            item:setTag(i)
            local hh = 0
            local block5 = self:getChildByName("block5"):clone()
            block5:setVisible(true)
            block5:setTag(2)
            item:addChild(block5)
            block5:getChildByName("chu_Label_156_1"):setString(ff.langString("战斗详情"))
            block5:setPosition(cc.p(0,0))
            hh = hh + 200
            
            
            
            local block2 = self:getChildByName("block6"):clone()
            block2:setVisible(true)
            item:addChild(block2)
          
            block2:setPosition(cc.p(0,hh))
            block2:setTag(1)
            hh = hh + 140

            item:setContentSize(cc.size(700,hh))
            
            local dateStr = ff.showData(self._repData:getLong(i,"time"))

            block2:getChildByName('time'):setString(dateStr)

            

            block2:getChildByName("enemy"):setString(ff.langString(dd.cfgNpc[tonumber(table[2])]["name"]).."  LV."..dd.cfgNpc[tonumber(table[2])]["level"])

            --block2:getChildByName("enemy"):setString(" LV.")

            local info =  block2:getChildByName("info")
            if tonumber(table[1]) == 1 then
                if tonumber(table[9]) ~= nil and tonumber(table[9]) == 1 then
                    info:setString(ff.langString("首杀"))
                else

                    info:setString(ff.langString("战斗胜利"))
                end
                
                block2:getChildByName("enemy"):setColor(cc.c3b(237,101,103))
                block2:getChildByName("iswin"):loadTexture(dd.getPathFromUI("vs_win.png",1))
                --info:setString(ff.langString("攻击").." "..ff.langString(self._enemy[tonumber(table[4])]["name"]).."LV."..table[2].." "..ff.langString("成功"))
            else
                info:setString(ff.langString("战斗失败"))
                block2:getChildByName("enemy"):setColor(cc.c3b(161,175,175))
   
                block2:getChildByName("iswin"):loadTexture(dd.getPathFromUI("vs_loss.png",1))
                --info:setString(ff.langString("攻击").." "..ff.langString(self._enemy[tonumber(table[4])]["name"]).."LV."..table[2].." "..ff.langString("失败"))
            end
            if table[7] ~= nil then
                block5:getChildByName("power"):getChildByName("count"):setString("-"..table[7])
            end
            if table[6] ~= nil then
                block5:getChildByName("wonder"):getChildByName("count"):setString(table[6])
            end
            if table[4] ~= nil then
                block5:getChildByName("total_unit"):getChildByName("count"):setString(table[4])
            end
            --if table[6] ~= nil then
            local remaining = tonumber(table[4])- tonumber(table[5]) - tonumber(table[6])
                block5:getChildByName("remaining"):getChildByName("count"):setString(remaining)
            --end
            if table[5] ~= nil then
                block5:getChildByName("killed"):getChildByName("count"):setString(table[5])
            end
            info:getVirtualRenderer():enableBold(true)
            block2:requestDoLayout()
            local giftInfo = Split(table[8],'|')
            local index = 1
            block2:getChildByName("open"):setVisible(false)
            block2:getChildByName("open"):setTouchEnabled(false)
            block2:getChildByName("down"):setVisible(true)
            block2:getChildByName("down"):setTouchEnabled(true)
            block2:getChildByName("open"):setTag(i)
            block2:getChildByName("down"):setTag(i)
            block2:getChildByName("open"):addTouchEventListener(self.openItems214)
            block2:getChildByName("down"):addTouchEventListener(self.closeItems214)
            block2:getChildByName("Image_57"):setTouchEnabled(false)
            block2:getChildByName("Image_57"):addTouchEventListener(self.openItemsEx214)
            local count = 0
            local close = false
            local block3 =nil-- self:getChildByName("block3"):clone()
            for key, var in pairs(giftInfo) do
                
                local gift = Split(var,'%^')
                if tonumber(gift[1]) == 15 then
                    close = true
                    --block2:getChildByName("open"):setVisible(true)
                    --block2:getChildByName("open"):setTouchEnabled(true)
                    block2:getChildByName("Image_57"):setTouchEnabled(true)
                elseif tonumber(gift[1]) == 9 then
                    block2:getChildByName("exp"):setString("EXP + "..tonumber(gift[3]))
                elseif tonumber(gift[1]) == 6 then
      
                    close = true
                    block2:getChildByName("Image_57"):setTouchEnabled(true)
                else
                    close = true
                    block2:getChildByName("Image_57"):setTouchEnabled(true)
                end
            end
            if close == true then
                block3 = self:getChildByName("block3"):clone()
                block3:setVisible(true)
                item:addChild(block3)
                block3:setTag(3)
                item:setContentSize(cc.size(700,140 + 200 + 215))
                block2:setPosition(cc.p(0,200+215))
                block3:setPosition(cc.p(0,200))
            else
                block2:getChildByName("down"):setVisible(false)
                block2:getChildByName("down"):setTouchEnabled(false)
            end
            if tonumber(table[9]) ~= nil and tonumber(table[9]) == 1 then
                local block7 = self:getChildByName("block7"):clone()
                block7:setVisible(true)
                item:addChild(block7)
                block7:getChildByName("ico"):loadTexture("images/icon/battle/type/repViewFist.jpg",0)
                local level = dd.cfgNpc[tonumber(table[2])]["level"] + 1
                block7:getChildByName("label"):setString(ff.langString("恭喜你首次击杀Lv.{0}的怪物，现在你可以挑战Lv.{1}的怪物了。",{dd.cfgNpc[tonumber(table[2])]["level"],level}))
                item:setContentSize(cc.size(700,140 + 200 + 215 + 195))
                block2:setPosition(cc.p(0,200+215 + 195))
                block7:setPosition(cc.p(0,200 + 215))
                block7:setTag(4)
            end
            for key, var in pairs(giftInfo) do
                
                local gift = Split(var,'%^')
                count = count + 1
                local name = "item"..count
                local num = "count"..count
                if block3 ~= nil and block3:getChildByName(name) ~= nil then
                    block3:getChildByName(name):getChildByName("ico"):loadTexture(dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[1],dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[2])
                    block3:getChildByName(num):getChildByName("count"):setString(gift[3])
                end
            end

            self:getChildByName("scrollview"):pushBackCustomItem(item)
        end
    elseif self._type == 215 then
        for i=count,self._repData:rowCount() do
            local table = Split(self._repData:getString(i,"content"),"%\\")
            item = self:getChildByName("block"):clone()
            item:setVisible(true)
            item:setTouchEnabled(true)
            item:setTag(i)
            local hh = 0

            block10 = self:getChildByName("block10"):clone()
            block10:setVisible(true)
            item:addChild(block10)
            block10:setTag(1)
            block10:setPosition(cc.p(0,hh))
            hh = hh + 162
            local giftInfo = Split(table[8],'|')
            local count = 0
            for key, var in pairs(giftInfo) do
                
                local gift = Split(var,'%^')
                count = count + 1
                local name = "item"..count
                local num = "count"..count
                if block10 ~= nil then
                    block10:getChildByName(name):getChildByName("ico"):loadTexture(dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[1],dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[2])
                    block10:getChildByName(num):getChildByName("count"):setString(gift[3])
                end
            end

            block9 = self:getChildByName("block9"):clone()
            block9:setVisible(true)
            item:addChild(block9)
            block9:setTag(2)
            block9:getChildByName("info"):setString(ff.langString("掉落的物品"))
            block9:getChildByName("heroname"):setString(ff.langString("伤害越高，奖励越丰厚"))
            block9:setPosition(cc.p(0,hh))
            hh = hh + 160


            local block2 = self:getChildByName("block5"):clone()
            block2:setVisible(true)
            block2:setTag(3)
            item:addChild(block2)
            if table[7] ~= nil then
                block2:getChildByName("power"):getChildByName("count"):setString("-"..table[7])
            end
            if table[6] ~= nil then
                block2:getChildByName("wonder"):getChildByName("count"):setString(table[6])
            end
            if table[4] ~= nil then
                block2:getChildByName("total_unit"):getChildByName("count"):setString(table[4])
            end
            --if table[6] ~= nil then
            local remaining = tonumber(table[4])- tonumber(table[5]) - tonumber(table[6])
                block2:getChildByName("remaining"):getChildByName("count"):setString(remaining)
            --end
            if table[5] ~= nil then
                block2:getChildByName("killed"):getChildByName("count"):setString(table[5])
            end
            block2:getChildByName("chu_Label_156_1"):setString(ff.langString("战斗详情"))
            block2:setPosition(cc.p(0,hh))
            hh = hh + 200

            local block5 = self:getChildByName("block8"):clone()
            block5:setVisible(true)
            block5:setTag(4)

            item:addChild(block5)
            if tonumber(table[1]) == 1 then
                block5:getChildByName("info"):setString(ff.langString("战斗胜利"))
            else
                block5:getChildByName("info"):setString(ff.langString("战斗失败"))
            end
            local dateStr = ff.showData(self._repData:getLong(i,"time"))
            block5:getChildByName('time'):setString(dateStr)
            local mapsite=dd.MapidToXY(tonumber(table[3]))
            block5:getChildByName("ico"):getChildByName("ico"):loadTexture(dd.getBossImg(),0)
            block5:getChildByName("pos"):setString("(x:"..mapsite.x..",y:"..mapsite.y..")")
            block5:getChildByName("name"):setString(ff.langString(dd.cfgNpc[tonumber(table[2])]["name"]).."  LV."..dd.cfgNpc[tonumber(table[2])]["level"])
            block5:getChildByName("progresshp"):getChildByName("exp"):setString(table[10].."/"..table[9])
            local per = tonumber(table[10])/tonumber(table[9])*100
            block5:getChildByName("progresshp"):getChildByName("progress"):setPercent(per)
            block5:getChildByName("sh"):setString(ff.langString("受到伤害")..":")
            block5:getChildByName("hert"):setString(table[11])
            block5:getChildByName("go"):addTouchEventListener(self.toMap)
            block5:getChildByName("go"):setTag(i)
            block5:setPosition(cc.p(0,hh))
            hh = hh + 250

            item:setContentSize(cc.size(700,hh))
            
            self:getChildByName("scrollview"):pushBackCustomItem(item)
        end
    elseif self._type == 218 then
        for i=count,self._repData:rowCount() do
            local table = Split(self._repData:getString(i,"content"),"%\\")
            item = self:getChildByName("block"):clone()
            item:setVisible(true)
            item:setTouchEnabled(true)
            item:setTag(i)
            local hh = 0

            block10 = self:getChildByName("block10"):clone()
            block10:setVisible(true)
            item:addChild(block10)
            block10:setTag(1)
            block10:setPosition(cc.p(0,hh))
            hh = hh + 162
            local giftInfo = Split(table[8],'|')
            local count = 0
            for key, var in pairs(giftInfo) do
                
                local gift = Split(var,'%^')
                count = count + 1
                local name = "item"..count
                local num = "count"..count
                if block10 ~= nil then
                    block10:getChildByName(name):getChildByName("ico"):loadTexture(dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[1],dd.getGiftsIcon(tonumber(gift[1]), tonumber(gift[2]))[2])
                    block10:getChildByName(num):getChildByName("count"):setString(gift[3])
                end
            end

            block9 = self:getChildByName("block9"):clone()
            block9:setVisible(true)
            item:addChild(block9)
            block9:setTag(2)
            block9:getChildByName("info"):setString(ff.langString("掉落的物品"))
            block9:getChildByName("heroname"):setString(ff.langString("伤害越高，奖励越丰厚"))
            block9:setPosition(cc.p(0,hh))
            hh = hh + 160


            local block2 = self:getChildByName("block5"):clone()
            block2:setVisible(true)
            block2:setTag(3)
            item:addChild(block2)
            if table[7] ~= nil then
                block2:getChildByName("power"):getChildByName("count"):setString("-"..table[7])
            end
            if table[6] ~= nil then
                block2:getChildByName("wonder"):getChildByName("count"):setString(table[6])
            end
            if table[4] ~= nil then
                block2:getChildByName("total_unit"):getChildByName("count"):setString(table[4])
            end
            --if table[6] ~= nil then
            local remaining = tonumber(table[4])- tonumber(table[5]) - tonumber(table[6])
                block2:getChildByName("remaining"):getChildByName("count"):setString(remaining)
            --end
            if table[5] ~= nil then
                block2:getChildByName("killed"):getChildByName("count"):setString(table[5])
            end
            block2:getChildByName("chu_Label_156_1"):setString(ff.langString("战斗详情"))
            block2:setPosition(cc.p(0,hh))
            hh = hh + 200

            local block5 = self:getChildByName("block8"):clone()
            block5:setVisible(true)
            block5:setTag(4)

            item:addChild(block5)
            if tonumber(table[1]) == 1 then
                block5:getChildByName("info"):setString(ff.langString("战斗胜利"))
            else
                block5:getChildByName("info"):setString(ff.langString("战斗失败"))
            end
            local dateStr = ff.showData(self._repData:getLong(i,"time"))
            block5:getChildByName('time'):setString(dateStr)
            local mapsite=dd.MapidToXY(tonumber(table[3]))
            block5:getChildByName("ico"):getChildByName("ico"):loadTexture("images/icon/boss/210002.png",0)
            block5:getChildByName("pos"):setString("(x:"..mapsite.x..",y:"..mapsite.y..")")
            block5:getChildByName("name"):setString(ff.langString(dd.cfgNpc[tonumber(table[2])]["name"]).."  LV."..dd.cfgNpc[tonumber(table[2])]["level"])
            block5:getChildByName("progresshp"):getChildByName("exp"):setString(table[10].."/"..table[9])
            local per = tonumber(table[10])/tonumber(table[9])*100
            block5:getChildByName("progresshp"):getChildByName("progress"):setPercent(per)
            block5:getChildByName("sh"):setString(ff.langString("受到伤害")..":")
            block5:getChildByName("hert"):setString(table[11])
            block5:getChildByName("go"):addTouchEventListener(self.toMap)
            block5:getChildByName("go"):setTag(i)
            block5:setPosition(cc.p(0,hh))
            hh = hh + 250

            item:setContentSize(cc.size(700,hh))
            
            self:getChildByName("scrollview"):pushBackCustomItem(item)
        end
    elseif self._type == 216 then
        for i=count,self._repData:rowCount() do
            if i == 1 then
                local wanfa = self:getChildByName("block9"):clone()
                wanfa:setVisible(true)
                wanfa:getChildByName("info"):setString(ff.langString("玩法说明"))
                local string = ""
                string = string..ff.langString("城防和警长在守城战斗中发挥重要作用，请设置警长并确保装备穿戴正确（穿戴警长专属装备）")
                wanfa:getChildByName("heroname"):setString(string)
                self:getChildByName("scrollview"):pushBackCustomItem(wanfa)
            end
            local table = Split(self._repData:getString(i,"content"),"%\\")

            item = self:getChildByName("block"):clone()
            item:setVisible(true)
            item:setTouchEnabled(true)
            item:setTag(i)
            local hh = 0
            local block5 = self:getChildByName("block11"):clone()
            block5:setVisible(true)
            block5:setTag(1)
            block5:getChildByName("open"):setVisible(true)
            block5:getChildByName("open"):setTouchEnabled(true)
            block5:getChildByName("down"):setVisible(false)
            block5:getChildByName("down"):setTouchEnabled(false)
            block5:getChildByName("open"):setTag(i)
            block5:getChildByName("down"):setTag(i)
            block5:getChildByName("open"):addTouchEventListener(self.openItems216)
            block5:getChildByName("down"):addTouchEventListener(self.closeItems216)
            block5:getChildByName("Image_57"):setTouchEnabled(true)
            block5:getChildByName("Image_57"):addTouchEventListener(self.openItemsEx216)
            block5:getChildByName("name"):setString(ff.langString("百鬼来袭").." "..ff.langString("第{0}波",{table[9]}))
            item:addChild(block5)
            local dateStr = ff.showData(self._repData:getLong(i,"time"))
            block5:getChildByName('time'):setString(dateStr)
            if tonumber(table[1]) == 1 then
                
                block5:getChildByName("info"):setString(ff.langString("战斗胜利"))
    
                block5:getChildByName("name"):setColor(cc.c3b(237,101,103))
                block5:getChildByName("iswin"):loadTexture(dd.getPathFromUI("vs_win.png",1))
                --info:setString(ff.langString("攻击").." "..ff.langString(self._enemy[tonumber(table[4])]["name"]).."LV."..table[2].." "..ff.langString("成功"))
            else
                block5:getChildByName("info"):setString(ff.langString("战斗失败"))
                block5:getChildByName("name"):setColor(cc.c3b(161,175,175))
   
                block5:getChildByName("iswin"):loadTexture(dd.getPathFromUI("vs_loss.png",1))
                --info:setString(ff.langString("攻击").." "..ff.langString(self._enemy[tonumber(table[4])]["name"]).."LV."..table[2].." "..ff.langString("失败"))
            end
            block5:getChildByName("point1"):setString(table[10])
            block5:getChildByName("point2"):setString(table[11])
            block5:setPosition(cc.p(0,hh))
            hh = hh + 180
            item:setContentSize(cc.size(700,hh))
   
            self:getChildByName("scrollview"):pushBackCustomItem(item)
        end
    elseif self._type == 217 then
        for i=count,self._repData:rowCount() do
            if i == 1 then
                local wanfa = self:getChildByName("block9"):clone()
                wanfa:setVisible(true)
                wanfa:getChildByName("info"):setString(ff.langString("玩法说明"))
                local string = ""
                string = string..ff.langString("地下城堡主要考验的是部队的生命属性。地下城堡中探险不会使你的部队死亡，而是直接撤退回城市中。行动力不足后，部队将自动撤回。")
                wanfa:getChildByName("heroname"):setString(string)
                self:getChildByName("scrollview"):pushBackCustomItem(wanfa)
            end
            local table = Split(self._repData:getString(i,"content"),"%\\")

            item = self:getChildByName("block"):clone()
            item:setVisible(true)
            item:setTouchEnabled(true)
            item:setTag(i)
            local hh = 0
            local block5 = self:getChildByName("block11"):clone()
            block5:setVisible(true)
            block5:setTag(1)
            block5:getChildByName("open"):setVisible(true)
            block5:getChildByName("open"):setTouchEnabled(true)
            block5:getChildByName("down"):setVisible(false)
            block5:getChildByName("down"):setTouchEnabled(false)
            block5:getChildByName("open"):setTag(i)
            block5:getChildByName("down"):setTag(i)
            block5:getChildByName("open"):addTouchEventListener(self.openItems217)
            block5:getChildByName("down"):addTouchEventListener(self.closeItems217)
            block5:getChildByName("Image_57"):setTouchEnabled(true)
            block5:getChildByName("Image_57"):addTouchEventListener(self.openItemsEx217)
            block5:getChildByName("name"):setString(ff.langString("地下城堡").." "..ff.langString("第{0}波",{table[7]}))
            item:addChild(block5)
            local dateStr = ff.showData(self._repData:getLong(i,"time"))
            block5:getChildByName('time'):setString(dateStr)
            if tonumber(table[1]) == 1 then
                
                block5:getChildByName("info"):setString(ff.langString("战斗胜利"))
    
                block5:getChildByName("name"):setColor(cc.c3b(237,101,103))
                block5:getChildByName("iswin"):loadTexture(dd.getPathFromUI("vs_win.png",1))
                --info:setString(ff.langString("攻击").." "..ff.langString(self._enemy[tonumber(table[4])]["name"]).."LV."..table[2].." "..ff.langString("成功"))
            else
                block5:getChildByName("info"):setString(ff.langString("战斗失败"))
                block5:getChildByName("name"):setColor(cc.c3b(161,175,175))
   
                block5:getChildByName("iswin"):loadTexture(dd.getPathFromUI("vs_loss.png",1))
                --info:setString(ff.langString("攻击").." "..ff.langString(self._enemy[tonumber(table[4])]["name"]).."LV."..table[2].." "..ff.langString("失败"))
            end
            block5:getChildByName("point1"):setString(table[8])
            block5:getChildByName("point2"):setString("-5")
            block5:getChildByName("name_2_3"):setString(ff.langString("行动力")..":")
            block5:setPosition(cc.p(0,hh))
            hh = hh + 180
            item:setContentSize(cc.size(700,hh))
   
            self:getChildByName("scrollview"):pushBackCustomItem(item)
        end
    end 

    self:getChildByName("scrollview"):setItemsMargin(5)
end

function repViewLayer:showWaiting(play)
    self:getChildByName("waiting"):getChildByName("icon"):getVirtualRenderer():stopAllActions()
    if play == true then
        function showMove()
            self:getChildByName("scrollview"):getInnerContainer():runAction(cc.MoveBy:create(0.5,cc.p(0,20)))
        end
        self:getChildByName("waiting"):setVisible(true) 
        --self:runAction(cc.CallFunc:create(showMove))
        local animation = cc.Animation:createWithSpriteFrames(self._animFrames, 0.1)
        self:getChildByName("waiting"):getChildByName("icon"):getVirtualRenderer():runAction(cc.RepeatForever:create(cc.Animate:create(animation)))
        
    else        
        
        self:getChildByName("waiting"):setVisible(false)
    end
end

function repViewLayer:onGetRepInfo( table )
    -- body
    if self._isGet == true then
        self._isGet = false

    end
   -- cclog("======2222222=============="..tostring(self._isGet))
    if table == nil or table.type ~= self._type  or self._repData == nil then
        return
    end
    self:showWaiting(false)
    local removeAll = true
    if self._repData:rowCount() > 0 then
        removeAll = false
    end
    if self._repData:rowCount() >= 10 then
        function showMove()
            self:getChildByName("scrollview"):getInnerContainer():runAction(cc.MoveBy:create(0.5,cc.p(0,20)))
            --cclog("====")
        end
        self:runAction(cc.CallFunc:create(showMove))
    end

    --self:showWaiting(false)
    local replist = table.info
    if replist ~= nil then
        for i=1,replist:rowCount() do
            local row = self._repData:addRow()
            self._repData:setSuperLong(row,"id",replist:getSuperLong(i,"id"))
            self._repData:setLong(row,"time",replist:getLong(i,"time"))
            self._repData:setLong(row,"state",replist:getLong(i,"state"))
            self._repData:setLong(row,"type",replist:getLong(i,"type"))
            self._repData:setString(row,"content",replist:getString(i,"content"))
            self._repData:setString(row,"awardStr",replist:getString(i,"awardStr"))
            self._repData:setLong(row,"awardTime",replist:getLong(i,"awardTime"))
            self._repData:setLong(row,"selected",replist:getLong(i,"receiveid"))
            self._repCount = replist:getSuperLong(i,"id")
            --cclog("===sdfsf======="..replist:getString(i,"content"))
        end
        table.info:clear()
        table.info = nil
    end

    self:showInfo(removeAll)
    return
   
end

function repViewLayer.scrollViewEvent(sender, evenType)
    if evenType == ccui.ScrollviewEventType.bounceBottom then
    
        
        local widget = pop.getDialog("repView")
      --  cclog("===================="..tostring(widget._isGet))

        if widget._isGet == false then
            widget._isGet = true
            widget:showWaiting(true)
            local getRepMsg = ff.net:createMessage()
           getRepMsg:addCmd(0x00000045)
           getRepMsg:addLong(dd.uid)
           getRepMsg:addLong(widget._type)
           getRepMsg:addLong(0)
           getRepMsg:addSuperLong(widget._repCount)
           getRepMsg:addSuperLong(0)
           ff.net:rpc(getRepMsg,false)
        
        end
    end
end

function repViewLayer.BtnDeleteEvent(sender,eventType )
    -- body

    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("repView")
        if widget == nil then
            return
        end
        local function sure()
            if widget ~= nil  and widget._repData ~= nil then
            
                if widget._repData:rowCount() > 0 then
                local message = ff.net:createMessage()
                message:addCmd(0x00000136)
                message:addLong(dd.uid)
                
                message:addLong(widget._type)
                message:addLong(1)
               
                --cclog("要报告的邮件数："..count)
                message:addLong(widget._repData:rowCount())

                for var=1, widget._repData:rowCount() do 
                    message:addSuperLong(widget._repData:getSuperLong(var,"id"))     
                end
                
                ff.net:rpc(message,false)
                --end  
                local widget1 = pop.getDialog("mail")
                if widget1 ~= nil then
                    if pop.isShowing("mail") then
                        if widget1._repData ~= nil then
                            for i=1,widget1._repData:rowCount() do
                                if widget._type == widget1._repData:getLong(i,"type") then
                                    widget1._repData:delRow(i)
                                    break
                                end
                            end
                            widget1:onShowReps(true)
                        end              
                    end            
                end
                
                pop.onClosePopDialog("repView")
                return
                end
            end
        end

        if widget ~= nil  and widget._repData ~= nil then
            dd.currentLayer._widget:onShowSure(ff.langString("警告"),ff.langString("您确认清空此类战报吗"),sure,false,1)
        end
    end
end