PropShopLayer = class("PropShopLayer")
PropShopLayer._name = "propShop"
PropShopLayer._init = false
PropShopLayer._index= 1
PropShopLayer._itemIndex = 1

PropShopLayer.curNum   = 0
PropShopLayer.price    = 0
PropShopLayer.__update = {}
--缓冲
PropShopLayer._items = {}
PropShopLayer.propData = {}
PropShopLayer.userDatas = {}
PropShopLayer._animFrames = {}

PropShopLayer.propList = {{},{},{},{},{}}

function PropShopLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, PropShopLayer)
    return target
end

function PropShopLayer:setCheckBox(sender)
    for i,v in ipairs(sender:getParent():getChildren()) do
        if v:getDescription() == "CheckBox" then
            local lab = v:getChildByName("chu_label")
            lab:setColor(cc.c3b(99,124,130))
            v:setSelectedState(false)
        end
    end
    local lab = sender:getChildByName("chu_label")
    lab:setColor(cc.c3b(233, 239, 244))
end

function PropShopLayer:initPropList()
    self.propList = {{},{},{},{},{}}
    for pId,tool in pairs(dd.cfgProp) do
        if dd.cfgProp[pId]['shop'] == 1 then
            local pBag = dd.cfgProp[pId]['bag'] 
            if self._index == 1 then
                if pBag == 1 then
                    self.propList[1][table.getn(self.propList[1]) + 1] = pId
                elseif pBag == 2 then
                    self.propList[2][table.getn(self.propList[2]) + 1] = pId
                elseif pBag == 3 then
                    self.propList[3][table.getn(self.propList[3]) + 1] = pId
                elseif pBag == 4 then
                    self.propList[4][table.getn(self.propList[4]) + 1] = pId
                elseif pBag == 5 then
                    self.propList[5][table.getn(self.propList[5]) + 1] = pId
                end
            else
                if pBag == 1 and self.propData[pId]['num'] > 0 then
                    self.propList[1][table.getn(self.propList[1]) + 1] = pId
                elseif pBag == 2 and self.propData[pId]['num'] > 0 then
                    self.propList[2][table.getn(self.propList[2]) + 1] = pId
                elseif pBag == 3 and self.propData[pId]['num'] > 0 then
                    self.propList[3][table.getn(self.propList[3]) + 1] = pId
                elseif pBag == 4 and self.propData[pId]['num'] > 0 then
                    self.propList[4][table.getn(self.propList[4]) + 1] = pId
                elseif pBag == 5 and self.propData[pId]['num'] > 0 then
                    self.propList[5][table.getn(self.propList[5]) + 1] = pId
                end
            end
        end
    end
    function comps(index1, index2)
       return self.propData[index1].showorder <  self.propData[index2].showorder
    end
    for i=1,5 do
        table.sort(self.propList[i],comps)
    end
end
function PropShopLayer:loadPropData()
    for pId,tool in pairs(dd.cfgProp) do
        if dd.cfgProp[pId]['shop'] == 1 then
            self.propData[pId] = {}
            self.propData[pId]['cost']  = dd.cfgProp[pId]['value']                   --价格
            self.propData[pId]['image'] = dd.cfgProp[pId]['image']                   --显示图片
            self.propData[pId]['name']  = ff.langString(dd.cfgProp[pId]['name'],{dd.cfgProp[pId]['name1_lan']})     --道具名称
            self.propData[pId]['tips']  = ff.langString(dd.cfgProp[pId]['tips'],{dd.cfgProp[pId]['tips1_lan']})     --道具说明
            self.propData[pId]['type']  = dd.cfgProp[pId]['type']                    --道具类型
            self.propData[pId]['inbag'] = dd.cfgProp[pId]['inbag']                   --是否在背包里使用
            self.propData[pId]['showorder'] = dd.cfgProp[pId]['showorder']
            self.propData[pId]['num'] = 0
            self.propData[pId]['pid'] = pId
        end
    end
    self:initPropList()
end

function PropShopLayer:requestBuyMessage(pid, num)
    local message = ff.net:createMessage()
    message:addCmd(0x121)
    message:addLong(dd.uid)
    message:addLong(pid)
    message:addLong(num)
    ff.net:rpc(message,false)
    local popview = self:getChildByName("panel_props"):getChildByName("panel_buyItem")
    popview:setVisible(false)
end

function PropShopLayer:requestUseMessage(pid, num)
    local message = ff.net:createMessage()
    message:addCmd(0x10a)
    message:addLong(dd.uid)
    message:addLong(pid)
    message:addLong(num)
    message:addLong(0)
    message:addLong(0)
    ff.net:rpc(message,false)
    local popview = self:getChildByName("panel_props"):getChildByName("panel_buyItem")
    popview:setVisible(false)
end

function PropShopLayer:responPropBuy(message)
    local result = message[1]
    if result == 0 then
        dd.currentLayer._widget:onShowTips("\t"..ff.langString("道具购买成功 ！"),true)
        self:updateCount()
        self:updateList()
    else
        dd.currentLayer._widget:onShowTips("\t"..ff.langString("道具购买失败 ！"))
    end
end

function PropShopLayer:responPropUse(message)
    local result = message[1]
    if result == 0 then
        local pid = message[2]
        local num = message[3]
        self.propData[pid]['num'] = num



        self:updateCount()
        if self._index == 1 then
            self:updateList()
            self:showItems(true)
        else
            if num == 0 then
                self:initPropList()
                self:releaseList()
                self:showItems(true)
            else
                self:updateList()
                self:showItems(true)
            end
        end       
    else
        dd.mainUI:onShowCodeTips(result)
    end
end

function PropShopLayer:showBuyView(cType, propData)
    local popview = self:getChildByName("panel_props"):getChildByName("panel_buyItem")
    popview:setVisible(true)
    popview:setPositionY(-popview:getContentSize().height)
    popview:stopAllActions()
    popview:runAction(cc.Sequence:create(cc.EaseExponentialOut:create(cc.MoveTo:create(1, cc.p(0,0)))))
    local imgBg = popview:getChildByName("img_icon_bg")
    local lab_itemNum = popview:getChildByName("lab_num")
    local img_icon = imgBg:getChildByName("img_icon")

    local lab_itemName = popview:getChildByName("infos"):getChildByName("lab_itemName")
    local lab_itemInfo = popview:getChildByName("infos"):getChildByName("lab_itemInfo")
    lab_itemName:setString(ff.langString(propData.name))
    lab_itemInfo:setString(ff.langString(propData.tips))
    lab_itemNum:setString(propData.num)--b
    img_icon:loadTexture(dd.getToolsIcon(propData.pid),0)

    local slider = popview:getChildByName("panel_slider"):getChildByName("slider")
    local lab_current = popview:getChildByName("panel_slider"):getChildByName("lab_current")
    slider:setPercent(0)

    local btn_sub = popview:getChildByName("btn_sub")
    local btn_add = popview:getChildByName("btn_add")
    local btn_commit = popview:getChildByName("btn_commit")
    local lab_comBuy = btn_commit:getChildByName("lab_buy")
    local lab_cost = btn_commit:getChildByName("lab_cost")
    local img_coin = btn_commit:getChildByName("Image_77")

    local panel_input = popview:getChildByName("panel_input")
    local tf_input = panel_input:getChildByName("lab_input")

    self.curNum = 1    --当前操作道具数量
    local userCoin = 0  --玩家当前货币值
    --local price = 0     --单价
    local maxNum = 0

    local function setCommitButtonWithPrice()
        if self.curNum < 1 then
            self.curNum = 1
        end
        local curCost = math.floor(self.curNum) * self.price
        --cclog("==curCost: "..curCost.."====userCoin: "..userCoin)
        if curCost > userCoin then
            lab_cost:setColor(cc.c3b(255,0,0))
        else
            lab_cost:setColor(cc.c3b(255,255,255))
        end
        lab_cost:setString(math.floor(curCost))
        slider:setPercent((self.curNum / maxNum)*100)

        local bgWidth = btn_commit:getContentSize().width
        tf_input:setString(math.floor(self.curNum))
        --
        lab_current:setString(math.floor(self.curNum))

        -- cclog("lab_cost ===================="..lab_cost:getContentSize().width)
    end
    
    local function buttonClick(sender, touchType)
        if touchType == ccui.TouchEventType.ended then
            if sender == btn_sub then
                self.curNum = self.curNum - 1
                if self.curNum < 1 then
                    self.curNum = 1
                end
                setCommitButtonWithPrice()
            elseif sender == btn_add then
                self.curNum = self.curNum + 1
                if self.curNum > maxNum then
                    self.curNum = maxNum
                end
                setCommitButtonWithPrice()
            elseif sender == btn_commit then
                setCommitButtonWithPrice()
                if cType == 1 then
                    self:requestUseMessage(propData.pid, self.curNum)
                else
                    self:requestBuyMessage(propData.pid, self.curNum)
                end
            end
        end
    end
    btn_add:addTouchEventListener(buttonClick)
    btn_sub:addTouchEventListener(buttonClick)
    btn_commit:addTouchEventListener(buttonClick)

    local function percentChangedEvent(sender,eventType)
        if eventType == ccui.SliderEventType.percentChanged then
            local percent = slider:getPercent()
            if maxNum > 99 then 
                maxNum = 99
            end
            self.curNum = (percent/100) * maxNum
            setCommitButtonWithPrice()
        end
    end  
    slider:addEventListener(percentChangedEvent)

    if cType == 1 then
        self.price = propData.cost
        userCoin = propData.num--dd.myUnion:getLong(1, "unionpoint")
        lab_comBuy:setString(ff.langString("使用"))
        popview:getChildByName("lab_viewInfo"):setString(ff.langString("道具使用"))
        maxNum = propData.num
        -- img_coin:loadTexture(dd.getPathFromUI("public/ic13.png", 1))
        lab_comBuy:setPositionY(50)
        lab_cost:setVisible(false)
        img_coin:setVisible(false)
        --guide, add by lhz
        GuideControl:GuideCheck()
        --guide end
    else
        self.price = propData.cost
        userCoin = dd.myinfo:getLong(1, "gold") --dd.myUnion:getLong(1, "nAllyFunds")
        lab_comBuy:setString(ff.langString("购买"))
        popview:getChildByName("lab_viewInfo"):setString(ff.langString("道具购买"))
        maxNum = 99
        -- img_coin:loadTexture(dd.getPathFromUI("public/ic14.png", 1))
        lab_comBuy:setPositionY(35)
        lab_cost:setVisible(true)
        img_coin:setVisible(true)
    end
    setCommitButtonWithPrice()

    --init editbox
    if panel_input:getChildByTag(10091) == nil then
        local editBox = dd.addEditBox(
             panel_input
            , panel_input:getContentSize()
            , "images/ui/alpha.png"
            , 10091
            , cc.p(0,0)
            , cc.p(popview:getChildByName("panel_input"):getChildByName("lab_input"):getPositionX()-32,popview:getChildByName("panel_input"):getChildByName("lab_input"):getPositionY())
            , cc.c3b(255,255,255)
            , 20
            , 2
            , 4
            , 1
            , 5
            , true
            , true
            , true
        )
        local function editBoxTextEventHandle(strEventName,pSender)
            local edit = pSender
            local strFmt 
            if strEventName == "began" then
                tf_input:setVisible(false)
            elseif strEventName == "ended" or strEventName == "return" then
                local text = edit:getText()
                tf_input:setVisible(true)
                if text ~= "" then
                  --tf_input:setText(tonumber(text))
                    local input_count = tonumber(text) 
                    if input_count > 99 then
                        input_count = 99
                    end
                    tf_input:setText(input_count)
                    self.curNum = input_count
                    setCommitButtonWithPrice()
                end
                edit:setText("")
            elseif strEventName == "changed" then
                tf_input:setVisible(true)
            end
        end
        editBox:registerScriptEditBoxHandler(editBoxTextEventHandle)
        slider:setCorrect(35,316)
    end
end

function PropShopLayer:updateList()
    local list = self:getChildByName("panel_props"):getChildByName("panel_list")
    for i=1,table.getn(self.propList[self._itemIndex]) do
        local item = list:getChildByTag(i)
        if item ~= nil then
            local id   = self.propList[self._itemIndex][i]
            local tool = self.propData[id]        
            --cclog("id:"..id..",num:"..tool.num)
            item:getChildByName("lab_num"):setString(tool.num)        
            if tool.num < 1 or tool.inbag == 0 then
                item:getChildByName("btn_use"):setVisible(false)
                item:getChildByName("btn_use2"):setVisible(false)
            else                
                if self._index == 2 then
                    item:getChildByName("btn_use2"):setVisible(true)
                else
                    item:getChildByName("btn_use"):setVisible(true)
                end
            end
            if self._index == 2 and tool.num < 1 then
                list:removeChildByTag(i)
            end
        end
    end    
    list:refreshView()
end
--index 1=商店 2=物品
function PropShopLayer:showItems(init)
    local list = self:getChildByName("panel_props"):getChildByName("panel_list")
    local addcount = 0
    for i=1,table.getn(self.propList[self._itemIndex]) do
        local id   = self.propList[self._itemIndex][i]
        local tool = self.propData[id]
        local add  = false
        if self._index == 1 then
            add = true
        else
            if tool.num > 0 then
                add = true
                --guide, add by lhz
                GuideControl:GuideCheck()
                --guide end
            end
        end
        if add == true then
            local item = list:getChildByTag(i)
            local update = true
            if list:getTag() == self._itemIndex then
                update = false
            end
            if self.__update[1] ~= self.__update[2] then
                update = true
            end
            if item == nil then
                if init == true then
                    item = self:getItem(false)
                else
                    item = self:getItem(true)
                end
                if item == nil then
                    list:refreshView()
                    return
                end
                addcount = addcount + 1
                update = true

                list:addChild(item)
                item:setTag(i)
            end
            item:getChildByName("img_icon_bg"):getChildByName("img_icon"):loadTexture(dd.getToolsIcon(id),0)
            item:getChildByName("lab_num"):setString(tool.num)            

            item:setVisible(true)

            item:getChildByName("btn_buy"):setTag(id)
            item:getChildByName("btn_use"):setTag(id)
            item:getChildByName("btn_use2"):setTag(id)

            if update == true then
                item:getChildByName("lab_name"):setString(tool.name)
                item:getChildByName("lab_info"):setString(tool.tips)
                item:getChildByName("btn_buy"):getChildByName("lab_userpower"):setString(tool.cost)
            end

            if self._index == 1 then
                item:getChildByName("btn_buy"):setVisible(true)
                item:getChildByName("btn_use"):setVisible(true)
                item:getChildByName("btn_use2"):setVisible(false)
            else
                item:getChildByName("btn_buy"):setVisible(false)
                item:getChildByName("btn_use"):setVisible(false)
                item:getChildByName("btn_use2"):setVisible(true)
            end
            if tool.num < 1 or tool.inbag == 0 then
                item:getChildByName("btn_use"):setVisible(false)
                item:getChildByName("btn_use2"):setVisible(false)
            else
                if self._index == 2 then
                    item:getChildByName("btn_use2"):setVisible(true)
                else
                    item:getChildByName("btn_use"):setVisible(true)
                end
            end            
            if addcount >= 10 and table.getn(self._items) <= 0 then
                break
            end
        end
    end
    list:refreshView()
end
function PropShopLayer:getItem(create)
    local item = nil
    if table.getn(self._items) <= 0 then
        if create == false then
            return
        end
        item = self:getChildByName("panel_props"):getChildByName("panel_item"):clone()
        item:retain()
    else
        item = self._items[1]
        table.remove(self._items, 1)
    end
    return item
end
function PropShopLayer:initItems()

    local itemModel = self:getChildByName("panel_props"):getChildByName("panel_item")

    local btn_buy = itemModel:getChildByName("btn_buy")
    local btn_use = itemModel:getChildByName("btn_use")
    local btn_use2 = itemModel:getChildByName("btn_use2")

    local function buttonClick(sender, touchType)
        local doaction = false
        if touchType == ccui.TouchEventType.canceled then
            local startp = sender:getTouchBeganPosition()
            local endp   = sender:getTouchEndPosition()
            if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                doaction = true
            end
        end

        if touchType == ccui.TouchEventType.ended then
            doaction = true
        end
        if doaction == true then
            local tool = self.propData[sender:getTag()]
            if sender:getName() == "btn_use" or sender:getName() == "btn_use2" then
                self:showBuyView(1, tool)
            elseif sender:getName() == "btn_buy" then
                if tool.cost > dd.myinfo:getLong(1, "gold") then
                    dd.currentLayer._widget:onShowTips("\t"..ff.langString("金币不足"))
                    return
                end
                self:showBuyView(2, tool)
            elseif sender:getName() == "btn_close" then
                local function endCall()
                    self:getChildByName("panel_props"):getChildByName("panel_buyItem"):setVisible(false)
                end
                self:getChildByName("panel_props"):getChildByName("panel_buyItem"):stopAllActions()
                self:getChildByName("panel_props"):getChildByName("panel_buyItem"):runAction(cc.Sequence:create(cc.EaseExponentialOut:create(cc.MoveTo:create(1, cc.p(0, -self:getChildByName("panel_props"):getChildByName("panel_buyItem"):getContentSize().height))),cc.CallFunc:create(endCall)))
            end
        end
    end

    btn_buy:addTouchEventListener(buttonClick)
    btn_use:addTouchEventListener(buttonClick)
    btn_use2:addTouchEventListener(buttonClick)        
    self:getChildByName("panel_props"):getChildByName("panel_buyItem"):getChildByName("btn_close"):addTouchEventListener(buttonClick)

    for i=1,5 do
        local item = itemModel:clone()
        item:retain()
        table.insert(self._items,item)
    end
end
function PropShopLayer:releaseList()
    local list = self:getChildByName("panel_props"):getChildByName("panel_list")
    local count = list:getChildrenCount()
    local real  = table.getn(self.propList[self._itemIndex])
    --cclog("count: "..count.."======real: "..real)
    for i=real + 1,count do
        local item = list:getChildByTag(i)
        list:removeChildByTag(i)
        self._items[table.getn(self._items) + 1] = item
    end
end

function PropShopLayer:initTopBar()
    local panel_top = self:getChildByName("top")
    local panel_topButton = self:getChildByName("btns")

    local btn_back = panel_top:getChildByName("return")
    local btn_shop = self:getChildByName("btns"):getChildByName("shop")
    local btn_bag = self:getChildByName("btns"):getChildByName("bag")
    local function button(sender, touchType)
        if touchType == ccui.TouchEventType.ended then
            if sender == btn_back then
                pop.onClosePopDialog("propShop")
            elseif sender == btn_shop then
                self:setCheckBox(sender)
                if self._index ~= 1 then
                    self._index = 1
                    self:initPropList()
                    table.insert(self.__update,1)
                    self:showItems(true)
                end
            elseif sender == btn_bag then
                self:setCheckBox(sender)
                if self._index ~= 2 then
                    self._index = 2
                    self:initPropList()
                    self:releaseList()
                    table.insert(self.__update,2)
                    self:showItems(true)
                end
            end
        end
    end
    btn_back:addTouchEventListener(button)
    btn_shop:addTouchEventListener(button)
    btn_bag:addTouchEventListener(button)
    self:getChildByName("panel_props"):getChildByName("panel_list"):addScrollViewEventListener(self.scrollViewEvent)
end

function PropShopLayer:initItemView()
    local panel_itemView = self:getChildByName("panel_props")
    local panel_top = panel_itemView:getChildByName("panel_top")
    panel_itemView:setVisible(true)

    local btn_item1 = panel_top:getChildByName("btn_navi1")
    local btn_item2 = panel_top:getChildByName("btn_navi2")
    local btn_item3 = panel_top:getChildByName("btn_navi3")
    local btn_item4 = panel_top:getChildByName("btn_navi4")
    local btn_item5 = panel_top:getChildByName("btn_navi5")

    self._itemIndex = 1
    local function buttonClick(sender, touchType)
        if touchType == ccui.TouchEventType.ended then
            self:setCheckBox(sender)

            self._itemIndex = sender:getTag()
            self:releaseList()
            self:showItems(true)
            if sender:getSelectedState() == true then
                self.__update = {}
            end

            self:getChildByName("panel_props"):getChildByName("panel_list"):setTag(self._itemIndex)
            self:getChildByName("panel_props"):getChildByName("panel_list"):jumpToTop()
        end
    end
    btn_item1:addTouchEventListener(buttonClick)
    btn_item2:addTouchEventListener(buttonClick)
    btn_item3:addTouchEventListener(buttonClick)
    btn_item4:addTouchEventListener(buttonClick)
    btn_item5:addTouchEventListener(buttonClick)
end

function PropShopLayer.updateGold(name,row,old,value)
    local sender = pop.getDialog("propShop")
    if sender ~= nil then
        sender:getChildByName("top"):getChildByName("count"):setString(dd.myinfo:getLong(1,"gold"))
        sender:getChildByName("top"):requestDoLayout()
        sender:updateCount()
        sender:showItems(true)
    end
end

function PropShopLayer:checkMore()
    if self:isVisible() == false then
        return
    end
    local count = self:getChildByName("panel_props"):getChildByName("panel_list"):getChildrenCount()
    local total = table.getn(self.propList[self._itemIndex])
    cclog("count:"..count..",total:"..total)
    if count >= total then
        return
    end
    function showMore()
        self:showItems(false)
        self:showWaiting(false)
    end
    function showMove()
       self:getChildByName("panel_props"):getChildByName("panel_list"):getInnerContainer():runAction(cc.MoveBy:create(0.3,cc.p(0,20)))
    end
    self:showWaiting(true)
    self:runAction(cc.Sequence:create(cc.DelayTime:create(0.1),cc.CallFunc:create(showMore),cc.CallFunc:create(showMove)))
end

function PropShopLayer.scrollViewEvent(sender,eventType)
    if eventType ==  ccui.ScrollviewEventType.bounceBottom then
        local prop = pop.getDialog("propShop")
        if prop:getChildByName("panel_props"):getChildByName("waiting"):isVisible() == false then
            prop:checkMore()
        end    
    end
end

function PropShopLayer:showWaiting(play)
    self:getChildByName("panel_props"):getChildByName("waiting"):getChildByName("icon"):getVirtualRenderer():stopAllActions()
    if play == true then
        local animation = cc.Animation:createWithSpriteFrames(self._animFrames, 0.1)
        self:getChildByName("panel_props"):getChildByName("waiting"):getChildByName("icon"):getVirtualRenderer():runAction(cc.RepeatForever:create(cc.Animate:create(animation)))
        self:getChildByName("panel_props"):getChildByName("waiting"):setVisible(true) 
    else        
        self:getChildByName("panel_props"):getChildByName("waiting"):setVisible(false)
    end
end

function PropShopLayer.onEnd(sender,btns)
    dd.delBackEvent()
    sender:stopAllActions()
    ff.net:removeEvent(2,dd.Tjf_prop_buy)
    ff.net:removeEvent(2,dd.Tjf_prop_use)
    ff.net:removeEvent(2,dd.Tjf_notify_SNGetBonus)
    ff.net:unbindProperty("gold",2603) 

    if ff.platform ~= 1 then
        local panel_list = sender:getChildByName("panel_props"):getChildByName("panel_list")
        for i=1,table.getn(sender.propList[sender._itemIndex]) do
            local item = panel_list:getChildByTag(i)
            if item ~= nil then
                item:getChildByName("img_icon_bg"):getChildByName("img_icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
            end
        end
    end
    if ff.set_power <= 1 then
        local free = 0
        if table.getn(sender._items) >= 15 then
            for i=16,table.getn(sender._items) do
                local item = sender._items[16]
                item:release()
                table.remove(sender._items,16)
                free = free + 1
            end
        end
        cclog("free item:"..free)
    end

    if btns == nil then
        if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
            dd.currentLayer._widget:unSelectBtns()
        end    
    end

    if pop.getDialog("reward") then
        pop.onClosePopDialog("reward")
    end
end

function PropShopLayer.onBefore(sender)
    sender._continue = true
    sender:showItems(true)
    dd.initGoldSpine(sender:getChildByName("top"):getChildByName("icon"),sender:getChildByName("top"):getChildByName("addgold")) 
    return true
end

function PropShopLayer.onReturn(sender,eventType)
    local close = false
    if sender == nil then
        close = true
    end
    if eventType==ccui.TouchEventType.ended then     
        close = true
    end
    if close == true then
        pop.onClosePopDialog("propShop")
    end
end
function PropShopLayer:updateCount()
    for tid,tool in pairs(self.propData) do
        self.propData[tid]['num'] = 0
    end
    for i=1,dd.mytools:rowCount() do
        if self.propData[dd.mytools:getLong(i,"tid")] ~= nil then
            self.propData[dd.mytools:getLong(i,"tid")]['num'] = dd.mytools:getLong(i,"count")
        end    
    end
end

function PropShopLayer:popRewardDialog(infos)
    if table.getn(infos) > 0 then
        cclog("prop Count : "..table.getn(infos))
        pop.onShowPopDialog("reward",infos)
    else
        return 
    end
end

function PropShopLayer.onStart(sender)
    ff.net:registerEvent(2,dd.Tjf_prop_buy, function (message)sender:responPropBuy(message) end)
    ff.net:registerEvent(2,dd.Tjf_prop_use, function (message)sender:responPropUse(message) end)
    ff.net:registerEvent(2,dd.Tjf_notify_SNGetBonus, function (message) sender:popRewardDialog(message) end)
    ff.net:bindProperty(2603,"gold",sender.updateGold)

    --platform_showWaiting(1,1)
    local tick = ff.gameCore:getTick()
    cclog("use1:"..(ff.gameCore:getTick() - tick))
    sender:showItems(false)
    cclog("use2:"..ff.gameCore:getTick() - tick)
end

function PropShopLayer:onInit()
    local tick = ff.gameCore:getTick()
    if self._init == false then
        self._init = true
        local hh = ff.height
        self:setContentSize(cc.size(720, hh - 214))
        self:getChildByName("top"):setPositionY(hh - 214 - 105)
        self:getChildByName("btns"):setPositionY(hh - 214 - 190)
        self:getChildByName("panel_props"):setContentSize(cc.size(720,hh - 214 - 190))
        self:getChildByName("panel_props"):setPositionY(0)

        self:getChildByName("panel_props"):getChildByName("panel_top"):setPositionY(hh - 214 - 190 -85)
        self:getChildByName("panel_props"):getChildByName("panel_list"):setContentSize(cc.size(720,hh - 214 - 190 -85))
        self:getChildByName("panel_props"):getChildByName("panel_list"):setPositionY(0)
        self:getChildByName("panel_props"):getChildByName("waiting"):setPositionY(0)

        local cache = cc.SpriteFrameCache:getInstance()
        cache:addSpriteFrames("images/mv/normaleffect.plist")
        for j = 1, 12 do
            local frame = nil
            if j < 10 then
                frame = cache:getSpriteFrame("of_native_loader_progress_0"..j..".png")
            else    
                frame = cache:getSpriteFrame("of_native_loader_progress_"..j..".png")
            end 
            self._animFrames[j] = frame
        end
        self:getChildByName("panel_props"):getChildByName("waiting"):getChildByName("icon"):loadTexture("of_native_loader_progress_01.png",1)

        self:setPositionY(0)
        self:loadPropData()
        self:initTopBar()
        self:initItemView()
        self:initItems()
        self:getChildByName("panel_props"):getChildByName("panel_list"):setTag(self._itemIndex)

        self:getChildByName("top"):getChildByName("addgold"):addTouchEventListener(dd.onPay)
        self:getChildByName("btns"):getChildByName("shop"):setSelectedState(true)
        self:getChildByName("panel_props"):getChildByName("panel_list"):jumpToTop()

        local panel_itemView = self:getChildByName("panel_props")
        local panel_top = panel_itemView:getChildByName("panel_top")
        panel_top:getChildByName("btn_navi1"):setSelectedState(true)
    end
    self:getChildByName("panel_props"):getChildByName("panel_buyItem"):setVisible(false)

    self:showWaiting(false)
    self.updateGold()
end

function onShowShop(widget,parent)
    local layer = PropShopLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)
    layer._parent = parent
    layer:onInit()
    return layer
end