local scrollSelectLayer   = class("selectLayer")
scrollSelectLayer._name = "selectScroll"
scrollSelectLayer._init = false
scrollSelectLayer._view = nil
scrollSelectLayer._data = nil
scrollSelectLayer._index = 0
scrollSelectLayer._callback = nil

function scrollSelectLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, scrollSelectLayer)
    return target
end

function scrollSelectLayer.onClose(sender,eventType)
    if eventType==ccui.TouchEventType.ended then
        pop.onClosePopDialog("selectScroll")   
    end
end
function scrollSelectLayer.onSure(sender,eventType)
    if eventType==ccui.TouchEventType.ended then
        local widget = pop.getDialog("selectScroll")
        if widget == nil then
            return nil
        end
        
        local index = widget._view:getCurCenter()
        if widget._callback ~= nil then
            widget._callback(index%table.getn(widget._data))
        end
        pop.onClosePopDialog("selectScroll") 
    end
end

function scrollSelectLayer.onReturn( sender,eventType )
    -- body
    local close = false
    if sender == nil then
        close = true
    end
    if eventType == ccui.TouchEventType.ended then
        close = true
    end
    if close == true then
        local widget = pop.getDialog("selectScroll")
        if widget == nil then
            return
        end
       
        pop.onClosePopDialog("selectScroll")

    end
end

function scrollSelectLayer:onInit()
    if self._init == false then
        local hh = ff.height
        self:setContentSize(cc.size(720,ff.height))
        self:setPositionY(0)

        local function closeView(sender,eventType)
            if eventType==ccui.TouchEventType.ended then  
                pop.onClosePopDialog("scrollSelect")
            end         
        end
        local function setSel(sender,eventType)
            if eventType==ccui.TouchEventType.ended then           
                self.backFun(self.sel)
            end       
        end
        self:getChildByName("view"):getChildByName("close"):addTouchEventListener(self.onClose)
        self:getChildByName("view"):getChildByName("sure"):addTouchEventListener(self.onSure)


        local tableView = cc.TableView:create(self:getChildByName("view"):getChildByName("area"):getContentSize())
        tableView:setTag(1)
        tableView:setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL)
        tableView:setDelegate()
        tableView:setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN)
        --tableView:setPosition(cc.p(self:getChildByName("view"):getChildByName("area"):getContentSize().width/2, 0))
        tableView:setPosition(cc.p(0, 0))
        self:getChildByName("view"):getChildByName("area"):addChild(tableView,1)

        tableView:registerScriptHandler(self.tableCellTouched,cc.TABLECELL_TOUCHED)
        tableView:registerScriptHandler(self.cellSizeForTable,cc.TABLECELL_SIZE_FOR_INDEX)
        tableView:registerScriptHandler(self.tableCellAtIndex,cc.TABLECELL_SIZE_AT_INDEX)
        tableView:registerScriptHandler(self.numberOfCellsInTableView,cc.NUMBER_OF_CELLS_IN_TABLEVIEW)

        tableView:setEnableToCenter(true)
        tableView:setEnableToCenterAni(true)

        self._view = tableView
        self._init = true
    end
    self:getChildByName("view"):getChildByName("title"):setString(self._title)
end
function scrollSelectLayer.tableCellAtIndex(view,idx)
    if idx < 0 then
        return nil
    end

    local widget = pop.getDialog("selectScroll")
    if widget == nil then
        return nil
    end
    idx = idx%table.getn(widget._data)

    local data = widget._data
    local cell = view:dequeueCell()
    local item = nil
    if nil == cell then
        cell = cc.TableViewCell:new()
        item = widget:getChildByName("view"):getChildByName("label"):clone()
        item:setTag(1)
        item:setPosition(cc.p(360,0))
        item:setVisible(true)
        item:setString(data[idx+1])
        cell:addChild(item)
    else
        item=cell:getChildByTag(1)
        item:setVisible(true)
        item:setString(data[idx+1])
    end
    return cell
end

function scrollSelectLayer.tableCellTouched(view,cell)
end
    
    
function scrollSelectLayer.cellSizeForTable(view)
    return 40,720
end
    
function scrollSelectLayer.numberOfCellsInTableView(view)
    local widget = pop.getDialog("selectScroll")
    if widget == nil then
        return 0
    end
    if widget._data == nil then
        return 0 
    end
    return table.getn(widget._data)*100
end

function scrollSelectLayer.onStart(sender)    
    sender._view:reloadData()
    sender._view:scrollTo(50 * table.getn(sender._data) + sender._index,false)    
end
function scrollSelectLayer.onEnd(sender)
    dd.delBackEvent()
end
function onShowSelectScroll(widget,data,callback,title,index)
    local layer = scrollSelectLayer.extend(widget)
    layer._data = data
    dd.regeditBackEvent(layer.onReturn)
    layer._index = index
    layer._callback = callback
    layer._title    = title
    layer:onInit()
    return layer
end