ActiveInfoLayer = class("ActiveInfoLayer")
ActiveInfoLayer._name = "ActiveInfo"
ActiveInfoLayer._init = false
ActiveInfoLayer._Time = 0
ActiveInfoLayer._Cfg_reward = {}
ActiveInfoLayer._itemCount = 0


function ActiveInfoLayer.extend( target )
	-- body
	local t = tolua.getpeer(target)
	if not t then
		t = {}
		tolua.setpeer(target,t)
	end
	setmetatable(t,ActiveInfoLayer)
	return target
end

function ActiveInfoLayer:onInit(  )
	-- body
	if self._init == false then
		local hh = ff.height
		self:setContentSize(cc.size(720,hh))
		self:setPositionY(0)
		self:getChildByName("back"):setContentSize(cc.size(720,hh))
		self:getChildByName("back"):addTouchEventListener(self.onReturn)
		self:getChildByName("top"):setPositionY(hh - 105)
		self:getChildByName("scrollview"):setContentSize(cc.size(720,hh-205))
    	self:getChildByName("scrollview"):setPositionY(100)
        self:getChildByName("oper"):setPositionY(0)
        self:getChildByName("oper"):setVisible(false)
        self:getChildByName("oper"):getChildByName("btn"):getChildByName("lab"):setString(ff.langString("合成"))
        self:getChildByName("oper"):getChildByName("btn"):addTouchEventListener(self.onBtn)
    	self:getChildByName("top"):getChildByName("return"):addTouchEventListener(self.onReturn)
    	self:getChildByName("top"):getChildByName("addgold"):addTouchEventListener(dd.onPay)
    	self:getChildByName("top"):getChildByName("title"):getChildByName("chu_title"):setString(ff.langString("节日庆典"))
		self._init = true
	end
    self:getChildByName("tips"):setVisible(false)
	self:initDate()
	self.updateGold()
end
function ActiveInfoLayer:showTips( type, id, count, pos )
    -- body
    local ret  = dd.getGiftsTips(type, id, count)
    local name = ret[1]
    local str  = ret[2]
    local tips = self:getChildByName("tips")
    local wid  = 360
    tips:stopAllActions()
    tips:setVisible(true)
    tips:getChildByName("tips"):removeAllChildren(true)

    local richText = ccui.RichText:create()
    richText:ignoreContentAdaptWithSize(false)
    richText:setContentSize(cc.size(wid-30,600))    
    richText:setAutoHeight()

    local chat = ccui.RichElementText:create(1, cc.c3b(161,175,175), 255, str, "Helvetica", 20)
    richText:insertElement(chat,0)
    richText:formatText()

    local size = richText:getContentSize()
    richText:setPosition(cc.p(172,size.height/2 + 15))
    tips:setContentSize(cc.size(wid, size.height + 60))
    tips:getChildByName("tips"):setContentSize(cc.size(wid, size.height + 60))
    tips:getChildByName("tips"):addChild(richText)

    tips:getChildByName("name"):setString(name) 
    tips:getChildByName("name"):setPositionY(size.height + 40)

    tips:setPositionX(pos.x)
    tips:setPositionY(pos.y)
    if pos.x < 250 then
        tips:setAnchorPoint(cc.p(0.2,0))
        tips:getChildByName("flag"):setPositionX(wid*0.2)
    elseif pos.x > 550 then
        tips:setAnchorPoint(cc.p(0.8,0))
        tips:getChildByName("flag"):setPositionX(wid*0.8)
    else
        tips:setAnchorPoint(cc.p(0.5,0))
        tips:getChildByName("flag"):setPositionX(wid*0.5)
    end  
    local function sched()
        tips:setVisible(false)
    end 

    performWithDelay(tips,sched,1.5)
end

function ActiveInfoLayer:getWorldPos(node)
    local anr   = node:getAnchorPoint()
    local size  = node:getContentSize()
    local p = node:convertToWorldSpace(cc.p(anr.x * size.width,anr.y * size.height)) --世界坐标
    return p
end

function ActiveInfoLayer.onShowTips( sender,eventType  )
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end

    if eventType==ccui.TouchEventType.ended then    
        doaction = true
    end
    if doaction == true then        
        local widget = pop.getDialog("ActiveInfo")
        local pos2word = widget:getWorldPos(sender)
        local pos = widget:convertToNodeSpace(pos2word) 
        pos = cc.p(pos.x, pos.y+30)
        widget:showTips(sender.type, sender.id, sender.count, pos)
    end
end

function ActiveInfoLayer.onStart( sender )
	ff.net:bindProperty(2325,"gold",sender.updateGold)
    dd.initGoldSpine(sender:getChildByName("top"):getChildByName("gold"),sender:getChildByName("top"):getChildByName("addgold"))
    
    schedule(sender, sender.update,1)
    
end

function ActiveInfoLayer.onReturn( sender,eventType )
	local close = false
    if sender == nil then
        close = true
    end
    if eventType == ccui.TouchEventType.ended then
        close = true
    end
    if close == true then
        local widget = pop.getDialog("ActiveInfo")
		if widget == nil then
			return
		end
        pop.onClosePopDialog("ActiveInfo")
    end
end


function ActiveInfoLayer.onBtn( sender,eventType )
    
    if eventType == ccui.TouchEventType.ended then
        pop.onShowPopDialog("hechengJump")
        --pop.onShowPopDialog("hechengex")
    end
    
end

function ActiveInfoLayer.onEnd( sender )
    -- body
    dd.delBackEvent()
    sender:getChildByName("tips"):stopAllActions()
    ff.net:removeEvent(2,dd.Tjf_GetTodayEvent)
    sender:stopAllActions()
    sender:getChildByName("scrollview"):removeAllChildren(true)
    ff.net:unbindProperty("gold",2325)
end

function onShowActiveInfo(widget,time)
	-- body
	local layer = ActiveInfoLayer.extend(widget)
	dd.regeditBackEvent(layer.onReturn)
	layer._Time = time
    layer:onInit()
    return layer
end

function ActiveInfoLayer:getTaskList()
    local message = ff.net:createMessage()
    message:addCmd(0x0000005c)
    message:addLong(dd.uid)
    message:addLong(202)
    ff.net:rpc(message,false)
    
end

function ActiveInfoLayer.onBefore( sender)
  -- bod
    ff.net:registerEvent(2,dd.Tjf_GetTodayEvent, function (message)sender:onGetTaskList(message)end)
    sender:getTaskList()
end

function ActiveInfoLayer:onGetTaskList(params)
    local code = params[1]
    if code == 0 then
        self._itemCount = params[3]
        self:showList()
    else
        dd.mainUI:onShowCodeTips(code)
    end
end


function ActiveInfoLayer.update( sender )
	local item = sender:getChildByName("scrollview"):getChildByTag(1)
	if item ~= nil then
		local time = sender._Time - dd.getServerTime()
        item:getChildByName("time"):setString(ff.getLeftTime(time,":"))
	end
end

function ActiveInfoLayer:initDate(  )
    self._itemCount = 0
    self._Cfg_reward = {}
    local propData3 = ff.dbmanager:sql_fetch_rows("SELECT * FROM `cfg_activity_awards`")
    for i=1, propData3:rowCount() do
       local id = tonumber(propData3:getString(i, "id"))
       self._Cfg_reward[id]={}
       self._Cfg_reward[id]['content'] = propData3:getString(i, "content")
        self._Cfg_reward[id]['num'] = tonumber(propData3:getString(i, "num"))
    end
    propData3:clear()
end

function ActiveInfoLayer:showList(  )
    local title = self:getChildByName("title"):clone()
    title:setVisible(true)
    title:setTag(1)
    title:getChildByName("ico"):loadTexture("images/active/active_back.jpg",0)
    title:getChildByName("Image_195"):loadTexture("images/active/active_di.png",0)
    self:getChildByName("scrollview"):pushBackCustomItem(title)
    
    local block1 = self:getChildByName("block1"):clone()
    block1:setVisible(true)
    local string = ""
    string = string..ff.langString("复活节庆典活动期间，采集资源有概率获得彩蛋，而攻击世界地图上的僵尸可获得打开彩蛋需要的锤子。锤子的品质越高，砸开奖励获得的奖励越丰厚。")
    block1:getChildByName("heroname"):setString(string)
    block1:getChildByName("heroname_0"):setString(ff.langString("砸彩蛋，赢奖励"))
    --local sp = cc.Sprite:create("images/active/info1.png") 
    --sp:setPosition(cc.p(350,124))
    --block1:addChild(sp,1,1)
    self:getChildByName("scrollview"):pushBackCustomItem(block1)

    local block33 = self:getChildByName("block1"):clone()
    block33:setVisible(true)
    local string = ""
    string = string..ff.langString("复活节庆典活动期间，开放联盟复活节神像，联盟成员消费金币，砸彩蛋，皆可获得升级神像需要的百合。升级神像可为所有联盟成员赢取丰厚奖励。")
    block33:getChildByName("heroname"):setString(string)
    block33:getChildByName("heroname_0"):setString(ff.langString("百合祭神像"))
    --local sp33 = cc.Sprite:create("images/active/active_tree.png") 
    --sp33:setPosition(cc.p(350,124))
   -- block33:addChild(sp33,1,1)
    self:getChildByName("scrollview"):pushBackCustomItem(block33)

    local block2 = self:getChildByName("block1"):clone()
    block2:setVisible(true)
    local string = ""
    string = string..ff.langString("活动期间，使用锤子砸开彩蛋可获得积分，锤子的品质越高，获得的积分越高！")
    block2:getChildByName("heroname"):setString(string)
    block2:getChildByName("heroname_0"):setString(ff.langString("彩蛋英雄"))

    --local sp2 = cc.Sprite:create("images/active/info2.png") 
   -- sp2:setPosition(cc.p(350,35))
   -- block2:addChild(sp2,1,1)
    self:getChildByName("scrollview"):pushBackCustomItem(block2)
end

function ActiveInfoLayer.updateGold(name,row,old,value)
    local widget = pop.getDialog("ActiveInfo")
    if widget ~= nil then
        widget:getChildByName("top"):getChildByName("count"):setString(dd.myinfo:getLong(1,"gold"))
        local w = widget:getChildByName("top"):getChildByName("count"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        widget:getChildByName("top"):getChildByName("title"):setContentSize(cc.size(w,100))
        widget:getChildByName("top"):getChildByName("title"):requestDoLayout()
        widget:getChildByName("top"):requestDoLayout()
    end
end