local achieveLayer = class("achieveLayer")
achieveLayer._name = "taskAchieve"
achieveLayer._init = false
--button is not clicked
achieveLayer._select = 0
achieveLayer._info = 0
achieveLayer._type = 0
achieveLayer.ss    = 0
achieveLayer._tasktype = 0
achieveLayer._littletype = 0
achieveLayer._cfg_ach = nil
achieveLayer._cfg_link = nil
--recType 1:分类 --2：领奖
achieveLayer.recType  = 0
achieveLayer._lessTag = {}
achieveLayer._posData = {}
achieveLayer._posCategoryData = {}
--accept data
achieveLayer.receiveData = {}
achieveLayer.categoryData = {}
achieveLayer.bonusData = {}
--all current task
achieveLayer._currentTaskLists = {}

achieveLayer.taskItems = {
    "建筑","科技","装备","联盟",
    "训练","采集","生产","英雄",
    "晶体","战力","宝石","杀敌"
} 

function achieveLayer.extend(target)
	local t = tolua.getpeer(target)
	if not t then
		t = {}
		tolua.setpeer(target, t)
	end
	setmetatable(t, achieveLayer)
	return target
end

function achieveLayer.onReturn(sender, eventType)
	local close = false
	if sender == nil then
		close = true
	else
		if ccui.TouchEventType.ended == eventType then
			close = true
		end
	end
	if close == true then
		local widget = pop.getDialog("taskAchieve")
		if widget ~= nil then
			widget:returnBack()
		end
	end
end

function achieveLayer:onInit()
	if self._init == false then
        local hh = ff.height - 220
        self:setContentSize(cc.size(720,hh))
        self:getChildByName("bg"):setContentSize(cc.size(720, hh))
        self:getChildByName("bg"):setPositionY(0)

        self:getChildByName("top"):setPositionY(hh - 105)
        self:getChildByName("main"):setPositionY(hh - 105 - 255)
        self:getChildByName("listview"):setContentSize(cc.size(720,hh - 105 - 260))
        self:getChildByName("listview"):setPositionY(0)
        self:getChildByName("top"):getChildByName("back"):addTouchEventListener(self.onReturn)
        self._init = true
	end
    self:loadItems()
    self._type = 1
    self:getChildByName("panel"):setVisible(false)
    self:getChildByName("des"):setVisible(false)
    self:getChildByName("item"):setVisible(false)
    self:getChildByName("item"):getChildByName("btm_unfold"):setVisible(false)
    self:initUI()
    self.updateGold()
end

--Init UI
function achieveLayer:initUI()
    self:getChildByName("listview"):removeAllChildren(true)
    for idx=1,12 do
        local panel = self:getChildByName("item"):clone()
        --一级菜单
        local task_name = panel:getChildByName("label")
        task_name:setString(ff.langString(self.taskItems[idx]))
        panel:setVisible(true)

        local function btnShow(sender, eventType)
            if eventType == ccui.TouchEventType.ended then
                local widget = pop.getDialog("taskAchieve")
                if widget ~= nil then
                    local index = sender:getTag()
                    local panel = widget:getChildByName("listview"):getChildByTag(index)
                    panel:getChildByName("btm_fold"):setVisible(false)
                    panel:getChildByName("btm_unfold"):setVisible(true)
                    self:onAchieveTask(index)
                    self:getChildByName("listview"):refreshView()
                end
            end
        end

        local function btnClose(sender, eventType)
            if eventType == ccui.TouchEventType.ended then
                local widget = pop.getDialog("taskAchieve")
                if widget ~= nil then
                    local index = sender:getTag()
                    local panel = widget:getChildByName("listview"):getChildByTag(index)
                    panel:getChildByName("btm_unfold"):setVisible(false)
                    panel:getChildByName("btm_fold"):setVisible(true)
                    self:closeTaskLists(index)
                end
            end
        end
        panel:setTag(idx) 
        panel:setPosition(cc.p(0,0))
        panel:getChildByName("btm_fold"):setTag(idx)
        panel:getChildByName("btm_unfold"):setTag(idx)
        panel:getChildByName("btm_fold"):addTouchEventListener(btnShow)
        panel:getChildByName("btm_unfold"):addTouchEventListener(btnClose)

        --self:getChildByName("listview"):insertCustomItem(panel, idx - 1)
        self:getChildByName("listview"):addChild(panel)
    end
    if data ~= nil then
        data:clear()
    end
    self:getChildByName("listview"):refreshView()
    self:getChildByName("listview"):setVisible(true)
end

--Init Data
function achieveLayer:loadItems()
    --init _cfg_ach
    self._cfg_ach = ff.NetTable:create()
    self._cfg_ach:addStreamCol("taskid",ff.NET_LONG)
    self._cfg_ach:addStreamCol("type",ff.NET_LONG)
    self._cfg_ach:addStreamCol("littletype",ff.NET_LONG)
    self._cfg_ach:addStreamCol("order",ff.NET_LONG)
    self._cfg_ach:addStreamCol("name",ff.NET_STRING,128)
    self._cfg_ach:addStreamCol("disc",ff.NET_STRING,256)
    self._cfg_ach:addStreamCol("value2",ff.NET_LONG)
    self._cfg_ach:addStreamCol("gold",ff.NET_LONG)
    self._cfg_ach:addStreamCol("link",ff.NET_LONG)
    local strSql = "SELECT * FROM `cfg_achievement` order by `taskid`"
    local data = ff.dbmanager:sql_fetch_rows(strSql)
    if data ~= nil then
        for i=1, data:rowCount() do
            local index = self._cfg_ach:addRow()
            self._cfg_ach:setLong(index,"taskid",tonumber(data:getString(i,"taskid")))
            self._cfg_ach:setLong(index,"type",tonumber(data:getString(i,"type")))
            self._cfg_ach:setLong(index,"littletype",tonumber(data:getString(i,"littletype")))
            self._cfg_ach:setLong(index,"order",tonumber(data:getString(i,"order")))
            self._cfg_ach:setString(index,"name",data:getString(i,"name"))
            self._cfg_ach:setString(index,"disc",data:getString(i,"disc"))
            self._cfg_ach:setLong(index,"value2",tonumber(data:getString(i,"value2")))
            self._cfg_ach:setLong(index,"gold",tonumber(data:getString(i,"gold")))
            self._cfg_ach:setLong(index,"link",tonumber(data:getString(i,"Link")))
        end
    end

    --init _cfg_link
    self._cfg_link = ff.NetTable:create()
    self._cfg_link:addCol("linkid",ff.NET_LONG)
    self._cfg_link:addCol("type",ff.NET_LONG)
    self._cfg_link:addCol("id",ff.NET_LONG)
    self._cfg_link:addCol("param1",ff.NET_LONG)
    self._cfg_link:addCol("param2",ff.NET_LONG)

    local sql = "SELECT * FROM `cfg_task_link` ORDER BY `linkid`"
    local dtLink = ff.dbmanager:sql_fetch_rows(sql)
    if dtLink ~= nil then
        for i=1, dtLink:rowCount() do
            local index = self._cfg_link:addRow()
            self._cfg_link:setLong(index,"linkid",tonumber(dtLink:getString(i,"linkid")))
            self._cfg_link:setLong(index,"type",tonumber(dtLink:getString(i,"type")))
            self._cfg_link:setLong(index,"id",tonumber(dtLink:getString(i,"id")))
            self._cfg_link:setLong(index,"param1",tonumber(dtLink:getString(i,"param1")))
            self._cfg_link:setLong(index,"param2",tonumber(dtLink:getString(i,"param2")))      
        end
    end

    if data ~= nil and dtLink ~= nil then
        data:clear()
        dtLink:clear()
    end

    for i=1,20 do
        self._posData[i] = {}
        self._posData[i]['state'] = 0
        self._lessTag[i] = {}
        for j=1,30 do
            self._lessTag[i][j] = 0
        end
    end
    for i=1,30 do
        self._posCategoryData[i] = {}
        self._posCategoryData[i]['state'] = 0
        self._posCategoryData[i]['count'] = 0
    end
end  

function achieveLayer:taskDatas(type)
    local ttable = {}
    for i=1,self.receiveData:rowCount() do
        if self.receiveData:getLong(i, "taskType") == type then
            local tag = self.receiveData:getLong(i,"taskCategory")
            for idx=1,self._cfg_ach:rowCount() do
                if self._cfg_ach:getLong(idx,"type") == type then
                    if self._cfg_ach:getLong(idx,"littletype") == tag then
                        if self._cfg_ach:getLong(idx,"taskid") == self.receiveData:getLong(i,"currentTask") then
                            local t = {}  --保存任务id和任务编号
                            table.insert(t, 1, idx)
                            table.insert(t, 2, self._cfg_ach:getLong(idx,"type"))
                            table.insert(t, 3, self._cfg_ach:getLong(idx,"littletype"))
                            table.insert(t, 4, self._cfg_ach:getLong(idx,"taskid"))
                            table.insert(t, 5, self.receiveData:getLong(i,"taskState"))
                            table.insert(t, 6, self.receiveData:getLong(i,"taskCount"))--该类总个数
                            table.insert(t, 7, self._cfg_ach:getLong(idx,"order"))--当前序号
                            table.insert(ttable,t)
                            break
                        end
                    end
                end
            end
        end
    end
    return ttable
end

--Task Lists
function achieveLayer:onAchieveTask(key)
    self._posData[key]['state'] = 1
    local index = 0
    for i=1,key do
        if self._posData[i]['state'] == 1 then
            index = index + 1
        end
    end
    --获取插入位置
    local pos = key + index - 1
    local panel = self:getChildByName("panel"):clone()
    panel:setTag(key + 30)
    panel:setVisible(true)

    --listView每隔一帧才去刷新
    self:getChildByName("listview"):insertCustomItem(panel, pos)
    self:runAction(
        cc.Sequence:create(
            cc.CallFunc:create(function()
                self:loadTaskDatas(panel,key)
            end),
            cc.DelayTime:create(0.001),
            cc.CallFunc:create(function()
                self:getChildByName("listview"):refreshView()
            end)
        )
    )
end

--加载panel数据
function achieveLayer:loadTaskDatas(panel,key)
    local hh = 0
    local currentTaskTable = self:taskDatas(key)
    table.sort(currentTaskTable,function(a, b)
        return a[1] > b[1]
    end)
    local cTag = table.getn(currentTaskTable)
    --清空任务
    if self._currentTaskLists ~= nil then
        self._currentTaskLists={}
    end
    for i,v in ipairs(currentTaskTable) do
        local des = self:getChildByName("des"):clone()
        des:getChildByName("name"):setString(self._cfg_ach:getString(v[1],"name").." ( "..v[7].."/"..v[6].." )")
        des:getChildByName("number"):setString("x"..self._cfg_ach:getLong(v[1],"gold"))
        local des1 = string.gsub(self._cfg_ach:getString(v[1],"disc"),"%{(.*)%}", self._cfg_ach:getLong(v[1],"value2"))
        des:getChildByName("describe"):setString(des1)
        des:getChildByName("link"):setString(self._cfg_ach:getLong(v[1],"link"))
        des:getChildByName("describe"):setVisible(false)
        des:getChildByName("more"):setVisible(true)
        des:getChildByName("less"):setVisible(false)
        des:getChildByName("more"):setTag(cTag-i+1)
        des:getChildByName("btmline"):setVisible(false)

        --某个panel下面的less tag
        self._lessTag[key][i] = i
        self:showBtnbyState(des,v[5],cTag-i+1 + 20,nil)

        local function btnShowMore(sender, eventType)
            if eventType == ccui.TouchEventType.ended then
                local widget = pop.getDialog("taskAchieve")
                if widget ~= nil then
                    if sender == des:getChildByName("more") then
                        local index = sender:getTag()
                        local panel = widget:getChildByName("listview"):getChildByTag(30 + key)
                        panel:getChildByTag(index):getChildByName("more"):setVisible(false)
                        panel:getChildByTag(index):getChildByName("less"):setVisible(true)
                        --分类
                        self.recType = 1
                        self:getDataByType(key, index)
                        self._select = 1
                    end                  
                end
            end
        end
    
        --button event
        local function btnClick(sender,eventType)
            if ccui.TouchEventType.ended == eventType then
                if des:getChildByName("award") == sender then
                    -- award
                    self.recType = 2
                    self._info = des:getTag()
                    self:taskDatas(key)
                    self:getDataByType(v[2],v[3],v[4])
                    self._select = 0

                elseif des:getChildByName("btm_btn") == sender then
                    self:goToTask(des:getChildByName("link"):getString())
                end
            end
        end

        des:setVisible(true)
        panel:addChild(des)
        des:setTag(cTag-i+1)
        
        panel:setContentSize(cc.size(690, 90 * i))
        des:setPosition(cc.p(0,hh))
        hh = hh + 90
        des:getChildByName("more"):addTouchEventListener(btnShowMore)
        des:getChildByName("btm_btn"):addTouchEventListener(btnClick)
        des:getChildByName("award"):addTouchEventListener(btnClick)
        --将当前任务插入到表中
        table.insert(self._currentTaskLists,v[4])
    end
end

function achieveLayer:closeTaskLists(tag)
    self._posData[tag]['state'] = 0
    local removeObj = self:getChildByName("listview"):getChildByTag(tag)
    if removeObj ~= nil then
        self:getChildByName("listview"):removeChildByTag(tag+30)
    end
    self:getChildByName("listview"):refreshView()
end

--Category Task lists
function achieveLayer:showCategoryTask(panel_tag,more_tag,count)
    self._posCategoryData[more_tag]['state'] = 1
    self._posCategoryData[more_tag]['count'] = count

    local panel = self:getChildByName("listview"):getChildByTag(panel_tag+30)
    --获取panel中的某一条数据项items
    local items = panel:getChildByTag(more_tag)
    local hh = 0
    local hhitem = items:getPositionY()
    items:setVisible(false)

    local cnt = 0
    local currentTaskTable = {}
    for key,value in pairs(self.categoryData) do
        for i=1,self._cfg_ach:rowCount() do
            if self._tasktype == self._cfg_ach:getLong(i,"type") then
                if self._littletype == self._cfg_ach:getLong(i,"littletype") then
                    if self.categoryData[key]['taskid'] == self._cfg_ach:getLong(i, "taskid") then
                        local t = {}
                        table.insert(t, 1, i)
                        table.insert(t, 2, self._tasktype)
                        table.insert(t, 3, self._littletype)
                        table.insert(t, 4, self._cfg_ach:getLong(i,"taskid"))
                        table.insert(t, 5, self.categoryData[key]['categoryState'])
                        table.insert(t, 6, self._cfg_ach:getLong(i,"order"))
                        table.insert(currentTaskTable,t)
                        cnt = cnt + 1
                        break
                    end
                end
            end
        end
    end
    --降序
    table.sort(currentTaskTable,function(a, b)
        return a[1] > b[1]
    end)
    local index = 1
    local cTag = table.getn(currentTaskTable)
    local flag = 0
    for k,v in pairs(currentTaskTable) do
        local info = panel:getChildByTag(more_tag * 100 + cTag-k+1)
        if info ~= nil then
        else
            info = self:getChildByName("des"):clone()
            info:getChildByName("name"):setString(self._cfg_ach:getString(v[1],"name"))
            info:getChildByName("number"):setString("x"..self._cfg_ach:getLong(v[1],"gold"))
            local des1 = string.gsub(self._cfg_ach:getString(v[1],"disc"),"%{(.*)%}", self._cfg_ach:getLong(v[1],"value2"))
            info:getChildByName("describe"):setString(des1)
            info:getChildByName("link"):setString(self._cfg_ach:getLong(v[1],"link"))
            info:getChildByName("more"):setVisible(false)
            info:getChildByName("less"):setVisible(false)
            info:getChildByName("describe"):setVisible(true)
            if k == cTag then
                info:getChildByName("less"):setVisible(true)
                info:getChildByName("describe"):setVisible(false)
                info:getChildByName("less"):setTag(self._lessTag[panel_tag][more_tag])
            end
            if k == 1 then
                info:getChildByName("btmline"):setVisible(true)
            else
                info:getChildByName("btmline"):setVisible(false)
            end
            --1:不能领奖；
            self:showBtnbyState(info,v[5],cTag-k+1,cTag-k+1+30)
            if k == count then
                 self:showBtnbyState(info,v[5],cTag-k+1,cTag-k+1+30)
            elseif k < count then
                if currentTaskTable[k+1][5] == 1 then
                    self:showBtnbyState(info,v[5],cTag-k+1,cTag-k+1+30,1)
                end
            end
            --获得可领奖的任务个数flag
            if v[5] == 1 or v[5] == 9 then
                flag = flag + 1
            end
            local function actionAfterBonus(kk,kinfo)
                self:runAction(
                    cc.Sequence:create(cc.CallFunc:create(function()
                        self:getDataByType(v[2],v[3],v[4]) end),
                        cc.DelayTime:create(0.2),
                        cc.CallFunc:create(function()
                            currentTaskTable[kk][5] = 9
                            if kk > count-flag+1 then
                                local it = panel:getChildByTag(kinfo:getTag()+1)
                                if it ~= nil then
                                    it:getChildByName("award"):setVisible(true)
                                    it:getChildByName("award"):setBright(true)
                                end
                            end 
                        end)
                    )
                )
            end
            local function btnShowLess(sender, eventType)
                if eventType == ccui.TouchEventType.ended then
                    local widget = pop.getDialog("taskAchieve")
                    if widget ~= nil then
                        if sender == info:getChildByName("less") then
                            local idx = sender:getTag()
                            local panel = widget:getChildByName("listview"):getChildByTag(30 + panel_tag)
                            self:closeCategoryTask(panel,idx,cnt)
                            self._select = 0
                        end
                    end
                end
            end
            local function btnClick(sender,eventType)
                if ccui.TouchEventType.ended == eventType then
                    if info:getChildByName("award") == sender then
                        -- award
                        local tt = sender:getTag()
                        self.ss = 1
                        self.recType = 2
                        self._info = sender:getTag()-30
                        for key,value in pairs(currentTaskTable) do
                            if value[6] == (tt - 30) then
                                if value[6] == 1 then
                                    actionAfterBonus(key,info)
                                    return
                                elseif currentTaskTable[key+1][5] == 1 then                                              
                                    return
                                end
                                actionAfterBonus(key,info)
                            end
                        end           
                    elseif info:getChildByName("btm_btn") == sender then                 
                        self:goToTask(info:getChildByName("link"):getString())
                    end
                end
            end
            info:setTag(more_tag * 100 + cTag-k+1)
            panel:addChild(info)
            info:getChildByName("less"):addTouchEventListener(btnShowLess)
            info:getChildByName("btm_btn"):addTouchEventListener(btnClick)
            info:getChildByName("award"):addTouchEventListener(btnClick)
        end
        info:setVisible(true)
        info:setPosition(cc.p(0,hhitem + hh))
        hh = hh + 90
        index = index + 1
    end
 
    items:setPositionY(hhitem + hh)
    local hhPanelbefor = panel:getContentSize().height - 90
    if more_tag > 1 then
        for i=1,more_tag-1 do
            local item2 = panel:getChildByTag(i)
            local yBefore = item2:getPositionY()
            item2:setPositionY(yBefore + hh - 90)
            if self._posCategoryData[i]['state'] == 1 then
                for j=1,self._posCategoryData[i]['count'] do
                    local des = panel:getChildByTag(i * 100 + j)
                    if des ~= nil then
                        local desy = des:getPositionY()
                        des:setPositionY(desy + hh - 90)
                    end
                end
            end
        end
    end
    panel:setContentSize(cc.size(690,hhPanelbefor + hh))
    self:getChildByName("listview"):refreshView()
end

function achieveLayer:changeData(item)
    if self.bonusData ~= nil then
        for i=1,self._cfg_ach:rowCount() do
            if self.bonusData.currentTask == self._cfg_ach:getLong(i,"taskid") then
                item:getChildByName("name"):setString(self._cfg_ach:getString(i,"name").." ( "..self.bonusData.currentId.."/"..self.bonusData.taskCount.." )")
                item:getChildByName("number"):setString("x"..self._cfg_ach:getLong(i,"gold"))
                item:getChildByName("link"):setString(self._cfg_ach:getLong(i,"link"))
                break
            end
        end
    end
    self:showBtnbyState(item,self.bonusData.taskState,nil,nil)
end

function achieveLayer:showBtnbyState(item,state,tag1,tag2,select)
    if state == 0 then
        item:getChildByName("award"):setVisible(false)
        item:getChildByName("complete"):setVisible(false)
        item:getChildByName("btm_btn"):setVisible(true)
        if tag1 ~= nil then
            item:getChildByName("btm_btn"):setTag(tag1)
        end
    elseif state == 1 then
        item:getChildByName("btm_btn"):setVisible(false)
        item:getChildByName("complete"):setVisible(false)
        item:getChildByName("award"):setVisible(true)
        if tag2 ~= nil then
            item:getChildByName("award"):setTag(tag2)
        end
        if select == 1 then
            item:getChildByName("award"):setBright(false)
        end
    elseif state == 9 then
        item:getChildByName("btm_btn"):setVisible(false)
        item:getChildByName("award"):setVisible(false)
        item:getChildByName("complete"):setVisible(true)
        item:getChildByName("complete"):setString(ff.langString("已完成"))
    end
end

function achieveLayer:closeCategoryTask(panel,tag,count)
    self._posCategoryData[tag]['state'] = 0
    self._posCategoryData[tag]['count'] = 0
    --获取到item并显示
    local item = panel:getChildByTag(tag)
    local hhy = item:getPositionY()
    item:setPositionY(hhy-90)
    item:getChildByName("more"):setVisible(true)
    item:getChildByName("less"):setVisible(false)

    --修改item属性
    if self.ss == 1 then
        self.ss = 0
        self:changeData(item)
    end
    item:setVisible(true)

    local hhPanelbefor = panel:getContentSize().height+90
    local hhitem = 0
    for i=tag*100+1,tag*100+count do
        local item2 = panel:getChildByTag(i)
        local hh = item:getContentSize().height
        if item2 ~= nil then
            item2:setVisible(false)
            hhitem = hhitem + hh
        end
        self:getChildByName("listview"):refreshView()
    end

    for i=1,tag do
        local item2 = panel:getChildByTag(i)
        local yBefore = item2:getPositionY()
        item2:setPositionY(yBefore - hhitem+90)
        if self._posCategoryData[i]['state'] == 1 then
            for j=1,self._posCategoryData[i]['count'] do
                local des = panel:getChildByTag(i * 100 + j)
                if des ~= nil then
                    local desy = des:getPositionY()
                    des:setPositionY(desy-hhitem+90)
                end
            end
        end
    end
    panel:setContentSize(cc.size(690,hhPanelbefor - hhitem))
    self:getChildByName("listview"):refreshView()
end

--Get Task information
function achieveLayer:getTaskAchieveLists(params)
    local code = params[1]

    if code == 0 then
        if dd.myAchieveTasks:rowCount() > 0 then
            self.receiveData = dd.myAchieveTasks
            self:initUI()
        end
    else
        dd.currentLayer._widget:onShowTips("\t"..ff.langString("网络错误！！！"))
    end
end

--Get Category Task information
function achieveLayer:getCategoryLists(params)
    local code = params[1]
    self._tasktype = params[2]
    self._littletype = params[3]
    local count = params[4]
    self.categoryData = {}
    if code == 0 then
        for i=1,params[5]:rowCount() do
           self.categoryData[i] = {}
           self.categoryData[i]['count'] = count
           self.categoryData[i]['order'] = params[5]:getLong(i,'order')
           self.categoryData[i]['taskid'] = params[5]:getLong(i,'taskid')
           self.categoryData[i]['categoryState'] = params[5]:getLong(i,'categoryState')
        end

       --获取已完成的任务信息
        local seg = params[5]:getLong(1,'order')
        for i=1,self._cfg_ach:rowCount() do
            if self._cfg_ach:getLong(i,"type") == self._tasktype then
                if self._cfg_ach:getLong(i,"littletype") == self._littletype then
                    if self._cfg_ach:getLong(i,"order") < seg then
                        local last = table.getn(self.categoryData) + 1
                        local t = {}
                        t.order = self._cfg_ach:getLong(i,"order")
                        t.taskid = self._cfg_ach:getLong(i,"taskid")
                        t.categoryState = 9
                        table.insert(self.categoryData,last, t)
                    end

                end
            end
        end

       --任务类型、分类的类型与panel（tag）、btn_more(tag)是同步的
        self:showCategoryTask(self._tasktype, self._littletype, count)
    else
        dd.currentLayer._widget:onShowTips("\t"..ff.langString("领奖失败！！！"))
    end
end

function achieveLayer:getTakeAchieveBonus(params)
    local message = params[1]
    local tp = params[2]
    local cateTp = params[3]
    for i=1,dd.myAchieveTasks:rowCount() do
        if tp == dd.myAchieveTasks:getLong(i,"taskType") then
            if cateTp == dd.myAchieveTasks:getLong(i,"taskCategory") then
                self.bonusData.currentId = dd.myAchieveTasks:getLong(i,"currentId")
                self.bonusData.currentTask = dd.myAchieveTasks:getLong(i,"currentTask")
                self.bonusData.taskCount = dd.myAchieveTasks:getLong(i,"taskCount")
                self.bonusData.taskState = dd.myAchieveTasks:getLong(i,"taskState")
                break
            end
        end
    end
    if message == 0 then
        if self._select == 0 then
            self.receiveData = dd.myAchieveTasks
            local panel = self:getChildByName("listview"):getChildByTag(tp+30)
            panel:removeAllChildren(true)
            self:loadTaskDatas(panel,tp)
            self:getChildByName("listview"):refreshView()
        elseif self._select == 1 then
            --1.修改状态；
            local widget = pop.getDialog("taskAchieve")
            if widget ~= nil then
                local panel = widget:getChildByName("listview"):getChildByTag(tp+30)
                local tag = cateTp*100+widget._info
                panel:getChildByTag(tag):getChildByName("award"):setVisible(false)
                panel:getChildByTag(tag):getChildByName("complete"):setVisible(true)
            end
        end
    else
        dd.mainUI:onShowCodeTips(message)
    end
end

function achieveLayer:goToTask(linkid)
    local tType = 0
    local id = 0
    local param1 = 0
    local param2 = 0
    for i=1,self._cfg_link:rowCount() do
        if self._cfg_link:getLong(i,"linkid") == tonumber(linkid) then
            tType = self._cfg_link:getLong(i,"type")
            id = self._cfg_link:getLong(i,"id")
            param1 = self._cfg_link:getLong(i,"param1")
            param2 = self._cfg_link:getLong(i,"param2")
            break
        end
    end
    cclog("=-=====name: "..dd.currentLayer._name)
    cclog("type: "..tType.."    id: "..id)
    self.onReturn()
    if tType == 0 then
        if dd.currentLayer._name ~= "CityLayer" then
            dd.yunClose(1)
        end
    elseif tType == 1 then
        self:commonEntry(id)
    elseif tType == 2 then
        pop.onShowPopDialog("unionTec")
    elseif tType == 3 then
        if dd.currentLayer._name ~= "WorldUILayer" then
            dd.yunClose(2)
        end
    elseif tType == 4 then
        if dd.currentLayer._name ~= "pve" then
            dd.yunClose(3)
        end
    elseif tType == 5 then
        pop.onShowPopDialog("lottery")
    elseif tType == 6 then
        self:commonEntry(11)
    elseif tType == 7 then
        self:commonEntry(21)
    elseif tType == 8 then
        self:runAction(
            cc.Sequence:create(
                cc.DelayTime:create(0.1),
                cc.CallFunc:create(function()
                    if dd.currentLayer._name ~= "CityLayer" then
                        dd.yunClose(1)
                    end
                end)))
    end
end

function achieveLayer:commonEntry(bid)
    for i=1,dd.mybuilds:rowCount() do
        if dd.mybuilds:getLong(i,"bid") == bid then
            onShowBuildsList(dd.currentLayer._widget,dd.mybuilds:getLong(i,"pos"))
            break
        end
    end
end

function achieveLayer:getDataByType(tType,cType,tCode)
    local message = ff.net:createMessage()
    if self.recType == 1 then
        message:addCmd(0x0000004a)
        message:addLong(dd.uid)
        message:addLong(tType) 
        message:addLong(cType)
    elseif self.recType == 2 then
--        message:addCmd(0x00000165)
--        message:addLong(dd.uid)
--        message:addLong(tType)
--        message:addLong(cType)
--        message:addLong(tCode)
    end
    ff.net:rpc(message, false)
end

function achieveLayer:returnBack()
	if self._type == 1 then
		pop.onClosePopDialog("taskAchieve")
	end
end

function achieveLayer.onStart(sender)
    ff.net:bindProperty(2602,"gold",sender.updateGold) 
end

function achieveLayer.updateGold()
    local widget = pop.getDialog("taskAchieve")
    if widget ~= nil then
        widget:getChildByName("top"):getChildByName("number"):setString(dd.gold())
        widget:getChildByName("top"):getChildByName("addgold"):addTouchEventListener(dd.onPay)
    end
end

function achieveLayer.onBefore(sender)
    ff.net:registerEvent(2,dd.Tjf_AchieveCategoryLists, function (message)sender:getCategoryLists(message)end)
    --ff.net:registerEvent(2,dd.Tjf_TaskAchieveTakeBonus, function (message)sender:getTakeAchieveBonus(message)end)

    --ff.net:registerEvent(2,dd.Tjf_GetTaskAchieveLists, function (message)sender:getTaskAchieveLists(message)end)
    if dd.myAchieveTasks == nil then
        dd.myAchieveTasks = ff.NetTable:create(true)
        --任务类型 
        dd.myAchieveTasks:addStreamCol("taskType",ff.NET_LONG)
        --分类类型
        dd.myAchieveTasks:addStreamCol("taskCategory",ff.NET_LONG)
        --该类总数
        dd.myAchieveTasks:addStreamCol("taskCount",ff.NET_LONG)
        --任务编号
        dd.myAchieveTasks:addStreamCol("currentId",ff.NET_LONG)
        --任务id
        dd.myAchieveTasks:addStreamCol("currentTask",ff.NET_LONG)
        --任务状态
        dd.myAchieveTasks:addStreamCol("taskState",ff.NET_LONG)

--        local message = ff.net:createMessage()
--        message:addCmd(0x00000049)
--        message:addLong(dd.uid)
--        ff.net:rpc(message, false)
    else
        local widget = pop.getDialog("taskAchieve")
        if widget ~= nil then
            widget.receiveData = dd.myAchieveTasks
        end
    end
end

function achieveLayer.onEnd(sender)
	dd.delBackEvent()
    --ff.net:removeEvent(2,dd.Tjf_GetTaskAchieveLists)
    ff.net:removeEvent(2,dd.Tjf_AchieveCategoryLists)
    --ff.net:removeEvent(2,dd.Tjf_TaskAchieveTakeBonus)
    ff.net:unbindProperty("gold",2602)
    if sender._cfg_ach ~= nil then
        sender._cfg_ach:clear()
    end
    if sender._cfg_link ~= nil then
        sender._cfg_link:clear()
    end
end

function onShowTaskAchieve(widget)
	local layer = achieveLayer.extend(widget)
	dd.regeditBackEvent(layer.onReturn)
	layer:onInit()
	return layer
end