taskInfoLayer = class("taskInfoLayer")
taskInfoLayer._name = "taskInfo"
taskInfoLayer._init = false
taskInfoLayer._type = 0

taskInfoLayer.info = {}
taskInfoLayer.linkid = 0
taskInfoLayer.__taskid = 0
taskInfoLayer.task_widget = nil
function taskInfoLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, taskInfoLayer)
    return target
end

function taskInfoLayer:onInit()
	if self._init == false then
		local hh = ff.height
		self:setContentSize(cc.size(720,hh))
		self:getChildByName("bgLayer"):setContentSize(cc.size(720,hh))
        self:getChildByName("bgLayer"):setPositionY(0)
        self:getChildByName("top"):setPositionY(hh-105)

        self:onAutoSize()
        
        local function onTouchBegan(touch, event)
            self:unShowTips()
            return false
        end
        local listener = cc.EventListenerTouchOneByOne:create()
        listener:registerScriptHandler(onTouchBegan,cc.Handler.EVENT_TOUCH_BEGAN)
        listener:setSwallowTouches(true)
        self:getChildByName("touch"):getEventDispatcher():addEventListenerWithSceneGraphPriority(listener,self:getChildByName("touch"))
        
        self:getChildByName("top"):getChildByName("return"):addTouchEventListener(self.onReturn)
        self:getChildByName("top"):getChildByName("addgold"):addTouchEventListener(dd.onPay)
	end
	self._init = true
    self.updateGold()
    self:initMethods()
end

function taskInfoLayer:onAutoSize()
    self:getChildByName("main"):setPositionY(ff.height-105-200)
    local h = ff.height-105-200-190
    self:getChildByName("panel_award"):setContentSize(cc.size(700,h))
    self:getChildByName("panel_award"):setPositionY(190)
    self:getChildByName("panel_award"):getChildByName("panel"):setPositionY(h-54)
    self:getChildByName("panel_award"):getChildByName("panel_top"):setPositionY(h-50)
    self:getChildByName("operate"):setPositionY(0)
end

function taskInfoLayer:initMethods()
    self:initInfo()
    self:initItem()
    self:initGifts()
    self:initBottomBtn()
end

function taskInfoLayer.onStart(sender)
    ff.net:bindProperty(2606,"gold",sender.updateGold)
end

function taskInfoLayer.onBefore(sender)
    dd.initGoldSpine(sender:getChildByName("top"):getChildByName("img"),sender:getChildByName("top"):getChildByName("addgold"))
end

function taskInfoLayer.updateGold()
    local sender = pop.getDialog("taskInfo")
    if sender ~= nil then
        sender:getChildByName("top"):getChildByName("number"):setString(dd.myinfo:getLong(1,"gold"))
        local w = sender:getChildByName("top"):getChildByName("number"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        sender:getChildByName("top"):getChildByName("title"):setContentSize(cc.size(w,100))
        sender:getChildByName("top"):getChildByName("title"):requestDoLayout()
        sender:getChildByName("top"):requestDoLayout()
    end
end

function taskInfoLayer:getDatas(tid)
    local strSql = "SELECT * FROM `cfg_basetask` WHERE `taskid` = "..tid
    local data = ff.dbmanager:sql_fetch_rows(strSql)
    if data == nil then
        return
    end
    return data
end

function taskInfoLayer:initInfo()
    self.task_widget = pop.getDialog("task")
    if self.task_widget ~= nil then
        if self.task_widget.flag == 1 then
            self.info.tid = dd.myTasks:getLong(1,"builds")
            self.info.state=dd.myTasks:getLong(1,"buildsState")
            self.info.progress = dd.myTasks:getLong(1,"buildsPro")
        elseif self.task_widget.flag == 2 then
            self.info.tid = dd.myTasks:getLong(1,"tec")
            self.info.state=dd.myTasks:getLong(1,"tecState")
            self.info.progress = dd.myTasks:getLong(1,"tecPro")
        elseif self.task_widget.flag == 3 then
            self.info.tid = dd.myTasks:getLong(1,"heros")
            self.info.state=dd.myTasks:getLong(1,"herosState")
            self.info.progress = dd.myTasks:getLong(1,"herosPro")
        elseif self.task_widget.flag == 4 then
            self.info.tid = dd.myTasks:getLong(1,"others")
            self.info.state=dd.myTasks:getLong(1,"othersState")
            self.info.progress = dd.myTasks:getLong(1,"othersPro")
        end
    end
    self._type = self.task_widget.flag
end

function taskInfoLayer:initGifts()
    local data = self:getDatas(self.info.tid)
    local giftInfo = Split(data:getString(1,"rew"),'|')

    local panel_award = self:getChildByName("panel_award")
    panel_award:getChildByName("item"):setVisible(false)
    local panel = panel_award:getChildByName("panel")
    if panel:getChildrenCount() > 0 then
        panel:removeAllChildren(true)
    end
    local pWidth = panel:getContentSize().width
    local hhitem = panel_award:getChildByName("item"):getContentSize().height
    panel_award:getChildByName("award"):setVisible(false)
    local list = panel_award:getChildByName("list")
    if list:getChildrenCount() > 0 then
        list:removeAllChildren(true)
    end

    local giftList = {}
    local propList = {}
    for key,var in ipairs(giftInfo) do
        local gift = Split(var,'%^')
        if gift[1] == '1' then
            local item = panel_award:getChildByName("award"):clone()
            local icon = item:getChildByName("icon"):getChildByName("img")
            local num = item:getChildByName("image"):getChildByName("num")
            icon:loadTexture(dd.getToolsIcon(tonumber(gift[2])),0)
            num:setString("X"..gift[3])
            item:setTag(tonumber(gift[2]))
            item.id = tonumber(gift[2])
            item:addTouchEventListener(self.onBlock)
            table.insert(propList,item)
        else
            local item = panel_award:getChildByName("item"):clone()
            if gift[1] == '2' then           
                item:getChildByName("icon"):loadTexture(dd.getPathFromUI('public/v2/res_ic01.png',1))
            elseif gift[1] == '3' then
                item:getChildByName("icon"):loadTexture(dd.getPathFromUI('public/v2/res_ic02.png',1))
            elseif gift[1] == '4' then
                item:getChildByName("icon"):loadTexture(dd.getPathFromUI('public/v2/res_ic03.png',1))
            elseif gift[1] == '5' then
                item:getChildByName("icon"):loadTexture(dd.getPathFromUI('public/v2/res_ic04.png',1))
            elseif gift[1] == '6' then
                item:getChildByName("icon"):loadTexture(dd.getPathFromUI('public/v2/res_ic05.png',1))
            elseif gift[1] == '7' then
                item:getChildByName("icon"):setPositionX(item:getChildByName("icon"):getPositionX() - 7)
                item:getChildByName("icon"):setScale(1.2)
                item:getChildByName("icon"):loadTexture(dd.getPathFromUI('public/v2/res_ic06.png',1))
            end
            item:getChildByName("award"):setString(gift[3])
            item:setTag(key)
            table.insert(giftList,item)
        end
    end
    panel:setContentSize(cc.size(pWidth,hhitem * #giftList))
    function comps(item1, item2)
       return item1:getTag() > item2:getTag()
    end
    table.sort(giftList,comps)
    for i,item in ipairs(giftList) do
        panel:addChild(item)
        item:setVisible(true)
        item:setPositionY((i-1)*50)
    end
    local surplushh = panel:getPositionY()-panel:getContentSize().height
    --cclog("surplushh: "..surplushh)
    list:setPositionY(surplushh-list:getContentSize().height-10)
    for key,it in ipairs(propList) do
        list:pushBackCustomItem(it)
        it:setVisible(true)
    end

    if data ~= nil then
        data:clear()
    end
end

function taskInfoLayer.onBlock(sender,eventType)
    if eventType == ccui.TouchEventType.ended then
        local widget = pop.getDialog("taskInfo")
        local main = widget      
        local anr   = sender:getAnchorPoint()--cc.p(0,0)
        local size  = sender:getContentSize()--size(140,170)
        local p = sender:convertToWorldSpace(cc.p(anr.x * size.width,anr.y * size.height)) --世界坐标
        local np = main:convertToNodeSpace(p)

        if np.x <150 then
            widget:showTips(0.1,np.x,np.y,sender.id)
        elseif np.x > 550 then
            widget:showTips(0.9,np.x,np.y,sender.id)
        else
            widget:showTips(0.5,np.x,np.y,sender.id)
        end
    end
end

function taskInfoLayer:showTips(anp,posx,posy,id)
    local tips = self:getChildByName("tips")
    tips:setAnchorPoint(cc.p(anp,0))
    tips:getChildByName("tip"):getVirtualRenderer():setDimensions(350,0)
    tips:getChildByName("tip"):setAnchorPoint(cc.p(anp,0))
    tips:getChildByName("tip"):setPosition(cc.p(anp*350+8,10))
    tips:getChildByName("flag"):setPosition(cc.p(anp*360,-10))
    posx = posx + 70
    posy = posy + 120
    tips:setVisible(true)  
    tips:setPositionX(posx)
    tips:setPositionY(posy)
    local str = ""    
    local scolor = 1
    tips:getChildByName("tip"):setString("")
    
    str = str..ff.langString(dd.cfgProp[id]['name'],{dd.cfgProp[id]['name1_lan']}).."\n"
    str = str..ff.langString(dd.cfgProp[id]['tips'],{dd.cfgProp[id]['tips1_lan']})
    --tips:getChildByName("tip"):setString(str)
    --self.setTipsColor(tips:getChildByName("tip"),dd.cfgProp[id]['color'])
    scolor = dd.cfgProp[id]['color']

    tips:removeChildByTag(101)    
    local richText = ccui.RichText:create()
    richText:ignoreContentAdaptWithSize(false)
    richText:setContentSize(cc.size(340,600))    
    richText:setAutoHeight()
    local chat = ccui.RichElementText:create(1, self.getColor(scolor), 255, str, "Helvetica", 20)
    richText:insertElement(chat,0)
    richText:formatText()
    local size = richText:getContentSize()
    richText:setPosition(cc.p(175,size.height/2 + 10))
    tips:setContentSize(cc.size(360, size.height + 20))
    tips:addChild(richText,0,101)
end

function taskInfoLayer.getColor(color)
    local colorcode = cc.c3b(196,213,214)
    if color == 1 then
        colorcode = cc.c3b(196,213,214)
    elseif color == 2 then
        colorcode = cc.c3b(75,137,81)
    elseif color == 3 then
        colorcode = cc.c3b(63,116,160)
    elseif color == 4 then
        colorcode = cc.c3b(164,80,151)
    elseif color == 5 then
        colorcode = cc.c3b(255,250,106)
    else
        colorcode = cc.c3b(196,213,214)
    end
    return colorcode
end
function taskInfoLayer:unShowTips()
    self:getChildByName("tips"):setVisible(false)
end

function taskInfoLayer:initItem()
    local panel_main = self:getChildByName("main")
    panel_main:setVisible(true)

    local data = self:getDatas(self.info.tid)
    local type = tonumber(data:getString(1,"type"))
    local name = panel_main:getChildByName("name")
    local icon = panel_main:getChildByName("ico")
    --描述
    local tips = ff.langString(tonumber(data:getString(1,"disc_lan")),{data:getString(1,"value2"),data:getString(1,"value3")})
    name:setString(tips)

    icon:loadTexture("images/icon/task/taskIco/img0"..type.."_task.png",0)
    local task_type = panel_main:getChildByName("chu_type")
    if type == 1 then
        task_type:setString(ff.langString("推荐任务"))
    elseif type == 2 then
        task_type:setString(ff.langString("科技"))
    elseif type == 3 then
        task_type:setString(ff.langString("训练"))
    elseif type == 4 then
        task_type:setString(ff.langString("杂项"))
    end
    task_type:getVirtualRenderer():enableBold(true)
    if type == 1 then
        task_type:setColor(cc.c3b(255,228,0))
        name:setColor(cc.c3b(189,208,208))
    else
        task_type:setColor(cc.c3b(183,197,199))
        name:setColor(cc.c3b(119,137,137))
    end

    local proInfo = panel_main:getChildByName("proInfo")
    local progressBar = proInfo:getChildByName("progressBar")
    local progressLabel = proInfo:getChildByName("progressLabel")
    --set proInfo
    local value = tonumber(data:getString(1,"value2"))
    if self.info.state == 1 then
        progressBar:setPercent(100)
        progressLabel:setString(value.."/"..value)
    elseif self.info.state == 9 then
        progressBar:setPercent(100)
        progressLabel:setString(value.."/"..value)
    else
        progressBar:setPercent(self.info.progress / value * 100)
        progressLabel:setString(self.info.progress.."/"..value)
    end
    self.linkid = tonumber(data:getString(1,"Link"))
    self.__taskid = tonumber(data:getString(1,"taskid"))
end

function taskInfoLayer:clickEvent()
    local btn = self:getChildByName("operate"):getChildByName("btn")
    local function click(sender,eventType)
        if eventType == ccui.TouchEventType.ended then
            if sender == btn then
                if btn:getChildByName("chu_label"):getString()==ff.langString("前往") then
                    self.onReturn()
                    --onShowTask(nil,nil,self.linkid)
                    self:goToTask(self.linkid)
                elseif btn:getChildByName("chu_label"):getString()==ff.langString("领奖") then
                    self.task_widget.succuce = true
                    self.task_widget:clientToServer(self._type)
                end
            end
        end
    end
    btn:addTouchEventListener(click)
end

function taskInfoLayer:setButton()
    self.task_widget.succuce = nil
    dd.currentLayer._widget:onShowTips("\t"..ff.langString("成功领取奖励 ！"),true)
end

function taskInfoLayer:initBottomBtn()
    local btn = self:getChildByName("operate"):getChildByName("btn")
    if self.info.state == 0 then
        btn:getChildByName("chu_label"):setString(ff.langString("前往"))
        btn:setBright(true)    
    elseif self.info.state == 1 then
        btn:getChildByName("chu_label"):setString(ff.langString("领奖"))
        btn:setBright(true)
    elseif self.info.state == 9 then
        btn:setBright(false)
        btn:getChildByName("chu_label"):setString(ff.langString("已完成"))
    end
    self:clickEvent()
end

function taskInfoLayer.onEnd(sender,btns)
    dd.delBackEvent()
    ff.net:unbindProperty("gold",2606)

    local panel_award = sender:getChildByName("panel_award")
    local panel = panel_award:getChildByName("panel")
    local list = panel_award:getChildByName("list")
    panel:removeAllChildren(true)
    list:removeAllChildren(true)
end

function taskInfoLayer.onReturn(sender,eventType)
    local close = false
    if sender == nil then
        close = true
    end
    if eventType==ccui.TouchEventType.ended then     
        close = true
    end
    if close == true then
        pop.onClosePopDialog("taskInfo")
    end
end

function taskInfoLayer:goToTask(linkid)
    local taskLink = "SELECT `linkid`, `type`, `id`, `param1`, `param2` FROM `cfg_task_link` WHERE linkid="..linkid
    local linkInfo = ff.dbmanager:sql_fetch_rows(taskLink)
        if linkInfo == nil then
            return
    end
    local tType   = tonumber(linkInfo:getString(1,"type"))
    local id     = tonumber(linkInfo:getString(1,"id"))
    local param1 = tonumber(linkInfo:getString(1,"param1"))
    local param2 = tonumber(linkInfo:getString(1,"param2"))
    --cclog("=-=====name: "..dd.currentLayer._name)
    --cclog("type: "..tType.."    id: "..id)
    pop.getDialog("task").onReturn()

    if tType == 1 then
        if param1 == 1 then
            self:commonEntry(id,nil)
        elseif param1 == 2 then
            self:commonEntry(id,true)
        end
    elseif tType == 2 then
        if param1 == 0 then
            --join union
            pop.onShowPopDialog("noUnion",1)
        else
            if dd.myUnion:getLong(1,"unionid") <= 0 then
                pop.onShowPopDialog("noUnion",1)
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("请先加入联盟 ！"))
            else
                if param1 == 1 then
                --Oversee
                if param2 == 1 then
                    pop.onShowPopDialog("unionMember")
                elseif param2 == 2 then
                    pop.onShowPopDialog("unionTec")
                elseif param2 == 3 then
                    pop.onShowPopDialog("unionHelp")
                elseif param2 == 4 then
                    pop.onShowPopDialog("unionOption")
                end
                elseif param1 == 2 then
                --union shop
                elseif param1 == 3 then
                --Deplomacy
                end
            end
        end
    elseif tType == 3 then
        if dd.currentLayer._name ~= "WorldUILayer" then
            dd.yunClose(2)
        end
    elseif tType == 4 then
        if dd.currentLayer._name ~= "pve" then
            dd.yunClose(3)
        end
    elseif tType == 5 then
        pop.onShowPopDialog("lottery")
    elseif tType == 6 then
        self:commonEntry(11,nil,id)
    elseif tType == 7 then
        if dd.mybuilds:rowCount() == 0 then
            onShowTask(nil,nil,linkid)
        else
            local flag = true
            for i=1,dd.mybuilds:rowCount() do
                if dd.mybuilds:getLong(i,"bid") == id then
                    flag = false
                    break
                end
            end
            if flag == false then
                self:commonEntry(id,nil,param1)
            else
                onShowTask(nil,nil,linkid)
            end
        end
    elseif tType == 8 then
        onShowTask(nil,nil,linkid)
    end
end

function taskInfoLayer:commonEntry(bid,show,param)
    for i=1,dd.mybuilds:rowCount() do
        if dd.mybuilds:getLong(i,"bid") == bid then
            onShowBuildsList(dd.currentLayer._widget,dd.mybuilds:getLong(i,"pos"),show,param)
            return
        end
    end
end

function onShowTaskInfo(widget)
    local layer = taskInfoLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)   
    layer:onInit()
    return layer
end