--transport
local transportLayer = class("transport")
transportLayer._name = "transport"
transportLayer._init = false
transportLayer._params = {}
transportLayer._cfgTransport = {}
transportLayer._ress = {0,0,0,0,0}

function transportLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, transportLayer)
    return target
end

function transportLayer:onAutoSize()
    if self._init == false then 
        local hh = ff.height
        self:setContentSize(cc.size(720,hh))
        self:getChildByName("bg"):setContentSize(cc.size(720,hh-105))
        self:getChildByName("bg"):setPositionY(0)
        
        self:getChildByName("masking"):setContentSize(cc.size(720,hh-105))
        self:getChildByName("masking"):setPositionY(0)
        
        self:getChildByName("topArea"):setPositionY(hh - 105)
        self:getChildByName("icon"):setPositionY(hh - 105 - 273)

        self:getChildByName("mainArea"):setContentSize(cc.size(720,hh-105-273-120))
        self:getChildByName("mainArea"):setPositionY(120)
        self:getChildByName("mainArea"):getChildByName("back"):setContentSize(cc.size(690,hh-498-4))
        self:getChildByName("mainArea"):getChildByName("list"):setContentSize(cc.size(690,hh-498 - 80))
    end
end

function transportLayer:onInit()
    if self._init == false then        
        self:getChildByName("topArea"):getChildByName("backbtn"):addTouchEventListener(self.onBack)
        self:getChildByName("topArea"):getChildByName("addbtn"):addTouchEventListener(dd.onPay)
        self:getChildByName("topArea"):getChildByName("title"):getChildByName("chu_title"):getVirtualRenderer():enableOutline(cc.c4b(0,0,0,255),3)
        
        local function onCancle(sender, eventType)
            if eventType==ccui.TouchEventType.ended then     
                self:reset()
            end
        end
        local function onGo(sender, eventType)
            if eventType==ccui.TouchEventType.ended then     
                if self:getSelectResNum() > 0 then
                    local message = ff.net:createMessage()
                    message:addCmd(0x00000151)
                    message:addLong(dd.uid)
                    message:addLong(self._params.touid)        --需求者uid
                    message:addLong(self._ress[1])  --石头(shiyou)
                    message:addLong(self._ress[2])  --木材
                    message:addLong(self._ress[3])  --铁
                    message:addLong(self._ress[4])  --粮食
                    message:addLong(self._ress[5])  --银币
                    ff.net:rpc(message,false) 
                else
                    dd.currentLayer._widget:onShowTips("\t"..ff.langString("请选择要运输的资源"))
                end
            end
        end
        
        self:getChildByName("info"):getChildByName("btn1"):addTouchEventListener(onCancle)
        self:getChildByName("info"):getChildByName("btn2"):addTouchEventListener(onGo)
        self:getChildByName("bar01"):getChildByName("infobtn"):addTouchEventListener(self.openPop)
        
        --加粗
        self:initCfg()
        self:initPop()
        self._init = true
    end
    self.updateGold()
    self:resetList()
end

function transportLayer:initCfg()
    local transport = ff.dbmanager:sql_fetch_rows("select * from cfg_transport")
    for i=1, transport:rowCount() do
        local lv = tonumber(transport:getString(i, "level"))
        self._cfgTransport[lv] = {}
        self._cfgTransport[lv]['percent'] = tonumber(transport:getString(i, "percent"))
        self._cfgTransport[lv]['transport'] = tonumber(transport:getString(i, "transport"))
    end
    transport:clear()
end

function transportLayer:initPop()
    self:getChildByName("pop"):getChildByName("close"):addTouchEventListener(self.closePop)    
end
function transportLayer:updatePop()
    for i,item in ipairs(self:getChildByName("pop"):getChildByName("view"):getChildByName("list"):getChildren()) do
        item:setVisible(false)
    end
    for i,v in ipairs(self._cfgTransport) do
        local item = self:getChildByName("pop"):getChildByName("view"):getChildByName("list"):getChildByTag(i)
        if item == nil then
            item = self:getChildByName("pop"):getChildByName("view"):getChildByName("itemmode"):clone()
            item:setTag(i)
            self:getChildByName("pop"):getChildByName("view"):getChildByName("list"):addChild(item)
        end
        item:getChildByName("level"):setString(i)
        item:getChildByName("max"):setString(dd.showKM(v["transport"],5))
        item:getChildByName("percent"):setString((v["percent"]/10).."%")
        item:setVisible(true)
        if i == dd.myinfo:getLong(1,"level") then
            item:loadTexture(dd.getPathFromUI("public/v2/title2.png",1))
        else
            item:loadTexture(dd.getPathFromUI("public/v2/title3.png",1))
        end
    end
end
function transportLayer:updateInfo(params)
    local info = self:getChildByName("info")
    local percent = self._cfgTransport[dd.myinfo:getLong(1,"level")]['percent']/10
    local value = math.floor(self:getSelectResNum()*percent/100)
    self:getChildByName("icon"):getChildByName("icon"):loadTexture("images/icon/battle/type/1.jpg",0)
    --info:getChildByName("title"):getChildByName("goal"):setString(params.name)
    self:getChildByName("bar01"):getChildByName("chu_percent"):setString(dd.showKM(value,5))
end

function transportLayer:updateResNum(rid,count,input)
    local oldcount = count
    local bags = 0
    local total = 0
    local max = self._cfgTransport[dd.myinfo:getLong(1,"level")]['transport']
    local real = 0
    --该资源上限
    if rid == 1 then
        total = dd.stone()
    elseif rid == 2 then
        total = dd.wood()
    elseif rid == 3 then
        total = dd.iron()
    elseif rid == 4 then
        total = dd.food()
    elseif rid == 5 then
        total = dd.silver()
    end
    if tonumber(count) ~= nil then
        if tonumber(count) > total then
            count = total
        else
            count = tonumber(count)
        end
    else
        count = 0
    end
    
    for id,temp in pairs(self._ress) do
        if id ~= rid then
            bags = bags + math.floor(temp*(1-self:getPercent()/100))
        end
    end    
    real = bags + math.floor(count*(1-self:getPercent()/100))   --实际到达对方
    
    if max < real then
        count = math.ceil(( max - bags )/ (1-self:getPercent()/100))
        if count < 0 then
            count = 0
        end
    end     
    --count = math.ceil(count)
    real = bags + count*(1-self:getPercent()/100)   --实际到达再赋值
    real = math.floor(real)
    self._ress[rid] = count
    
    self:getChildByName("bar01"):getChildByName("chu_total"):setString(dd.showKM(real,5).."/"..dd.showKM(max,5))
    if bags + count*(1-self:getPercent()/100) >= max then
        self:getChildByName("bar01"):getChildByName("chu_total"):setColor(cc.c3b(179,4,24))
    else
        self:getChildByName("bar01"):getChildByName("chu_total"):setColor(cc.c3b(183,197,199))
    end
    self:updateInfo(self._params)                 --更新显示
    --更新滑动条
    local item = self:getChildByName("mainArea"):getChildByName("list"):getChildByTag(rid)
    local editbox = item:getChildByName("textpanel"):getChildByTag(rid)
    editbox:setText(count)
    if total > 0 and item ~= nil then
        local progress = math.ceil(count*100/total)
        if input == true then
            item:getChildByName("panel"):getChildByName("slider"):setPercent(progress)
        else
            if oldcount ~= count then
                item:getChildByName("panel"):getChildByName("slider"):setPercent(progress)
            end
        end
    end
    
    --计算时间
    local speed = 80
    local x1 = (self._params.cid-1)%ff.world_maplayerSize.width
    local y1 = math.floor((self._params.cid-1 - x1)/ff.world_maplayerSize.width)

    local x2 = (dd.mycity:getLong(1,"cid")-1)%ff.world_maplayerSize.width
    local y2 = math.floor((dd.mycity:getLong(1,"cid")-1-x2)/ff.world_maplayerSize.width)

    local dis = math.floor(math.sqrt((x2 - x1)*(x2 - x1) + (y2 - y1)*(y2 - y1)))
    local tick = math.ceil(dis * 1000/speed)
    self:getChildByName("info"):getChildByName("btn2"):getChildByName("time"):setString(ff.getLeftTime(tick,":"))
end 
function transportLayer:reset()
    self:resetList()
    self:updateInfo(self._params)
end
function transportLayer:resetList()
    local valueArr = {dd.stone(),dd.wood(),dd.iron(),dd.food(),dd.silver()}  --dd.silver()
    local max = self._cfgTransport[dd.myinfo:getLong(1,"level")]['transport']
    self:getChildByName("bar01"):getChildByName("chu_total"):setString("0".."/"..dd.showKM(max,5))
    self:getChildByName("bar01"):getChildByName("chu_total"):setColor(cc.c3b(183,197,199))
    self:getChildByName("info"):getChildByName("btn2"):getChildByName("time"):setString(ff.getLeftTime(0,":"))
    for i,item in ipairs(self:getChildByName("mainArea"):getChildByName("list"):getChildren()) do
        local id      = item:getTag()
        local editbox = item:getChildByName("textpanel"):getChildByTag(id)
        editbox:setText("0")
        item:getChildByName("panel"):getChildByName("slider"):setPercent(0)
        item:getChildByName("count"):setString(dd.showKM(valueArr[id],5))
    end 
    self._ress = {0,0,0,0,0}
end

function transportLayer:updateList()
    local list = self:getChildByName("mainArea"):getChildByName("list")
    local resArr = {"石油","木材","钢铁","粮食","银币"}
    local resid  = {}
    local valueArr = {dd.stone(),dd.wood(),dd.iron(),dd.food(),dd.silver()}  --dd.silver()
    if dd.myinfo:getLong(1,"level") <= 10 then
        resid  = {2,4,5}
    elseif dd.myinfo:getLong(1,"level") <= 14 then
        resid  = {2,4,1,5}
    else
        resid  = {2,4,1,3,5}
    end
    if self._params.level < dd.myinfo:getLong(1,"level") then
        if self._params.level <= 10 then
            resid  = {2,4,5}
        elseif self._params.level <= 14 then
            resid  = {2,4,1,5}
        else
            resid  = {2,4,1,3,5}
        end
    end

    list:removeAllChildren(true)

    for i, id in pairs(resid) do
        local item = self:getChildByName("mainArea"):getChildByName("listitem"):clone()
        item:setTag(id)
        item:setVisible(true)
        item:getChildByName("name"):setString(ff.langString(resArr[id]))
        item:getChildByName("count"):setString(dd.showKM(valueArr[id],5))
        item:getChildByName("panel"):getChildByName("slider"):addEventListener(self.sliderEvent)
        item:getChildByName("panel"):getChildByName("slider"):setTag(id)
        item:getChildByName("panel"):getChildByName("slider"):setPercent(0)
        item:getChildByName("panel"):getChildByName("slider"):setCorrect(30,352)
        
        item:getChildByName("face"):getChildByName("icon"):loadTexture("images/icon/res/ic0"..id.."_bk.png",0)
        
        --输入框 textpanel
        local size=item:getChildByName("textpanel"):getContentSize()
        local pos=cc.p(0,0)
        local editBox = dd.addEditBox(
            item:getChildByName("textpanel")
            , size
            , "images/ui/alpha.png"
            , 20000
            , cc.p(0,0)
            , pos
            , cc.c3b(161,175,175)
            , 20
            , 2
            , 4
            , 1
            , 9
            , true
            , true
            , true
        )
        editBox:setName("editbox")
        editBox:registerScriptEditBoxHandler(self.editBoxTextEventHandle)
        editBox:setText(0)
        editBox:setTag(id)
        list:addChild(item)        
    end    
    list:requestRefreshView()
end

function transportLayer.sliderEvent( ref, type )
    if type == ccui.SliderEventType.percentChanged then
        local widget = pop.getDialog("transport")
        local percent = ref:getPercent()
        local resid = ref:getTag()
        local maxNum = 0
        if resid == 1 then
            maxNum = dd.stone()   --石油
        elseif resid ==2 then
            maxNum = dd.wood()
        elseif resid == 3 then
            maxNum = dd.iron()
        elseif resid == 4 then
            maxNum = dd.food()
        elseif resid == 5 then
            maxNum = dd.silver()
        end
        local curNum  = math.floor(percent * maxNum/100)
        
        local item    = widget:getChildByName("mainArea"):getChildByName("list"):getChildByTag(resid)
        local editbox = item:getChildByName("textpanel"):getChildByTag(resid)
        editbox:setText(curNum)
        widget:updateResNum(resid,curNum,false)
    end
end

function transportLayer.editBoxTextEventHandle(strEventName,pSender)
    local widget = pop.getDialog("transport")
    local edit = pSender
    if strEventName == "began" then
    elseif strEventName == "ended" then
    elseif strEventName == "return" then
        local count = pSender:getText()
        local rid   = pSender:getTag()
        widget:updateResNum(tonumber(rid),count,true)
    end
end

function transportLayer.updateGold()
    local widget = pop.getDialog("transport")
    widget:getChildByName("topArea"):getChildByName("money"):setString(dd.gold())
    widget:getChildByName("topArea"):requestDoLayout()

    local w = widget:getChildByName("topArea"):getChildByName("money"):getContentSize().width
    w = 720 - (w + 94 + 75 + 104)
    widget:getChildByName("topArea"):getChildByName("title"):setContentSize(cc.size(w,100))
    widget:getChildByName("topArea"):getChildByName("title"):requestDoLayout()
end

function transportLayer:onResourceTransport(params)
    local code = params[1]
    if code == 0 then
        --运输成功
        pop.onClosePopDialog("transport")
    else
        dd.mainUI:onShowCodeTips(code)
    end
end

function transportLayer:getSelectResNum()
    local count = 0 
    for id,temp in pairs(self._ress) do
        count = count + temp
    end
    return count
end

function transportLayer:getPercent()
    local percent = self._cfgTransport[dd.myinfo:getLong(1,"level")]['percent']
    return percent/10
end

function transportLayer.openPop(sender,eventType)
    if eventType==ccui.TouchEventType.ended then 
        local widget = pop.getDialog("transport")
        widget:getChildByName("masking"):setVisible(true)
        widget:updatePop()
        pop.showPopEffect(12,widget:getChildByName("pop"))        
    end 
end

function transportLayer.closePop(sender,eventType)
    local function unShow()
        local widget = pop.getDialog("transport")
        widget:getChildByName("masking"):setVisible(false)
        widget:getChildByName("pop"):setVisible(false)
    end    

    if eventType==ccui.TouchEventType.ended then   
        local widget = pop.getDialog("transport") 
        widget:getChildByName("masking"):setVisible(false)
        widget:getChildByName("pop"):setVisible(false)               
    end
end

--接口
function transportLayer.onBack(sender,eventType)
    if eventType==ccui.TouchEventType.ended then     
        local widget = pop.getDialog("transport")
        if widget ~= nil then            
            if widget:getChildByName("pop"):isVisible() == true then
                widget.closePop(sender,ccui.TouchEventType.ended)
                return
            end
            pop.onClosePopDialog("transport")
        end
    end
end

function transportLayer.onStart(sender)
    ff.net:bindProperty(2510,"gold",sender.updateGold)
    ff.net:registerEvent(2,dd.Tjf_union_ResourceTransport,function (message)sender:onResourceTransport(message)end)
end
function transportLayer.onBefore(sender)
    dd.initGoldSpine(sender:getChildByName("topArea"):getChildByName("gold"),sender:getChildByName("topArea"):getChildByName("addbtn"))
    sender:updateInfo(sender._params)
    sender:updateList()
    return true
end
function transportLayer.onEnd(sender)
    ff.net:unbindProperty("gold",2510)
    ff.net:removeEvent(2,dd.Tjf_union_ResourceTransport)
    dd.delBackEvent()    
    sender:getChildByName("mainArea"):getChildByName("list"):removeAllChildren(true)
    if ff.platform ~= 1 then
        sender:getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
    end
end

function transportLayer.onReturn(sender)
    local widget = pop.getDialog("transport")
    if widget ~= nil then
        if widget:getChildByName("pop"):isVisible() == true then
            widget.closePop(sender,ccui.TouchEventType.ended)
            return
        end
        pop.onClosePopDialog("transport")
    end  
end

function onShowTransportLayer(widget,params)
    local layer = transportLayer.extend(widget)
    if params == nil then
        params = {}
        params.totem = dd.myUnion:getLong(1,"totem")
        params.level= dd.myinfo:getLong(1,"level")
        params.name = "fatality"
        params.cid = 1
    end    
    layer._params = params
    dd.regeditBackEvent(layer.onReturn)
    layer:onAutoSize()
    layer:onInit()
    return layer
end