--transport "("..WorldControl:getInstance():getCidStr(self.infoList[var]['cid'])..")"
local transportInfoLayer = class("transportInfo")
transportInfoLayer._name = "transportInfo"
transportInfoLayer._init = false
transportInfoLayer._id = 1
transportInfoLayer._onlyView = false
transportInfoLayer._ViewTable = {}
function transportInfoLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, transportInfoLayer)
    return target
end

function transportInfoLayer:onInit()
    if self._init == false then        
        self:getChildByName("close"):addTouchEventListener(self.onBack)
        self:getChildByName("title"):getVirtualRenderer():enableBold(true)
        self._init = true
    end
    self:updateInfo(self._id)
end

function transportInfoLayer:updateInfo(id)
    if self._onlyView == true then
        self:getChildByName("info"):getChildByName("tovalue"):setString("("..WorldControl:getInstance():getCidStr(self._ViewTable.to)..")")
        self:getChildByName("info"):getChildByName("fromvalue"):setString("("..WorldControl:getInstance():getCidStr(self._ViewTable.from)..")")
        local total = self._ViewTable.res1 + self._ViewTable.res2 + self._ViewTable.res3 + self._ViewTable.res4 + self._ViewTable.res5
        self:getChildByName("info"):getChildByName("resvalue"):setString(dd.showKM(total,5))
        
        self:getChildByName("item1"):getChildByName("count1"):setString(dd.showKM(self._ViewTable.res1,5))
        self:getChildByName("item1"):getChildByName("count2"):setString(dd.showKM(self._ViewTable.res2,5))
        self:getChildByName("item1"):getChildByName("count3"):setString(dd.showKM(self._ViewTable.res3,5))
        self:getChildByName("item2"):getChildByName("count4"):setString(dd.showKM(self._ViewTable.res4,5))
        self:getChildByName("item2"):getChildByName("count5"):setString(dd.showKM(self._ViewTable.res5,5))
        self:getChildByName("info"):getChildByName("icon"):getChildByName("icon"):loadTexture("images/icon/charge/transport.png",0)
        cclog("瞭望塔的查看")
    else
        cclog("世界地图的查看")
        self:getChildByName("title"):setString(ff.langString("{0}的军队",{dd.myinfo:getString(1,'name')}))
        self:getChildByName("info"):getChildByName("icon"):getChildByName("icon"):loadTexture("images/icon/charge/transport.png",0)
        local ishave = false 
        for i=1,dd.myTroops:rowCount() do
            if dd.myTroops:getLong(i,"id") == id then
                local res1 = dd.myTroops:getLong(i,"b1")   --石
                local res2 = dd.myTroops:getLong(i,"b2")   --木
                local res3 = dd.myTroops:getLong(i,"b4")   --粮食
                local res4 = dd.myTroops:getLong(i,"b3")   --铁矿
                local res5 = dd.myTroops:getLong(i,"b5")   --银币
                local total = res1 + res2 + res3 + res4 + res5
                local to = dd.myTroops:getLong(i,"to")
                local from = dd.myTroops:getLong(i,"from")
                self:getChildByName("info"):getChildByName("tovalue"):setString("("..WorldControl:getInstance():getCidStr(to)..")")
                self:getChildByName("info"):getChildByName("fromvalue"):setString("("..WorldControl:getInstance():getCidStr(from)..")")
                self:getChildByName("info"):getChildByName("resvalue"):setString(dd.showKM(total,5))
                self:getChildByName("item1"):getChildByName("count1"):setString(dd.showKM(res1,5))
                self:getChildByName("item1"):getChildByName("count2"):setString(dd.showKM(res2,5))
                self:getChildByName("item1"):getChildByName("count3"):setString(dd.showKM(res3,5))
                self:getChildByName("item2"):getChildByName("count4"):setString(dd.showKM(res4,5))
                self:getChildByName("item2"):getChildByName("count5"):setString(dd.showKM(res5,5))
                ishave = true
                break
            end
        end
        if ishave == false then
            cclog("没找到运输部队?")
        end
    end
end

--接口
function transportInfoLayer.onBack(sender,eventType)
    if eventType==ccui.TouchEventType.ended then     
        pop.onClosePopDialog("transportInfo")
    end
end


function transportInfoLayer.onStart(sender)
end

function transportInfoLayer.onEnd(sender)
    if ff.platform ~= 1 then
        sender:getChildByName("info"):getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
    end
end


function transportInfoLayer.onReturn(sender)
    return false
end

function onShowTransportInfo(widget,id,onlyView,table)
    local layer = transportInfoLayer.extend(widget)
    if id == nil then
        id = 0
    end
    layer._id = id
    if onlyView ~= nil then
        layer._onlyView = true
        layer._ViewTable = table
    end
    layer:onInit()
    return layer
end