unionRankLayer   = class("unionRankLayer")
unionRankLayer._name = "unionRank"
unionRankLayer._init = false
unionRankLayer._parent = nil
unionRankLayer._lastID  = 0
unionRankLayer._history = nil
unionRankLayer._serach  = 9
unionRankLayer._isLast  = false
unionRankLayer._animFrames = {}


function unionRankLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, unionRankLayer)
    return target
end
function unionRankLayer:onAutoSize()
    cclog("parent:"..self._parent:getName())
    if self._parent._name == "union" then
        local hh = self._parent:getContentSize().height
        self:setContentSize(cc.size(720,hh - 184))
        self:getChildByName("lists"):setContentSize(cc.size(720,hh - 184 - 8 - 8))
        self:getChildByName("lists"):setPositionY(10)
        self:getChildByName("waiting"):setPositionY(10)
    end
    if self._parent:getName() == "union_join" then      
        local hh = ff.height
        self:setContentSize(cc.size(720,hh - 214 - 94 - 110))
        self:getChildByName("lists"):setContentSize(cc.size(720,hh - 214 - 94 - 110))
        self:getChildByName("lists"):setPositionY(4)
        self:getChildByName("waiting"):setPositionY(4)
    end
end
function unionRankLayer:onInit()
    if self._init == false then
        self._history = ff.NetTable:create()
        self._history:addStreamCol("rank",ff.NET_LONG)
        self._history:addStreamCol("unionid",ff.NET_LONG)
        self._history:addStreamCol("short",ff.NET_STRING,3)
        self._history:addStreamCol("name",ff.NET_STRING,32)
        self._history:addStreamCol("totem",ff.NET_LONG)
        self._history:addStreamCol("power",ff.NET_SUPER_LONG)
        self._history:addStreamCol("rels",ff.NET_LONG)
        self._history:addStreamCol("members",ff.NET_LONG)
        self._history:addStreamCol("memberMax",ff.NET_LONG)
        self._history:addStreamCol("applying",ff.NET_LONG)
        self._history:addStreamCol("inviting",ff.NET_LONG)


        self:getChildByName("lists"):addScrollViewEventListener(self.scrollViewEvent)
--        self._init = true
    end
end
function unionRankLayer.onUpdate(params)
    cclog(".................")
    local widget = pop.getDialog("unionRank")
    local code = params[1]
    if code == 0 then
        if params[3] == 1 then
            widget._isLast = true
        else
            widget._isLast = false
        end
        local datas = params[5]
        if widget._serach == params[4] and datas ~= nil then
            for i=1,datas:rowCount() do
                local row = datas:getLong(i,"rank")
                if widget._history:rowCount() < row then
                    row = widget._history:addRow()
                end
                widget._history:setLong(row,"rank",datas:getLong(i,"rank"))
                widget._history:setLong(row,"unionid",datas:getLong(i,"unionid"))
                widget._history:setString(row,"short",datas:getString(i,"short"))
                widget._history:setString(row,"name",datas:getString(i,"name"))
                widget._history:setLong(row,"totem",datas:getLong(i,"totem"))
                widget._history:setLong(row,"rels",datas:getLong(i,"rels"))
                widget._history:setSuperLong(row,"power",datas:getSuperLong(i,"power"))
                widget._history:setLong(row,"members",datas:getLong(i,"members"))
                widget._history:setLong(row,"memberMax",datas:getLong(i,"memberMax"))
                widget._history:setLong(row,"applying",datas:getLong(i,"applying"))
                widget._history:setLong(row,"inviting",datas:getLong(i,"inviting"))
            end
        end
        if datas ~= nil then
            widget:updatePage()       
        end    
    else
        if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
            dd.currentLayer._widget:onShowTips("\t"..dd.errorCode(code))
        end         
    end
end
function unionRankLayer:showWaiting(play)
    self:getChildByName("waiting"):getChildByTag(1):stopAllActions()
    if play == true then
        local animation = cc.Animation:createWithSpriteFrames(self._animFrames, 0.1)
        self:getChildByName("waiting"):getChildByTag(1):runAction(cc.RepeatForever:create(cc.Animate:create(animation)))
        self:getChildByName("waiting"):setVisible(true) 
    else        
        self:getChildByName("waiting"):setVisible(false)
    end
end
function unionRankLayer.onStart(sender)
    if sender._init == false then
        --先添加10条
        for i=1,10 do
            local item = sender:getChildByName("item"):clone()
            item:setTag(i)
            sender:getChildByName("lists"):addChild(item)
        end
        sender:getChildByName("lists"):refreshView()
    
        local cache = cc.SpriteFrameCache:getInstance()
        cache:addSpriteFrames("images/mv/normaleffect.plist")
    
        local mv = cc.Sprite:createWithSpriteFrameName("of_native_loader_progress_01.png")
        local xx = sender:getChildByName("waiting"):getChildByName("label"):getPositionX()
        mv:setContentSize(cc.size(30,30))
        mv:setPosition(cc.p(xx - 30,15))
        mv:setScale(0.4)
    
        sender:getChildByName("waiting"):addChild(mv,1,1)
        for j = 1, 12 do
            local frame = nil
            if j < 10 then
                frame = cache:getSpriteFrame("of_native_loader_progress_0"..j..".png")
            else    
                frame = cache:getSpriteFrame("of_native_loader_progress_"..j..".png")
            end 
            sender._animFrames[j] = frame
        end
        sender._init = true
    end
    sender:getChildByName("lists"):refreshView()
    ff.net:registerEvent(2,dd.Tjf_union_GetRankAlly,sender.onUpdate)
    sender._isLast = false
    sender._lastID = 0
    sender.onShow() 
end
function unionRankLayer:checkUpdate()
    cclog("checkUpdate")
    if self._isLast == false then
        self:showWaiting(true)
        local message = ff.net:createMessage()
        message:addCmd(0x30)
        message:addLong(dd.uid)
        message:addLong(0)
        message:addLong(0)
        message:addString("",15)
        cclog("_lastID:"..self._lastID)
        message:addLong(self._lastID)
        message:addLong(self._serach)
        message:addLong(0)
        ff.net:postMessage(message)
    end    
end
function unionRankLayer.onEnd(sender)
    sender._show = false
    ff.net:removeEvent(2,dd.Tjf_union_GetRankAlly)
    
    if sender:getChildByTag(10008) and pop.isShowing("unionInfo") then--联盟排行里可能弹出了联盟信息界面
        pop.onClosePopDialog("unionInfo")
    end
    
    for i=1,sender._history:rowCount() do
        local item = sender:getChildByName("lists"):getChildByTag(i)
        if item ~= nil then
            if ff.platform ~= 1 then
                if sender._history:getLong(i,"applying") == 1 then
                    item:getChildByName("apply_icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                end
                item:getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
            end
            item:setVisible(false)
            if i > 10 then
                sender:getChildByName("lists"):removeChild(item,true)
            end        
        end
    end
    sender._history:delRows()
    sender:getChildByName("lists"):scrollToTop(0.01,false)
end
function unionRankLayer:updatePage()
    self:showWaiting(false)
    local nextpage = false
    local tick = 1
    
    local function showUnionInfo(sender,eventType) 
        local doaction = false
        if eventType == ccui.TouchEventType.canceled then
            local startp = sender:getTouchBeganPosition()
            local endp   = sender:getTouchEndPosition()
            if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                doaction = true
            end
        end
        if eventType == ccui.TouchEventType.ended then
            doaction = true
        end
        if doaction == true then   
            local key = sender:getTag()
            if self._history:getLong(key,"short") ~= nil then
                pop.onShowPopDialog("unionInfo",self,self._history:getString(key,"short"))
            end
            AudioEngine.playEffect(ff.sounds[109])
        end
    end
    local beforey = self:getChildByName("lists"):getInnerContainer():getPositionY()
    for i=1,self._history:rowCount() do
        local rank = self._history:getLong(i,"rank")
        if rank > self._lastID then
            self._lastID = rank
            local item = self:getChildByName("lists"):getChildByTag(i)
            if item == nil then
                item = self:getChildByName("item"):clone()
                item:setTag(i)
                self:getChildByName("lists"):addChild(item)
            end    
            item:getChildByName("rank_text"):setString(self._history:getLong(i,"rank"))
            item:getChildByName("rank_text"):setColor(cc.c3b(255,255,255))
            item:getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getUnionIcon(self._history:getLong(i,"totem")),0)  
            item:getChildByName("info"):getChildByName("chu_short"):setString("["..self._history:getString(i,"short").."]")
            item:getChildByName("info"):getChildByName("chu_name"):setString(self._history:getString(i,"name"))
            item:getChildByName("info"):getChildByName("power"):setString(ff.getFormatMoney(self._history:getSuperLong(i,"power")))

            if self._history:getLong(i,"applying") == 1 then
                item:getChildByName("apply_icon"):loadTexture("images/icon/union/union_apply.png",0)
            end
            if self._history:getLong(i,"rels") >= 3 then
                item:getChildByName("info"):getChildByName("rels"):loadTexture("images/icon/rels/"..self._history:getLong(i,"rels").."_union.png",0)
            end
            if rank > 999 then
                item:getChildByName("rank_icon"):setVisible(false)
                item:getChildByName("rank_text"):setVisible(true)   
                item:getChildByName("rank_text"):setString(rank)         
            else
                item:getChildByName("rank_icon"):setVisible(true)
                item:getChildByName("rank_icon"):loadTexture(self:getRankIcon(rank),0)
                if rank > 3 then
                    item:getChildByName("rank_text"):setVisible(true)
                    item:getChildByName("rank_text"):setString(rank)    
                    item:getChildByName("rank_text"):setPositionX(38)
                    if rank > 100 then
                        item:getChildByName("rank_text"):setPositionY(43)
                    else
                        item:getChildByName("rank_text"):setPositionY(38)
                    end 
                else
                    item:getChildByName("rank_text"):setVisible(false)
                end
            end
            if rank <= 10 then
                item:setVisible(true)
            else    
                item:setVisible(true)
                nextpage = true
            end
            item:addTouchEventListener(showUnionInfo)
        end    
    end    
    self:getChildByName("lists"):setVisible(true)
    if nextpage == true then
        self:getChildByName("lists"):getInnerContainer():setPositionY(beforey)
        self:getChildByName("lists"):refreshView()
        if self._history:rowCount() > 0 then
            self:getChildByName("lists"):getInnerContainer():runAction(cc.MoveBy:create(0.3,cc.p(0,20)))
        end
    end  
end
function unionRankLayer:getRankIcon(rank)
    if rank <= 3 then
        return "images/icon/rank/no"..rank..".png"
    elseif rank <= 10 then
        return "images/icon/rank/tag01_union.png"
    elseif rank <= 100 then
        return "images/icon/rank/tag02_union.png"
    elseif rank <= 999 then
        return "images/icon/rank/tag03_union.png"
    end
end
function unionRankLayer.scrollViewEvent(sender, evenType)
    if evenType == ccui.ScrollviewEventType.bounceBottom then
        local rank = pop.getDialog("unionRank")
        if rank:getChildByName("waiting"):isVisible() == false and rank:isVisible() == true then
            rank:checkUpdate()
        end    
    elseif evenType ==  ccui.ScrollviewEventType.scrollToTop then
    end
end
function unionRankLayer.onShow()
    local widget = pop.getDialog("unionRank")
    widget:checkUpdate()
end
function unionRankLayer.onBefore(sender)
    return false
end
function unionRankLayer:onClose()
    local widget = pop.getDialog("unionInfo")
    if widget and widget:isVisible() and pop.isShowing("unionInfo") then
        pop.onClosePopDialog("unionInfo")
        return true
    end
    return false
end

function onShowUnionRank(widget,parent)
    local layer = unionRankLayer.extend(widget)
    if layer._parent ~= parent then
        layer._parent = parent
        layer:onAutoSize()
    end    
	layer:onInit()
	return layer
end