UnionShopLayer   = class("UnionShopLayer")
UnionShopLayer._name = "unionShop"
UnionShopLayer._init = false

UnionShopLayer.pos = 0
UnionShopLayer.jhID= 0
UnionShopLayer.curNum = 0
UnionShopLayer.price  = 0
UnionShopLayer._index = 1
UnionShopLayer._items = {}
UnionShopLayer.propData = {}
UnionShopLayer._animFrames = {}
UnionShopLayer._tecinfo = nil

UnionShopLayer.propList = {{},{},{},{},{}}

function UnionShopLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, UnionShopLayer)
    return target
end

function UnionShopLayer:setCheckBox(sender)
    for i,v in ipairs(sender:getParent():getChildren()) do
        if v:getDescription() == "CheckBox" then
            local lab = v:getChildByName("chu_label")
            lab:setColor(cc.c3b(99,124,130))
            v:setSelectedState(false)
        end
    end
    local lab = sender:getChildByName("chu_label")
    lab:setColor(cc.c3b(233, 239, 244))
end

function UnionShopLayer:loadPropData()
    local tmpData = ff.dbmanager:sql_fetch_rows("select * from cfg_league_shop")
    for i=1, tmpData:rowCount() do 
        local pId = tonumber(tmpData:getString(i, "tid"))
        self.propData[pId] = {}
        self.propData[pId]['purch'] = tonumber(tmpData:getString(i, "value"))          --进货价格
        self.propData[pId]['cost']  = tonumber(tmpData:getString(i, "buy"))            --购买价格
        self.propData[pId]['buytype']  = tonumber(tmpData:getString(i, "buytype"))     --购买类型
        self.propData[pId]['image'] = dd.cfgProp[pId]['image']                         --显示图片
        self.propData[pId]['name'] = ff.langString(dd.cfgProp[pId]['name'],{dd.cfgProp[pId]['name1_lan']})            --道具名称
        self.propData[pId]['tips'] = ff.langString(dd.cfgProp[pId]['tips'],{dd.cfgProp[pId]['tips1_lan']})            --道具说明
        self.propData[pId]['type'] = tonumber(dd.cfgProp[pId]['type'])                 --道具类型
        self.propData[pId]['showorder'] = dd.cfgProp[pId]['showorder']
        self.propData[pId]['showlevel'] = dd.cfgProp[pId]['showlevel']                 --道具等级
        self.propData[pId]['bag'] = dd.cfgProp[pId]['bag']
        self.propData[pId]['num'] = 0   --dd.getToolsCount(pId)
        self.propData[pId]['pid'] = pId
    end
    tmpData:clear()
    self:initPropList()
end

function UnionShopLayer:initPropList()
    self:requestShopAction(0,nil,nil)   --查询联盟商店物品

    self.propList = {{},{},{},{},{}}
    for pid,v in pairs(self.propData) do
        local pBag = self.propData[pid]['bag']
        
        if dd.myinfo:getLong(1,"level") < self.propData[pid]['showlevel'] then
        else
            if pBag == 1 then
                self.propList[1][table.getn(self.propList[1]) + 1] = pid
            elseif pBag == 2 then
                self.propList[2][table.getn(self.propList[2]) + 1] = pid
            elseif pBag == 3 then
                self.propList[3][table.getn(self.propList[3]) + 1] = pid
            elseif pBag == 4 then
                self.propList[4][table.getn(self.propList[4]) + 1] = pid
            elseif pBag == 5 then
                --self.propList[5][table.getn(self.propList[5]) + 1] = pid
            end
        end
    end
   function comps(index1, index2)
       return self.propData[index1].showorder <  self.propData[index2].showorder
    end
    for i=1,5 do
        table.sort(self.propList[i],comps)
    end
end

function UnionShopLayer:showBuyView(cType, propData)
    local popview = self:getChildByName("panel_buyItem")
    popview:setVisible(true)
    popview:setPositionY(-popview:getContentSize().height)
    popview:stopAllActions()
    popview:runAction(cc.Sequence:create(cc.EaseExponentialOut:create(cc.MoveTo:create(0.5, cc.p(0, 0)))))

    local imgBg = popview:getChildByName("img_icon_bg")
    local lab_itemNum = popview:getChildByName("lab_num")
    local img_icon = imgBg:getChildByName("img_icon")

    local lab_itemName = popview:getChildByName("infos"):getChildByName("chu_lab_itemName")
    local lab_itemInfo = popview:getChildByName("infos"):getChildByName("lab_itemInfo")
    lab_itemName:setString(ff.langString(propData.name))
    lab_itemInfo:setString(ff.langString(propData.tips))
    lab_itemNum:setString(propData.num)
    --cclog("=======pid: "..propData.pid)
    img_icon:loadTexture(dd.getToolsIcon(propData.pid),0)

    local slider = popview:getChildByName("panel_slider"):getChildByName("slider")
    local lab_current = popview:getChildByName("panel_slider"):getChildByName("lab_current")
    slider:setPercent(0)

    local btn_sub = popview:getChildByName("btn_sub")
    local btn_add = popview:getChildByName("btn_add")
    local btn_commit = popview:getChildByName("btn_commit")
    local lab_comBuy = btn_commit:getChildByName("lab_buy")
    local lab_cost = btn_commit:getChildByName("lab_cost")
    local img_coin = btn_commit:getChildByName("Image_77")

    local panel_input = popview:getChildByName("panel_input")
    local tf_input = panel_input:getChildByName("lab_input")

    self.curNum = 1    --当前操作道具数量
    local userCoin = 0  --玩家当前货币值
    --local price = 0     --单价
    local maxNum = 0

    local function setCommitButtonWithPrice()
        if self.curNum < 1 then
            self.curNum = 1
        end
        local curCost = math.floor(self.curNum) * self.price
        if curCost > userCoin then
            lab_cost:setColor(cc.c3b(255,0,0))
        else
            lab_cost:setColor(cc.c3b(255,255,255))
        end
        lab_cost:setString(math.floor(curCost))
        slider:setPercent((self.curNum / maxNum)*100)

        local bgWidth = btn_commit:getContentSize().width
        tf_input:setString(math.floor(self.curNum))
        lab_current:setString(math.floor(self.curNum))
    end
    
    local function buttonClick(sender, touchType)
        if touchType == ccui.TouchEventType.ended then
            if sender == btn_sub then
                self.curNum = self.curNum - 1
                if self.curNum < 1 then
                    self.curNum = 1
                end
                setCommitButtonWithPrice()
            elseif sender == btn_add then
                self.curNum = self.curNum + 1
                if self.curNum > maxNum then
                    self.curNum = maxNum
                end
                setCommitButtonWithPrice()
            elseif sender == btn_commit then
                self.curNum = math.floor(self.curNum)
                if self.curNum*self.price > userCoin then
                    dd.currentLayer._widget:onShowTips("\t"..ff.langString("点数不足"))
                    return
                end
                if cType == 1 then
                    self:requestShopAction(1, propData.pid, self.curNum)
                else
                    self.jhID = propData.pid
                    self:requestShopAction(3, propData.pid, self.curNum)
                end
            end
        end
    end
    btn_add:addTouchEventListener(buttonClick)
    btn_sub:addTouchEventListener(buttonClick)
    btn_commit:addTouchEventListener(buttonClick)

    local function percentChangedEvent(sender,eventType)
        if eventType == ccui.SliderEventType.percentChanged then
            local percent = slider:getPercent()
            self.curNum = (percent/100) * maxNum
            setCommitButtonWithPrice()
        end
    end  
    slider:addEventListener(percentChangedEvent)


    if cType == 1 then
        --local cost = math.ceil(propData.cost * (1-self:getRank4Plus()))
        self.price = propData.cost * (1-self:getZheKou())
        userCoin = dd.myUnion:getLong(1, "unionpoint")
        lab_comBuy:setString(ff.langString("购买"))
        popview:getChildByName("chu_lab_viewInfo"):setString(ff.langString("道具购买"))
        maxNum = propData.num
        img_coin:loadTexture(dd.getPathFromUI("public/ic13.png", 1))
    else
        self.price = propData.purch
        userCoin = dd.myUnion:getLong(1, "nAllyFunds")
        lab_comBuy:setString(ff.langString("进货"))
        popview:getChildByName("chu_lab_viewInfo"):setString(ff.langString("道具进货"))
        maxNum = math.floor(dd.myUnion:getLong(1, "nAllyFunds")/self.price)
        img_coin:loadTexture(dd.getPathFromUI("public/ic14.png", 1))
    end
    if maxNum > 99 then
        maxNum = 99
    end
    popview:getChildByName("lab_max"):setString(maxNum)

    setCommitButtonWithPrice()

    --init editbox
    if panel_input:getChildByTag(10091) == nil then
        local editBox = dd.addEditBox(
             panel_input
            , panel_input:getContentSize()
            , "images/ui/alpha.png"
            , 10091
            , cc.p(0,0)
            , cc.p(popview:getChildByName("panel_input"):getChildByName("lab_input"):getPositionX()-32,popview:getChildByName("panel_input"):getChildByName("lab_input"):getPositionY())
            , cc.c3b(255,255,255)
            , 20
            , 2
            , 4
            , 1
            , 5
            , true
            , true
            , true
        )
        local function editBoxTextEventHandle(strEventName,pSender)
            local edit = pSender
            local strFmt 
            if strEventName == "began" then
                tf_input:setVisible(false)
            elseif strEventName == "ended" or strEventName == "return" then
                local text = edit:getText()
                tf_input:setVisible(true)
                if text ~= "" then
                    local input_count = tonumber(text)
                    if input_count > 99 then
                        input_count = 99
                    end
                    tf_input:setText(input_count)
                    self.curNum = input_count
                    setCommitButtonWithPrice()
                end
                edit:setText("")
            elseif strEventName == "changed" then
                tf_input:setVisible(true)
            end
        end
        editBox:registerScriptEditBoxHandler(editBoxTextEventHandle)
        slider:setCorrect(35,316)
    end
end

function UnionShopLayer:initBuyView()
    
    local itemModel = self:getChildByName("panel_item")

    local btn_buy = itemModel:getChildByName("btn_buy")
    local btn_purchase = itemModel:getChildByName("btn_purchase")

    local function buttonClick(sender, touchType)
        local doaction = false
        if touchType == ccui.TouchEventType.canceled then
            local startp = sender:getTouchBeganPosition()
            local endp   = sender:getTouchEndPosition()
            if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                --sender:setSelectedState(true)
                doaction = true
            end
        end
        if touchType == ccui.TouchEventType.ended then
            doaction = true
        end
        if doaction == true then
            local tool = self.propData[sender:getTag()]
            if sender:getName() == "btn_purchase" then
                self:showBuyView(3, tool)
            elseif sender:getName() == "btn_buy" then
                if dd.myUnion:getLong(1,"unionofficial") < 2 then
                    dd.currentLayer._widget:onShowTips("\t"..ff.langString("购买权限不足，需升级到2级会员"))
                    return
                else
                    self:showBuyView(1, tool)
                end
            elseif sender:getName() == "btn_close" then
                self:getChildByName("panel_buyItem"):stopAllActions()
                self:getChildByName("panel_buyItem"):setVisible(false)

            end
            self.pos = self:convertToNodeSpace(self:convertToWorldCoordinate(sender)) --获取按钮的位置
        end
    end

    btn_buy:addTouchEventListener(buttonClick)
    btn_purchase:addTouchEventListener(buttonClick)     
    self:getChildByName("panel_buyItem"):getChildByName("btn_close"):addTouchEventListener(buttonClick)

    for i=1,5 do
        local item = itemModel:clone()
        item:retain()
        table.insert(self._items,item)
    end
end

function UnionShopLayer:getItem(create)
    local item = nil
    if table.getn(self._items) <= 0 then
        if create == false then
            return
        end
        item = self:getChildByName("panel_item"):clone()
        item:retain()
    else
        item = self._items[1]
        table.remove(self._items, 1)
    end
    return item
end

function UnionShopLayer:showItems(init)
    local list = self:getChildByName("panel_list")
    local addcount = 0
    cclog("propNum: "..#self.propList[self._index])
    for i=1,table.getn(self.propList[self._index]) do
        local id   = self.propList[self._index][i]
        local tool = self.propData[id]

        local item = list:getChildByTag(i)
        local update = true
        if list:getTag() == self._index then
            update = false
        end
        if item == nil then
            if init == true then
                item = self:getItem(false)
            else
                item = self:getItem(true)
            end
            if item == nil then
                list:refreshView()
                return
            end
            addcount = addcount + 1
            update = true

            list:addChild(item)
            item:setTag(i)
        end

        if update == true then
            item:getChildByName("chu_lab_name"):setString(ff.langString(tool.name))
            item:getChildByName("lab_info"):setString(ff.langString(tool.tips))
        end
        item:getChildByName("lab_num"):setString(tool.num)
        item:getChildByName("img_icon_bg"):getChildByName("img_icon"):loadTexture(dd.getToolsIcon(id),0)
        item:setVisible(true)
        
        local btn_buy = item:getChildByName("btn_buy")
        local btn_purch = item:getChildByName("btn_purchase")
        local lab_point = btn_buy:getChildByName("lab_userpower")
        local icon_purch = btn_purch:getChildByName("icon_purch")
        local lab_cash = btn_purch:getChildByName("lab_unionpower")

        btn_buy:setTag(id)
        btn_purch:setTag(id)

        --购买权限 从2开始
        --进货权限 从4开始
        local unionOffic = dd.myUnion:getLong(1, "unionofficial")
        if unionOffic < 4 then
            btn_purch:setVisible(false)
        else
            btn_purch:setVisible(true)
        end
        if dd.myUnion:getLong(1, "nAllyFunds") >= tool.purch then
            btn_purch:setBright(true)
            btn_purch:setTouchEnabled(true)
            btn_purch:getChildByName("lab_unionpower"):setColor(cc.c3b(255,255,255))
        else
            btn_purch:setBright(false)
            btn_purch:setTouchEnabled(false)
            btn_purch:getChildByName("lab_unionpower"):setColor(cc.c3b(116,123,125))
        end


        if tool.purch < 0 then
            btn_purch:setVisible(false)
        else
            icon_purch:setVisible(true)
            lab_cash:setVisible(true)
        end
        lab_cash:setString(tool.purch)
        local cost = math.ceil(tool.cost * (1-self:getZheKou()))
        lab_point:setString(cost)

        if tool.num < 1 then
            btn_buy:setBright(false)
            btn_buy:setTouchEnabled(false)
            btn_buy:getChildByName("lab_userpower"):setColor(cc.c3b(116,123,125))
        else
            if dd.myUnion:getLong(1, "unionpoint") >= cost then
                btn_buy:setBright(true)
                btn_buy:setTouchEnabled(true)
                btn_buy:getChildByName("lab_userpower"):setColor(cc.c3b(255,255,255))
            else
                btn_buy:setBright(false)
                btn_buy:setTouchEnabled(false)
                btn_buy:getChildByName("lab_userpower"):setColor(cc.c3b(116,123,125))
            end
        end
        if addcount >= 10 and table.getn(self._items) <= 0 then
            break
        end
    end 
    list:refreshView()   
end

function UnionShopLayer:getRank4Plus()
    local ret = 0
    if self._tecinfo ~= nil then
        for i=1,table.getn(self._tecinfo) do
            if self._tecinfo[i]["utid"] == 101 then
                local lv = self._tecinfo[i]["level"]
                if lv == 0 then
                    ret = 0
                else
                    local teclvid = 10100+lv
                    local rows = ff.dbmanager:sql_fetch_rows("select * from cfg_league_tech_levelup where id="..teclvid)
                    local param = tonumber(rows:getString(1, "effect4"))
                    local value  = tonumber(rows:getString(1, "params4"))
                    if dd.cfgEffect[param]['value'] > 0 then
                        value = value/(dd.cfgEffect[param]['value']*100)
                    end
                    ret = value
                    rows:clear()
                end
                break
            end
        end
    end
    --cclog("==============="..ret)
    return ret
end

function UnionShopLayer:requestShopAction(actionType, propId, propNum)
    local message = ff.net:createMessage()
    message:addCmd(0x11b)
    message:addLong(dd.uid)
    message:addLong(actionType)
    if propId and propNum then
        message:addLong(propId)
        message:addLong(propNum)
        cclog("propId:"..propId)
        cclog("propNum:"..propNum)
    else
        message:addLong(0)
        message:addLong(0)
    end

    ff.net:rpc(message,false)
    self:getChildByName("panel_buyItem"):setVisible(false)
end

function UnionShopLayer:responPropList(message)
    local result = message[1]
    if result == 0 then
        local actionType = message[2]
        local propTable = message[3]
        if actionType == 0 then
        elseif actionType == 1 then
            --dd.currentLayer._widget:onShowTips("\t"..ff.langString("道具购买成功 ！"),true)
            local pId = message[4]
            local pCount = message[5]
            dd.setToolCount(pId,pCount)

            self.pos.y = self.pos.y + 225
            --cclog("price: "..self.price.."===zk: "..self:getZheKou())
            local count = self.price  * self.curNum
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("成功购买{0}个{1}道具 ！",{self.curNum,self.propData[pId]['name']}),true)
            dd.mainUI:showGiftNotice(10,0,count,self.pos,2)
        elseif actionType == 3 then
            --dd.currentLayer._widget:onShowTips("\t"..ff.langString("进货成功"),true)
            self.pos.y = self.pos.y + 225
            local count = self.curNum * self.price
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("成功进货{0}个{1}道具 ！",{self.curNum,self.propData[self.jhID]['name']}),true)
            dd.mainUI:showGiftNotice(14,0,count,self.pos,2)
        end
        --
        for i=1,propTable:rowCount() do
            local tid = propTable:getLong(i,"id")
            cclog("tid:"..tid)
            self.propData[tid]['num'] = propTable:getLong(i,"num")
        end
        self:updatePointAndNumber()
        self:showItems(true)
        propTable:clear()
    else
        dd.mainUI:onShowCodeTips(result)
    end
end

function UnionShopLayer:convertToWorldCoordinate(node)
    local anr   = node:getAnchorPoint()
    local size  = node:getContentSize()
    local p = node:convertToWorldSpace(cc.p(anr.x * size.width,anr.y * size.height)) --世界坐标
    return p
end

function UnionShopLayer:initTopButton()
    local top_panel = self:getChildByName("panel_top")

    local btn_navi1 = top_panel:getChildByName("btn_navi1")
    local btn_navi2 = top_panel:getChildByName("btn_navi2")
    local btn_navi3 = top_panel:getChildByName("btn_navi3")
    local btn_navi4 = top_panel:getChildByName("btn_navi4")
    local btn_navi5 = top_panel:getChildByName("btn_navi5")

    local function buttonClick(sender, touchType)
        if touchType == ccui.TouchEventType.ended then
            cclog("click button name========"..sender:getName())
            self:setCheckBox(sender)

            self._index = sender:getTag()
            self:releaseList()
            self:showItems(true)

            self:getChildByName("panel_list"):setTag(self._index)
            self:getChildByName("panel_list"):jumpToTop()
        end
    end
    local function showHelpInfo(sender, eventType)
        if eventType==ccui.TouchEventType.ended then  
            self:getChildByName("mask"):setVisible(true)
            pop.showPopEffect(12,self:getChildByName("pop"))    
            self:getChildByName("mask"):setVisible(true)
            self:getChildByName("mask"):setEnabled(true)
            self:getChildByName("pop"):setEnabled(true)
        end
    end
    local function closeHelpInfo(sender, eventType)
        if eventType==ccui.TouchEventType.ended then     
            self:getChildByName("mask"):setVisible(false)
            self:getChildByName("pop"):setVisible(false)
            self:getChildByName("mask"):setEnabled(false)
            self:getChildByName("pop"):setEnabled(false)
        end
    end
    self:getChildByName("panel_top"):getChildByName("bar"):getChildByName("btn_info"):addTouchEventListener(showHelpInfo)
    self:getChildByName("pop"):getChildByName("close"):addTouchEventListener(closeHelpInfo)
    btn_navi1:addTouchEventListener(buttonClick)
    btn_navi2:addTouchEventListener(buttonClick)
    btn_navi3:addTouchEventListener(buttonClick)
    btn_navi4:addTouchEventListener(buttonClick)
    btn_navi5:addTouchEventListener(buttonClick)
end

function UnionShopLayer:releaseList()
    local list = self:getChildByName("panel_list")
    local count = list:getChildrenCount()
    local real  = table.getn(self.propList[self._index])
    for i=real + 1,count do
        local item = list:getChildByTag(i)
        list:removeChildByTag(i)
        self._items[table.getn(self._items) + 1] = item
    end
end

function UnionShopLayer:onInit()
    if self._init == false then
        self._init = true
        local hh = self._parent:getContentSize().height
        self:setContentSize(cc.size(720, hh - 192))
        self:getChildByName("mask"):setContentSize(cc.size(720, hh - 192))
        local panel_top = self:getChildByName("panel_top")

        panel_top:setPositionY(self:getContentSize().height - panel_top:getContentSize().height)
        local listHeight = hh - 190 - panel_top:getContentSize().height 
        self:getChildByName("panel_list"):setContentSize(cc.size(720, listHeight))
        self:getChildByName("panel_list"):setPositionY(0)
        self:getChildByName("panel_buyItem"):setPositionY(0)

        local cache = cc.SpriteFrameCache:getInstance()
        cache:addSpriteFrames("images/mv/normaleffect.plist")
        for j = 1, 10 do
            local frame = nil
            if j < 10 then
                frame = cache:getSpriteFrame("of_native_loader_progress_0"..j..".png")
            else    
                frame = cache:getSpriteFrame("of_native_loader_progress_"..j..".png")
            end 
            self._animFrames[j] = frame
        end
        self:getChildByName("waiting"):getChildByName("icon"):loadTexture("of_native_loader_progress_01.png",1)

        
        self:initTopButton()
        self:initBuyView()
        self:updatePointAndNumber()
        self:getChildByName("panel_list"):setTag(self._index)
        self:getChildByName("panel_list"):addScrollViewEventListener(self.scrollViewEvent)
        local top_panel = self:getChildByName("panel_top")
        top_panel:getChildByName("btn_navi1"):setSelectedState(true)
    else
        self:initPropList()
    end
    self:loadPropData()
    self:showWaiting(false)
    self:getChildByName("mask"):setVisible(false)
    self:getChildByName("pop"):setVisible(false)
    self:getChildByName("mask"):setEnabled(false)
    self:getChildByName("pop"):setEnabled(false)
    self:getChildByName("panel_list"):jumpToTop()
    self.updateGold()
end

--获取道具折扣
function UnionShopLayer:getZheKou()
    local zk = 0
    for i=1,dd.myUnionTecs:rowCount() do
        if dd.myUnionTecs:getLong(i,"id") == 101 then
            local lv = dd.myUnionTecs:getLong(i,"level")
            if lv == 0 then
                zk = 0
            else
                local unionid = 10100 + lv
                local rowData = ff.dbmanager:sql_fetch_rows("SELECT * FROM `cfg_league_tech_levelup` WHERE `id` = "..unionid)
                zk = tonumber(rowData:getString(1,"params4")) / 1000
            end
        end
    end
    return zk
end

function UnionShopLayer:updatePointAndNumber()
    local panel_top = self:getChildByName("panel_top")
    local cash = dd.myUnion:getLong(1, "nAllyFunds")                  --基金
    local unionPoint = dd.myUnion:getLong(1, "unionpoint")            --贡献点数
    local lab_cash = panel_top:getChildByName("bar"):getChildByName("lab_cash")
    local lab_point = panel_top:getChildByName("bar"):getChildByName("lab_coin")
    lab_cash:setString(ff.getFormatMoney(cash))
    lab_point:setString(ff.getFormatMoney(unionPoint))
end

function UnionShopLayer.updateGold(...)
    local sender = pop.getDialog("unionShop")
    if sender ~= nil then
        local parent = sender:getParent()
        if parent ~= nil then
            parent:updateGold()
            sender:updatePointAndNumber()
            sender:showItems(true)
        end
    end
end

function UnionShopLayer:checkMore()
    if self:isVisible() == false then
        return
    end
    local count = self:getChildByName("panel_list"):getChildrenCount()
    local total = table.getn(self.propList[self._index])
    if count >= total then
        return
    end
    function showMore()
        self:showItems(false)
        self:showWaiting(false)
    end
    function showMove()
       self:getChildByName("panel_list"):getInnerContainer():runAction(cc.MoveBy:create(0.3,cc.p(0,20)))
    end
    self:showWaiting(true)
    self:runAction(cc.Sequence:create(cc.DelayTime:create(0.1),cc.CallFunc:create(showMore),cc.CallFunc:create(showMove)))
end

function UnionShopLayer.scrollViewEvent(sender,eventType)
    if eventType ==  ccui.ScrollviewEventType.bounceBottom then
        local prop = pop.getDialog("unionShop")
        if prop:getChildByName("waiting"):isVisible() == false then
            prop:checkMore()
        end    
    end
end

function UnionShopLayer:showWaiting(play)
    self:getChildByName("waiting"):getChildByName("icon"):getVirtualRenderer():stopAllActions()
    if play == true then
        local animation = cc.Animation:createWithSpriteFrames(self._animFrames, 0.1)
        self:getChildByName("waiting"):getChildByName("icon"):getVirtualRenderer():runAction(cc.RepeatForever:create(cc.Animate:create(animation)))
        self:getChildByName("waiting"):setVisible(true) 
    else        
        self:getChildByName("waiting"):setVisible(false)
    end
end

function UnionShopLayer.onEnd(sender)
    ff.net:removeEvent(1,dd.Tjf_union_shopAction)
    ff.net:removeEvent(2,dd.Tjf_rpc_getUnionDetail)
    ff.net:unbindProperty("gold",2607)
    
    local panel_list = sender:getChildByName("panel_list")
    if ff.platform ~= 1 then
        for i=1,table.getn(sender.propList[sender._index]) do
            local item = panel_list:getChildByTag(i)
            if item ~= nil then
                item:getChildByName("img_icon_bg"):getChildByName("img_icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
            end
        end
    end
    if ff.set_power <= 1 then
        local free = 0
        if table.getn(sender._items) >= 12 then
            for i=13,table.getn(sender._items) do
                local item = sender._items[13]
                item:release()
                table.remove(sender._items,13)
                free = free + 1
            end
        end
       -- cclog("free item:"..free)
    end

    if btns == nil then
        if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
            dd.currentLayer._widget:unSelectBtns()
        end    
    end
end

function UnionShopLayer:onNetGetUnionDetail(params)
    local code = params[1]
    if code == 0 then
        --self._detailinfo = params[2] 
        self._tecinfo = params[3]   
        self:showItems()
        --self:initDetailInfo()
        --self:getUnionMembersNum(self._unionflag)
    else
        dd.currentLayer._widget:onShowTips("\t"..dd.errorCode(code))
    end
end

function UnionShopLayer.onStart(sender)
    ff.net:registerEvent(1,dd.Tjf_union_shopAction, function (message)sender:responPropList(message) end)
    ff.net:registerEvent(2,dd.Tjf_rpc_getUnionDetail,function (message)sender:onNetGetUnionDetail(message)end)
    ff.net:bindProperty(2607,"gold",sender.updateGold)
    sender:showItems(false)
end

function UnionShopLayer:getUnionDetail()
    local message = ff.net:createMessage()
    message:addCmd(0x031)
    message:addLong(dd.uid) 
    message:addLong(dd.myUnion:getLong(1,"unionid"))   
    ff.net:rpc(message,false)
end

function UnionShopLayer.onBefore(sender)
    sender._continue = true
    sender:getUnionDetail()
    --sender:showItems(true)
    return true
end

function onShowUnionShop(widget,parent)
    local layer = UnionShopLayer.extend(widget)
    layer._parent = parent
    layer:onInit()
    return layer
end