local unionDiplomacyLayer   = class("unionDiplomacyLayer")
unionDiplomacyLayer._name = "unionDiplomacy"
unionDiplomacyLayer._init = false
unionDiplomacyLayer._parent = nil
unionDiplomacyLayer._lastID  = 0
unionDiplomacyLayer._history = nil
unionDiplomacyLayer._serach  = 9
unionDiplomacyLayer._isLast  = false
unionDiplomacyLayer._animFrames = {}
unionDiplomacyLayer.selKey = 0
unionDiplomacyLayer.selRelation = 0

function unionDiplomacyLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, unionDiplomacyLayer)
    return target
end
function unionDiplomacyLayer:onAutoSize()
    if self._parent._name == "union" then
        local hh = self._parent:getContentSize().height
        self:setContentSize(cc.size(720,hh - 190))
        self:getChildByName("back"):setContentSize(cc.size(720,hh - 190))
        self:getChildByName("top"):setPositionY(hh - 190 - 108 )
        self:getChildByName("lists"):setContentSize(cc.size(690,hh - 190 - 111 ))
        self:getChildByName("lists"):setInnerContainerSize(cc.size(690,hh - 190 - 111 ))
        self:getChildByName("lists"):setPositionY(0)
        self:getChildByName("waiting"):setPositionY(0)
    end
end
function unionDiplomacyLayer:onInit()
    if self._init == false then
        self._history = ff.NetTable:create()
        self._history:addStreamCol("rank",ff.NET_LONG)
        self._history:addStreamCol("unionid",ff.NET_LONG)
        self._history:addStreamCol("short",ff.NET_STRING,3)
        self._history:addStreamCol("name",ff.NET_STRING,32)
        self._history:addStreamCol("totem",ff.NET_LONG)
        self._history:addStreamCol("power",ff.NET_SUPER_LONG)
        self._history:addStreamCol("rels",ff.NET_LONG)
        self._history:addStreamCol("members",ff.NET_LONG)
        self._history:addStreamCol("memberMax",ff.NET_LONG)
        self._history:addStreamCol("applying",ff.NET_LONG)
        self._history:addStreamCol("inviting",ff.NET_LONG)
     
        self:getChildByName("lists"):addScrollViewEventListener(self.scrollViewEvent)
    end
end
function unionDiplomacyLayer:initState()
    self:getChildByName("top"):getChildByName("all_check"):setSelectedState(self._serach  == 9)
    self:getChildByName("top"):getChildByName("all_check"):setTouchEnabled(self._serach  ~= 9)
    self:getChildByName("top"):getChildByName("friend_check"):setSelectedState(self._serach == 3)
    self:getChildByName("top"):getChildByName("friend_check"):setTouchEnabled(self._serach  ~= 3)
    self:getChildByName("top"):getChildByName("normal_check"):setSelectedState(self._serach == 0)
    self:getChildByName("top"):getChildByName("normal_check"):setTouchEnabled(self._serach  ~= 0)
    self:getChildByName("top"):getChildByName("enemy_check"):setSelectedState(self._serach == 4)
    self:getChildByName("top"):getChildByName("enemy_check"):setTouchEnabled(self._serach  ~= 4)
end
function unionDiplomacyLayer.updateRelation(params)
    local widget = pop.getDialog("unionDiplomacy")
    if widget == nil then
        return
    end
    local code = params[1]

    if code == 0 then
        if widget._history:getLong(widget.selKey,"unionid") == params[2] then
            widget._history:setLong(widget.selKey,"rels",params[3])
            widget:getChildByName("lists"):getChildByTag(widget.selKey):getChildByName("item"):getChildByName("dip_icon"):loadTexture("images/icon/rels/ic"..widget._history:getLong(widget.selKey,"rels").."_union.png",0)
            local relation = widget._history:getLong(widget.selKey,"rels")
            if relation == 3 or relation == 4 or relation == 0 then
                widget:getChildByName("lists"):getChildByTag(widget.selKey):getChildByName("item"):getChildByName("dip_icon"):loadTexture("images/icon/rels/ic"..relation.."_union.png",0)
            else
                widget:getChildByName("lists"):getChildByTag(widget.selKey):getChildByName("item"):getChildByName("dip_icon"):loadTexture("images/icon/rels/ic0_union.png",0)
            end
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("更改外交状态成功"),true)
            local apply = widget:getChildByName("pop")
            if apply:isVisible() == true and apply:getPositionY() == 0 then
                pop.onCloseEffect(99,apply)   
                widget:getChildByName("mask"):setVisible(false)
                widget.selKey = 0        
            end
        end
    else
        dd.mainUI:onShowCodeTips(code)
    end
end
function unionDiplomacyLayer:updatePop()
    if self.selKey <= 0 then
        return
    end
    local relation = self:getChildByName("pop")
    relation:getChildByName("union_mark"):loadTexture(dd.getUnionIcon(self._history:getLong(self.selKey,"totem")),0)  
    relation:getChildByName("short_text"):setString("["..self._history:getString(self.selKey,"short").."]")
    relation:getChildByName("name_text"):setString(self._history:getString(self.selKey,"name"))
    
    relation:getChildByName("friend"):setSelectedState(false)
    relation:getChildByName("zl"):setSelectedState(false)
    relation:getChildByName("enemy"):setSelectedState(false)
    if self._history:getLong(self.selKey,"rels") == 3 then
        relation:getChildByName("friend"):setSelectedState(true)
    elseif self._history:getLong(self.selKey,"rels") == 4 then
        relation:getChildByName("enemy"):setSelectedState(true)
    else
        relation:getChildByName("zl"):setSelectedState(true)
    end
    relation:requestDoLayout()
end
function unionDiplomacyLayer:initPop()
    local function closePop(sender,eventType)
        if eventType==ccui.TouchEventType.ended then    
            local apply = self:getChildByName("pop")
            if apply:isVisible() == true and apply:getPositionY() == 0 then
                pop.onCloseEffect(99,apply)   
                self:getChildByName("mask"):setVisible(false)
                self.selKey = 0         
            end
        end

    end
    self:getChildByName("pop"):getChildByName("closeBtn"):addTouchEventListener(closePop)
    
    local function setRelation(sender,eventType)
        if eventType==ccui.TouchEventType.ended then 
            local name = sender:getName()
            if name == "friend" then
                self.selRelation = 3
            elseif name == "enemy" then
                self.selRelation = 4
            elseif name == "zl" then
                self.selRelation = 0
            end
            self:getChildByName("pop"):getChildByName("friend"):setSelectedState(false)
            self:getChildByName("pop"):getChildByName("zl"):setSelectedState(false)
            self:getChildByName("pop"):getChildByName("enemy"):setSelectedState(false)
             
        end
    end
    local function saveSet(sender,eventType)
        if eventType==ccui.TouchEventType.ended then    
            
            local message = ff.net:createMessage()
            message:addCmd(0x13e)
            message:addLong(dd.uid)
            message:addLong(self._history:getLong(self.selKey,"unionid"))
            message:addLong(self.selRelation)
            ff.net:rpc(message,false)
        end
    end
    
    self:getChildByName("pop"):getChildByName("friend"):addTouchEventListener(setRelation)
    self:getChildByName("pop"):getChildByName("zl"):addTouchEventListener(setRelation)
    self:getChildByName("pop"):getChildByName("enemy"):addTouchEventListener(setRelation)
    self:getChildByName("pop"):getChildByName("saveBtn"):addTouchEventListener(saveSet)
end

function unionDiplomacyLayer:initTop()
    local function showRelation(sender,eventType)
        if eventType==ccui.TouchEventType.ended then    
            local name = sender:getName()
            local relation = 0
            if name == "all_check" or name == "chu_label" then
                relation = 9
            elseif name == "friend_check" then
                relation = 3
            elseif name == "normal_check" then
                relation = 0
            elseif name == "enemy_check" then
                relation = 4
            end
            if relation == self._serach then
                return
            end
            self._serach = relation
            self._lastID = 0
            self._isLast  = false
            self._history:delRows()
            self:getChildByName("lists"):removeAllItems()
            self:getChildByName("lists"):setInnerContainerSize(cc.size(690,self._parent:getContentSize().height - 190 - 116 ))
            self:getChildByName("lists"):scrollToTop(0.01,false)
            if name == "chu_label" then
                self:setCheckState("all_check")
                self:getChildByName("top"):getChildByName("all_check"):setSelectedState(true)
            else
                self:setCheckState(name)
            end
            self:checkUpdate()
        end
    
    end
    self:getChildByName("top"):getChildByName("all_check"):addTouchEventListener(showRelation)
    self:getChildByName("top"):getChildByName("all_check"):getChildByName("chu_label"):addTouchEventListener(showRelation)
    self:getChildByName("top"):getChildByName("friend_check"):addTouchEventListener(showRelation)
    self:getChildByName("top"):getChildByName("normal_check"):addTouchEventListener(showRelation)
    self:getChildByName("top"):getChildByName("enemy_check"):addTouchEventListener(showRelation)
end
function unionDiplomacyLayer:setCheckState(name)
    self:getChildByName("top"):getChildByName("all_check"):setTouchEnabled(true)
    self:getChildByName("top"):getChildByName("all_check"):setSelectedState(false)        
    self:getChildByName("top"):getChildByName("friend_check"):setTouchEnabled(true)
    self:getChildByName("top"):getChildByName("friend_check"):setSelectedState(false)
    self:getChildByName("top"):getChildByName("normal_check"):setTouchEnabled(true)
    self:getChildByName("top"):getChildByName("normal_check"):setSelectedState(false)
    self:getChildByName("top"):getChildByName("enemy_check"):setTouchEnabled(true)
    self:getChildByName("top"):getChildByName("enemy_check"):setSelectedState(false)
    
    self:getChildByName("top"):getChildByName(name):setTouchEnabled(false)
end
function unionDiplomacyLayer.onUpdate(params)
    local widget = pop.getDialog("unionDiplomacy")
    local code = params[1]
    widget:showWaiting(false)
    if code == 0 then
        if params[3] == 1 then
            widget._isLast = true
        else
            widget._isLast = false
        end
        local datas = params[5]
        if widget._serach == params[4] and datas ~= nil then
            for i=1,datas:rowCount() do
                local row = datas:getLong(i,"rank")
                if widget._history:rowCount() < row then
                    row = widget._history:addRow()
                end
                widget._history:setLong(row,"rank",datas:getLong(i,"rank"))
                widget._history:setLong(row,"unionid",datas:getLong(i,"unionid"))
                widget._history:setString(row,"short",datas:getString(i,"short"))
                widget._history:setString(row,"name",datas:getString(i,"name"))
                widget._history:setLong(row,"totem",datas:getLong(i,"totem"))
                widget._history:setLong(row,"rels",datas:getLong(i,"rels"))
                widget._history:setSuperLong(row,"power",datas:getSuperLong(i,"power"))                
                widget._history:setLong(row,"members",datas:getLong(i,"members"))
                widget._history:setLong(row,"memberMax",datas:getLong(i,"memberMax"))
                widget._history:setLong(row,"applying",datas:getLong(i,"applying"))
                widget._history:setLong(row,"inviting",datas:getLong(i,"inviting"))
            end
        end
        if datas ~= nil then
            widget:updatePage()
--            datas:clear()
--            datas = nil
        else
            dd.currentLayer._widget:onShowTips("\t"..ff.langString("没有此外交关系的联盟"))
        end    
    else
        dd.mainUI:onShowCodeTips(code)
    end
end
function unionDiplomacyLayer:showWaiting(play)
    self:getChildByName("waiting"):getChildByTag(1):stopAllActions()
    if play == true then
        local animation = cc.Animation:createWithSpriteFrames(self._animFrames, 0.1)
        self:getChildByName("waiting"):getChildByTag(1):runAction(cc.RepeatForever:create(cc.Animate:create(animation)))
        self:getChildByName("waiting"):setVisible(true) 
    else        
        self:getChildByName("waiting"):setVisible(false)
    end
end
function unionDiplomacyLayer.onStart(sender)
    if sender._init == false then
        --先添加10条
        for i=1,10 do
            local item = sender:getChildByName("item"):clone()
            item:setTag(i)
            sender:getChildByName("lists"):addChild(item)
        end
        sender:getChildByName("lists"):refreshView()

        local cache = cc.SpriteFrameCache:getInstance()
        cache:addSpriteFrames("images/mv/normaleffect.plist")

        local mv = cc.Sprite:createWithSpriteFrameName("of_native_loader_progress_01.png")
        local xx = sender:getChildByName("waiting"):getChildByName("label"):getPositionX()
        mv:setContentSize(cc.size(30,30))
        mv:setPosition(cc.p(xx - 30,15))
        mv:setScale(0.4)

        sender:getChildByName("waiting"):addChild(mv,1,1)
        for j = 1, 12 do
            local frame = nil
            if j < 10 then
                frame = cache:getSpriteFrame("of_native_loader_progress_0"..j..".png")
            else    
                frame = cache:getSpriteFrame("of_native_loader_progress_"..j..".png")
            end 
            sender._animFrames[j] = frame
        end
        sender:initPop()
        sender:initTop()
        sender._init = true
    end
    sender:getChildByName("lists"):refreshView()
    ff.net:registerEvent(1,dd.Tjf_union_GetRankAlly,sender.onUpdate)
    ff.net:registerEvent(1,dd.Tjf_union_SetAllyRelationship,sender.updateRelation)
    sender._isLast = false
    sender._lastID = 0
    sender:initState()
    sender.onShow()
end
function unionDiplomacyLayer:checkUpdate()
    if self._isLast == false then
        self:showWaiting(true)
        local message = ff.net:createMessage()
        message:addCmd(0x30)
        message:addLong(dd.uid)
        message:addLong(0)
        message:addLong(0)
        message:addString("",15)
        message:addLong(self._lastID)
        cclog("_lastID:"..self._lastID)
        cclog("_serach:"..self._serach)
        message:addLong(self._serach)
        message:addLong(0)
        ff.net:postMessage(message)
    end    
end
function unionDiplomacyLayer.onEnd(sender)
    sender._show = false
    ff.net:removeEvent(1,dd.Tjf_union_GetRankAlly)
    ff.net:removeEvent(1,dd.Tjf_union_SetAllyRelationship)
    
    for i=1,sender._history:rowCount() do
        local item = sender:getChildByName("lists"):getChildByTag(i)
        if item ~= nil then
            if ff.platform ~= 1 then
                item:getChildByName("item"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
            end
            item:setVisible(false)
            if i > 10 then
                sender:getChildByName("lists"):removeChild(item,true)
            end        
        end
    end
    sender._history:delRows()
    sender:getChildByName("lists"):scrollToTop(0.01,false)
    if sender._parent ~= nil then
        sender._parent = nil
    end
    sender._lastID  = 0
    sender._serach  = 9
    sender._isLast  = false
    sender.selKey = 0   
    sender.selRelation = 0
end
function unionDiplomacyLayer:updatePage()
    local nextpage = false
    local tick = 1
    cclog(".................")
    local function showUnionInfo(sender,eventType)
        local doaction = false
        if eventType == ccui.TouchEventType.canceled then
            local startp = sender:getTouchBeganPosition()
            local endp   = sender:getTouchEndPosition()
            if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                doaction = true
            end
        end
        if eventType == ccui.TouchEventType.ended then
            doaction = true
        end
        if doaction == true then     
            --弹出联盟关系设置
            local key = sender:getTag()
            if dd.myUnion:getLong(1,"unionid") == self._history:getLong(key,'unionid') then
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("自己的联盟无需设置外交！"))
                return
            end
            
            if dd.myUnion:getLong(1,"unionofficial") < 5 then
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("您没有足够的联盟权限设置外交关系！"))
                return
            end
            local relation = self:getChildByName("pop")
            relation:stopAllActions()                      
            pop.showPopEffect(99,relation)  
            self:getChildByName("mask"):setVisible(true)
            self.selKey = key
            self:updatePop()
            AudioEngine.playEffect(ff.sounds[109])
        end
    end
    local num = 0
    local beforey = self:getChildByName("lists"):getInnerContainer():getPositionY()
    for i=1,self._history:rowCount() do
        local rank = self._history:getLong(i,"rank")
        if rank > self._lastID then
            self._lastID = rank
            local item = self:getChildByName("lists"):getChildByTag(i)
            if item == nil then
                item = self:getChildByName("item"):clone()
                item:setTag(i)
                self:getChildByName("lists"):addChild(item)
            end    
            item:getChildByName("item"):getChildByName("icon"):loadTexture(dd.getUnionIcon(self._history:getLong(i,"totem")),0) 
        
            item:getChildByName("item"):getChildByName("chu_short"):setString("["..self._history:getString(i,"short").."]")
       
            item:getChildByName("item"):getChildByName("name"):setString(self._history:getString(i,"name"))
            item:getChildByName("item"):getChildByName("power"):setString(ff.getFormatMoney(self._history:getSuperLong(i,"power")))
            if self._history:getLong(i,"rels") == 3 or self._history:getLong(i,"rels") == 4 or self._history:getLong(i,"rels") == 0 then
                item:getChildByName("item"):getChildByName("dip_icon"):loadTexture("images/icon/rels/ic"..self._history:getLong(i,"rels").."_union.png",0)
            else
                item:getChildByName("item"):getChildByName("dip_icon"):loadTexture("images/icon/rels/ic0_union.png",0)
            end
            if self._serach == 9 then
                num = rank
            elseif self._serach == 4 or self._serach == 3 or self._serach == 0 then
                num = i
            end
            if self._history:rowCount() <= 10 then
                item:setVisible(true)
            else    
                item:setVisible(true)
                nextpage = true
            end
            item:addTouchEventListener(showUnionInfo)
        end    
    end    
    self:getChildByName("lists"):setVisible(true)
    if nextpage == true then
        self:getChildByName("lists"):getInnerContainer():setPositionY(beforey)
        if self._history:rowCount() > 0 then
            self:getChildByName("lists"):getInnerContainer():runAction(cc.MoveBy:create(0.3,cc.p(0,20)))
        end
    end 
    self:getChildByName("lists"):refreshView()
    if self._history:rowCount() <= 0 then
        dd.currentLayer._widget:onShowTips("\t"..ff.langString("没有此外交关系的联盟"))
    end 
end

function unionDiplomacyLayer:getRankIcon(rank)
    if rank <= 3 then
        return "images/icon/rank/no"..rank..".png"
    elseif rank <= 10 then
        return "images/icon/rank/tag01_union.png"
    elseif rank <= 100 then
        return "images/icon/rank/tag02_union.png"
    elseif rank <= 999 then
        return "images/icon/rank/tag03_union.png"
    end
end
function unionDiplomacyLayer.scrollViewEvent(sender, evenType)
    if evenType == ccui.ScrollviewEventType.bounceBottom then
        local rank = pop.getDialog("unionDiplomacy")
        if rank:getChildByName("waiting"):isVisible() == false and rank:isVisible() == true then
            rank:checkUpdate()
        end    
    elseif evenType ==  ccui.ScrollviewEventType.scrollToTop then
    end
end
function unionDiplomacyLayer.onShow()
    local widget = pop.getDialog("unionDiplomacy")
    widget:checkUpdate()
end
function unionDiplomacyLayer.onBefore(sender)
    return false
end
function unionDiplomacyLayer:onClose()
    return false
end
function onShowUnionDiplomacy(widget,parent)
    local layer = unionDiplomacyLayer.extend(widget)
    if layer._parent ~= parent then
        layer._parent = parent
        layer:onAutoSize()
    end    
    layer:onInit()
    return layer
end