--联盟信息
local unionHistoryLayer = class("unionHistoryLayer")
unionHistoryLayer._name = "unionHistory"
unionHistoryLayer._init = false
unionHistoryLayer.historyList = {}
unionHistoryLayer.lastID = 0
unionHistoryLayer.lastTime = 0
unionHistoryLayer._animFrames = {}


function unionHistoryLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, unionHistoryLayer)
    return target
end

function unionHistoryLayer:onInit()
    if self._init == false then
        local hh = ff.height       
        self:setContentSize(cc.size(720,hh))
        self:getChildByName("mainArea"):setContentSize(cc.size(720,hh - 110))
        self:getChildByName("waiting"):setPositionY(10)

        self:getChildByName("mainArea"):addScrollViewEventListener(self.scrollViewEvent)
        self:getChildByName("topArea"):getChildByName("return"):addTouchEventListener(self.onReturn)
        self:getChildByName("topArea"):getChildByName("gold_btn"):addTouchEventListener(dd.onPay)
    end
    self:addRegisterEvent()
    self.updateGold()    
end
function unionHistoryLayer.updateGold(name,row,old,value)
    local sender = pop.getDialog("unionHistory")
    if sender ~= nil then
        sender:getChildByName("topArea"):getChildByName("gold_text"):setString(dd.myinfo:getLong(1,"gold"))
        local w = sender:getChildByName("topArea"):getChildByName("gold_text"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        sender:getChildByName("topArea"):getChildByName("title"):setContentSize(cc.size(w,100))
        sender:getChildByName("topArea"):getChildByName("title"):requestDoLayout()
        sender:getChildByName("topArea"):requestDoLayout()
    end
end
function unionHistoryLayer:checkUpdate()
    self:showWaiting(true)
    local message = ff.net:createMessage()
    message:addCmd(0x2c)
    message:addLong(dd.uid)
    message:addLong(self.lastID)
    cclog("lastID:"..self.lastID)
    ff.net:rpc(message,false)
end
function unionHistoryLayer.scrollViewEvent(sender, evenType)
    if evenType == ccui.ScrollviewEventType.bounceBottom then
        local rank = pop.getDialog("unionHistory")
        if rank:getChildByName("waiting"):isVisible() == false then
            rank:checkUpdate()
        end    
    elseif evenType ==  ccui.ScrollviewEventType.scrollToTop then
    end
end
function unionHistoryLayer:getHistoryData()
    local message = ff.net:createMessage()
    message:addCmd(0x2c)
    message:addLong(dd.uid)
    message:addLong(self.lastID)
    cclog("lastID:"..self.lastID)
    ff.net:rpc(message,false)
end

function unionHistoryLayer:backGetAllyEvents(ret)
    if ret[1] == 0 then
        if ret[2]:rowCount() == 0 then
            self:showWaiting(false)
        else
            local temp = {}
            for var=1, ret[2]:rowCount() do
                local key = table.getn(temp) + 1
                temp[key] = {}
                temp[key]["id"] = ret[2]:getLong(var,'id')
                temp[key]["time"] = ret[2]:getLong(var,'id')
                temp[key]["index"] = ret[2]:getLong(var,'index')
                temp[key]["content"] = ret[2]:getString(var,'content')            
            end
            local function sortFun(d1, d2)
                local ret = dd.biger(d1["time"], d2["time"])
                if ret == 0 then         
                    ret = true
                end
                return ret
            end
            table.sort(temp,sortFun)            
            for var=1, table.getn(temp) do
                local key = table.getn(self.historyList) + 1
                self.historyList[key] = {}
                self.historyList[key]["id"] = temp[var]["id"]
                self.historyList[key]["time"] = temp[var]["time"]
                self.historyList[key]["index"] = temp[var]["index"]
                self.historyList[key]["content"] = temp[var]["content"]
            end
            self:updatePage()
        end
    else
        if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
            dd.currentLayer._widget:onShowTips("\t"..dd.errorCode(ret[1]))
        end 
    end
end
function unionHistoryLayer:updatePage()
    self:showWaiting(false)
    local nextpage = false
    local tick = 1
    local beforey = self:getChildByName("mainArea"):getInnerContainer():getPositionY()
    local len = table.getn(self.historyList)
    self.lastTime = self.historyList[len]['time']
    self.lastID = self.historyList[len]['id']
    for i=1,table.getn(self.historyList) do
        local time = self.historyList[i]['time']
        local item = self:getChildByName("mainArea"):getChildByTag(i)
        if item == nil then
            item = self:getChildByName("infoItem"):clone()
            item:setTag(i)
            self:getChildByName("mainArea"):addChild(item)
        end
        local strArr = Split(self.historyList[i]['content'],',')
        item:getChildByName("chu_his_text"):setString(ff.langString(notify[self.historyList[i]['index']],strArr))  
        if table.getn(self.historyList) <= 10 then
            item:setVisible(true)
        else    
            item:setVisible(true)
            nextpage = true
        end   
    end    
    if nextpage == true then
        self:getChildByName("mainArea"):getInnerContainer():setPositionY(beforey)
        self:getChildByName("mainArea"):refreshView()
        if table.getn(self.historyList) > 0 then
            self:getChildByName("mainArea"):getInnerContainer():runAction(cc.MoveBy:create(0.3,cc.p(0,10)))
        end
    end  
end

function unionHistoryLayer:showWaiting(play)
    self:getChildByName("waiting"):getChildByTag(1):stopAllActions()
    if play == true then
        local animation = cc.Animation:createWithSpriteFrames(self._animFrames, 0.1)
        self:getChildByName("waiting"):getChildByTag(1):runAction(cc.RepeatForever:create(cc.Animate:create(animation)))
        self:getChildByName("waiting"):setVisible(true) 
    else        
        self:getChildByName("waiting"):setVisible(false)
    end
end
function unionHistoryLayer:addRegisterEvent()
    ff.net:registerEvent(1,dd.Tjf_union_GetAllyEvents, function (message)self:backGetAllyEvents(message)end)
    ff.net:bindProperty(2406,"gold",function ()self.updateGold() end) 
end

function unionHistoryLayer.onEnd(sender)
    dd.delBackEvent()
    ff.net:removeEvent(1,dd.Tjf_union_GetAllyHelpLists)
    ff.net:unbindProperty("gold",2406)
    sender.lastID = 0
    for var=1,table.getn(sender.historyList) do
        local item = sender:getChildByName("mainArea"):getChildByTag(var)
        if item ~= nil then
            item:setVisible(false)
            if var > 10 then
                sender:getChildByName("mainArea"):removeChild(item,true)
            end        
        end
    end

end

function unionHistoryLayer.onStart(sender)
    if sender._init == false then
        --先添加10条
        for i=1,10 do
            local item = sender:getChildByName("infoItem"):clone()
            item:setTag(i)
            sender:getChildByName("mainArea"):addChild(item)
        end
        sender:getChildByName("mainArea"):refreshView()

        local cache = cc.SpriteFrameCache:getInstance()
        cache:addSpriteFrames("images/mv/normaleffect.plist")

        local mv = cc.Sprite:createWithSpriteFrameName("of_native_loader_progress_01.png")
        local xx = sender:getChildByName("waiting"):getChildByName("chu_label"):getPositionX()
        mv:setContentSize(cc.size(30,30))
        mv:setPosition(cc.p(xx - 30,15))
        mv:setScale(0.4)

        sender:getChildByName("waiting"):addChild(mv,1,1)
        for j = 1, 12 do
            local frame = nil
            if j < 10 then
                frame = cache:getSpriteFrame("of_native_loader_progress_0"..j..".png")
            else    
                frame = cache:getSpriteFrame("of_native_loader_progress_"..j..".png")
            end 
            sender._animFrames[j] = frame
        end
        sender._init = true
    end
    sender.historyList = {}
    sender:getChildByName("mainArea"):refreshView()
    sender.onShow()
end

function unionHistoryLayer.onShow()
    local widget = pop.getDialog("unionHistory")
    widget:getHistoryData()
end
--界面即将播放
function unionHistoryLayer.onBefore(sender)
    dd.initGoldSpine(sender:getChildByName("topArea"):getChildByName("icon"),sender:getChildByName("topArea"):getChildByName("gold_btn")) 

    return true
end
function unionHistoryLayer:onClose()
    return false
end
function unionHistoryLayer.onReturn(sender,eventType)
    local close = false
    if sender == nil then
        close = true
    end
    if eventType==ccui.TouchEventType.ended then     
        close = true
    end
    if close == true then
        local widget = pop.getDialog("unionHistory")
        if widget~=nil and widget:onClose() == false then
            pop.onClosePopDialog("unionHistory")
        end    
    end
end
function onShowUnionHistory(widget)
    local layer = unionHistoryLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)
    layer:onInit()
    return layer
end
