--联盟信息
local unionInfoLayer = class("unionInfo")
unionInfoLayer._name = "unionInfo"
unionInfoLayer._init = false
unionInfoLayer._parent = nil
unionInfoLayer._unionid  = 0
unionInfoLayer._unionflag = nil
unionInfoLayer._lv  = 0
unionInfoLayer._baseinfo = nil
unionInfoLayer._detailinfo = nil   --详细信息
unionInfoLayer._tecinfo = nil      --科技信息
unionInfoLayer._ulederid = 0
unionInfoLayer._uledername = 0

unionInfoLayer._state  = {0,0,0,0,0,0}
unionInfoLayer._members= {}

function unionInfoLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, unionInfoLayer)
    return target
end

function unionInfoLayer:onAutoSize()
    if self._init == false then
        local hh = ff.height 
        self:setContentSize(cc.size(720,hh))
        self:getChildByName("topArea"):setPositionY(hh - 105)
        self:getChildByName("bg"):setContentSize(cc.size(720,hh))
        self:getChildByName("bg"):setPositionY(0)
        self:getChildByName("masking"):setContentSize(cc.size(720,hh-105))
        self:getChildByName("masking"):setPositionY(0)
        
        self:getChildByName("union_info"):setContentSize(cc.size(720,hh-105))
        self:getChildByName("union_info"):setPositionY(0)        
        --位置设置
        self:getChildByName("union_info"):getChildByName("info"):setPositionY(hh - 105 - 273)
        self:getChildByName("union_info"):getChildByName("notice"):setPositionY(hh - 105 - 273 - 176)
        self:getChildByName("union_info"):getChildByName("btns"):setPositionY(hh - 105 - 273 - 176 - 88)
        
        self:getChildByName("union_info"):getChildByName("member"):getChildByName("lists"):setContentSize(cc.size(720,hh-105-543))
        self:getChildByName("union_info"):getChildByName("member"):getChildByName("lists"):setPositionY(0)  
    end
end

function unionInfoLayer:onInit()
    if self._init == false then
        --mail
        local function onMail(sender, touchEventType)
            if touchEventType == ccui.TouchEventType.ended then 
                pop.onShowPopDialog("mailWrite",true,self._ulederid,self._uledername,'','ch',dd.uid,0,0)
            end
        end
        --message
        local function onMessage(sender, touchEventType)
            if touchEventType == ccui.TouchEventType.ended then 
                if dd.myUnion:getLong(1,"unionid") <= 0 then
                    dd.currentLayer._widget:onShowTips("\t"..ff.langString("您的联盟权限不足"))
                else
                    if dd.myUnion:getLong(1,"unionid") == self._baseinfo._unionid then
                        pop.onShowPopDialog("unionMessage", self._baseinfo._unionid)
                    else
                        if dd.myUnion:getLong(1,"unionofficial") < 4 then
                            dd.currentLayer._widget:onShowTips("\t"..ff.langString("您的联盟权限不足"))
                        else
                            pop.onShowPopDialog("unionMessage", self._baseinfo._unionid)
                        end
                    end
                end
            end
        end
        --join
        local function onJoin(sender, touchEventType)
            if touchEventType == ccui.TouchEventType.ended then 
                local message = ff.net:createMessage()
                message:addCmd(0x122)
                message:addLong(dd.uid)
                message:addLong(1) 
                message:addLong(self._baseinfo._unionid)
                ff.net:rpc(message,false)
            end
        end
        self:getChildByName("topArea"):getChildByName("backbtn"):addTouchEventListener(self.onBack)
        self:getChildByName("topArea"):getChildByName("addbtn"):addTouchEventListener(dd.onPay)
        
        self:getChildByName("union_info"):getChildByName("btns"):getChildByName("mail_btn"):addTouchEventListener(onMail)
        self:getChildByName("union_info"):getChildByName("btns"):getChildByName("msg_btn"):addTouchEventListener(onMessage)
        self:getChildByName("union_info"):getChildByName("btns"):getChildByName("adv_btn"):addTouchEventListener(onJoin)
        
        local lists = self:getChildByName("union_info"):getChildByName("member"):getChildByName("lists")
        lists:getChildByName("rank6"):getChildByName("title"):getChildByName("show"):addTouchEventListener(self.selectGroup)
        lists:getChildByName("rank5"):getChildByName("title"):getChildByName("show"):addTouchEventListener(self.selectGroup)
        lists:getChildByName("rank4"):getChildByName("title"):getChildByName("show"):addTouchEventListener(self.selectGroup)
        lists:getChildByName("rank3"):getChildByName("title"):getChildByName("show"):addTouchEventListener(self.selectGroup)
        lists:getChildByName("rank2"):getChildByName("title"):getChildByName("show"):addTouchEventListener(self.selectGroup)
        lists:getChildByName("rank1"):getChildByName("title"):getChildByName("show"):addTouchEventListener(self.selectGroup)
        
        lists:getChildByName("rank6"):getChildByName("title"):addTouchEventListener(self.selectGroup2)
        lists:getChildByName("rank5"):getChildByName("title"):addTouchEventListener(self.selectGroup2)
        lists:getChildByName("rank4"):getChildByName("title"):addTouchEventListener(self.selectGroup2)
        lists:getChildByName("rank3"):getChildByName("title"):addTouchEventListener(self.selectGroup2)
        lists:getChildByName("rank2"):getChildByName("title"):addTouchEventListener(self.selectGroup2)
        lists:getChildByName("rank1"):getChildByName("title"):addTouchEventListener(self.selectGroup2)
        
        self:getChildByName("topArea"):getChildByName("title"):getChildByName("chu_title"):getVirtualRenderer():enableOutline(cc.c4b(0,0,0,255),3)
        --加粗
    end    
    self._state = {0,0,0,0,0,0}
    self:addRegisterEvent()
    self:onInitMemberLister()
    self:updateJoinLight()
    self.updateGold()
    self._members = {}
end

function unionInfoLayer:onInitMemberLister()
    local lists = self:getChildByName("union_info"):getChildByName("member"):getChildByName("lists")
    --rank6
    local leader = lists:getChildByName("rank6"):getChildByName("leader")
    leader:getChildByName("icon"):addTouchEventListener(self.onShowPower2)
    --rank5
    local rank5 = lists:getChildByName("rank5")
    rank5:getChildByName("lists"):getChildByName("item1"):getChildByName("icon"):addTouchEventListener(self.onShowPower2)
    rank5:getChildByName("lists"):getChildByName("item2"):getChildByName("icon"):addTouchEventListener(self.onShowPower2)
    
end

function unionInfoLayer.updateGold()
    local widget = pop.getDialog("unionInfo")
    widget:getChildByName("topArea"):getChildByName("money"):setString(dd.gold())
    widget:getChildByName("topArea"):requestDoLayout()

    local w = widget:getChildByName("topArea"):getChildByName("money"):getContentSize().width
    w = 720 - (w + 94 + 75 + 104)
    widget:getChildByName("topArea"):getChildByName("title"):setContentSize(cc.size(w,100))
    widget:getChildByName("topArea"):getChildByName("title"):requestDoLayout()
end

function unionInfoLayer:resetRank()
    local lists = self:getChildByName("union_info"):getChildByName("member"):getChildByName("lists")
    lists:getChildByName("rank6"):getChildByName("title"):getChildByName("show"):setFlippedY(true)
    lists:getChildByName("rank5"):getChildByName("title"):getChildByName("show"):setFlippedY(false)
    lists:getChildByName("rank4"):getChildByName("title"):getChildByName("show"):setFlippedY(false)
    lists:getChildByName("rank3"):getChildByName("title"):getChildByName("show"):setFlippedY(false)
    lists:getChildByName("rank2"):getChildByName("title"):getChildByName("show"):setFlippedY(false)
    lists:getChildByName("rank1"):getChildByName("title"):getChildByName("show"):setFlippedY(false)
    
    lists:getChildByName("rank6"):setContentSize(cc.size(720,277))
    lists:getChildByName("rank6"):getChildByName("leader"):setVisible(true)

    lists:getChildByName("rank5"):getChildByName("lists"):setVisible(false)
    lists:getChildByName("rank5"):setContentSize(cc.size(720,77))
    lists:getChildByName("rank4"):getChildByName("lists"):setVisible(false)
    lists:getChildByName("rank4"):setContentSize(cc.size(720,77))
    lists:getChildByName("rank3"):getChildByName("lists"):setVisible(false)
    lists:getChildByName("rank3"):setContentSize(cc.size(720,77))
    lists:getChildByName("rank2"):getChildByName("lists"):setVisible(false)
    lists:getChildByName("rank2"):setContentSize(cc.size(720,77))
    lists:getChildByName("rank1"):getChildByName("lists"):setVisible(false)
    lists:getChildByName("rank1"):setContentSize(cc.size(720,77))
    lists:requestRefreshView()
end

function unionInfoLayer:onInitBaseInfo()
    local info = self:getChildByName("union_info"):getChildByName("info")
    info:getChildByName("short"):setString("["..self._unionflag.."]")
    info:getChildByName("name"):setString(self._baseinfo._name)
    info:getChildByName("rank"):setString(self._baseinfo._rank)
    --info:getChildByName("power"):setString(ff.getFormatMoney("0"))
    --info:getChildByName("funds"):setString(ff.getFormatMoney(0))
    info:getChildByName("member"):setString(self._baseinfo._curmember.."/"..self._baseinfo._memberMax)
    info:getChildByName("leader"):setString(self._baseinfo._ledername)
    info:getChildByName("icon"):loadTexture(dd.getUnionIcon(self._baseinfo._totem),0)
    info:requestDoLayout()
    local bbs = self._baseinfo._bbs
    if string.len(bbs) <= 0 then
        bbs = ff.langString("尚未设置联盟公告")
    end    
    self:getChildByName("union_info"):getChildByName("notice"):getChildByName("move"):getChildByName("label"):setString(bbs)
    --self:startNoticeMove()
end

function unionInfoLayer:initDetailInfo()
    self:getChildByName("union_info"):getChildByName("info"):getChildByName("power"):setString(ff.getFormatMoney(self._detailinfo._power))
end

function unionInfoLayer:startNoticeMove()
    local mov = self:getChildByName("union_info"):getChildByName("notice"):getChildByName("move"):getChildByName("label")
    mov:stopAllActions()

    local function again(sender)
        if sender:getContentSize().width >= 500 then
            sender:setPositionX(600)
            local tick = math.ceil(sender:getContentSize().width/600) * 10
            sender:runAction(cc.Sequence:create(cc.DelayTime:create(2),cc.MoveTo:create(tick,cc.p(-sender:getContentSize().width,15)),cc.CallFunc:create(again)))
        end
    end

    if mov:getContentSize().width >= 500 then
        mov:setPositionX(0)
        local tick = math.ceil(mov:getContentSize().width/600) * 10
        mov:runAction(cc.Sequence:create(cc.DelayTime:create(2),cc.MoveTo:create(tick,cc.p(-mov:getContentSize().width,15)),cc.CallFunc:create(again)))
    else
        mov:setPositionX(0)
    end
end

function unionInfoLayer:onInitLists()
    local list = self:getChildByName("union_info"):getChildByName("member"):getChildByName("lists")
end

function unionInfoLayer.selectGroup(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    
    if eventType==ccui.TouchEventType.ended then    
        doaction = true
    end
    if doaction == true then
        local widget = pop.getDialog("unionInfo")
        if widget ~= nil then
            widget:onShowRank(sender:getTag(),sender)
        end 
    end
end
function unionInfoLayer.selectGroup2(sender,eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
end
    
    if eventType==ccui.TouchEventType.ended then    
        doaction = true
    end
    if doaction == true then
        local widget = pop.getDialog("unionInfo")
        if widget ~= nil then
            widget:onShowRank(sender:getChildByName("show"):getTag(),sender:getChildByName("show"))
        end
    end 
end

function unionInfoLayer:onShowRank(index,sender)    
    local lists = self:getChildByName("union_info"):getChildByName("member"):getChildByName("lists")
    local show = false
    if sender:isFlippedY() == true then
        sender:setFlippedY(false)
    else
        sender:setFlippedY(true)
        show = true
    end        
    if index == 6 then
        if show == false then
            lists:getChildByName("rank6"):getChildByName("leader"):setVisible(false)
            lists:getChildByName("rank6"):setContentSize(cc.size(720,77))
            lists:requestRefreshView()
        else
            self:onShowULevel(6)
        end    
    elseif index == 5 then
        if show == false then
            lists:getChildByName("rank5"):getChildByName("lists"):setVisible(false)
            lists:getChildByName("rank5"):setContentSize(cc.size(720,77))
            lists:requestRefreshView()
        else
            self:onShowULevel(5)
        end    
    else    
        if show == false then
            lists:getChildByName("rank"..index):getChildByName("lists"):setVisible(false)
            lists:getChildByName("rank"..index):setContentSize(cc.size(720,77))
            lists:requestRefreshView()
        else
            self:onShowULevel(index)
        end    
    end
end

function unionInfoLayer:onShowULevel(ulevel)
    if self._state[ulevel] == 0 then
        self:queryMember(ulevel)
    else
        self:showULevel(ulevel)
    end    
end

function unionInfoLayer:updateJoinLight()
    if dd.myUnion:getLong(1,"unionid") <= 0 then
        self:getChildByName("union_info"):getChildByName("btns"):getChildByName("adv_btn"):getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
        self:getChildByName("union_info"):getChildByName("btns"):getChildByName("adv_btn"):setTouchEnabled(true)
        self:getChildByName("union_info"):getChildByName("btns"):getChildByName("adv_btn"):getChildByName("chu_label"):setColor(cc.c3b(255,255,255))
    else 
        local effect = ff.Effect:effectGrey()    
        self:getChildByName("union_info"):getChildByName("btns"):getChildByName("adv_btn"):getVirtualRenderer():setGLProgramState(effect:getGLProgramState())
        self:getChildByName("union_info"):getChildByName("btns"):getChildByName("adv_btn"):setTouchEnabled(false)
        self:getChildByName("union_info"):getChildByName("btns"):getChildByName("adv_btn"):getChildByName("chu_label"):setColor(cc.c3b(116,123,125))
    end
end

function unionInfoLayer:showULevel(level)
    cclog("level:"..level)
    local lists = self:getChildByName("union_info"):getChildByName("member"):getChildByName("lists")
    local members = self._members[level]
    local nums    = 0
    if members ~= nil then
        nums = table.getn(members)
    end
    if nums == 0 then
        return
    end
    self._state[level] = 1
    if level == 6 then
        if nums == 1 then
            local leader = lists:getChildByName("rank6"):getChildByName("leader")
            leader:getChildByName("info"):getChildByName("name"):setString(members[1]["name"])
            leader:getChildByName("info"):getChildByName("level"):setString("LV."..members[1]["level"])
            leader:getChildByName("info"):getChildByName("power"):setString(ff.getFormatMoney(members[1]["power"]))
            leader:getChildByName("icon"):loadTexture(dd.getPlayerIcon(tonumber(members[1]["face"])),0)
            leader:getChildByName("icon").uid = tonumber(members[1]["uid"])
            leader:getChildByName("info"):getChildByName("tag"):setString("")
            self._ulederid = tonumber(members[1]["uid"])
            self._uledername = members[1]["name"]
            lists:getChildByName("rank6"):getChildByName("leader"):setVisible(true)
            lists:getChildByName("rank6"):setContentSize(cc.size(720,277))
        end
    elseif level == 5 then
        local rank5 = lists:getChildByName("rank5")
        rank5:getChildByName("title"):getChildByName("member"):setString(nums.."/2")
        if nums > 0 then
            for i=1,nums do
                if i > 2 then
                    break
                end    
                local item = rank5:getChildByName("lists"):getChildByName("item"..i)
                item:getChildByName("info"):getChildByName("name"):setString(members[i]["name"])
                item:getChildByName("info"):getChildByName("level"):setString("LV."..members[i]["level"])
                item:getChildByName("info"):getChildByName("power"):setString(ff.getFormatMoney(members[i]["power"]))
                item:getChildByName("icon"):loadTexture(dd.getPlayerIcon(tonumber(members[i]["face"])),0)
                item:getChildByName("icon").uid = tonumber(members[i]["uid"])
                item:getChildByName("info"):getChildByName("tag"):setString("")
            end
            if nums == 1 then
                rank5:getChildByName("lists"):getChildByName("item2"):setVisible(false)
            end

            lists:getChildByName("rank5"):getChildByName("lists"):setVisible(true)
            lists:getChildByName("rank5"):setContentSize(cc.size(720,277))
        end
    else 
        local rank = lists:getChildByName("rank"..level)
        rank:getChildByName("lists"):stopAllActions()
        if level == 4 then
            local tn = 4 + self:getRank4Plus()
            rank:getChildByName("title"):getChildByName("member"):setString(nums.."/"..tn)
        else
            rank:getChildByName("title"):getChildByName("member"):setString(nums)
        end
        --先隐藏        
        local rlist = lists:getChildByName("rank"..level):getChildByName("lists")
        for tid,item in pairs(rlist:getChildren()) do
            if item ~= nil then
                item:setVisible(false)
            end
        end   
        if nums > 0 then
            local hh = 200 * math.ceil(nums/2)
            rank:getChildByName("lists"):setContentSize(cc.size(720,hh))
            rank:setContentSize(cc.size(720,hh + 77))  
            if nums <= 10 then
                for i=1,nums do
                    self:addItem(rank, members, i, hh)
                end
            else
                local count = 11
                for i=1,10 do
                    self:addItem(rank, members, i, hh)
                end
                local function add_sche()
                    if count <= nums then
                        self:addItem(rank, members, count, hh)
                        count = count + 1
                    else
                        rank:getChildByName("lists"):stopAllActions()
                    end
                end
                schedule(rank:getChildByName("lists"), add_sche,0.01)
            end 

            rank:getChildByName("lists"):setVisible(true)
            --如果在屏幕底下 上移
            if nums > 0 then
                local fixy = rank:getPositionY() - 200 + lists:getInnerContainer():getPositionY()
                if fixy < 0 then
                    lists:getInnerContainer():runAction(cc.MoveBy:create(0.3,cc.p(0,-fixy)))
                end
            end           
        end

    end
    lists:requestRefreshView()
end

function unionInfoLayer:addItem(rank, members, i, hh)
    local item = rank:getChildByName("lists"):getChildByTag(i)
    if item == nil then
        item = self:getChildByName("union_info"):getChildByName("member"):getChildByName("item"):clone()
        rank:getChildByName("lists"):addChild(item)
    end
    item:setTag(i)
    item:getChildByName("icon"):loadTexture(dd.getPlayerIcon(tonumber(members[i]["face"])),0)
    item:getChildByName("bg"):loadTexture(dd.getPathFromUI("bg5_member.png",1))
    item:getChildByName("icon").uid = tonumber(members[i]["uid"])
    item:getChildByName("icon"):addTouchEventListener(self.onShowPower2)
    item:getChildByName("name"):setString(members[i]["name"])
    item:getChildByName("power"):setString(ff.getFormatMoney(tonumber(members[i]["power"])))
    item:getChildByName("level"):setString("LV."..members[i]["level"])
    item:getChildByName("tag"):setString("")
    local shang = math.modf(i/2.0)         
    local yu = i%2
    if yu == 0 then
        shang = shang - 1
    end
    if yu == 1 then
        item:setPositionX(20)
    elseif yu == 2 then
        item:setPositionX(255)    
    elseif yu == 0 then    
        item:setPositionX(370)    
    end  
    item:setVisible(true)
    item:setPositionY(hh - 200 * (shang + 1))
end

function unionInfoLayer.onShowPower2(sender, eventType)
    local doaction = false
    if eventType == ccui.TouchEventType.canceled then
        local startp = sender:getTouchBeganPosition()
        local endp   = sender:getTouchEndPosition()
        if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
            doaction = true
        end
    end
    
    if eventType==ccui.TouchEventType.ended then    
        doaction = true
    end
    if doaction == true then
        local widget = pop.getDialog("unionInfo")
        if widget._parent._name == "powerInfo" then
            pop.onShowPopDialog("power2",widget._parent,sender.uid)
        else
            local union = pop.getDialog("union")
            pop.onShowPopDialog("power2",union,sender.uid)
        end  
    end
end

function unionInfoLayer:getUnionOverView(flag)
    local message = ff.net:createMessage()
    message:addCmd(0x021)
    message:addLong(dd.uid) 
    message:addString(flag,3)   
    ff.net:rpc(message,false)
end


function unionInfoLayer:getUnionDetail(unionid)
    local message = ff.net:createMessage()
    message:addCmd(0x031)
    message:addLong(dd.uid) 
    message:addLong(unionid)   
    ff.net:rpc(message,false)
end

function unionInfoLayer:getUnionMembers(flag, offid)
    local message = ff.net:createMessage()
    message:addCmd(0x012)
    message:addLong(dd.uid) 
    --message:addLong(0)
    message:addString(flag, 3)  
    message:addLong(offid)  
    ff.net:rpc(message,false)
end

function unionInfoLayer:getUnionMembersNum(flag)
    local message = ff.net:createMessage()
    message:addCmd(0x013)
    message:addLong(dd.uid) 
    message:addString(flag, 3)  
    ff.net:rpc(message,false)
end

function unionInfoLayer:queryMember(ulevel)
    local message = ff.net:createMessage()
    message:addCmd(0x00000012)
    message:addLong(dd.uid)
    message:addString(self._unionflag,3)
    message:addLong(ulevel)
    ff.net:rpc(message,false)
end

--概要信息
function unionInfoLayer:onNetGetUnionOverView(params)    
    local code = params[1]
    if code == 0 then
        self._baseinfo = params[2]
        self:onInitBaseInfo()
        self:getUnionDetail(self._baseinfo._unionid)
    else
        dd.mainUI:onShowCodeTips(code)
    end
end
--详细信息
function unionInfoLayer:onNetGetUnionDetail(params)
    local code = params[1]
    if code == 0 then
        self._detailinfo = params[2] 
        self._tecinfo = params[3]   
        self:initDetailInfo()
        self:getUnionMembersNum(self._unionflag)
    else
        dd.currentLayer._widget:onShowTips("\t"..dd.errorCode(code))
    end
end
--成员列表
function unionInfoLayer:onNetGetUnionMembers(params)
    local code = params[1]
    if code == 0 then
        local ulevel = params[2]
        local infos  = params[3]
        local widget = pop.getDialog("unionInfo")
        if widget ~= nil then
            widget._members[ulevel] = infos
            widget:showULevel(ulevel)
            widget:onInitLists()
        end    
    else
        dd.currentLayer._widget:onShowTips("\t"..dd.errorCode(code))
    end
end

function unionInfoLayer:onNetGetUnionMembersNum(params)
    cclog("unionInfoLayer.onNetGetUnionMembersNum")
    local code = params[1]
    if code == 0 then
        local flag = params[2]
        local rank4 = params[3]
        local rank3 = params[4]
        local rank2 = params[5]
        local rank1 = params[6]
        local rank5 = params[7]

        local widget = pop.getDialog("unionInfo")
        if widget ~= nil then
            widget:getChildByName("union_info"):getChildByName("member"):getChildByName("lists"):getChildByName("rank5"):getChildByName("title"):getChildByName("member"):setString(rank5.."/2")
            widget:getChildByName("union_info"):getChildByName("member"):getChildByName("lists"):getChildByName("rank4"):getChildByName("title"):getChildByName("member"):setString(rank4.."/"..(4 + self:getRank4Plus()))
            widget:getChildByName("union_info"):getChildByName("member"):getChildByName("lists"):getChildByName("rank3"):getChildByName("title"):getChildByName("member"):setString(rank3)
            widget:getChildByName("union_info"):getChildByName("member"):getChildByName("lists"):getChildByName("rank2"):getChildByName("title"):getChildByName("member"):setString(rank2)
            widget:getChildByName("union_info"):getChildByName("member"):getChildByName("lists"):getChildByName("rank1"):getChildByName("title"):getChildByName("member"):setString(rank1)

            widget:getChildByName("union_info"):getChildByName("member"):getChildByName("lists"):getChildByName("rank5"):getChildByName("title"):getChildByName("member"):setVisible(true)
            widget:getChildByName("union_info"):getChildByName("member"):getChildByName("lists"):getChildByName("rank4"):getChildByName("title"):getChildByName("member"):setVisible(true)
            widget:getChildByName("union_info"):getChildByName("member"):getChildByName("lists"):getChildByName("rank3"):getChildByName("title"):getChildByName("member"):setVisible(true)
            widget:getChildByName("union_info"):getChildByName("member"):getChildByName("lists"):getChildByName("rank2"):getChildByName("title"):getChildByName("member"):setVisible(true)
            widget:getChildByName("union_info"):getChildByName("member"):getChildByName("lists"):getChildByName("rank1"):getChildByName("title"):getChildByName("member"):setVisible(true)
        end
    else
        dd.currentLayer._widget:onShowTips("\t"..dd.errorCode(code))
    end
end

function unionInfoLayer:onNetAskForJoinUnion(ret)
    if ret[1] == 0 then
        if ret[2]['action'] == 1 then
            if ret[2]['join_suc'] == 0 then
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("申请已发出，请等待"),true)
            elseif ret[2]['join_suc'] == 1 then
                dd.currentLayer._widget:onShowTips("\t"..ff.langString("申请已被接受，成功加入联盟"),true)
                pop.onClosePopDialog("unionInfo")
                performWithDelay(self,function() pop.onShowPopDialog("union",1) end,0.2)
            end
        end
    else
        if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
            dd.currentLayer._widget:onShowTips("\t"..dd.errorCode(ret[1]))
        end 
    end
end

function unionInfoLayer:getRank4Plus()
    local ret = 0
    for i=1,table.getn(self._tecinfo) do
        if self._tecinfo[i]["utid"] == 101 then
            local lv = self._tecinfo[i]["level"]
            if lv == 0 then
                ret = 0
            else
                local teclvid = 10100+lv
                local rows = ff.dbmanager:sql_fetch_rows("select * from cfg_league_tech_levelup where id="..teclvid)
                local param = tonumber(rows:getString(1, "effect3"))
                local value  = tonumber(rows:getString(1, "params3"))
                if dd.cfgEffect[param]['value'] > 0 then
                    value = value/dd.cfgEffect[param]['value']
                end
                ret = value
                rows:clear()
            end
            break
        end
    end
    return ret
end

function unionInfoLayer:addRegisterEvent()
    ff.net:registerEvent(2,dd.Tjf_rpc_getUnionOverview, function (message)self:onNetGetUnionOverView(message)end)
    ff.net:registerEvent(2,dd.Tjf_rpc_getUnionDetail,function (message)self:onNetGetUnionDetail(message)end)
    ff.net:registerEvent(2,dd.Tjf_rpc_getUnionMembers,function (message)self:onNetGetUnionMembers(message)end)
    ff.net:registerEvent(2,dd.Tjf_rpc_getUnionMembersNum,function (message)self:onNetGetUnionMembersNum(message)end)
    ff.net:registerEvent(2,dd.Tjf_NewAllyApply,function (message)self:onNetAskForJoinUnion(message)end)
    ff.net:bindProperty(2515,"gold",self.updateGold)
end

--接口
function unionInfoLayer.onBack(sender,eventType)
    if eventType==ccui.TouchEventType.ended then   
        local widget = pop.getDialog("unionInfo")
        if widget ~= nil then
            pop.onClosePopDialog("unionInfo")
        end 
    end
end

function unionInfoLayer.onStart(sender)
    --详细信息接口要获取id之后使用
    sender:getUnionOverView(sender._unionflag)   
    --要获取科技才能计算数量
    --sender:getUnionMembersNum(sender._unionflag)
    sender:getUnionMembers(sender._unionflag, 6)
end

function unionInfoLayer.onEnd(sender)
    ff.net:removeEvent(2,dd.Tjf_rpc_getUnionOverview)
    ff.net:removeEvent(2,dd.Tjf_rpc_getUnionDetail)
    ff.net:removeEvent(2,dd.Tjf_rpc_getUnionMembers)
    ff.net:removeEvent(2,dd.Tjf_rpc_getUnionMembersNum)
    ff.net:removeEvent(2,dd.Tjf_NewAllyApply)
    ff.net:unbindProperty("gold",2515)
    dd.delBackEvent()

    if ff.platform ~= 1 then
        sender:getChildByName("union_info"):getChildByName("info"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        
        local lists = sender:getChildByName("union_info"):getChildByName("member"):getChildByName("lists")
        --rank6
        lists:getChildByName("rank6"):getChildByName("leader"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        --rank5 4
        lists:getChildByName("rank5"):getChildByName("lists"):getChildByName("item1"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        lists:getChildByName("rank5"):getChildByName("lists"):getChildByName("item2"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
        --rank 1-3
        for i = 1, 4 do
            lists:getChildByName("rank"..i):getChildByName("lists"):stopAllActions()
            if sender._state[i] == 1 then
                local lists = lists:getChildByName("rank"..i):getChildByName("lists")
                for tid,item in pairs(lists:getChildren()) do
                    if item ~= nil then
                        item:getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                        item:getChildByName("bg"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
                    end
                end 
            end
        end
    end
end

--界面即将播放
function unionInfoLayer.onBefore(sender)
    sender:resetRank()
    sender._init = true
    --pop.jsons["unionInfo"][pop._index_show] = 2
    dd.initGoldSpine(sender:getChildByName("topArea"):getChildByName("gold"),sender:getChildByName("topArea"):getChildByName("addbtn"))
    return true
end

function unionInfoLayer.onReturn(sender,eventType)
    pop.onClosePopDialog("unionInfo")    
end

function onShowUnionInfoLayer(widget, parent, unionflag)
    local layer = unionInfoLayer.extend(widget)
    if layer._parent ~= parent then
        layer._parent = parent
        layer:onAutoSize()
    end 
    dd.regeditBackEvent(layer.onReturn)
    layer._unionflag = unionflag
    layer:onInit()
    return layer
end
