local umessageLayer = class("unionMessage")
umessageLayer._name = "unionMessage"
umessageLayer._init = false
umessageLayer._message = nil
umessageLayer._fristID = 0
umessageLayer._lastID  = 0
umessageLayer._unionid = 0
umessageLayer._animFrames = {}



function umessageLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, umessageLayer)
    return target
end

function umessageLayer:onInit()
	if self._init == false then
		local top = self:getChildByName("top")
		top:getChildByName("return"):addTouchEventListener(self.onClose)
		top:setPositionY(ff.height - 105)

		self:getChildByName("message"):setContentSize(cc.size(720,ff.height - 105))
		self:getChildByName("message"):setPositionY(0)

		self:getChildByName("message"):getChildByName("lists"):setContentSize(cc.size(720,ff.height - 105 - 130 -8))
		self:getChildByName("message"):getChildByName("lists"):setPositionY(130 + 4)
		self:getChildByName("message"):getChildByName("mBtm"):setPositionY(0)

		self:getChildByName("umsg"):getChildByName("close"):addTouchEventListener(self.closeUMessage)
		self:getChildByName("umsg"):getChildByName("send"):addTouchEventListener(self.sendUnionMessage)
		self:getChildByName("message"):getChildByName("mBtm"):getChildByName("sure"):addTouchEventListener(self.showNewUnionMessage)

        local size = self:getChildByName("umsg"):getChildByName("input"):getChildByName("input"):getContentSize()
        local editBox = dd.addEditBox(
             self:getChildByName("umsg"):getChildByName("input")
            , size
            , "images/editbox.png"
            , 11011
            , cc.p(0,0)
            , cc.p(self:getChildByName("umsg"):getChildByName("input"):getChildByName("input"):getPosition())
            , cc.c3b(255,255,255)
            , 20
            , 0
            , 4
            , 0
            , 500
            , true
            , true
            , true
        )

        local cache = cc.SpriteFrameCache:getInstance()
        cache:addSpriteFrames("images/mv/normaleffect.plist")

        for j = 1, 12 do
            local frame = nil
            if j < 10 then
                frame = cache:getSpriteFrame("of_native_loader_progress_0"..j..".png")
            else    
                frame = cache:getSpriteFrame("of_native_loader_progress_"..j..".png")
            end 
            self._animFrames[j] = frame
        end


        self._message = editBox        
        self:getChildByName("message"):getChildByName("lists"):addScrollViewEventListener(self.scrollViewEvent)
        self:getChildByName("top"):getChildByName("addgold"):addTouchEventListener(dd.onPay)
		self._init = true
	end
	self.updateGold()         
end
function umessageLayer.updateGold(name,row,old,value)
    local sender = pop.getDialog("unionMessage")
    if sender ~= nil then
        sender:getChildByName("top"):getChildByName("count"):setString(dd.myinfo:getLong(1,"gold"))
        local w = sender:getChildByName("top"):getChildByName("count"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        sender:getChildByName("top"):getChildByName("title"):setContentSize(cc.size(w,100))
        sender:getChildByName("top"):getChildByName("title"):requestDoLayout()
        sender:getChildByName("top"):requestDoLayout()
    end
end

function umessageLayer.sendUnionMessage(sender,eventType)
    if eventType==ccui.TouchEventType.ended then     
        local widget = pop.getDialog("unionMessage")
        if widget ~= nil then
        	local txt = widget._message:getText()
        	if string.len(txt) > 0 then
			    local message = ff.net:createMessage()
			    message:addCmd(0xF0B)
			    message:addLong(dd.uid)
			    message:addLong(ff.serverid)
			    message:addLong(widget._unionid)
			    message:addString(txt,511)
			    message:addString("cn",15)
			    message:addLong(widget._lastID)
			    ff.net:rpc(message,false)

	            widget:getChildByName("umsg"):stopAllActions()
	            pop.onCloseEffect(99,widget:getChildByName("umsg"))
			else
				dd.currentLayer._widget:onShowTips("\t"..ff.langString("留言内容不能为空"))
			end    
        end
    end
end

function umessageLayer:showWaiting(show,type)
	if show == false then
		self:getChildByName("message"):getChildByName("waiting"):getChildByName("icon"):getVirtualRenderer():stopAllActions()
		self:getChildByName("message"):getChildByName("waiting"):setVisible(false)
	else
	    local animation = cc.Animation:createWithSpriteFrames(self._animFrames, 0.1)
	    self:getChildByName("message"):getChildByName("waiting"):getChildByName("icon"):setContentSize(cc.size(32,32))
	    self:getChildByName("message"):getChildByName("waiting"):getChildByName("icon"):getVirtualRenderer():runAction(cc.RepeatForever:create(cc.Animate:create(animation)))
	    self:getChildByName("message"):getChildByName("waiting"):setVisible(true)
	    if type == 1 then
	    	self:getChildByName("message"):getChildByName("waiting"):setPositionY(ff.height - 105 - 32)
	    else
	    	self:getChildByName("message"):getChildByName("waiting"):setPositionY(130)
	    end	
	end
end

function umessageLayer.scrollViewEvent(sender, eventType)
    local widget = pop.getDialog("unionMessage")
    if widget:getChildByName("message"):getChildByName("waiting"):isVisible() == false then
	    if eventType ==  ccui.ScrollviewEventType.bounceTop then
        	widget:showWaiting(true,1)
            widget:peakUnionMessage(1)
		elseif eventType == ccui.ScrollviewEventType.bounceBottom then
			if widget._fristID > 1 then 	  
        		widget:showWaiting(true,2)
            	widget:peakUnionMessage(2)			
            end
	    end
	end
end
function umessageLayer.showNewUnionMessage(sender,eventType)
    if eventType==ccui.TouchEventType.ended then     
        local widget = pop.getDialog("unionMessage")
        if widget ~= nil then
		    local umsg = widget:getChildByName("umsg")
		    umsg:stopAllActions()
		    pop.showPopEffect(12,umsg)      
		    --留言最多5行，每行之间间距是6
		    platform_setMultilinePro(5,6)	
        end
    end
end
--发送消息
function umessageLayer.onSendAllyComment(code)
	if code == 0 then
		dd.mainUI:onShowTips("\t"..ff.langString("留言成功"),true)
		local widget = pop.getDialog("unionMessage")
		widget:showMessage(widget._unionid,widget._lastID,0,1)
	end
end

function umessageLayer.closeUMessage(sender,eventType)
    if eventType==ccui.TouchEventType.ended then     
        local widget = pop.getDialog("unionMessage")
        if widget ~= nil then
            widget:getChildByName("umsg"):stopAllActions()
            pop.onCloseEffect(99,widget:getChildByName("umsg"))
        end
    end
end

function umessageLayer.updateUMessage(params)
	local code = params[1]
	local unionid = params[2]
	local maxid   = params[3]
	local minid   = params[4]
	local row     = params[5]
    local widget = pop.getDialog("unionMessage")
    if code == 0 then
    	cclog("maxid:"..maxid..",minid:"..minid..",row:"..row)
        widget:showMessage(unionid,maxid,minid,row)
    end
    widget:showWaiting(false)
end

function umessageLayer:showMessage(unionid,maxid,minid,row)
	cclog("onShowUnionMessage:"..unionid)
	local str = ""
	if unionid ~= self._unionid then
		return
	end
	if row == 0 then
		return
	end
	cclog("here......")
	if maxid == 0 and minid == 0 then
		str = "select * from client_union_message where `unionid`='"..self._unionid.."' order by `id` desc limit 10"
	elseif maxid > 0 then
		str = "select * from client_union_message where `unionid`='"..self._unionid.."' and `id`>'"..maxid.."' order by `id` asc limit 10"
	else
		str = "select * from client_union_message where `unionid`='"..self._unionid.."' and `id`<'"..minid.."' order by `id` desc limit 10"
	end
	cclog("str:"..str)
	local rows = ff.dbmanager:sql_fetch_rows(str)	
	if rows ~= nil then
		if maxid > 0 then
			self._lastID = tonumber(rows:getString(rows:rowCount(),"id"))
		end
		if minid > 0 then
			self._fristID = tonumber(rows:getString(rows:rowCount(),"id"))
		end
		if maxid == 0 and minid == 0 then
			self._fristID = tonumber(rows:getString(rows:rowCount(),"id"))
			self._lastID = tonumber(rows:getString(1,"id"))
		end

		for i=1,rows:rowCount() do
			local id = tonumber(rows:getString(i,"id"))
			local item = self:getChildByName("message"):getChildByName("item"):clone()
			item:setVisible(true)

	        local richText=ccui.RichText:create()
	        richText:ignoreContentAdaptWithSize(false)
	        richText:setContentSize(cc.size(650,600))    
	        richText:setAutoHeight()

	        local chat = ccui.RichElementText:create(1, cc.c3b(161, 175, 175), 255, rows:getString(i,"message"), "Helvetica", 20)
	        richText:insertElement(chat,0)
	        richText:formatText()
	        local size = richText:getContentSize()
	        cclog("ww:"..size.width..",hh:"..size.height)
			local hh = 60 + size.height + 20
			if hh < 120 then
				hh = 120
			end	
	        richText:setPosition(cc.p(700/2,hh - (60 + size.height/2)))
	        item:addChild(richText)

			item:setContentSize(cc.size(700,hh))
			item:getChildByName("title"):setPositionY(hh - 48)

			local unionid = tonumber(rows:getString(i,"unionid"))
			if unionid > 0 then
				item:getChildByName("title"):getChildByName("ulevel"):setString(rows:getString(i,"ulevel"))
				if string.len(rows:getString(i,"short")) > 0 then
					item:getChildByName("title"):getChildByName('short'):setString("["..rows:getString(i,"short").."]")
				else
					item:getChildByName("title"):getChildByName('short'):setString("")
				end
			else
				item:getChildByName("title"):getChildByName("ulevel"):setString("")
				item:getChildByName("title"):getChildByName('short'):setString("")
			end
			item:getChildByName("title"):getChildByName("name"):setString(rows:getString(i,"name"))
			item:getChildByName("title"):getChildByName("time"):setString(ff.getTimeTips(dd.getChatServerTime() - tonumber(rows:getString(i,"time"))))
			item:setTag(id)
			if maxid > 0 then
				self:getChildByName("message"):getChildByName("lists"):insertCustomItem(item,0)
			elseif minid > 0 or (maxid == 0 and minid == 0) then
				self:getChildByName("message"):getChildByName("lists"):addChild(item)
			end
			item:getChildByName("title"):requestDoLayout()
			self:getChildByName("message"):getChildByName("lists"):refreshView(true)
		end
		self:getChildByName("message"):getChildByName("lists"):refreshView()
	end
	if maxid > 0 or (maxid == 0 and minid == 0) then
		self:getChildByName("message"):getChildByName("lists"):scrollToTop(0.5,true)
	elseif minid > 0 then
        self:getChildByName("message"):getChildByName("lists"):getInnerContainer():runAction(cc.MoveBy:create(0.3,cc.p(0,20)))
		--self:getChildByName("message"):getChildByName("lists"):scrollToBottom(0.5,true)
	end

	cclog("id1:"..self._lastID..",id2:"..self._fristID)
end

function umessageLayer:peakUnionMessage(type)
    local message = ff.net:createMessage()
    message:addCmd(0xE0E)
    message:addLong(dd.uid)
    message:addLong(ff.serverid)
    message:addLong(self._unionid)
    if type == 0 then
	    message:addLong(0)
	    message:addLong(0)
    elseif type == 1 then
    	message:addLong(self._lastID)
    	message:addLong(0)
    else
    	message:addLong(0)
    	message:addLong(self._fristID)
    end
    message:addLong(10)
    ff.net:postMessage(message)
end

function umessageLayer.onClose(sender,eventType)
    if eventType==ccui.TouchEventType.ended then     
    	--pop.onClosePopDialog("unionMessage") 
	    local widget = pop.getDialog("unionMessage")
	    if widget ~= nil then
		    if widget:getChildByName("umsg"):isVisible() == true then
		    	widget.closeUMessage(sender,eventType)
	    	else
				pop.onClosePopDialog("unionMessage")
			end
		end
    end
end

function umessageLayer:close(force)
end

function umessageLayer.onStart(sender)
    ff.net:bindProperty(2017,"gold",sender.updateGold)
end
function umessageLayer.onEnd(sender)
	sender:getChildByName("message"):getChildByName("lists"):removeAllChildren(true)
	ff.net:removeEvent(3,dd.Tjf_union_GetAllyCommentList)
	ff.net:removeEvent(3,dd.Tjf_union_SendAllyComment)
	dd.delBackEvent()
	ff.net:unbindProperty("gold",2017) 
end
function umessageLayer.onBefore(sender)
    dd.initGoldSpine(sender:getChildByName("top"):getChildByName("icon"),sender:getChildByName("top"):getChildByName("addgold")) 
	sender._fristID = 0
	sender._lastID  = 0 
	ff.net:registerEvent(3,dd.Tjf_union_GetAllyCommentList,sender.updateUMessage)
	ff.net:registerEvent(3,dd.Tjf_union_SendAllyComment,sender.onSendAllyComment)
	sender:peakUnionMessage(0)
	return true
end
function umessageLayer.onReturn(sender,eventType)
    local widget = pop.getDialog("unionMessage")
    if widget ~= nil then
	    if widget:getChildByName("umsg"):isVisible() == true then
	    	widget.closeUMessage(nil,ccui.TouchEventType.ended)
    	else
			pop.onClosePopDialog("unionMessage")
		end
	end
end

function onShowUnionMessage(widget,unionid)	
	cclog("unionMessage:"..unionid)
	if unionid == nil then
		unionid = dd.myUnion:getLong(1,"unionid")
	end
    local layer = umessageLayer.extend(widget)
    layer._unionid = unionid
    dd.regeditBackEvent(layer.onReturn)
    layer:onInit()
    return layer
end
