--vip
local vipLayer = class("vip")
vipLayer._name = "vip"
vipLayer._init = false
vipLayer._selectlv = 1
vipLayer._cfgvip = {}
vipLayer._vipmax = 12
vipLayer._isActive = false

function vipLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, vipLayer)
    return target
end

function vipLayer:onAutoSize()
    if self._init == false then 
        local hh = ff.height - 214
        self:setContentSize(cc.size(720,hh))
        self:getChildByName("masking"):setContentSize(cc.size(720,hh-105))
        self:getChildByName("masking"):setPositionY(0)
        
        self:getChildByName("bg"):setContentSize(cc.size(720,hh-105))
        self:getChildByName("bg"):setPositionY(0)
        
        self:getChildByName("topArea"):setPositionY(hh - 105)
        self:getChildByName("info"):setPositionY(hh - 105 - 51)
        self:getChildByName("content"):setPositionY(hh - 105 - 48 - 401)
        self:getChildByName("view"):setPositionY(0)
        
        self:getChildByName("view"):getChildByName("view"):setContentSize(cc.size(720, hh - 105 - 48 - 401))
    end
end

function vipLayer:onInit()
    if self._init == false then  
        --help      
        local function onHelp(sender, eventType)
            if eventType==ccui.TouchEventType.ended then     
                self.openPop()
            end
        end

        local function backSure(tid)
            local message = ff.net:createMessage()
            message:addCmd(0x139)
            message:addLong(dd.uid)
            message:addLong(tid)
            ff.net:rpc(message,false) 
        end   
        local function backAdd()
            self:updates()
        end        
        --add      
        local function onAddPoint(sender, eventType)
            if eventType==ccui.TouchEventType.ended then 
                --dd.currentLayer._widget:onShowUseTools("VIP增加点数",11102,1,backAdd)
                if dd.myinfo:getLong(1,"vip") < self._vipmax then
                    dd.currentLayer._widget:onShowMulTools(24,1,nil,false)
                else
                    dd.currentLayer._widget:onShowTips("\t"..ff.langString("VIP已达最高等级"))
                end
            end
        end

        --open extra      
        local function onOpenExtra(sender, eventType)
            if eventType==ccui.TouchEventType.ended then     
                --dd.currentLayer._widget:onShowSureUseTools("VIP开启额外效果",11101,1,backSure)
                dd.currentLayer._widget:onShowMulTools(31,1,backSure,true)
            end
        end
        
        --left     
        local function onLeft(sender, eventType)
            if eventType==ccui.TouchEventType.ended then     
                if self._selectlv == 1 then
                    dd.currentLayer._widget:onShowTips("\t"..ff.langString("没有更多"))
                else
                    self._selectlv = self._selectlv - 1
                    self:onUpdateSelect()
                end  
            end
        end

        --right      
        local function onRight(sender, eventType)
            if eventType==ccui.TouchEventType.ended then 
                if self._selectlv == self._vipmax then
                    dd.currentLayer._widget:onShowTips("\t"..ff.langString("没有更多"))
                else
                    self._selectlv = self._selectlv + 1
                    self:onUpdateSelect()
                end 
            end
        end
        
        --topArea
        self:getChildByName("topArea"):getChildByName("backbtn"):addTouchEventListener(self.onBack)
        self:getChildByName("topArea"):getChildByName("addbtn"):addTouchEventListener(dd.onPay)

        self:getChildByName("info"):getChildByName("help"):addTouchEventListener(onHelp)

        self:getChildByName("content"):getChildByName("block"):getChildByName("progress"):getChildByName("addbtn"):addTouchEventListener(onAddPoint)
        self:getChildByName("content"):getChildByName("block"):getChildByName("time"):getChildByName("openext"):addTouchEventListener(onOpenExtra)
        self:getChildByName("content"):getChildByName("vipTitle"):getChildByName("left"):addTouchEventListener(onLeft)
        self:getChildByName("content"):getChildByName("vipTitle"):getChildByName("right"):addTouchEventListener(onRight)
        self:getChildByName("topArea"):getChildByName("title"):getChildByName("chu_title"):getVirtualRenderer():enableOutline(cc.c4b(0,0,0,255),3) 
        self:getChildByName("content"):getChildByName("block"):getChildByName("time"):getChildByName("openext"):getChildByName("chu_label"):getVirtualRenderer():enableBold(true)
              
        --加粗
        self:getChildByName("itemmode"):getChildByName("name"):getVirtualRenderer():enableBold(true)
        self:getChildByName("itemmode"):getChildByName("value"):getVirtualRenderer():enableBold(true)

        self:onInitPop()
        self:onInitCfg()
        self._init = true
    end
    self._selectlv = dd.myinfo:getLong(1,"vip")
    self.updateGold()
end

function vipLayer:onInitPop()
    self:getChildByName("pop"):getChildByName("close"):addTouchEventListener(self.closePop)
end

function vipLayer:onInitCfg()
    --vip
    local vip = ff.dbmanager:sql_fetch_rows("select * from cfg_vip")
    for i=1, vip:rowCount() do
        local lv = tonumber(vip:getString(i, "vip"))
        self._cfgvip[lv] = {}
        self._cfgvip[lv]['point'] = tonumber(vip:getString(i, "point"))
        for k=1,16 do
            self._cfgvip[lv]['param'..k] = tonumber(vip:getString(i, "param"..k))
            self._cfgvip[lv]['value'..k] = tonumber(vip:getString(i, "value"..k))
            self._cfgvip[lv]['exparam'..k] = tonumber(vip:getString(i, "exparam"..k))
            self._cfgvip[lv]['exvalue'..k] = tonumber(vip:getString(i, "exvalue"..k))
        end        
        --self._cfgvip[lv]['gift'] = tonumber(vip:getString(i, "gift"))
        self._cfgvip[lv]['tid'] = tonumber(vip:getString(i, "tid"))
    end
    vip:clear()
end

function vipLayer.updateGold()
    local widget = pop.getDialog("vip")
    widget:getChildByName("topArea"):getChildByName("money"):setString(dd.gold())
    widget:getChildByName("topArea"):requestDoLayout()

    local w = widget:getChildByName("topArea"):getChildByName("money"):getContentSize().width
    w = 720 - (w + 94 + 75 + 104)
    widget:getChildByName("topArea"):getChildByName("title"):setContentSize(cc.size(w,100))
    widget:getChildByName("topArea"):getChildByName("title"):requestDoLayout()
end

function vipLayer:updates()
    self:onUpdateBtn()
    self:onUpdateExtraTime()
    self:onUpdateVipInfo()
    self:onUpdateSelect()
end

function vipLayer:onUpdateBtn()
    if self._cfgvip[dd.myinfo:getLong(1,"vip")]['tid'] == 0 then
        local effect = ff.Effect:effectGrey()
        self:getChildByName("content"):getChildByName("block"):getChildByName("time"):getChildByName("openext"):setTouchEnabled(false)
        self:getChildByName("content"):getChildByName("block"):getChildByName("time"):getChildByName("openext"):getVirtualRenderer():setGLProgramState(effect:getGLProgramState())
    else
        self:getChildByName("content"):getChildByName("block"):getChildByName("time"):getChildByName("openext"):setTouchEnabled(true)
        self:getChildByName("content"):getChildByName("block"):getChildByName("time"):getChildByName("openext"):getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
    end
end

function vipLayer:onUpdateExtraTime()
    self:stopAllActions()     
    local have = false
    for i=1,dd.mylists:rowCount() do
        if dd.mylists:getLong(i,"type") == 12 then
            local time   = dd.mylists:getLong(i,"end") - dd.getServerTime()    
            if time > 0 then  
                have = true
                break
            end
        end
    end  
    self._isActive = have
    if have == true then
        self.showAction()
        schedule(self, self.showAction,1)
        self:getChildByName("content"):getChildByName("block"):getChildByName("time"):getChildByName("openext"):getChildByName("chu_label"):setString(ff.langString("增加持续时间"))
        self:getChildByName("content"):getChildByName("block"):getChildByName("time"):getChildByName("progress"):setVisible(true)
        self:getChildByName("content"):getChildByName("block"):getChildByName("time"):getChildByName("timetip"):setVisible(false)
    else
        self:getChildByName("content"):getChildByName("block"):getChildByName("time"):getChildByName("time"):setString("00:00:00")
        self:getChildByName("content"):getChildByName("block"):getChildByName("time"):getChildByName("openext"):getChildByName("chu_label"):setString(ff.langString("开启额外效果"))
        self:getChildByName("content"):getChildByName("block"):getChildByName("time"):getChildByName("progress"):setVisible(false)
        self:getChildByName("content"):getChildByName("block"):getChildByName("time"):getChildByName("timetip"):setVisible(true)
    end
end

function vipLayer:onUpdateVipInfo()
    local block = self:getChildByName("content"):getChildByName("block")
    local viplv = dd.myinfo:getLong(1,"vip")
    local vippt = dd.myinfo:getLong(1,"vippoint")
    local tick  = block:getChildByName("progress"):getChildByName("tick")   -- x = 64     l = 600
    for i = 1, self._vipmax do
        if viplv == i then
            block:getChildByName("progress"):getChildByName(tostring(i)):setColor(cc.c3b(255,255,0))
        else
            block:getChildByName("progress"):getChildByName(tostring(i)):setColor(cc.c3b(118,137,137))
        end
    end
    
    if viplv >= self._vipmax then
        block:getChildByName("progress"):getChildByName("progress"):setPercent(99)
        block:getChildByName("exps"):setString(ff.langString("已经是最高等级"))
        tick:setPositionX(600)
        block:getChildByName("progress"):getChildByName("exps"):setPositionX(600)
        block:getChildByName("progress"):getChildByName("exps"):setString(ff.getFormatMoney(self._cfgvip[self._vipmax]["point"]).."/"..ff.getFormatMoney(self._cfgvip[self._vipmax]["point"]))
    else
        local twope = ((vippt - self._cfgvip[viplv]["point"])/(self._cfgvip[viplv+1]["point"]-self._cfgvip[viplv]["point"]))/(self._vipmax)
        local levelpe = (viplv)/(self._vipmax)
        local percent = 100*(levelpe + twope)
        block:getChildByName("progress"):getChildByName("progress"):setPercent(percent)
        block:getChildByName("exps"):setString(ff.langString("VIP 升到下一级还需要 {0}点",{self._cfgvip[viplv+1]["point"] - vippt}))
        tick:setPositionX(62 + 536*percent/100)
        block:getChildByName("progress"):getChildByName("exps"):setPositionX(62 + 536*percent/100)
        block:getChildByName("progress"):getChildByName("exps"):setString(ff.getFormatMoney(vippt).."/"..ff.getFormatMoney(self._cfgvip[viplv+1]["point"]))
    end
end

function vipLayer:onUpdateSelect()
    local hh = self:getChildByName("view"):getChildByName("view"):getContentSize().height
    local lv = self._selectlv
    local title = self:getChildByName("content"):getChildByName("vipTitle")
    self:getChildByName("view"):getChildByName("view"):jumpToTop()
    title:getChildByName("vips"):getChildByName("vip"):setString(self._selectlv)
    --检查按钮变灰
    if self._selectlv == 1 then
        self:setBtnLight(self:getChildByName("content"):getChildByName("vipTitle"):getChildByName("left"), false)
        self:setBtnLight(self:getChildByName("content"):getChildByName("vipTitle"):getChildByName("right"), true)
    elseif self._selectlv == self._vipmax then
        self:setBtnLight(self:getChildByName("content"):getChildByName("vipTitle"):getChildByName("left"), true)
        self:setBtnLight(self:getChildByName("content"):getChildByName("vipTitle"):getChildByName("right"), false)
    else
        self:setBtnLight(self:getChildByName("content"):getChildByName("vipTitle"):getChildByName("left"), true)
        self:setBtnLight(self:getChildByName("content"):getChildByName("vipTitle"):getChildByName("right"), true)
    end
    --隐藏
    for k=1,self:getChildByName("view"):getChildByName("view"):getChildrenCount() do
        local item = self:getChildByName("view"):getChildByName("view"):getChildByName(k)
        if item then
            item:setVisible(false)
        end
    end
    
    --计算深度
    local depth = 0
    local exdepth = 0
    local num = 0
    local innerhh = 0
    for i=1, 16 do
        local effid = self._cfgvip[lv]["param"..i]
        if effid ~= 0 and effid ~= nil then
            depth = depth + 1
        end
        
        local exeffid = self._cfgvip[lv]["exparam"..i]
        if exeffid ~= 0 and exeffid ~= nil then
            exdepth = exdepth + 1
        end
    end
    
    if depth > exdepth then
        num = depth
    else 
        num = exdepth
    end

    if num*140 > hh then
        self:getChildByName("view"):getChildByName("view"):setInnerContainerSize(cc.size(720,num*140))
        innerhh = num*140
    else
        self:getChildByName("view"):getChildByName("view"):setInnerContainerSize(cc.size(720,hh))
        innerhh = hh
    end
    
    --赠送效果
    local count = 0
    local ncount = 1
    for i=1, 16 do
        local effid = self._cfgvip[lv]["param"..i]
        if effid ~= 0 and effid ~= nil then
            local value = self._cfgvip[lv]["value"..i]
            local item = self:getChildByName("view"):getChildByName("view"):getChildByName(ncount)
            if item == nil then
                item = self:getChildByName("itemmode"):clone()
                item:setName(ncount)
                self:getChildByName("view"):getChildByName("view"):addChild(item)
            end
            ncount = ncount + 1
            local isop = dd.cfgEffect[effid]['open']
            if isop == 0 then
                value = value/dd.cfgEffect[effid]['value']
                local tips2 = ff.langString(dd.cfgEffect[effid]['tips2'])

                if tonumber(tips2)  == 0 then
                    item:getChildByName("value"):setString("+"..value)
                elseif tips2 ~= nil then
                    item:getChildByName("value"):setString("+"..value..tips2)
                end
            else
                item:getChildByName("value"):setString("open")
            end
            
            item:setVisible(true)
            item:setPositionX(16)
            item:setPositionY(innerhh - 130 - count*140)
            item:setTag(effid)
            
            item:getChildByName("name"):setString(ff.langString(dd.cfgEffect[effid]['name']))
            item:getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getEffectIcon2(effid),0)
            
            self:setBtnLight(item:getChildByName("icon"):getChildByName("icon"), true)
            item:getChildByName("value"):setColor(cc.c3b(7,159,0))
            
            count = count + 1
        end
    end
    --额外效果(激活要变亮)
    local excount = 0
    for i=1, 16 do
        local effid = self._cfgvip[lv]["exparam"..i]
        if effid ~= 0 and effid ~= nil then
            local value = self._cfgvip[lv]["exvalue"..i]
            local item = self:getChildByName("view"):getChildByName("view"):getChildByName(ncount)
            if item == nil then
                item = self:getChildByName("itemmode"):clone()
                item:setName(ncount)
                self:getChildByName("view"):getChildByName("view"):addChild(item)
            end
            ncount = ncount + 1
            local isop = dd.cfgEffect[effid]['open']
            if isop == 0 then
                value = value/dd.cfgEffect[effid]['value']
                local tips2 = ff.langString(dd.cfgEffect[effid]['tips2'])
                --print("=="..tips2.."=="..ff.langString(dd.cfgEffect[effid]['name']))
                
                if tonumber(dd.cfgEffect[effid]['tips2']) == 0 then
                    item:getChildByName("value"):setString("+"..value)
                elseif tips2 ~= nil then
                    item:getChildByName("value"):setString("+"..value..tips2)
                end
            else
                item:getChildByName("value"):setString("open")
            end
           
            item:setVisible(true)
            item:setPositionX(370)
            item:setPositionY(innerhh - 130 - excount*140)
            item:setTag(effid)
            item:getChildByName("name"):setString(ff.langString(dd.cfgEffect[effid]['name']))
            item:getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getEffectIcon2(effid),0)
            if self._isActive == true then
                self:setBtnLight(item:getChildByName("icon"):getChildByName("icon"), true)
                item:getChildByName("value"):setColor(cc.c3b(7,159,0))
            else
                self:setBtnLight(item:getChildByName("icon"):getChildByName("icon"), false)
                item:getChildByName("value"):setColor(cc.c3b(161,175,175))
            end
            excount = excount + 1
        end
    end    
end

function vipLayer.showAction()
    local sender = pop.getDialog("vip")
    local have = false
    if sender ~= nil then
        local type = 12
        for i=1,dd.mylists:rowCount() do
            if dd.mylists:getLong(i,"type") == type then
                local time   = dd.mylists:getLong(i,"end") - dd.getServerTime() 
                local starttime = dd.mylists:getLong(i,"start")
                local total     = dd.mylists:getLong(i,"end") - starttime
                if total <= 0 then
                    dd.mylists:delRow(i)
                    return
                end    
                local now       = dd.getServerTime() - starttime
                local progress  = math.floor(now * 100 / total)
                if progress < 0 then
                    progress = 0
                elseif progress > 100 then
                    progress = 100
                end
                if time >= 0 then    
                    have = true
                    sender:getChildByName("content"):getChildByName("block"):getChildByName("time"):getChildByName("time"):setString(ff.getLeftTime(time,":"))
                    sender:getChildByName("content"):getChildByName("block"):getChildByName("time"):getChildByName("progress"):getChildByName("time"):setString(ff.getLeftTime(time,":"))
                    sender:getChildByName("content"):getChildByName("block"):getChildByName("time"):getChildByName("progress"):getChildByName("progress"):setPercent(progress)
                else
                    sender:updates()
                end  
                break              
            end
        end                
    end 
    if have == false then
        sender:updates()
    end
end

function vipLayer.openPop()
    local widget = pop.getDialog("vip") 
    widget:getChildByName("masking"):setVisible(true)
    pop.showPopEffect(12,widget:getChildByName("pop"))
end

function vipLayer.closePop(sender,touchEventType)
    if touchEventType==ccui.TouchEventType.ended then   
        local widget = pop.getDialog("vip")
        widget:getChildByName("masking"):setVisible(false)
        widget:getChildByName("pop"):setVisible(false)                    
    end
end

function vipLayer:onVipActivation(params)
    local code = params[1]
    if code == 0 then
        self:updates()
    else
        dd.mainUI:onShowCodeTips(code)
    end
end
function vipLayer:onTestCharge(params)
    local code = params[1]
    if code == 0 then
        self:updates()
    end
end
function vipLayer:onPropUse(params)
    local code = params[1]
    if code == 0 then
        self:updates()
    end
end

function vipLayer:setBtnLight(node, light)
    if light == true then
        node:getVirtualRenderer():setGLProgramState(ff.gameCore:getNormalGLState())
        node:setTouchEnabled(true)
    else 
        local effect = ff.Effect:effectGrey()    
        node:getVirtualRenderer():setGLProgramState(effect:getGLProgramState())
        node:setTouchEnabled(false)
    end
end

--接口
function vipLayer.onBack(sender,eventType)
    if eventType==ccui.TouchEventType.ended then  
            
        local widget = pop.getDialog("vip")
        if widget ~= nil then            
            if widget:getChildByName("pop"):isVisible() == true then
                widget.closePop(sender,ccui.TouchEventType.ended)
                return
            end
            pop.onClosePopDialog("vip")
        end
    end
end

function vipLayer:onClose()
   
end

function vipLayer.onStart(sender)
    ff.net:registerEvent(2,dd.Tjf_vip_Activation, function (message)sender:onVipActivation(message)end)
    ff.net:registerEvent(501,dd.Tjf_charge_TestCharge, function (message)sender:onTestCharge(message)end)
    ff.net:registerEvent(8,dd.Tjf_prop_use, function (message)sender:onPropUse(message)end)
    ff.net:bindProperty(2503,"gold",sender.updateGold)
    if sender._init == false then
        sender:onInitCfg()
        sender._init = true
    end
    sender:onUpdateSelect()
end
function vipLayer.onBefore(sender)
    dd.initGoldSpine(sender:getChildByName("topArea"):getChildByName("gold"),sender:getChildByName("topArea"):getChildByName("addbtn"))    
    sender:onUpdateBtn()
    sender:onUpdateExtraTime()
    sender:onUpdateVipInfo()
    return true
end
function vipLayer.onEnd(sender)
    sender:stopAllActions() 
    dd.delBackEvent(sender.onReturn)
    ff.net:unbindProperty("gold",2503)
    ff.net:removeEvent(2,dd.Tjf_vip_Activation)  
    ff.net:removeEvent(501,dd.Tjf_charge_TestCharge) 
    ff.net:removeEvent(8,dd.Tjf_prop_use) 
    if ff.platform ~= 1 then
        for i=1,sender:getChildByName("view"):getChildByName("view"):getChildrenCount() do
            local item = sender:getChildByName("view"):getChildByName("view"):getChildByName(i)
            if item ~= nil then
                item:getChildByName("icon"):getChildByName("icon"):loadTexture(dd.getPathFromUI("public/alpha.png",1))
            end
        end
    end
end

function vipLayer.onReturn(sender,eventType)
    local widget = pop.getDialog("vip")
    if widget ~= nil then
        if widget:getChildByName("pop"):isVisible() == true then
            widget.closePop(sender,ccui.TouchEventType.ended)
            return
        end
        pop.onClosePopDialog("vip")
    end   
end

function onShowVipLayer(widget, parent)
    local layer = vipLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)
    layer:onAutoSize()
    layer:onInit()
    return layer
end