--司令部升级
local collectLayer   = class("collectLayer")
collectLayer._name = "collect"
collectLayer._init = false
collectLayer.state = 1
collectLayer.infoList = {}
collectLayer.animFrames = {}
collectLayer.lastID = 0
collectLayer.pageNum = 10
collectLayer.allData = {}
function collectLayer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, collectLayer)
    return target
end
function collectLayer:onInit()
    if self._init == false then
        local hh = ff.height
        self:setContentSize(cc.size(720,hh - 214))  
        self:getChildByName("back"):setContentSize(cc.size(720,hh - 214))    
        self:getChildByName("mainArea"):setContentSize(720,hh - 214 - 105)
        self:getChildByName("mainInfo"):setContentSize(720,hh - 214 - 105 - 70)
        self:getChildByName("mainInfo"):addScrollViewEventListener(self.scrollViewEvent)
        
        local cache = cc.SpriteFrameCache:getInstance()
        cache:addSpriteFrames("images/mv/normaleffect.plist")
        local mv = cc.Sprite:createWithSpriteFrameName("of_native_loader_progress_01.png")
        local xx = self:getChildByName("waiting"):getChildByName("label"):getPositionX()
        mv:setContentSize(cc.size(30,30))
        mv:setPosition(cc.p(xx - 30,15))
        mv:setScale(0.4)

        self:getChildByName("waiting"):addChild(mv,1,1)
        self:getChildByName("waiting"):getChildByName("label"):setString(ff.langString('请稍后'))
        for j = 1, 12 do
            local frame = nil
            if j < 10 then
                frame = cache:getSpriteFrame("of_native_loader_progress_0"..j..".png")
            else    
                frame = cache:getSpriteFrame("of_native_loader_progress_"..j..".png")
            end 
            self.animFrames[j] = frame
        end
        self:initListener()
        self._init = true
    end
    self.updateGold()
end
function collectLayer.scrollViewEvent(sender, evenType)
    if evenType == ccui.ScrollviewEventType.bounceBottom then
        local rank = pop.getDialog("collect")
        if rank:getChildByName("waiting"):isVisible() == false and rank:isVisible() == true  then
            rank:checkUpdate()
        end    
    elseif evenType ==  ccui.ScrollviewEventType.bounceTop then
    end
end
function collectLayer:checkUpdate()  
    cclog("~~~~~~~~~~~~~~lastID"..self.lastID.." pageNum:"..self.pageNum)
    if self.lastID > 1 then
        self:showWaiting(true)
        self:initList(true)
        self.pageNum = 10
    end
end
function collectLayer:showWaiting(play)
    self:getChildByName("waiting"):getChildByTag(1):stopAllActions()
    if play == true then
        local animation = cc.Animation:createWithSpriteFrames(self.animFrames, 0.1)
        self:getChildByName("waiting"):getChildByTag(1):runAction(cc.RepeatForever:create(cc.Animate:create(animation)))
        self:getChildByName("waiting"):setVisible(true) 
    else        
        self:getChildByName("waiting"):setVisible(false)
    end
end
function collectLayer.updateGold(name,row,old,value)
    local sender = pop.getDialog("collect")
    if sender ~= nil then
        sender:getChildByName("topArea"):getChildByName("gold_text"):setString(dd.myinfo:getLong(1,"gold"))
        local w = sender:getChildByName("topArea"):getChildByName("gold_text"):getContentSize().width
        w = 720 - (w + 94 + 75 + 104)
        sender:getChildByName("topArea"):getChildByName("title"):setContentSize(cc.size(w,100))
        sender:getChildByName("topArea"):getChildByName("title"):requestDoLayout()
        sender:getChildByName("topArea"):requestDoLayout()
    end
end

function collectLayer:getInfo()
    local message = ff.net:createMessage()
    message:addCmd(0x19)
    message:addLong(dd.uid)
    ff.net:rpc(message,false)
end

function collectLayer:initListener()
    local function goInfo(sender,eventType)
        local doaction = false
        if eventType == ccui.TouchEventType.canceled then
            local startp = sender:getTouchBeganPosition()
            local endp   = sender:getTouchEndPosition()
            if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                doaction = true
            end
        end
        if eventType == ccui.TouchEventType.ended then
            doaction = true
        end
        if doaction == true then            
            self:disAll()
            self:getChildByName("mainInfo"):setVisible(true)
            self:getChildByName("mainInfo"):setEnabled(true)
            self:getChildByName("mainInfo"):removeAllChildren()
            self.lastID = 0
            local tag = sender:getTag()
            self.state = tag + 1
            if tag == 1 then
                self:getChildByName("topArea"):getChildByName("title"):getChildByName("chu_title"):setString(ff.langString("攻击"))
            elseif tag == 2 then
                self:getChildByName("topArea"):getChildByName("title"):getChildByName("chu_title"):setString(ff.langString("被攻击"))
            elseif tag == 3 then
                self:getChildByName("topArea"):getChildByName("title"):getChildByName("chu_title"):setString(ff.langString("采集"))
            elseif tag == 4 then
                self:getChildByName("topArea"):getChildByName("title"):getChildByName("chu_title"):setString(ff.langString("收藏"))
            end
            self:getChildByName("mainInfo"):getInnerContainer():stopAllActions()
            self:getChildByName("mainInfo"):jumpToTop()
            self:getDataByType()
            self.lastID = table.getn(self.infoList)        
            self:initList()
            if sender:getName() ~= "goInfo" then
                AudioEngine.playEffect(ff.sounds[109])
            end
        end  
    end
    local function cancelAll(sender,eventType)
        if eventType==ccui.TouchEventType.ended then  
            if table.getn(self.infoList) <= 0 then
                return
            end
            for var=1, table.getn(self.infoList) do
            	if self.infoList[var]['del'] == 0 and self.infoList[var]['select'] == 1 then
            	   self.infoList[var]['select'] = 0
            	   if self:getChildByName("mainInfo"):getChildByTag(var) ~= nil then
            	       self:getChildByName("mainInfo"):getChildByTag(var):getChildByName("colCheck"):setSelectedState(false)
            	   end
            	end
            end
        end  
    end
    local function selAll(sender,eventType)
        if eventType==ccui.TouchEventType.ended then     
            if table.getn(self.infoList) <= 0 then
                return
            end
            for var=1, table.getn(self.infoList) do
                if self.infoList[var]['del'] == 0 and self.infoList[var]['select'] == 0 then
                    self.infoList[var]['select'] = 1
                    if self:getChildByName("mainInfo"):getChildByTag(var) ~= nil then
                        self:getChildByName("mainInfo"):getChildByTag(var):getChildByName("colCheck"):setSelectedState(true)
                    end
                end
            end
        end  
    end
    local function delSel(sender,eventType)
        if eventType==ccui.TouchEventType.ended then    
            if table.getn(self.infoList) <= 0 then
                return
            end
            local fresh = false
            for var=1, table.getn(self.infoList) do
                if self.infoList[var]['del'] == 0 and self.infoList[var]['select'] == 1 then
                    local message = ff.net:createMessage()
                    message:addCmd(0x124)
                    message:addLong(dd.uid)
                    message:addLong(3)
                    message:addLong(1)
                    message:addLong(self.infoList[var]['cid'])
                    message:addString(self.infoList[var]['name'],32)
                    ff.net:rpc(message,false)
                    fresh = true
                end
            end
        end  
    end
    self:getChildByName("topArea"):getChildByName("add_btn"):addTouchEventListener(dd.onPay)
    self:getChildByName("topArea"):getChildByName("return"):addTouchEventListener(self.onReturn)

    self:getChildByName("mainArea"):getChildByName("attack"):getChildByName("goInfo"):addTouchEventListener(goInfo)
    self:getChildByName("mainArea"):getChildByName("beattack"):getChildByName("goInfo"):addTouchEventListener(goInfo)
    self:getChildByName("mainArea"):getChildByName("cai"):getChildByName("goInfo"):addTouchEventListener(goInfo)
    self:getChildByName("mainArea"):getChildByName("collect"):getChildByName("goInfo"):addTouchEventListener(goInfo)

    --fatality
    self:getChildByName("mainArea"):getChildByName("attack"):getChildByName("goInfo"):setTag(self:getChildByName("mainArea"):getChildByName("attack"):getTag())
    self:getChildByName("mainArea"):getChildByName("beattack"):getChildByName("goInfo"):setTag(self:getChildByName("mainArea"):getChildByName("beattack"):getTag())
    self:getChildByName("mainArea"):getChildByName("cai"):getChildByName("goInfo"):setTag(self:getChildByName("mainArea"):getChildByName("cai"):getTag())
    self:getChildByName("mainArea"):getChildByName("collect"):getChildByName("goInfo"):setTag(self:getChildByName("mainArea"):getChildByName("collect"):getTag())
    
    
    self:getChildByName("mainArea"):getChildByName("attack"):addTouchEventListener(goInfo)
    self:getChildByName("mainArea"):getChildByName("beattack"):addTouchEventListener(goInfo)
    self:getChildByName("mainArea"):getChildByName("cai"):addTouchEventListener(goInfo)
    self:getChildByName("mainArea"):getChildByName("collect"):addTouchEventListener(goInfo)

    self:getChildByName("op"):getChildByName("cancel_btn"):addTouchEventListener(cancelAll)
    self:getChildByName("op"):getChildByName("sel_btn"):addTouchEventListener(selAll)
    self:getChildByName("op"):getChildByName("del_btn"):addTouchEventListener(delSel)
end
function collectLayer:disAll()
    self:getChildByName("mainArea"):setVisible(false)
    self:getChildByName("mainArea"):setEnabled(false)
    self:getChildByName("mainInfo"):setVisible(false)
    self:getChildByName("mainInfo"):setEnabled(false)
    self:getChildByName("op"):setVisible(false)
    self:getChildByName("op"):setEnabled(false)
end

function collectLayer:goToMain()
    self:disAll()
    self.state = 1
    self:getChildByName("mainArea"):setVisible(true)
    self:getChildByName("mainArea"):setEnabled(true)
    self:getChildByName("topArea"):getChildByName("title"):getChildByName("chu_title"):setString(ff.langString("收藏"))
    self:getChildByName("no_tip"):setVisible(false)
end

function collectLayer:backGetBookMarkLists(ret)
    if ret[1] == 0 then
        self.allData = {}
        if ret[2] ~= nil and ret[2]:rowCount() >= 0 then
            for var=1, ret[2]:rowCount() do
                local key = table.getn(self.allData) + 1
                self.allData[key] = {}
                self.allData[key]['type'] = ret[2]:getLong(var,'type')
                self.allData[key]['cid'] = ret[2]:getLong(var,'cid')
                self.allData[key]['time'] = ret[2]:getLong(var,'time')
                self.allData[key]['name'] = ret[2]:getString(var,'name')
                self.allData[key]['select'] = 0
                self.allData[key]['del'] = 0
            end
        end
--        self:getDataByType()
--        self.lastID = table.getn(self.infoList)        
--        self:initList()
    else
        if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
            dd.currentLayer._widget:onShowTips("\t"..dd.errorCode(ret[1]))
        end    
    end
end
function collectLayer:getDataByType()
    self.infoList = {}
    for var=1, table.getn(self.allData) do
        if (self.state == 2 and self.allData[var]['type'] == 11)
            or (self.state == 3 and self.allData[var]['type'] == 12)
            or (self.state == 4 and self.allData[var]['type'] == 13)
            or (self.state == 5 and self.allData[var]['type'] == 1) then
            local key = table.getn(self.infoList) + 1
            self.infoList[key] = {}
            self.infoList[key]['key'] = var
            self.infoList[key]['type'] = self.allData[var]['type']
            self.infoList[key]['cid'] = self.allData[var]['cid']
            self.infoList[key]['time'] = self.allData[var]['time']
            self.infoList[key]['name'] = self.allData[var]['name']
            self.infoList[key]['select'] = 0
            self.infoList[key]['del'] = self.allData[var]['del']
        end
    end
    cclog("该分页收藏数量："..table.getn(self.infoList).."  state:"..self.state)
end
function collectLayer:getCid(gid)
    local row = gid % ff.world_maplayerSize.width
    local col = math.floor((gid - row) / ff.world_maplayerSize.width)
    local cid = col * ff.world_maplayerSize.width + row
    return cid
end
function collectLayer:initList(flag)
    local nextpage = false
    if flag ~= nil then
        nextpage = flag
    end
    local function setSelect(sender,eventType)
        local doaction = false
        if eventType == ccui.TouchEventType.canceled then
            local startp = sender:getTouchBeganPosition()
            local endp   = sender:getTouchEndPosition()
            if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                if sender:getName() == "colCheck" then
                    sender:setSelectedState(true)
                end
                doaction = true
            end
        end
        if eventType == ccui.TouchEventType.ended then
            doaction = true
        end
        if doaction == true then  
            cclog(" touch state 2")   
            local tag = sender:getTag()
            local info = self.infoList[tag]
            if info ~= nil then
                if info['select'] == 0 then 
                    self.infoList[tag]['select'] = 1
                else
                    self.infoList[tag]['select'] = 0
                end
                if sender:getName() ~= "colCheck" then
                    sender:getChildByName("colCheck"):setSelectedState(self.infoList[tag]['select'] == 1)
                    AudioEngine.playEffect(ff.sounds[109])
                end
            end
        end  
    end
    local function goToMap(sender,eventType)
        local doaction = false
        if eventType == ccui.TouchEventType.canceled then
            local startp = sender:getTouchBeganPosition()
            local endp   = sender:getTouchEndPosition()
            if math.abs(startp.y - endp.y) <= 10 and math.abs(startp.x - endp.x) <= 10 then
                doaction = true
            end
        end
        if eventType == ccui.TouchEventType.ended then
            doaction = true
        end
        if doaction == true then     
            local tag = sender:getTag()
            local cid = self.infoList[tag-1]['cid']
            local function closeDialog()
                pop.onClosePopDialog("collect")
            end
            if dd.mainUI ~= nil then
                if dd.currentLayer._name == "CityLayer" then
                    local function updateScene()
                        if dd.currentLayer._name == "CityLayer" then
                            runWorldScene()
                        end    
                        WorldControl:getInstance()._worldUILayer:setSceneCenterByGid(cid - 1,true) 
                        performWithDelay(self,closeDialog, 0.1) 
                    end
                    dd.mainUI:onClose()
                    local sequence = cc.Sequence:create(cc.DelayTime:create(0.2),cc.CallFunc:create(updateScene))
                    dd.mainUI:runAction(sequence)
                else
                    WorldControl:getInstance()._worldUILayer:setSceneCenterByGid(cid - 1,true)
                    WorldControl:getInstance():showGid(cid,false)
                    performWithDelay(self,closeDialog, 0.1)
                end
            end       
        end  
    end
    local layer = self:getChildByName("mainInfo")
    local beforey = layer:getInnerContainer():getPositionY()
    for var=table.getn(self.infoList), 1, -1 do
        if var <= self.lastID and var > self.lastID - self.pageNum and self.infoList[var]['del'] == 0 then              
            local item = self:getChildByName("colItem"):clone()
            item:setVisible(true)
            item:setTag(var)
            item:getChildByName("colCheck"):setTag(var)
            item:getChildByName("go_btn"):setTag(var+1)
            item:getChildByName("colCheck"):setSelectedState(false)
            
            if self.state == 5 then
                item:getChildByName("colCheck"):setVisible(true)
                item:getChildByName("colCheck"):setTouchEnabled(true)
            else
                item:getChildByName("colCheck"):setVisible(false)
                item:getChildByName("colCheck"):setTouchEnabled(false)
            end               
    
            item:getChildByName("col_icon"):setVisible(true)
            if self.infoList[var]['type'] == 1 then
                item:getChildByName("col_icon"):loadTexture(dd.getPathFromUI("ic04_collect.png",1))
            elseif self.infoList[var]['type'] == 11 then
                item:getChildByName("col_icon"):loadTexture(dd.getPathFromUI("ic01_collect.png",1))
            elseif self.infoList[var]['type'] == 12 then
                item:getChildByName("col_icon"):loadTexture(dd.getPathFromUI("ic02_collect.png",1))
            elseif self.infoList[var]['type'] == 13 then
                item:getChildByName("col_icon"):loadTexture(dd.getPathFromUI("ic03_collect.png",1))
            end
    
            item:getChildByName('col_name'):setString(self.infoList[var]['name'])
            item:getChildByName('time'):setString(ff.getFormatTime(self.infoList[var]['time']))
            item:getChildByName('pos'):setString(WorldControl:getInstance():getCidStr(self.infoList[var]['cid']))
            item:getChildByName("colCheck"):addTouchEventListener(setSelect)
            item:getChildByName("go_btn"):addTouchEventListener(goToMap)
            item:addTouchEventListener(setSelect)
            layer:addChild(item)
       elseif var <= self.lastID and var > self.lastID - self.pageNum and self.infoList[var]['del'] == 1 then
            self.pageNum = self.pageNum + 1
       end
    end
    self.lastID = self.lastID - self.pageNum
    if self.lastID < 1 then
        self.lastID = 1    
    end    
    if nextpage then
        layer:getInnerContainer():setPositionY(beforey)     
        layer:refreshView()
        if table.getn(self.infoList) > 0 then
            local function func()
                self:showWaiting(false)   
            end
            local seq = cc.Sequence:create(cc.MoveBy:create(0.3,cc.p(0,20)),cc.CallFunc:create(func))
            layer:getInnerContainer():runAction(seq)
        end
    else
        self:showWaiting(false)   
    end
    self:showTip()
    layer:refreshView()
end
function collectLayer:showTip()
    local allDel = true
    if table.getn(self.infoList) > 0 then
        for var=1, table.getn(self.infoList) do
            if self.infoList[var]['del'] == 0 then
               allDel = false
               break
            end
        end
    end
    if table.getn(self.infoList) <= 0 or allDel then
        self:getChildByName("op"):setVisible(false)
        self:getChildByName("op"):setTouchEnabled(false)
        self:getChildByName("no_tip"):setVisible(true)
    else
        if self.state == 5 then--只有收藏的时候可以对记录进行操作
            self:getChildByName("op"):setVisible(true)
            self:getChildByName("op"):setEnabled(true)
        end
        self:getChildByName("no_tip"):setVisible(false)
    end
end
function collectLayer:backBookMarkAction(ret)
    if ret[1] == 0 then
        if ret[2]['opType'] == 3 then
            for var=1, table.getn(self.infoList) do
                if self.infoList[var]['cid'] == ret[2]['pos'] then
                    cclog("del var--"..var)
                    self.infoList[var]['del'] = 1
                    self.allData[self.infoList[var]['key']]['del'] = 1
                    local item = self:getChildByName("mainInfo"):getChildByTag(var)
                    if item ~= nil then
                        self:getChildByName("mainInfo"):removeChild(item,true)
                        self:getChildByName("mainInfo"):refreshView()
                    end
                    self:showTip()
                    break
                end
            end
        end
    else
        if dd.currentLayer ~= nil and dd.currentLayer._widget ~= nil then
            dd.currentLayer._widget:onShowTips("\t"..dd.errorCode(ret[1]))
        end    
    end
end
--界面显示后调用
function collectLayer.onStart(sender)
    ff.net:registerEvent(1,dd.Tjf_map_GetBookMarkLists,function (message)sender:backGetBookMarkLists(message)end)
    ff.net:registerEvent(2,dd.Tjf_map_BookMarkAction,function (message)sender:backBookMarkAction(message)end)
    ff.net:bindProperty(2407,"gold",function ()sender.updateGold() end) 
    sender:goToMain()
    sender:getInfo()
end
--界面关闭效果结束后调用
function collectLayer.onEnd(sender)
    dd.delBackEvent()
    ff.net:unbindProperty("gold",2407) 
    ff.net:removeEvent(1,dd.Tjf_map_GetBookMarkLists) 
    ff.net:removeEvent(2,dd.Tjf_map_BookMarkAction) 
    sender.state = 1
    sender.infoList = {}
    sender.allData = {}
    sender.animFrames = {}
    sender.lastID = 0
    sender.pageNum = 10
    sender:getChildByName("mainInfo"):removeAllChildren()
end
--界面即将播放显示缓动时调用，返回false界面显示将终止
function collectLayer.onBefore(sender)
    dd.initGoldSpine(sender:getChildByName("topArea"):getChildByName("icon"),sender:getChildByName("topArea"):getChildByName("add_btn"))
    return true
end

function collectLayer:onClose()
    if self.state ~= 1 then
        self:goToMain()
        --回到主界面
        return true
    else
        return false
    end
    return false
end

function collectLayer.onReturn(sender,eventType)
    local close = false
    if sender == nil then
        close = true
    end
    if eventType==ccui.TouchEventType.ended then     
        close = true
    end
    if close == true then
        local widget = pop.getDialog("collect")
        if widget~=nil and widget:onClose() == false then
            pop.onClosePopDialog("collect")
        end    
    end
end
function onShowCollect(widget)
    local layer = collectLayer.extend(widget)
    dd.regeditBackEvent(layer.onReturn)
    layer:onInit()
    return layer
end